﻿// Nakamichi is 100% FREE LZSS SUPERFAST decompressor.
// Home of Nakamichi: www.sanmayce.com/Nakamichi/index.html

// Downloadable at:
// The 'Large Text Compression Benchmark' main revision from 2019-Aug-06:
// https://gist.githubusercontent.com/Sanmayce/33e5047d45cdcb8e7711cd7d3ed52c7f/raw/d72e7126c8fbfde07c0d727dcb353b0267b8196c/Nakamichi_Ryuugan-ditto-1TB.c
// Other older ones:
// https://community.centminmod.com/data/attachment-files/2019/07/8164_Nakamichi_2019-Jul-01.zip
// https://community.centminmod.com/threads/a-lzss-microdeduplicator-tagetting-huge-texts-with-c-source.16427/#post-75533

// 2019-Nov-28: Jesteress was replaced by 'Pippip':
// https://software.intel.com/en-us/forums/intel-moderncode-for-parallel-architectures/topic/824947#comment-1946863
// https://www.codeproject.com/Articles/716530/Fastest-Hash-Function-for-Table-Lookups-in-C
// https://softwareengineering.stackexchange.com/questions/401167/searching-hashing-wikipedia-at-each-position-for-keys-1-31-long-the-fastest

// How to compile?
/*
_MakeELF_Nakamichi_GCC.sh:
gcc -O3 -static -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Nakamichi_Vanilla_LITE_GCC_64bit.elf -D_N_XMM -D_N_prefetch_4096 -D_N_alone -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_POSIX_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32 -DLITE

_MakeEXE_Nakamichi_GCC.bat:
gcc -O3 -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Satanichi_GCC730_64bit.exe -D_N_XMM -D_N_prefetch_4096 -D_N_alone -D_N_HIGH_PRIORITY -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32 -DLITE

_MakeEXE_Nakamichi_ICL.bat:
icl /TP /O3 /arch:SSE4.1 Nakamichi_Ryuugan-ditto-1TB_btree.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ /FAcs -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32 -D_NSHA3 -DLITE
copy Nakamichi_Ryuugan-ditto-1TB_btree.exe Nakamichi_SHA3_LITE_ICL190_64bit.exe /y
icl /TP /O3 /arch:SSE4.1 Nakamichi_Ryuugan-ditto-1TB_btree.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ /FAcs -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32 -DLITE
copy Nakamichi_Ryuugan-ditto-1TB_btree.exe Nakamichi_Vanilla_LITE_ICL190_64bit.exe /y
icl /TP /O3 /arch:SSE4.1 Nakamichi_Ryuugan-ditto-1TB_btree.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ /FAcs -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32
copy Nakamichi_Ryuugan-ditto-1TB_btree.exe Nakamichi_ICL190_64bit.exe /y
icl /TP /O3 /arch:SSE4.1 Nakamichi_Ryuugan-ditto-1TB_btree.c -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ /FAcs -DHashInBITS=24 -DHashChunkSizeInBITS=24 -DRAMpoolInKB=5120 -DBtreeHEURISTIC -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=128 -DSpeedUpBuilding=32 -DLITE -D_N_alone
copy Nakamichi_Ryuugan-ditto-1TB_btree.exe Satanichi_ICL190_64bit.exe /y
*/

/*
QQQQQQQQQQQQQQQRS2jtJtU1f2j2UfU2fF1XS9XPSPhSthQQQQQDc1tf7PQQQQRh2tt2t2f2f1f2t1t1f1t2t1t2f1t2t1t1t2t1t22Sfc7LJtritQQQQQQQp21pF2U1t1f2f1t2t10PJJcjj12FUJ7riri7LtFZQQQQQQQQQQQQM1.                                                                         
QQQQQQQQQQQQQQQQQQbUJLYYUjtt2t2t2ttU22XS9SPhStFQQQQSJt2tJ1QQQQPFft1t1t1f1f1t2t2f2t1f1f1f1f2t1t1f1t1f1f2fh2Y7JhhcirRQQQQQQD12Ph2U2f2f1f1t1UPQQQEfJcJjF2hUUYc7ririr72EQQQQQQQQQQQU                                                                        
QQQQQQQQQQQQQQQQQQQQQRXfYYLJJtUfU2t2Ufj2FpPPhS2FQQQjj1ffcRQQQX2XU1f2t1t2t1t1t2t1f1f1f1f2f1f2f1f1t1f1f2t2fh2LJF2hJriSQQQQQQQhtPh1jft2t1f2t2JURQQQQR1JLUtF2h11ffJY77irr2RQQQQQQQQQY                                                                       
QQQQQQQQQQQQQQQQQQQQQQQQQREF2YYLJYUJ2U2UtthXpSpt1Q1Y2t1j2QQEF2pfft1f2f1t1t1f1f2t1f1t1f1f2f1f1f1t1f1t1t1fFfFfFfF2hj7iLMQQQQQQ0thXhUttft2t1t2JchQQQQQQEJYjftFfh2S1FUJ77irJQQQQQQQQQ7                                                                      
QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQR0XUjLJJtU2j1X9X1Jjj2f2tt1pfFFp1tf1t2t1f1t1f2t1t1f2f1f2f2f1t2t1t1t2t1f1f2t1t1f2t1fhULrrJ0RQQQQQ22hSFX12t1f1t2UYYDQQQQQQ0JY2t1fFfF2h11JL7ri2QQQQQQQQr                                                                     
QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ01cJJfj1PXj2t2t1t1ffY2X91ft1f1t1f1f2t1f1t1t1t2t2f1f1f2t1t1t1t1t1f2t1t1f1t1t22hUc77irrYhQQQbh212Phft1t1t2UULfDQQQQQQ2ctU2f1f2f1fh2UL7i7EQQQQQQQ:                                                                    
RQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQXJctUFUft1t2f1t1t2fSfft2f1t2t2f1f1f1f1f1t1f1f1f1f1f2f2t2f1f2t1t1f2t1t2t2f1fhfJ7L7crriUQQQQQD1X22f1f1t1tfJcJ9QQQQQPctj1t1t1t1tFF1cLri1QQQQQQQ.                                                                   
h1bRQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQhQQQQXLUU1f1t1f1t2f1t1t2t1t1t2t2f1f1t1f2t2f1t1f1t2f2f2t1f2f1t1t1f1t1f2t2t1t1f1fh1fYcJFJ7irEQQQQM2hj1f2f1f2f2UjLJpQQQQZJtjft1t1f1f11SJL7rcQQQQQQQ.                                                                  
QQ0pXMQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQXjXQQQQMctt2f1f2t1f1f1f1t1t1f1t1f1f1f1f1t1t2t2f2t1t1f1t1t2f1t2t1t1f1f1t2f1f1f2t1f11hff1htcrr0QQQQP2tt1f1f1f1t1t2JYjQQQQZtFUff1t1f1f1fhjc7rLQQQQQQQ                                                                  
QQQQQDEDQQQQQQQQQQQQQQQQQQQQQQQQQQQpf1tRQQQQRctt1f1f1f1t1t1f1t2f1t1t2f1f1f2t2t1t2f1f1f2t1t2f1f1f1f1f1t2t2f1f2f1f2f1t2f1fFfFfh2YrrEQQQE1j1t1f2t1t1t1t2UjcMQQQ01XffU1t1t2t12SjLLrLQQQQQQQ                                                                 
fDQQQQQQMQQQQQQQQQQQQQQQQQQQQQQQQQP2FSfXQQQQQ0Yff1f2f1f1f1f1f1f1t2t2t1t2t2t2f2f2f2f2f1t1t1f2t1f2f1t1t2t2t2t2t1t1t1t2f1t2f1t1fh2JrrMQQQttU1f2f2f2f1t1f2UULbQQQh1pF2U2t2f2t1fhJc7rJQQQQQQQ                                                                
XJtPQQQQQQQQQQQQQQQQQQQQQQQQQQQQQX2hXhSURQQQQRJt1t1f1f1f1f2f2t2t2tFf2UfjfUtUtUfUfUtUfU2t1t2f1f1f2f1t1t2f1t1f2t1t2t1t2t2f1t1f1fF1Yr7QQQPftt1t2t2f1t2f2t1ttLPQQR1hpS2U1t1f1f12FcYLrFQQQQQQQ                                                               
QQMp1ZQQQQQQQQQQQQQQQQQQQQQQQQQQh2FXhXh1SQQQQQL2t2f1f1t2t1t1f1f1t21PX9hX1F2F1ShXhXFFf1UfUfUtU2t1t2t1t2f2t2t1f2t2t1t1t2t1t1f1t1fF2Ji7QQ9S2tt1f2t1f1t1t2f2ttLhQQ01FpP1U2f1f1t12t7c7iDQQQQQQD                                                              
QQQQQRQQQQQQQQQQQQQQQQQQQQQQQQMf1hXSPhX22QQQQDJU1f1t1f1t2t2t2f1f2t2U11pX9PpXpX9PpX9PpXphSFhf1t2UfUfUtUfUtjtUtUffFt1t1f2t2f1f1f2fF1JiYQQfp2ft2f2f1t2t1f1f1ftL2QQ1hhPXFU2t2t2f1fc77:iRQQQQQQbi,                                                           
QQQQQQQQQQQQQQQQQQQQQQQQQQQQZXthhXhXSXXfPQQQQPJff1t1f1t1f1t2t2f1f1ttJ2hpSPSXSPhPSPSPhPXpSpXpXPSPSPFXFShXhXhXhPP9f2t2t1t2f1f1t2f22F2jiFQSSPtft1t1t2f2f2f2f1t2ctQQfShpX1U2t1f12hY1pEfMQQQQQQQQQQEL,                                                       
QQQQQQQQQQQQQQQQQQQQQQQRREp11fShPSPSXXS2QXtchUft1f1t2t2t1f1tft2t2Uf2XXpSXhXSXSPhPSXhPhPhXSPhpXpSpXpSpPpP9XpX9Xpfff1f2t2t1f2t1t2f2fF2trP0pPPU2t2f1f1t1t1t1f2t2YUQR1SSPS1U1t2t122jpQQQQQQQQQQQQQQQQQMr                                                    
QQQQQQQQQQQQQQQQQQQQQPfft1thFXhPhPSPXXU1JJJtj2t2f1t1f1t1t1f1f1tfjFS9XPSPSXhPSPhPhPSS2F1XFPhXSPSXhPhPhPhPSPhXh91Ut2f2f2t2f1t1f2t1f1t1f2c1h0pFU2f2t1f1f1t1t1t1ffJURDFXh9X2t1f1f1f27rrJhRQQQQQQQQQQQQQQQb,                                                 
QQQQQQQQQQQQQQQQQQQZfthFXhXhPhPXPX9XhU2Uft1f1f1t2f1f1t1f2f2tFhPhXXpSXSXSPhXhPSXhXhSpRDXt12ShXhXhPhXFhhXhPSPSPXXttt2f1f2f2t1f2t1f1f1f2f1j2fPp1t1t2f1t1f1t1f1f1t1jt00SPhpFtt2f1fFfFUYriircSDQQQQQQQQQQQQQM,                                               
QQQQQQQQQQQQQQQQQQDf2SSPSXXpXpXpSS22U1f1t1t1f2t1t2ffU2Uftfjfj1SpSPSXSXSPSPhPhXhShSff2QQQ0ht22hhXFSF0SFhXhXhXhPPpfft2f1f1t1t1f1t1t1f2f1f1tfU122t1f1t2f1t1f2t2t1f1jtF9hXS9fft1f1f1fF11jJ7riiiLU0QQQQQQQQQQQJ                                              
QQQQQQQQQQQQQQQQQQ21XhXhpSX1h22t2Uft1t1t2f2f2t1f2t12Ft1t2f1thSpSXhXhXSXhPhXFS2FtffX0QQQQQQQ0P21t2UUSQF1hXSXhPhXXpF2Uff2f1f1f1f1f1f1t1f1t2f2t2f2f2t1f1t2f1t2f2f1f1UfFpSPXXU2t1f1f2f1fh1FtUcLrrir7hQQQQQQQQQM                                             
QQQQQQQQQQQQQQQQQXfSSXhPX2jfjfU2f1t1f1f1f1t2t1t1f2tFS9PpSPX9XPSXhPhXhSFX2Ft2tFSERQQQQQQQQQQQQQQQZMEQQQFfFXhPSPhPhpXhUft1t2t1t1f1f2t1f1f2t2f1f2f1f2f2f1t1t1t1t1t2f1tth9SPXFU1f1t1t2f1fFfh1S21jJ77iiJQQQQQQQQM                                            
QQQQQQQQQQQQQRQQptXSPSXS92UU1f1f1t2t1f2f1f1t2U2t2UfJtUhXPSPhPhXhXhPSh21fFhbZQQQQQQQQQQQQQQQQQQQQQQQQQQQX21XSXhPSXhpXp1fUft2f2t1f1t1f1f1f1f1f1f2f1f1t1t1t1t2f2t2t1f2tfSph9Ftt1f1t1t1f1f1f12F2h1hUj7iiDQQQQQQQY                                           
QQQQQQQQQQQQQ0QptShPhXhXh9hft2t1t2f1f2tfUfUft2t2f12h1XFXSXhXhXhXhXhP9RQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQb22ShXSXhXhXXphhtft2t1f2t2f1t1t1f1t1t1t2t2f1t2f1t2t1t1t2t1t1j2S9XpU2t1f2t2f1t1f1f1t1tF2F1FU7:MQQQQQQQ                                           
QQQQQQQQQQQQpFpfShPhPSpXPX9XFt2f1f2t2t12SSPXpPpX9XpX9XpSXhXSXhShSFF2SXbMQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQRhUhFhhShXhXhPXpF1Utt1t1f2t1t2f1t1t2t2t1t2t2f1f2f1t2f1f1t2t1j1X9X2U2t1f2f1f1f1f1f1t2t1f2tFf7rQQQQQQQc                                          
QQQQQQQQQQDSth1XhXS9X9XpSPS9X2t1t2t1fhS9SpS9X9P9XpX9XphPSPhPSPFh2h2h1h1bQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQbjhp11XhPSPSPSpXS2tUft1f1f2t1f1f1t1f2t2f1t1f1f2f2f1t1t1t1f2UhX92ft1f1f2f2t1f1t1f2t1t1thf1Ji9QQQQQQQ                                          
QQQQQQQQR121ShPhXXphS21t2t1t1t1f1f1f2t2UfUfU2t1fF1hhpX9XPhXh9ZQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQRRRQQQQQQRFQRFFXhPhXSXhPXpShfft1t2t1f1f1f2f1t1t2f1t1t1t1t1t1f1t2t2ffUPpFU2f1f2t1f1f1f1f2f2Utj1p9F1iJQQQQQQQ                                          
QQQQQQRSthhXhPhPPSttjft2tft2t1f2f1t1f1t1t2tft2tfUfjfU2thSXhS11fSpQQQQQQQQQQQQQQQQQQQQQQQQQQQQQR02fUfUfttXQQQQQRQR1FPSXhXhXhPh9X9h2t2t2f1f2t1f1f2t2f2f1f2t2f2t1f1f1f2f1tft01tt1f2t1t1f1f1f2fF2FthSPX0S7LQQQQQQQ                                          
QQQQQD2fXhPhPSXPSjft2f2t1t1f1t1t1t1t2f1t1t1f1f1f2t2tfJ2FX1FfF1SFhhQQQQQQQQQQQQQQQQQQQQQQQQQQQRFtfUtU12Sft0QQQQQQQSFhPhXhXSPSPSpP0t2f2t2t2t2t2f1f2t1f2t2t1t1t2t1t1t2f2t2t2Fht1t1t1f1t1f1t2f1tFX0hShXS07jQQQQQQQ                                          
QQQQZf2XhPSPSPSpUft1f1f1f2t2f1t2t1t1f2t1t1t2f1f1t1f2tXpppMQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQMSFU2f2pQQQQQQEtXhXhPhPhXSPfSFft2t1f1t2t1t1f2f1t2f2t1f2f1t1t2f2f1f1t1t2f2f1f1f1t1f1f1t1t1t2XMXFfhhLPQQQQQQQ                                          
QQQQ2fXSXhXSPSphfU2f1t1f1f1f1f1t1t2f2f1t1f1t1t2t1f1thh11MZZpP112hh9bRQQQQQQQQQQQQQQQQQQQQQQQMFfLSQQQQQRX2UU2RQQQQR2FXhXSXhXhpStj2f1f1f1f2f2f1t1t1t2f2t1f1t1t1f1t1t1t1f1f1f2f1f1t1f1f2t1t1t1f2UU9QQRP1LQQQQQQQ7                                          
QQQMjXhPhXhXhXSXU2t2f2f1t2t1t1t1t1t1f1t1f1t2f2f2t2f2t2UfJjYJcJcJ7Lrr::rbQQQQQQQQQQQQQQQQQQQR    RQLcRQQQQD2jYXQQQQFFFXhXhPhPS92tf1f1t1f2t1t1t1f2t1f2f1t1t1U2f1f2f1f2f1f2t1f2t2f2t1f1f1t1f2t1f1UccQQQQQQQQQQQQr                                          
QQQ92hPhXSPhPhPSfU1t1t1t1t1t2f1t1f1t2t2t1t2t1f1t1t2t1t1t1t2t2f1fFfFtF9QQQQQQQQQQQQQQQQQQQQQL   QQi:.jQQQQQQMScUbQQRtShPSXSXSXSptft1f2t1f1t2t1f1f1t2f1f2ff1ptft2f2t2t1f1f2f1t2f1f1t1f1t1t1t2f2f1tjrjQQQQQQQQQQQR,                                        
QQQbtSSXSPhPhXXptft2t2t1t1f1t2t1f1f1t1f1f1t1t1t2t1f1f1t1t1fFt1t1t1t2p02tUh9QQQQQQQQQQQQQQQQ.  SQ:,   FQQQQQQQQfY0QQS2XSXhPhPSPXPUff1t1t1t1f1f2t1f1t1f2t1tfPpfff1f1f1f1f1f1t1t1t1t1f1f2t1f2t1f1t2f27rcDQQQQQQQQQQh                                       
QQQbfFPhXhS1ShPPhj2f1t1f2t1f1f1f1t2t1t2f1t1t1f1t1t1t2t2t2t1f1f1t1t1ttJJcc7rr7JEQQQQQQQQQQQQ,  Q9:    FQQQQPSQQQEjMQMfFXhXSPhPhPPPfft1f2f1f1t2f1t2t2f1f1t2UhP9FfU1f1t2t1t1f1f1t1f1t1t2f1t1f2f1f1f1fhtLi72QQQQQQQQQQ7                                     
QQQQthhPhX2MXFhPS2U1f1t2t1t1f1f1f1t1t1t1t1f1f1t1f1t1t1f1f2t2t2t1t1f1t1t12122J7irfQQQQQQQQQQ:  Q1:7irQQQQp:...7RQQPQQPfhXSPSXSXSPS91fUft1f1f1t1t1f1f2f1t1ttf9Xphtt1t2f1f1f2t1t1f2f1t1t1t1t2f2f1t2fFf222LritQQQQQQQQQQ,                                   
QQQQX2XSX1SQQtSh9Fff1f2t1f1t1t1f2t1f2t1t1t1t2f1f2f1t1t1t1f1f1t1t2t1t1tFtFt1fF21cripQQQQQQQQj  QQ.:r:QQQ1.:ii:..LQQQQQS21XhPSXSPhPS9XFUft1t1t2f1t1f1t1t1t2t2SPSpFft1t1t2t1f1f2f1t2f1f2f1f2t2t2t2f1f2U1fhtLirtQQQQQQQQQJ                                  
QQQQD1hPF10QQptXS92tt1f1t2t2t1t1t1t2t1t1f1t1t2f2t2f2f2t2f1t2t1f1t1t1t2t1t1tFf1fh2Y:UQQQQJbQQ  0Qr.:.SQD.:ririi..QQQQQQSfFXhXhXFSFPSpXP2fU2t2t1t1t1f1t2t1fttpSPSp2ft2t1f2t1tFt1t1f1t1f1f1t1t1t2f1t22PtfthfUrir0QQQQQQQQQ                                 
QQQQQtShXfQQQQF2XXp2ft1f1t2t1f1t2t1f1f2f2f2t1t2f1t1t1f1t1t1t1t2f1t1t1f1t1f2t1f12F12rYQQQt:QQJ  QQ:..rQi:iirii..FQQQQQQQb2fXFPhSXS1XhPX9hSffUfj2t2t2t2t2UfjhXPhPSpU2t1t1t1fth1j1t1f1t2t2t2f1t1f1t1UF9pfft212L7ijQQQQQQQQQ.                               
QQQQQS2XFhQQQQQFfXXP2ft2t2f2f2f1t1f1t2f1f2t2f1f1f1t1t2f1t2f1f1f1f2f1t1f1t1t2f1f2t1217UQQPr7QQ. .QQY.,:.:::.:.:0QQr QQQQQRSUFhX2QQ2FPSXSPX9SS22UfjfjfUfUttSXPSPhXhhj1t1t1t2Up2jU2f2t1t1t2t2f1f1f2ff29P9t1hffFc7i7QQQQQQQQQ                               
QQQQQXFhX2QQQQQQ1tXS91tU1t2t1t1t2f1t1f2f2f2f1t1t1t1t1f2t1f1f2t2t1f1t1f1f1f1t1f2t2fFt27pQb2r7QQ:  QQQPri::i7tQQQQ.   RQQQQQZf22fRQ0fFXSPSPhpP9SPhXFhFhFSS9XpSXhXFbPtj2t2f2j2hMXjt1t1t1t1t1f1t2f1t1UhXPXSh9Ff2FLLiFQQQQQQQQ                               
QQQQQPfSF19QQQQQQStSh9S1UfU2f1t2t2f1t1t2t2t1t1t2t1f2t1t2f2t1f1t1t1t2f1t1f2f1t1t2t1t2ttYQbXXYiRQh  ,MQQQQQQQQQQ:   ,, ZQQQQQQ02cRQQpfFXSXSPhXhpSpXpXpXpPpSXSXSXh2QR1tj2Ufj2h1QQJtU1f1f1t2f1f1f1t2UfhP1h2XS91f1h77tQQQQQQQF                               
QQQQQFFhX12QQQQQQQ02XSpXXffjtjfUfU2U2f2t2f1t1t1t1t1t1f1t1t1t1f1f1f1f1f2f2t2t1t2t1f1t1tjPDhpp1rtQQi    :7Jcr.       ,, bQQQQQQQ0DQQQp21ShPSXSPSXSPSPSPSXhXSPhPFFFQRhh1UfthSStQQXtfU2t2t2f2f1t2t2jU2SthXMSSSpt2tJjhQQQQQQQ                                
QQQQQ11XhSURQQQQQQQRFXSPX9XPhXFh2hFht1t1t2t2f2t1f2f2f1f2t2f1f2f1t1t1t1t1t1f2f1f1f1f1t2UfhpSPP9J7SQQ7                 , pQQQQQQQQQQQQ021SSPhPhPhXhPhPhPSXhPhXhStQQRfPXpXPShjEQQ9hSFtfjfUtUfUtjft2f1SRQQQPFXPhJ2hhPQQQQQQ:                                
QQQQRtSFPh2EQQQQQM9hPhXhXhPXpP0p0pXf1t1t2t1f2t2t2t1t1f1f1f1f1f1t2f1t1f2f1t2f1f1t1t2f1f2UthpSPS0XJ7XQQX,                 7QQQQQQQQQQQQM1fShXhPSPhPhXhXhXhPhXhhjbQQFtFSFSf2tDQQQQUXXphX1hFS1SFSFFfpRQQQMFfhhP11Sh2QQQQQQF                                 
QQQQp21ShStMQQQQSt2XhXhPSPSpX9PX11j2f1t1t1t2t1f1t2t1f1f1t1f2t2t1t2f1f1t1f1f1f2f1t1t1t1t1tfh9SPhPPXjJYQQQF.                 PQQQQQQQQQQQPUFhXhPSPhXhXhXhPhPFhU9QQQ9U2f12PEQQQQQQXjFhXhPhPhSFFtFPQQQQQEJjhSSFPFfFQQQQQQQ                                  
QQQQFtQFXF2MQQRt2hSSPhpXpXPhhf1Uft2t2f1t1f2t1f2f1t1f1f1t2t1t2t1t1f2f1t1f2f1f2f1t1f1f2t1t1Ufh9SPhPS9RQJ7jQQQQSi.         :FRQQQQQQQQQQQQQRFftFhXFXhShShXFS12UEQQQQQQQQQQQQQQQQQQQb21f2t11XP90RQQQQQ:DQQQQQh1t29QQQQQQQ                                   
QQQQYbQ02StQQMUhFXhPS9SS2fttUft2t1t2t1t1t1f1f1t2f1t2f2t1t1t2f1f1f2t1t1f1f1f2t1f1f1t1f2f2f1tfh0XPSXhhMQQMJLLSMQQQQQQQQQQQQQQQQQQQQQQQQQQQQQR012U1fh2h2Ff2tF9QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQP7QQ. bQQQEJU9QQQQQQQQ                                    
QQQpUQQ911SQRthFXhPSp12UtU2t1f2t2t1t1t1t1t1f2t1f2t2t1f2f1f1t2t1f1t1t1f2t2t2t2t1t1f1t1f1f1t1Uf2pSXhSF2FQQQQQ0FYYLJJtUtYLrriSQQQQQQQQQQQQQQQQQQRR00XXhPPEZQQQQQQQQQQQD0hh2h2Ft112tMQQQQQQQ:  QQU,,QQr  QQEf9QQQQQQQQQ                                     
QQQhRQQX2XXRfShPhXXp1tU1f1f2f1f1f1t1t2t2t1f1f1t1f1t1t2t1t1f1f1t1t1f1t2t1f1t2f1t2t2f2f2t2f1t2tttb0X22ttJt2bQQQQQQQQRQRRRQQQRQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQPUfthhSftJUJjJcrLbQQQQh rDQE..:QQ   QQRQQQQQQQQQQ                                      
QQQQQQZfShPFXhXhPX92tt2t1t1f1f2f2f1t1t2t1t2t2f2t2t1t1f1f1f1t1t1f1t2t1t1t2t2t1t1t2t1f1f1t1f1t2tt1RQQQRDDPX1XQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQMRZMZRRQQQQQQQQZJhhXXSjtU2t2t2t2crcQQQQfcXi...pQQ  jQQQQQQQQQQQP                                       
QQQQQRtShXhXSXhPX92tt1f1t2f1f1t2f2t1f1t2t1f2f1t1t2t1t1f2f1t2f2t2f1f1f1t1t1f2f1t1f2f2t2f1f1f1t1ftJfSRQQQQQQQQQQQQRZpStUYJYUj2190QQQQQQQQQQQQQQb21f1jtJJLJcYUMQQQQMUFXSpjtt2f2t1f1f1fLiPQQQQc:,.2QQ  cQQQQQQQQQQQ.                                        
QQQQQthFPhXhPhPPpftt1f1f1f2t1f1f2t1f1f1t1f1f1t1t1f1t2t2t2t2t1t1f2f1f1f1f1t1t1f1t1f1f1t1t2f2f2f1t2jJcYcjj221tfJjcJLJYUjtUUJtJUU22XDQQQQQQQQQ92thhFUtjtUfUfJJrjQQQQ02FpFtt1f2t1f1t1fF2UiJQQQQQQRQM,.QQQFQQQQQQQ,                                          
QQQQ92FXSXhPhpXhUtt1t1t2t2t1t1f1t2f2f1t2t2f2t2UtjtjtjUJjYJJUj2f1t1t1t1t1t1t2f1t2t1t2t1f2t2t1f1f1t1t2UfjtJUJUJUJft2t2f1t2t1t2ttj1F21QQQQQQQpfFXS1j2t1t2t1t1t2LrpQQQb2hPU2f1f1f1f2f1f122i7QQQQQQQQQQQRiiQQQQQQQ.                                          
QQQQSfShXSPSph1jft1t1f2t2f2t1f1t1f2t1t1UfjtUfUtJjJUJftFFp0Db022f2t1f1t2t2t2f2f2f1f1f1t2t1f1t2f1f2t1t2f1t2t1t1t1f1t1f1t1f1t1t2tfjf1htbQQQQRt1XXhj2t2t2t1t1f1fFJrjQQQb2SFU1f1f1t1f2t2t1fFrrQQQQQQMb1tc:1QQQQQQQ:                                          
QQQQFFhXSXS9h2j1t2t1f1t1f2t1f1t1f1t1UtU2t121f119bRRQQQQQQQEp12f1t1t1f1t1f1t1f2t1f2f2f2f1t2f2f1t1f2t1t1f2f2f1t1f1t2f2t2f1f1f2t1t2Ut2PtPQQQEUXhpttt1f1t1t2t2f2t1t77QQQpFFft1f1f1t2t1f2tFf1rrQQp9QpJJjjSQQQQQQQQ                                           
QQQQS2XhPS9hfU1t2t1f1t2t1t1f1f1t2tfj21ShhfhpRQQQQQQQQQE2jYjJft1t1f2f1t1t1t1f1f1t2t1f1t1t1f1f2f1t1f1f1f2t2f2f1f2t1f1t2t1t1f1t2t1f2tt2PfXQQ92FPXFU2t2t1t1f1f1f1f1fLrQQQ2X1ft2t1f1t1t1f2tF1tr7QQJP0hjtfQQQQQQQQQQj                                         
QQQQ91FPhpX2U1t1t1f2f2f1t1f1f1t2jf1XSXfFXRQQQQQQQQZXJJcUj1ttJjJtUfUfUtjfjtUftft1t2t1t1f1t1t1f1f1f2f1f2t1f1f2t1t1t1t2f1t1f1f2f1f2t1tttP2XQMtXSpFtf2f1t2f1t1t1t1f22ciMQR292tt1t2t1f1t1t2fF1JifQpFXFftfY2QQQQQQQQQ                                         
QQQQQthSPXhU2f1t2t1t2t1t1t1f2t2UFXpShfbQQQQQQQQRhJYYttfJL777JU92f2h2hf1fFf1ffttUtJjj2t1f1f1t2f1t2f2f1t2f1t1f1f2t2f2f1f1t2t1t2t1f2t1tttX2ERhhXS9tft1t2f2t2f2f1t2t12JiDQpSpfft1f1t1f2f2t2th2LrPhPPSU2ttirMQQQQQQR                                         
QQQQQX2XhPtft1t2f2t2t1t1t1f2f2tXPPh1hQQQQQQQQbjYcUt2Y7rLt9RQQQRFt11Ffh112FfF2h2pbM92cUU2t2t1f1f1t1t2f2f2t2f2f1t1f2f1f1f1f1f1t1t1f2f1tfUXh0hXSPXSU2f1f1f1f1f2t1f1f11J:DESp0t2f1t1t1t1t2f22hJLrU191ffFtr:rQQQQQQ,                                         
QQQQQM2FPS2U2f2f1t1f1f1f2t1t1tSPphhSQQQQQQQEJLUU2fjr7fRQQQQQQZP0RRQQQQQQQMREbShf1hZQRUJt2f2f2t1t1t2f1t1f1t2t2f2t2f1f1f1f1t1f1t1f2t1f2tftXXPSPhPSft2t1f2f1f2f1f1f2t11JrtthS9f2t2t1f2t1t1t121LLtf1pUffER0YQQQQQQ                                          
QQQQQQFFS92ft1f2t2f2t2t1t1t1t2P9hXfQQQQQQQSLYft2UJ7hQQQQQQQQQQQQQQQQQQQQQQQQQQQQMbF20QFYj2f1t1f1f2f1f1t1f1t1t2Jjj2t2t1f2t1t2t1f2f2f1f1ttjSXPSXh91ft1t1f1t1t1f1f1f1f11YL1tf2Ff1t1t1t1f1t2tF2Jchf2f1f2JtRQQQQQQQQ.                                        
QQQQQQRtSSPU2t2t1f2f2f1t2f2t2tXPphhpQQQQQQcJ2f1ftUDQQQQQQQQQQRMXhf2jffhh0ZQQQQQQQQQQZDQXYj1t1t1t2f1f2UfttUfUtUDhJLUt1t1t1f1t2f1f1f2t1f1tfUXPphPX9tff2f1t1f2t1t1f2f1tFfJt1t2t2f1f1t1f1f2t1f1t2fFt2f2t1Jr7RQQQQQQQS                                       
QQQQQQQptXPhU2t1t1f1f1f2t2t1t2UhX9h2DQQQQQcUt1U2XXQQQQQQQQbFYYLJYJJjJjYJcYcUFZQQQQQQQQQQpcJ2t1t1f1t11S1S12jjcL1QQ0jJJtt2f1t2t1t2t2t1t1t1t2USPpSPXXj2t1f1f1t1t1t2f1t2f1f1f1f1f2t1f1t1f1f2t2fFf2f1fF21t1Ur:hQQQQQQQQ                                      
QQQQQQQQ2FpPFU1f1t1f2t1t2t1f1f2U22phFDQQQQFcff1UXFMQQQQQPLcYtjft2t2t2t2U1ttJJLJtZQQQQQQQQ0Yj2t1f1f2tF2SPDMQQQQQQQQQbfYUU1f1f2f1f2t1t2t1f2tfUSX9SPX1j1t1f2f2t1f1t2f1t2t1f1f1f2t2t2t2t2t1f2f1t1t1tUJtthf2ci:cQQQQQQQQ                                     
QQQQQQQQ92FpX2U2f2t2f1t2t2t2f1f1tttF1FbQQQQJj2t2UF2bQQQZ7tt1f1f1t2f2t2f1t1t2tfJjLUPQQQQQQQbcJ2t2t2f2ffjtJf29MQQQQQQQQbjtJft1t2f1f1t2f1t1t1f2U1X9h9Sft2t1t2f2f2t1f2t1f2t2t1t1t2t1f1t2f1f2t1f1t1f1ffcLJMQQpJ:cQQQQQQQ,                                    
QQQQQQQQQ2FhpS1U1t1t2f1f1f1f1f2f1tfUft2XQQQDcj2t2UtYjtDpUt2f1f1f1f2t1t1t1f1t2t1tfJJURQQQQQQZJY2t1f1f2t1f1UtJjJ1XRQQQQQR22jtt2f1f1f2t2t2t2f1f2U2h9X91ft1t2f1t1f1f1t1f1t1f1t1f1f2t1f2t2t2t1f1t2f2f12FtJ7J0QQQMQQQQQQX                                     
QQQQQQQQQRUSh9S1U2t1t2t1f1t1f1f1f2f2ttjUUMQQDYJ2t2tfjjYUU2f2t1f2t2t1t2f1f1t2f1t1f2UttQQQQQQQRtLtt1f1t2t1f2t1ttJtUh9QQQQQS1ftU1f2t1t1f1f1t2t1t2tt19X9fft2f1t2f2t1f1f1t2f1t1f2t1t2f1t1t1t2t1f1f2t1f2tF11cri2QQQQQQQQQ0                                    
QQQQQQQQQQ9UShpX1j2t1f2f2t1t2t2t2f1t2f2jjcFRQRUJ2t1t1t2t1t1t1t1t1f1f1f1f2f1t1t1t2t2jt2RQQQQQQQhLtU2t1f2f1t1f2t2UtU2fpRQQQpF2ft1f2f2t1t2f1t2f1t1tftXppUff1t1f1f1f1f2f2f1t1f1t2t1t1f2f2f1t1t2t2t1t1t1f1fF2JrrjQQQQQQQQQ.                                  
QQQQQQQQQQQStShPXhjft1t1t2t1t1f2t2t1t1f2UfYJfQRFt1f1t1t2f1t1t2t2t2t1t1t1t2f2t1f1t1f2jffDQQQQQQQZcJU2t2f1f2t1f1f1ttjffFXQQQpFh2U1t1t1t1f1t1f2t1t2ffUFPPt1f2f2f1t2f1f1t1f1t1t1t2f1t1f1t1t2t1t1f2t1f1f2f2fF1FcriSQQQQQQQQL                                 
QQQQQQQQQQQQPtShPPSUft2t2f1f2t1t1t1f1f2t1t2UUY12ft2f2f1f2f1f2t1t2f1f1f1t1f2t1f1t1t1f2j22PRQQQQQQQ1cJ2t1t1f1f1t1f1t2UttFfDQQphXFj2t1f1f1t2f1t1f2f2f2UfhFt1t2t2t2f1t1f1f2tfjtjfUftft2t1t2f2f1f2f1f2f1t1t2t1fhfL:LRQQQQQQQZ                                
QQQRpFFQQQQQQ0UhFPXp2tt2t2f1t1t2t1t1f1t1t2t1t2t2t1t2tfUfU2UfUfU2t2t2t1t1t2t2f1t1f1f2f2j111PQQQQQQQDULUt1t1t2f1f2f1t1tfj1fXQQXhS2U1t2t1t1t2f2f1f2f1f1tff1f2t1f1f2f1f1UUYJcJYJcJcYcJYUjtj2t1t1t1t1t2t1f2f2t1f11triXQQQQQQQQ.                              
DX1t221UEQQQQQMt1hPXpF2j2f1t1f2t2f1t2f2t2t2t2tfttjfUft1f12F2F1hf1tfUfU2t1f1t1f1t2t1f2t2j1hF2ZQQQQQQQDYYJ2t1f1f2t2t1t1t2j22FRQhSS2U1f1f1f1f2t1f2t2t1t1t1f1f1t1t1f2tfjYchDQQQQQQRDbhhjjJJcJJ2t1f1f1t1t1t2f1t1fF117itQQQQQQQQQQQQb7:                       
UF1XhXFhUhRQQQQQFf1Xh9XhtfU1t2f2f1t1f2UfUfUfUft12hFXhPXpPpXpXpX9PPSPFhf2jfU1t2t1t2t2t1t2Uf1XfhbQQQQQQQpjLUt2t1t2t1f1f1t1UtfFMQFphtf1t1t1f1t2f2t1f2f1f1f2f1f2t1t2ttcJpQQQQQQQQQQQQQQQQQQQ0tctt1f1f1t2f1f1f1t2t12hciYQQQQQQQQQQQQQQQQpr,                  
XhXhXhPhhtJZQQQQQ92fXhpPp12UfUtjtUtjfU2fF2ShPSpXpXPSPFShXFXhXhPhPXpX9Pphh22jft2t2t2t1t2f1UtUShF2DQQQQQQQEJcJ2t2f2f1f2t2t2tfU1DRF92ft1t1t1t2f1t1t1t1f1t2f2f1f1t2ftJbQQQQQQbhUUU1bQQQQMMQQQQEcjU1t1t1f1t1t1t1f1t12hYicQQQQQQQQQQQQQQQQQQS                 
hPhXhPSX1fbQQQQQQQRStFFXSpXXFhFS1SFXhPXpXpSpSXFFfFt2t2f1fFtF2hFPSPhPhPS9P9SX11jfjft1f1f1t1tfj21XfF9QQQQQQQbtLjjft1t1t2f1f1ttjF0PSXU2f2f2t1f1t1t1t1t1t2U2t2t1t2tfYQQQQQQpccLJYJ7r7hEQ7:rJMQQQjJU2t2t1t1t1f1f1f1fF2FYiYQQQQQQQQQQQQQQQQQQ                 
XhXSPhSF2DQQS2ZQQQQQMt21XSPSpPpXpXpSXhS1Ft2t2fFh99MMQQQQQQQQQR0hXhXSXhPhXhPXpXX11UtU2f1f1t1t1UtUF1h20RQQQQQQMjYYfU1t1f2f1t1tfjhXpXFU1f2f1t2f1f2t1f1t22Ft2U1t2f2UYQQQQQtLttft2tFftLL7c777rLQQQFcJ2f1f2t1t2f1t1t1f2fhci2QQZtjLYJSMQQQQQQQ.                
hXhSFSffZQQbUFUFZQQQQQ91UF1XFh1h2Ff2U2fhSbERRQQQQQQQQQQQRRZEpPhPhPhXhXhPSSFh1ShPXpF1UtUff2t2f2tfjf2X2FSQQQQQQQM1LJUff1f1t2f1f2jhP01ft1f2f1t1t2f1t1f1f1FpF2Uft2ttcQQQQh7ft2tfUft1f1f121fhtriRQQ9YYft1f1f1t1f2t1f1f1fF7ibQbjjJ7LiiLQQQQQQr                
XFS12tSRQQRthhX2fpQQQQQQZF1t12h1XpEZQQQQQQQQQQQQQQQQR1tcJYjj2fSFShXhPhPhXP0XS22f11PSpF1UfU2t2t1f1tfU11h2PMQQQQQQQ1JcUt1t2f2t1t1jh9PU2t2f1f2f1f1t2f1t1tff0XXtft2JYQQQQcUtftSFhttJtU2t1f2thUrrQQQMU7UU2t2f1f1t1f1f1t111rrQQ2PXhtFci7QQQQQt                
f2tS9QQQQQtFhXhXF2FQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQMDPX21t2t1fF1hFhF9MQQQQR0Pf2fXXX11Uft1f2t1t2jfU12FhMQQQQQQQPcYj2t1t2f1t2UXSff2f2t2t2t1t1f2t1f2tt20PpF2YcSQQQQJj2f9PSFPFtLYcJcjjtUFJi1QQQQbjYcft2f2t1t1t1t2fF1ji2Q9FPPStF7iQQQQQp                
pEQQQQQQQS1FPhXSXF22QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQRR00XP1h22jjjpQQQQQQDPt21PXP12jfU2t1t2ffUftFfXEQQQQQQQXJctt2f1f2f2fXf1t2t1f1f2f2f2f1t1f2U1SphphfMQQQQSJfUhXhhQQQQR0b9D9SFht2Lr9QQQQQRScJU2t1f1f1t1t1fFfLiQRFhpS22jLQQQQQZ                
QQQQQQQQZfFPSXhPSXhhtDQQQQQQQQQQQQQQQQQQQRQQQRRQQQQQQQQQQQQQQQQQQQQQQQQQQQQQERQQQQQQQQEXt1hpXX11Uft1f1t1tfj2f1FZQQQQQQQpcjt1t1f1f2f1t1t2f2f1t1f1t2f2t2ftfphXh2RQQQ0jc2U2hXtMQQQQQQQQQQ0pPP11cr72ZQQQQQtJt2f1f1f1f2t12hJrjQ1PXXU2YSQQQQQQ                
QRMXU9QQ0UShPSXhPhXFSfSpDEEX0QQQ9Xb00ppFf2QQMJtJXQQZM00FFUUcjJYLYU11p9MRQQQQQQQQQQQQQQQQQpFthXpSXf2U2t2f2t1jtjFfh0QQQQQQQjYj2t1t1f2t1t1f1t1f1f2t1f1t1t2UhXPF2hQQQhLJ2tf19FFQQQQQMpP222hhPX911tJrrrtbQQQFJt2f2f1t1t1fF2177RbS9t2UJ9QQQQQQ                
f2t1thQQQ21XSXhXSPSXhS21f2UJSQQRJ2fFf12ftQQQtFthQQQMEMDRDDp9F1Jcri..,, ,,..::rLfPRQQQQQQQQQE2f1PS9ShttU2f2t1ffjt212ZQQQQQQhYj2t2f2t1f1f2f1t1t2t2f2f2f1tt29hhUQQQRcJft1h9F19QQQQQhJJtU2fFFP1tU1fFfU7rrhQQ2Jt1f2f1f2f1f12JrXRPFttfcRQQQQQQ                
ShXhStQQQp2FXhXSXSXSXhPhSfffQQQ92FXhXSFJQQQSh1hQQffhXhXPEZQQQQQQQQQQQQRhJr:..,... rQQQQQQQQQQbhthFPXpF1tft2t2t2ttththMQQQQQPYj1f1t2t1t1f2f2t1f1t1t1t2t1t2SXtZQQQZc2tf1pFStQQQQQQQRQMMEEpF2PFtt2fF2FfJ:7QQJff2f2f1f1f1fht7LMX2t2jJQQQQQQQ                
hXSXhFhQQQ2hhPSXSPXpSph1tPMQQQQ0UXhXXh7hQQXUffQQ1..:::::.:::.::ircj0RQQQQQQQb17:.7RQQQQQQQQQQQQM221Xh9PX2fUft1f2ttjhF2XQQQQQSJU1f1t1f1f1f1f1f1f1t2f2t2t2jS10QQQEjtf1j2R9JpQQQQQQQQQQQQQQQhfPhtU2f1f12tiDQFj1f2f2t1t1f2fhc7t9t2ttjQQQQQQQ                
XhXSXF2DQQQtSSPXpSS2tJtSQQQQQQQRfFXPXYYQQRiiiXQR::rr7rrrrrririiii:::::irfEQQQQQQQQQQQQQQQQQQQQQQQb1thhXXpShttt2t2t2jhS2tQQQQQUJt1f1t1f2f1f1f1t2f1f1t2f1ffUFQQQJ7tt2t2JZQbQQQQQQQQQQQQQQQQQSfphfU2f1f12J2Qttt1t1f2f1t1f1FUrFF2t1Y1QQQQQQQ                
hXhPhX1FQQQMU112JY7JfZQQQQEffQQQ1FSPjYhQQJrrYQQr:rr7r7r7r7r7r7r7rrrrrrii:::i7XQQQQQQQQQQQfQQQQQQQQQEt1FPSpPP12U2t2f2jSXFtQQQQQcft2t1t1f1f1t2t1t2t1f1f1f1ttUQQRrYJft1ttjQQQQQQQQQQQQQQQQQQQQPtpS2U1t1f1tfS2U1f2f1t1f1t2fF2LjFt2tjFQQQQQQQ                
PSPhXhSfSQQQEL7Lj1RQQQQQE2t220QQRtP2jcQQZi7rQQ1.rr7r7r7r7r7r7r7r7r7r7rrr7rr::.::cFQQQQQQQc fQQQQQQQQQX2fShPSpPSUft1t2tPS1hQQQQXcff1t1f1f2t2f1f2t1f1f1f1f1UJRQQbtjcJj2jj1QQQQQQQQQQQQQQQQQQQQXfPS1U2t1t2Uft2f1t2t2t1t1t2fhJUf1f1chQQQQQQQ                
hXhPSPhXf0QQQQMQQQQQQQpFttJFh2DQQ0UUc1QQ7rrhQQ:rr7r7r7r7r7r7r7r7r7r7r7r7r7r7rrii:.iQQQQQQQ  ,QQQQQQQQQRSUFFPhpXpF2Uftt1pF1QQQQQJJ1f2f1t1t1t1f1f2f2f2f1t2f1JtQQQQQQPtctJUSQQQQQQQQQQQQQQQQQQQQSfpX2j2f1t2f2t1t2t2t1t1f1t2fFfFf1fJFQQQQQQQ                
PSpSpS9XPtEQQQQQQQQDX22UtjfUXh2RQQF77EQDr7rQQ:,rc77r7r7r7r7r7r7r7r7r7r7r7r7r7r7rri.2QQQQQQR   7QQQQQQQQQZ221XhXXpXhjfjfXPtZQQQQ1Jf1f1t1f1t1t1t2t2f2f2t1f1t2JfEQQQQQQEYUjUFQQQQQ1XEQQQQQQQQQQQQ1FpX2U2t1t2f2t1t1t1t2f2t1f1f2f1f1JhQQQQQQQ                
XpSXSpXXSPUMQQQQM011tfJft1t2tPh2EQQpSQQJrrUQR  ,rcr7r7r7r7r7r7r7r7r7r7r7r7r7r7r7rr::QQQQQQQ     XQQQQQQQQQPffShPhpPpftJSSFXQQQQZcft2t1t1f2f1t1f2t1f2t1t1f2tfJJctfPDQQQJtjUfRQQQtJUtEQQQQQQQQQQ01h91ft1t2f1f1t2f1t1t1t1t2t1f1f1ttjQQQQQQQQ               
2UfU2tt7Lr7QQRPFFf2jtt2t1t2tttPS1PQQQQQr7rQQi , ,rLr7r7r7r7r7r7r7r7r7r7r7r7r7r7r7rr.FQQQQQQt     .QQQQQQQQQRXthhXSPPpFf2P1SQQQQQJU1f1t2t1f2t1f1f2f2f2f1t1t1t2UtJUYYchQQJfUUjPQQJjjjc20QQQQQQQQRtXSpU2f1t1f2f1t2t1t1f1f1f1t1f2t1UJRQQQQQQQQ              
t2t1fFJL7rYQQFtFUtj2t2t1f1t1ttUFhFtZQQXr77QQ  ,, i77r7r7r7r7r7r7r7r7r7r7r7r7r7r7r7ri:QQQQQQQ       LQQQQQQQQQZf2FXhPSphXSh1QQQQQJUt1f1t2t2f2t2f1f1f1f2f1f1t1f1t1t2ttYjpFt1UUjh1Ut2tfYj1QQQQQQQRFFpP2U2f1t2t2t2f2t1f1f1t2t1t1f1t2YfQQQQQQQQQ             
1f1tFFj7crQQRfFjtt1t2t1f1t1t1t2U2ftZQQJr7JQR.i777r7rrrrrrr7rrr7r7r7r7r7r7r7r7r7r7r7r:XQQQQQQ:        0QQQQQQQQQSf2ShPhPSX11QQQQQFY2f2t1t1f2f1f1f2f1t2t1f1t1t1f2f2f1t2Utt1f1tfUft2t2ttcLjQQQQQQRtXh9f2t1t2f2t1f1t1t2f1t1f1f1f1t1f2rbQQQQQQQQQ            
t2t121LYrJQQPhU2t1t1f1f1t2t2f2f1UJJQQQ77rSQM:rii::::.:.::::::iiiirrrr7r7r7r7r7r7r7rr:7QQQQQQh         :QQQQQQQQQD1fShPhXhStQQQQQPYU2t1t2f2t1f1f2t1f1f1f1f2f2f1t1f1f2t1t1f2f1f2t2Utt2jUtPQQQQQQSFhPPFU1t1f1f1f1t2f1f2t1t2f1t1t2f12JiFQQQQQQQQY           
1fF2SYc7rRQQFttf1t1f1t1t1f1f1t2t1YhQQQr7rPQ0.iYJfFpp0P9XStUcLri::.::::iirrrr7r7r7r7ri:QQQQQQQ           1QQQQQQQQQpUFFPhXh10QQQQQLtt1f2f1t1f1t2t1f1t1f2t1t2f1f1f2t1t1t1t1t2t2t2tSfJYDQQQQQQQQR1FXS92tf1t1f2t2t1t2t1t1f2f1f1f1f1t12c:rDQQQQQQR           
f1FSJL7r2QQRttU2t2f1f1t1f2t1f1t1tJXQQMrLr0QQQQQQQQQQQQQQQQQQQQQQQQp1Lr::.::iirr7r7r7i.PQQQQQQ,           .QQQQQQQQQR22FXhX1SQQQQQXL2t1t2t1f1f1f1f2t2t1f2t1f2t2f1t1f2t2t1t2t1f1ffXQQPLU9QQQQQQh2XhXXSUft2t2f2f1t1t1f1f2f1t2f1f1f2tFfYiYQQQQQQ9           
hftL7riYQQQ9tj2t1f1t1t1f1f1t1f1tfcDQQEr7r9QR:...,,....::rr7JFEQQQQQQQQQQM2ci:.::iirrr.FQQQQQQ7             7QQQQQQQQQP22XhSURQQQQQJJ1t1f1f2t1t2f2f2t1t2t2f2t2f1f1f1f2t2t1f1f1t1tUjRQQ2rrJjXPS2ShPSPPhUft2t2t1t2f2t1t1t1t2t1t1t2t2fhfr7QQQQQQ7           
YLrricbQQQQPjtf1t2t1f1t1t2t1f2fFtjDQQZrLr0Q2       ,:rri::.:.::::irJFRQQQQQQQRFLi:.:..RQQQQQQb               QQQQQQQQQD1tXFF1QQQQQDcJft2tUJft2t2f2f1t1f1f1f1f2t1t1t2f1f2t2t1t1f1UtcFQQRt7LJF2XFShPhXPp22jft1f1t1f1t1t1t2t2f2t1f1f1thrcQQQQQQ,           
ri71QQQQQQQ9fjff1t1f1t2t1f2t1tF12rZQQDr7rFQE ,.....,,.i7Y77rrrrii:i::.::7JEQQQQQQQEJipQQQQQQR                 LQQQQQQQQQPthh1PQQQQQ9cJfJYtXYtt2f1t1t2f2t1f1f1f1t1t1t2t2f1f1t2t2t1tfJJEQQEU2tft1fF1ShXS9PSf2Uft2t1f2t1f1t1f1f1t2f1t1UrbQQQQQQ:           
2RQQQQRSRQQQ2FUft1f1f1f1t2tF2h2j7iMQQQrLr2QQ ,......., .:cL7r7r7rrrrrrii::.::LhQQQQQQQQQQQQQL,                 ,QQQQQQQQQEtF129QQQQQpL7UEQQDLjU2f1f1t2t2t2f2t1f1f2f2t1t1f1f1t1t1f2f2jY2QQQQQMR00hhf1FPSPX9SS2fjft1f1t1f1f1f1f1t1t2JYpQQQQQQQQQ.         
QQQQZhfUhQQQZtStft1f1t1f1fh1FJc7r:ZQQQ777LQQ  .........,,,iLYr7r7r7r7r7r7rrii::.i7XQQQQQQQQQQQQ,                 JQQQQQQQQQf21fXQQQQQDjRQQQQRYJj2U2jUYJYff1t2t1f2t1f2t1t1t2f1f1f2f1f2UJJQQQQQQQQQQQbFhPSXSpX9SS2fjfU2f1t1t1f2f1f2JYMQQQQQQQQQQQ         
QZX1ttJF1pQQQ0fP2fU2t1fF2Stj77rrL9QQQQY777QQ. ..........., .rJ77r7r7r7r7r7r7rrrr::.:itEQQQQQQQQQ                  .QQQQQQQQQSt12FQQQQQQQQQQQQQ1ccJLJtPbQM022t1f1f2f1t1t2t1t1t1t2f1f1f1tjLRQQQQQQQQQQPhhPSPSPhpP9SX22jft2t2t1t1t2UJZQPLXQQQQQQQQ1        
1UtjtjtUXtEQQQS2Ph2U1tF11YLrrrtMQQQQQQhrLrQQr .............,,:Y77r7r7r7r7r7r7r7r7rrii:::PQQQQQQQQ                   0QQQQQQQQbft1tbQQQQQQRQQQQQMUfRQQQQ0fJ2t1t1f1f2f1fFFFttU2t2t1t1t1t1ttYjcJLJhQREREFpSPhPhPhPSpX9SSffU2t2f1f1tUXQPY77LQQQQQQQQ        
Utj2t1tttXtZQQQXtPXSU12f7riLhQQQQQ9QQQZr7rPQp ,.............,,.LL7r7r7r7r7r7r7r7r7r7rrii.JQQQQQQQP                   rQQQQQQQQR1tht1bQQQQfjRQQQQQQQQQQpcU22Ft1f1t1f2t1tFh9FFUfUfU2t2f1t2ffjtjtJJJYLJfSX0P9X9SPSPSXhpXph1t1f2t1t2jQ9FU2f7cQQQQQQQ        
2t1t1f2tt1XtMQQQpjSX1UcirJMQQQQQZfJRQQQ77rjQQ  ..............,,.LL7r7r7r7r7r7r7r7r7r7r7rr.cQQQQQQQi                   ,QQQQQQQQQhtS22fbQ9thjpQQQQQQQQ1UtF21Uff2f2t2t2t2UtF0P9SS22tfUft1t2t1f1f2tfU2UtU22h1ShpXpXphPhPhpSfU2f1f2t1XPhff2YJQQQQQQQQ       
f2f1f2t1tfhXtMQQQZU1c77pQQQQQQ0htfUDQQQ2rLrQQi .............,.,,,777r7r7r7r7r7r7r7r7r7r7rr.jQQQQQQQ                     bQQQQQQQQPtSFhfFFShSt1MQQQQQcJtfJcLJt2f2f2t1ffjSfU29SpXpSpFhtfjtt1t2f2t2f1t1t2UfUtUfUF1SXpPPhPS01ft2t1t2t9PhU1jcZQQQQQQQQQ      
1f2f2t2f2j2XStDQQQQbEQQQQQQDp2fUUJ2SQQQZr7r9QE  ,,,,,,,,,,,,,,,  ,7r7r7r7r7r7r7r7r7r7r7r7rr.SQQQQQQQ                     cQQQQQQQQ0UShXhShXhSfURQQQJjtJ77c121f1f1t2tfUFppUtF9hXSPX9XpSX22ttUtjfU2t2f1f1t2t1t2ttU22XX9SPPhU1t2f1UhpFU2UJ2QQQQQQQQQQL     
f2f1t1t1t1UFPp29QQQQQQQQDp12UtjfUttFQQQQ77rJQQ,,.::::iiriririi:i:.r7r7r7r7r7r7r7r7r7r7r7rrri.RQQQQQQ2                     :QQQQQQQQ9tSSPSXSPh1hQQQXJfc7cth2Ft2f2ttj22PP9X1j2XXhPhPhPXPX9XXFXFh21UfUft1f1t1f1t2t2tfj11pP9fft1t1t22FU2tUJQQQQQQQQQQQQ     
2t2f1f1t1f1Uf1pt2QQQR0P21tfjtU2f1tffDQQQ9iLiQQD:77L7L77r7777L7L7c77rrr7r7rrr7r7r7r7r7r7r7r7ri:QQQQQQQ.                     ,QQQQQQQQ9fXSXSXhSfQQQQJUj7Yfh2Ff1fftF1XX9XPX92jtpSXhXSPhPhXSpX9X9PpPpSht2j2t1f1f1f1f1f2Utth12f2f1f1t2t1ffYQQQf1QQQQQQQQ.    
f1f1t1t1f1thY77rrQQ9J2UtjtU1f2t1t1UFhQQQQ7rrUQQi.::::::::::::::::::::::iirirrrrrr7r7r7r7r7r7r:7QQQQQQQ                       QQQQQQQQFFPSPhX1hQQQZL1LLUht1t1tt1PX9XPhXS9XUtP2SSpSPSpXpSpSphPSXhPSpX9SSttjft1f2f1t1t1t2U2t1f1t1f1f1ffj0Qcii:cQQQQQQQh    
1f2f1f1t1t12jLLrtQQXhftU2f2f1f1f1tft1MQQQFr7rQQMPQQQQQQQQQQQQQQRMb0h2Jcrri:::.::iirirr7r7r7r7i:XQQQQQQD                      rQQQQQQQfXSPSXhhFQQQ0JtLch21t2tf20XPhPSPXp1tLUQM2h1Ft2tff12S1XSpSPXPSPSpPphhttj2t1t2f1t2t2f1t2f1t1t2tfUfSJLJL7iZQQQQQQQ    
t1t1f1t1f2fFYYLrhQQPFFU1f1f2t1t2f2tt2PQQQQr7rtQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQZFYri::.::iirrrrr::QQQQQQQr                     ZQQQQQQZ1hXSPhX1SQQQQc27t11f2tff9SPSPXphFJcLtbQQF7JJft2UfjtYJcJJf2XhpXphXSpXphhttjft2t2t2t2t2t1t1t1Ut2pfftF2hLi1QQQQQQQ    
1t2f1t2t2fFfYLcrRQQFXt2t2f2f1t1t1f2jF2QQQQpiLiQQJ                     ..:rjFZQQQQQQQ9j7::.::iii,2QQQQQQQ                     QQQQQQQDUShPSXhS2QQQQfJYUFf2f1jSXPhpXXUY7f0QQQQQMQQQQQQQQQQQQQE02fYJJ1hPXPSXS9XphFf2UfjtU2fhf2tfUtt1F9XfjtUF1JiFQQQQQQQ    
t1f2f1f2t11t7J77QQQhFft2t1t1t1f2f2tfUFXQQQQ7r7LQQ. ,,.,.,.,.,.,,,,,,       ,,.,:r9QQQQQQQQSJr:..MQQQQQQ.                     ZQQQQQQRt2ShXhXh1bQQQ0JJt21f2tfSphphfLUpQQQQQQQQQQQQQQQQQQQQQQQQQQQMptJct1PXPhpX9PphSFSFPX9pFjf1hFPPpSP2h1PXhY:0QQQQQQQ    
1f1t2t1t2fhJYL7YQQQ2hj2t1f1f2f1t1t1tt21RQQQbr7r9QQ ,........................:rc7i:::i7FDQQQQQQRRQQQQQQD                      :QQQQQQQ9f2SFXhX2FQQQQUJUFf2f2tpXP1cJMQQQQQQQRDZbD9EEMDRRQQQQQQQQQQQQQQM1jctFPXPSPX9PpXpXpX9fU29XpSX2SSpPpSXJ7JQQQQQQQF    
f1t2t1t2f1fYLYipQQRF2ft1t2t1t1f1t1f2tf2hQQQQJrr7QQL ,.......................,,.rLLrri:.::rLpQQQQQQQQQQQQQS                    QQQQQQQQMFtFhXSSfXQQQQcUt2t1t2PptY9QQQQQ9hfft1fh1h2hf1UfU22SPEERRQQQQQQQQRhjcfFPSPhPhXSPSphUtpXXF1fRDFhXFFUU9QQQQQQQp     
2f2f1t2fF1fLY7rQQQR12U1f1t1t2f2t2t1f1UF10QQQQr7rUQQ, ,........................,,.iY77rrrr::.::YSQQQQQQQQQQM                    QQQQQQQQQZ222ShSt9QQQELtt1t2t92cZQQQQXU21SSPhh2FUUcL77r7r77cYjUFh9bQQQQQQQQRfJYFSphPhXSPh22Phhf2XQQRfXF2pQQQQQQQQQJ      
f1t2t1f2fSYcc7JQQQp1j2t1f2f1t2t1t1t2t2UXfRQQQpi7iEQQ ,,.........................,,.7cLr7rrrrii:::rYRQQQQQQQQ                    RQQQQQQQQQbFthFSU9QQQp7Ut2t2hYpQQQQ1tSSphhttjtYYLYcJJjJJLL77r77JJ12PpMQQQQQQQ0jJUXXXhSFS1Sfff0RQQQSFf2ZQQQQQQQQQ:       
1t1f1f2tFtYLciRQQRhttf2t1f1f1t2t1t1f1ftfXtQQQQYr7rQQ2 ,...........................,,:Lc77r7r7rrrr::.tQQQQQQQQ                    rQQQQQQQQQQD122hUXQQQbLjt2tfJQQQR1fXXXftUft2U2fh1hFh1h1h1FtfJY777LY22hSMQQQQQQZ1ct21f2tFh0ZQQQQQpftFRQQQQQQQQQ         
f2t1f2t1FU7crJQQQS2tt1t1f1f2f1t1t1f1t1ttFhFQQQQr77LQQi ,............................ .7c77r7r7r7r7ri.rQQQQQQQQ,                    SQQQQQQQQQQDhj1thQQQQjcYtLPQQQ12XSFUtt2f2t2fF2Ff1f1f1fFfF1h1FftcL7YJ2fFXRQQQQQQFpERRQQQQQQQQR1fJPQQQQQQQQQP          
1t1t2t111LcrrQQQPffU1f1f2t2t1t2t1t2f1f1t2h1PQQQpr7rfQQ. .............................,.rc77r7r7r7r7rr::bQQQQQQQ:                     pQQQQQQQQQQMFfjt9QQQD2L7hQQF2XXFjft2t1t1t1t1t2t1fFf1f1t2t1f1fh22JJcjt1fS0QQQQQQQQQMZ99QQQQfjUEQQQQQQQQQi           
f2t1fF1FcLi7MQQbf1U2t2f2t1f1f2t1f1t1t2f2UFS2DQQQJr7rbQQ  .............................,.7Lr7r7r7r7r7rr:.2QQQQQQQ7                      0QQQQQQQQQQMXJjtZQQQQpMQPfXSpt2f2f1t2f2t2t2U1t1tfUfJUJJcYcJYUU2f2Utjft129MQR91hFh2jrSQQQPJRQQQQQQQQM             
1f11h2tL7iJQQQRtSjff1t2f1f2f1f1t1t1t1t2f2UPh2QQQQr77rQQQ  .............................,.LLr7r7r7r7r7rri.cQQQQQQQj                      ,9QQQQQQQQQQQStYfPQQQQRtSh9hft2f1f1t21FJJcJYJcJLJcUUhXbbDpPfjLJJfU2ttj2t1hh1X2JL7ribQQQpQQQQQQQQQr              
2h12Jcri7EQQQQXth2U2f1t1t2f1f2f2f2f2t1t121UPf9QQQRiLr7QQM  .............................,:c7r7r7r7r7r7r7i:rQQQQQQQP                        hQQQQQQQQQQQbtjJ2FP1SFPX1U1t2t2t1thDQRMXpS90MQQQQQQQQQQQQQQPfcJJtU2Utt2t2UjcJYcJQQQQQQQQQQQQM                
1JY7ri7SQQQQQQQUhFft2f2t1f1f2t2f1t1t1f12hJ7J2pQQQQPiLrjQQF  ............................,,777r7r7r7r7r7rrr:iQQQQQQQM                         JQQQQQQQQQQQEhJfthFh12j1t1f2jft1UU1RQQQQQQQQQQRREE0DbRQQQQQQb2cJYtUfjft2tFfjYQQQQQQQQQQQQi                 
77ii79QQQQQMQQQRtSFfj2t1t1f2f1t2f2t1fF1hYLrr0QQQQQQJrcihQQL ,............................,:cr7r7r7r7r7r7r7r::RQQQQQQQ                          7QQQQQQQQQQQQP1t1SQ92f1tffPjjt2ttYJjFt2jUcJLYLJcYLYcYct1EQQQQMhJYcjJUjjcYUQQQQQQQQQ:                     
rrtMQQQQQ0FJ0QQQQfhFfU2f1f2t1f1t2t2th1tL7i7DQQQRQQQQ7rLiZQQ: ,...........................,:L7r7r7r7r7r7r7r7r:.bQQQQQQQ                           :QQQQQQQQQQQQQQQQ2Jc7Yjf0Q2tU1tfUtJUJUJfjft2t2t2U2ttJJLJJhZQQQQbfUcJjSMQQQQQQQQQ.                      
ZQQQQQR922UFfPQQQQhFhFj2t2t2f2f1f12SfJ77itQQQQbttQQQMr77rQQQ, ,.,.,.,,,,,,,,,,,.,.,......,.c77r7r7r7r7r7r7r7ri.SQQQQQQQ,                           .hQQQQQQQQQQQQjc7L221UJQQjtt2jfU2jtjft1f1t1t2f1f1f1t2UtYJchRQQQQQQQQQQQQQQQQc                        
QQQRbF1tfUtUS1hQQQQ911htft2f1f1fh1FYLrr7ZQQQQh2tFfQQQFr777QQQ  ,,,.............,.,,,,,,,, :L7r7r7r7r7r7r7r7r7ri.2QQQQQQQ.                             7QQQQQQQQQhLLYh21tfLXQFJ2j1JJcJJff2f1t2f1tfUtj2t1f2t2UtJYLtQQQQQQQQQQX.                           
EpFFtfjfU2ffjFFFMQQQRSfX21jffF2htJ77i7SQQQQ021UUth2QQQc7LrJQQ2,rrL7cLcLYLYLcLYLL77rrii::..:cr7r7r7r7r7r7r7r7r7rr.jQQQQQQQ:                              iQQQQQQQLJJFf2UtYLEQjUJJQStDQQQ9Uft2jtcJLJYjYtt2t1t2tfJ7JQQQQQQQQQQ                             
h21Utj2t1f1t2jFh29QQQQbtFhh2fjULLrrrhQQQQEhf1jtUt2hhQQQr77rSQQj:777r7rrrrrrrrr7r7777LLYLc77r7r7r7r7r7r7r7r7r7r7rr.cQQQQQQQi                             ,QQQQQQQYj2JJLJYUpQp77Y0QQQQQ9J7JYYLJjXbQQQQDYUUff2tULjpQQQQQQQQQR                              
*/

// This is 'Non-Unique_Only_Keys_Are_Inserted_in_Btrees' revision, 2019-Sep-28:
// TO-DO Benefits:
// - Smaller footprint, much smaller!
// - Faster key searches due to smaller height of B-trees, thus compression becomes much speedy!
// - Wearing of the SSD is not as atrocious as before.

// This is 'PASSES' revision of main 'btree' revision, command-line-wise it differs only in the letter case:
// Single-pass revision:
// D:\>Nakamichi %1 %1.Nakamichi 25 420000 e
// Multi-pass revision a.k.a.'PASSES':
// D:\>Nakamichi %1 %1.Nakamichi 25 420000 E
// The upper case means 2^25 =~ 32M slots are to be divided in 128 passes, it creates B-trees into cache-friendly manner, DONE!
// TO-DO! Its purpose is to build all the Btrees in RAM without trashing the SSD with random reads/writes, when a pass is complete then writing in a single 'fwrite' happens, thus concatenating Btrees sub-pools to the master pool. TO-DO!
// In order to avoid changing command line options, a few workarounds are to be enforced:
// - using the decompression buffer for building a given pass of the Btrees
// - Number of passes is automatically set to 2^7=128 (there is strong reason for that - to fit into N size i.e. filesize: 128N > 98N, because if all slots point to a unique leaf (98 bytes-per-leaf)):
// HashChunkSizeInBITS_GLOBAL = HashInBITS_GLOBAL - 7;

//TO-DO1: Reduce (return actually) the keysize to 1:1, not as present where HEX doubles the keysize... DONE! 2019-Feb-07
//TO-DO2: Replace all 'if (BSTorBtree == 2) {' with '#if defined(ExternalRAM)' '#else' '#endif'

// In 2019-Feb-10 revision, SHA3-224 is in use.

// In 2019-Feb-07 revision, the size of keys in the LEAF is back to 1:1 - instead of ending with ASCII 0, the first (i.e. zero) byte of the key houses the length - 1..255, pretty enough since 28 bytes will be the MAX - the SHA3-224.

// In 2019-Jan-20 revision, the allocation bug in SSD (z/Z) mode was fixed by adding Internal/External if-else check.
// Also, for benchmarking SSDs via USB, there is a tool reporting the mode:
/*
If the device is connected in USB 3.0 SuperSpeed mode, it will show:
Device Bus Speed         : 0x03 (SuperSpeed)

For USB 2.0, it will show:
Device Bus Speed         : 0x02 (High-Speed)

For USB 1.1, it will show:
Device Bus Speed         : 0x01 (Full-Speed)

https://www.uwe-sieber.de/usbtreeview_e.html
*/

// Ryuugan-ditto-1TB features 1TB as well.
// Ryuugan+ features 128GB as well.
// Washigan+ has been tuned for 2/3 bytes windows...
// Nakamichi_Washigan is strongest so far and by far - it is just as Okamigan but uses the reserved value 9.
// Okamigan is strongest so far and by far.
// Okami is stronger than Okamiko thanks to the additional 6:3 (64KB window), plus, 14:4 (16MB window) instead of 48:3/24:3/12:3/6:3 (64KB window).
// Okamiko is stronger than Zato thanks to the additional 48:3/24:3/12:3/6:3 (64KB window).

// 狼 Okami, the next...
// Nakamichi 'Zato' is successor to 'Tsubame' which is to 'Tengu-Tsuyo' which is to 'Tengu'.
// 座頭 - Zato
// The character's name is actually Ichi. Zatō is a title, the lowest of the four official ranks within the Tōdōza, the historical guild for blind men. (Thus zato also designates a blind person in Japanese slang.) Ichi is therefore properly called Zatō-no-Ichi ("Low-Ranking Blind Person Ichi", approximately), or Zatōichi for short. Massage was a traditional occupation for the blind (as their lack of sight removed the issue of gender), as was playing the biwa or, for blind women (goze), the shamisen. Being lesser Hinin (lit. "non-people"), blind people and masseurs were regarded as among the very lowest of the low in social class, other than Eta or outright criminals; they were generally considered wretches, beneath notice, no better than beggars or even the insane — especially during the Edo period — and it was also commonly thought that the blind were accursed, despicable, severely mentally disabled, deaf and sexually dangerous.
// Source: https://en.wikipedia.org/wiki/Zatoichi

// Compilation:
/*
Intel(R) Parallel Studio XE 2015
Copyright (C) 1985-2014 Intel Corporation. All rights reserved.

Intel(R) MPI Library 5.0 Update 1 Build Environment for Intel(R) 64 applications
Copyright (C) 2007-2014 Intel Corporation. All rights reserved.


Intel(R) Trace Analyzer and Collector 9.0 Update 1 for Windows* OS for Intel(R) 64 applications
Copyright (C) 1996-2014 Intel Corporation. All rights reserved.

Setting environment for using Microsoft Visual Studio 2010 x64 cross tools.

C:\Program Files (x86)\Intel>cd "Composer XE 2015"

C:\Program Files (x86)\Intel\Composer XE 2015>cd bin

C:\Program Files (x86)\Intel\Composer XE 2015\bin>iclvars.bat
Syntax:
 iclvars.bat <arch> [vs]

   <arch> must be is one of the following
       ia32         : Set up for IA-32 host and target
       ia32_intel64 : Set up for IA-32 host and Intel(R)64 target
       intel64      : Set up for Intel(R) 64 host and target
   If specified, <vs> must be one of the following
       vs2010      : Set to use Microsoft Visual Studio 2010
       vs2010shell : Set to use Microsoft Visual Studio Shell 2010
       vs2012      : Set to use Microsoft Visual Studio 2012
       vs2012shell : Set to use Microsoft Visual Studio Shell 2012
       vs2013      : Set to use Microsoft Visual Studio 2013
   If <vs> is not specified, the version of Visual Studio detected at install
   time is used.


C:\Program Files (x86)\Intel\Composer XE 2015\bin>iclvars.bat intel64
Intel(R) Parallel Studio XE 2015
Copyright (C) 1985-2014 Intel Corporation. All rights reserved.
Intel(R) Parallel Studio XE 2015 Composer Edition (package 108)
Setting environment for using Microsoft Visual Studio 2010 x64 tools.


C:\Program Files (x86)\Intel\Composer XE 2015\bin>d:

D:\>cd D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)

D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)>dir
 Volume in drive D is S640_Vol5
 Volume Serial Number is 5861-9E6C

 Directory of D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)

12/02/2016  01:25 PM    <DIR>          .
12/02/2016  01:25 PM    <DIR>          ..
11/28/2016  01:34 PM         4,353,536 Booklet_Okamigan.doc
11/28/2016  01:35 PM         2,766,041 Booklet_Okamigan.pdf
10/25/2016  01:08 AM            55,397 lzsse2.cpp
10/25/2016  01:08 AM             4,858 lzsse2.h
10/25/2016  01:08 AM             2,481 lzsse2_platform.h
11/14/2016  08:52 PM             1,357 MakeEXEs_Okamigan.bat
10/25/2016  01:08 AM             1,632 MokujIN BLUE 224 prompt.lnk
10/25/2016  01:08 AM             1,632 MokujIN CYAN 224 prompt.lnk
10/25/2016  01:08 AM             1,632 MokujIN DARK 224 prompt.lnk
10/25/2016  01:08 AM             1,632 MokujIN GREEN 224 prompt.lnk
10/25/2016  01:08 AM             1,632 MokujIN ORANGE 224 prompt.lnk
12/02/2016  01:23 PM           417,892 Nakamichi_Okamigan.c
11/28/2016  06:55 PM        10,245,120 Okamigan_TurboBench.doc
11/28/2016  06:56 PM         5,119,192 Okamigan_TurboBench.pdf
              14 File(s)     22,974,034 bytes
               2 Dir(s)  30,903,410,688 bytes free

D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)>MakeEXEs_Okamigan.bat

D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)>icl /TP /O3 /QxSSE4.1 Nakamichi_Okamigan.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY /FAcs
Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726
Copyright (C) 1985-2014 Intel Corporation.  All rights reserved.

Nakamichi_Okamigan.c
lzsse2.cpp
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

-out:Nakamichi_Okamigan.exe
Nakamichi_Okamigan.obj
lzsse2.obj

D:\TEXTUAL_MADNESS_old\Nakamichi_Okamigan\Nakamichi_Okamigan_(source-executable-booklet)>icl /TP /O3 /QxAVX Nakamichi_Okamigan.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY /FAcs
Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726
Copyright (C) 1985-2014 Intel Corporation.  All rights reserved.

Nakamichi_Okamigan.c
lzsse2.cpp
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

-out:Nakamichi_Okamigan.exe
Nakamichi_Okamigan.obj
lzsse2.obj
*/

// 2016-Apr-04: Grrr... Stupid bug (due to overlooking) was crushed in 'TT', namely:
/*
//#define Min_Match_Length (32)
  #define Min_Match_Length (4)
*/
// becomes:
/*
//#define Min_Match_Length (32)
//#define Min_Match_Length (4)
  #define Min_Match_Length (16) // Maximum MatchLength is 16, it decides the size of Look-ahead buffer - to avoid search beyound end. This needs more attention in the future - to clarify it fully. Overlapping is also yet to come.
*/

// 2016-Apr-03: Finished the unfinished 2016-Mar-31 draft. Stupid stats bug was fixed TargetSize -> VerifySize in line: k = (((float)1000*VerifySize/(clocks2 - clocks1 + 1))); k=k>>20; k=k*Trials;
// 2016-Mar-31: added the FASTEST decompressor - LZSSE2 - to juxtapose two XMM vs XMM etudes, below the compile lines:
/*
D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>MakeEXEs_Tengu-Tsuyo.bat

D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>icl /TP /O3 /QxSSE4.1 Nakamichi_Tengu-Tsuyo.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY /FAcs
Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726
Copyright (C) 1985-2014 Intel Corporation.  All rights reserved.

Nakamichi_Tengu-Tsuyo.c
lzsse2.cpp
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

-out:Nakamichi_Tengu-Tsuyo.exe
Nakamichi_Tengu-Tsuyo.obj
lzsse2.obj

D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>icl /TP /O3 /QxAVX Nakamichi_Tengu-Tsuyo.c lzsse2.cpp -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY /FAcs
Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726
Copyright (C) 1985-2014 Intel Corporation.  All rights reserved.

Nakamichi_Tengu-Tsuyo.c
lzsse2.cpp
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

-out:Nakamichi_Tengu-Tsuyo.exe
Nakamichi_Tengu-Tsuyo.obj
lzsse2.obj

D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>dir Nakamichi_Tengu-Tsuyo*
 Volume in drive D is S640_Vol5
 Volume Serial Number is 5861-9E6C

 Directory of D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2

03/31/2016  12:50 AM           107,458 Nakamichi_Tengu-Tsuyo.c
03/27/2016  11:04 PM         1,234,944 Nakamichi_Tengu-Tsuyo.doc
03/31/2016  12:57 AM           948,131 Nakamichi_Tengu-Tsuyo_XMM_PREFETCH_4096_Intel_15.0_64bit_AVX.cod
03/31/2016  12:57 AM           139,264 Nakamichi_Tengu-Tsuyo_XMM_PREFETCH_4096_Intel_15.0_64bit_AVX.exe
03/31/2016  12:57 AM           943,556 Nakamichi_Tengu-Tsuyo_XMM_PREFETCH_4096_Intel_15.0_64bit_SSE41.cod
03/31/2016  12:57 AM           146,432 Nakamichi_Tengu-Tsuyo_XMM_PREFETCH_4096_Intel_15.0_64bit_SSE41.exe
               6 File(s)      3,519,785 bytes
               0 Dir(s)   8,169,893,888 bytes free

D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>dir lzs*
 Volume in drive D is S640_Vol5
 Volume Serial Number is 5861-9E6C

 Directory of D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2

03/30/2016  10:05 PM            55,397 lzsse2.cpp
03/30/2016  10:17 PM             4,858 lzsse2.h
03/31/2016  12:57 AM           690,697 lzsse2_64bit_AVX.cod
03/31/2016  12:57 AM           734,033 lzsse2_64bit_SSE41.cod
03/27/2016  07:49 AM             2,481 lzsse2_platform.h
               5 File(s)      1,487,466 bytes
               0 Dir(s)   8,169,893,888 bytes free

D:\_The_Usual_Suspects\Nakamichi_(Tengu-Tsuyo)_1MB-Sliding-Window_vs_LZSSE2>
*/

// 2016-Mar-19: Tiny improvement in encoding (just forgot to refresh two define's), namely:
/*
//#define Min_Match_Length (32)
  #define Min_Match_Length (4)
//#define OffsetBITS (32-3)
  #define OffsetBITS (29)
*/

// How to compile:
// icl /O3 /QxSSE2 Nakamichi_Tengu-Tsuyo.c -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY /FAcs

// Nakamichi_Tengu-Tsuyo.c, using 16B/4KB/1MB or (8-4)bit/(16-4)bit/(24-4)bit windows with 1/2/3 bytes long offsets.
// The variant 'Tsuyo' tries next position and if it gives higher ratio it is used.

// 中道 nakamichi [noun]
// English Meaning(s) for 中道
//  1. road through the middle; middle road
// Meanings for each kanji in 中道
// 中 in; inside; middle; mean; center
// 道 road-way; street; district; journey; course; moral; teachings

// 天狗 tengu
// heavenly dog

// 強 - Tsuyo
// https://glosbe.com/ja/en/%E5%BC%B7
// Translations into English:
//    JMdict:
//    a little more than   
//    JMdict:
//    a little over   
//    JMdict:
//    military build-up   
//    JMdict:
//    one of the biggest   
//    JMdict:
//    one of the most powerful   
//    JMdict:
//    powerhouse

// The first Nakamichi was 'Kaidanji', based on Nobuo Ito's source, thanks Ito.
// The main goal of Nakamichi is to allow supersimple and superfast decoding for English x-grams (mainly) in pure C, or not, heh-heh.
// Natively Nakamichi is targeted as 64bit tool with 16 threads, helping Kazahana to traverse faster when I/O is not superior.
// In short, Nakamichi is intended as x-gram decompressor.

// Eightfold Path ~ the Buddhist path to nirvana, comprising eight aspects in which an aspirant must become practised; 
// eightfold way ~ (Physics), the grouping of hadrons into supermultiplets by means of SU(3)); (b) adverb to eight times the number or quantity: OE.

void x64toaKAZE (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEcomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}

char * _ui64toaKAZEzerocomma4 (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 4 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 4 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

/* minimum signed 64 bit value */
#define _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
#define _I64_MAX      9223372036854775807i64
/* maximum unsigned 64 bit value */
#define _UI64_MAX     0xffffffffffffffffui64

/* minimum signed 128 bit value */
#define _I128_MIN   (-170141183460469231731687303715884105727i128 - 1)
/* maximum signed 128 bit value */
#define _I128_MAX     170141183460469231731687303715884105727i128
/* maximum unsigned 128 bit value */
#define _UI128_MAX    0xffffffffffffffffffffffffffffffffui128

      char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      // below duplicates are needed because of one_line_invoking need different buffers.
      char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits5[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)

// During compilation use one of these, the granularity of the padded 'memcpy', 4x2x8/2x2x16/1x2x32/1x1x64 respectively as GP/XMM/YMM/ZMM, the maximum literal length reduced from 127 to 63:
//#define _N_GP
//#define _N_XMM
//#define _N_YMM
//#define _N_ZMM

//#define _N_prefetch_64
//#define _N_prefetch_128
//#define _N_prefetch_4096

//Only one must be uncommented:
//#define _WIN32_ENVIRONMENT_
//#define _POSIX_ENVIRONMENT_

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h> // uint64_t needed
#include <time.h>
#include <string.h>

      clock_t clocks0, clocks1, clocks2;
	time_t time1,time2;

#if defined(_WIN32_ENVIRONMENT_)
#include <io.h> // needed for Windows' 'lseeki64' and 'telli64'
//Above line must be commented in order to compile with Intel C compiler: an error "can't find io.h" occurs.
#include <fcntl.h> // 2020-Jan-13
#else
#endif /* defined(_WIN32_ENVIRONMENT_)  */

#ifdef _N_XMM
#include <emmintrin.h> // SSE2 intrinsics
#include <smmintrin.h> // SSE4.1 intrinsics
#endif
#ifdef _N_YMM
#include <emmintrin.h> // SSE2 intrinsics
#include <smmintrin.h> // SSE4.1 intrinsics
#include <immintrin.h> // AVX intrinsics
#endif
#ifdef _N_ZMM
#include <emmintrin.h> // SSE2 intrinsics
#include <smmintrin.h> // SSE4.1 intrinsics
#include <immintrin.h> // AVX intrinsics
#include <zmmintrin.h> // AVX2 intrinsics, definitions and declarations for use with 512-bit compiler intrinsics.
#endif

#ifdef _N_XMM
void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
void NotSoSlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_lddqu_si128((const __m128i *)(SOURCE))); }
#endif
#ifdef _N_YMM
void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
void NotSoSlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_lddqu_si128((const __m128i *)(SOURCE))); }
#endif
#ifdef _N_ZMM
void SlowCopy128bit (const char *SOURCE, char *TARGET) { _mm_storeu_si128((__m128i *)(TARGET), _mm_loadu_si128((const __m128i *)(SOURCE))); }
#endif
/*
 * Move Unaligned Packed Integer Values
 * **** VMOVDQU ymm1, m256
 * **** VMOVDQU m256, ymm1
 * Moves 256 bits of packed integer values from the source operand to the
 * destination
 */
//extern __m256i __ICL_INTRINCC _mm256_loadu_si256(__m256i const *);
//extern void    __ICL_INTRINCC _mm256_storeu_si256(__m256i *, __m256i);
#ifdef _N_YMM
void SlowCopy256bit (const char *SOURCE, char *TARGET) { _mm256_storeu_si256((__m256i *)(TARGET), _mm256_loadu_si256((const __m256i *)(SOURCE))); }
#endif
//extern __m512i __ICL_INTRINCC _mm512_loadu_si512(void const*);
//extern void    __ICL_INTRINCC _mm512_storeu_si512(void*, __m512i);
#ifdef _N_ZMM
void SlowCopy512bit (const char *SOURCE, char *TARGET) { _mm512_storeu_si512((__m512i *)(TARGET), _mm512_loadu_si512((const __m512i *)(SOURCE))); }
#endif

// SearchIn... uses it:
void FIPS202_SHA3_224(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);

#ifndef NULL
#define NULL ((void*)0)
#endif

// LZSSE2 [
#ifdef _N_alone
#else
#include "lzsse2.h"
#endif
// LZSSE2 ]

// Comment it to see how slower 'BruteForce' is, for Wikipedia 100MB the ratio is 41KB/s versus 197KB/s.
#define ReplaceBruteForceWithRailgunSwampshineBailOut

void SearchIntoSlidingWindow(unsigned int* HowManyDittoTagsToEmit, unsigned int* ShortMediumLongOFFSET, uint64_t* retIndex, unsigned int* retMatch, char* refStart,char* refEnd,char* encStart,char* encEnd, char* src, char* srcR, uint64_t srcSize);
unsigned int SlidingWindowVsLookAheadBuffer(char* refStart, char* refEnd, char* encStart, char* encEnd);
uint64_t Compress(char* ret, char* src, char* srcR, uint64_t srcSize);
//unsigned int Decompress(char* ret, char* src, unsigned int srcSize);
uint64_t Decompress(char* ret, char* src, uint64_t srcSize);
//char * Railgun_Trolldom(char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern);
char * Railgun_Trolldom_64(char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern); // 2020-Jan-10
char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern);
char * Railgun_BawBaw_reverse(char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern);
char * Railgun_Baw_reverse(char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern);

/*
void memcpy_AVX_4K_prefetched (void *dst, const void *src, size_t nbytes) {
// F3 0F 6F /r RM V/V SSE2 Move unaligned packed integer values from xmm2/m128 to xmm1.
// MOVDQU xmm1, xmm2/m128 
// F3 0F 7F /r MR V/V SSE2 Move unaligned packed integer values from xmm1 to xmm2/m128.
// MOVDQU xmm2/m128, xmm1 
// VEX.128.F3.0F.WIG 6F /r RM V/V AVX Move unaligned packed integer values from xmm2/m128 to xmm1.
// VMOVDQU xmm1, xmm2/m128 
// VEX.128.F3.0F.WIG 7F /r MR V/V AVX Move unaligned packed integer values from xmm1 to xmm2/m128.
// VMOVDQU xmm2/m128, xmm1 
// VEX.256.F3.0F.WIG 6F /r RM V/V AVX Move unaligned packed integer values from ymm2/m256 to ymm1.
// VMOVDQU ymm1, ymm2/m256 
// VEX.256.F3.0F.WIG 7F /r MR V/V AVX Move unaligned packed integer values from ymm1 to ymm2/m256.
// VMOVDQU ymm2/m256, ymm1 
if ( (nbytes&0x3f) == 0 ) { // 64bytes per cycle
	__asm{
		mov		rsi, src
	        mov		rdi, dst
	        mov		rcx, nbytes
	        shr		rcx, 6
	main_loop:
		test		rcx, rcx ; 'nbytes' may be 0
	        jz		main_loop_end
	        prefetcht0	[rsi+64*64]
		vmovdqu 	xmm0, [rsi]
	        vmovdqu 	xmm1, [rsi+16]
	        vmovdqu 	xmm2, [rsi+32]
	        vmovdqu 	xmm3, [rsi+48]
		vmovdqu 	[rdi], xmm0
	        vmovdqu 	[rdi+16], xmm1
	        vmovdqu 	[rdi+32], xmm2
	        vmovdqu 	[rdi+48], xmm3
	        add		rsi, 64
	        add		rdi, 64
		dec		rcx
	        jmp		main_loop
	main_loop_end:
	        sfence
	}
} else memcpy(dst, src, nbytes);
}

void memcpy_SSE2_4K_prefetched (void *dst, const void *src, size_t nbytes) {
// F3 0F 6F /r RM V/V SSE2 Move unaligned packed integer values from xmm2/m128 to xmm1.
// MOVDQU xmm1, xmm2/m128 
// F3 0F 7F /r MR V/V SSE2 Move unaligned packed integer values from xmm1 to xmm2/m128.
// MOVDQU xmm2/m128, xmm1 
// VEX.128.F3.0F.WIG 6F /r RM V/V AVX Move unaligned packed integer values from xmm2/m128 to xmm1.
// VMOVDQU xmm1, xmm2/m128 
// VEX.128.F3.0F.WIG 7F /r MR V/V AVX Move unaligned packed integer values from xmm1 to xmm2/m128.
// VMOVDQU xmm2/m128, xmm1 
// VEX.256.F3.0F.WIG 6F /r RM V/V AVX Move unaligned packed integer values from ymm2/m256 to ymm1.
// VMOVDQU ymm1, ymm2/m256 
// VEX.256.F3.0F.WIG 7F /r MR V/V AVX Move unaligned packed integer values from ymm1 to ymm2/m256.
// VMOVDQU ymm2/m256, ymm1 
if ( (nbytes&0x3f) == 0 ) { // 64bytes per cycle
	__asm{
		mov		rsi, src
	        mov		rdi, dst
	        mov		rcx, nbytes
	        shr		rcx, 6
	main_loop:
		test		rcx, rcx ; 'nbytes' may be 0
	        jz		main_loop_end
	        prefetcht0	[rsi+64*64]
		movdqu 		xmm0, [rsi]
	        movdqu 		xmm1, [rsi+16]
	        movdqu 		xmm2, [rsi+32]
	        movdqu 		xmm3, [rsi+48]
		movdqu 		[rdi], xmm0
	        movdqu 		[rdi+16], xmm1
	        movdqu 		[rdi+32], xmm2
	        movdqu 		[rdi+48], xmm3
	        add		rsi, 64
	        add		rdi, 64
		dec		rcx
	        jmp		main_loop
	main_loop_end:
	        sfence
	}
} else memcpy(dst, src, nbytes);
}
*/

#ifdef _N_HIGH_PRIORITY
// https://msdn.microsoft.com/en-us/library/windows/desktop/ms686219.aspx
#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#endif

/*
int main( void )
{
   DWORD dwError, dwPriClass;

   if(!SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS))
   {
      _tprintf(TEXT("Already REALTIME_PRIORITY\n"));
      goto Cleanup;
   } 

   // Display priority class

   dwPriClass = GetPriorityClass(GetCurrentProcess());

   _tprintf(TEXT("Current priority class is 0x%x\n"), dwPriClass);

   if (dwPriClass==0x00000100) printf("Current priority class is REALTIME_PRIORITY_CLASS.\n");


Cleanup:
   // Clean up
   ;
return 0;
}

// IDLE_PRIORITY_CLASS
// 0x00000040
// Process whose threads run only when the system is idle. The threads of the process are preempted by the threads of any process running in a higher priority class. An example is a screen saver. The idle-priority class is inherited by child processes.

// NORMAL_PRIORITY_CLASS
// 0x00000020
// Process with no special scheduling needs.

// HIGH_PRIORITY_CLASS
// 0x00000080
// Process that performs time-critical tasks that must be executed immediately. The threads of the process preempt the threads of normal or idle priority class processes. An example is the Task List, which must respond quickly when called by the user, regardless of the load on the operating system. Use extreme care when using the high-priority class, because a high-priority class application can use nearly all available CPU time.

// REALTIME_PRIORITY_CLASS
// 0x00000100
// Process that has the highest possible priority. The threads of the process preempt the threads of all other processes, including operating system processes performing important tasks. For example, a real-time process that executes for more than a very brief interval can cause disk caches not to flush or cause the mouse to be unresponsive.
*/

// Min_Match_Length=THRESHOLD=4 means 4 and bigger are to be encoded:
#define Min_Match_BAILOUT_Length (8)
#define Min_Match_Length (704)
//#define Min_Match_Length (4)
//#define Min_Match_Length (16) // Maximum MatchLength is 16, it decides the size of Look-ahead buffer - to avoid search beyound end. This needs more attention in the future - to clarify it fully. Overlapping is also yet to come.
#define Min_Match_Length_SHORT (5)
//#define OffsetBITS (32-3+8) // 37bit=128GB
#define OffsetBITS (32+8) // 40bit=1TB
  //#define OffsetBITS (20)
#define LengthBITS (1)

//12bit
//#define REF_SIZE (4095+Min_Match_Length)
//#define REF_SIZE ( ((1<<OffsetBITS)-1) + Min_Match_Length )
#define REF_SIZE ( (((1LL)<<OffsetBITS)-1) )
//3bit
//#define ENC_SIZE (7+Min_Match_Length)
#define ENC_SIZE ( ((1<<LengthBITS)-1) + Min_Match_Length )

#define _rotl_KAZE(x, n) (((x) << (n)) | ((x) >> (32-(n))))
#define _rotl_KAZE64(x, n) (((x) << (n)) | ((x) >> (64-(n))))

uint32_t FNV1A_Hash_YoshimitsuTRIADii(const char *str, uint64_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    const char *p = str;
    uint32_t Loop_Counter;
    uint32_t Second_Line_Offset;

if (wrdlen >= 24) {
    Loop_Counter = (wrdlen/24);
    Loop_Counter++;
    Second_Line_Offset = wrdlen-(Loop_Counter)*(3*4);
    for(; Loop_Counter; Loop_Counter--, p += 3*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+0+Second_Line_Offset))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+4+Second_Line_Offset),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+8+Second_Line_Offset))) * PRIME;        
    }
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
} else {
    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;
}
    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

uint32_t FNV1A_Hash_YoshimitsuTRIAD(const char *str, uint64_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    //uint32_t hash32D = 2166136261;
    const char *p = str;

    for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        
		//hash32D = (hash32D ^ (_rotl_KAZE(*(uint32_t *)(p+24),5) ^ *(uint32_t *)(p+28))) * PRIME;        

/*
// Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86 gave this:
// 12d-0f4+2= 59 bytes, No CARAMBA anymore.
$LL9@FNV1A_Hash@2:

; 160  : 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  000f4	8b 01		 mov	 eax, DWORD PTR [ecx]
  000f6	c1 c0 05	 rol	 eax, 5
  000f9	33 41 04	 xor	 eax, DWORD PTR [ecx+4]
  000fc	83 eb 18	 sub	 ebx, 24			; 00000018H
  000ff	33 f0		 xor	 esi, eax

; 161  : 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  00101	8b 41 08	 mov	 eax, DWORD PTR [ecx+8]
  00104	69 f6 e7 d3 0a
	00		 imul	 esi, 709607		; 000ad3e7H
  0010a	c1 c0 05	 rol	 eax, 5
  0010d	33 41 0c	 xor	 eax, DWORD PTR [ecx+12]
  00110	83 c1 18	 add	 ecx, 24			; 00000018H
  00113	33 f8		 xor	 edi, eax

; 162  : 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  00115	8b 41 f8	 mov	 eax, DWORD PTR [ecx-8]
  00118	69 ff e7 d3 0a
	00		 imul	 edi, 709607		; 000ad3e7H
  0011e	c1 c0 05	 rol	 eax, 5
  00121	33 41 fc	 xor	 eax, DWORD PTR [ecx-4]
  00124	33 e8		 xor	 ebp, eax
  00126	69 ed e7 d3 0a
	00		 imul	 ebp, 709607		; 000ad3e7H
  0012c	4a		 dec	 edx
  0012d	75 c5		 jne	 SHORT $LL9@FNV1A_Hash@2
*/

/*
// Intel(R) C++ Compiler XE for applications running on IA-32, Version 12.1.1.258 Build 20111011 gave this:
// 216a-212f+2= 61 bytes, No CARAMBA anymore.
;;;     for(; wrdlen >= 3*2*sizeof(uint32_t); wrdlen -= 3*2*sizeof(uint32_t), p += 3*2*sizeof(uint32_t)) {

  02127 83 fa 18         cmp edx, 24                            
  0212a 72 43            jb .B4.5 ; Prob 10%                    
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.2:                          ; Preds .B4.1
  0212c 89 34 24         mov DWORD PTR [esp], esi               ;
                                ; LOE eax edx ecx ebx ebp edi
.B4.3:                          ; Preds .B4.2 .B4.3

;;; 		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        

  0212f 8b 31            mov esi, DWORD PTR [ecx]               
  02131 83 c2 e8         add edx, -24                           
  02134 c1 c6 05         rol esi, 5                             
  02137 33 71 04         xor esi, DWORD PTR [4+ecx]             
  0213a 33 de            xor ebx, esi                           

;;; 		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        

  0213c 8b 71 08         mov esi, DWORD PTR [8+ecx]             
  0213f c1 c6 05         rol esi, 5                             
  02142 33 71 0c         xor esi, DWORD PTR [12+ecx]            
  02145 33 fe            xor edi, esi                           

;;; 		hash32C = (hash32C ^ (_rotl_KAZE(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        

  02147 8b 71 10         mov esi, DWORD PTR [16+ecx]            
  0214a c1 c6 05         rol esi, 5                             
  0214d 33 71 14         xor esi, DWORD PTR [20+ecx]            
  02150 83 c1 18         add ecx, 24                            
  02153 33 ee            xor ebp, esi                           
  02155 69 db e7 d3 0a 
        00               imul ebx, ebx, 709607                  
  0215b 69 ff e7 d3 0a 
        00               imul edi, edi, 709607                  
  02161 69 ed e7 d3 0a 
        00               imul ebp, ebp, 709607                  
  02167 83 fa 18         cmp edx, 24                            
  0216a 73 c3            jae .B4.3 ; Prob 82%                   
                                ; LOE eax edx ecx ebx ebp edi
.B4.4:                          ; Preds .B4.3
  0216c 8b 34 24         mov esi, DWORD PTR [esp]               ;
                                ; LOE eax edx ecx ebx ebp esi edi
.B4.5:                          ; Preds .B4.1 .B4.4
*/

    }
	if (p != str) {
		hash32 = (hash32 ^ _rotl_KAZE(hash32C,5) ) * PRIME;
		//hash32B = (hash32B ^ _rotl_KAZE(hash32D,5) ) * PRIME;
	}

    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}


#if defined(_icl_mumbo_jumbo_)
// GetRDTSC() taken from strchr.com
#if defined(_M_IX86)
unsigned long long __forceinline GetRDTSC(void) {
   __asm {
      ; Flush the pipeline
      XOR eax, eax
      CPUID
      ; Get RDTSC counter in edx:eax
      RDTSC
   }
}
#elif defined(_M_X64)
unsigned long long __forceinline GetRDTSC(void) {
	return __rdtsc();
}
#else
unsigned long long __forceinline GetRDTSC(void) {
	return GetTickCount();
}
#endif
#endif

// Leprechaun BBhex [
// How to Compile?
// For *nix replace -D_WIN32_ENVIRONMENT_ with -D_POSIX_ENVIRONMENT_

// The command line should have one of these, if not the default is set to Windows:
//#define _WIN32_ENVIRONMENT_
//#define _POSIX_ENVIRONMENT_

#if defined(_WIN32_ENVIRONMENT_) || defined(_POSIX_ENVIRONMENT_)
#else
#define _WIN32_ENVIRONMENT_ // Default
#endif

// Compile for BB=24 with:
// icl /Ox /TcLeprechaun_x-leton.c /FaLeprechaun_x-leton /w /FAcs -Dsingleton -D_1p -D_WIN32_ENVIRONMENT_ -DLongestLineInclusive=48 -DExternalRAM -DRAMpoolInKB=12000123

#ifndef LongestLineInclusive
//#define LongestLineInclusive 36 // Default is 18*2, for HEXed i.e. 2:1 - printable keys, that is.
#define LongestLineInclusive 28 // Actually for not HEXed keys the MAX should be 28*1=28 - the 1:1 length of SHA3-224.
#else
#endif

#ifndef SpeedUpBuilding // This is how many megabytes you want to add up to the 'TargetBuffer' - if more then less passes - if huge (like 92000) then probably 1 pass only
#define SpeedUpBuilding 32
#else
#endif

#if defined(InternalRAM) || defined(ExternalRAM)
#else
#define InternalRAM // Default
#endif

#ifndef RAMpoolInKB
#define RAMpoolInKB 5123456 // Default ~5GB
#else
#endif

#ifndef pseudoLAZY
#define GREEDY
#else
#endif

/*
#if defined(_WIN32_ENVIRONMENT_)
__declspec(align(64))
#else
//__attribute__((aligned(64)));
#endif 
*/

typedef unsigned short USHORT; // As for 'With *(DWORD*), a buffer overrun is possible at the end of a memory page.' I knew about it but was fooled by assembly code generated by VS2010 which translates it to a word access:
typedef unsigned int UINT;
//typedef unsigned int DWORD;

#ifndef NULL
#ifdef __cplusplus
#define NULL 0
#else
#define NULL ((void*)0)
#endif
#endif

#ifndef HashInBITS
#define HashInBITS 27 // default 26 i.e. 2^26 i.e. 64MS(Mega Slots); slots contain 8bytes pointers or 512MB, because many netbooks have 512MB free (1GB in total)!
#else
#endif

#ifndef HashChunkSizeInBITS
#define HashChunkSizeInBITS 27 // Defines the number of passes. Should be smaller or equal to HashInBITS. If HashInBITS == HashChunkSizeInBITS then 2^(HashInBITS-HashChunkSizeInBITS)=2^0=1 pass(es).
#else
#endif

int RAMpoolInKB_GLOBAL= RAMpoolInKB;
int HashInBITS_GLOBAL= HashInBITS;
int HashChunkSizeInBITS_GLOBAL= HashChunkSizeInBITS;

#if defined(InternalRAM) 
int BSTorBtree=3;
#endif

#if defined(ExternalRAM) 
int BSTorBtree=2;
#endif

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#if defined(_WIN32_ENVIRONMENT_)
#include <io.h> // needed for Windows' 'lseeki64' and 'telli64'
//Above line must be commented in order to compile with Intel C compiler: an error "can't find io.h" occurs.
#else
#endif /* defined(_WIN32_ENVIRONMENT_)  */

#define ROL(x, n) (((x) << (n)) | ((x) >> (32-(n))))
UINT FNV1A_Hash_Jesteress_27bit(const char *str, unsigned int wrdlen)
{
	const UINT PRIME = 709607;
	UINT hash32 = 2166136261;
	const char *p = str;

	// Idea comes from Igor Pavlov's 7zCRC, thanks.
/*
	for(; wrdlen && ((unsigned)(ptrdiff_t)p&3); wrdlen -= 1, p++) {
		hash32 = (hash32 ^ *p) * PRIME;
	}
*/
	for(; wrdlen >= 2*sizeof(UINT); wrdlen -= 2*sizeof(UINT), p += 2*sizeof(UINT)) {
		hash32 = (hash32 ^ (ROL(*(UINT *)p,5)^*(UINT *)(p+4))) * PRIME;		
	}
	// Cases: 0,1,2,3,4,5,6,7
	if (wrdlen & sizeof(UINT)) {
		hash32 = (hash32 ^ *(UINT*)p) * PRIME;
		p += sizeof(UINT);
	}
	if (wrdlen & sizeof(USHORT)) {
		hash32 = (hash32 ^ *(USHORT*)p) * PRIME;
		p += sizeof(USHORT);
	}
	if (wrdlen & 1) 
		hash32 = (hash32 ^ *p) * PRIME;
	
	return (hash32 ^ (hash32 >> 16)) & (( ((1LL)<<HashInBITS_GLOBAL) )-1);
}

// "There it now stands for ever. Black on white.
// I can't get away from it. Ahoy, Yorikke, ahoy, hoy, ho!
// Go to hell now if you wish. What do I care? It's all the same now to me.
// I am part of you now. Where you go I go, where you leave I leave, when you go to the devil I go. Married.
// Vanished from the living. Damned and doomed. Of me there is not left a breath in all the vast world.
// Ahoy, Yorikke! Ahoy, hoy, ho!
// I am not buried in the sea,
// The death ship is now part of me
// So far from sunny New Orleans
// So far from lovely Louisiana."
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
// 
// "Walking home to our good old Yorikke, I could not help thinking of this beautiful ship, with a crew on board that had faces as if they were seeing ghosts by day and by night.
// Compared to that gilded Empress, the Yorikke was an honorable old lady with lavender sachets in her drawers.
// Yorikke did not pretend to anything she was not. She lived up to her looks. Honest to her lowest ribs and to the leaks in her bilge.
// Now, what is this? I find myself falling in love with that old jane.
// All right, I cannot pass by you, Yorikke; I have to tell you I love you. Honest, baby, I love you.
// I have six black finger-nails, and four black and green-blue nails on my toes, which you, honey, gave me when necking you.
// Grate-bars have crushed some of my toes. And each finger-nail has its own painful story to tell.
// My chest, my back, my arms, my legs are covered with scars of burns and scorchings.
// Each scar, when it was being created, caused me pains which I shall surely never forget.
// But every outcry of pain was a love-cry for you, honey.
// You are no hypocrite. Your heart does not bleed tears when you do not feel heart-aches deeply and truly.
// You do not dance on the water if you do not feel like being jolly and kicking chasers in the pants.
// Your heart never lies. It is fine and clean like polished gold. Never mind the rags, honey dear.
// When you laugh, your whole soul and all your body is laughing.
// And when you weep, sweety, then you weep so that even the reefs you pass feel like weeping with you.
// I never want to leave you again, honey. I mean it. Not for all the rich and elegant buckets in the world.
// I love you, my gypsy of the sea!"
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
//
// Dedicated to Pippip, the main character in the 'Das Totenschiff' roman, actually the B.Traven himself, his real name was Hermann Albert Otto Maksymilian Feige.
// CAUTION: Add 8 more bytes to the buffer being hashed, usually malloc(...+8) - to prevent out of boundary reads!
// Many thanks go to Yurii 'Hordi' Hordiienko, he lessened with 3 instructions the original 'Pippip', thus:
//#include <stdlib.h>
//#include <stdint.h>
#define _PADr_KAZE(x, n) ( ((x) << (n))>>(n) )
uint32_t FNV1A_Pippip_Yurii(const char *str, size_t wrdlen) {
	const uint32_t PRIME = 591798841; uint32_t hash32; uint64_t hash64 = 14695981039346656037ULL;
	size_t Cycles, NDhead;
if (wrdlen > 8) {
	Cycles = ((wrdlen - 1)>>4) + 1; NDhead = wrdlen - (Cycles<<3);
#pragma nounroll
        for(; Cycles--; str += 8) {
		hash64 = ( hash64 ^ (*(uint64_t *)(str)) ) * PRIME;        
		hash64 = ( hash64 ^ (*(uint64_t *)(str+NDhead)) ) * PRIME;        
	}
} else
	hash64 = ( hash64 ^ _PADr_KAZE(*(uint64_t *)(str+0), (8-wrdlen)<<3) ) * PRIME;        
hash32 = (uint32_t)(hash64 ^ (hash64>>32));
	//return hash32 ^ (hash32 >> 16);
	return (hash32 ^ (hash32 >> 16)) & (( ((1LL)<<HashInBITS_GLOBAL) )-1);
} // Last update: 2019-Oct-30, 14 C lines strong, Kaze.

// https://godbolt.org/z/i40ipj x86-64 gcc 9.2 -O3
/*
FNV1A_Pippip_Yurii:                              FNV1A_Pippip(char const*, unsigned int):
        mov     rax, QWORD PTR [rdi]                    mov     rax, QWORD PTR [rdi]
        cmp     rsi, 8                                  cmp     esi, 8
        jbe     .L2                                     jbe     .L2
        lea     rax, [rsi-1]                            lea     ecx, [rsi-1]
        shr     rax, 4                                  xor     edx, edx
        lea     rdx, [8+rax*8]                          shr     ecx, 4
        movabs  rax, -3750763034362895579               add     ecx, 1
        sub     rsi, rdx                                lea     eax, [0+rcx*8]
        add     rdx, rdi                                sub     esi, eax
                                                        movabs  rax, -3750763034362895579
                                                        movsx   rsi, esi
                                                        add     rsi, rdi
.L3:                                            .L4:
        xor     rax, QWORD PTR [rdi]                    xor     rax, QWORD PTR [rdi+rdx*8]
        add     rdi, 8                                  imul    rax, rax, 591798841
        imul    rax, rax, 591798841                     xor     rax, QWORD PTR [rsi+rdx*8]
        xor     rax, QWORD PTR [rdi-8+rsi]              add     rdx, 1
        imul    rax, rax, 591798841                     imul    rax, rax, 591798841
        cmp     rdi, rdx                                cmp     ecx, edx
        jne     .L3                                     jg      .L4
.L4:                                            .L3:
        mov     rdx, rax                                mov     rdx, rax
        shr     rdx, 32                                 shr     rdx, 32
        xor     eax, edx                                xor     eax, edx
        mov     edx, eax                                mov     edx, eax
        shr     edx, 16                                 shr     edx, 16
        xor     eax, edx                                xor     eax, edx
        ret                                             ret
.L2:                                            .L2:
        movabs  rdx, -3750763034362895579               movabs  rdx, -3750763034362895579
        mov     ecx, 8                                  mov     ecx, 8
        sub     ecx, esi                                sub     ecx, esi
        sal     ecx, 3                                  sal     ecx, 3
        sal     rax, cl                                 sal     rax, cl
        shr     rax, cl                                 shr     rax, cl
        xor     rax, rdx                                xor     rax, rdx
        imul    rax, rax, 591798841                     imul    rax, rax, 591798841
        jmp     .L4                                     jmp     .L3
*/

// And some visualization:
/*
kl= 9..16 Cycles= (kl-1)/16+1=1; MARGINAL CASES:
                                 2nd head starts at 9-1*8=1 or:
                                        012345678
                                 Head1: [Q-WORD]
                                 Head2:  [Q-WORD]

                                 2nd head starts at 16-1*8=8 or:
                                        0123456789012345
                                 Head1: [Q-WORD]
                                 Head2:         [Q-WORD]

kl=17..24 Cycles= (kl-1)/16+1=2; MARGINAL CASES:
                                 2nd head starts at 17-2*8=1 or:
                                        01234567890123456
                                 Head1: [Q-WORD][Q-WORD]
                                 Head2:  [Q-WORD][Q-WORD]

                                 2nd head starts at 24-2*8=8 or:
                                        012345678901234567890123
                                 Head1: [Q-WORD][Q-WORD]
                                 Head2:         [Q-WORD][Q-WORD]

kl=25..32 Cycles= (kl-1)/16+1=2; MARGINAL CASES:
                                 2nd head starts at 25-2*8=9 or:
                                        0123456789012345678901234
                                 Head1: [Q-WORD][Q-WORD]
                                 Head2:          [Q-WORD][Q-WORD]

                                 2nd head starts at 32-2*8=16 or:
                                        01234567890123456789012345678901
                                 Head1: [Q-WORD][Q-WORD]
                                 Head2:                 [Q-WORD][Q-WORD]

kl=33..40 Cycles= (kl-1)/16+1=3; MARGINAL CASES:
                                 2nd head starts at 33-3*8=9 or:
                                        012345678901234567890123456789012
                                 Head1: [Q-WORD][Q-WORD][Q-WORD]
                                 Head2:          [Q-WORD][Q-WORD][Q-WORD]

                                 2nd head starts at 40-3*8=16 or:
                                        0123456789012345678901234567890123456789
                                 Head1: [Q-WORD][Q-WORD][Q-WORD]
                                 Head2:                 [Q-WORD][Q-WORD][Q-WORD]

kl=41..48 Cycles= (kl-1)/16+1=3; MARGINAL CASES:
                                 2nd head starts at 41-3*8=17 or:
                                        01234567890123456789012345678901234567890
                                 Head1: [Q-WORD][Q-WORD][Q-WORD]
                                 Head2:                  [Q-WORD][Q-WORD][Q-WORD]

                                 2nd head starts at 48-3*8=24 or:
                                        012345678901234567890123456789012345678901234567
                                 Head1: [Q-WORD][Q-WORD][Q-WORD]
                                 Head2:                         [Q-WORD][Q-WORD][Q-WORD]
*/

/*
		FNV prime						FNV offset basis

32
Decimal		16777619						2166136261
Hexadecimal	0x01000193						0x811c9dc5

64
Decimal		1099511628211						14695981039346656037
Hexadecimal	0x00000100000001B3					0xcbf29ce484222325

128					
Decimal		309485009821345068724781371				144066263297769815596495629667062367629
Hexadecimal	0x0000000001000000000000000000013B			0x6c62272e07bb014262b821756295c58d
*/

int strcmpKAZE13 (
        const char * src,
        const char * dst
        )
{
        int ret = 0 ;

        while( (!(ret = *(unsigned char *)src - *(unsigned char *)dst)) && (*dst!=13-13) && (*src!=13-13))
                ++src, ++dst;

        if ( ret < 0 )
                ret = -1 ;
        else if ( ret > 0 )
                ret = 1 ;

        return( ret );
}

char FourGramL[LongestLineInclusive+1+8]; // 31bytes longest 4-gram + 1byte NULL + 4bytes COUNTER
char FourGramR[LongestLineInclusive+1+8]; // 31bytes longest 4-gram + 1byte NULL + 4bytes COUNTER
char LEAF[8+8+8+2*(LongestLineInclusive+1+8)]; // 136bytes = 3 pointers + 2 keys

char LEAFbackup[8+8+8+2*(LongestLineInclusive+1+8)]; // 2019-Dec-26

char LEAFNEW[8+8+8+2*(LongestLineInclusive+1+8)]; // 136bytes = 3 pointers + 2 keys
FILE *fp_outRG; // Global - not to burden the extract/compare function with one more parameter
char *GLOBAL_HASHPOT; //btree matchfinder needed, the hash table/pool
char* GLOBAL_SourceBlock; //btree matchfinder needed, the file in-memory itself
uint64_t GLOBAL_SourceSize; //btree matchfinder needed, the file in-memory itself
char *GLOBAL_CurrentPositionForReading_TAILforLookAhead; //btree matchfinder needed, updated on each position, step 1, that is
char *GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug = NULL; // Debug the ratio difference, 2019-Dec-17
unsigned char SHA328bytes[28];

#define MatchLensNUM 15
int MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48,56,128};
//                           0,1,2, 3, 4, 5, 6, 7, 8, 9, a, b, c, d,  e

char *GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[MatchLensNUM]; // 2020-Jan-25

uint64_t GLOBAL_Railgun_INVOCATIONS=0; // 2020-Jan-29
uint64_t GLOBAL_Railgun_INVOCATIONS_ARRAY[705]; // 2020-Jan-29
//uint64_t GLOBAL_Railgun_INVOCATIONS_004_3_bytes=0; // 2020-Jan-29
//uint64_t GLOBAL_Railgun_INVOCATIONS_004_2_bytes=0; // 2020-Jan-29
//uint64_t GLOBAL_Railgun_INVOCATIONS_004_1_bytes=0; // 2020-Jan-29

// OPTIMIZE THIS CRAP!!!
int CompareStringsEndingWith13_EXTERNAL(unsigned long long AtPosition64L, unsigned long long AtPosition64R) {

int i;
unsigned long long *AtPosition64Lpointer=&AtPosition64L;
unsigned long long *AtPosition64Rpointer=&AtPosition64R;

// Caramba: seek and tell report OK but in fact they lie, only setpos works?!?!?!

//#if defined(_WIN32_ENVIRONMENT_)
//_lseeki64( fileno(fp_outRG), AtPosition64L, 0 );
//#else
//fseeko( fp_outRG, AtPosition64L, SEEK_SET );
//#endif /* defined(_WIN32_ENVIRONMENT_)  */

//  _CRTIMP __int64 __cdecl _telli64(int);
//  off64_t ftello64 (FILE *stream)  

fsetpos(fp_outRG, (fpos_t *)AtPosition64Lpointer);
	for (i=0; i<(LongestLineInclusive+1+4); i++) {fread(&FourGramL[i], 1, 1, fp_outRG); if (FourGramL[i]==13-13) break;}
	//Commented line below is slower than the one above: 778156 clocks vs 756297 clocks.
	//fread(&FourGramL[0], 31+1, 1, fp_outRG);

fsetpos(fp_outRG, (fpos_t *)AtPosition64Rpointer);
	for (i=0; i<(LongestLineInclusive+1+4); i++) {fread(&FourGramR[i], 1, 1, fp_outRG); if (FourGramR[i]==13-13) break;}
	//Commented line below is slower than the one above: 778156 clocks vs 756297 clocks.
	//fread(&FourGramR[0], 31+1, 1, fp_outRG);

return(strcmpKAZE13(FourGramL, FourGramR));
}

// OPTIMIZE THIS CRAP!!!
int CompareStringsEndingWith13_INTERNAL(unsigned long long AtPosition64L, unsigned long long AtPosition64R, char *POOLinternal) {

int i;
//char FourGramL[LongestLineInclusive+2]; // 31 longest 4-gram + CR + LF
//char FourGramR[LongestLineInclusive+2]; // 31 longest 4-gram + CR + LF

for (i=0; i<(LongestLineInclusive+1+4); i++) {
	//fread(&FourGramL[i], 1, 1, fp_in);
	FourGramL[i] = *(char *)(POOLinternal + AtPosition64L);
	if (FourGramL[i]==13-13) break;
}

for (i=0; i<(LongestLineInclusive+1+4); i++) {
	//fread(&FourGramR[i], 1, 1, fp_in);
	FourGramR[i] = *(char *)(POOLinternal + AtPosition64R);
	if (FourGramR[i]==13-13) break;
}

return(strcmpKAZE13(FourGramL, FourGramR));
}


void B_tree_Non_Unique_Only_DEFRAGMENTED(int argc, char *argv[], char* SourceBlock, uint64_t SourceSize, char* VerifyBlock) {  // B_tree_Non_Unique_Only_DEFRAGMENTED[
      //int BSTorBtree = 0;
	int BSTorBtree_RAM = 3; //Internal // 2019-Dec-04
      FILE *fp_in, *fp_out, *fp_outLOG, *fp_inLINE;
      int Thunderwith;
// cleand unused below...
   int nlines;

      int LetterOffset;
      unsigned long long FilesLEN;
      unsigned long long WORDcount; 
      unsigned long long WORDcountBOTTOM; 
      unsigned long long WORDcountAttemptsToPut; 
      unsigned long long Total_fread=0, Total_fwrite=0; 

// 15fixfixfixfix [
        //unsigned long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfix
        unsigned long long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfixfix
// 15fixfixfixfix ]
        unsigned long long NumberOfLines;  // rev. 12+
      unsigned long WHOLEletter_BufferSize;
      unsigned long long WHOLEletter_BufferSize_L14;
        unsigned long memory_size, LetterBuffer, j, k, LINE10len, wrdlen;
        unsigned long k_FIX;
        unsigned long long i;              // rev. 12+
        //unsigned long size_in, size_out, size_inLINE;
        unsigned long size_in;           // rev. 12+
#if defined(_WIN32_ENVIRONMENT_)
      unsigned long long size_inLINESIXFOUR;
#else
      size_t size_inLINESIXFOUR;
#endif /* defined(_WIN32_ENVIRONMENT_)  */

      const int NumberOfSLOTs = 4096*2; // Since r.12+ in rev.12 it was 4096
  unsigned long StackPtr;
  unsigned long StackPtrDUMP; // 2019-Dec-26
  //unsigned long BSTstack [65536*3]; // BST in worst case could become a LL.
  unsigned long long BSTstack [8192*3]; // BST in worst case could become a LL.
  unsigned long long BSTstackDUMP [8192*3]; // BST in worst case could become a LL. // 2019-Dec-26
unsigned long NumberOfTrees=0, NumberOfHashCollisions=0;
unsigned long iBSTwithMAXpeak, jBSTwithMAXpeak;
  unsigned int PEAKibBST;
  unsigned long BSTsTotalLEAFs=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnode=0, BSTcurrentNode=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentNodeMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnodePEAK=1, BSTwithMAXnodeLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeak=0, BSTcurrentPeak=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAX=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeakNODE=1, BSTwithMAXpeakLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleaf=0, BSTcurrentLeaf=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentLeafMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleafNODE=1, BSTwithMAXleafPEAK=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!

      char *pointerflush, *pointerflushUNALIGN, *BufStart, *Flushing;
      char *pointerflush_64, *pointerflushUNALIGN_64; // r.14++
      char *pointerflush_64_RAM = VerifyBlock; // 2019-Dec-04
      char *pointerflush_64_RESTART; // 2019-Dec-07

      unsigned long PseudoLinkedPointer, PseudoLinkedPointerNEW, PseudoLinkedPointerROOT, PseudoLinkedPointerNEWold;
      unsigned long PseudoLinkedPointerNEWleft, PseudoLinkedPointerNEWright;
      unsigned long PseudoLinkedPointerNEWmiddle;
      char *bufend[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      long bufNumberOfWords[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      // long bufNoWpS[ 806 ][ 8192 ]; // ?! crashes below when an attempt to use it occur
      char wrd[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUP[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUPold[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char LINE10[257]; // 000..255, 256 = 0
      char ZEROS[4]; // 0..3, 0 = 0, 1 = 0, 2 = 0, 3 = 0
      char CRdLFa[2];  // 0..1, 0 = 13, 1 = 10
      unsigned char workbyte; // unsigned in order to index ASCII
      char workK[1024*128];
      long workKoffset = -1;
      unsigned long long FoundInLinkedList, Slot; //r.18
      unsigned long long FoundInLinkedList_RAM, Slot_RAM; // 2019-Dec-04
      unsigned long OffsetsInBuffer[31]; // 00..30
      unsigned long MAXusedBuffer[32]; // 00 not used, only 01..31
      unsigned long GRMBLhill[32]; // 00..31
      unsigned long GRMBLFoolAgain[32]; // 00..31
      int Melnitchka;
      unsigned long MAXusedBufferABS = 0;
      unsigned long Utiliza1 = 0;
      unsigned long Utiliza2 = 0;
      unsigned long TotalWLchars = 0;

// GCC 7.3.0 from MINGW complains, so commented them all:
/* minimum signed 64 bit value */
//#define _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
//#define _I64_MAX      9223372036854775807i64
/* maximum unsigned 64 bit value */
//#define _UI64_MAX     0xffffffffffffffffui64

/* minimum signed 128 bit value */
#define _I128_MIN   (-170141183460469231731687303715884105727i128 - 1)
/* maximum signed 128 bit value */
#define _I128_MAX     170141183460469231731687303715884105727i128
/* maximum unsigned 128 bit value */
#define _UI128_MAX    0xffffffffffffffffffffffffffffffffui128

      char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      // below duplicates are needed because of one_line_invoking need different buffers.
      char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      unsigned long HEADOffetFromStartBUKVA = 0;
      unsigned long TAILOffetFromStartBUKVA = 0;

      int SplitOccured;
      int POffsetInLEAF;
char *Auberge[4] = {"|\0","/\0","-\0","\\\0"};
int hashAlfalfa, iAlfalfa;
int PLE_words=0; // Quadruple!
char wrd1st[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd2nd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd3rd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd4th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd5th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd6th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd7th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd8th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd9th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd10th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char *DelimiterUnderscore = "_\0";
int PLE_words_INITflag = 0;

// QuickSortExternal_4+GB [
unsigned long long ThunderwithL64_L14;
unsigned long long Strnglen64_L14;
unsigned long long size_in64_L14, size_in2_L14;

//unsigned long long size_in64_L14_RAM = SourceSize; //2019-Dec-04
unsigned long long size_in64_L14_RAM = SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024; //2019-Dec-17, if the file is e.g. 67 bytes then this pool is not enough, no matter how many passes!

unsigned long long Over4billionLines, j_Over4billion;
char OneChar_ieByte = '\0';
char CR_ieByte = '\r';
char SomeByte;
unsigned long long BufEnd_64;
unsigned long long BufEnd_64_RAM; // 2019-Dec-04
unsigned long long BufEnd_64_RESTART; // 2019-Dec-04
unsigned long long SeekPosition;
unsigned long long *PointerToSeekPosition;
char FourGram[LongestLineInclusive+2]; // 31 longest 4-gram + CR + LF
char *PoolPhysical;
unsigned long long fsetpos_ZERO=0;
char OneCkusterZEROES[1024*4]; // Caution: must be ZEROed(NULLified)!
char *FileSwapTag = "LEPRECHAUNISH";
char EOFcode = 0x1A;
unsigned long long PseudoLinkedPointer_64, PseudoLinkedPointerNEW_64, PseudoLinkedPointerROOT_64, PseudoLinkedPointerNEWold_64;
      unsigned long long PseudoLinkedPointerNEWleft_64, PseudoLinkedPointerNEWright_64;
      unsigned long long PseudoLinkedPointerNEWmiddle_64;
      unsigned long long NULLs_64 = 0;
unsigned long long PseudoLinkedPointerAUX_64;
unsigned long long PseudoLinkedPointerAUXdumbo_64;

unsigned long long PseudoLinkedPointer_64DUMP; // 2019-Dec-26
unsigned long long PseudoLinkedPointerAUX_64DUMP; // 2019-Dec-26

      char wrdAUX[LongestLineInclusive+1+8];  // 0..30, 31 = 0
// QuickSortExternal_4+GB ]

//unsigned long CounterOccurrencies;
unsigned long long CounterOccurrencies; // 2019-Dec-04
unsigned long long NumberOfLEAFs=0;
unsigned long LevelsInCorona_Not_Counting_ROOT=0;
char *ngram[11] = {"NULLleton\0","singleton\0","doubleton\0","tripleton\0","quadrupleton\0","quintupleton\0","sextupleton\0","septupleton\0","octupleton\0","nonupleton\0","decupleton\0"};

unsigned long RipPasses;
unsigned long long NULLsForWRD=0;

int NewOrder;
      char LINE10_NO_DUMP[257]; // 000..255, 256 = 0

char *TwoDigitHEXlist[256] = {
"00\0",
"01\0",
"02\0",
"03\0",
"04\0",
"05\0",
"06\0",
"07\0",
"08\0",
"09\0",
"0A\0",
"0B\0",
"0C\0",
"0D\0",
"0E\0",
"0F\0",
"10\0",
"11\0",
"12\0",
"13\0",
"14\0",
"15\0",
"16\0",
"17\0",
"18\0",
"19\0",
"1A\0",
"1B\0",
"1C\0",
"1D\0",
"1E\0",
"1F\0",
"20\0",
"21\0",
"22\0",
"23\0",
"24\0",
"25\0",
"26\0",
"27\0",
"28\0",
"29\0",
"2A\0",
"2B\0",
"2C\0",
"2D\0",
"2E\0",
"2F\0",
"30\0",
"31\0",
"32\0",
"33\0",
"34\0",
"35\0",
"36\0",
"37\0",
"38\0",
"39\0",
"3A\0",
"3B\0",
"3C\0",
"3D\0",
"3E\0",
"3F\0",
"40\0",
"41\0",
"42\0",
"43\0",
"44\0",
"45\0",
"46\0",
"47\0",
"48\0",
"49\0",
"4A\0",
"4B\0",
"4C\0",
"4D\0",
"4E\0",
"4F\0",
"50\0",
"51\0",
"52\0",
"53\0",
"54\0",
"55\0",
"56\0",
"57\0",
"58\0",
"59\0",
"5A\0",
"5B\0",
"5C\0",
"5D\0",
"5E\0",
"5F\0",
"60\0",
"61\0",
"62\0",
"63\0",
"64\0",
"65\0",
"66\0",
"67\0",
"68\0",
"69\0",
"6A\0",
"6B\0",
"6C\0",
"6D\0",
"6E\0",
"6F\0",
"70\0",
"71\0",
"72\0",
"73\0",
"74\0",
"75\0",
"76\0",
"77\0",
"78\0",
"79\0",
"7A\0",
"7B\0",
"7C\0",
"7D\0",
"7E\0",
"7F\0",
"80\0",
"81\0",
"82\0",
"83\0",
"84\0",
"85\0",
"86\0",
"87\0",
"88\0",
"89\0",
"8A\0",
"8B\0",
"8C\0",
"8D\0",
"8E\0",
"8F\0",
"90\0",
"91\0",
"92\0",
"93\0",
"94\0",
"95\0",
"96\0",
"97\0",
"98\0",
"99\0",
"9A\0",
"9B\0",
"9C\0",
"9D\0",
"9E\0",
"9F\0",
"A0\0",
"A1\0",
"A2\0",
"A3\0",
"A4\0",
"A5\0",
"A6\0",
"A7\0",
"A8\0",
"A9\0",
"AA\0",
"AB\0",
"AC\0",
"AD\0",
"AE\0",
"AF\0",
"B0\0",
"B1\0",
"B2\0",
"B3\0",
"B4\0",
"B5\0",
"B6\0",
"B7\0",
"B8\0",
"B9\0",
"BA\0",
"BB\0",
"BC\0",
"BD\0",
"BE\0",
"BF\0",
"C0\0",
"C1\0",
"C2\0",
"C3\0",
"C4\0",
"C5\0",
"C6\0",
"C7\0",
"C8\0",
"C9\0",
"CA\0",
"CB\0",
"CC\0",
"CD\0",
"CE\0",
"CF\0",
"D0\0",
"D1\0",
"D2\0",
"D3\0",
"D4\0",
"D5\0",
"D6\0",
"D7\0",
"D8\0",
"D9\0",
"DA\0",
"DB\0",
"DC\0",
"DD\0",
"DE\0",
"DF\0",
"E0\0",
"E1\0",
"E2\0",
"E3\0",
"E4\0",
"E5\0",
"E6\0",
"E7\0",
"E8\0",
"E9\0",
"EA\0",
"EB\0",
"EC\0",
"ED\0",
"EE\0",
"EF\0",
"F0\0",
"F1\0",
"F2\0",
"F3\0",
"F4\0",
"F5\0",
"F6\0",
"F7\0",
"F8\0",
"F9\0",
"FA\0",
"FB\0",
"FC\0",
"FD\0",
"FE\0",
"FF\0"
};

/*
#if defined(InternalRAM) 
BSTorBtree = 3; //Internal
#endif
#if defined(ExternalRAM)
BSTorBtree = 2; //External
#endif
*/

uint64_t PointerToNotLoadedYet;
uint64_t jj,jjj, kk, BuildingBlocksSTRIDE;
int mm;
//#define MatchLensNUM 8
//int MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18};
uint64_t GettingIndexOfArray;
uint64_t NotFoundKeys=0, FoundKeys=0;
unsigned long long WORDcountBOTTOMPerMatchLen;
int strFLAG;
int KeySize;
uint64_t AllSlots;
unsigned long long BUGGYoffset; // fix for the bug in r.17 and prior, r.18

	FILE *fpratio;

Thunderwith=RAMpoolInKB_GLOBAL;
printf ("Leprechaun: Memory pool for B-trees is %s MB.\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits2, 10) );

if (BSTorBtree == 3)
{
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
} else if (BSTorBtree == 2){
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
}

// Below comment is due to adding auto-setting passes, 2019-Dec-07
/*
if (HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL==0)
printf ("Leprechaun: In this revision, %s pass is to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));
else
printf ("Leprechaun: In this revision, %s passes are to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));
*/

// 16fixfix [
PLE_words_INITflag = 0;
PLE_words = 0;
// 16fixfix ]
        Melnitchka = 0;
        WORDcount = 0; // Total word count i.e. for all files!
        WORDcountDistinct = 0;
        NumberOfFiles = 0;
        NumberOfLines = 0;
        FilesLEN = 0;
        LINE10len = 0;
// Added in r.14+++++FIXFIX [
	NumberOfTrees=0; NumberOfHashCollisions=0;
	NumberOfLEAFs=0;
	WORDcountAttemptsToPut=0;
	LevelsInCorona_Not_Counting_ROOT=0;
// Added in r.14+++++FIXFIX ]


	if ((fpratio = fopen("Nakamichi.ratio-graph.csv", "a")) == NULL) {
		printf("Nakamichi: Can't write '%s' file.\n", "Nakamichi.ratio-graph.csv"); exit(13);
	}

	fprintf( fpratio, "%s:\n", argv[1] );
	fclose(fpratio);

if( ( fp_outLOG = fopen( "Leprechaun.LOG", "a+" ) ) == NULL )
{ printf( "Leprechaun: Can't open file Leprechaun.LOG.\n" ); exit( 7 ); }

//	printf( "Leprechaun: Allocating HASH memory %s bytes ... ", _ui64toaKAZEcomma( ((1<<HashInBITS)*8) + 1 + 64 , llTOaDigits, 10) );
//	pointerflushUNALIGN = (char *)malloc( (1<<HashInBITS)*8 + 1 + 64 );

	printf( "Leprechaun: Allocating HASH memory %s bytes = 8*(%d+1)*2^(%d) ... ", _ui64toaKAZEcomma( (uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8 + 1 + 64 , llTOaDigits, 10), MatchLensNUM, HashInBITS_GLOBAL ); // +1 for the PASS #1 // 2019-Dec-04
	pointerflushUNALIGN = (char *)malloc( (uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8 + 1 + 64 ); // +1 for the PASS #1 // 2019-Dec-04

	if( pointerflushUNALIGN == NULL )
	{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
	pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64); // 13_6+
	//offset=64-int((long)data&63);
	printf( "OK\n");

	GLOBAL_HASHPOT = pointerflush; //btree matchfinder needed

//	memset(pointerflush,0,17210368*8);
	memset(pointerflush,0,(uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04
				if (BSTorBtree == 2) {
	if( ( fp_outRG = fopen( "Leprechaun_64bit.swp", "wb+" ) ) == NULL )
	{ printf( "Leprechaun: Can't create file 'Leprechaun_64bit.swp'.\n" ); exit( 7 ); }
// Tag for the swap file is: LEPRECHAUNISH{ASCIIcode26}
// or 14bytes, then when type of the swap is requested:
// D:\_KAZE_~1\LEPREC~1>type Leprechaun_64bit.swp
// LEPRECHAUNISH
// D:\_KAZE_~1\LEPREC~1>
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14;
BufEnd_64 = 0+14;
// The tag plays two roles, the second to avoid existence of SeekPosition equal to 0. The 0 cannot be used as a free slot FLAG without the TAG.
	printf( "Leprechaun: Allocating/ZEROing %s bytes swap file ... ", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
	memset(OneCkusterZEROES,0,1024*4);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14/(1024*4); ThunderwithL64_L14++)
        	fwrite(OneCkusterZEROES, 1024*4, 1, fp_outRG);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14%(1024*4); ThunderwithL64_L14++)
        	fwrite(&OneChar_ieByte, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
        	fwrite(FileSwapTag, 13, 1, fp_outRG);
        	fwrite(&EOFcode, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
				} else { // ########## 64bit memory manipulations [
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14 + 1 + 64;
printf( "Leprechaun: Allocating memory for B-trees %lu MB ... ", (size_in64_L14>>20)+1 );
pointerflushUNALIGN_64 = (char *)malloc( size_in64_L14 );
	memset(pointerflushUNALIGN_64,0,size_in64_L14);
if( pointerflushUNALIGN_64 == NULL )
{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
pointerflush_64 = pointerflushUNALIGN_64 + 64 - (((size_t)pointerflushUNALIGN_64) % 64); // 13_6+
//offset=64-int((long)data&63);
	//memset(pointerflush_64,0,1024 * (unsigned long long)Thunderwith + 14);
BufEnd_64 = (unsigned long long)pointerflush_64;
/*
printf( "BufEnd_64: %s\n", _ui64toaKAZEcomma(BufEnd_64, llTOaDigits, 10) );
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
pointerflush_64 = (char *)BufEnd_64;
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
exit (1);
	//BufEnd_64: 541,261,888
	//pointerflush_64: 541,261,888
	//pointerflush_64: 541,261,888
*/
				} // ########## 64bit memory manipulations ]
	printf( "OK\n");
	fprintf( fp_outLOG, "Leprechaun report:\n" );

// Comment the streamed-read of input file ... [[[
/*
if( ( fp_inLINE = fopen( argv[1], "rb" ) ) == NULL )
{ printf( "Leprechaun: Can't open file %s \n", argv[1] ); exit( 7 ); }

//fseek( fp_inLINE, 0L, SEEK_END );  //Rev. 12
//size_inLINE = ftell( fp_inLINE );  //Rev. 12
//fseek( fp_inLINE, 0L, SEEK_SET );  //Rev. 12

#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp_inLINE), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp_inLINE) );
_lseeki64( fileno(fp_inLINE), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp_inLINE, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp_inLINE );
fseeko( fp_inLINE, 0L, SEEK_SET );
#endif // defined(_WIN32_ENVIRONMENT_)

printf( "Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	wrdlen = 0;
        for( i = 0; i < size_inLINESIXFOUR; i++ )
	{

                // ~~~~~~~~~~~~ Buffering fread [
                if (workKoffset == -1) {
                        if (i + 1024*128 < size_inLINESIXFOUR) {
                                fread( &workK[0], 1, 1024*128, fp_inLINE );
                                workKoffset = 0;
                                workbyte = workK[workKoffset];
                        } else {
                        fread( &workbyte, 1, 1, fp_inLINE );
			//printf("%d,'%d' %s\n",i, workbyte,TwoDigitHEXlist[workbyte]); //So stupid code of mine, the remaining (mod 128*1024) has to be read byte by byte as NULL, grmbl!
			}

                } else {
                        workKoffset++;
                        workbyte = workK[workKoffset];
                        if (workKoffset == 1024*128 - 1) workKoffset = -1;
                }
                // ~~~~~~~~~~~~ Buffering fread ]

//                if( isalpha( workbyte ) )
//                {
//                        if( wrdlen < 31 )
//                        { wrd[ wrdlen ] = tolower( workbyte ); }
//                        wrdlen++;
//                }
	//			  memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[workbyte], 2 );
	//                        wrdlen++;
	//                        wrdlen++;
        } // i 'for'
        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
// Comment the streamed-read of input file ... ]]]
size_inLINESIXFOUR=SourceSize;
printf( "Leprechaun: Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );
printf( "\n");

		time1=time(NULL); //fix of bigtime

HashChunkSizeInBITS_GLOBAL = HashInBITS_GLOBAL; // 2019-Dec-07

#ifdef _NSHA3
	printf( "Leprechaun: Using SHA3-224 for Matches 28[+] long, in order to reduce memory footprint.\n" ); // 2020-Feb-02
#endif


for (jj=0; jj< MatchLensNUM; jj++) {

BufEnd_64_RESTART = BufEnd_64; // 2019-Dec-07
pointerflush_64_RESTART = pointerflush_64; // 2019-Dec-07

NewAttemptRaisePasses: // 2019-Dec-07

BufEnd_64 = BufEnd_64_RESTART; // 2019-Dec-07
pointerflush_64 = pointerflush_64_RESTART; // 2019-Dec-07
memset(pointerflush + (uint64_t)(jj)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8,0, (uint64_t)(1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04

				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]

//for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )
//{
RipPasses = 1-1;
WhyTheHellForIsNotWorking:

if (RipPasses < (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1)
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %s ... \r", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-7), _ui64toaKAZEzerocomma((1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10)+(26-7) );
else
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %s ... ", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-7), _ui64toaKAZEzerocomma((1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10)+(26-7) );

// In-here the new lowering MEMORY FOOTPRINT improvement begins:
// It is from two passes:
// - the first builds B-trees by putting all keys (unique and non-unique) into leaves;
// - the second builds B-trees by putting ONLY non-unique keys into leaves;
// Each pass has its own two POOLs:
// Pass #1: HASH POOL size:     ((1LL)<<HashInBITS_GLOBAL)*8 
// Pass #1: HASH POOL address:  pointerflush       //BufStart + Slot +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8) // MatchLensNUM=10
// Pass #1: Btree POOL size:    size_in64_L14_RAM = SourceSize
// Pass #1: Btree POOL address: pointerflush_64_RAM = VerifyBlock

// Pass #2: HASH POOL size:     MatchLensNUM*((1LL)<<HashInBITS_GLOBAL)*8 
// Pass #2: HASH POOL address:  pointerflush       //BufStart + Slot +(jj*(1LL<<HashInBITS_GLOBAL)*8) // jj=0..9
// Pass #2: Btree POOL size:    size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14
// Pass #2: Btree POOL address: pointerflush_64

// Variable-Differences between two passes:
// Pass #1: Slot_RAM, BufEnd_64_RAM, size_in64_L14_RAM, pointerflush_64_RAM, BSTorBtree_RAM enforced to be 3 i.e. RAM; Pass #1 has 'counter' uncommented!
// Pass #2: Slot,     BufEnd_64,     size_in64_L14,     pointerflush_64,     BSTorBtree
// 'FoundInLinkedList_RAM' decides whether to execute B-tree fragment AT ALL in PASS #2! If the key's occurrences are 1+ then FoundInLinkedList_RAM = 1

// The ASCII block-scheme of major mumbo-jumbo:

// 2019-Dec-28
/*
https://software.intel.com/en-us/forums/intel-moderncode-for-parallel-architectures/topic/520602#comment-1950202
https://community.centminmod.com/threads/a-lzss-microdeduplicator-tagetting-huge-texts-with-c-source.16427/#post-80053

Gladden I am to share the most refined revision of my texttoy.

Nakamichi already entered Dr. Mahoney's LTCB (Large Text Compression Benchmark) roster as Pareto frontier setter i.e. no other (open-source) decompressor is faster with this compression ratio.
http://mattmahoney.net/dc/text.html#2774

Big news! Now, the matchfinder is able to find a match with ONE only random (external) access, one random fetch done within a hashtable (based on physical RAM), and one random fetch done within a B-tree (based on physical/external RAM).

The revision achieving above results is from 2019-Aug-06, today gladly I share the latest much superior revision featuring:
- Needs 3N physical RAM (+ adjustable physical RAM for HASH pools), where N is the size of file being compressed;
- Automatic setting of PASSES (allows to fit building B-trees into RAM (the third N used to house output file) and just then to rebuild the current PASS either on RAM or SSD) - it lowers drastically the wearing of external RAM;
- Significantly Lowered Memory Footprint - now, only the NON-UNIQUE keys are put into B-trees;
- All B-trees are DEFRAGMENTED i.e. all their leaves are concatenated i.e. each B-tree is housed in one SOLID block - thus PREFETCH-FRIENDLY they became.

The beauty of the Nakamichi C source comes from it being a practical etude/benchmark of superfast implementations of:
- FASTEST known to me memmem(), namely the function char * Railgun_Trolldom(char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern);
- FASTEST known to me LOOKUP hasher, namely the uint32_t FNV1A_Pippip_Yurii(const char *str, size_t wrdlen);
- FASTEST known to me B-tree, namely the void B_tree_Non_Unique_Only_DEFRAGMENTED(int argc, char *argv[], char* SourceBlock, uint64_t SourceSize, char* VerifyBlock), it is capable transparently to work with internal/external RAM.

The "normal" case (which is advocated even in Prof. Knuth's bible) is to use a LEAF with many many keys - to avoid TAPE/HDD revolvements/repositions.
Footprintwise, I always considered this advice out of fashion/style, even today's NAND and Xpoint SSDs cannot deliver magical speeds unless the B-tree is both compact (my order 3 is more size effective) and prefetch-friendly.
My two benchmarking laptops are now busy, but in the next year will share how in practice this revision works with some big corpora as:
- SILVA DNA corpus ~1.1 GB strong;
- Human Genome DNA corpus ~3.3 GB strong.

On 'SILVA' Nakamichi sets Pareto, but actually Skibinski's LIZARD is better:
https://community.centminmod.com/threads/a-lzss-microdeduplicator-tagetting-huge-texts-with-c-source.16427/#post-80053

The needed memory for latter is 20N i.e. 66GB, the FRAGMENTED revision is already on the 4th percent, after finishing will run the DEFRAGMENTED one...

```
Parsing all the BBs (Building-Blocks) of length 4,6,8,10,12,14,16,18,36,64 at each position:

PASS #1 – TEMPORARY STUFF:
One POOL based/located always on physical (internal RAM) – the last/hidden one of all HASH SUB-POOLS:
-----------------------------------------------------------------------                   
| Hash BLOCK (TEMPORARY HASH Sub-Pool), size = command line parameter |---------------------------------------------------------------------------------------------\
-----------------------------------------------------------------------                                                                                             |
 |                                                                                                                                                                  |
 | All slots point to B-tree roots in the TEMPORARY B-tree POOL                                                                                                     |
 \--------------------------------------------------------------\                                                                                                   |
                                                                |                                                                                                   |
Three POOLs based/located always on physical (internal RAM):   \ /                                                                                                  |
-------------------------- ----------------------------------- ---------------------------------------------------------                                            |
| Source Block, size = N | | Source REVERSED Block, size = N | | Target Block, size = N, or, B-trees BLOCK (TEMPORARY) |                                            |
-------------------------- ----------------------------------- ---------------------------------------------------------                                            |
                                                                                                                                                                    |
PASS #2 – TEMPORARY-TO-NONTEMPORARY STUFF (takes into account what above two temporary blocks house):                                                               |
-------------------------------------------------                                                                                                                   |
| Source Pool: Houses the file being compressed |                                                                                                                   |
-------------------------------------------------                                                                                                                   |
 |\--------------------------------------------------------------------------------------------------------------------------\                                      |
 | |                                                                                                                         |Hash 64 bytes                         |
 | |Hash 6 bytes                                                                                                             |                                      |
 | \--------------------------------------------------------\                                                                |                                      |
 |                                                          |                                                                |                                      |
 |Hash 4 bytes                                              |                                                                |                                      |
 \                                                          |                                                                |                                      |
 \/                                                        \ /                                                              \ /                                    \ /
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
| Hash Sub-Pool for BBs 4 bytes long                       | Hash Sub-Pool for BBs 6 bytes long                       | ... | Hash Sub-Pool for BBs 64 bytes long | TEMPORARY HASH Sub-Pool |
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
| Slot # 0         | ... | Slot # (1<<HashInBITS_GLOBAL)-1 | Slot # 0         | ... | Slot # (1<<HashInBITS_GLOBAL)-1 |     |                                     |                         |
| Address 8 bytes  | ... | Address 8 bytes                 | Address 8 bytes  | ... | Address 8 bytes                 |     |                                     |                         |
| to a B-tree root | ... | to a B-tree root                | to a B-tree root | ... | to a B-tree root                |     |                                     |                         |
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
 |                                                                             |
 |                                                                             \---------------------------------------------------------\
 \----------------------------------------------\ LEAF #1 is on level 0                                                                  |
                                                |                                                                                        |
                                                |         /----------------------------------------------\ LEAF #5 is on level 2         |
                                               \ /        |                                              \/                             \ /
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- ! Located either on
| Btree Pool: Houses the leaves of all B-trees | ROOT #1 | LEAF #2                  | LEAF #3 | LEAF #4 | LEAF #5 | ... some leaves ... | ROOT #2 | ... some leaves/roots ... | ! Internal or
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- ! External RAM
                                                |||       /\                         / \       / \
                                                ||\-------/ LEAF #2 is on level 1     |         |
                                                |\------------------------------------/         |
                                                \-----------------------------------------------/

B-tree order 3 (MAX 3 pointers, MAX 2 keys) LEAF #1 (ROOT is also a LEAF – if no successors) structure:
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
| LeftPointer,    | MiddlePointer,  | RightPointer,   | DynamicLeftKey (LeftKeySize + LeftKey       + LeftQWORD)| DynamicRightKey (RightKeySize + RightKey       + RightQWORD) | ! LEVEL 0
| Address 8 bytes | Address 8 bytes | Address 8 bytes |                 1 byte      + 1..255 bytes  + 8 bytes   |                  1 byte       + 1..255 bytes   + 8 bytes     |
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 |                  |                 |
 |                  |                 \--------------------------------------------------------------------\
 |                  |                                                                                      |
 |                  \-----------------------------\                                                        |
\ /                                               \/                                                      \ /
-----------------------------------------------  -------------------------------------------------------  -----------------------------------------------
| LEAF #2 (housing keys smaller than LeftKey) |  | LEAF #3 (housing keys between LeftKey and RightKey) |  | LEAF #4 (housing keys bigger than RightKey) | ! LEVEL 1
-----------------------------------------------  -------------------------------------------------------  -----------------------------------------------

Note1: Hash Pool: Houses (10+1) consecutive Sub-Pools, the 11th (the last one actually) is used in PASS #1 only (as temporary, its slots point to physical RAM only addresses located in TargetBlock of size N=SourceSize).
Note2: Usually 'LeftQWORD' and 'RightQWORD' are used either for OCCURRENCES or LastSeenOffest of that key.
Note3: If 'LeftKeySize' or 'RightKeySize' is 0 then the field is not used - there is no KEY.
```

In the near future I intend to reduce more memmem() invocations which are the main culprit for speed drops, it is a matter of few hours to write it down, and ... more SSD memory.
*/

// PASS #1: [

	// INITIALIZE: 
	// Below line is zeroing the LAST HASH SUB-POOL for RAM RIP:
	memset(pointerflush + (uint64_t)(MatchLensNUM)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8,0, (uint64_t)(1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04
	// Below line is resetting Btree POOL for RAM RIP:
	BufEnd_64_RAM = (unsigned long long)pointerflush_64_RAM;
	memset(pointerflush_64_RAM,0, size_in64_L14_RAM); // Probably no need, have to check whether it is necessary... YES, if commented then it crashes!? Maybe all the B-tree building/init causes the worse ratio compared to older versions?!

	for (BuildingBlocksSTRIDE=0; (signed long long)BuildingBlocksSTRIDE < (signed long long)size_inLINESIXFOUR-MatchLens[jj]+1; BuildingBlocksSTRIDE++) { // 2020-Jan-01

		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(SourceBlock+mm+BuildingBlocksSTRIDE)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];
		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.

#ifdef _NSHA3
		if (wrdlen >= 28) {
			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
			wrdlen=28;
		}
#endif
		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
#ifdef _NSHA3
		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen );
		else
			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#else
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#endif


	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28

// Bug fix for all r.14+++ and below! [
//memcpy( &wrd[(LongestLineInclusive+1+4)-4], &NULLsForWRD, 4 );
//memcpy( &wrd[(LongestLineInclusive+1+4)-4-1], &NULLsForWRD, 1 );
// Bug fix for all r.14+++ and below! ]

// Example: HashInBITS-HashChunkSizeInBITS=2
//          HashInBITS = 5
//          HashChunkSizeInBITS = 3
//          RipPasses = 1<<(HashInBITS-HashChunkSizeInBITS) i.e. 1<<2 which is 4 i.e. 32 slots with 4 passes 8 slots each.
//          00??? 5bits 0-7
//          01??? 5bits 8-15
//          10??? 5bits 16-23
//          11??? 5bits 24-31
if ( (Slot>>HashChunkSizeInBITS_GLOBAL) == RipPasses ) {
	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
	// The line above uses the upper/last part of HASH POOL i.e. for MatchLensNUM=10 11th i.e. 0..9 for pass #2, 10 for pass #1
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64_RAM in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64_RAM, 8 );
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64_RAM);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64_RAM, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64_RAM, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64_RAM);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			if (CounterOccurrencies==0) CounterOccurrencies++;         	// Fixing an old bug, counting starts from 0 since this is 'search' not 'insert' - it was already inserted i.e. with 1 occurrence but the field is ZERO when put initially. Fix: 2019-Dec-19
			if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &CounterOccurrencies, 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #1: BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			if (CounterOccurrencies==0) CounterOccurrencies++;         	// Fixing an old bug, counting starts from 0 since this is 'search' not 'insert' - it was already inserted i.e. with 1 occurrence but the field is ZERO when put initially. Fix: 2019-Dec-19
			if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &CounterOccurrencies, 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #1: BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree_RAM == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree_RAM == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 fragment 64bit ]

} //if ( (Slot>>HashChunkSizeInBITS) == RipPasses ) {
	} //for (BuildingBlocksSTRIDE=0; 

// PASS #1: ]

// PASS #2: [

	//KeySize = MatchLens[jj]; // UNNECESSARY for non-SHA3, and buggy for SHA3 - it should be 'wrdlen', // 2020-Feb-02
	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 

		Slot_RAM = (jjj<<3) +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8); // Check out all slots of TEMPORARY
		memcpy( &PseudoLinkedPointer_64DUMP, BufStart+Slot_RAM, 8 );

                      if (PseudoLinkedPointer_64DUMP != 0)
                      {

// CAUTION: Did forget that dumping/traversing the B-trees - DESTROYS them! On purpose, pointers are zeroed.
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit [
     // DONE JOB:
     // Must be written B-tree traverse ! with simulated stack i.e. non-recursive.
     // ...
  StackPtrDUMP = 0;
  while ( 2==2 ) {
        while (PseudoLinkedPointer_64DUMP != 0)
              { 
                if (StackPtrDUMP > 8192*3-1) { printf( "\nLeprechaun: Failure! B-tree simulated stack overflow, too high B-tree!\n" ); exit( 13 );}
                BSTstackDUMP[StackPtrDUMP] = PseudoLinkedPointer_64DUMP; ++StackPtrDUMP; //ptr to Rwrd
//if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) == 0 ) {memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );}
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64DUMP, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		if (SomeByte == 0 ) // RW exists not
		 {
		  PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8;
				if (BSTorBtree_RAM == 2) {
		  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		  fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64DUMP, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8], &NULLs_64, 8 );
			// ]  //r.14+
		 }
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
// Give first from right to left non-zero PTR
                if (PseudoLinkedPointerNEWright_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWright;
//                }
                {
		PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8;
				if (BSTorBtree_RAM == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64DUMP, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64DUMP = PseudoLinkedPointerNEWright_64;
                }
                else if (PseudoLinkedPointerNEWmiddle_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWmiddle;
//                }
                {
		PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8;
				if (BSTorBtree_RAM == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64DUMP, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64DUMP = PseudoLinkedPointerNEWmiddle_64;
                }
                else if (PseudoLinkedPointerNEWleft_64 !=0 )
//                { memcpy( PseudoLinkedPointer, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWleft;
//                }
                {
		PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP;
				if (BSTorBtree_RAM == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64DUMP, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64DUMP = PseudoLinkedPointerNEWleft_64;
                }
                else
                {
                  PseudoLinkedPointer_64DUMP = 0;
                }
              }
	    if (LevelsInCorona_Not_Counting_ROOT < StackPtrDUMP) LevelsInCorona_Not_Counting_ROOT = StackPtrDUMP; //r.14
        if (StackPtrDUMP == 0) break;
        PseudoLinkedPointer_64DUMP = BSTstackDUMP[--StackPtrDUMP];
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64DUMP, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
        if (PseudoLinkedPointerNEWleft_64 + PseudoLinkedPointerNEWmiddle_64 + PseudoLinkedPointerNEWright_64 == 0) // One LEAF is PRINTED when LP=0 MP=0 RP=0
           { 
//        memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4, i%31+1 );
//        fwrite(wrd, i%31+1, 1, fp_out);
//        fwrite(CRdLFa, 2, 1, fp_out); 
//        if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) != 0 )
//             { memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4 + i%31+1, i%31+1 );
//               fwrite(wrd, i%31+1, 1, fp_out);
//               fwrite(CRdLFa, 2, 1, fp_out); 
//             }
//        PseudoLinkedPointer = 0;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8 + 8;
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		//fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			memcpy( &CounterOccurrencies, &wrd[(KeySize+1+8)-8], 8 ); // 2019-Dec-26
			FoundInLinkedList_RAM = 0; // Assume not found // 2019-Dec-26
			if (CounterOccurrencies>1) FoundInLinkedList_RAM = 1; // 2019-Dec-26

// Have to back up the LEAF since it is changed in 1of2 and 2of2 sections:
			memcpy( &LEAFbackup[0], &LEAF[0], 8+8+8+2*(KeySize+1+8) );

// Building nonunique 1 of 2 [
#ifdef _NSHA3
		memcpy( &wrdlen, &wrd[ 0 ], 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224). // 2020-Feb-02
#else
		wrdlen=MatchLens[jj];
#endif
		//memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented. // 2019-Dec-26

//		if (wrdlen > 28) {
//			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
//			wrdlen=28;
//		}

		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
//if (memcmp( &wrd[ 0 ], &wrdlen, 1 )) printf ("\nwrd != wrdlen\n");

//		if (wrdlen < 28)
			//memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen ); // 2019-Dec-26
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );

	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28
	Slot = Slot<<3;
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

	if (FoundInLinkedList_RAM == 1) { // 2019-Dec-04
// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64 in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64, 8 );
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 fragment 64bit ]
	} // if (FoundInLinkedList_RAM == 1) { // 2019-Dec-04

// Building nonunique 1 of 2 ]
			// Counter ]

// Have to restore the LEAF since it is changed in 1of2 and 2of2 sections:
			//memcpy( &LEAFbackup[0], &LEAF[0], 8+8+8+2*(KeySize+1+8) );
			memcpy( &LEAF[0], &LEAFbackup[0], 8+8+8+2*(KeySize+1+8) );

                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//	        fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                WORDcountBOTTOM++;
//	        fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	//fwrite(CRdLFa, 2, 1, fp_out); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		 //fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		 if (SomeByte != 0 ) // RW exists
		 {
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64DUMP = PseudoLinkedPointer_64DUMP + 8 + 8 + 8 + (LongestLineInclusive+1+4);
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64DUMP);
		 //fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			memcpy( &CounterOccurrencies, &wrd[(KeySize+1+8)-8], 8 ); // 2019-Dec-26
			FoundInLinkedList_RAM = 0; // Assume not found // 2019-Dec-26
			if (CounterOccurrencies>1) FoundInLinkedList_RAM = 1; // 2019-Dec-26
// Building nonunique 2 of 2 [
#ifdef _NSHA3
		memcpy( &wrdlen, &wrd[ 0 ], 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224). // 2020-Feb-02
#else
		wrdlen=MatchLens[jj];
#endif
		//memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented. // 2019-Dec-26

//		if (wrdlen > 28) {
//			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
//			wrdlen=28;
//		}

		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
//if (memcmp( &wrd[ 0 ], &wrdlen, 1 )) printf ("\nwrd != wrdlen\n");

//		if (wrdlen < 28)
			//memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen ); // 2019-Dec-26
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );

	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28
	Slot = Slot<<3;
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

	if (FoundInLinkedList_RAM == 1) { // 2019-Dec-04
// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64 in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64, 8 );
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 fragment 64bit ]
	} // if (FoundInLinkedList_RAM == 1) { // 2019-Dec-04
	
// Building nonunique 2 of 2 ]
			// Counter ]
                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//   	         fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                 WORDcountBOTTOM++;
//   	         fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	 //fwrite(CRdLFa, 2, 1, fp_out); 
		 }
		  PseudoLinkedPointer_64DUMP = 0;
	    NumberOfLEAFs++; //r.14
           }
  }                                          
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit ]

                      } //if (PseudoLinkedPointer_64 != 0)

	} // for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18

// PASS #2: ]

 RipPasses++;
 if (RipPasses <= (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1) goto WhyTheHellForIsNotWorking;
//} // for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )

// Counting trees [
NumberOfTrees=0;
AllSlots=0;

	for( j = 0; j < MatchLensNUM; j++ ) //r.18
	{
	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 
                      Slot = (AllSlots)<<3; AllSlots++;
                      memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );
                      if (PseudoLinkedPointer_64 != 0) NumberOfTrees++;
	}
	}
// Counting trees ]

	printf( "DONE; %s B-trees have been rooted so far.\n", _ui64toaKAZEzerocomma(NumberOfTrees, llTOaDigits, 10)+(26-14));
} //for (jj=0; 
	printf( "\n");

goto SkipDestroyingTheTrees;
//...
SkipDestroyingTheTrees:
	printf( "Leprechaun: Total Searches-n-Inserts Per Second: %s SNIPS = %s keys in %s seconds\n", _ui64toaKAZEcomma((double)(WORDcount)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10), _ui64toaKAZEcomma(WORDcount, llTOaDigits4, 10), _ui64toaKAZEcomma(time(NULL) - time1 + 1, llTOaDigits5, 10));
	printf( "Leprechaun: RAM needed to house B-trees (relative to the file being ripped): %sN = %sMB\n", _ui64toaKAZEcomma((BufEnd_64-(unsigned long long)pointerflush_64+1)/size_inLINESIXFOUR, llTOaDigits3, 10), _ui64toaKAZEcomma(1+((BufEnd_64-(unsigned long long)pointerflush_64+1)>>20), llTOaDigits2, 10));
	printf( "Leprechaun: RAM needed to build B-trees IN ONE PASS: (Target-Buffer = %s MB) x %s passes = %sMB\n", _ui64toaKAZEcomma((SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024)>>20, llTOaDigits2, 10), _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits3, 10), _ui64toaKAZEcomma( ((SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024)>>20) * (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10) );
	printf( "Note: In case of RAM in spades then may use compile option: -DSpeedUpBuilding=%s\n", _ui64toaKAZE( ((SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024)>>20) * (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10) );

//#if defined(ExternalRAM)
if (BSTorBtree == 2) {
	printf( "Leprechaun: Total IOPS for %s 'freads' and %s 'fwrites' (of packets %d bytes long) during loading traversing all orders: %s IOPS\n", _ui64toaKAZEcomma(Total_fread, llTOaDigits, 10), _ui64toaKAZEcomma(Total_fwrite, llTOaDigits2, 10), 8+8+8+2*(LongestLineInclusive+1+8), _ui64toaKAZEcomma((double)(Total_fwrite+Total_fread)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10));
}
//#endif
	printf( "\n");

//exit(0);

} // B_tree_Non_Unique_Only_DEFRAGMENTED]


void B_tree_Non_Unique_Only(int argc, char *argv[], char* SourceBlock, uint64_t SourceSize, char* VerifyBlock) {  // B_tree_Non_Unique_Only[
      //int BSTorBtree = 0;
	int BSTorBtree_RAM = 3; //Internal // 2019-Dec-04
      FILE *fp_in, *fp_out, *fp_outLOG, *fp_inLINE;
      int Thunderwith;
// cleand unused below...
   int nlines;

      int LetterOffset;
      unsigned long long FilesLEN;
      unsigned long long WORDcount; 
      unsigned long long WORDcountBOTTOM; 
      unsigned long long WORDcountAttemptsToPut; 
      unsigned long long Total_fread=0, Total_fwrite=0; 

// 15fixfixfixfix [
        //unsigned long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfix
        unsigned long long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfixfix
// 15fixfixfixfix ]
        unsigned long long NumberOfLines;  // rev. 12+
      unsigned long WHOLEletter_BufferSize;
      unsigned long long WHOLEletter_BufferSize_L14;
        unsigned long memory_size, LetterBuffer, j, k, LINE10len, wrdlen;
        unsigned long k_FIX;
        unsigned long long i;              // rev. 12+
        //unsigned long size_in, size_out, size_inLINE;
        unsigned long size_in;           // rev. 12+
#if defined(_WIN32_ENVIRONMENT_)
      unsigned long long size_inLINESIXFOUR;
#else
      size_t size_inLINESIXFOUR;
#endif /* defined(_WIN32_ENVIRONMENT_)  */

      const int NumberOfSLOTs = 4096*2; // Since r.12+ in rev.12 it was 4096
  unsigned long StackPtr;
  //unsigned long BSTstack [65536*3]; // BST in worst case could become a LL.
  unsigned long long BSTstack [8192*3]; // BST in worst case could become a LL.
unsigned long NumberOfTrees=0, NumberOfHashCollisions=0;
unsigned long iBSTwithMAXpeak, jBSTwithMAXpeak;
  unsigned int PEAKibBST;
  unsigned long BSTsTotalLEAFs=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnode=0, BSTcurrentNode=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentNodeMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnodePEAK=1, BSTwithMAXnodeLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeak=0, BSTcurrentPeak=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAX=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeakNODE=1, BSTwithMAXpeakLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleaf=0, BSTcurrentLeaf=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentLeafMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleafNODE=1, BSTwithMAXleafPEAK=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!

      char *pointerflush, *pointerflushUNALIGN, *BufStart, *Flushing;
      char *pointerflush_64, *pointerflushUNALIGN_64; // r.14++
      char *pointerflush_64_RAM = VerifyBlock; // 2019-Dec-04
      char *pointerflush_64_RESTART; // 2019-Dec-07

      unsigned long PseudoLinkedPointer, PseudoLinkedPointerNEW, PseudoLinkedPointerROOT, PseudoLinkedPointerNEWold;
      unsigned long PseudoLinkedPointerNEWleft, PseudoLinkedPointerNEWright;
      unsigned long PseudoLinkedPointerNEWmiddle;
      char *bufend[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      long bufNumberOfWords[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      // long bufNoWpS[ 806 ][ 8192 ]; // ?! crashes below when an attempt to use it occur
      char wrd[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUP[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUPold[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char LINE10[257]; // 000..255, 256 = 0
      char ZEROS[4]; // 0..3, 0 = 0, 1 = 0, 2 = 0, 3 = 0
      char CRdLFa[2];  // 0..1, 0 = 13, 1 = 10
      unsigned char workbyte; // unsigned in order to index ASCII
      char workK[1024*128];
      long workKoffset = -1;
      unsigned long long FoundInLinkedList, Slot; //r.18
      unsigned long long FoundInLinkedList_RAM, Slot_RAM; // 2019-Dec-04
      unsigned long OffsetsInBuffer[31]; // 00..30
      unsigned long MAXusedBuffer[32]; // 00 not used, only 01..31
      unsigned long GRMBLhill[32]; // 00..31
      unsigned long GRMBLFoolAgain[32]; // 00..31
      int Melnitchka;
      unsigned long MAXusedBufferABS = 0;
      unsigned long Utiliza1 = 0;
      unsigned long Utiliza2 = 0;
      unsigned long TotalWLchars = 0;

// GCC 7.3.0 from MINGW complains, so commented them all:
/* minimum signed 64 bit value */
//#define _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
//#define _I64_MAX      9223372036854775807i64
/* maximum unsigned 64 bit value */
//#define _UI64_MAX     0xffffffffffffffffui64

/* minimum signed 128 bit value */
#define _I128_MIN   (-170141183460469231731687303715884105727i128 - 1)
/* maximum signed 128 bit value */
#define _I128_MAX     170141183460469231731687303715884105727i128
/* maximum unsigned 128 bit value */
#define _UI128_MAX    0xffffffffffffffffffffffffffffffffui128

      char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      // below duplicates are needed because of one_line_invoking need different buffers.
      char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      unsigned long HEADOffetFromStartBUKVA = 0;
      unsigned long TAILOffetFromStartBUKVA = 0;

      int SplitOccured;
      int POffsetInLEAF;
char *Auberge[4] = {"|\0","/\0","-\0","\\\0"};
int hashAlfalfa, iAlfalfa;
int PLE_words=0; // Quadruple!
char wrd1st[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd2nd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd3rd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd4th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd5th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd6th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd7th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd8th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd9th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd10th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char *DelimiterUnderscore = "_\0";
int PLE_words_INITflag = 0;

// QuickSortExternal_4+GB [
unsigned long long ThunderwithL64_L14;
unsigned long long Strnglen64_L14;
unsigned long long size_in64_L14, size_in2_L14;

//unsigned long long size_in64_L14_RAM = SourceSize; //2019-Dec-04
unsigned long long size_in64_L14_RAM = SourceSize+512+32*1024*1024; //2019-Dec-17, if the file is e.g. 67 bytes then this pool is not enough, no matter how many passes!

unsigned long long Over4billionLines, j_Over4billion;
char OneChar_ieByte = '\0';
char CR_ieByte = '\r';
char SomeByte;
unsigned long long BufEnd_64;
unsigned long long BufEnd_64_RAM; // 2019-Dec-04
unsigned long long BufEnd_64_RESTART; // 2019-Dec-04
unsigned long long SeekPosition;
unsigned long long *PointerToSeekPosition;
char FourGram[LongestLineInclusive+2]; // 31 longest 4-gram + CR + LF
char *PoolPhysical;
unsigned long long fsetpos_ZERO=0;
char OneCkusterZEROES[1024*4]; // Caution: must be ZEROed(NULLified)!
char *FileSwapTag = "LEPRECHAUNISH";
char EOFcode = 0x1A;
unsigned long long PseudoLinkedPointer_64, PseudoLinkedPointerNEW_64, PseudoLinkedPointerROOT_64, PseudoLinkedPointerNEWold_64;
      unsigned long long PseudoLinkedPointerNEWleft_64, PseudoLinkedPointerNEWright_64;
      unsigned long long PseudoLinkedPointerNEWmiddle_64;
      unsigned long long NULLs_64 = 0;
unsigned long long PseudoLinkedPointerAUX_64;
unsigned long long PseudoLinkedPointerAUXdumbo_64;
      char wrdAUX[LongestLineInclusive+1+8];  // 0..30, 31 = 0
// QuickSortExternal_4+GB ]

//unsigned long CounterOccurrencies;
unsigned long long CounterOccurrencies; // 2019-Dec-04
unsigned long long NumberOfLEAFs=0;
unsigned long LevelsInCorona_Not_Counting_ROOT=0;
char *ngram[11] = {"NULLleton\0","singleton\0","doubleton\0","tripleton\0","quadrupleton\0","quintupleton\0","sextupleton\0","septupleton\0","octupleton\0","nonupleton\0","decupleton\0"};

unsigned long RipPasses;
unsigned long long NULLsForWRD=0;

int NewOrder;
      char LINE10_NO_DUMP[257]; // 000..255, 256 = 0

char *TwoDigitHEXlist[256] = {
"00\0",
"01\0",
"02\0",
"03\0",
"04\0",
"05\0",
"06\0",
"07\0",
"08\0",
"09\0",
"0A\0",
"0B\0",
"0C\0",
"0D\0",
"0E\0",
"0F\0",
"10\0",
"11\0",
"12\0",
"13\0",
"14\0",
"15\0",
"16\0",
"17\0",
"18\0",
"19\0",
"1A\0",
"1B\0",
"1C\0",
"1D\0",
"1E\0",
"1F\0",
"20\0",
"21\0",
"22\0",
"23\0",
"24\0",
"25\0",
"26\0",
"27\0",
"28\0",
"29\0",
"2A\0",
"2B\0",
"2C\0",
"2D\0",
"2E\0",
"2F\0",
"30\0",
"31\0",
"32\0",
"33\0",
"34\0",
"35\0",
"36\0",
"37\0",
"38\0",
"39\0",
"3A\0",
"3B\0",
"3C\0",
"3D\0",
"3E\0",
"3F\0",
"40\0",
"41\0",
"42\0",
"43\0",
"44\0",
"45\0",
"46\0",
"47\0",
"48\0",
"49\0",
"4A\0",
"4B\0",
"4C\0",
"4D\0",
"4E\0",
"4F\0",
"50\0",
"51\0",
"52\0",
"53\0",
"54\0",
"55\0",
"56\0",
"57\0",
"58\0",
"59\0",
"5A\0",
"5B\0",
"5C\0",
"5D\0",
"5E\0",
"5F\0",
"60\0",
"61\0",
"62\0",
"63\0",
"64\0",
"65\0",
"66\0",
"67\0",
"68\0",
"69\0",
"6A\0",
"6B\0",
"6C\0",
"6D\0",
"6E\0",
"6F\0",
"70\0",
"71\0",
"72\0",
"73\0",
"74\0",
"75\0",
"76\0",
"77\0",
"78\0",
"79\0",
"7A\0",
"7B\0",
"7C\0",
"7D\0",
"7E\0",
"7F\0",
"80\0",
"81\0",
"82\0",
"83\0",
"84\0",
"85\0",
"86\0",
"87\0",
"88\0",
"89\0",
"8A\0",
"8B\0",
"8C\0",
"8D\0",
"8E\0",
"8F\0",
"90\0",
"91\0",
"92\0",
"93\0",
"94\0",
"95\0",
"96\0",
"97\0",
"98\0",
"99\0",
"9A\0",
"9B\0",
"9C\0",
"9D\0",
"9E\0",
"9F\0",
"A0\0",
"A1\0",
"A2\0",
"A3\0",
"A4\0",
"A5\0",
"A6\0",
"A7\0",
"A8\0",
"A9\0",
"AA\0",
"AB\0",
"AC\0",
"AD\0",
"AE\0",
"AF\0",
"B0\0",
"B1\0",
"B2\0",
"B3\0",
"B4\0",
"B5\0",
"B6\0",
"B7\0",
"B8\0",
"B9\0",
"BA\0",
"BB\0",
"BC\0",
"BD\0",
"BE\0",
"BF\0",
"C0\0",
"C1\0",
"C2\0",
"C3\0",
"C4\0",
"C5\0",
"C6\0",
"C7\0",
"C8\0",
"C9\0",
"CA\0",
"CB\0",
"CC\0",
"CD\0",
"CE\0",
"CF\0",
"D0\0",
"D1\0",
"D2\0",
"D3\0",
"D4\0",
"D5\0",
"D6\0",
"D7\0",
"D8\0",
"D9\0",
"DA\0",
"DB\0",
"DC\0",
"DD\0",
"DE\0",
"DF\0",
"E0\0",
"E1\0",
"E2\0",
"E3\0",
"E4\0",
"E5\0",
"E6\0",
"E7\0",
"E8\0",
"E9\0",
"EA\0",
"EB\0",
"EC\0",
"ED\0",
"EE\0",
"EF\0",
"F0\0",
"F1\0",
"F2\0",
"F3\0",
"F4\0",
"F5\0",
"F6\0",
"F7\0",
"F8\0",
"F9\0",
"FA\0",
"FB\0",
"FC\0",
"FD\0",
"FE\0",
"FF\0"
};

/*
#if defined(InternalRAM) 
BSTorBtree = 3; //Internal
#endif
#if defined(ExternalRAM)
BSTorBtree = 2; //External
#endif
*/

uint64_t PointerToNotLoadedYet;
uint64_t jj,jjj, kk, BuildingBlocksSTRIDE;
int mm;
//#define MatchLensNUM 8
//int MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18};
uint64_t GettingIndexOfArray;
uint64_t NotFoundKeys=0, FoundKeys=0;
unsigned long long WORDcountBOTTOMPerMatchLen;
int strFLAG;
int KeySize;
uint64_t AllSlots;
unsigned long long BUGGYoffset; // fix for the bug in r.17 and prior, r.18

Thunderwith=RAMpoolInKB_GLOBAL;
printf ("Leprechaun: Memory pool for B-trees is %s MB.\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits2, 10) );

if (BSTorBtree == 3)
{
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
} else if (BSTorBtree == 2){
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
}

// Below comment is due to adding auto-setting passes, 2019-Dec-07
/*
if (HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL==0)
printf ("Leprechaun: In this revision, %s pass is to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));
else
printf ("Leprechaun: In this revision, %s passes are to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));
*/

// 16fixfix [
PLE_words_INITflag = 0;
PLE_words = 0;
// 16fixfix ]
        Melnitchka = 0;
        WORDcount = 0; // Total word count i.e. for all files!
        WORDcountDistinct = 0;
        NumberOfFiles = 0;
        NumberOfLines = 0;
        FilesLEN = 0;
        LINE10len = 0;
// Added in r.14+++++FIXFIX [
	NumberOfTrees=0; NumberOfHashCollisions=0;
	NumberOfLEAFs=0;
	WORDcountAttemptsToPut=0;
	LevelsInCorona_Not_Counting_ROOT=0;
// Added in r.14+++++FIXFIX ]

if( ( fp_outLOG = fopen( "Leprechaun.LOG", "a+" ) ) == NULL )
{ printf( "Leprechaun: Can't open file Leprechaun.LOG.\n" ); exit( 7 ); }

//	printf( "Leprechaun: Allocating HASH memory %s bytes ... ", _ui64toaKAZEcomma( ((1<<HashInBITS)*8) + 1 + 64 , llTOaDigits, 10) );
//	pointerflushUNALIGN = (char *)malloc( (1<<HashInBITS)*8 + 1 + 64 );

	printf( "Leprechaun: Allocating HASH memory %s bytes ... ", _ui64toaKAZEcomma( (uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8 + 1 + 64 , llTOaDigits, 10) ); // +1 for the PASS #1 // 2019-Dec-04
	pointerflushUNALIGN = (char *)malloc( (uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8 + 1 + 64 ); // +1 for the PASS #1 // 2019-Dec-04

	if( pointerflushUNALIGN == NULL )
	{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
	pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64); // 13_6+
	//offset=64-int((long)data&63);
	printf( "OK\n");

	GLOBAL_HASHPOT = pointerflush; //btree matchfinder needed

//	memset(pointerflush,0,17210368*8);
	memset(pointerflush,0,(uint64_t)(MatchLensNUM+1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04
				if (BSTorBtree == 2) {
	if( ( fp_outRG = fopen( "Leprechaun_64bit.swp", "wb+" ) ) == NULL )
	{ printf( "Leprechaun: Can't create file 'Leprechaun_64bit.swp'.\n" ); exit( 7 ); }
// Tag for the swap file is: LEPRECHAUNISH{ASCIIcode26}
// or 14bytes, then when type of the swap is requested:
// D:\_KAZE_~1\LEPREC~1>type Leprechaun_64bit.swp
// LEPRECHAUNISH
// D:\_KAZE_~1\LEPREC~1>
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14;
BufEnd_64 = 0+14;
// The tag plays two roles, the second to avoid existence of SeekPosition equal to 0. The 0 cannot be used as a free slot FLAG without the TAG.
	printf( "Leprechaun: Allocating/ZEROing %s bytes swap file ... ", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
	memset(OneCkusterZEROES,0,1024*4);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14/(1024*4); ThunderwithL64_L14++)
        	fwrite(OneCkusterZEROES, 1024*4, 1, fp_outRG);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14%(1024*4); ThunderwithL64_L14++)
        	fwrite(&OneChar_ieByte, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
        	fwrite(FileSwapTag, 13, 1, fp_outRG);
        	fwrite(&EOFcode, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
				} else { // ########## 64bit memory manipulations [
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14 + 1 + 64;
printf( "Leprechaun: Allocating memory for B-trees %lu MB ... ", (size_in64_L14>>20)+1 );
pointerflushUNALIGN_64 = (char *)malloc( size_in64_L14 );
	memset(pointerflushUNALIGN_64,0,size_in64_L14);
if( pointerflushUNALIGN_64 == NULL )
{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
pointerflush_64 = pointerflushUNALIGN_64 + 64 - (((size_t)pointerflushUNALIGN_64) % 64); // 13_6+
//offset=64-int((long)data&63);
	//memset(pointerflush_64,0,1024 * (unsigned long long)Thunderwith + 14);
BufEnd_64 = (unsigned long long)pointerflush_64;
/*
printf( "BufEnd_64: %s\n", _ui64toaKAZEcomma(BufEnd_64, llTOaDigits, 10) );
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
pointerflush_64 = (char *)BufEnd_64;
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
exit (1);
	//BufEnd_64: 541,261,888
	//pointerflush_64: 541,261,888
	//pointerflush_64: 541,261,888
*/
				} // ########## 64bit memory manipulations ]
	printf( "OK\n");
	fprintf( fp_outLOG, "Leprechaun report:\n" );

// Comment the streamed-read of input file ... [[[
/*
if( ( fp_inLINE = fopen( argv[1], "rb" ) ) == NULL )
{ printf( "Leprechaun: Can't open file %s \n", argv[1] ); exit( 7 ); }

//fseek( fp_inLINE, 0L, SEEK_END );  //Rev. 12
//size_inLINE = ftell( fp_inLINE );  //Rev. 12
//fseek( fp_inLINE, 0L, SEEK_SET );  //Rev. 12

#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp_inLINE), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp_inLINE) );
_lseeki64( fileno(fp_inLINE), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp_inLINE, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp_inLINE );
fseeko( fp_inLINE, 0L, SEEK_SET );
#endif // defined(_WIN32_ENVIRONMENT_)

printf( "Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	wrdlen = 0;
        for( i = 0; i < size_inLINESIXFOUR; i++ )
	{

                // ~~~~~~~~~~~~ Buffering fread [
                if (workKoffset == -1) {
                        if (i + 1024*128 < size_inLINESIXFOUR) {
                                fread( &workK[0], 1, 1024*128, fp_inLINE );
                                workKoffset = 0;
                                workbyte = workK[workKoffset];
                        } else {
                        fread( &workbyte, 1, 1, fp_inLINE );
			//printf("%d,'%d' %s\n",i, workbyte,TwoDigitHEXlist[workbyte]); //So stupid code of mine, the remaining (mod 128*1024) has to be read byte by byte as NULL, grmbl!
			}

                } else {
                        workKoffset++;
                        workbyte = workK[workKoffset];
                        if (workKoffset == 1024*128 - 1) workKoffset = -1;
                }
                // ~~~~~~~~~~~~ Buffering fread ]

//                if( isalpha( workbyte ) )
//                {
//                        if( wrdlen < 31 )
//                        { wrd[ wrdlen ] = tolower( workbyte ); }
//                        wrdlen++;
//                }
	//			  memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[workbyte], 2 );
	//                        wrdlen++;
	//                        wrdlen++;
        } // i 'for'
        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
// Comment the streamed-read of input file ... ]]]
size_inLINESIXFOUR=SourceSize;
printf( "Leprechaun: Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );
printf( "\n");

		time1=time(NULL); //fix of bigtime

HashChunkSizeInBITS_GLOBAL = HashInBITS_GLOBAL; // 2019-Dec-07

for (jj=0; jj< MatchLensNUM; jj++) {

				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]

BufEnd_64_RESTART = BufEnd_64; // 2019-Dec-07
pointerflush_64_RESTART = pointerflush_64; // 2019-Dec-07

NewAttemptRaisePasses: // 2019-Dec-07

BufEnd_64 = BufEnd_64_RESTART; // 2019-Dec-07
pointerflush_64 = pointerflush_64_RESTART; // 2019-Dec-07
memset(pointerflush + (uint64_t)(jj)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8,0, (uint64_t)(1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04

//for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )
//{
RipPasses = 1-1;
WhyTheHellForIsNotWorking:

if (RipPasses < (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1)
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %s ... \r", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-7), _ui64toaKAZEzerocomma((1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10)+(26-7) );
else
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %s ... ", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-7), _ui64toaKAZEzerocomma((1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)), llTOaDigits4, 10)+(26-7) );

// In-here the new lowering MEMORY FOOTPRINT improvement begins:
// It is from two passes:
// - the first builds B-trees by putting all keys (unique and non-unique) into leaves;
// - the second builds B-trees by putting ONLY non-unique keys into leaves;
// Each pass has its own two POOLs:
// Pass #1: HASH POOL size:     ((1LL)<<HashInBITS_GLOBAL)*8 
// Pass #1: HASH POOL address:  pointerflush       //BufStart + Slot +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8) // MatchLensNUM=10
// Pass #1: Btree POOL size:    size_in64_L14_RAM = SourceSize
// Pass #1: Btree POOL address: pointerflush_64_RAM = VerifyBlock

// Pass #2: HASH POOL size:     MatchLensNUM*((1LL)<<HashInBITS_GLOBAL)*8 
// Pass #2: HASH POOL address:  pointerflush       //BufStart + Slot +(jj*(1LL<<HashInBITS_GLOBAL)*8) // jj=0..9
// Pass #2: Btree POOL size:    size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14
// Pass #2: Btree POOL address: pointerflush_64

// Variable-Differences between two passes:
// Pass #1: Slot_RAM, BufEnd_64_RAM, size_in64_L14_RAM, pointerflush_64_RAM, BSTorBtree_RAM enforced to be 3 i.e. RAM; Pass #1 has 'counter' uncommented!
// Pass #2: Slot,     BufEnd_64,     size_in64_L14,     pointerflush_64,     BSTorBtree
// 'FoundInLinkedList_RAM' decides whether to execute B-tree fragment AT ALL in PASS #2! If the key's occurrences are 1+ then FoundInLinkedList_RAM = 1

// The ASCII block-scheme of major mumbo-jumbo:

/*
Parsing all the BBs (Building-Blocks) of length 4,6,8,10,12,14,16,18,36,64 at each position:

PASS #1 – TEMPORARY STUFF:
One POOL based/located always on physical (internal RAM) – the last/hidden one of all HASH SUB-POOLS:
-----------------------------------------------------------------------                   
| Hash BLOCK (TEMPORARY HASH Sub-Pool), size = command line parameter |---------------------------------------------------------------------------------------------\
-----------------------------------------------------------------------                                                                                             |
 |                                                                                                                                                                  |
 | All slots point to B-tree roots in the TEMPORARY B-tree POOL                                                                                                     |
 \--------------------------------------------------------------\                                                                                                   |
                                                                |                                                                                                   |
Three POOLs based/located always on physical (internal RAM):   \ /                                                                                                  |
-------------------------- ----------------------------------- ---------------------------------------------------------                                            |
| Source Block, size = N | | Source REVERSED Block, size = N | | Target Block, size = N, or, B-trees BLOCK (TEMPORARY) |                                            |
-------------------------- ----------------------------------- ---------------------------------------------------------                                            |
PASS #2 – TEMPORARY-TO-NONTEMPORARY STUFF (takes into account what above two temporary blocks house):                                                               |
-------------------------------------------------                                                                                                                   |
| Source Pool: Houses the file being compressed |                                                                                                                   |
-------------------------------------------------                                                                                                                   |
 |\--------------------------------------------------------------------------------------------------------------------------\                                      |
 | |                                                                                                                         |Hash 64 bytes                         |
 | |Hash 6 bytes                                                                                                             |                                      |
 | \--------------------------------------------------------\                                                                |                                      |
 |                                                          |                                                                |                                      |
 |Hash 4 bytes                                              |                                                                |                                      |
 \                                                          |                                                                |                                      |
 \/                                                        \ /                                                              \ /                                    \ /
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
| Hash Sub-Pool for BBs 4 bytes long                       | Hash Sub-Pool for BBs 6 bytes long                       | ... | Hash Sub-Pool for BBs 64 bytes long | TEMPORARY HASH Sub-Pool |
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
| Slot # 0         | ... | Slot # (1<<HashInBITS_GLOBAL)-1 | Slot # 0         | ... | Slot # (1<<HashInBITS_GLOBAL)-1 |     |                                     |                         |
| Address 8 bytes  | ... | Address 8 bytes                 | Address 8 bytes  | ... | Address 8 bytes                 |     |                                     |                         |
| to a B-tree root | ... | to a B-tree root                | to a B-tree root | ... | to a B-tree root                |     |                                     |                         |
|----------------------------------------------------------|----------------------------------------------------------|-----|-------------------------------------|-------------------------|
 |                                                                             |
 |                                                                             \------\
 \----------------------------------------------\ LEAF #1 is on level 0               |
                                                |                                     |         /---------------------------------------------------------------\ LEAF #5 is on level 2
                                               \ /                                   \ /        |                                                               \/
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------- ! Located either on
| Btree Pool: Houses the leaves of all B-trees | ROOT #1 | ... some leaves/roots ... | ROOT #2 | LEAF #2 | ... some leaves/roots ... | LEAF #3 | LEAF #4 | ... | LEAF #5 | ! Internal or
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------- ! External RAM
                                                |||                                             /\                                    / \       / \
                                                ||\---------------------------------------------/ LEAF #2 is on level 1                |         |
                                                |\-------------------------------------------------------------------------------------/         |
                                                \------------------------------------------------------------------------------------------------/

B-tree order 3 (MAX 3 pointers, MAX 2 keys) LEAF #1 (ROOT is also a LEAF – if no successors) structure:
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
| LeftPointer,    | MiddlePointer,  | RightPointer,   | DynamicLeftKey (LeftKeySize + LeftKey       + LeftQWORD)| DynamicRightKey (RightKeySize + RightKey       + RightQWORD) |
| Address 8 bytes | Address 8 bytes | Address 8 bytes |                 1 byte      + 1..255 bytes  + 8 bytes   |                  1 byte       + 1..255 bytes   + 8 bytes     |
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 |                  |                 |
 |                  |                 \--------------------------------------------------------------------\
 |                  |                                                                                      |
 |                  \-----------------------------\                                                        |
\ /                                               \/                                                      \ /
-----------------------------------------------  -------------------------------------------------------  -----------------------------------------------
| LEAF #2 (housing keys smaller than LeftKey) |  | LEAF #3 (housing keys between LeftKey and RightKey) |  | LEAF #4 (housing keys bigger than RightKey) |
-----------------------------------------------  -------------------------------------------------------  -----------------------------------------------

Note1: Hash Pool: Houses (10+1) consecutive Sub-Pools, the 11th (the last one actually) is used in PASS #1 only (as temporary, its slots point to physical RAM only addresses located in TargetBlock of size N=SourceSize).
Note2: Usually 'LeftQWORD' and 'RightQWORD' are used either for OCCURRENCES or LastSeenOffest of that key.
Note3: If 'LeftKeySize' or 'RightKeySize' is 0 then the field is not used - there is no KEY.

// Source of 2019-Dec-07 revision is downloadable at: https://community.centminmod.com/threads/a-lzss-microdeduplicator-tagetting-huge-texts-with-c-source.16427/#post-80053 
// And glad to share the latest revision of Nakamichi, featuring:
// - Needs 3N physical RAM (+ adjustable physical RAM for HASH pools), where N is the size of file being compressed;
// - Automatic setting of PASSES (allows to fit building B-trees into RAM (the third N used to house output file) and just then to rebuild the current PASS either on RAM or SSD) - it lowers drastically the wearing of external RAM;
// - Significantly Lowered Memory Footprint - now, only the NON-UNIQUE keys are put into B-trees.
*/

// PASS #1: [

	// INITIALIZE: 
	// Below line is zeroing the LAST HASH SUB-POOL for RAM RIP:
	memset(pointerflush + (uint64_t)(MatchLensNUM)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8,0, (uint64_t)(1)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8); // 2019-Dec-04
	// Below line is resetting Btree POOL for RAM RIP:
	BufEnd_64_RAM = (unsigned long long)pointerflush_64_RAM;
	memset(pointerflush_64_RAM,0, size_in64_L14_RAM); // Probably no need, have to check whether it is necessary... YES, if commented then it crashes!? Maybe all the B-tree building/init causes the worse ratio compared to older versions?!

	for (BuildingBlocksSTRIDE=0; BuildingBlocksSTRIDE < size_inLINESIXFOUR-MatchLens[jj]+1; BuildingBlocksSTRIDE++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(SourceBlock+mm+BuildingBlocksSTRIDE)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];
		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.

//		if (wrdlen > 28) {
//			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
//			wrdlen=28;
//		}

		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );

	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28

// Bug fix for all r.14+++ and below! [
//memcpy( &wrd[(LongestLineInclusive+1+4)-4], &NULLsForWRD, 4 );
//memcpy( &wrd[(LongestLineInclusive+1+4)-4-1], &NULLsForWRD, 1 );
// Bug fix for all r.14+++ and below! ]

// Example: HashInBITS-HashChunkSizeInBITS=2
//          HashInBITS = 5
//          HashChunkSizeInBITS = 3
//          RipPasses = 1<<(HashInBITS-HashChunkSizeInBITS) i.e. 1<<2 which is 4 i.e. 32 slots with 4 passes 8 slots each.
//          00??? 5bits 0-7
//          01??? 5bits 8-15
//          10??? 5bits 16-23
//          11??? 5bits 24-31
if ( (Slot>>HashChunkSizeInBITS_GLOBAL) == RipPasses ) {
	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
	// The line above uses the upper/last part of HASH POOL i.e. for MatchLensNUM=10 11th i.e. 0..9 for pass #2, 10 for pass #1
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64_RAM in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64_RAM, 8 );
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64_RAM);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64_RAM, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64_RAM, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64_RAM);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			if (CounterOccurrencies==0) CounterOccurrencies++;         	// Fixing an old bug, counting starts from 0 since this is 'search' not 'insert' - it was already inserted i.e. with 1 occurrence but the field is ZERO when put initially. Fix: 2019-Dec-19
			if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &CounterOccurrencies, 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #1: BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			if (CounterOccurrencies==0) CounterOccurrencies++;         	// Fixing an old bug, counting starts from 0 since this is 'search' not 'insert' - it was already inserted i.e. with 1 occurrence but the field is ZERO when put initially. Fix: 2019-Dec-19
			if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &CounterOccurrencies, 8 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #1: BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree_RAM == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree_RAM == 2) { //r.18
	BUGGYoffset = (BufEnd_64_RAM-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64_RAM-(unsigned long long)pointerflush_64_RAM);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14_RAM - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64_RAM;
			BufEnd_64_RAM = BufEnd_64_RAM + 8 + 8 + 8;
			BufEnd_64_RAM = BufEnd_64_RAM + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14_RAM, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
if ( HashChunkSizeInBITS_GLOBAL > 0 ) { // 2019-Dec-07
	HashChunkSizeInBITS_GLOBAL--;
	printf( "Automatically increasing number of passes in order to fit B-trees into Target Buffer.\n" );
	goto NewAttemptRaisePasses;
} else exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree_RAM == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree_RAM == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 fragment 64bit ]

} //if ( (Slot>>HashChunkSizeInBITS) == RipPasses ) {
	} //for (BuildingBlocksSTRIDE=0; 

// PASS #1: ]

// PASS #2: [

	for (BuildingBlocksSTRIDE=0; BuildingBlocksSTRIDE < size_inLINESIXFOUR-MatchLens[jj]+1; BuildingBlocksSTRIDE++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(SourceBlock+mm+BuildingBlocksSTRIDE)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];
		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.

//		if (wrdlen > 28) {
//			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
//			wrdlen=28;
//		}

		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );

	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28

// Bug fix for all r.14+++ and below! [
//memcpy( &wrd[(LongestLineInclusive+1+4)-4], &NULLsForWRD, 4 );
//memcpy( &wrd[(LongestLineInclusive+1+4)-4-1], &NULLsForWRD, 1 );
// Bug fix for all r.14+++ and below! ]

// Example: HashInBITS-HashChunkSizeInBITS=2
//          HashInBITS = 5
//          HashChunkSizeInBITS = 3
//          RipPasses = 1<<(HashInBITS-HashChunkSizeInBITS) i.e. 1<<2 which is 4 i.e. 32 slots with 4 passes 8 slots each.
//          00??? 5bits 0-7
//          01??? 5bits 8-15
//          10??? 5bits 16-23
//          11??? 5bits 24-31
if ( (Slot>>HashChunkSizeInBITS_GLOBAL) == RipPasses ) {
	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot_RAM = Slot +(MatchLensNUM*(1LL<<HashInBITS_GLOBAL)*8); // 2019-Dec-04
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot_RAM, 8 );

// HERE THE 'DECIDER' is EXECUTED (whether 'wrd' is encountered 1+ times within ALL KEYS already put in PASS #1) [[[
FoundInLinkedList_RAM = 0; // Assume not found
// 1] Search [ Just check for 1+ occurrences

                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
			// Impossible, they all have already been inserted...
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // 2019-Dec-04
			if (CounterOccurrencies>1) FoundInLinkedList_RAM = 1; // 2019-Dec-04

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #2 (decider): BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree_RAM == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+8)-8], 8 ); // 2019-Dec-04
			if (CounterOccurrencies>1) FoundInLinkedList_RAM = 1; // 2019-Dec-04

// Debug the ratio difference [
//			if (CounterOccurrencies>1) {
//				printf("\nPASS #2 (decider): BuildingBlocksSTRIDE, jj = %s, %s\n", _ui64toaKAZEzerocomma4(BuildingBlocksSTRIDE, llTOaDigits3, 16)+(26-8-1), _ui64toaKAZEzerocomma4(jj, llTOaDigits2, 10)+(26-2));
//			}
// Debug the ratio difference ]

			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree_RAM == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section ]
                      } // while
                    }

// 1] Search ] Just check for 1+ occurrences
// HERE THE 'DECIDER' is EXECUTED (whether 'wrd' is encountered 1+ times within ALL KEYS already put in PASS #1) ]]]

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

	if (FoundInLinkedList_RAM == 1) { // 2019-Dec-04
// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64 in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64, 8 );
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
//		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
//			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
//			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 fragment 64bit ]
	} // if (FoundInLinkedList_RAM == 0) { // 2019-Dec-04
} //if ( (Slot>>HashChunkSizeInBITS) == RipPasses ) {
	} //for (BuildingBlocksSTRIDE=0; 

// PASS #2: ]

 RipPasses++;
 if (RipPasses <= (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1) goto WhyTheHellForIsNotWorking;
//} // for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )

// Counting trees [
NumberOfTrees=0;
AllSlots=0;

	for( j = 0; j < MatchLensNUM; j++ ) //r.18
	{
	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 
                      Slot = (AllSlots)<<3; AllSlots++;
                      memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );
                      if (PseudoLinkedPointer_64 != 0) NumberOfTrees++;
	}
	}
// Counting trees ]

	printf( "DONE; %s B-trees have been rooted so far.\n", _ui64toaKAZEzerocomma(NumberOfTrees, llTOaDigits, 10)+(26-14));
} //for (jj=0; 
	printf( "\n");

goto SkipDestroyingTheTrees;
// Stats... [

	time2=time(NULL); //fix of bigtime
	NumberOfTrees=0;
	NumberOfLEAFs=0;
	LevelsInCorona_Not_Counting_ROOT=0;
// DUMP and STATS [[[
WORDcountBOTTOM = 0;
// The dump file with ripped data [
//if( ( fp_out = fopen( argv[2], "ab+" ) ) == NULL )
//{ printf( "Leprechaun: Can't create file %s \n", argv[2] ); exit( 7 ); }
// The dump file with ripped data ]
CRdLFa[0] = 13; CRdLFa[1] = 10;
AllSlots=0;

	BufStart = pointerflush;
//	for( j = 0; j < 28*28*28*28*28; j++ )
	//for( j = 0; j < (1<<HashInBITS); j++ )
	for( j = 0; j < MatchLensNUM; j++ ) //r.18
	{
//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = (MatchLens[j]<<1); //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 
	WORDcountBOTTOMPerMatchLen=0; //r.18
                      Slot = (AllSlots)<<3; AllSlots++;
                      memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );
                      if (PseudoLinkedPointer_64 != 0)
                      {
	NumberOfTrees++;

// CAUTION: Did forget that dumping/traversing the B-trees - DESTROYS them! On purpose, pointers are zeroed.
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit [
     // DONE JOB:
     // Must be written B-tree traverse ! with simulated stack i.e. non-recursive.
     // ...
  StackPtr = 0;
  while ( 2==2 ) {
        while (PseudoLinkedPointer_64 != 0)
              { 
                if (StackPtr > 8192*3-1) { printf( "\nLeprechaun: Failure! B-tree simulated stack overflow, too high B-tree!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //ptr to Rwrd
//if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) == 0 ) {memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );}
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		if (SomeByte == 0 ) // RW exists not
		 {
		  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
				if (BSTorBtree == 2) {
		  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8], &NULLs_64, 8 );
			// ]  //r.14+
		 }
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
// Give first from right to left non-zero PTR
                if (PseudoLinkedPointerNEWright_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWright;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWright_64;
                }
                else if (PseudoLinkedPointerNEWmiddle_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWmiddle;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWmiddle_64;
                }
                else if (PseudoLinkedPointerNEWleft_64 !=0 )
//                { memcpy( PseudoLinkedPointer, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWleft;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWleft_64;
                }
                else
                {
                  PseudoLinkedPointer_64 = 0;
                }
              }
	    if (LevelsInCorona_Not_Counting_ROOT < StackPtr) LevelsInCorona_Not_Counting_ROOT = StackPtr; //r.14
        if (StackPtr == 0) break;
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
        if (PseudoLinkedPointerNEWleft_64 + PseudoLinkedPointerNEWmiddle_64 + PseudoLinkedPointerNEWright_64 == 0) // One LEAF is PRINTED when LP=0 MP=0 RP=0
           { 
//        memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4, i%31+1 );
//        fwrite(wrd, i%31+1, 1, fp_out);
//        fwrite(CRdLFa, 2, 1, fp_out); 
//        if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) != 0 )
//             { memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4 + i%31+1, i%31+1 );
//               fwrite(wrd, i%31+1, 1, fp_out);
//               fwrite(CRdLFa, 2, 1, fp_out); 
//             }
//        PseudoLinkedPointer = 0;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		//fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			// Counter ]
                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//	        fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                WORDcountBOTTOM++;
//	        fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	//fwrite(CRdLFa, 2, 1, fp_out); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		 //fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		 if (SomeByte != 0 ) // RW exists
		 {
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		 //fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			// Counter ]
                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//   	         fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                 WORDcountBOTTOM++;
//   	         fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	 //fwrite(CRdLFa, 2, 1, fp_out); 
		 }
		  PseudoLinkedPointer_64 = 0;
	    NumberOfLEAFs++; //r.14
           }
  }                                          
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit ]

                      } //if (PseudoLinkedPointer_64 != 0)
	// Stats for one tree only:
	//printf( "\nLeprechaun: Total keys (j=%d) into B-trees order 3 (during traversal/dump): %s\n", j,_ui64toaKAZEcomma(WORDcountBOTTOMPerMatchLen, llTOaDigits, 10) );

	} //for( jjj = 0; 
	} //for( j = 0; 

// The dump file with ripped data [
//fclose(fp_out);
// The dump file with ripped data ]

	fprintf( fp_outLOG, "Number Of Hash Collisions(Distinct WORDs - Number Of Trees): %s\n", _ui64toaKAZEcomma(WORDcountDistinct - NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Number Of Trees(GREATER THE BETTER): %s\n", _ui64toaKAZEcomma(NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: %s\n", _ui64toaKAZEcomma(NumberOfLEAFs-NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): %s\n", _ui64toaKAZEcomma(LevelsInCorona_Not_Counting_ROOT-1, llTOaDigits, 10) );

	fprintf( fp_outLOG, "Used value for third parameter in KB: %s\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Use next time as third parameter: %s\n", _ui64toaKAZEcomma((((BufEnd_64-(unsigned long long)pointerflush_64)+1)>>10)+1, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );

// DUMP and STATS ]]]

	printf( "\n");
	printf( "Leprechaun: Number Of Total/Distinct/Undistinct keys/BBs (all orders): %s/%s/%s\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma(WORDcountDistinct, llTOaDigits2, 10), _ui64toaKAZEcomma(WORDcount-WORDcountDistinct, llTOaDigits3, 10) );
	printf( "Leprechaun: Number Of TREEs(GREATER THE BETTER): %s\n", _ui64toaKAZEcomma(NumberOfTrees, llTOaDigits, 10) );
	printf( "Leprechaun: Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: %s\n", _ui64toaKAZEcomma(NumberOfLEAFs-NumberOfTrees, llTOaDigits, 10) );
	printf( "Leprechaun: Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): %s\n", _ui64toaKAZEcomma(LevelsInCorona_Not_Counting_ROOT-1, llTOaDigits, 10) );
	printf( "Leprechaun: Used value for B-trees pool in KB: %s\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits, 10) );
	printf( "Leprechaun: Use next time for B-trees pool in KB: %s\n", _ui64toaKAZEcomma((((BufEnd_64-(unsigned long long)pointerflush_64)+1)>>10)+1, llTOaDigits, 10) );
//	printf( "Leprechaun: Total Attempts to Find/Put keys into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	printf( "Leprechaun: Total keys (all orders) into B-trees order 3 (during traversal/dump): %s\n", _ui64toaKAZEcomma(WORDcountBOTTOM, llTOaDigits, 10) );
	printf( "Leprechaun: Total keys MISSES/HITS (all orders) into B-trees order 3: %s/%s\n", _ui64toaKAZEcomma(NotFoundKeys, llTOaDigits, 10), _ui64toaKAZEcomma(FoundKeys, llTOaDigits2, 10) );
	printf( "\n");
// Stats... ]

	printf( "Leprechaun: B-trees building speed (counting ROOT LEAFs): %s LEAFs/s\n", _ui64toaKAZEcomma((double)(NumberOfLEAFs)/(double)(time2 - time1 + 1), llTOaDigits3, 10));
	printf( "Leprechaun: B-trees traverse speed (counting ROOT LEAFs): %s LEAFs/s\n", _ui64toaKAZEcomma((double)(NumberOfLEAFs)/(double)(time(NULL) - time2 + 1), llTOaDigits3, 10));
SkipDestroyingTheTrees:
	printf( "Leprechaun: Total Searches-n-Inserts Per Second: %s SNIPS\n", _ui64toaKAZEcomma((double)(WORDcount)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10));
	printf( "Leprechaun: RAM needed to house B-trees (relative to the file being ripped): %sN = %sMB\n", _ui64toaKAZEcomma((BufEnd_64-(unsigned long long)pointerflush_64+1)/size_inLINESIXFOUR, llTOaDigits3, 10), _ui64toaKAZEcomma(1+((BufEnd_64-(unsigned long long)pointerflush_64+1)>>20), llTOaDigits2, 10));
//#if defined(ExternalRAM)
if (BSTorBtree == 2) {
	printf( "Leprechaun: Total IOPS for %s 'freads' and %s 'fwrites' (of packets %d bytes long) during loading traversing all orders: %s IOPS\n", _ui64toaKAZEcomma(Total_fread, llTOaDigits, 10), _ui64toaKAZEcomma(Total_fwrite, llTOaDigits2, 10), 8+8+8+2*(LongestLineInclusive+1+8), _ui64toaKAZEcomma((double)(Total_fwrite+Total_fread)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10));
}
//#endif
	printf( "\n");

//exit(0);

} // B_tree_Non_Unique_Only]


void B_tree(int argc, char *argv[], char* SourceBlock, uint64_t SourceSize) {  // b_tree[
      //int BSTorBtree = 0;
      FILE *fp_in, *fp_out, *fp_outLOG, *fp_inLINE;
      int Thunderwith;
// cleand unused below...
   int nlines;

      int LetterOffset;
      unsigned long long FilesLEN;
      unsigned long long WORDcount; 
      unsigned long long WORDcountBOTTOM; 
      unsigned long long WORDcountAttemptsToPut; 
      unsigned long long Total_fread=0, Total_fwrite=0; 

// 15fixfixfixfix [
        //unsigned long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfix
        unsigned long long NumberOfFiles, WORDcountDistinct, WORDcountDistinctTOTAL = 0, TotalMemoryNeededForOnePass = 0; // This was in r.15fixfixfixfix
// 15fixfixfixfix ]
        unsigned long long NumberOfLines;  // rev. 12+
      unsigned long WHOLEletter_BufferSize;
      unsigned long long WHOLEletter_BufferSize_L14;
        unsigned long memory_size, LetterBuffer, j, k, LINE10len, wrdlen;
        unsigned long k_FIX;
        unsigned long long i;              // rev. 12+
        //unsigned long size_in, size_out, size_inLINE;
        unsigned long size_in;           // rev. 12+
#if defined(_WIN32_ENVIRONMENT_)
      unsigned long long size_inLINESIXFOUR;
#else
      size_t size_inLINESIXFOUR;
#endif /* defined(_WIN32_ENVIRONMENT_)  */

      const int NumberOfSLOTs = 4096*2; // Since r.12+ in rev.12 it was 4096
  unsigned long StackPtr;
  //unsigned long BSTstack [65536*3]; // BST in worst case could become a LL.
  unsigned long long BSTstack [8192*3]; // BST in worst case could become a LL.
unsigned long NumberOfTrees=0, NumberOfHashCollisions=0;
unsigned long iBSTwithMAXpeak, jBSTwithMAXpeak;
  unsigned int PEAKibBST;
  unsigned long BSTsTotalLEAFs=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnode=0, BSTcurrentNode=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentNodeMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXnodePEAK=1, BSTwithMAXnodeLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeak=0, BSTcurrentPeak=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAX=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentPeakMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXpeakNODE=1, BSTwithMAXpeakLEAF=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleaf=0, BSTcurrentLeaf=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long                   BSTcurrentLeafMAXqUANTITY=0; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!
  unsigned long BSTwithMAXleafNODE=1, BSTwithMAXleafPEAK=1; // ?! MADHOUSE: if BSTcurrent is not zeroed here then INSANE values of BSTcurrent occur below where 'break' is ?!

      char *pointerflush, *pointerflushUNALIGN, *BufStart, *Flushing;
      char *pointerflush_64, *pointerflushUNALIGN_64; // r.14++
      unsigned long PseudoLinkedPointer, PseudoLinkedPointerNEW, PseudoLinkedPointerROOT, PseudoLinkedPointerNEWold;
      unsigned long PseudoLinkedPointerNEWleft, PseudoLinkedPointerNEWright;
      unsigned long PseudoLinkedPointerNEWmiddle;
      char *bufend[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      long bufNumberOfWords[ 806 ]; // 'a'=0, ... 'z'=25 - 26 letters x 31 lengths
      // long bufNoWpS[ 806 ][ 8192 ]; // ?! crashes below when an attempt to use it occur
      char wrd[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUP[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char wrdUPold[LongestLineInclusive+1+8];  // 0..30, 31 = 0
      char LINE10[257]; // 000..255, 256 = 0
      char ZEROS[4]; // 0..3, 0 = 0, 1 = 0, 2 = 0, 3 = 0
      char CRdLFa[2];  // 0..1, 0 = 13, 1 = 10
      unsigned char workbyte; // unsigned in order to index ASCII
      char workK[1024*128];
      long workKoffset = -1;
      unsigned long long FoundInLinkedList, Slot; //r.18
      unsigned long OffsetsInBuffer[31]; // 00..30
      unsigned long MAXusedBuffer[32]; // 00 not used, only 01..31
      unsigned long GRMBLhill[32]; // 00..31
      unsigned long GRMBLFoolAgain[32]; // 00..31
      int Melnitchka;
      unsigned long MAXusedBufferABS = 0;
      unsigned long Utiliza1 = 0;
      unsigned long Utiliza2 = 0;
      unsigned long TotalWLchars = 0;

// GCC 7.3.0 from MINGW complains, so commented them all:
/* minimum signed 64 bit value */
//#define _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
//#define _I64_MAX      9223372036854775807i64
/* maximum unsigned 64 bit value */
//#define _UI64_MAX     0xffffffffffffffffui64

/* minimum signed 128 bit value */
#define _I128_MIN   (-170141183460469231731687303715884105727i128 - 1)
/* maximum signed 128 bit value */
#define _I128_MAX     170141183460469231731687303715884105727i128
/* maximum unsigned 128 bit value */
#define _UI128_MAX    0xffffffffffffffffffffffffffffffffui128

      char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      // below duplicates are needed because of one_line_invoking need different buffers.
      char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
      unsigned long HEADOffetFromStartBUKVA = 0;
      unsigned long TAILOffetFromStartBUKVA = 0;

      int SplitOccured;
      int POffsetInLEAF;
char *Auberge[4] = {"|\0","/\0","-\0","\\\0"};
int hashAlfalfa, iAlfalfa;
int PLE_words=0; // Quadruple!
char wrd1st[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd2nd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd3rd[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd4th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd5th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd6th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd7th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd8th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd9th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char wrd10th[LongestLineInclusive+1+4];  // 0..30, 31 = 0
char *DelimiterUnderscore = "_\0";
int PLE_words_INITflag = 0;

// QuickSortExternal_4+GB [
unsigned long long ThunderwithL64_L14;
unsigned long long Strnglen64_L14;
unsigned long long size_in64_L14, size_in2_L14;
unsigned long long Over4billionLines, j_Over4billion;
char OneChar_ieByte = '\0';
char CR_ieByte = '\r';
char SomeByte;
unsigned long long BufEnd_64;
unsigned long long SeekPosition;
unsigned long long *PointerToSeekPosition;
char FourGram[LongestLineInclusive+2]; // 31 longest 4-gram + CR + LF
char *PoolPhysical;
unsigned long long fsetpos_ZERO=0;
char OneCkusterZEROES[1024*4]; // Caution: must be ZEROed(NULLified)!
char *FileSwapTag = "LEPRECHAUNISH";
char EOFcode = 0x1A;
unsigned long long PseudoLinkedPointer_64, PseudoLinkedPointerNEW_64, PseudoLinkedPointerROOT_64, PseudoLinkedPointerNEWold_64;
      unsigned long long PseudoLinkedPointerNEWleft_64, PseudoLinkedPointerNEWright_64;
      unsigned long long PseudoLinkedPointerNEWmiddle_64;
      unsigned long long NULLs_64 = 0;
unsigned long long PseudoLinkedPointerAUX_64;
unsigned long long PseudoLinkedPointerAUXdumbo_64;
      char wrdAUX[LongestLineInclusive+1+8];  // 0..30, 31 = 0
// QuickSortExternal_4+GB ]

unsigned long CounterOccurrencies;
unsigned long long NumberOfLEAFs=0;
unsigned long LevelsInCorona_Not_Counting_ROOT=0;
char *ngram[11] = {"NULLleton\0","singleton\0","doubleton\0","tripleton\0","quadrupleton\0","quintupleton\0","sextupleton\0","septupleton\0","octupleton\0","nonupleton\0","decupleton\0"};

unsigned long RipPasses;
unsigned long long NULLsForWRD=0;

int NewOrder;
      char LINE10_NO_DUMP[257]; // 000..255, 256 = 0

char *TwoDigitHEXlist[256] = {
"00\0",
"01\0",
"02\0",
"03\0",
"04\0",
"05\0",
"06\0",
"07\0",
"08\0",
"09\0",
"0A\0",
"0B\0",
"0C\0",
"0D\0",
"0E\0",
"0F\0",
"10\0",
"11\0",
"12\0",
"13\0",
"14\0",
"15\0",
"16\0",
"17\0",
"18\0",
"19\0",
"1A\0",
"1B\0",
"1C\0",
"1D\0",
"1E\0",
"1F\0",
"20\0",
"21\0",
"22\0",
"23\0",
"24\0",
"25\0",
"26\0",
"27\0",
"28\0",
"29\0",
"2A\0",
"2B\0",
"2C\0",
"2D\0",
"2E\0",
"2F\0",
"30\0",
"31\0",
"32\0",
"33\0",
"34\0",
"35\0",
"36\0",
"37\0",
"38\0",
"39\0",
"3A\0",
"3B\0",
"3C\0",
"3D\0",
"3E\0",
"3F\0",
"40\0",
"41\0",
"42\0",
"43\0",
"44\0",
"45\0",
"46\0",
"47\0",
"48\0",
"49\0",
"4A\0",
"4B\0",
"4C\0",
"4D\0",
"4E\0",
"4F\0",
"50\0",
"51\0",
"52\0",
"53\0",
"54\0",
"55\0",
"56\0",
"57\0",
"58\0",
"59\0",
"5A\0",
"5B\0",
"5C\0",
"5D\0",
"5E\0",
"5F\0",
"60\0",
"61\0",
"62\0",
"63\0",
"64\0",
"65\0",
"66\0",
"67\0",
"68\0",
"69\0",
"6A\0",
"6B\0",
"6C\0",
"6D\0",
"6E\0",
"6F\0",
"70\0",
"71\0",
"72\0",
"73\0",
"74\0",
"75\0",
"76\0",
"77\0",
"78\0",
"79\0",
"7A\0",
"7B\0",
"7C\0",
"7D\0",
"7E\0",
"7F\0",
"80\0",
"81\0",
"82\0",
"83\0",
"84\0",
"85\0",
"86\0",
"87\0",
"88\0",
"89\0",
"8A\0",
"8B\0",
"8C\0",
"8D\0",
"8E\0",
"8F\0",
"90\0",
"91\0",
"92\0",
"93\0",
"94\0",
"95\0",
"96\0",
"97\0",
"98\0",
"99\0",
"9A\0",
"9B\0",
"9C\0",
"9D\0",
"9E\0",
"9F\0",
"A0\0",
"A1\0",
"A2\0",
"A3\0",
"A4\0",
"A5\0",
"A6\0",
"A7\0",
"A8\0",
"A9\0",
"AA\0",
"AB\0",
"AC\0",
"AD\0",
"AE\0",
"AF\0",
"B0\0",
"B1\0",
"B2\0",
"B3\0",
"B4\0",
"B5\0",
"B6\0",
"B7\0",
"B8\0",
"B9\0",
"BA\0",
"BB\0",
"BC\0",
"BD\0",
"BE\0",
"BF\0",
"C0\0",
"C1\0",
"C2\0",
"C3\0",
"C4\0",
"C5\0",
"C6\0",
"C7\0",
"C8\0",
"C9\0",
"CA\0",
"CB\0",
"CC\0",
"CD\0",
"CE\0",
"CF\0",
"D0\0",
"D1\0",
"D2\0",
"D3\0",
"D4\0",
"D5\0",
"D6\0",
"D7\0",
"D8\0",
"D9\0",
"DA\0",
"DB\0",
"DC\0",
"DD\0",
"DE\0",
"DF\0",
"E0\0",
"E1\0",
"E2\0",
"E3\0",
"E4\0",
"E5\0",
"E6\0",
"E7\0",
"E8\0",
"E9\0",
"EA\0",
"EB\0",
"EC\0",
"ED\0",
"EE\0",
"EF\0",
"F0\0",
"F1\0",
"F2\0",
"F3\0",
"F4\0",
"F5\0",
"F6\0",
"F7\0",
"F8\0",
"F9\0",
"FA\0",
"FB\0",
"FC\0",
"FD\0",
"FE\0",
"FF\0"
};

/*
#if defined(InternalRAM) 
BSTorBtree = 3; //Internal
#endif
#if defined(ExternalRAM)
BSTorBtree = 2; //External
#endif
*/

uint64_t PointerToNotLoadedYet;
uint64_t jj,jjj, kk, BuildingBlocksSTRIDE;
int mm;
//#define MatchLensNUM 8
//int MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18};
uint64_t GettingIndexOfArray;
uint64_t NotFoundKeys=0, FoundKeys=0;
unsigned long long WORDcountBOTTOMPerMatchLen;
int strFLAG;
int KeySize;
uint64_t AllSlots;
unsigned long long BUGGYoffset; // fix for the bug in r.17 and prior, r.18

Thunderwith=RAMpoolInKB_GLOBAL;
printf ("Leprechaun: Memory pool for B-trees is %s MB.\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits2, 10) );

if (BSTorBtree == 3)
{
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s internal B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
} else if (BSTorBtree == 2){
if (HashInBITS_GLOBAL+3<10)
printf ("Leprechaun: In this revision %sbytes %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma((((1LL)<<HashInBITS_GLOBAL)<<3), llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else if (HashInBITS_GLOBAL+3>=10 && HashInBITS_GLOBAL+3<20)
printf ("Leprechaun: In this revision %sKB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>10, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
else
printf ("Leprechaun: In this revision %sMB %d-way hash is used which results in %d x %s external B-Trees of order 3.\n", _ui64toaKAZEcomma( ((((1LL)<<HashInBITS_GLOBAL)<<3))>>20, llTOaDigits, 10), MatchLensNUM, MatchLensNUM, _ui64toaKAZEcomma(( ((1LL)<<HashInBITS_GLOBAL) ), llTOaDigits2, 10) );
}

if (HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL==0)
printf ("Leprechaun: In this revision, %s pass is to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));
else
printf ("Leprechaun: In this revision, %s passes are to be executed.\n", _ui64toaKAZEcomma(1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL), llTOaDigits, 10));

// 16fixfix [
PLE_words_INITflag = 0;
PLE_words = 0;
// 16fixfix ]
        Melnitchka = 0;
        WORDcount = 0; // Total word count i.e. for all files!
        WORDcountDistinct = 0;
        NumberOfFiles = 0;
        NumberOfLines = 0;
        FilesLEN = 0;
        LINE10len = 0;
// Added in r.14+++++FIXFIX [
	NumberOfTrees=0; NumberOfHashCollisions=0;
	NumberOfLEAFs=0;
	WORDcountAttemptsToPut=0;
	LevelsInCorona_Not_Counting_ROOT=0;
// Added in r.14+++++FIXFIX ]

if( ( fp_outLOG = fopen( "Leprechaun.LOG", "a+" ) ) == NULL )
{ printf( "Leprechaun: Can't open file Leprechaun.LOG.\n" ); exit( 7 ); }

//	printf( "Leprechaun: Allocating HASH memory %s bytes ... ", _ui64toaKAZEcomma( ((1<<HashInBITS)*8) + 1 + 64 , llTOaDigits, 10) );
//	pointerflushUNALIGN = (char *)malloc( (1<<HashInBITS)*8 + 1 + 64 );

	printf( "Leprechaun: Allocating HASH memory %s bytes ... ", _ui64toaKAZEcomma( (uint64_t)MatchLensNUM*((uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8) + 1 + 64 , llTOaDigits, 10) );
	pointerflushUNALIGN = (char *)malloc( (uint64_t)(MatchLensNUM)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8 + 1 + 64 );

	if( pointerflushUNALIGN == NULL )
	{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
	pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64); // 13_6+
	//offset=64-int((long)data&63);
	printf( "OK\n");

	GLOBAL_HASHPOT = pointerflush; //btree matchfinder needed

//	memset(pointerflush,0,17210368*8);
	memset(pointerflush,0,(uint64_t)(MatchLensNUM)*(uint64_t)( ((1LL)<<HashInBITS_GLOBAL) )*8);
				if (BSTorBtree == 2) {
	if( ( fp_outRG = fopen( "Leprechaun_64bit.swp", "wb+" ) ) == NULL )
	{ printf( "Leprechaun: Can't create file 'Leprechaun_64bit.swp'.\n" ); exit( 7 ); }
// Tag for the swap file is: LEPRECHAUNISH{ASCIIcode26}
// or 14bytes, then when type of the swap is requested:
// D:\_KAZE_~1\LEPREC~1>type Leprechaun_64bit.swp
// LEPRECHAUNISH
// D:\_KAZE_~1\LEPREC~1>
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14;
BufEnd_64 = 0+14;
// The tag plays two roles, the second to avoid existence of SeekPosition equal to 0. The 0 cannot be used as a free slot FLAG without the TAG.
	printf( "Leprechaun: Allocating/ZEROing %s bytes swap file ... ", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
	memset(OneCkusterZEROES,0,1024*4);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14/(1024*4); ThunderwithL64_L14++)
        	fwrite(OneCkusterZEROES, 1024*4, 1, fp_outRG);
	for (ThunderwithL64_L14=0; ThunderwithL64_L14 < size_in64_L14%(1024*4); ThunderwithL64_L14++)
        	fwrite(&OneChar_ieByte, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&fsetpos_ZERO); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
        	fwrite(FileSwapTag, 13, 1, fp_outRG);
        	fwrite(&EOFcode, 1, 1, fp_outRG);
	fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64); // SOMETHING ROTTEN with lseeki64/fseeko and fsetpos ??!! So DO-IT-OVER.
				} else { // ########## 64bit memory manipulations [
	size_in64_L14 = 1024LL * 1024 * (unsigned long long)Thunderwith + 14 + 1 + 64;
printf( "Leprechaun: Allocating memory for B-trees %lu MB ... ", (size_in64_L14>>20)+1 );
pointerflushUNALIGN_64 = (char *)malloc( size_in64_L14 );
	memset(pointerflushUNALIGN_64,0,size_in64_L14);
if( pointerflushUNALIGN_64 == NULL )
{ puts( "\nLeprechaun: Needed memory allocation denied!\n" ); exit( 7 ); }
pointerflush_64 = pointerflushUNALIGN_64 + 64 - (((size_t)pointerflushUNALIGN_64) % 64); // 13_6+
//offset=64-int((long)data&63);
	//memset(pointerflush_64,0,1024 * (unsigned long long)Thunderwith + 14);
BufEnd_64 = (unsigned long long)pointerflush_64;
/*
printf( "BufEnd_64: %s\n", _ui64toaKAZEcomma(BufEnd_64, llTOaDigits, 10) );
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
pointerflush_64 = (char *)BufEnd_64;
printf( "pointerflush_64: %s\n", _ui64toaKAZEcomma(pointerflush_64, llTOaDigits, 10) );
exit (1);
	//BufEnd_64: 541,261,888
	//pointerflush_64: 541,261,888
	//pointerflush_64: 541,261,888
*/
				} // ########## 64bit memory manipulations ]
	printf( "OK\n");
	fprintf( fp_outLOG, "Leprechaun report:\n" );

// Comment the streamed-read of input file ... [[[
/*
if( ( fp_inLINE = fopen( argv[1], "rb" ) ) == NULL )
{ printf( "Leprechaun: Can't open file %s \n", argv[1] ); exit( 7 ); }

//fseek( fp_inLINE, 0L, SEEK_END );  //Rev. 12
//size_inLINE = ftell( fp_inLINE );  //Rev. 12
//fseek( fp_inLINE, 0L, SEEK_SET );  //Rev. 12

#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp_inLINE), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp_inLINE) );
_lseeki64( fileno(fp_inLINE), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp_inLINE, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp_inLINE );
fseeko( fp_inLINE, 0L, SEEK_SET );
#endif // defined(_WIN32_ENVIRONMENT_)

printf( "Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );

        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	wrdlen = 0;
        for( i = 0; i < size_inLINESIXFOUR; i++ )
	{

                // ~~~~~~~~~~~~ Buffering fread [
                if (workKoffset == -1) {
                        if (i + 1024*128 < size_inLINESIXFOUR) {
                                fread( &workK[0], 1, 1024*128, fp_inLINE );
                                workKoffset = 0;
                                workbyte = workK[workKoffset];
                        } else {
                        fread( &workbyte, 1, 1, fp_inLINE );
			//printf("%d,'%d' %s\n",i, workbyte,TwoDigitHEXlist[workbyte]); //So stupid code of mine, the remaining (mod 128*1024) has to be read byte by byte as NULL, grmbl!
			}

                } else {
                        workKoffset++;
                        workbyte = workK[workKoffset];
                        if (workKoffset == 1024*128 - 1) workKoffset = -1;
                }
                // ~~~~~~~~~~~~ Buffering fread ]

//                if( isalpha( workbyte ) )
//                {
//                        if( wrdlen < 31 )
//                        { wrd[ wrdlen ] = tolower( workbyte ); }
//                        wrdlen++;
//                }
	//			  memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[workbyte], 2 );
	//                        wrdlen++;
	//                        wrdlen++;
        } // i 'for'
        //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
// Comment the streamed-read of input file ... ]]]
size_inLINESIXFOUR=SourceSize;
printf( "Leprechaun: Size of input file: %s\n", _ui64toaKAZEcomma(size_inLINESIXFOUR, llTOaDigits, 10) );
printf( "\n");

		time1=time(NULL); //fix of bigtime

for (jj=0; jj< MatchLensNUM; jj++) {
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]

//for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )
//{
RipPasses = 1-1;
WhyTheHellForIsNotWorking:

if (RipPasses < (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1)
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %lu ... \r", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-3), (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)) );
else
	printf( "Leprechaun: Inserting keys/BBs of order %s into B-trees, free RAM in B-tree pool is %s MB; Pass #%s of %lu ... ", _ui64toaKAZEzerocomma(MatchLens[jj], llTOaDigits2, 10)+(26-3), _ui64toaKAZEzerocomma((size_in64_L14 - BUGGYoffset)>>20, llTOaDigits, 10)+(26-10), _ui64toaKAZEzerocomma(RipPasses+1, llTOaDigits3, 10)+(26-3), (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL)) );
	for (BuildingBlocksSTRIDE=0; BuildingBlocksSTRIDE < size_inLINESIXFOUR-MatchLens[jj]+1; BuildingBlocksSTRIDE++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(SourceBlock+mm+BuildingBlocksSTRIDE)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];
		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.

//		if (wrdlen > 28) {
//			FIPS202_SHA3_224((unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen, (unsigned char *)SHA328bytes);
//			wrdlen=28;
//		}

		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(SourceBlock+BuildingBlocksSTRIDE), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );

	BufStart = pointerflush;
//	Slot = ((wrd[0]-'_')*28*28*28*28 + (wrd[1]-'_')*28*28*28 + (wrd[2]-'_')*28*28 + (wrd[3]-'_')*28 + (wrd[4]-'_'))<<3;
//	Slot = FNV1A_Hash_Jesteress_27bit(wrd, wrdlen)<<3; // Commented since r.14++++ because of passes.
	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen); WORDcount++;
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); WORDcount++; // Changed 2019-Nov-28

// Bug fix for all r.14+++ and below! [
//memcpy( &wrd[(LongestLineInclusive+1+4)-4], &NULLsForWRD, 4 );
//memcpy( &wrd[(LongestLineInclusive+1+4)-4-1], &NULLsForWRD, 1 );
// Bug fix for all r.14+++ and below! ]

// Example: HashInBITS-HashChunkSizeInBITS=2
//          HashInBITS = 5
//          HashChunkSizeInBITS = 3
//          RipPasses = 1<<(HashInBITS-HashChunkSizeInBITS) i.e. 1<<2 which is 4 i.e. 32 slots with 4 passes 8 slots each.
//          00??? 5bits 0-7
//          01??? 5bits 8-15
//          10??? 5bits 16-23
//          11??? 5bits 24-31
if ( (Slot>>HashChunkSizeInBITS_GLOBAL) == RipPasses ) {
	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );

// ########################################## B-tree order 3 fragment 64bit [
//
// LEAF structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord][RightWord]
//                  4bytes       4bytes         4bytes        wrdlen    wrdlen
//                                                            *         *          <- if *(char *)==0 means the word cell is empty
// ALL B-tree order 3 fragment consists of 3 sub-fragments:
// 1] Search 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search 3] Insert Iterative

// LEAF_64 structure: [LeftPointer][MiddlePointer][RightPointer][LeftWord]               [RightWord]
//                     8bytes       8bytes         8bytes        LongestLineInclusive+1+4 LongestLineInclusive+1+4
//                                                               *         *          <- if *(char *)==0 means the word cell is empty
// Note: In order to use one fread(and strcmp) a NULL postfix for LeftWord, RightWord i.e. LeftWord_Length=len(LeftWord)+1 a kinda stupid choice ...
// Note: BufEnd_64 in fact is the first free position after the BUFFER END!

// 1] Search [
                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
            //if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
            //          {
            //          memcpy( BufStart+Slot, &bufend[LetterOffset], 4 );
            //          bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
            //          memcpy( bufend[LetterOffset], wrd, wrdlen ); WORDcountDistinct++; bufNumberOfWords[LetterOffset]++;
            //          bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
            //          if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
            //          }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
                        memcpy( BufStart+Slot, &BufEnd_64, 8 );
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&BufEnd_64);
		       	//fwrite(wrd, wrdlen, 1, fp_outRG); //GRMBL! r.18
		       	fwrite(wrd, (KeySize+1+8), 1, fp_outRG); //GRMBL! r.18
			WORDcountDistinct++; Total_fwrite++;
		       	//fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// r.14++ The above line was commented because the pool is already ZEROed.
				} else { // ########## 64bit memory manipulations [
			//memcpy( (char *)BufEnd_64, wrd, wrdlen ); //GRMBL! r.18
			memcpy( (char *)BufEnd_64, wrd, (KeySize+1+8) ); //GRMBL! r.18
			WORDcountDistinct++; 
				} // ########## 64bit memory manipulations ]
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			//fsetpos(fp_outRG, &BufEnd_64);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
              fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
                      FoundInLinkedList = 1+1;
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
                        WORDcountAttemptsToPut++;
// ***** 'P W P' section ]
                      } // while
                        WORDcountAttemptsToPut--; // - 1 due to BST way of counting i.e. direct hash hit is not counted only successors
                    }
// 1] Search ]
if (FoundInLinkedList == 0) NotFoundKeys++; //r.18
if (FoundInLinkedList == 1) FoundKeys++; //r.18
if (FoundInLinkedList == 2) NotFoundKeys++; //r.18
			
if (FoundInLinkedList == 0)
{
/*
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= [
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search [
//    'TracingSearch' is the same as 'Search' except that adds the trail in my simulated stack,
//    the goal is not to waste time in 'Search' by dealing with no needed trail in case of not 'Insert'.
//    Simulated stack contains pairs of 'Address of ParentLEAF' + 'Offset of ParentPointer in ParentLEAF i.e. 0 for LP, 4 for MP, 8 for RP'.
//    'Offset ...' saves unnecessary comparisons of NEWword which after splitting goes up.
                    memcpy( &PseudoLinkedPointer, BufStart+Slot, 4 );
                StackPtr = 0;
                      while (PseudoLinkedPointer != 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                           { // RW existence check - line below:
                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                           { // No ?W after RW - go RP
                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
                           }
                        else FoundInLinkedList = 1; // wrd is RW
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 4; ++StackPtr; //LPoffset=0;MPoffset=4;RPoffset=8;
                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
                                }
                           }
                        else FoundInLinkedList = 1; // wrd is LW
// ***** 'P W P' section ]
                      } // while
// 2] if Search failed Trasirascht(pushing in stack PseudoLinkedPointer(visited LEAFs)) Search ]
// ======================= [ The whole section/sub-fragment 2 is commented due to great time differences for Internal_vs_External memory accesses - it is far more cheap to have the STACK overhead (moved to sub-fragment 1) ] ======================= ]
*/

// 3] Insert Iterative [
//    There are total 4 situations:
//    Case #1: Outer NODE(including ROOT) [  ][  ][  ][LW][  ]
//    Case #2: Outer NODE(including ROOT) [  ][  ][  ][LW][RW]  Split Occurs   -----  
//    Case #3: ROOT                       [LP][MP][  ][LW][  ]                     |  'wrdUP' (wrdlen bytes) 
//    Case #4: Inner NODE(including ROOT) [LP][MP][RP][LW][RW]  Split Occurs   --- |   &
//                                                                               | |  'PseudoLinkedPointerNEW' (ptr to NEW LEAF)
//    There are total 2 situations for PARENT LEAF: <-------------------------------  ARE GOING UP
//    Case #3: [LP][MP][  ][LW][  ]  
//    Case #4: [LP][MP][RP][LW][RW]  Split Occurs

// ~  First deal alonely with the OUTER NODE(LEAF) where Search stopped i.e Case #1 & Case #2:
        POffsetInLEAF = BSTstack[--StackPtr];
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
// NOTE: ONE LEAF IS FULL ONLY WHEN LAST CELL FOR KEY(here RW) EXISTS!
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #2
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1; WORDcountDistinct++; 
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrd < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );   // wrd go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrd < RW
         {
//                      memcpy( wrdUP, wrd, wrdlen );                       // wrd up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
                        memcpy( wrdUP, wrd, (KeySize+1+8) );     // wrd up
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// Here reordering (of writing wrdAUX) is needed to avoid seek the position NEW and stupidly to seek again OLD/current position!
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrdAUX[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdAUX[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrd > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrd, wrdlen );   // wrd go to NEW LEAF
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }
else // If LEAF is not full: Case #1
    { SplitOccured = 0; WORDcountDistinct++; 
      if (POffsetInLEAF == 0) // wrd < [LW][] so [LW][] -> [][LW] -> [wrd][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrd[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+

         }
      if (POffsetInLEAF == 8) // wrd > [LW][] so [LW][] -> [LW][wrd]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrd, wrdlen );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
			  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (KeySize+1+8);
				if (BSTorBtree == 2) {
			  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  fwrite(&wrd[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrd[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one! Here NO need!
         }
    }

if (SplitOccured != 0)
{
// ~  Second deal with the INNER NODE(S) i.e Case #3 & Case #4:
        while (StackPtr != 0 || SplitOccured != 0)
              {
        // 'PseudoLinkedPointerNEW' is new LEAF to be inserted
        // 'wrdUP' is NEW word to be inserted
        if (StackPtr != 0)
        {
           POffsetInLEAF = BSTstack[--StackPtr];
           PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // If LEAF is full: Case #4
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
    { SplitOccured = 1;
//                      memcpy( wrdUPold, wrdUP, wrdlen ); // LW up
//                      PseudoLinkedPointerNEWold = PseudoLinkedPointerNEW;
                        memcpy( wrdUPold, wrdUP, (KeySize+1+8) );
                        PseudoLinkedPointerNEWold_64 = PseudoLinkedPointerNEW_64;
            // ALlocate NEW LEAF:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerNEW, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerNEW_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			// [  //r.14+
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&LEAFNEW[0], 8+8+8+2*(LongestLineInclusive+1+4), 1, fp_outRG);
			// In fact above three lines are slow, the only need is ZEROed LEAFNEW.
			memset(&LEAFNEW[0],0,8+8+8+2*(KeySize+1+8));
			// ]  //r.14+
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
//	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
      if (POffsetInLEAF == 0) // wrdUPold < LW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4, wrdlen ); // LW up
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP](PseudoLinkedPointerNEWold)[MP][RP](wrdUPold)[LW][RW]       ------
//                      //              pair [LW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:                         PseudoLinkedPointerNEW: |
//                      // [LP](PseudoLinkedPointerNEWold)[](wrdUPold)  [MP][RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // LW < wrdUPold < RW
         {
//                      memcpy( wrdUP, wrdUPold, wrdlen );                       // wrdUPold up
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW go to NEW LEAF
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      // [LP][MP](PseudoLinkedPointerNEWold)[RP][LW](wrdUPold)[RW]       ------
//                      //              pair [wrdUPold] PseudoLinkedPointerNEW goes up          |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        (PseudoLinkedPointerNEWold)[RP][][RW]      <----
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, &PseudoLinkedPointerNEWold, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, PseudoLinkedPointer+8, 4 );  
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                        memcpy( wrdUP, wrdUPold, (KeySize+1+8) );
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	   //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerNEWold_64, 8 );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerAUXdumbo_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 16) // wrdUPold > RW
         {
//                      memcpy( wrdUP, PseudoLinkedPointer+4+4+4+wrdlen, wrdlen ); // RW up
//                      *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) = 0;    // RW mark unused in OLD LEAF
//                      memcpy( PseudoLinkedPointerNEW+4+4+4, wrdUPold, wrdlen );   // wrdUPold go to NEW LEAF
//                      // [LP][MP][RP](PseudoLinkedPointerNEWold)[LW][RW](wrdUPold)       ------
//                      //              pair [RW] PseudoLinkedPointerNEW goes up                |
//                      // PseudoLinkedPointer:  PseudoLinkedPointerNEW:                        |
//                      // [LP][MP][][LW]        [RP](PseudoLinkedPointerNEWold)[](wrdUPold) <---
//                      // no need to put zero in RP because logic is based on words existence:
//                      memcpy( PseudoLinkedPointerNEW+0, PseudoLinkedPointer+8, 4 );  
//                      memcpy( PseudoLinkedPointerNEW+4, &PseudoLinkedPointerNEWold, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	 //fwrite(&OneChar_ieByte, 1, 1, fp_outRG); // Write ZERO ASCII code
			  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8 + 8 + 8;
			  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			  //fwrite(&wrdUPold[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 0;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEWold_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdUP[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &OneChar_ieByte, 1 );
		  	memcpy( &LEAFNEW[8 + 8 + 8], &wrdUPold[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[16], 8 );
		  	memcpy( &LEAFNEW[0], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAFNEW[8], &PseudoLinkedPointerNEWold_64, 8 );
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerNEW_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAFNEW[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAFNEW[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
    }
else // If LEAF is not full: Case #3
    { SplitOccured = 0; 
      if (POffsetInLEAF == 0) // wrdUP < [LW][] so [LW][] -> [][LW] -> [wrdUP][LW]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, PseudoLinkedPointer+4+4+4, wrdlen );
//                      memcpy( PseudoLinkedPointer+4+4+4, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][][MP] -> [LP][np][MP]
//                      memcpy( PseudoLinkedPointer+8, PseudoLinkedPointer+4, 4 );  
//                      memcpy( PseudoLinkedPointer+4, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdAUX[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&PseudoLinkedPointerAUXdumbo_64, 8, 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrdAUX[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdAUX[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8 + 8], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &PseudoLinkedPointerAUXdumbo_64, &LEAF[8], 8 );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerAUXdumbo_64, 8 );
		  	memcpy( &LEAF[8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
      if (POffsetInLEAF == 8) // wrdUP > [LW][] so [LW][] -> [LW][wrdUP]
         {
//                      memcpy( PseudoLinkedPointer+4+4+4+wrdlen, wrdUP, wrdlen );
//                              // [LP][MP][] -> [LP][MP][np]
//                      memcpy( PseudoLinkedPointer+8, &PseudoLinkedPointerNEW, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fwrite(&wrdUP[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 16;
			 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			 //fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &wrdUP[0], (KeySize+1+8) );
		  	memcpy( &LEAF[8 + 8], &PseudoLinkedPointerNEW_64, 8 );
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
         }
           break; 
    }
        }
        else // Empty stack means ROOT and more over ROOT is already splitted(Case #4 is off)
        {
     // If LEAF is not full: Case #3
     // THIS IS WHERE A NEW(SECOND) LEAF 'PseudoLinkedPointerROOT' must be allocated:
//            if( (unsigned long)(bufend[LetterOffset] - BufStart) + 2*wrdlen + 4 + 4 + 4 < GRMBLFoolAgain[(int)wrdlen] ) // +4 more for BST instead of LL; + more(see LEAF)
//                      {
//                      memcpy( &PseudoLinkedPointerROOT, &bufend[LetterOffset], 4 );
//                      bufend[LetterOffset] = bufend[LetterOffset] + 4 + 4 + 4; // + 4 due to above commenting
//                      memcpy( bufend[LetterOffset], wrdUP, wrdlen ); 
//                      bufend[LetterOffset] = bufend[LetterOffset] + 2*wrdlen;
//                      if (MAXusedBuffer[wrdlen] < (unsigned long)(bufend[LetterOffset] - BufStart)) {MAXusedBuffer[wrdlen] = (unsigned long)(bufend[LetterOffset] - BufStart);}
//                      }
				// BUG IN R.17 and prior - the next 'if' is only for RAM (y/Y) not for SSD (z/Z):
				if (BSTorBtree == 2) { //r.18
	BUGGYoffset = (BufEnd_64-(0+14));
				} else { // ########## 64bit memory manipulations [
	BUGGYoffset = (BufEnd_64-(unsigned long long)pointerflush_64);
				} // ########## 64bit memory manipulations ]
            if( 8 + 8 + 8 + 2*(KeySize+1+8) < size_in64_L14 - BUGGYoffset ) // the longest wrdlen is LongestLineInclusive but actual is LongestLineInclusive(+ CR char)
                      {
			PseudoLinkedPointerROOT_64 = BufEnd_64;
			BufEnd_64 = BufEnd_64 + 8 + 8 + 8;
			BufEnd_64 = BufEnd_64 + 2*(KeySize+1+8);
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8 + 8 + 8;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fwrite(&wrdUP[0], (KeySize+1+8), 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &wrdUP[0], (KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
                      }
            else
            { printf( "\nLeprechaun: Failure! Increment 'Memory for B-trees'!\n" );
	      fprintf( fp_outLOG, "Word count: %s of them %s distinct\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma((unsigned long long)WORDcountDistinct, llTOaDigits2, 10) );
	      fprintf( fp_outLOG, "Allocated memory: %s bytes\n", _ui64toaKAZEcomma(size_in64_L14, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	      fprintf( fp_outLOG, "Used value for third parameter in KB: %lu\n", (unsigned long)Thunderwith );
	      fprintf( fp_outLOG, "Leprechaun: Failure! Increment 'Memory for B-trees'!\n\n");
              exit( 7 );
            }
            // Here                    --  'PseudoLinkedPointerROOT' --
            //                         |           (wrdUP)            |
            // 'PseudoLinkedPointer' <--                              --> 'PseudoLinkedPointerNEW'
            //         (LW)                                                          (RW)
//            memcpy( PseudoLinkedPointerROOT, &PseudoLinkedPointer, 4 );      // LP
//            memcpy( PseudoLinkedPointerROOT+4, &PseudoLinkedPointerNEW, 4 ); // MP
//            // Here must NEW ROOT be updated i.e. HASH table(SLOT) must point it:
//            memcpy( BufStart+Slot, &PseudoLinkedPointerROOT, 4 );
	      PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64;
				if (BSTorBtree == 2) {
	      fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	      fwrite(&PseudoLinkedPointer_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointer_64, 8 );
				} // ########## 64bit memory manipulations ]
	       PseudoLinkedPointerAUX_64 = PseudoLinkedPointerROOT_64 + 8;
				if (BSTorBtree == 2) {
	       fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
	       fwrite(&PseudoLinkedPointerNEW_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &PseudoLinkedPointerNEW_64, 8 );
				} // ########## 64bit memory manipulations ]
		memcpy( BufStart+Slot, &PseudoLinkedPointerROOT_64, 8 );
           break; //because it is ROOT without split
        }
              } // while
} //if (SplitOccured != 0)
// 3] Insert Iterative ]
} //if (FoundInLinkedList == 0)
// ########################################## B-tree order 3 64bit ]
} //if ( (Slot>>HashChunkSizeInBITS) == RipPasses ) {
	} //for (BuildingBlocksSTRIDE=0; 

 RipPasses++;
 if (RipPasses <= (1<<(HashInBITS_GLOBAL-HashChunkSizeInBITS_GLOBAL))-1) goto WhyTheHellForIsNotWorking;
//} // for( RipPasses = 1-1; RipPasses <= (1<<(HashInBITS-HashChunkSizeInBITS))-1; RipPasses++ )

// Counting trees [
NumberOfTrees=0;
AllSlots=0;

	for( j = 0; j < MatchLensNUM; j++ ) //r.18
	{
	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 
                      Slot = (AllSlots)<<3; AllSlots++;
                      memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );
                      if (PseudoLinkedPointer_64 != 0) NumberOfTrees++;
	}
	}
// Counting trees ]

	printf( "DONE; %s B-trees have been rooted so far.\n", _ui64toaKAZEzerocomma(NumberOfTrees, llTOaDigits, 10)+(26-14));
} //for (jj=0; 
	printf( "\n");

goto SkipDestroyingTheTrees;
// Stats... [

	time2=time(NULL); //fix of bigtime
	NumberOfTrees=0;
	NumberOfLEAFs=0;
	LevelsInCorona_Not_Counting_ROOT=0;
// DUMP and STATS [[[
WORDcountBOTTOM = 0;
// The dump file with ripped data [
//if( ( fp_out = fopen( argv[2], "ab+" ) ) == NULL )
//{ printf( "Leprechaun: Can't create file %s \n", argv[2] ); exit( 7 ); }
// The dump file with ripped data ]
CRdLFa[0] = 13; CRdLFa[1] = 10;
AllSlots=0;

	BufStart = pointerflush;
//	for( j = 0; j < 28*28*28*28*28; j++ )
	//for( j = 0; j < (1<<HashInBITS); j++ )
	for( j = 0; j < MatchLensNUM; j++ ) //r.18
	{
//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = (MatchLens[j]<<1); //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	for( jjj = 0; jjj < ( ((1LL)<<HashInBITS_GLOBAL) ); jjj++ ) //r.18
	{ 
	WORDcountBOTTOMPerMatchLen=0; //r.18
                      Slot = (AllSlots)<<3; AllSlots++;
                      memcpy( &PseudoLinkedPointer_64, BufStart+Slot, 8 );
                      if (PseudoLinkedPointer_64 != 0)
                      {
	NumberOfTrees++;

// CAUTION: Did forget that dumping/traversing the B-trees - DESTROYS them! On purpose, pointers are zeroed.
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit [
     // DONE JOB:
     // Must be written B-tree traverse ! with simulated stack i.e. non-recursive.
     // ...
  StackPtr = 0;
  while ( 2==2 ) {
        while (PseudoLinkedPointer_64 != 0)
              { 
                if (StackPtr > 8192*3-1) { printf( "\nLeprechaun: Failure! B-tree simulated stack overflow, too high B-tree!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //ptr to Rwrd
//if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) == 0 ) {memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );}
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		if (SomeByte == 0 ) // RW exists not
		 {
		  PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
				if (BSTorBtree == 2) {
		  fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8], &NULLs_64, 8 );
			// ]  //r.14+
		 }
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
// Give first from right to left non-zero PTR
                if (PseudoLinkedPointerNEWright_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4 + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWright;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWright_64;
                }
                else if (PseudoLinkedPointerNEWmiddle_64 !=0 )
//                { memcpy( PseudoLinkedPointer + 4, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWmiddle;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWmiddle_64;
                }
                else if (PseudoLinkedPointerNEWleft_64 !=0 )
//                { memcpy( PseudoLinkedPointer, &BufStart[NumberOfSLOTs*4], 4 );
//                  PseudoLinkedPointer = PseudoLinkedPointerNEWleft;
//                }
                {
		PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
		fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		fwrite(&NULLs_64, 8, 1, fp_outRG); Total_fwrite++;
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &NULLs_64, 8 );
				} // ########## 64bit memory manipulations ]
		 PseudoLinkedPointer_64 = PseudoLinkedPointerNEWleft_64;
                }
                else
                {
                  PseudoLinkedPointer_64 = 0;
                }
              }
	    if (LevelsInCorona_Not_Counting_ROOT < StackPtr) LevelsInCorona_Not_Counting_ROOT = StackPtr; //r.14
        if (StackPtr == 0) break;
        PseudoLinkedPointer_64 = BSTstack[--StackPtr];
//                memcpy( &PseudoLinkedPointerNEWleft, PseudoLinkedPointer, 4 );
//                memcpy( &PseudoLinkedPointerNEWmiddle, PseudoLinkedPointer + 4, 4 );
//                memcpy( &PseudoLinkedPointerNEWright, PseudoLinkedPointer + 4 + 4, 4 );
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		  //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
		  //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		  //fread(&PseudoLinkedPointerNEWleft_64, 8, 1, fp_outRG);
		   //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8;
		   //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		   //fread(&PseudoLinkedPointerNEWmiddle_64, 8, 1, fp_outRG);
		    //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8;
		    //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		    //fread(&PseudoLinkedPointerNEWright_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); Total_fread++;
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &PseudoLinkedPointerNEWleft_64, &LEAF[0], 8 );
		  	memcpy( &PseudoLinkedPointerNEWmiddle_64, &LEAF[8], 8 );
		  	memcpy( &PseudoLinkedPointerNEWright_64, &LEAF[8+8], 8 );
			// ]  //r.14+
        if (PseudoLinkedPointerNEWleft_64 + PseudoLinkedPointerNEWmiddle_64 + PseudoLinkedPointerNEWright_64 == 0) // One LEAF is PRINTED when LP=0 MP=0 RP=0
           { 
//        memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4, i%31+1 );
//        fwrite(wrd, i%31+1, 1, fp_out);
//        fwrite(CRdLFa, 2, 1, fp_out); 
//        if ( *(char *)(PseudoLinkedPointer + 4 + 4 + 4 + i%31+1) != 0 )
//             { memcpy( wrd, PseudoLinkedPointer + 4 + 4 + 4 + i%31+1, i%31+1 );
//               fwrite(wrd, i%31+1, 1, fp_out);
//               fwrite(CRdLFa, 2, 1, fp_out); 
//             }
//        PseudoLinkedPointer = 0;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
		//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		//fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			// Counter ]
                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//	        fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                WORDcountBOTTOM++;
//	        fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	//fwrite(CRdLFa, 2, 1, fp_out); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		 //fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
		 if (SomeByte != 0 ) // RW exists
		 {
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
		 //PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
		 //fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		 //fread(&wrd[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &wrd[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			// Counter [
			//memcpy( &CounterOccurrencies, &wrd[(KeySize+1+4)-4], 4 );
			//if (CounterOccurrencies<999999999) CounterOccurrencies++; // Starting from ZERO! Because when insertion happened there was no setting counter to 1.
			// Counter ]
                                                WORDcountBOTTOM++; //Nakamichi
						WORDcountBOTTOMPerMatchLen++;
if (*argv[k_FIX] == 'Y' || *argv[k_FIX] == 'Z') 
	//if (CounterOccurrencies>1) // For Nakamichi
//   	         fprintf(fp_out, "%s\t%s\r\n", _ui64toaKAZEzerocomma(CounterOccurrencies, llTOaDigits2, 10)+(26-11), wrd); WORDcountBOTTOM++;
if (*argv[k_FIX] == 'y' || *argv[k_FIX] == 'z') 
// NO-DUMP: [
                                                 WORDcountBOTTOM++;
//   	         fprintf(fp_out, "%s\r\n", wrd); WORDcountBOTTOM++;
// NO-DUMP: ]
        	 //fwrite(CRdLFa, 2, 1, fp_out); 
		 }
		  PseudoLinkedPointer_64 = 0;
	    NumberOfLEAFs++; //r.14
           }
  }                                          
// $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ B-tree order 3 traverse 64bit ]

                      } //if (PseudoLinkedPointer_64 != 0)
	// Stats for one tree only:
	//printf( "\nLeprechaun: Total keys (j=%d) into B-trees order 3 (during traversal/dump): %s\n", j,_ui64toaKAZEcomma(WORDcountBOTTOMPerMatchLen, llTOaDigits, 10) );

	} //for( jjj = 0; 
	} //for( j = 0; 

// The dump file with ripped data [
//fclose(fp_out);
// The dump file with ripped data ]

	fprintf( fp_outLOG, "Number Of Hash Collisions(Distinct WORDs - Number Of Trees): %s\n", _ui64toaKAZEcomma(WORDcountDistinct - NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Number Of Trees(GREATER THE BETTER): %s\n", _ui64toaKAZEcomma(NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: %s\n", _ui64toaKAZEcomma(NumberOfLEAFs-NumberOfTrees, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): %s\n", _ui64toaKAZEcomma(LevelsInCorona_Not_Counting_ROOT-1, llTOaDigits, 10) );

	fprintf( fp_outLOG, "Used value for third parameter in KB: %s\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Use next time as third parameter: %s\n", _ui64toaKAZEcomma((((BufEnd_64-(unsigned long long)pointerflush_64)+1)>>10)+1, llTOaDigits, 10) );
	fprintf( fp_outLOG, "Total Attempts to Find/Put WORDs into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );

// DUMP and STATS ]]]

	printf( "\n");
	printf( "Leprechaun: Number Of Total/Distinct/Undistinct keys/BBs (all orders): %s/%s/%s\n", _ui64toaKAZEcomma(WORDcount, llTOaDigits, 10), _ui64toaKAZEcomma(WORDcountDistinct, llTOaDigits2, 10), _ui64toaKAZEcomma(WORDcount-WORDcountDistinct, llTOaDigits3, 10) );
	printf( "Leprechaun: Number Of TREEs(GREATER THE BETTER): %s\n", _ui64toaKAZEcomma(NumberOfTrees, llTOaDigits, 10) );
	printf( "Leprechaun: Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: %s\n", _ui64toaKAZEcomma(NumberOfLEAFs-NumberOfTrees, llTOaDigits, 10) );
	printf( "Leprechaun: Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): %s\n", _ui64toaKAZEcomma(LevelsInCorona_Not_Counting_ROOT-1, llTOaDigits, 10) );
	printf( "Leprechaun: Used value for B-trees pool in KB: %s\n", _ui64toaKAZEcomma(Thunderwith, llTOaDigits, 10) );
	printf( "Leprechaun: Use next time for B-trees pool in KB: %s\n", _ui64toaKAZEcomma((((BufEnd_64-(unsigned long long)pointerflush_64)+1)>>10)+1, llTOaDigits, 10) );
//	printf( "Leprechaun: Total Attempts to Find/Put keys into B-trees order 3: %s\n", _ui64toaKAZEcomma(WORDcountAttemptsToPut, llTOaDigits, 10) );
	printf( "Leprechaun: Total keys (all orders) into B-trees order 3 (during traversal/dump): %s\n", _ui64toaKAZEcomma(WORDcountBOTTOM, llTOaDigits, 10) );
	printf( "Leprechaun: Total keys MISSES/HITS (all orders) into B-trees order 3: %s/%s\n", _ui64toaKAZEcomma(NotFoundKeys, llTOaDigits, 10), _ui64toaKAZEcomma(FoundKeys, llTOaDigits2, 10) );
	printf( "\n");
// Stats... ]

	printf( "Leprechaun: B-trees building speed (counting ROOT LEAFs): %s LEAFs/s\n", _ui64toaKAZEcomma((double)(NumberOfLEAFs)/(double)(time2 - time1 + 1), llTOaDigits3, 10));
	printf( "Leprechaun: B-trees traverse speed (counting ROOT LEAFs): %s LEAFs/s\n", _ui64toaKAZEcomma((double)(NumberOfLEAFs)/(double)(time(NULL) - time2 + 1), llTOaDigits3, 10));
SkipDestroyingTheTrees:
	printf( "Leprechaun: Total Searches-n-Inserts Per Second: %s SNIPS\n", _ui64toaKAZEcomma((double)(WORDcount)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10));
	printf( "Leprechaun: RAM needed to house B-trees (relative to the file being ripped): %sN = %sMB\n", _ui64toaKAZEcomma((BufEnd_64-(unsigned long long)pointerflush_64+1)/size_inLINESIXFOUR, llTOaDigits3, 10), _ui64toaKAZEcomma(1+((BufEnd_64-(unsigned long long)pointerflush_64+1)>>20), llTOaDigits2, 10));
//#if defined(ExternalRAM)
if (BSTorBtree == 2) {
	printf( "Leprechaun: Total IOPS for %s 'freads' and %s 'fwrites' (of packets %d bytes long) during loading traversing all orders: %s IOPS\n", _ui64toaKAZEcomma(Total_fread, llTOaDigits, 10), _ui64toaKAZEcomma(Total_fwrite, llTOaDigits2, 10), 8+8+8+2*(LongestLineInclusive+1+8), _ui64toaKAZEcomma((double)(Total_fwrite+Total_fread)/(double)(time(NULL) - time1 + 1), llTOaDigits3, 10));
}
//#endif
	printf( "\n");

//exit(0);

} // b_tree]

// Leprechaun BBhex ]


// https://github.com/XKCP/XKCP/blob/master/Standalone/CompactFIPS202/C/Keccak-more-compact.c
/*
#define FOR(i,n) for(i=0; i<n; ++i)
typedef unsigned char u8;
typedef unsigned long long int u64;
typedef unsigned int ui;

void Keccak(ui r, ui c, const u8 *in, u64 inLen, u8 sfx, u8 *out, u64 outLen);
void FIPS202_SHAKE128(const u8 *in, u64 inLen, u8 *out, u64 outLen) { Keccak(1344, 256, in, inLen, 0x1F, out, outLen); }
void FIPS202_SHAKE256(const u8 *in, u64 inLen, u8 *out, u64 outLen) { Keccak(1088, 512, in, inLen, 0x1F, out, outLen); }
void FIPS202_SHA3_224(const u8 *in, u64 inLen, u8 *out) { Keccak(1152, 448, in, inLen, 0x06, out, 28); }
void FIPS202_SHA3_256(const u8 *in, u64 inLen, u8 *out) { Keccak(1088, 512, in, inLen, 0x06, out, 32); }
void FIPS202_SHA3_384(const u8 *in, u64 inLen, u8 *out) { Keccak(832, 768, in, inLen, 0x06, out, 48); }
void FIPS202_SHA3_512(const u8 *in, u64 inLen, u8 *out) { Keccak(576, 1024, in, inLen, 0x06, out, 64); }

int LFSR86540(u8 *R) { (*R)=((*R)<<1)^(((*R)&0x80)?0x71:0); return ((*R)&2)>>1; }
#define ROL(a,o) ((((u64)a)<<o)^(((u64)a)>>(64-o)))
static u64 load64(const u8 *x) { ui i; u64 u=0; FOR(i,8) { u<<=8; u|=x[7-i]; } return u; }
static void store64(u8 *x, u64 u) { ui i; FOR(i,8) { x[i]=u; u>>=8; } }
static void xor64(u8 *x, u64 u) { ui i; FOR(i,8) { x[i]^=u; u>>=8; } }
#define rL(x,y) load64((u8*)s+8*(x+5*y))
#define wL(x,y,l) store64((u8*)s+8*(x+5*y),l)
#define XL(x,y,l) xor64((u8*)s+8*(x+5*y),l)
void KeccakF1600(void *s)
{
    ui r,x,y,i,j,Y; u8 R=0x01; u64 C[5],D;
    for(i=0; i<24; i++) {
        FOR(x,5) C[x]=rL(x,0)^rL(x,1)^rL(x,2)^rL(x,3)^rL(x,4); FOR(x,5) { D=C[(x+4)%5]^ROL(C[(x+1)%5],1); FOR(y,5) XL(x,y,D); }
        x=1; y=r=0; D=rL(x,y); FOR(j,24) { r+=j+1; Y=(2*x+3*y)%5; x=y; y=Y; C[0]=rL(x,y); wL(x,y,ROL(D,r%64)); D=C[0]; }
        FOR(y,5) { FOR(x,5) C[x]=rL(x,y); FOR(x,5) wL(x,y,C[x]^((~C[(x+1)%5])&C[(x+2)%5])); }
        FOR(j,7) if (LFSR86540(&R)) XL(0,0,(u64)1<<((1<<j)-1));
    }
}
void Keccak(ui r, ui c, const u8 *in, u64 inLen, u8 sfx, u8 *out, u64 outLen)
{
    u8 s[200]; ui R=r/8; ui i,b=0; FOR(i,200) s[i]=0;
    while(inLen>0) { b=(inLen<R)?inLen:R; FOR(i,b) s[i]^=in[i]; in+=b; inLen-=b; if (b==R) { KeccakF1600(s); b=0; } }
    s[b]^=sfx; if((sfx&0x80)&&(b==(R-1))) KeccakF1600(s); s[R-1]^=0x80; KeccakF1600(s);
    while(outLen>0) { b=(outLen<R)?outLen:R; FOR(i,b) out[i]=s[i]; out+=b; outLen-=b; if(outLen>0) KeccakF1600(s); }
}
*/

// SHA3 [[[

 /*
 Implementation by the Keccak, Keyak and Ketje Teams, namely, Guido Bertoni,
 Joan Daemen, Michaël Peeters, Gilles Van Assche and Ronny Van Keer, hereby
 denoted as "the implementer".
 
 For more information, feedback or questions, please refer to our websites:
 http://keccak.noekeon.org/
 http://keyak.noekeon.org/
 http://ketje.noekeon.org/
 
 To the extent possible under law, the implementer has waived all copyright
 and related or neighboring rights to the source code in this file.
 http://creativecommons.org/publicdomain/zero/1.0/
 */
 
 /*
 ================================================================
 The purpose of this source file is to demonstrate a readable and compact
 implementation of all the Keccak instances approved in the FIPS 202 standard,
 including the hash functions and the extendable-output functions (XOFs).
 
 We focused on clarity and on source-code compactness,
 rather than on the performance.
 
 The advantages of this implementation are:
     + The source code is compact, after removing the comments, that is. :-)
     + There are no tables with arbitrary constants.
     + For clarity, the comments link the operations to the specifications using
         the same notation as much as possible.
     + There is no restriction in cryptographic features. In particular,
         the SHAKE128 and SHAKE256 XOFs can produce any output length.
     + The code does not use much RAM, as all operations are done in place.
 
 The drawbacks of this implementation are:
     - There is no message queue. The whole message must be ready in a buffer.
     - It is not optimized for peformance.
 
 The implementation is even simpler on a little endian platform. Just define the
 LITTLE_ENDIAN symbol in that case.
 
 For a more complete set of implementations, please refer to
 the Keccak Code Package at https://github.com/gvanas/KeccakCodePackage
 
 For more information, please refer to:
     * [Keccak Reference] http://keccak.noekeon.org/Keccak-reference-3.0.pdf
     * [Keccak Specifications Summary] http://keccak.noekeon.org/specs_summary.html
 
 This file uses UTF-8 encoding, as some comments use Greek letters.
 ================================================================
 */
 
 //void Keccak(unsigned int rate, unsigned int capacity, const unsigned char *input, unsigned long long int inputByteLen, unsigned char delimitedSuffix, unsigned char *output, unsigned long long int outputByteLen);
 
//#include "sha3.h"
// sha3.h [
#define SHA3_256_DIGEST_LEN 32
#define SHA3_512_DIGEST_LEN 64
#define SHA3_256_BLOCK_LEN 136
#define SHA3_512_BLOCK_LEN 72
#define SHA3_256_B64_LEN      43
#define SHA3_512_B64_LEN      86
#define SHA3_256_DIGEST_STR_LEN   (SHA3_256_DIGEST_LEN * 2 + 1)
#define SHA3_512_DIGEST_STR_LEN   (SHA3_512_DIGEST_LEN * 2 + 1)
void Keccak(unsigned int rate, unsigned int capacity, const unsigned char *input, unsigned long long int inputByteLen, unsigned char delimitedSuffix, unsigned char *output, unsigned long long int outputByteLen);
void FIPS202_SHAKE128(const unsigned char *input, unsigned int inputByteLen, unsigned char *output, int outputByteLen);
void FIPS202_SHAKE256(const unsigned char *input, unsigned int inputByteLen, unsigned char *output, int outputByteLen);
void FIPS202_SHA3_224(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);
void FIPS202_SHA3_256(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);
void FIPS202_SHA3_384(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);
void FIPS202_SHA3_512(const unsigned char *input, unsigned int inputByteLen, unsigned char *output);
// sha3.h ]

 void FIPS202_SHAKE128(const unsigned char *input, unsigned int inputByteLen, unsigned char *output, int outputByteLen)
 {
     Keccak(1344, 256, input, inputByteLen, 0x1F, output, outputByteLen);
 }
 
 void FIPS202_SHAKE256(const unsigned char *input, unsigned int inputByteLen, unsigned char *output, int outputByteLen)
 {
     Keccak(1088, 512, input, inputByteLen, 0x1F, output, outputByteLen);
 }
 
 void FIPS202_SHA3_224(const unsigned char *input, unsigned int inputByteLen, unsigned char *output)
 {
     Keccak(1152, 448, input, inputByteLen, 0x06, output, 28);
 }
 
 void FIPS202_SHA3_256(const unsigned char *input, unsigned int inputByteLen, unsigned char *output)
 {
     Keccak(1088, 512, input, inputByteLen, 0x06, output, 32);
 }
 
 void FIPS202_SHA3_384(const unsigned char *input, unsigned int inputByteLen, unsigned char *output)
 {
     Keccak(832, 768, input, inputByteLen, 0x06, output, 48);
 }
 
 void FIPS202_SHA3_512(const unsigned char *input, unsigned int inputByteLen, unsigned char *output)
 {
     Keccak(576, 1024, input, inputByteLen, 0x06, output, 64);
 }
 
 /*
 ================================================================
 Technicalities
 ================================================================
 */
 
 typedef unsigned char UINT8;
 typedef unsigned long long int UINT64;
 typedef UINT64 tKeccakLane;
 
 #ifndef LITTLE_ENDIAN
 
 static UINT64 load64(const UINT8 *x)
 {
     int i;
     UINT64 u=0;
 
     for(i=7; i>=0; --i) {
         u <<= 8;
         u |= x[i];
     }
     return u;
 }
 
 static void store64(UINT8 *x, UINT64 u)
 {
     unsigned int i;
 
     for(i=0; i<8; ++i) {
         x[i] = u;
         u >>= 8;
     }
 }
 
 static void xor64(UINT8 *x, UINT64 u)
 {
     unsigned int i;
 
     for(i=0; i<8; ++i) {
         x[i] ^= u;
         u >>= 8;
     }
 }
 #endif
 
 /*
 ================================================================
 A readable and compact implementation of the Keccak-f[1600] permutation.
 ================================================================
 */
 
 #define ROL64(a, offset) ((((UINT64)a) << offset) ^ (((UINT64)a) >> (64-offset)))
 #define i(x, y) ((x)+5*(y))
 
 #ifdef LITTLE_ENDIAN
     #define readLane(x, y)          (((tKeccakLane*)state)[i(x, y)])
     #define writeLane(x, y, lane)   (((tKeccakLane*)state)[i(x, y)]) = (lane)
     #define XORLane(x, y, lane)     (((tKeccakLane*)state)[i(x, y)]) ^= (lane)
 #else
     #define readLane(x, y)          load64((UINT8*)state+sizeof(tKeccakLane)*i(x, y))
     #define writeLane(x, y, lane)   store64((UINT8*)state+sizeof(tKeccakLane)*i(x, y), lane)
     #define XORLane(x, y, lane)     xor64((UINT8*)state+sizeof(tKeccakLane)*i(x, y), lane)
 #endif
 
 int LFSR86540(UINT8 *LFSR)
 {
     int result = ((*LFSR) & 0x01) != 0;
     if (((*LFSR) & 0x80) != 0)
         // Primitive polynomial over GF(2): x^8+x^6+x^5+x^4+1
         (*LFSR) = ((*LFSR) << 1) ^ 0x71;
     else
         (*LFSR) <<= 1;
     return result;
 }
 
 void KeccakF1600_StatePermute(void *state)
 {
     unsigned int round, x, y, j, t;
     UINT8 LFSRstate = 0x01;
 
     for(round=0; round<24; round++) {
         {   // === θ step (see [Keccak Reference, Section 2.3.2]) ===
             tKeccakLane C[5], D;
 
             // Compute the parity of the columns
             for(x=0; x<5; x++)
                 C[x] = readLane(x, 0) ^ readLane(x, 1) ^ readLane(x, 2) ^ readLane(x, 3) ^ readLane(x, 4);
             for(x=0; x<5; x++) {
                 // Compute the θ effect for a given column
                 D = C[(x+4)%5] ^ ROL64(C[(x+1)%5], 1);
                 // Add the θ effect to the whole column
                 for (y=0; y<5; y++)
                     XORLane(x, y, D);
             }
         }
 
         {   // === ρ and π steps (see [Keccak Reference, Sections 2.3.3 and 2.3.4]) ===
             tKeccakLane current, temp;
             // Start at coordinates (1 0)
             x = 1; y = 0;
             current = readLane(x, y);
             // Iterate over ((0 1)(2 3))^t * (1 0) for 0 ≤ t ≤ 23
             for(t=0; t<24; t++) {
                 // Compute the rotation constant r = (t+1)(t+2)/2
                 unsigned int r = ((t+1)*(t+2)/2)%64;
                 // Compute ((0 1)(2 3)) * (x y)
                 unsigned int Y = (2*x+3*y)%5; x = y; y = Y;
                 // Swap current and state(x,y), and rotate
                 temp = readLane(x, y);
                 writeLane(x, y, ROL64(current, r));
                 current = temp;
             }
         }
 
         {   // === χ step (see [Keccak Reference, Section 2.3.1]) ===
             tKeccakLane temp[5];
             for(y=0; y<5; y++) {
                 // Take a copy of the plane
                 for(x=0; x<5; x++)
                     temp[x] = readLane(x, y);
                 // Compute χ on the plane
                 for(x=0; x<5; x++)
                     writeLane(x, y, temp[x] ^((~temp[(x+1)%5]) & temp[(x+2)%5]));
             }
         }
 
         {   // === ι step (see [Keccak Reference, Section 2.3.5]) ===
             for(j=0; j<7; j++) {
                 unsigned int bitPosition = (1<<j)-1; //2^j-1
                 if (LFSR86540(&LFSRstate))
                     XORLane(0, 0, (tKeccakLane)1<<bitPosition);
             }
         }
     }
 }
 
 /*
 ================================================================
 A readable and compact implementation of the Keccak sponge functions
 that use the Keccak-f[1600] permutation.
 ================================================================
 */
 
 #include <string.h>
 #define MIN(a, b) ((a) < (b) ? (a) : (b))
 
 void Keccak(unsigned int rate, unsigned int capacity, const unsigned char *input, unsigned long long int inputByteLen, unsigned char delimitedSuffix, unsigned char *output, unsigned long long int outputByteLen)
 {
     UINT8 state[200];
     unsigned int rateInBytes = rate/8;
     unsigned int blockSize = 0;
     unsigned int i;
 
     if (((rate + capacity) != 1600) || ((rate % 8) != 0))
         return;
 
     // === Initialize the state ===
     memset(state, 0, sizeof(state));
 
     // === Absorb all the input blocks ===
     while(inputByteLen > 0) {
         blockSize = MIN(inputByteLen, rateInBytes);
         for(i=0; i<blockSize; i++)
             state[i] ^= input[i];
         input += blockSize;
         inputByteLen -= blockSize;
 
         if (blockSize == rateInBytes) {
             KeccakF1600_StatePermute(state);
             blockSize = 0;
         }
     }
 
     // === Do the padding and switch to the squeezing phase ===
     // Absorb the last few bits and add the first bit of padding (which coincides with the delimiter in delimitedSuffix)
     state[blockSize] ^= delimitedSuffix;
     // If the first bit of padding is at position rate-1, we need a whole new block for the second bit of padding
     if (((delimitedSuffix & 0x80) != 0) && (blockSize == (rateInBytes-1)))
         KeccakF1600_StatePermute(state);
     // Add the second bit of padding
     state[rateInBytes-1] ^= 0x80;
     // Switch to the squeezing phase
     KeccakF1600_StatePermute(state);
 
     // === Squeeze out all the output blocks ===
     while(outputByteLen > 0) {
         blockSize = MIN(outputByteLen, rateInBytes);
         memcpy(output, state, blockSize);
         output += blockSize;
         outputByteLen -= blockSize;
 
         if (outputByteLen > 0)
             KeccakF1600_StatePermute(state);
     }
 }

// SHA3 ]]]

// MAIN[

int main( int argc, char *argv[] ) {
	FILE *fp;
	FILE *fp_outLOG;
	uint32_t Filehash;
	//int SourceSize;
	//int TargetSize;
	uint64_t SourceSize;
	uint64_t TargetSize;
	uint64_t TargetSize1;
	uint64_t TargetSize2;
	uint64_t VerifySize;
	uint64_t DoOffset;
	char* SourceBlock=NULL;
	char* SourceBlockREVERSED=NULL;
	char* TargetBlock=NULL;
	char* VerifyBlock=NULL;
	char* Nakamichi = ".Nakamichi\0";
	char* LZSSE     = ".L17.LZSSE2\0";
	char NewFileName[256];
	char NewFileName2[256];
//	clock_t clocks1, clocks2;
	uint64_t OneMB=1024*1024;
	uint64_t SevenGB = OneMB*5120;
unsigned long long ticksTOTAL=0, ticksStart;

	char* NakamichiSHA3 = "Nakamichi";
	char* NakamichiSHA3q = "q";

char *pointerALIGN;
int i, j;
uint64_t i64;// 2020-Feb-26
clock_t clocks3, clocks4;
double duration;
double durationGENERIC;
int BandwidthFlag=0;

unsigned long long k;
unsigned long long k1;
unsigned long long kMAXIMUM;
unsigned long long k2;
unsigned long long k3;
int Trials;

// LZSSE2 [
#ifdef _N_alone
#else
LZSSE2_OptimalParseState *s;
#endif
// LZSSE2 ]

#if defined(_WIN32_ENVIRONMENT_)
      unsigned long long size_inLINESIXFOUR;
      unsigned long long size_inLINESIXFOURlog;
#else
      size_t size_inLINESIXFOUR;
      size_t size_inLINESIXFOURlog;
#endif /* defined(_WIN32_ENVIRONMENT_)  */

#ifdef _N_HIGH_PRIORITY
   DWORD dwError, dwPriClass;
#endif

char *TwoDigitHEXlist[256] = {
"00\0",
"01\0",
"02\0",
"03\0",
"04\0",
"05\0",
"06\0",
"07\0",
"08\0",
"09\0",
"0A\0",
"0B\0",
"0C\0",
"0D\0",
"0E\0",
"0F\0",
"10\0",
"11\0",
"12\0",
"13\0",
"14\0",
"15\0",
"16\0",
"17\0",
"18\0",
"19\0",
"1A\0",
"1B\0",
"1C\0",
"1D\0",
"1E\0",
"1F\0",
"20\0",
"21\0",
"22\0",
"23\0",
"24\0",
"25\0",
"26\0",
"27\0",
"28\0",
"29\0",
"2A\0",
"2B\0",
"2C\0",
"2D\0",
"2E\0",
"2F\0",
"30\0",
"31\0",
"32\0",
"33\0",
"34\0",
"35\0",
"36\0",
"37\0",
"38\0",
"39\0",
"3A\0",
"3B\0",
"3C\0",
"3D\0",
"3E\0",
"3F\0",
"40\0",
"41\0",
"42\0",
"43\0",
"44\0",
"45\0",
"46\0",
"47\0",
"48\0",
"49\0",
"4A\0",
"4B\0",
"4C\0",
"4D\0",
"4E\0",
"4F\0",
"50\0",
"51\0",
"52\0",
"53\0",
"54\0",
"55\0",
"56\0",
"57\0",
"58\0",
"59\0",
"5A\0",
"5B\0",
"5C\0",
"5D\0",
"5E\0",
"5F\0",
"60\0",
"61\0",
"62\0",
"63\0",
"64\0",
"65\0",
"66\0",
"67\0",
"68\0",
"69\0",
"6A\0",
"6B\0",
"6C\0",
"6D\0",
"6E\0",
"6F\0",
"70\0",
"71\0",
"72\0",
"73\0",
"74\0",
"75\0",
"76\0",
"77\0",
"78\0",
"79\0",
"7A\0",
"7B\0",
"7C\0",
"7D\0",
"7E\0",
"7F\0",
"80\0",
"81\0",
"82\0",
"83\0",
"84\0",
"85\0",
"86\0",
"87\0",
"88\0",
"89\0",
"8A\0",
"8B\0",
"8C\0",
"8D\0",
"8E\0",
"8F\0",
"90\0",
"91\0",
"92\0",
"93\0",
"94\0",
"95\0",
"96\0",
"97\0",
"98\0",
"99\0",
"9A\0",
"9B\0",
"9C\0",
"9D\0",
"9E\0",
"9F\0",
"A0\0",
"A1\0",
"A2\0",
"A3\0",
"A4\0",
"A5\0",
"A6\0",
"A7\0",
"A8\0",
"A9\0",
"AA\0",
"AB\0",
"AC\0",
"AD\0",
"AE\0",
"AF\0",
"B0\0",
"B1\0",
"B2\0",
"B3\0",
"B4\0",
"B5\0",
"B6\0",
"B7\0",
"B8\0",
"B9\0",
"BA\0",
"BB\0",
"BC\0",
"BD\0",
"BE\0",
"BF\0",
"C0\0",
"C1\0",
"C2\0",
"C3\0",
"C4\0",
"C5\0",
"C6\0",
"C7\0",
"C8\0",
"C9\0",
"CA\0",
"CB\0",
"CC\0",
"CD\0",
"CE\0",
"CF\0",
"D0\0",
"D1\0",
"D2\0",
"D3\0",
"D4\0",
"D5\0",
"D6\0",
"D7\0",
"D8\0",
"D9\0",
"DA\0",
"DB\0",
"DC\0",
"DD\0",
"DE\0",
"DF\0",
"E0\0",
"E1\0",
"E2\0",
"E3\0",
"E4\0",
"E5\0",
"E6\0",
"E7\0",
"E8\0",
"E9\0",
"EA\0",
"EB\0",
"EC\0",
"ED\0",
"EE\0",
"EF\0",
"F0\0",
"F1\0",
"F2\0",
"F3\0",
"F4\0",
"F5\0",
"F6\0",
"F7\0",
"F8\0",
"F9\0",
"FA\0",
"FB\0",
"FC\0",
"FD\0",
"FE\0",
"FF\0"
};

if (argc == 2) {} else { // 2020-Jan-13
	printf("                                                                                                                                                                 \n");
	printf("                                                            SMMi                                                                               :MM2              \n");
	printf("                                                           0MMMMM:                                                                            rMMMMMa            \n");
	printf("                                                          ZMMM. 0Z                                                                           :MMM7 7B            \n");
	printf("                                                         rMM@                                                                                MMM                 \n");
	printf("         7                                               MMM                                                                                MMM.                 \n");
	printf("       BMMMa XZ               :MM:                      MMM                                                                                XMMX                  \n");
	printf("     XMSANMAYCE;             rMMMM                     rMM;                                                                                MM@                   \n");
	printf("    WM0  2MMMMM             ZMMMM                      MMW                                                                                BMM                    \n");
	printf("    :      MMMB           aMMMMW                      2MM                                                           :MM8                  MM7               8MMi \n");
	printf("            MMMZ           XMMM                       MMa                                                         .WMMM0                 @MM              rMMMMi \n");
	printf("            MMMMa           MM,                      aMM                                                          XMMB                   MM:              MMM2   \n");
	printf("           @MXMMM7         0MM                       MMS                                                                                WMM                      \n");
	printf("           MM  MMM,        MM7                      7MM                                                                                 MM:                      \n");
	printf("          MMX  ;MMM       iMM         MMM8  .       MM8     MMS         MMMZ  .     iMBi    :MMMX      @MMa      WB:       XMMZ2aX     ZMM     MMM2     :M2      \n");
	printf("         :MM    ZMMM      BM8       ;MMMMMaaMM     ,MM    XMM@MM      rMMMMM2aMM   XMMMM   SMMSMM.    MMXMMM    MMMM0     aMMMa@MMr    MMS   ;MM;MM8   XMMMM.    \n");
	printf("         MMr     MMM0     MM       2MMW    MMM     0MM   ZMS 2MM.    aMMB    MMM  BM aMM  8Ma  MM   iMM  BMM   M7 MMZ    ;MMX   MMi   ;MM   ZMW  MM0  rM 7MM     \n");
	printf("        ;MM       MMM7   iMM      ZMM2    0MMa     MMX  8M:  MMM    ZMMS    BMM2  7  MM8 ZMr  :MM  rMB   MM@     iMM     MMZ   iMM    WMW  BM2   MMX     @MM     \n");
	printf("        MMi       ;MMM   0MS     2MM7    aMMM     ;MM .8Mi  MMM    aMM7    ZMMM      MM ;Mr   XMM iM8    MMa     0MM    BMM    MMM    MM: BMX   .MM      MM7     \n");
	printf("       aMM         BMMM  MM     ;MMX    ZMMMZ     BM@ MMM    .    rMM7    ZMMMZ     :MM:MX    0MZ M8    XMM,     MMX    MM.    ;W:   rMM aMX    ZMM     7MM      \n");
	printf("       MM           MMMi MM     MMZ    8M:MM      MM; MMM,        MMa    0M:MM      8MWM8     MMZM0     MMM     rMM    0MM           WMa,M2     MMS     MM8      \n");
	printf("      @M0           :MMMXMa    MMM    WM XMB ;   :MM;M8MMM       MMM    @M XM0 ;    MMM@      MMMW      MMrZi   MMS    MMi           MMZM0     rMM Mi   MM :     \n");
	printf("     ;MM             BMMMM:   rMM    MM  MMSMa   ZMMM@ iMMr     7MM    MM  MMXM2   :MMM      ZMMM      8MM@@    MMZ0  7MM       ,   :MMMM      MMBMa   0MWBr     \n");
	printf("    ,MMMM             MMMM    MMS   MM   MMMZ    MMMM   MMM     MMS  .MM   MMMZ    @MM.      MMM       MMMM    WMM@   0MM      2M   ZMMM      :MMMa    MMM7      \n");
	printf("  iMMMMMM@            XMMM   .MM  XMM   aMMM     MMM:    MMW   .MM  XM@   ZMMM     MM0      aMMX      8MMM    .MMM    WMM     ZMr   MMMX      MMM8    0MMS       \n");
	printf(" SMMMMi                MMM,  rMM,MM2    MMM:    SMMM     ;MM2  ;MM,MMS    MMM,    MMM       MMM       MMM.    MMM     .MM    MMZ    MMM      XMMM    rMMB        \n");
	printf(" :MMM7                 MM@    BMMM      aMM     ;MMX      aMMX  8MMM      ZMM     MM8      .MMX      MMM2    iMMX      ,MMMMMMZ     .@;      MMM     WMM         \n");
	printf("    .                  .:                         :        0MMZ                                      .2Z                  :7r.                ;i                 \n");
	printf("                                                            0MMMaSMi                                                                                             \n");
	printf("                                                             aMMMM7                                                                                              \n");
	printf("                                                              .WW                                                                                                \n");
	printf("                                                                                                                                                                 \n");
	printf("Nakamichi 'Ryuugan-ditto-1TB', written by Kaze, inspired by Haruhiko Okumura sharing, based on Nobuo Ito's LZSS source, muffinesque tips by m^2, Jim Dempsey and Kirill Kryukov enforced.\n");
//	printf("https://twitter.com/Sanmayce/status/1091780310407233536\n");
	printf("Downloadable at: https://twitter.com/Sanmayce/status/1211005691873439744\n");
	printf("Note0: Nakamichi 'Dragoneye', (AUTO-RESETTING PASSES and DEFRAGMENTED B-trees revision) is 100%% FREE, licenseless that is.\n");
	printf("Note1: Hamid Buzidi's LzTurbo ([a] FASTEST [Textual] Decompressor, Levels 19/29/39) retains kingship, his TurboBench (2017-Apr-07) proves the supremacy of LzTurbo, Turbo-Amazing!\n");
	printf("Note2: Conor Stokes' LZSSE2 ([a] FASTEST Textual Decompressor, Level 17) is embedded, all credits along with many thanks go to him.\n");
//	printf("Note3: 'Ryuugan' predecessors are Washigan, Okamigan, Zato, Tsubame, Tengu-Tsuyo, Tengu, Rakka, Kokuen, Kinroba, Yoko, Kinutora, Jiten, Butsuhira, Suiken, Keigan, Kumataka, Washi, Aratama, Hitomi, Nekomata, Kitsune, Kinezumi, Sanbashi, Kaiko, Inazuma, Zangetsu, Hanabi, Hanazakari, Sanshi and Kaidanji.\n");
//	printf("Note4: This variant is the SLOWEST compressor under the Sun! This compile can handle files up to 5120MB.\n");
	printf("Note3: The matchfinder is either 'Railgun_Trolldom' (matches longer than 18, except 36 and 64) or Leprechaun's B-tree order 3.\n");
	printf("Note4: Instead of '_mm_loadu_si128' '_mm_lddqu_si128' is used.\n");
//	printf("Note7: The lookahead 'Tsuyo' heuristic which looks one char ahead is applied thrice, still not strengthened, though.\n");
//	printf("Note8: The compile made 2017-Oct-22, the decompression time measuring is done in 16x8 passes choosing the top score from 64 back-to-back runs - the goal - to enter [maximal] Turbo Mode.\n");
//	printf("Note9: In GP/SSE4.1/AVX2 compile, the 24 matches become 3xQWORD/1xQWORD+1xXMMWORD/1xYMMWORD.\n");
	printf("Note5: Maximum compression ratio is 44:1, for 704 bytes long matches within 1TB Sliding Window.\n");
	printf("Note6: Please send me (at sanmayce@sanmayce.com) decompression results obtained on machines with fast CPU-RAM subsystems.\n");
	printf("Note7: In this compile, clock() was replaced with time() - to counter bigtime stats misreporting.\n");
	printf("Note8: Multi-way hashing allows each KeySize to occupy its own HASH pool, thus less RAM is in use - the LEAF is smaller.\n");
	printf("Note9: In this revision, B-tree heuristics are in use, allowing skipping many unnecessary memmem() invocations.\n");
//	printf("NoteF: In this compile, B-tree is the primary matchfinder, memmem() is used for 18+ matches (except 24,28,36,48,64), and for marginal cases.\n");
	printf("NoteA: The file being compressed should be 4 bytes or longer due to Building-Blocks being in range 4..18, 24,28,36,48,56,64,128.\n");
	printf("NoteB: In this compile, the keysizes in the LEAF are not HEXed i.e. not doubled. Also, the hash in use: FNV1A_Pippip_Yurii, the fastest one known to me.\n");
	printf("NoteC: In this latest (2020-May-09) compile, SHA3-224 is enabled at compile time, it is optional, that is.\n");

//	printf("NoteH: The SHA3_224 hash for 'Nakamichi' should be: 6f6f29a1a07131340613af7eaeb0924af7cf605c6eb78f964b601fdf, is: ");
}

//FIPS202_SHA3_224((unsigned char *)NakamichiSHA3, 9, (unsigned char *)SHA328bytes);
//SHA3-224
//Nakamichi
//6f6f29a1a07131340613af7eaeb0924af7cf605c6eb78f964b601fdf
//
//SHA3-224
//q
//774057ce10e1b255cfa747982782e969231ef434a057622021ff5b9c
//for (i=0; i<28; i++)
//	printf ("%s",TwoDigitHEXlist[SHA328bytes[i]]);
//printf("\n");

	if (argc==1) {
		//printf("Usage: Nakamichi filename\n"); exit(13);
	printf("\n");
	printf(":.:.::i         ,,:ri.,               .77     :r7LJcJY7i7JUcLr7r7LfL.      .,   ,.:.,             :rtc7:.     .DQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".:.::i:            ,ii::,              i7,   i7i:::::irLri:::::::::LjL,                :iirr::,      .rJUtr     pQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("::::ii,             .r::i::::::::.,    .Lr   ::.::i:i:i:::i:i:i:i:::i72r,      .i:7ri:.,i:iir7JYr,      .itf    2QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("::::.            :ir:ri::::::::::ii.   ,r7r   ,:ii:i:i:i:i:i:i:i:i:i::iJJYJ:    :r:rrrrriiiiirrrLUYr.,     .    RQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("                  ,.r77r7rrir::::.:::   7iL,  .ii:i:i:i:i:i:i:i:i:i:i:::LLrYc    ,i:iii:i:i:,,:irr77jJUc7:,       QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".,                    ,:irr7r7rri:.::: :rii  .:r:i:i:i:i:i:i:i:i:i:i:i:::r::7f.    ::iirii:r:    :rr:iir7JUj:      QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(" ,...,                    ,,.:ir7rr::iriiii.::iii:i:i:i:i:i:i:i:i:i:i:i:i::::r17:,  ,:i:iiiirr:    :7ii:::irtji     QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":.   ...,                       .r7r:rii:iir:iii:i:i:i:i:i:i:i:i:i:i:i:i:i:i::iJUtcr   .:iii:ir7.   ,7ii:i:::7fY     QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".:i::,  ,..,                   .  .rr:i:i:i:iii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:::rrrc2.  ,ir:i:ii7r:   rii:i:i:iJt,   ,QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("   ,.:i:,  ,,,                :r,  ,rr:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i::::::r1.  iii:i:i:rrr   i:r:i:i:icf,   .QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("       ,::.                  :i::   :ri:i:i:i:i:i:iiiiriiiiiiiiii:i:i:i:i:i:i:i:i:i::r2, .rii:i:i:ii7, .::i:i:i:rYt    iQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".         ,.               ,:i::i,  :r:i:i:i:i:i::::::::.::::i:iiiiriiiiirii:i:i:i:i::rt  :iii:i:i:ii7, .:.iii:::LUf    cQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("i:                        :::::.:   rii:i:i:i:i:ri:.:...:.:.:.:.:.:::::::::.i:i:i:i:i:irL .:r:i:i:i:ii7. ::.iii::ri.       iXQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":i                   ,.::i::.:.::irrii:i:i:i:i:i::.:.:::::::::::.:.:.:.:.:.iii:i:i:i:i::rr..:i:i:i:i:i:r...:.i:i:iii.,        ,hQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("i:                  .ii::.:.:.iiiiiii:i:i:iii::...:.::::::i.,.iii:::::::::::iii:i:i:i:i:iir:::i:i:i:i:i:r:..::r:i:irYJJr:,       PQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("i,                 .i::::::i:rii:i:i:i:::::i::.:.::::::i::.,   ,.::i.,i:::.:.iii:i:i:i:i:i:i:i:i:i:i:i:iir:..::i:i:::iiLYtJL:     rQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(",                 ,::::.irrii:i:i:i:riiii.:...:.:::::..               .:i::.:.::iii:i:i:i:i:i:i:i:i:i:i:i:r:..:ii:i:i:i:i:r7Uj.    fQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("                ,.::.:...::i:i:i::::::::::.::::::i.,                   ,:i::::.:::ir:i:i:i:i:i:i:i:i:i:i:i:i:..i:i:i:i:i:i:::7f.    QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("  , ,          .i::.:.:.:.i:i:i::.:.:.....:::.....:,                     .:.:::...::iii:i:i:i:i:i:i:i:i:i:i:r..:i:i:i:i:i:iii:7L    XQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("....,        .:i::.::iiiii:i:i:i:iii:i:i::::::.,                 ,.::::.    .:::.:.:.::i:i:i:i:i:i:i:i:i:i:iii.i:i:i:i:i:i:i..:U    7QQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("            i::::.:ii:i:i:i:i:i:i:i:i:iii:.., ,                   ,.:irr.    ::.:.:.:.i:i:i:i:i:i:i:i:i:i:i:i:::i:i:i:i:i::.::i7    1QQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("....,      :i:::..:i:i:i:i:i:i:i:i:i:i:i::.....:.:.             iU.   ,:r:   :::::.::r:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:ii:  ..    QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("           i:.:::.iii:i:i:i:i:i:i:i:i:i:iirirrrr7Lr,           .QQ 7E    .r. ,i::::.:ii:i:i:i:i:i:i:i:iii:i:i:i:i:i:i:i:i:ii7.      iQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("           i:::::::i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:::irr.,       LQ.:QQf     :. ::::.:.:ii:i:i:i:i:i:ii:.iii:i:i:i:i:i:i:i:i:ii77i      7QQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("           ::::.::::i:i:i:i:i:i:i:i:i:i:i:i:i:i:iiiirrLcc.     iQ cDF  :0pL ,  i:::::.::iii:i:i:i:i:i:..i:i:i:i:i:i:i:i:i:i:i:r7tr,     DQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".          .i::  i::ii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:irjr  ,  Q. bf .MXPDZ   ,:i::::::.iirii:i:i:iii...iii:i:iii:i:i:i:i:i:::iictr     iQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("r.          i::  .i.:ii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:7r  J YQ .bL0ppPX  :   :i::,:::.::i:iiriiii::.::r:i:r:iii:i:i:i:i:i:.:i:rJt,     QQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("i.          :::   .i.::iii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:7: i7 tQ: ..:,   RQ7   ,ir  i::.:.:::::::.:.:..iriii:,rii:i:i:i:ii:.:.::rjU     QQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":           i:i,    ::::iiiir:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:r,.:r :QQhi..iZQQQQ7    .  .r::::.:.:.:.:.::. ::i::: .riiiiiririr::...:i77,   7QQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("   ,       ,i::.    .:.:.:.:.::i:i:i:i:i:i:i:i:i:i:i:i:i:i:iir...i. :QQQQQQQQQQQt       ,i:::::::::::::i  i::i:. ,:::iii:iir.   :::ii:    QQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".,,   ,    .i:i.  .::.:.:..:::i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:iii...::. .rpQQQQQQQQQr       :ii::::::::ir,  :..,    ::i::::..    :..ii:    QQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("   ...     i .i, :i:.:.::iiiii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:iii.:::.  , ,.:i7L7:,         ,.::i:i:i:.               ,  ,  . hL  ::,    QQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(",..       ,. .i,.::.::iiiii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:iir:..i:.   ,    ,..                        .:::iirii,   RP jQ bQ ,,     RQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("             i::::..:rii:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:iir.,  ,.                       ,,,,,,    :r::rirrrrYr  ::pQ: Q9      ,QQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("            i::.:.::i:i:i:i:i:i:i:i:iiriririiii:i:i:i:i:i:i:i:i:i:ri:.....::ii7r7r7ii.,     ,:ii7r7r77i  ,i:iii:i:i:7c.  .: fr ,    RQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":i:i:,     .i:::.::r:i:i:i:i:i:iiiirrrrrii::.:ii:i:i:i:i:i:i:i:i:i:iirrrr7rrrriiiiirir:.   ,i::rii:i:irL,  ::r:i:i:i:rY:      Y:    QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("::::ii     :i::.:ii:i:i:i:i:iiriiii:.,     ,::i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:i:iir::  .i.iii:i:i:iic. ,:ii:i:i:i:iJ: .,r7:     QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".::::i     .::.:ii:i:i:i:i:ii::i:.     ,.irL77iririririiirii:i:i:i:i:i:i:i:i:i:i:i:i:iir:: .:::i:i:i:i:i:c: .:ii:i:i:i:rU..::r:.     QQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":.::i.      i:::i:i:i:i:i:i::::,    ,:77YYLi:,:ii:i:i:rii:irr:i:i:i:i:i:i:i:i:i:i:i:i:i:r:..:.:ii:i:i:i:i:c:,.::i:i:i:i:7ci.::rhr   .QQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".::i:  ,,   .i:r:i:i:i:i:i:..:     r77rc:,             .....i7ii:i:i:i:i:iirii:i:i:i:i:i:i::.:.iii:i:i:i:i:7r:.:ii:i:i:i:cr::i::.   LQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("::i:  .:    ,i::i:i:i:i:i:i.::    7riii       ,,...,,        :7ii:i:i:iirrr.rrr:i:i:i:i:i:r::...i:i:i:i:i:i:rii:i:i:i:i::ii:i:ir:    ,QQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(".::  .r,     :::ii:i:i:i:iii::.   rri:.    :i7r7r7r777i:,     :7ii:i::::...  .i7ii:i:i:i:i:i:...:r:i:i:i:i:i:i:i:i:i:i:i:i:iii:iJF.    bQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("::  .ir       i::ii:i:i:i:iir:i:  ,7rii.  i7rii:i:i:iirr7r.    :7ii:i:i::.,    .rii:i:i:i:i:r::.::i:i:i:i:i:i:i:i:i:i:i:i:i:iir.,.r    UQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":  .ii:       ,i.:ii:i:i:i:i:iiri. ,rrirrrii:i:i:i:i:i:i:r7:    .7ri:i:iirrr:,   :ir:i:i:i:i:ii:.:ii:i:i:i:i:i:i:i:i:i:i:i:i:::rr.     :QQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("  .i:i,        .i.:ii:i:i:i:i:iirri .iiiiii:i:i:i:i:i:i:i:rr:    ,rrrii:i:rirri,  :irii:i:i:i:iii.:ii:i:i:i:iii:i:i:i:i:i:i:i:i:i7j:     ZQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(" .7ri,          .i:::r:i:i:i:i:iiiir:i:iiiiiiiii:i:i:i:i:i:rr:,    :77ii:i:i:rir:  ::i:i:i:i:i:iii:i:i:i:iirr7r7r7r7rrir:i:i:i:i::iYc.    LQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":77:,   ,.::r.   .i:::iii:i:i:i:i:iirir:i:i:::i:i:riiii:i:i:rii.,    :7rr:i:i:iiri, ::r:i:i:i:i:i:i:i:i:ii7r:,    ..::irrii:i:i:i:i:rj:     ,.7PQQQQQQQQQQQQQQQQQQ\n");
	printf("77i,   :ii:::ii,   :::.::iiiirir:i:i::::::::::...::::iiiii:i:rii:.     i77ii:i:iiri.,::i:i:i:i:i:i:i:i:iir:    ,        .7ii:i:i:i:i:iji          .QQQQQQQQQQQQQQQ\n");
	printf("7r,   .i:::::::     .:i.::::::::::::i::::.....:::.:.:.::iiiii:iirii.,    :7rr:i:i:ri:.:ii:i:i:i:i:i:iii:7.   :77L77..jL.  rri:i:i:i:i:ij:   ,      7QQQQQQQQQQQQQQ\n");
	printf("r,   :i::::ii:  ii,   .i:i:i::::...,     , ,,.:::::::::::::iiiii:iiri:,    :r7ii:i:ri:.i:i:i:i:i:i:::iii7.  i7irirr7r7rL7  i7rii:i:i:i:it, 77YYi   .QQQQQQQQQQQQQQ\n");
	printf(",   .r::i:i:,  :::r.    ,..,,            .::i:i:i::::,,,.:::::iir:iirir:.    .rrrii:ii::i:i:i:i:i:i:..:rL,  Li::::7r7ii:J7  .i7ii:i:i:i:7c .::rF:   QQQQQQQQQQQQQQ\n");
	printf("     i::.,    .i:::i:                            ,,...,    ..::::iiiiiirii.    .r7ii:i::ii:i:i:i:i:r::.i   :ri::     ,.::Y:    iri:i:i:i:J:,::iL,   QQQQQQQQQQQQQQ\n");
	printf("  :r      ,.  i:::::i:.,..  ....:. ,r.    ,,..:::::.,         .:::::riiirrr:.    .7ii:i:i:i:i:i:i:ii:.i,  7rr:i,   ...:.::LLr.  .ri:i:i::ic,.:rr    QQQQQQQQQQQQQQ\n");
	printf(" :r.  .::iir, .i:::::::rr: ,ri:ir  ii  :....,.,..:iLf9bDXS.     .::::::i:iirii.   ,7ii:i:i:i:i:i:i:i::.  iri:::    :::.::iiii7Lr :ii:i:i::L:.irr    QQQQQQQQQQQQQQ\n");
	printf(":r,  :i::::::  ::.:::ii.,   r::r. rL  9XhFh22jJ7i.,    ,LL        .:i.::iii:rii:,  .7ii:i:i:i:i:i:iir:  :rri...         ::iii:ic. r:i:i:i:r7:ir:    QQQQQQQQQQQQQQ\n");
	printf("r   :i:::::::. ,irrr:.   :  ::ir .Xr j1UYjJUJtj12ShStL:       .     .i::.::iiri:i,  :7ii:i:i:i:i:i:ii: .J7rr:            ::iii:i::ii:i:i:i:7:ir:    QQQQQQQQQQQQQQ\n");
	printf("   ::::.:.::::, ,:.   ,:7i:  ic. YU .1JcJYJcJcJcJJjJttSSht.   :Q:     :::.::iiri::   rr:i:i:i:i:i:i:rr   .:r7:            :::ii:i:i:i:i:i:iii:7.    QQQQQQQQQQQQQQ\n");
	printf("  ::::.:.....::,    ,irrii:. .7 .X. QF7YLJcJcJcJcJcJcJYjjXF    QQb     ,:i::.::r:i,  :ri:i:i:i:i:i:iiri.    i7:   :.       :.:ii:i:i:i:i:i:i:ir:    RQQQQQQQQQQQQQ\n");
	printf(" ::.:.::i:i:i7U. .:irir:iii:.   Lt 7QQf7JcJYJcJcJcJcJcJcJJ0:   ,QQQr     ,i::.::::.  .7:i:i:i:i:i:i:i:ir7ri,,i7i,,77r.     .::i:i:i:i:i:i:i:i:ri     DQQQQQQQQQQQQ\n");
	printf("::.:::iiiriiijj  rrrii:i:iirii  f7 0MD1UUfUfjtJUJjcJYJcJcJf1    QQQQQ.     :i:.::i.  ,7i:i:i:i:i:i:i:i:i:rir:iiriiirrYr    ::::i:i:i:i:i:i:i:ii7.     MQQQQQQQQQQQ\n");
	printf("i.::rii:i:::7t: :ir:i:i:i:ii7: .S: jU777L7YYtthhXFhttJjYJcUP.   UQQQQQF     ,:i::::   7ii:i:i:i:i:i:i:i:i:i:i:i:iiiir:.    ::.i:i:i:i:i:i:i:i:iiJi     QQQQQQQQQQQ\n");
	printf(":iii:i:i:::7tJ  ir:i:i:i:i:ir. :1:              ,:iYtShhftJ0r   ,QQQQQQQ:     .i:::   .7ii:i:i:i:i:i:i:i:i:i:i:i:i:,.:,   .i:::rii:i:i:i:i:i:i::ihr    QQQQQQQQQQQ\n");
	printf("iii:i:::r7Ujr  ,7ii:i:i:i:::r, :F: RQQQRPUfUjri.,     ,:cfpR7    QQQQQQQQ0     ,i:i.   rrirrr:i:i:i:i:i:i:i:i:i:i:r:, iY7:i::.::iiiii:i:i:i:i:i::77   rQQQQQQQQQQQ\n");
	printf(":iiiir7UJL.     irii:i:i:::iY. :1i QQRMQZpYLcf1ShX2tr:     :    7QQQQQQQQQQi     :ir,   rLi.:7iiiiirii:i:i:i:i:i:i:rr:  .::::i::.::iiiii:i:i:i:iiL,   .QQQQQQQQQQQ\n");
	printf(" .cUtLr,    ::  .iiii:i:::7JX, .Fr PQbEbZRRXYrYcJJUU1FPFJ:,      .QQQQQQQQQQ0     .ir,   :   :Lrrrr:::i:i:i:i:i:i:i:irr       .::...::iii:i:i:iir       RQQQQQQQQQ\n");
	printf("  ,.     .:rrr:  ::iii:i7tJi    UJ LQM0E0DbQM1rLLJcJYjYUtXSSJ:    ,QQQQQQQQQQQ.    ,i7.       ,r:,  :i:i:i:i:::iii:i:iir.:.,  ,:.:.:...::r:i:i:r ,ci    .QQQQQQQQQ\n");
	printf("1   ,.:irrririi.  ::iiLJY.   .  ct ,QZD0E0DbRQ07LcJcJcJcJYjUh9c    rQQQQQQQQQQQJ     :r:.  i.      :i:i:i:i:i:::::iii:iirr7rrrr::.:.:.:...i:i:r:.:rJ:    QQQQQQQQQ\n");
	printf("i .riririi:i:ri:.  .:7:,   .rr  :S. QQMRMRMRMQQZLYLJcJLYLJcJYtPL    bQQQQQQQQQQQR     .ri::i::   .r7r7ii:i:ri:i:.:.::iiiiririririi:i::....:i:ii:.ir7      QQQQQQQQ\n");
	printf("  iirii:i:i:i:i::.      ,:rrrr, ,tc LQDp9XPS9XbM1LJcJcJcJcJcJcUpi    QQQQQQQQQQQQQ,    .i::::i.  rLLr:i:iii::.ii:.:.:.::::i:iirii:iiiii::.:ii:i::ir,      cQQQQQQQ\n");
	printf(" :ii:i:i:i:i:i:ir7r  .:rrriiir.  71, XftJjJjJjJtfhfFtfjjYJcJcJcfP.   ,QQQQQQQQQQQQQ:    .::::i  :7Lr:i:i::.:..:r::.:.:.:...:.::iiiii:iiii::i:i:iir: :7     QQQQQQQ\n");
	printf(" ir:i:i:i:i:i:i:LUL .r7ir:i:iii  ,h7 ,            ..:i7Y2FS11jtJhh    jQQQQQQQQQQQQQ    .:::::  i77:::i:..:.:rL,.rriririi::::.:.::iiiii:iii:i:iii::rJhi    QQQQQQQ\n");
	printf(".rii:i:i:i:i:i:i7U: .rii:i:i:ri.  7S, 1X2Ff2UUYLrr:..,    ,:rU1XXQ7    QQQQQQQQQQQQQ    .i::::  .Li::i::.::ri:   .,, , ..::rii::.:.::iirii:i:iii.:ri:j7    MQQQQQQ\n");
	printf("rii:i:i:i:i:i:::Lj. .ir:i:i:i:r:  ,2J fQQQQQQQQQQQQQQQ0UL:.     :L.   :QQQQQQQQQQQQQ    .i::::,  rr:ii:.:r:                  .:ir::.:.:::..:i::::::::j:    QQQQQQQ\n");
	printf("ri:i:i:i:i:i:i:rLJ  :rii:i:i:iir.  ih: RQZbD0E0D0DbZERMZ1jjFfJi.       ,EQQQQQQQQQQQ7    ,:i:::  .7r:i::i,  ,.:::::iiri:..      ,:ii::.:.::i:::.,::::.    YQQQQQQQ\n");
	printf("r:i:i:i:i:i:i::7ji  iii:i:i:i:iii,  jt  QRZ0E0E0b0E0bbZZQD27YUhhPfL:     fQQQQQQQQQQQr     ,iii:  :7riii   :i::iir77LLYLJYYri.,    ,ii::::i:i:,  ii,     PQQQQQQQQ\n");
	printf("ir:i:i:i:i:i::ict  .ir:i:i:i:i:rii  ,FL :QZD0E0b0b9b0E0EbMR07LcJJfF0S:    7QQQQQQQQQQQ0      .:7:  .r77. ,:::iiiiii::::::rr7Lc7r:,   ,:i..,,   ,ri      QQQQQQQQQQ\n");
	printf(":ii:i:i:i:i:::Lfi ,ir:i:i:i:i:i:r::  iX: jQDD0b0E0b0E0b0E0DRMLLLJcJY2p7    :QQQQQQQQQQQQ2      ,ir.  .L  :::rii:i:i:i:iiririrr777ri.      ,.  ,7:     rQQQQQQQQQQQ\n");
	printf(":::rii:i:i:iiJU:  irii:i:i:i:i:i:i:.  LF. PQDE0b0E0E0E0E9E0ZRM7LcJcJYUXt    .QQQQQQQQQQQQQj      .:r.   .:.iii:i::irrrrri:...::rr7rrr:,.:rLh.  .     DQQQQQQQQQQQQ\n");
	printf(" .i:r:i:::rcfr   .iir:i:i:i:i:i::i7i   U2  MQED9b9E0E0b9E9E0DRP7cLYcJYjFh,    QQQQQQQQQQQQQQh       :ii:i:::::iii.,             ,.rr7r7ir7J7       iQQQQQQQQQQQQQQ\n");
	printf("  ,:iri7Lfjr   ,  .iir:i:i:i:i::ijf.   .2j  QQbD0D0DbE0DbD0E0MMc7JcJcYcj2p.    QQQQQQQQQQQQQQQp,      .::,:rii.iiri:...::rrrrr::,  ,.rrL77:     iRQQQQQQQQQQQQQQQQ\n");
	printf("i,  .:Ucr.   ,:i:  ,iirii:i:i:i7fL,  .  r2L ,QQRQRQRRRRRRMRDRZQjLLJcJcJYjt9:    QQQQQQQQQQQQQQQQQ:       ,77ri: iirrL77iriririrrrri.   ,.      JQQQQQQQQQQQQQQQQQQ\n");
	printf("ir:        .:rrri:   ::iir:::7jU.  .:7:  Yfi rQ0hF21f11hhPPEbRRj7JcJcJcJcJU0:    RQQQQQQQQQQQQQQQQQh     L7ri77 :L:r:..rirr7r7rriri77L      YQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":717  ..::ririi:ri:,  .:ii7cfJ:   :irii.  ft. 71UYjJjJUJUJJJjJtYUJJYJJJcJcJU9r    0QQQQQQQQQQQQQQQQQc   ,c7rri.,Y:    :77i:,, ,r7r77r,     7QQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":7Ui ::ririi:i:i:rii.   .:i7.   .rir:iii. .2j  r.        ,,..:i7cf2SFh1FtfjUUEr    SQQQQQQQQQQQQQQQQR    7.    .   ,,,         ,.r:,      jQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("iLt  :iii:i:i:i:i:iir:        .irii:i:i:i  72L  ptfjJcL7r::..        ,:iYUhSppQ.    QQQQQQQQQQQQQQQQQ:          .:i::::   .7r.            cQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("rjr ,iii:i:i:i:i:i:iirr:  ..:iirii:i:i:r::  jf: ZQQQQQQQQQQQQQQQQMFc.,      ,iJ,   .QQQQQQQQQQQQQQQQQQ:         .crr::i:  ::              PQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("ct, ::r:i:i:i:i:i:i:iitY  ririi:i:i:i:iii:, iUj  QQ0E0D0D0EbDbZERRQQQEP1Fc:          ZQQQQQQQQQQQQQQQQQX  QQQ    ,7irii.  r    XQQ9,     ,QQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("f: ,:r:i:i:i:i:i:i:i:icL ,:iii:i:i:i:i:ii::  UU: cQD9E0E0E0b0b0E0DbDZQ0t7jFPF27:,     YQQQQQQQQQQQQQQQQQQQQQQQ    .7i:,  :7.   QQQQQf   ,QQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf(":  :i:r:i:i:i:i:i:i::iUi .:ii:i:i:i:i:i:i::  rt7  QDE0E9E9E9E0E0E9b0EERREJ7LUUhh0F.    :QQQQQQQQQQQQQQQQQQQQQQ    .ri. .rrJ,   2QQQQQ: 7QQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("   ,:::iii:i:i:i:i:i:rU: ::r:i:i:i:i:i:i:i:. .UU  QR0E0E0b0E9b0b0b0b0EbZMQhL7YYjJF9r    .QQQQQQQQQQQQQQQQQQQQU   ,rr..ic7r,    bQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("     :::rii:i:i:i:::icf  :iii:i:i:i:i:i:ii:.  tj  QME9E9b9E9E0E0b9b9E0E0DEREYrccJYtPJ    ,QQQQQQQQQQQQQQQQQQQ    i7i:rr.      rQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("      .i:iii:i:::::rJ1. .iii:i:i:i:i:i:i:r::  Jt, QR0b0E0E0E0b9E0E0E9E0b0EbRRjrcLYcUXf    ,QQQQQQQQQQQQQQQQQQ    :7rr:     :JQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQ     ,:::ii:::rrJfL   iir:i:i:i:i:i:i:ii::  tJ, QZD0D0D0E0D0E0E0E0E0E0E9E0RRJ7YcJcJh1    ,QQQQQQQQQQQQQQQQQ,    :7L    YQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQQ:     ::::rrYj27.    .7ii:i:i:i:i:i:i:i:i ,JU, QQRRRRMRZRZMEMbEbE0EbE9E0E0Rb7LJLJYjFh    .QQQQQQQQQQQQQQQQQ     :L.  iQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQQQ9     ,.712ci,       .rir:i:i:i:i:::iY7, .UJ ,Q9pSpS9X09EbMZRRRRRMREZbD0DbQJ7cJcJcjF1    :QQQQQQQQQQQQQQQQQ1        .QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQQQQQ:     ,.            ,rrrii:i:i:::7UJ   :Jj .FJcJcJYJcYcJcJYttFSbbRRQRRZRQS7JcJLJcJFf    7QQQQQQQQQQQQQQQQQQQ7      7QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQQQQQQZ           .QQ7     :rrii:i::rUU:    rUc :ti:...::::rr77JYtjtjtj2fSXDMQjccJcJcJYUSJ    FQQQQQQQQQQQQQQQQQQQQQRh7iiQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("QQQQQQQQQh       rQQQQQS     .irii:rJfi      JJ7 ,.irLLJcL7r:.,,     ,,:i7cUU2fUJJcJcJcJYUPr    RQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");
	printf("\n");
	printf("Syntax: Nakamichi infile [outfile hashsize treesize treetype]\n");
	printf("        hashsize - hash pool in bits, 0..32, 0 meaning 2^0=1 B-tree per keysize\n");
	printf("        treesize - B-trees pool in MB\n");
	printf("        treetype - i|e or I|E, meaning (Internal|External)\n");
	printf("Example1: Nakamichi OSHO.TXT\n");
	printf("Example2: Nakamichi OSHO.TXT.Nakamichi\n");
	printf("Example3: Nakamichi OSHO.TXT OSHO.TXT.Nakamichi 24 49000 i\n");
	printf("Note1: Example above uses (8x2^24)x(12+1) bytes for hash, 3N+32~=600+32 and ~48GB for B-trees of physical RAM.\n");
	printf("Note2: The bigger the hash pool, the lesser B-tree tiering, i.e. significantly faster the compression is.\n");
	printf("Note3: The 'outfile' name is a dummy, it always is 'infile'+'.Nakamichi', not a bug, just enforcing avoidance of filename mayhem.\n");
	printf("Note4: Since 2020-Jan-13, above is deprecated and the 'outfile' name is NOT dummy, also, when decompressing, the 'stdout' is used instead.\n");
	exit(13);
	}

//time_t t = time(NULL);
//struct tm tm = *localtime(&t);
//printf("now: year-mon-day hour:min:sec %d-%d-%d %d:%d:%d\n", tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec);

//Description
//The C library function time_t time(time_t *seconds) returns the time since the Epoch (00:00:00 UTC, January 1, 1970), measured in seconds. If seconds is not NULL, the return value is also stored in variable seconds.
/*
#include <stdio.h>
#include <time.h>
int main () {
   time_t seconds;
   seconds = time(NULL);
   printf("Hours since January 1, 1970 = %ld\n", seconds/3600);
   return(0);
}
*/

/*
// C program to demonstrate 
// example of time() function. 
#include <stdio.h> 
#include <time.h> 
int main() 
{ 
    time_t seconds; 
     // Stores time seconds 
    time(&seconds); 
    printf("Seconds since January 1, 1970 = %ld\n", seconds); 
    return 0; 
} 
*/

#ifdef _N_HIGH_PRIORITY
   if(!SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS))
   {
//      _tprintf(TEXT("Already REALTIME_PRIORITY.\n"));
//      goto Cleanup;
   } 
   if(!SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS))
   {
//      _tprintf(TEXT("Already REALTIME_PRIORITY.\n"));
//      goto Cleanup;
   } 
   // Display priority class

   dwPriClass = GetPriorityClass(GetCurrentProcess());

   //_tprintf(TEXT("Current priority class is 0x%x\n"), dwPriClass);

if (argc == 2) {} else // 2020-Jan-13
   if (dwPriClass==0x00000080) printf("Current priority class is HIGH_PRIORITY_CLASS.\n");
if (argc == 2) {} else // 2020-Jan-13
   if (dwPriClass==0x00000100) printf("Current priority class is REALTIME_PRIORITY_CLASS.\n");
#endif

#ifdef _N_HIGH_PRIORITY
// https://habrahabr.ru/post/113682/
// Andrew Aksyonoff [
SetProcessAffinityMask(GetCurrentProcess(), 1);
	//volatile int zomg = 1;
	//for ( int i=1; i<1000000000; i++ )
	//	zomg *= i;
// Andrew Aksyonoff ]
#endif

	if (argc==3) BandwidthFlag=1;
	BandwidthFlag=0; // Disable memcpy test
	//if (BandwidthFlag) Trials=64; else Trials=1; 
	if (argc==3) Trials=64; else Trials=1; 
	if ((fp = fopen(argv[1], "rb")) == NULL) {
		printf("Nakamichi: Can't open '%s' file.\n", argv[1]); exit(13);
	}

#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp) );
_lseeki64( fileno(fp), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp );
fseeko( fp, 0L, SEEK_SET );
#endif /* defined(_WIN32_ENVIRONMENT_)  */
SourceSize = (uint64_t)size_inLINESIXFOUR;

	if( SourceSize < 4 ) // 2020-Jan-01
		{ printf("Nakamichi: The file being compressed should be 4 bytes or longer due to Building-Blocks being in range 4..!\n"); exit(15); }

GLOBAL_SourceSize = SourceSize; //btree matchfinder needed

	//fseek(fp, 0, SEEK_END);
	//SourceSize = ftell(fp);
	//fseek(fp, 0, SEEK_SET);

	// If filename ends in '.Nakamichi' then mode is decompression otherwise compression.
	if (strcmp(argv[1]+(strlen(argv[1])-strlen(Nakamichi)), Nakamichi) == 0) {
// DECOMPRESSING [
if (argc == 2) {} else // 2020-Jan-13
	printf("Allocating Source-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
	SourceBlock = (char*)malloc(SourceSize+512);
	if( SourceBlock == NULL )
		{ printf("Nakamichi: Needed memory (%luMB) allocation denied!\n", (SourceSize+512)>>20); exit(13); }

// !!! Ensure the sentinel - the first byte after the last one should be non 0x83 !!!
*(char*)(SourceBlock+SourceSize) = !0x83;

//	TargetBlock = (char*)malloc(1111*1024*1024+512); // This was enwik9 setting
//	TargetBlock = (char*)malloc(OneMB*2330+512); // This is GTCC_General_Textual_Compression_Corpus.tar 2,443,181,056 setting
if (argc == 2) {} else // 2020-Jan-13
	printf("Allocating Target-Buffer %s MB ... \n", _ui64toaKAZEcomma((SevenGB+512)>>20, llTOaDigits2, 10) );
	TargetBlock = (char*)malloc(SevenGB+512); // 5GB
		if( TargetBlock == NULL )
		{ printf("Nakamichi: Needed memory (%luMB) allocation denied!\n", (SevenGB+512)>>20); free(SourceBlock); exit(13); }
	fread(SourceBlock, 1, SourceSize, fp);
	fclose(fp);
		//printf("Decompressing %lu bytes ...\n", SourceSize );
if (argc == 2) {} else // 2020-Jan-13
		printf("Decompressing %s bytes (being the compressed stream) ...\n", _ui64toaKAZEcomma(SourceSize, llTOaDigits2, 10) );
	if (argc==3) {
// Warm up...[
	printf("Warming up ...\n");
	for (i = 1; i <= Trials*4; i++) {
		TargetSize = Decompress(TargetBlock, SourceBlock, SourceSize);
		TargetSize1=SourceSize;
	}
// Warm up...]
// Attempt to pick up the Turbomode score... [
clocks0 = clock();
ticksTOTAL = 0;
#if defined(_icl_mumbo_jumbo_)
ticksStart = GetRDTSC();
#endif
	k1=0;
	printf("RAM-to-RAM performance:\n");
if (TargetSize < (1UL<<20)) {Trials=8192; printf("The file is smaller than 1MB, increasing trials to %d.\n",Trials);}
	for (j = 1; j <= 16*8; j++) {
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
	for (i = 1; i <= Trials; i++) {
		TargetSize = Decompress(TargetBlock, SourceBlock, SourceSize);
	}
		clocks2 = clock();
		k = (((double)CLOCKS_PER_SEC*TargetSize/(double)(clocks2 - clocks1 + 1))); k=k*Trials; k=k>>20; 
			if (j%16==0) printf("%d MB/s\n", k); else printf("%d MB/s; ", k);
			if (j%16==0) {
				printf("Enforcing 17 seconds idling to avoid throttling ...\n", k);
				clocks1 = clock();
				while (clocks1 + (double)CLOCKS_PER_SEC*17 > clock() );
			}
	if (k1<k) k1=k;
	}
	k=k1;
	k2=k;
#if defined(_icl_mumbo_jumbo_)
ticksTOTAL = ticksTOTAL + GetRDTSC() - ticksStart;
printf("This CPU seems to be working at %s MHz, or more due to ensleeping.\n", _ui64toaKAZEcomma(ticksTOTAL/((double)(clock() - clocks0 + 1)/(double)CLOCKS_PER_SEC)/1000000, llTOaDigits, 10));	
#endif
	} else
		TargetSize = Decompress(TargetBlock, SourceBlock, SourceSize);

// Attempt to pick up the Turbomode score... ]
	if (argc==3) {
		printf("RAM-to-RAM (peak) performance: %d MB/s.\n", k);
	}
		strcpy(NewFileName, argv[1]);
		*( NewFileName + strlen(argv[1])-strlen(Nakamichi) ) = '\0';
if (argc == 2) {} else // 2020-Jan-13
		printf("Source-file-Hash(FNV1A_YoshimitsuTRIAD) = 0x%s\n", _ui64toaKAZEzerocomma4(FNV1A_Hash_YoshimitsuTRIAD(SourceBlock, SourceSize), llTOaDigits2, 16)+(26-8-1) );
if (argc == 2) {} else // 2020-Jan-13
		printf("Target-file-Hash(FNV1A_YoshimitsuTRIAD) = 0x%s\n", _ui64toaKAZEzerocomma4(FNV1A_Hash_YoshimitsuTRIAD(TargetBlock, TargetSize), llTOaDigits2, 16)+(26-8-1) );

	if (argc!=3) { // 2020-Feb-02, do not dump if in bench mode [

// 2020-Jan-13 [
// https://stackoverflow.com/questions/16888339/what-is-the-simplest-way-to-write-to-stdout-in-binary-mode
// The line below crashes under Windows XP?!
//if (!freopen(NULL, "wb", stdout)) { printf("Can't set output stream to binary mode.\n"); exit(23); }
//https://stackoverflow.com/questions/23107609/is-there-way-to-set-stdout-to-binary-mode
//#ifdef _WIN32
#if defined(_WIN32_ENVIRONMENT_)
  setmode(fileno(stdout),O_BINARY);
  setmode(fileno(stdin),O_BINARY);
#endif
//https://github.com/KirillKryukov/naf/blob/4e737ce8852f5bde2ca5fb31ee6d2b9c34f1a5cb/unnaf/src/files.c#L29

	if (TargetSize <= OneMB) {
		fwrite(TargetBlock, 1, TargetSize, stdout);
	} else {
		for (DoOffset = 0; DoOffset+OneMB < TargetSize; DoOffset=DoOffset+OneMB) {
			fwrite(TargetBlock+DoOffset, 1, OneMB, stdout);
		}
		//if (DoOffset+OneMB >= TargetSize) {
			fwrite(TargetBlock+DoOffset, 1, TargetSize - DoOffset, stdout);
	}
	fclose(stdout);
// 2020-Jan-13 ]

/*
	if ((fp = fopen(NewFileName, "wb")) == NULL) {
		printf("Nakamichi: Can't write '%s' file.\n", NewFileName); exit(13);
	}
	//fwrite(TargetBlock, 1, TargetSize, fp); // Caramba: It doesn't work when file is 4+GB long!
	if (TargetSize <= OneMB) {
		fwrite(TargetBlock, 1, TargetSize, fp);
	} else {
		for (DoOffset = 0; DoOffset+OneMB < TargetSize; DoOffset=DoOffset+OneMB) {
			fwrite(TargetBlock+DoOffset, 1, OneMB, fp);
		}
		//if (DoOffset+OneMB >= TargetSize) {
			fwrite(TargetBlock+DoOffset, 1, TargetSize - DoOffset, fp);
	}
	fclose(fp);
*/
	} //if (argc!=3) { // 2020-Feb-02, do not dump if in bench mode [

// LZSSE2 [
#ifdef _N_alone
#else
	if (argc==3) {
	free(TargetBlock);
	free(SourceBlock);
	memcpy(NewFileName2, argv[1], (strlen(argv[1])-strlen(Nakamichi)));
	memcpy(NewFileName2+strlen(argv[1])-strlen(Nakamichi), LZSSE, strlen(LZSSE)+1); //+1 to add NULL
	if ((fp = fopen(NewFileName2, "rb")) == NULL) {
		printf("Nakamichi: Can't open '%s' file.\n", NewFileName2); exit(13);
	}
#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp), 0L, SEEK_END );
size_inLINESIXFOUR = _telli64( fileno(fp) );
_lseeki64( fileno(fp), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp, 0L, SEEK_END );
size_inLINESIXFOUR = ftello( fp );
fseeko( fp, 0L, SEEK_SET );
#endif /* defined(_WIN32_ENVIRONMENT_)  */
SourceSize = (uint64_t)size_inLINESIXFOUR;

	printf("Allocating Source-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
	SourceBlock = (char*)malloc(SourceSize+512);
	if( SourceBlock == NULL )
		{ printf("Nakamichi: Needed memory (%luMB) allocation denied!\n", (SourceSize+512)>>20); exit(13); }
//	TargetBlock = (char*)malloc(1111*1024*1024+512); // This was enwik9 setting
//	TargetBlock = (char*)malloc(OneMB*2330+512); // This is GTCC_General_Textual_Compression_Corpus.tar 2,443,181,056 setting
	printf("Allocating Target-Buffer %s MB ... \n", _ui64toaKAZEcomma((SevenGB+512)>>20, llTOaDigits2, 10) );
	TargetBlock = (char*)malloc(SevenGB+512); // 5GB
		if( TargetBlock == NULL )
		{ printf("Nakamichi: Needed memory (%luMB) allocation denied!\n", (SevenGB+512)>>20); free(SourceBlock); exit(13); }
	fread(SourceBlock, 1, SourceSize, fp);
	fclose(fp);
		//printf("Decompressing %lu bytes ...\n", SourceSize );
		printf("Decompressing '%s' (%s bytes, being the compressed stream) ...\n", NewFileName2, _ui64toaKAZEcomma(SourceSize, llTOaDigits2, 10) );
// Warm up...[
	printf("Warming up ...\n");
	for (i = 1; i <= Trials*4; i++) {
		TargetSize = LZSSE2_Decompress( SourceBlock, SourceSize, TargetBlock, TargetSize );
		TargetSize2=SourceSize;
	}
// Warm up...]
// Attempt to pick up the Turbomode score... [
clocks0 = clock();
ticksTOTAL = 0;
#if defined(_icl_mumbo_jumbo_)
ticksStart = GetRDTSC();
#endif
	k1=0;
	printf("RAM-to-RAM performance:\n");
if (TargetSize < (1UL<<20)) {Trials=8192; printf("The file is smaller than 1MB, increasing trials to %d.\n",Trials);}
	for (j = 1; j <= 16*8; j++) {
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
	for (i = 1; i <= Trials; i++) {
		TargetSize = LZSSE2_Decompress( SourceBlock, SourceSize, TargetBlock, TargetSize );
	}
		clocks2 = clock();
		k = (((double)CLOCKS_PER_SEC*TargetSize/(double)(clocks2 - clocks1 + 1))); k=k*Trials; k=k>>20; 
			if (j%16==0) printf("%d MB/s\n", k); else printf("%d MB/s; ", k);
			if (j%16==0) {
				printf("Enforcing 17 seconds idling to avoid throttling ...\n", k);
				clocks1 = clock();
				while (clocks1 + (double)CLOCKS_PER_SEC*17 > clock() );
			}
	if (k1<k) k1=k;
	}
	k=k1;
	k3=k;
#if defined(_icl_mumbo_jumbo_)
ticksTOTAL = ticksTOTAL + GetRDTSC() - ticksStart;
printf("This CPU seems to be working at %s MHz, or more due to ensleeping.\n", _ui64toaKAZEcomma(ticksTOTAL/((double)(clock() - clocks0 + 1)/(double)CLOCKS_PER_SEC)/1000000, llTOaDigits, 10));	
#endif

// Attempt to pick up the Turbomode score... ]
		printf("RAM-to-RAM (peak) performance: %d MB/s.\n", k);
	printf("Nakamichi 'Ryuugan' vs LZSSE2 17, c.size: %.2fx\n", (double)(TargetSize1) / (double)(TargetSize2)  );
	printf("LZSSE2 17 vs Nakamichi 'Ryuugan', d.rate: %.2fx\n", (double)(k3) / (double)(k2)  );
	printf("Bottomline:\n", k);
	printf("Nakamichi 'Ryuugan' expanding %.2fx to %s at %d MB/s.\n", (double)(TargetSize) / (double)(TargetSize1), _ui64toaKAZEcomma(TargetSize, llTOaDigits2, 10), k2 );
	}
#endif
// LZSSE2 ]
// DECOMPRESSING ]
	} else {
// COMPRESSING [

	if (argc==6) { // overwrite the 'DEFINE' defaults

HashInBITS_GLOBAL= atoi(argv[3]);
HashChunkSizeInBITS_GLOBAL= atoi(argv[3]);

	if (*argv[5]=='i')  {
BSTorBtree=3;
	}
	if (*argv[5]=='I')  {
BSTorBtree=3;
if (HashInBITS_GLOBAL > 7) HashChunkSizeInBITS_GLOBAL= HashInBITS_GLOBAL - 7;
	}
	if (*argv[5]=='e') {
BSTorBtree=2;
	}
	if (*argv[5]=='E') {
BSTorBtree=2;
if (HashInBITS_GLOBAL > 7) HashChunkSizeInBITS_GLOBAL= HashInBITS_GLOBAL - 7;
	}

RAMpoolInKB_GLOBAL= atoi(argv[4]);

#ifdef LITE
printf("This compile uses B-trees only, no memmem() invocations - it compresses worse but much faster.\n"); // 2020-Feb-14
#endif
	
	}

	Trials=256;
	printf("Allocating Source-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
	SourceBlock = (char*)malloc(SourceSize+512);
	if( SourceBlock == NULL )
		{ printf("Nakamichi: Needed memory (%sMB) allocation denied!\n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10)); exit(13); }

	GLOBAL_SourceBlock = SourceBlock; //btree matchfinder needed
	GLOBAL_CurrentPositionForReading_TAILforLookAhead = SourceBlock; //btree matchfinder needed

	for (i = 0; i < MatchLensNUM; i++) 
		GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[i] = SourceBlock; // 2020-Jan-25

	printf("Allocating Source-Buffer %s MB (REVERSED) ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
	SourceBlockREVERSED = (char*)malloc(SourceSize+512);
	if( SourceBlockREVERSED == NULL )
		{ printf("Nakamichi: Needed memory (%sMB) allocation denied!\n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10)); exit(13); }
	printf("Allocating Target-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024)>>20, llTOaDigits2, 10) );
	TargetBlock = (char*)malloc(SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024); //+32*1024*1024, some files may be expanded instead of compressed.
	if( TargetBlock == NULL )
		{ printf("Nakamichi: Needed memory (%sMB) allocation denied!\n", _ui64toaKAZEcomma((SourceSize+512+(unsigned long long)SpeedUpBuilding*1024*1024)>>20, llTOaDigits2, 10)); free(SourceBlock); exit(13); }
	// Allocating before the compression, TO TRY TO AVOID JUST-MAPPING [
	//printf("Allocating Verification-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
	//VerifyBlock = (char*)malloc(SourceSize+512); // 2019-Dec-04
	//if( VerifyBlock == NULL )
	//{ printf("Nakamichi: Needed memory (%sMB) allocation denied!\n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10)); exit(13); }
	// Allocating before the compression, TO TRY TO AVOID JUST-MAPPING ]
	fread(SourceBlock, 1, SourceSize, fp);
	fclose(fp);
	for (i64 = 1; i64 <= SourceSize; i64++) { // 2020-Feb-26
		SourceBlockREVERSED[i64-1]=SourceBlock[SourceSize-i64]; // 2020-Feb-26 // Again in 2020-Apr-12
	}

// Leprechaun BBhex [[
// B_tree(argc, argv, SourceBlock, SourceSize); // This is the generic one (2019-Aug-06, the shared one on GIST/LTCB), it inserts ALL keys into B-trees, good for general searching also, but too heavy for compression.
//B_tree_Non_Unique_Only(argc, argv, SourceBlock, SourceSize, TargetBlock); // This one adds another pass before the old one, it uses the last (the buffer for verification) N in size malloc() for building B-trees - for speed. Then it proceeds again with the same pass but builds either on E or I while checking whether the current/candidate key is with occurrence >1, if so, then skip it and not insert it. SHARED on centminmod forum
B_tree_Non_Unique_Only_DEFRAGMENTED(argc, argv, SourceBlock, SourceSize, TargetBlock); // This is the successor of above/fragmented revision of 2019-Dec-19 - it has defragmented B-trees - all leaves are in one continuous block

// Leprechaun BBhex ]]

		//printf("Compressing %lu bytes ...\n", SourceSize );
		printf("Compressing %s bytes ...\n", _ui64toaKAZEcomma(SourceSize, llTOaDigits2, 10) );
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
		time1=time(NULL); //fix of bigtime
		TargetSize = Compress(TargetBlock, SourceBlock, SourceBlockREVERSED, SourceSize);
		//free(SourceBlockREVERSED); // 2019-Dec-07
		TargetSize1=TargetSize;
		clocks2 = clock();
		//k = (((double)CLOCKS_PER_SEC*SourceSize/(double)(clocks2 - clocks1 + 1))); //k=k>>10;
		k=(double)SourceSize/(double)(time(NULL) - time1 + 1);
		printf("RAM-to-RAM performance: %d B/s.\n", k);
		strcpy(NewFileName, argv[1]);
		strcat(NewFileName, Nakamichi);
		//printf("Compressed to %d bytes.\n", TargetSize );
		printf("Compressed to %s bytes.\n", _ui64toaKAZEcomma(TargetSize, llTOaDigits2, 10) );
		Filehash = FNV1A_Hash_YoshimitsuTRIAD(SourceBlock, SourceSize);
		printf("Source-file-Hash(FNV1A_YoshimitsuTRIAD) = 0x%s\n", _ui64toaKAZEzerocomma4(Filehash, llTOaDigits2, 16)+(26-8-1) );
		printf("Target-file-Hash(FNV1A_YoshimitsuTRIAD) = 0x%s\n", _ui64toaKAZEzerocomma4(FNV1A_Hash_YoshimitsuTRIAD(TargetBlock, TargetSize), llTOaDigits2, 16)+(26-8-1) );
	//if ((fp = fopen(NewFileName, "wb")) == NULL) { 
	if ((fp = fopen(argv[2], "wb")) == NULL) { // 2020-Jan-13:
//		printf("Nakamichi: Can't write '%s' file.\n", NewFileName); exit(13);
		printf("Nakamichi: Can't write '%s' file.\n", argv[2]); exit(13); // 2020-Jan-13:
	}
	//fwrite(TargetBlock, 1, TargetSize, fp); // Caramba: It doesn't work when file is 4+GB long!
	if (TargetSize <= OneMB) {
		fwrite(TargetBlock, 1, TargetSize, fp);
	} else {
		for (DoOffset = 0; DoOffset+OneMB < TargetSize; DoOffset=DoOffset+OneMB) {
			fwrite(TargetBlock+DoOffset, 1, OneMB, fp);
		}
		//if (DoOffset+OneMB >= TargetSize) {
			fwrite(TargetBlock+DoOffset, 1, TargetSize - DoOffset, fp);
	}
	fclose(fp);
		printf("Decompressing %s (being the compressed stream) bytes ...\n", _ui64toaKAZEcomma(TargetSize, llTOaDigits2, 10) );
		printf("RAM-to-RAM performance: ");
	kMAXIMUM = 0;
	if (SourceSize < (1LL<<20)) Trials = 7777; else Trials = 77;
	for (j = 1; j <= 5; j++) {
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
	for (i = 1; i <= Trials; i++) {
		//VerifySize = Decompress(VerifyBlock, TargetBlock, TargetSize); // 2019-Dec-07
		VerifySize = Decompress(SourceBlockREVERSED, TargetBlock, TargetSize); // 2019-Dec-07
	}
		clocks2 = clock();
		k1 = (((double)CLOCKS_PER_SEC*VerifySize/(double)(clocks2 - clocks1 + 1))); k1=k1*Trials; k1=k1>>20; 
		printf("%s MB/s (Trials = %s); ", _ui64toaKAZEcomma(k1, llTOaDigits3, 10), _ui64toaKAZEcomma(Trials, llTOaDigits2, 10));
	if (k1 > kMAXIMUM) kMAXIMUM = k1;
	Trials = Trials*2;
	} //j
		k1 = kMAXIMUM;
		printf(": %d MB/s\n",k1);
		if(VerifySize == SourceSize) printf("Verification (input and output sizes match) OK.\n"); else printf("Verification (input and output sizes mismatch) FAILED!\n");
		//if (memcmp(SourceBlock, SourceBlockREVERSED, SourceSize)==0) printf("Verification (input and output blocks match) OK.\n"); else printf("Verification (input and output blocks mismatch) FAILED!\n"); // 2019-Dec-07
		if (memcmp(SourceBlock, SourceBlockREVERSED, SourceSize)==0) printf("Verification (input and output blocks match) OK.\n"); else printf("Verification (input and output blocks mismatch) FAILED!\n"); // 2019-Dec-07

// LZSSE2 [
#ifdef _N_alone
#else

		printf("LZSSE2: Compressing with LZSSE2 (level 17) %s bytes ...\n", _ui64toaKAZEcomma(SourceSize, llTOaDigits2, 10) );
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
		s = LZSSE2_MakeOptimalParseState(SourceSize);
		if(s==NULL) { printf("Errorful compression, allocation stage!\n"); exit(13); }; 
		TargetSize = LZSSE2_CompressOptimalParse( s, SourceBlock, SourceSize, TargetBlock, SourceSize+3*1024*1024, 17 );
		TargetSize2=TargetSize;
		if (TargetSize == 0) { printf("Errorful compression!\n"); exit(13); }; 
		LZSSE2_FreeOptimalParseState(s);
		//printf("LZSSE2: Compressed to %d bytes.\n", TargetSize );
		printf("LZSSE2: Compressed to %s bytes.\n", _ui64toaKAZEcomma(TargetSize, llTOaDigits2, 10) );
		clocks2 = clock();
		k = (((double)CLOCKS_PER_SEC*SourceSize/(double)(clocks2 - clocks1 + 1))); k=k>>10;
		printf("LZSSE2: RAM-to-RAM performance: %d KB/s.\n", k);
		// Another operation (I/O) TO TRY TO AVOID JUST-MAPPING [
		strcpy(NewFileName2, argv[1]);
		strcat(NewFileName2, LZSSE);
	if ((fp = fopen(NewFileName2, "wb")) == NULL) {
		printf("Nakamichi: Can't write '%s' file.\n", NewFileName2); exit(13);
	}
	fwrite(TargetBlock, 1, TargetSize, fp); // Caramba: It doesn't work when file is 4+GB long!
	fclose(fp);
		// Another operation (I/O) TO TRY TO AVOID JUST-MAPPING ]
//		printf("LZSSE2: Allocating Verification-Buffer %s MB ... \n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10) );
//		VerifyBlock = (char*)malloc(SourceSize+512);
//		if( VerifyBlock == NULL )
//		{ printf("Nakamichi: Needed memory (%sMB) allocation denied!\n", _ui64toaKAZEcomma((SourceSize+512)>>20, llTOaDigits2, 10)); exit(13); }
		printf("LZSSE2: Decompressing %s bytes (being the compressed stream) ...\n", _ui64toaKAZEcomma(TargetSize, llTOaDigits2, 10) );
		printf("LZSSE2: RAM-to-RAM performance: ");
	kMAXIMUM = 0;
	if (SourceSize < (1LL<<20)) Trials = 7777; else Trials = 77;
	for (j = 1; j <= 5; j++) {
		clocks1 = clock();
		while (clocks1 == clock());
		clocks1 = clock();
		for (i = 1; i <= Trials; i++) {
			//VerifySize = LZSSE2_Decompress( TargetBlock, TargetSize, VerifyBlock, SourceSize ); // 2019-Dec-07
			VerifySize = LZSSE2_Decompress( TargetBlock, TargetSize, SourceBlockREVERSED, SourceSize ); // 2019-Dec-07
		}
		clocks2 = clock();
		k2 = (((double)CLOCKS_PER_SEC*VerifySize/(double)(clocks2 - clocks1 + 1))); k2=k2*Trials; k2=k2>>20; 
		printf("%s MB/s (Trials = %s); ", _ui64toaKAZEcomma(k2, llTOaDigits3, 10), _ui64toaKAZEcomma(Trials, llTOaDigits2, 10));
	if (k2 > kMAXIMUM) kMAXIMUM = k2;
	Trials = Trials*2;
	} //j
		k2 = kMAXIMUM;
		printf(": %d MB/s\n",k2);
		if(VerifySize == SourceSize) printf("LZSSE2: Verification (input and output sizes match) OK.\n"); else printf("LZSSE2: Verification (input and output sizes mismatch) FAILED!\n");
		//if (memcmp(SourceBlock, VerifyBlock, SourceSize)==0) printf("LZSSE2: Verification (input and output blocks match) OK.\n"); else printf("LZSSE2: Verification (input and output blocks mismatch) FAILED!\n"); // 2019-Dec-07
		if (memcmp(SourceBlock, SourceBlockREVERSED, SourceSize)==0) printf("LZSSE2: Verification (input and output blocks match) OK.\n"); else printf("LZSSE2: Verification (input and output blocks mismatch) FAILED!\n"); // 2019-Dec-07
#endif
// LZSSE2 ]

#ifdef _N_alone
#else

	printf("LZSSE2 vs Nakamichi 'Ryuugan', c.size: %.2fx\n", (double)(TargetSize2) / (double)(TargetSize1)  );
	if (k1 != 0) 
		printf("LZSSE2 vs Nakamichi 'Ryuugan', d.rate: %.2fx\n", (double)(k2) / (double)(k1)  );
//	else
//		printf("LZSSE2 vs Nakamichi 'Okamigan', quicker: %.2f:1\n", 0  );

	printf("Railgun_INVOCATIONS (the-lower-the-better) = %s\n", _ui64toaKAZEcomma(GLOBAL_Railgun_INVOCATIONS, llTOaDigits2, 10) );
	for (i = 0; i <= 704; i++) { // 2020-Jan-29
		if (GLOBAL_Railgun_INVOCATIONS_ARRAY[i])
		printf("Railgun_INVOCATIONS (for needle %s bytes) = %s\n", _ui64toaKAZEzerocomma(i, llTOaDigits3, 10)+(26-3), _ui64toaKAZEcomma(GLOBAL_Railgun_INVOCATIONS_ARRAY[i], llTOaDigits2, 10) );
	}
	//printf("Railgun_INVOCATIONS for 004:3 = %s\n", _ui64toaKAZEcomma(GLOBAL_Railgun_INVOCATIONS_004_3_bytes, llTOaDigits2, 10) );
	//printf("Railgun_INVOCATIONS for 004:2 = %s\n", _ui64toaKAZEcomma(GLOBAL_Railgun_INVOCATIONS_004_2_bytes, llTOaDigits2, 10) );
	//printf("Railgun_INVOCATIONS for 004:1 = %s\n", _ui64toaKAZEcomma(GLOBAL_Railgun_INVOCATIONS_004_1_bytes, llTOaDigits2, 10) );

#endif
	//free(VerifyBlock); // 2019-Dec-07
	free(SourceBlockREVERSED); // 2019-Dec-07

// COMPRESSING ]
// LOG writing [
	if( ( fp_outLOG = fopen( "Nakamichi.LOG", "a+" ) ) == NULL )
	{ printf( "Nakamichi: Can't open file Nakamichi.LOG.\n" ); return( 1 ); }
#if defined(_WIN32_ENVIRONMENT_)
   // 64bit:
_lseeki64( fileno(fp_outLOG), 0L, SEEK_END );
size_inLINESIXFOURlog = _telli64( fileno(fp_outLOG) );
_lseeki64( fileno(fp_outLOG), 0L, SEEK_SET );
#else
   // 64bit:
fseeko( fp_outLOG, 0L, SEEK_END );
size_inLINESIXFOURlog = ftello( fp_outLOG );
fseeko( fp_outLOG, 0L, SEEK_SET );
#endif /* defined(_WIN32_ENVIRONMENT_)  */
if ( (uint64_t)size_inLINESIXFOURlog == 0 )
	fprintf( fp_outLOG, "| #1 Filesize     | #2 Filehash  | #3 Nakamichi 'EE' c.size/decompressionrate | #4 LZSSE2 c.size/decompressionrate | #5 Filename \n" );
	fprintf( fp_outLOG, "| %s ",  _ui64toaKAZEzerocomma(size_inLINESIXFOUR, llTOaDigits3, 10)+(26-15) );
	fprintf( fp_outLOG, "| 0x%s  ",  _ui64toaKAZEzerocomma4(Filehash, llTOaDigits2, 16)+(26-8-1) );
	fprintf( fp_outLOG, "| %s / %sMB/s                ",  _ui64toaKAZEzerocomma(TargetSize1, llTOaDigits2, 10)+(26-13), _ui64toaKAZEzerocomma(k1, llTOaDigits3, 10)+(26-7) );
#ifdef _N_alone // 2020-Feb-15
#else
	fprintf( fp_outLOG, "| %s / %sMB/s        ",  _ui64toaKAZEzerocomma(TargetSize2, llTOaDigits2, 10)+(26-13), _ui64toaKAZEzerocomma(k2, llTOaDigits3, 10)+(26-7) );
#endif
	fprintf( fp_outLOG, "| %s \n", argv[1] );
	fclose(fp_outLOG);
// LOG writing ]
	}

	if (BandwidthFlag) {
// Benchmark memcpy() [
pointerALIGN = TargetBlock + 64 - (((size_t)TargetBlock) % 64);
//offset=64-int((long)data&63);
printf("Memory pool starting address: %p ... ", pointerALIGN);
if (((uintptr_t)(const void *)pointerALIGN & (64 - 1)) == 0) printf( "64 byte aligned, OK\n"); else printf( "NOT 64 byte aligned, FAILURE\n");
clocks3 = clock();
while (clocks3 == clock());
clocks3 = clock();
printf("Copying a %dMB block 1024 times i.e. %dGB READ + %dGB WRITTEN ...\n", 512, 512, 512);
	for (i = 0; i < 1024; i++) {
	memcpy(pointerALIGN+512*1024*1024, pointerALIGN, 512*1024*1024);
	}
clocks4 = clock();
duration = (double) (clocks4 - clocks3 + 1);
durationGENERIC = duration;
printf("memcpy(): (%dMB block); %dMB copied in %d clocks or %.3fMB per clock\n", 512, 1024*( 512 ), (int) duration, (double)1024*( 512 )/ ((int) duration));

/*
#ifndef _N_GP
clocks3 = clock();
while (clocks3 == clock());
clocks3 = clock();
printf("Copying a %dMB block 1024 times i.e. %dGB READ + %dGB WRITTEN ...\n", 512, 512, 512);
	for (i = 0; i < 1024; i++) {
	memcpy_SSE2_4K_prefetched(pointerALIGN+512*1024*1024, pointerALIGN, 512*1024*1024);
	}
clocks4 = clock();
duration = (double) (clocks4 - clocks3 + 1);
printf("memcpy_SSE2_4K_prefetched(): (%dMB block); %dMB copied in %d clocks or %.3fMB per clock\n", 512, 1024*( 512 ), (int) duration, (double)1024*( 512 )/ ((int) duration));
#endif

#ifdef _N_YMM
clocks3 = clock();
while (clocks3 == clock());
clocks3 = clock();
printf("Copying a %dMB block 1024 times i.e. %dGB READ + %dGB WRITTEN ...\n", 512, 512, 512);
	for (i = 0; i < 1024; i++) {
	memcpy_AVX_4K_prefetched(pointerALIGN+512*1024*1024, pointerALIGN, 512*1024*1024);
	}
clocks4 = clock();
duration = (double) (clocks4 - clocks3 + 1);
printf("memcpy_AVX_4K_prefetched(): (%dMB block); %dMB copied in %d clocks or %.3fMB per clock\n", 512, 1024*( 512 ), (int) duration, (double)1024*( 512 )/ ((int) duration));
#endif
*/
// Benchmark memcpy() ]
//k = (((double)1000*TargetSize/(clocks2 - clocks1 + 1))); k=k>>20;
j = (double)1000*1024*( 512 )/ ((int) durationGENERIC);
printf("RAM-to-RAM performance vs memcpy() ratio (bigger-the-better): %d%%\n", (int)((double)k*100/j));
	}

	free(TargetBlock);
	free(SourceBlock);
	exit(0);
}

// See #30   8:3= 2.6  (1MB) section for replacing Backward 'BawBaw' with Forward 'Trolldom'!
void SearchIntoSlidingWindow(unsigned int* HowManyDittoTagsToEmit, unsigned int* ShortMediumLongOFFSET, uint64_t* retIndex, unsigned int* retMatch, char* refStart,char* refEnd,char* encStart,char* encEnd, char* src, char* srcR, uint64_t srcSize ){
	char* Skip;
	char* FoundAtPosition;
	char* FoundAtPosition2;
	unsigned int match=0;
int i;

// Too lazy to write Railgun-Reverse, it would save many ugly patches...
	char* refStartSW1 = refEnd-(16-1);             // 11b
	char* refStartSW2 = refEnd-(4*8*128-1);        // 10b
	char* refStartSW2ryuu = refEnd-(8*8*128-1);        // 10b
	char* refStartSW3 = refEnd-(1024*8*128-1);     // 01b
	char* refStartSW3ryuu = refEnd-(2*1024*8*128-1);     // 01b
	char* refStartSW4 = refEnd-(256*1024*8*128-1); // 00b
	char* refStartSW5 = refEnd-(512*1024*8*128-1); // 00b
	char* refStartSW5ryuu = refEnd-(128LL*2*512*1024*8*128-1); // 00b
	char* refStartSW6ryuu = refEnd-(1024LL*2*512*1024*8*128-1); // 00b
	char* refStartSW1a = refEnd-(16*1024*8*128-1);  // 11b
	char* refStartSW1b = refEnd-(64*8*128-1);  // 11b
	char* refStartSW1c = refEnd-(256-1);  // 11b
	char* refStartSW1d = refEnd-(256*4-1);  // 11b
	char* refStartSW1d2 = refEnd-(256*8-1);  // 11b
	char* refStartSW1e = refEnd-(64*1024*8*128-1);  // 11b

	char* refStartSW512 = refEnd-(512-1);  // 11b
	char* refStartSW128kb = refEnd-(128*8*128-1);  // 11b

	// In order to avoid the unheardof slowness the 256MB may be reduced to 2MB... // --|
	char* refStartHOT = refEnd-(256*8*128-1);                                      //   |
	char* refStartHOTTER = refEnd-(4*8*128-1);                                     //   |
	char* refStartHOTTERryuu = refEnd-(8*8*128-1);                                     //   |
	char* refStartHOTEST = refEnd-(16-1);                                          //   |
	char* refStartCOLDERbig = refEnd-(1024*8*128-1);                               //   |
	char* refStartCOLDERbigryuu = refEnd-(2*1024*8*128-1);                               //   |
	char* refStartCOLDERERbig = refEnd-(2048*8*128-1);                             //   |
	char* refStartCOLDERERERbig = refEnd-(8192*8*128-1);                           //   |
	char* refStartCOLDERERERERbig = refEnd-(512*1024*8*128-1);                     // <-|
	char* refStartCOLDERERERERbigryuu = refEnd-(128LL*2*512*1024*8*128-1);                     // <-|
	char* refStartCOLDESTbig = refStart;

	*retIndex=0;
	*retMatch=0;
	*ShortMediumLongOFFSET=0;

#ifdef ReplaceBruteForceWithRailgunSwampshineBailOut

//btree [
uint64_t LastSeenOffset_PseudoPointer04=0;
uint64_t LastSeenOffset_PseudoPointer06=0;
uint64_t LastSeenOffset_PseudoPointer08=0;
uint64_t LastSeenOffset_PseudoPointer10=0;
uint64_t LastSeenOffset_PseudoPointer12=0;
uint64_t LastSeenOffset_PseudoPointer14=0;
uint64_t LastSeenOffset_PseudoPointer16=0;
uint64_t LastSeenOffset_PseudoPointer18=0;
uint64_t LastSeenOffset_PseudoPointer[MatchLensNUM];
// Before main() are already defined:
//FILE *fp_outRG; // Global - not to burden the extract/compare function with one more parameter
//char *GLOBAL_HASHPOT; //btree matchfinder needed, the hash table/pool
//char* GLOBAL_SourceBlock; //btree matchfinder needed, the file in-memory itself
//uint64_t GLOBAL_SourceSize; //btree matchfinder needed, the file in-memory itself
//char *GLOBAL_CurrentPositionForReading_TAILforLookAhead; //btree matchfinder needed, updated on each position, step 1, that is

char wrd[LongestLineInclusive+1+8];
int jj, mm;
unsigned long wrdlen;
unsigned long long FoundInLinkedList, Slot; //r.18
uint64_t GettingIndexOfArray;
int KeySize;
unsigned long long PseudoLinkedPointer_64;
unsigned long long PseudoLinkedPointerAUX_64;
int strFLAG;
unsigned long StackPtr;
unsigned long long BSTstack [8192*3];
char SomeByte;
char *TwoDigitHEXlist[256] = {
"00\0",
"01\0",
"02\0",
"03\0",
"04\0",
"05\0",
"06\0",
"07\0",
"08\0",
"09\0",
"0A\0",
"0B\0",
"0C\0",
"0D\0",
"0E\0",
"0F\0",
"10\0",
"11\0",
"12\0",
"13\0",
"14\0",
"15\0",
"16\0",
"17\0",
"18\0",
"19\0",
"1A\0",
"1B\0",
"1C\0",
"1D\0",
"1E\0",
"1F\0",
"20\0",
"21\0",
"22\0",
"23\0",
"24\0",
"25\0",
"26\0",
"27\0",
"28\0",
"29\0",
"2A\0",
"2B\0",
"2C\0",
"2D\0",
"2E\0",
"2F\0",
"30\0",
"31\0",
"32\0",
"33\0",
"34\0",
"35\0",
"36\0",
"37\0",
"38\0",
"39\0",
"3A\0",
"3B\0",
"3C\0",
"3D\0",
"3E\0",
"3F\0",
"40\0",
"41\0",
"42\0",
"43\0",
"44\0",
"45\0",
"46\0",
"47\0",
"48\0",
"49\0",
"4A\0",
"4B\0",
"4C\0",
"4D\0",
"4E\0",
"4F\0",
"50\0",
"51\0",
"52\0",
"53\0",
"54\0",
"55\0",
"56\0",
"57\0",
"58\0",
"59\0",
"5A\0",
"5B\0",
"5C\0",
"5D\0",
"5E\0",
"5F\0",
"60\0",
"61\0",
"62\0",
"63\0",
"64\0",
"65\0",
"66\0",
"67\0",
"68\0",
"69\0",
"6A\0",
"6B\0",
"6C\0",
"6D\0",
"6E\0",
"6F\0",
"70\0",
"71\0",
"72\0",
"73\0",
"74\0",
"75\0",
"76\0",
"77\0",
"78\0",
"79\0",
"7A\0",
"7B\0",
"7C\0",
"7D\0",
"7E\0",
"7F\0",
"80\0",
"81\0",
"82\0",
"83\0",
"84\0",
"85\0",
"86\0",
"87\0",
"88\0",
"89\0",
"8A\0",
"8B\0",
"8C\0",
"8D\0",
"8E\0",
"8F\0",
"90\0",
"91\0",
"92\0",
"93\0",
"94\0",
"95\0",
"96\0",
"97\0",
"98\0",
"99\0",
"9A\0",
"9B\0",
"9C\0",
"9D\0",
"9E\0",
"9F\0",
"A0\0",
"A1\0",
"A2\0",
"A3\0",
"A4\0",
"A5\0",
"A6\0",
"A7\0",
"A8\0",
"A9\0",
"AA\0",
"AB\0",
"AC\0",
"AD\0",
"AE\0",
"AF\0",
"B0\0",
"B1\0",
"B2\0",
"B3\0",
"B4\0",
"B5\0",
"B6\0",
"B7\0",
"B8\0",
"B9\0",
"BA\0",
"BB\0",
"BC\0",
"BD\0",
"BE\0",
"BF\0",
"C0\0",
"C1\0",
"C2\0",
"C3\0",
"C4\0",
"C5\0",
"C6\0",
"C7\0",
"C8\0",
"C9\0",
"CA\0",
"CB\0",
"CC\0",
"CD\0",
"CE\0",
"CF\0",
"D0\0",
"D1\0",
"D2\0",
"D3\0",
"D4\0",
"D5\0",
"D6\0",
"D7\0",
"D8\0",
"D9\0",
"DA\0",
"DB\0",
"DC\0",
"DD\0",
"DE\0",
"DF\0",
"E0\0",
"E1\0",
"E2\0",
"E3\0",
"E4\0",
"E5\0",
"E6\0",
"E7\0",
"E8\0",
"E9\0",
"EA\0",
"EB\0",
"EC\0",
"ED\0",
"EE\0",
"EF\0",
"F0\0",
"F1\0",
"F2\0",
"F3\0",
"F4\0",
"F5\0",
"F6\0",
"F7\0",
"F8\0",
"F9\0",
"FA\0",
"FB\0",
"FC\0",
"FD\0",
"FE\0",
"FF\0"
};
//btree ]

char * di;

// Also, finally it is time to fix the stupid offset (blind for files smaller than the current window) stupidity for small files:
// Simply assign 'refStart' if it is within the current window i.e. between e.g. 'refEnd-(256*8*128-1)' and 'refEnd':

// Nasty bug fixed (pointer getting negative) only here, to be fixed in all the rest variants [
/*
	if ( refStart >= refEnd-(2048*8*128-1) ) refStartHOT = refStart;                //--|
	if ( refStart >= refEnd-(256*8*128-1) ) refStartHOTTER = refStart;              //--|
	if ( refStart >= refEnd-(2*4*8*128-1) ) refStartHOTEST = refStart;              //--|
	if ( refStart >= refEnd-(512*1024*8*128-1) ) refStartCOLDERbig = refStart;      //--|
                                                                                        // \ /
*/
// Nasty bug fixed (pointer getting negative) only here, to be fixed in all the rest variants ]

//	if ( refStart >= refEnd-(256*8*128-1) ) refStartHOT = refStart;
//	if ( refStart >= refEnd-(4*8*128-1) ) refStartHOTTER = refStart;
//	if ( refStart >= refEnd-(16-1) ) refStartHOTEST = refStart;     
//	if ( refStart >= refEnd-(1024*8*128-1) ) refStartCOLDERbig = refStart; 
//	if ( refStart >= refEnd-(2048*8*128-1) ) refStartCOLDERERbig = refStart;

	if ( (256*8*128-1) >= refEnd-refStart ) refStartHOT = refStart;
	if ( (4*8*128-1) >= refEnd-refStart ) refStartHOTTER = refStart;
	if ( (8*8*128-1) >= refEnd-refStart ) refStartHOTTERryuu = refStart;
	if ( (16-1) >= refEnd-refStart ) refStartHOTEST = refStart;     
	if ( (1024*8*128-1) >= refEnd-refStart ) refStartCOLDERbig = refStart; 
	if ( (2*1024*8*128-1) >= refEnd-refStart ) refStartCOLDERbigryuu = refStart; 
	if ( (2048*8*128-1) >= refEnd-refStart ) refStartCOLDERERbig = refStart;

	if ( (8192*8*128-1) >= refEnd-refStart ) refStartCOLDERERERbig = refStart;
	if ( (512*1024*8*128-1) >= refEnd-refStart ) refStartCOLDERERERERbig = refStart;
	if ( (128LL*2*512*1024*8*128-1) >= refEnd-refStart ) refStartCOLDERERERERbigryuu = refStart;

	//printf("%d\n", refStartCOLDERbig); //debug
	//printf("%p\n", refStartCOLDERbig); //debug

	if ( (16-1) >= refEnd-refStart ) refStartSW1 = refStart;     
	if ( (4*8*128-1) >= refEnd-refStart ) refStartSW2 = refStart;     
	if ( (8*8*128-1) >= refEnd-refStart ) refStartSW2ryuu = refStart;     
	if ( (1024*8*128-1) >= refEnd-refStart ) refStartSW3 = refStart;     
	if ( (2*1024*8*128-1) >= refEnd-refStart ) refStartSW3ryuu = refStart;     
	if ( (256*1024*8*128-1) >= refEnd-refStart ) refStartSW4 = refStart;     
	if ( (512*1024*8*128-1) >= refEnd-refStart ) refStartSW5 = refStart;     
	if ( (128LL*2*512*1024*8*128-1) >= refEnd-refStart ) refStartSW5ryuu = refStart;     
	if ( (1024LL*2*512*1024*8*128-1) >= refEnd-refStart ) refStartSW6ryuu = refStart;     
	if ( (16*1024*8*128-1) >= refEnd-refStart ) refStartSW1a = refStart;     
	if ( (64*8*128-1) >= refEnd-refStart ) refStartSW1b = refStart;     
	if ( (256-1) >= refEnd-refStart ) refStartSW1c = refStart;     

	if ( (256*4-1) >= refEnd-refStart ) refStartSW1d = refStart;     
	if ( (256*8-1) >= refEnd-refStart ) refStartSW1d2 = refStart;     
	if ( (64*1024*8*128-1) >= refEnd-refStart ) refStartSW1e = refStart;     

	if ( (512-1) >= refEnd-refStart ) refStartSW512 = refStart;     
	if ( (128*8*128-1) >= refEnd-refStart ) refStartSW128kb = refStart;     

// Sizewise/MatchLenWise priority:
//   4:1=4              (16B) #01 320:(5+1)+1+1+1+1=32     (1TB)
//   8:1=8              (16B) #02 256:(5+1)+1+1+1=  28.4   (1TB)
//  12:1=12             (16B) #03 192:(5+1)+1+1=    24     (1TB)
//  16:1=Flag           (16B) #04 128:(5+1)+1=      18.2   (1TB)
//   4:2=2              (4KB) #05  30:2=            15    (512B)
//   6:2=3             (512B) #06  56:(2+1)+1=      14     (8KB)
//   8:2=4              (4KB) #07  24:2=            12     (4KB)
//  12:2=6              (4KB) #08  12:1=            12     (16B)
//  14:2=7             (512B) #09  56:(3+1)+1=      11.2   (2MB)
//  16:2=8              (4KB) #10  22:2=            11    (512B)
//  22:2=11            (512B) #11  64:(5+1)=        10.6   (1TB)
//  24:2=12             (4KB) #12  30:3=            10   (128KB)
//  30:2=15            (512B) #13  56:(4+1)+1=       9.3 (512MB)
//   4:3=1.3            (1MB) #14  28:(2+1)=         9.3   (8KB)
//   6:3=2            (128KB) #15  36:(2+1)+1=       9     (8KB)
//   8:3=2.6            (1MB) #16  56:(5+1)+1=       8   (128GB)
//  12:3=4              (1MB) #17  24:3=             8     (1MB)
//  14:3=4.6          (128KB) #18  16:2=             8     (4KB)
//  16:3=5.3            (1MB) #19   8:1=             8     (16B)
//  18:(2+1)=6          (8KB) #20  22:3=             7.3 (128KB)
//  22:3=7.3          (128KB) #21  36:(3+1)+1=       7.2   (2MB)
//  24:3=8              (1MB) #22  28:(3+1)=         7     (2MB)
//  28:(2+1)=9.3        (8KB) #23  14:2=             7    (512B)
//  30:3=10           (128KB) #24  36:(4+1)+1=       6   (512MB)
//   6:4=1.5           (16MB) #25  24:4=             6   (256MB)
//   8:4=2             (16MB) #26  18:(2+1)=         6     (8KB)
//  10:4=2.5           (16MB) #27  12:2=             6     (4KB)
//  12:4=3             (16MB) #28  28:(4+1)=         5.6 (512MB)
//  14:4=3.5           (16MB) #29  16:3=             5.3   (1MB)
//  16:4=4            (16MB)F #30  36:(5+1)+1=       5.1 (128GB)
//  18:(3+1)=4.5        (2MB) #31  28:(5+1)=         4.6 (128GB)
//  24:4=6            (256MB) #32  14:3=             4.6 (128KB)
//  28:(3+1)=7          (2MB) #33  18:(3+1)=         4.5   (2MB)
//  36:(2+1)+1=9        (8KB) #34  16:4=             4   (16MB)F
//  56:(2+1)+1=14       (8KB) #35  12:3=             4     (1MB)
//  18:(4+1)=3.6      (512MB) #36   8:2=             4     (4KB)
//  28:(4+1)=5.6      (512MB) #37   4:1=             4     (16B)
//  36:(3+1)+1=7.2      (2MB) #38  18:(4+1)=         3.6 (512MB)
//  56:(3+1)+1=11.2     (2MB) #39  14:4=             3.5  (16MB)
//  18:(5+1)=3        (128GB) #40  18:(5+1)=         3   (128GB)
//  28:(5+1)=4.6      (128GB) #41  12:4=             3    (16MB)
//  36:(4+1)+1=6      (512MB) #42   6:2=             3    (512B)
//  56:(4+1)+1=9.3    (512MB) #43   8:3=             2.6   (1MB)
//  64:(5+1)=10.6       (1TB) #44  10:4=             2.5  (16MB)
//  36:(5+1)+1=5.1    (128GB) #45   8:4=             2    (16MB)
//  56:(5+1)+1=8      (128GB) #46   6:3=             2   (128KB)
// 128:(5+1)+1=18.2     (1TB) #47   4:2=             2     (4KB)
// 192:(5+1)+1+1=24     (1TB) #48   6:4=             1.5  (16MB)
// 256:(5+1)+1+1+1=28.4 (1TB) #49   4:3=             1.3   (1MB)
// 320:(5+1)+1+1+1+1=32 (1TB)

*HowManyDittoTagsToEmit = 0;

//  *96:2+1+1+1=19.2     (4KB)
//  *72:2+1+1=18         (4KB)
//  *96:3+1+1+1=16       (1MB)
//  *48:2+1=16           (4KB)
//  *72:3+1+1=14.4       (1MB)
//  *96:4+1+1+1=13.7   (256MB)
//  *72:4+1+1=12       (256MB)
//  *48:3+1=12           (1MB)
//  *48:4+1=9.6        (256MB)

//  *90:2+1+1=22.5      (512B) 
//  *44:2+1=22          (512B)
// *120:3+1+1+1=20     (128KB)
//  *60:2+1=20          (512B) 
//  *90:3+1+1=18       (128KB)
//  *60:3+1=15         (128KB)
//  *44:3+1=11         (128KB)

goto Jan25;
//btree [

while ( GLOBAL_CurrentPositionForReading_TAILforLookAhead <= encStart ) { // TAIL should become LookAhead (i.e. encStart)
	for (jj=0; jj< MatchLensNUM; jj++) {
		LastSeenOffset_PseudoPointer[jj] = 0; // By Default - Not Seen
		if ( GLOBAL_CurrentPositionForReading_TAILforLookAhead + MatchLens[jj] -1 <= GLOBAL_SourceBlock + GLOBAL_SourceSize -1 ) {

		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead+mm)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];

#ifdef _NSHA3
		if (wrdlen >= 28) {
			FIPS202_SHA3_224((unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen, (unsigned char *)SHA328bytes);
			wrdlen=28;
		}
#endif
		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
#ifdef _NSHA3
		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen );
		else
			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#else
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#endif

	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen);
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); // Changed 2019-Nov-28

	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, GLOBAL_HASHPOT+Slot, 8 );

// 1] Search [ Read the 8 bytes field into LastSeenOffset_PseudoPointer[jj]



                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
			// Impossible, they all have already been inserted...
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead, 8 ); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead, 8 ); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section ]
                      } // while
                    }



// 1] Search ] Write (uint64_t)(GLOBAL_CurrentPositionForReading_TAILforLookAhead) into the 8 bytes field
		}
	} //for (jj=0; 

// Debug the ratio difference [
// Save the first value, in order to start from zero:
//if (GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug == NULL) GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug = GLOBAL_CurrentPositionForReading_TAILforLookAhead;
//
//printf("\nGLOBAL_CurrentPositionForReading_TAILforLookAhead = %s (catching up with encStart = %s): ", _ui64toaKAZEzerocomma4((uint64_t)GLOBAL_CurrentPositionForReading_TAILforLookAhead-(uint64_t)GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug, llTOaDigits2, 16)+(26-8-1), _ui64toaKAZEzerocomma4((uint64_t)encStart-(uint64_t)GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug, llTOaDigits3, 16)+(26-8-1) );
//	for (i=0; i< MatchLensNUM; i++) {
//		if (LastSeenOffset_PseudoPointer[i] == 0)
//			printf(" %s ", _ui64toaKAZEzerocomma4(LastSeenOffset_PseudoPointer[i], llTOaDigits2, 16)+(26-8-1) );
//		else
//			printf(" %s ", _ui64toaKAZEzerocomma4(LastSeenOffset_PseudoPointer[i] -(uint64_t)GLOBAL_CurrentPositionForReading_TAILforLookAhead_ZERO_debug, llTOaDigits2, 16)+(26-8-1) );
//	}
//printf("\n");
// Debug the ratio difference ]

	GLOBAL_CurrentPositionForReading_TAILforLookAhead++;
} // At the end of this loop we should have (in LastSeenOffset_PseudoPointer[]) all matches found for position 'encStart'.

//btree ]


Jan25:
//btree [ 2020-Jan-25, improved updating - not causing fallbacks to memmem() by introducing GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[]

// step #1 of 2: Updating up to the end of Sliding Window
	for (jj=0; jj< MatchLensNUM; jj++) {
		LastSeenOffset_PseudoPointer[jj] = 0; // By Default - Not Seen
//while ( GLOBAL_CurrentPositionForReading_TAILforLookAhead <= encStart ) { // TAIL should become LookAhead (i.e. encStart)
while ( GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj] + MatchLens[jj] -1 <= encStart -1 ) { // TAIL should cover all positions up to the end of Sliding Window i.e. GLUED to the LookAheadBuffer i.e. EncStart ->...]|[EncStart
		//if ( GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj] + MatchLens[jj] -1 <= GLOBAL_SourceBlock + GLOBAL_SourceSize -1 ) {

		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead+mm)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];
#ifdef _NSHA3
		if (wrdlen >= 28) {
			FIPS202_SHA3_224((unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj]), wrdlen, (unsigned char *)SHA328bytes);
			wrdlen=28;
		}
#endif
		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
#ifdef _NSHA3
		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj]), wrdlen );
		else
			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#else
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj]), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#endif

	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen);
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); // Changed 2019-Nov-28

	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, GLOBAL_HASHPOT+Slot, 8 );

// 1] Search [ Read the 8 bytes field into LastSeenOffset_PseudoPointer[jj]


                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
			// Impossible, they all have already been inserted...
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj], 8 ); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj], 8 ); 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section ]
                      } // while
                    }


// 1] Search ] Write (uint64_t)(GLOBAL_CurrentPositionForReading_TAILforLookAhead) into the 8 bytes field
		//}

	GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[jj]++;
} // At the end of this loop we should have (in LastSeenOffset_PseudoPointer[]) all matches found for position 'encStart'.
	} //for (jj=0; 

// step #2 of 2: Loading into LastSeenOffset_PseudoPointer[] the actual LookAheadBuffer i.e. EncStart
GLOBAL_CurrentPositionForReading_TAILforLookAhead = encStart;
while ( GLOBAL_CurrentPositionForReading_TAILforLookAhead <= encStart ) { // TAIL should become LookAhead (i.e. encStart)
	for (jj=0; jj< MatchLensNUM; jj++) {
		LastSeenOffset_PseudoPointer[jj] = 0; // By Default - Not Seen
		if ( GLOBAL_CurrentPositionForReading_TAILforLookAhead + MatchLens[jj] -1 <= GLOBAL_SourceBlock + GLOBAL_SourceSize -1 ) {

		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//		wrdlen=0;
//		memset( &wrd[0], 0, (LongestLineInclusive+1+8) ); //r.18, see below, the old nullifier is commented.
//		for (mm=0; mm< MatchLens[jj]; mm++) {
//			memcpy( &wrd[ wrdlen ], TwoDigitHEXlist[*(unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead+mm)], 2 );
//			wrdlen++;
//			wrdlen++;
//		}
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]

		wrdlen=MatchLens[jj];

#ifdef _NSHA3
		if (wrdlen >= 28) {
			FIPS202_SHA3_224((unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen, (unsigned char *)SHA328bytes);
			wrdlen=28;
		}
#endif
		memcpy( &wrd[ 0 ], &wrdlen, 1 ); // The keysize is 1..255, pretty enough since my needs are 1..28 (up to SHA3-224).
#ifdef _NSHA3
		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen );
		else
			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#else
//		if (wrdlen < 28)
			memcpy( &wrd[ 0+1 ], (unsigned char *)(GLOBAL_CurrentPositionForReading_TAILforLookAhead), wrdlen );
//		else
//			memcpy( &wrd[ 0+1 ], (unsigned char *)SHA328bytes, wrdlen );
#endif

	//Slot = FNV1A_Hash_Jesteress_27bit(wrd +1, wrdlen);
	Slot = FNV1A_Pippip_Yurii(wrd +1, wrdlen); // Changed 2019-Nov-28

	Slot = Slot<<3;
// NEW NEW NEW [ //r.18
	// In here Slot is not within a single pool but in MatchLensNUM sub-pools i.e. MatchLensNUM-way i.e. MatchLensNUM hashpots:
/*
for (GettingIndexOfArray=0; GettingIndexOfArray<MatchLensNUM; GettingIndexOfArray++) {
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed [
//	if ( (wrdlen>>1)==MatchLens[GettingIndexOfArray] ) break;
	if ( (wrdlen)==MatchLens[GettingIndexOfArray] ) break;
		// Since 2019-Feb-07 the length of keys is 1:1 i.e. not HEXed ]
}
*/
	GettingIndexOfArray=jj; // same as above atrocity
	Slot = Slot +(GettingIndexOfArray*(1LL<<HashInBITS_GLOBAL)*8); // CAUTION: 'wrdlen' is halved here, when a new revision comes with 1:1 keysize then change it.
// NEW NEW NEW ] //r.18

//KeySize = LongestLineInclusive; // 'LongestLineInclusive' is for 1-way hashing where different KeySizes can occupy same HASH pool.
KeySize = wrdlen; //r.18, In case multi-way hashing: either the MAX alowed or the 'wrdlen'.

	//Slot = 0; // One Tree only!
	memcpy( &PseudoLinkedPointer_64, GLOBAL_HASHPOT+Slot, 8 );

// 1] Search [ Read the 8 bytes field into LastSeenOffset_PseudoPointer[jj]

                    if (PseudoLinkedPointer_64 == 0) // means EMPTY-SLOT
                    {
			// Impossible, they all have already been inserted...
                    }
                    else // means USED-SLOT
                    { FoundInLinkedList = 0;
                StackPtr = 0;
//                      while (PseudoLinkedPointer != 0 && FoundInLinkedList == 0)
                      while (PseudoLinkedPointer_64 != 0 && FoundInLinkedList == 0)
                      { 
// ***** 'P W P' section [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS LW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) > 0) // go LP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8;
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
			PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64;
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			fread(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( &LEAF[0], (char *)PseudoLinkedPointerAUX_64, 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go LP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 0, 4 ); //LP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 0; //LP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 0; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[0], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4,wrd,wrdlen) < 0) // go RP or MP
                        else if (strFLAG < 0) // go RP or MP
                           { // RW existence check - line below:
//                             if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 ) // RW exists
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4); //RW
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
		       	//fread(&SomeByte, 1, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &SomeByte, &LEAF[8 + 8 + 8 + (KeySize+1+8)], 1 );
			// ]  //r.14+
			if (SomeByte != 0 ) // RW exists
                                { // Here all 'P W P' section is repeated; the way of handling case when dynamic number of words in leaf
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// ***** 'P W P' section 2 [
// LW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4) != 0 )
// RW: existence check if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
                        // here ALWAYS RW exists: no need for existence check - line below
                        // if ( *(char *)(PseudoLinkedPointer+4+4+4+wrdlen) != 0 )
//                        if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) > 0) // go MP
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8 + 8 + (LongestLineInclusive+1+4);
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &FourGramL[0], &LEAF[8 + 8 + 8 + (KeySize+1+8)], (KeySize+1+8) );
			// ]  //r.14+
			//strFLAG=strcmpKAZE13(FourGramL, wrd);
			strFLAG=memcmp(FourGramL +1, wrd +1, wrdlen); // Since 2019-Feb-07, it is not ASCIIZ string but zero byte is the length of the 1..
                        if (strFLAG > 0) // go MP
//                           { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                           }
//                        else if (memcmp(PseudoLinkedPointer+4+4+4+wrdlen,wrd,wrdlen) < 0) // go RP
                        else if (strFLAG < 0) // go RP
//                           { // No ?W after RW - go RP
//                             memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4 + 4, 4 ); //RP
//                             PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                           }
                           { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8 + 8; //RP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 16; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8 + 8], 8 );
			// ]  //r.14+
                           }
                        else { FoundInLinkedList = 1; // wrd is RW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
//			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead, 8 ); // 2020-Feb-02, commented - NO UPDATING!
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8 + (KeySize+1+8)], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section 2 ]
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                }
                             else // RW empty - go MP
//                                { memcpy( &PseudoLinkedPointerNEW, PseudoLinkedPointer + 4, 4 ); //MP
//                                  PseudoLinkedPointer = PseudoLinkedPointerNEW;
//                                }
                                { 
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//PseudoLinkedPointerAUX_64 = PseudoLinkedPointer_64 + 8; //MP
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
                if (StackPtr > 8192*3-1-1) { printf( "\nLeprechaun: Failure! 'B-tree order 3' simulated stack overflow!\n" ); exit( 13 );}
                BSTstack[StackPtr] = PseudoLinkedPointer_64; ++StackPtr; //pt to visited leaf
                BSTstack[StackPtr] = 8; ++StackPtr; //LPoffset=0;MPoffset=8;RPoffset=16;
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
			//fread(&PseudoLinkedPointer_64, 8, 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &PseudoLinkedPointer_64, &LEAF[8], 8 );
			// ]  //r.14+
                                }
                           }
                        else { FoundInLinkedList = 1; // wrd is LW
			// Counter [
				if (BSTorBtree == 2) {
			fsetpos(fp_outRG, (const fpos_t *)&PseudoLinkedPointerAUX_64);
				}
			//memcpy( &CounterOccurrencies, &FourGramL[(KeySize+1+4)-4], 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			memcpy( &LastSeenOffset_PseudoPointer[jj], &FourGramL[(KeySize+1+8)-8], 8 ); 
			//if (CounterOccurrencies<999999999) CounterOccurrencies++;       // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
			//memcpy( &FourGramL[(KeySize+1+4)-4], &CounterOccurrencies, 4 ); // r.18, 4 becomes 8, instead of counter it houses LastSeenOffset
//			memcpy( &FourGramL[(KeySize+1+8)-8], &GLOBAL_CurrentPositionForReading_TAILforLookAhead, 8 ); // 2020-Feb-02, commented - NO UPDATING!
			// [  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			//fwrite(&FourGramL[0], (LongestLineInclusive+1+4), 1, fp_outRG);
			// ]  //r.14+ Optimized I/O i.e. reading a LEAF at once not LEAF's elements one-by-one!
			// [  //r.14+
		  	memcpy( &LEAF[8 + 8 + 8], &FourGramL[0], (KeySize+1+8) );
				if (BSTorBtree == 2) {
			fwrite(&LEAF[0], 8+8+8+2*(KeySize+1+8), 1, fp_outRG); 
				} else { // ########## 64bit memory manipulations [
			memcpy( (char *)PseudoLinkedPointerAUX_64, &LEAF[0], 8+8+8+2*(KeySize+1+8) );
				} // ########## 64bit memory manipulations ]
			// ]  //r.14+
			// Counter ]
			     }
// ***** 'P W P' section ]
                      } // while
                    }

// 1] Search ] Write (uint64_t)(GLOBAL_CurrentPositionForReading_TAILforLookAhead) into the 8 bytes field
		}
	} //for (jj=0; 

	GLOBAL_CurrentPositionForReading_TAILforLookAhead++;
} // At the end of this loop we should have (in LastSeenOffset_PseudoPointer[]) all matches found for position 'encStart'.

//btree ] 2020-Jan-25, improved updating - not causing fallbacks to memmem() by introducing GLOBAL_CurrentPositionForReading_TAILforLookAhead_ARRAY[]

//printf("\nLastSeenOffset_PseudoPointer[7]: %lu\n", LastSeenOffset_PseudoPointer[7]);//debugprint
// LastSeenOffset_PseudoPointer[9] is 64
// LastSeenOffset_PseudoPointer[8] is 36
// LastSeenOffset_PseudoPointer[7] is 18
// LastSeenOffset_PseudoPointer[6] is 16
// LastSeenOffset_PseudoPointer[5] is 14
// LastSeenOffset_PseudoPointer[4] is 12
// LastSeenOffset_PseudoPointer[3] is 10
// LastSeenOffset_PseudoPointer[2] is 8
// LastSeenOffset_PseudoPointer[1] is 6
// LastSeenOffset_PseudoPointer[0] is 4

Skip = NULL;

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

// In order to skip 192,256,320 it is better to try 128 before 192,256,320 - they are slow! [
//#04 128:(5+1)+1=      18.2   (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
	Skip = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*2-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
	}
// In order to skip 192,256,320 it is better to try 128 before 192,256,320 - they are slow! ]

if (Skip!=NULL) {

//#01 704:(5+1)+1+1+1+1+1+1+1+1+1+1=44     (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*11);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*11-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*11);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*11-1);
		} else FoundAtPosition = NULL;

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*11;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 10;
				return;
		}
	}

//#01 320:(5+1)+1+1+1+1=32     (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*5);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*5-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*5);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*5-1);
		} else FoundAtPosition = NULL;

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*5;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 4;
				return;
		}
	}

//#02 256:(5+1)+1+1+1=  28.4   (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*4-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*4-1);
		} else FoundAtPosition = NULL;

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*4;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 3;
				return;
		}
	}

//#03 192:(5+1)+1+1=    24     (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*3-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*3-1);
		} else FoundAtPosition = NULL;

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*3;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

}

		} // B-TREE heuristic


#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

//  90:2+1+1=22.5      (512B) 
	if (refStartSW512 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 30*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(30*3-1), (uint32_t)(refEnd-refStartSW512), 30*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30*3-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30*3;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x7C; // (4+3)C
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 ) 
#endif
		{ // Search into ... If 36 is not found then skip all 36[+] - see the roster above.

//  44:2+1=22          (512B)
	if (refStartSW512 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 22*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(22*2-1), (uint32_t)(refEnd-refStartSW512), 22*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(22*2-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=22*2;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x6C; // (4+3)C
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

// 120:3+1+1+1=20     (128KB)
	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 30*4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(30*4-1), (uint32_t)(refEnd-refStartSW128kb), 30*4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30*4-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30*4;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x3C;
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 3;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[12] != 0 ) // MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48};
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//  60:2+1=20          (512B) 
	if (refStartSW512 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 30*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(30*2-1), (uint32_t)(refEnd-refStartSW512), 30*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30*2-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30*2;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x7C; // (4+3)C
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

//#03a  96:2+1+1+1=19.2     (4KB)
	if (refStartSW2 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24*4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24*4-1), (uint32_t)(refEnd-refStartSW2), 24*4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*4-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*4;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0008; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 3;
				return;
		}
	}


goto Jan27;
if (Skip!=NULL) {	

//#04 128:(5+1)+1=      18.2   (1TB)
	if (refStartSW6ryuu >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*2-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*2-1);
		} else FoundAtPosition = NULL;

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

}
Jan27:


#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[14] != 0 ) 
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#04 128:(5+1)+1=      18.2   (1TB)
	if (refStartSW6ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*2-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW6ryuu <= (char *)LastSeenOffset_PseudoPointer[14] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[14] < (64*2) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64*2-1), (uint64_t)(refEnd-refStartSW6ryuu), 64*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[14];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

   		if (FoundAtPosition!=NULL) {
				*retMatch=64*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

//  90:3+1+1=18       (128KB)
	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 30*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(30*3-1), (uint32_t)(refEnd-refStartSW128kb), 30*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30*3-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30*3;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x3C;
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

//#04a  72:2+1+1=18         (4KB)
	if (refStartSW2 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24*3-1), (uint32_t)(refEnd-refStartSW2), 24*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*3-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*3;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0008; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

//#04b  96:3+1+1+1=16       (1MB)
	if (refStartSW3 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24*4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24*4-1), (uint32_t)(refEnd-refStartSW3), 24*4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*4-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*4;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 3;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[12] != 0 ) // MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48};
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#04c  48:2+1=16           (4KB)
	if (refStartSW2 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW2), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[12] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[12] < (48) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW2), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[12];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=24*2;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0008; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

//  60:3+1=15         (128KB)
	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 30*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(30*2-1), (uint32_t)(refEnd-refStartSW128kb), 30*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30*2-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30*2;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x3C;
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#05  30:2=            15    (512B)
	if (refStartSW512 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 30);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(30-1), (uint32_t)(refEnd-refStartSW512), 30);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x7C; // (4+3)C
				*ShortMediumLongOFFSET=2;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

//#05a  72:3+1+1=14.4       (1MB)
	if (refStartSW3 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24*3-1), (uint32_t)(refEnd-refStartSW3), 24*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*3-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*3;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[13] != 0 ) // MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48};
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#06  56:(2+1)+1=      14     (8KB)
	if (refStartSW2ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW2ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2ryuu <= (char *)LastSeenOffset_PseudoPointer[13] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[13] < (56) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW2ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[13];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=28*2;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFF8)|0x07; // 111, 32:(2+1)=10.6
				*ShortMediumLongOFFSET=2+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

//#06a  96:4+1+1+1=13.7   (256MB)
	if (refStartSW4 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 24*4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(24*4-1), (uint32_t)(refEnd-refStartSW4), 24*4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*4-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*4;
				// The first four bits should be:
				                                                                    // 0000b = 0x0; 6<<2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFFFF0)|0x00; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				*HowManyDittoTagsToEmit = 3;
				return;
		}
	}

//#06b  72:4+1+1=12       (256MB)
	if (refStartSW4 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 24*3);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(24*3-1), (uint32_t)(refEnd-refStartSW4), 24*3);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*3-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=24*3;
				// The first four bits should be:
				                                                                    // 0000b = 0x0; 6<<2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFFFF0)|0x00; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				*HowManyDittoTagsToEmit = 2;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[12] != 0 ) 
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#06c  48:3+1=12           (1MB)
	if (refStartSW3 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW3), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[12] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[12] < (48) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW3), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[12];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=24*2;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[10] != 0 ) // 2020-Jan-01
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#07  24:2=            12     (4KB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTTER >= refStart)
	if (refStartHOTTER < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTTER, encStart, (uint32_t)(refEnd-refStartHOTTER), 24);	
		if (FoundAtPosition!=NULL) {
				*retMatch=24;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0008; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
	if (refStartSW2 >= refStart) {
// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24-1), (uint32_t)(refEnd-refStartSW2), 24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[10] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[10] < (24) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(24-1), (uint32_t)(refEnd-refStartSW2), 24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[10];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=24;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0008; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}

		} // B-TREE heuristic

//#08  12:1=            12     (16B)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTEST >= refStart)
	if (refStartHOTEST < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTEST, encStart, (uint32_t)(refEnd-refStartHOTEST), 12);	
		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                  // 0111b = 7
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0007; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[4] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW1), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1 <= (char *)LastSeenOffset_PseudoPointer[4] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[4] < (12) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW1), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[4];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

// DEBUGed [ -------------------------- THE BUG FIX: ADDING -1 AVOIDS OVERLAPPING --------------------------------------
/*                                                                                                                     |
//                                                                                                                    \ /
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW1), 12);	
		if (FoundAtPosition2!=NULL) {	

	printf("\n 1 = %d\n",(uint32_t)( (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1) ));	
	printf(" 2 = %d\n",(uint32_t)( (srcSize - 1) - (encStart - src) -(12-1) ));	

	if ( FoundAtPosition != src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1) ) {

	printf("\n %p refStartSW1:                                                                [", refStartSW1);	
for (i=0; i<15; i++) {
	printf("%c",*(refStartSW1 +i));	
}
	printf("]");	
	printf("\n %p srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1): [", srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1));	
for (i=0; i<15; i++) {
	printf("%c",*(srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1) +i));	
}
	printf("]\n");	


	printf("\n %p encStart:                                        [", encStart);	
for (i=0; i<12; i++) {
	printf("%c",*(encStart +i));	
}
	printf("]");	
	printf("\n %p srcR + (srcSize - 1) - (encStart - src) -(12-1): [", srcR + (srcSize - 1) - (encStart - src) -(12-1));	
for (i=0; i<12; i++) {
	printf("%c",*(srcR + (srcSize - 1) - (encStart - src) -(12-1) +i));	
}
	printf("]\n");	
*/

//printf("\n (uint32_t)(refEnd-refStartSW1)=%d\n", (uint32_t)(refEnd-refStartSW1)); //(uint32_t)(refEnd-refStartSW1)=15

// 1 = 200108
// 2 = 200097

// 000000000043640D refStartSW1:                                                                [.' Something, s]
// 000000000049818C srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1): [os ,gnihtemoS ']

// 000000000043641C encStart:                                        [omething, so]
// 0000000000498181 srcR + (srcSize - 1) - (encStart - src) -(12-1): [os ,gnihtemo]

//12:1 FoundAtPosition  = 0000000000000000

//FoundAtPosition2 = 000000000049818C
//Mismatch!

                                                         
//                                                                                               DEF0123456789AB
// 000000000043640D refStartSW1:                                                                [.' Something, s] 15
//                                                                                                              CDEF01234567
// 000000000043641C encStart:                                                                                  [omething, so] 12
//
// 000000000049818C srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1):            [os ,gnihtemoS ']
//                                                                                               123456789ABC                                                                                                            
// 0000000000498181 srcR + (srcSize - 1) - (encStart - src) -(12-1):                            [os ,gnihtemo]

// 'omething, so'
// 0812 line: “She said, 'Master Ridley.' She said some crazy thing when we came in the door. 'Play the man,' she said, 'Master Ridley.' Something, something, something.”
// 3127 line: But now there was a long morning's walk until noon, and if the men were silent it was because there was everything to think about and much to remember. Perhaps later in the morning, when the sun was up and had warmed them, they would begin to talk, or just say the things they remembered, to be sure they were there, to be absolutely certain that things were safe in them. Montag felt the slow stir of words, the slow simmer. And when it came to his turn, what could he say, what could he offer on a day like this, to make the trip a little easier? To everything there is a season. Yes. A time to break down, and a time to build up. Yes. A time to keep silence and a time to speak. Yes, all that. But what else. What else? Something, something…

//	printf("\n12:1 FoundAtPosition  = %p\n",FoundAtPosition);	
//	printf("\nFoundAtPosition2 = %p\n",FoundAtPosition2);	

//printf ("Mismatch!\n"); exit(13);}
// DEBUGed ]

		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                  // 0111b = 7
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xF0)|0x0007; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[13] != 0 ) // MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48};
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#09  56:(3+1)+1=      11.2   (2MB)
	if (refStartSW3ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW3ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3ryuu <= (char *)LastSeenOffset_PseudoPointer[13] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[13] < (56) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW3ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[13];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=28*2;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFF8)|0x06; // 011, 32:(3+1)=8
				*ShortMediumLongOFFSET=3+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 ) // MatchLens[MatchLensNUM]={4,6,8,10,12,14,16,18,36,64,24,28,48};
#endif
		{ // Search into ... If 36 is not found then skip all 36[+] - see the roster above.

//  44:3+1=11         (128KB)
	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 22*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(22*2-1), (uint32_t)(refEnd-refStartSW128kb), 22*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(22*2-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=22*2;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x2C;
				*ShortMediumLongOFFSET=3;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) 
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#10  22:2=            11    (512B)
	if (refStartSW512 >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 22);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(22-1), (uint32_t)(refEnd-refStartSW512), 22);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(22-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=22;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x6C;  // (4+2)C
				*ShortMediumLongOFFSET=2;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[9] != 0 ) 
#endif
		{ // Search into ... If 64 is not found then skip all 64[+] - see the roster above.

//#11  64:(5+1)=        10.6   (1TB)
	if (refStartSW6ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64-1), (uint64_t)(refEnd-refStartSW6ryuu), 64);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW6ryuu <= (char *)LastSeenOffset_PseudoPointer[9] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[9] < (64) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW6ryuu, encStart, (uint64_t)(refEnd-refStartSW6ryuu), 64);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW6ryuu - src) -(uint64_t)(refEnd-refStartSW6ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(64-1), (uint64_t)(refEnd-refStartSW6ryuu), 64);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(64-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[9];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

   		if (FoundAtPosition!=NULL) {
				*retMatch=64;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<0)&0xFFFFFFFFFF);
				*ShortMediumLongOFFSET=5+1 +9999;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#12  30:3=            10   (128KB)
	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 30);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(30-1), (uint32_t)(refEnd-refStartSW128kb), 30);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(30-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=30;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x3C;
				*ShortMediumLongOFFSET=3;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[12] != 0 ) 
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#12a  48:4+1=9.6        (256MB)
	if (refStartSW4 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW4), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW4 <= (char *)LastSeenOffset_PseudoPointer[12] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[12] < (48) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 24*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(24*2-1), (uint32_t)(refEnd-refStartSW4), 24*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[12];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=24*2;
				// The first four bits should be:
				                                                                    // 0000b = 0x0; 6<<2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFFFF0)|0x00; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic


#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[13] != 0 ) 
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#13  56:(4+1)+1=       9.3 (512MB)
	if (refStartSW5 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW5), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5 <= (char *)LastSeenOffset_PseudoPointer[13] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[13] < (56) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint32_t)(refEnd-refStartSW5), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[13];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=28*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFF8)|0x05; // 101, 32:(4+1)=6.4
				*ShortMediumLongOFFSET=4+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic


#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#14  28:(2+1)=         9.3   (8KB)
	if (refStartSW2ryuu >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW2ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2ryuu <= (char *)LastSeenOffset_PseudoPointer[11] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[11] < (28) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
// 2020-Feb-02: No need of FALLBACK to memmem() when 'refEnd - (char *)LastSeenOffset_PseudoPointer[11] == (28)' is true, because when SHA3 is used it will search for SHA3 in the ... Uncompressed Block!
//                              refEnd=40=encStart is LookAheadBuffer
//                              \/
// 1         2         3        |4
// 12345678901234567890123456789|0
// Bombastica Playlist Ecstatica|tica
//       [  ]               [  ]
//       ^^^^               ^^^^
// 36+(4-1) is within 1..39
// if (40-36 < 4) then memmem() 
// The buffer starts at refStartSW3ryuu and is long (uint32_t)(refEnd-refStartSW3ryuu) or:
// 1..(40-1) or 1..39

/*
// debugg [[[[[[[[
printf("refEnd - (char *)LastSeenOffset_PseudoPointer[11] = %d\n", refEnd - (char *)LastSeenOffset_PseudoPointer[11]); 
// 0   1     2     3
// Src Src+1 Src+2 Src+3
//                 refEnd
// refEnd-Src = 3-0 = 3
printf("LastSeenOffset_PseudoPointer[11]-src= %x\n", (char *)LastSeenOffset_PseudoPointer[11]-src);
printf("refEnd-src                          = %x\n", refEnd-src);
for (di=(char *)LastSeenOffset_PseudoPointer[11]; di<=refEnd+1; di++)
printf("[%c]", *di);
printf("\n");

// For alice29.txt:
// 
// refEnd - (char *)LastSeenOffset_PseudoPointer[11] = 8
// LastSeenOffset_PseudoPointer[11]-src= 2303             '   *       *       *       *'
// refEnd-src                          = 230b
// [ ][ ][ ][*][ ][ ][ ][ ][ ][ ]
// refEnd - (char *)LastSeenOffset_PseudoPointer[11] = 8
// LastSeenOffset_PseudoPointer[11]-src= 230b
// refEnd-src                          = 2313
// [ ][ ][ ][*][ ][ ][ ][ ][ ][ ]
// 22c0  66 65 65 2c 20 61 6e 64 20 68 6f 74 20 62 75 74 74 65 72 65 64 20 74 6f 61 73 74 2c 29 20 73 68  fee, and hot buttered toast,) sh
// 22e0  65 20 76 65 72 79 20 73 6f 6f 6e 20 66 69 6e 69 73 68 65 64 0d 0a 69 74 20 6f 66 66 2e 0d 0a 0d  e very soon finished..it off....
// 2300  0a 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20  .     *       *       *       *
//                ^[                      |                                                         ]        [                          ]
// 2320  20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 0d 0a 0d 0a 20 20 20 20 20        *       *       *....
// 2340  20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20      *       *       *       *
// 2360  20 20 20 20 2a 20 20 20 20 20 20 20 2a 0d 0a 0d 0a 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20      *       *....     *       *
// 2380  20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20 20 20 20 20 20 20 2a 20        *       *       *       *
// 23a0  20 20 20 20 20 20 2a 0d 0a 0d 0a 20 20 60 57 68 61 74 20 61 20 63 75 72 69 6f 75 73 20 66 65 65        *....  `What a curious fee
// 23c0  6c 69 6e 67 21 27 20 73 61 69 64 20 41 6c 69 63 65 3b 20 60 49 20 6d 75 73 74 20 62 65 20 73 68  ling!' said Alice; `I must be sh
// Before commenting the two lines (where updating happens), they have // 2020-Feb-02 tag:
// Railgun_INVOCATIONS (the-lower-the-better) = 41,640
// Railgun_INVOCATIONS (for needle 004 bytes) = 21,929
// Railgun_INVOCATIONS (for needle 006 bytes) = 12     VANISHES
// Railgun_INVOCATIONS (for needle 008 bytes) = 12,350
// Railgun_INVOCATIONS (for needle 010 bytes) = 3      VANISHES
// Railgun_INVOCATIONS (for needle 012 bytes) = 4,426
// Railgun_INVOCATIONS (for needle 014 bytes) = 6      VANISHES
// Railgun_INVOCATIONS (for needle 016 bytes) = 1      VANISHES
// Railgun_INVOCATIONS (for needle 022 bytes) = 1,827
// Railgun_INVOCATIONS (for needle 024 bytes) = 4      VANISHES
// Railgun_INVOCATIONS (for needle 028 bytes) = 2 <-   VANISHES
// Railgun_INVOCATIONS (for needle 030 bytes) = 346
// Railgun_INVOCATIONS (for needle 036 bytes) = 2      VANISHES
// Railgun_INVOCATIONS (for needle 044 bytes) = 208
// Railgun_INVOCATIONS (for needle 056 bytes) = 167
// Railgun_INVOCATIONS (for needle 060 bytes) = 95
// Railgun_INVOCATIONS (for needle 072 bytes) = 71
// Railgun_INVOCATIONS (for needle 090 bytes) = 54
// Railgun_INVOCATIONS (for needle 096 bytes) = 73
// Railgun_INVOCATIONS (for needle 120 bytes) = 27
// Railgun_INVOCATIONS (for needle 128 bytes) = 29
// Railgun_INVOCATIONS (for needle 192 bytes) = 2
// Railgun_INVOCATIONS (for needle 256 bytes) = 2
// Railgun_INVOCATIONS (for needle 320 bytes) = 2
// Railgun_INVOCATIONS (for needle 704 bytes) = 2
// After commenting the two lines (where updating happens), they have // 2020-Feb-02 tag:
// Railgun_INVOCATIONS (the-lower-the-better) = 41,579
// Railgun_INVOCATIONS (for needle 004 bytes) = 21,919
// Railgun_INVOCATIONS (for needle 008 bytes) = 12,340
// Railgun_INVOCATIONS (for needle 012 bytes) = 4,415
// Railgun_INVOCATIONS (for needle 022 bytes) = 1,827
// Railgun_INVOCATIONS (for needle 030 bytes) = 346
// Railgun_INVOCATIONS (for needle 044 bytes) = 208
// Railgun_INVOCATIONS (for needle 056 bytes) = 167
// Railgun_INVOCATIONS (for needle 060 bytes) = 95
// Railgun_INVOCATIONS (for needle 072 bytes) = 71
// Railgun_INVOCATIONS (for needle 090 bytes) = 54
// Railgun_INVOCATIONS (for needle 096 bytes) = 73
// Railgun_INVOCATIONS (for needle 120 bytes) = 27
// Railgun_INVOCATIONS (for needle 128 bytes) = 29
// Railgun_INVOCATIONS (for needle 192 bytes) = 2
// Railgun_INVOCATIONS (for needle 256 bytes) = 2
// Railgun_INVOCATIONS (for needle 320 bytes) = 2
// Railgun_INVOCATIONS (for needle 704 bytes) = 2
// debugg ]]]]]]]]
*/
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW2ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[11];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=28;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFF8)|0x07; // 111, 32:(2+1)=10.6
				*ShortMediumLongOFFSET=2+1 +3333;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 )
#endif
		{ // Search into ... If 36 is not found then skip all 36[+] - see the roster above.

//#15  36:(2+1)+1=       9     (8KB)
	if (refStartSW2ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW2ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2ryuu <= (char *)LastSeenOffset_PseudoPointer[8] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[8] < (36) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW2ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[8];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=18*2;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFF8)|0x03; // 110, 18:(2+1)=6
				*ShortMediumLongOFFSET=2+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[13] != 0 )
#endif
		{ // Search into ... If 48 is not found then skip all 48[+] - see the roster above.

//#16  56:(5+1)+1=       8   (128GB)
	if (refStartSW5ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint64_t)(refEnd-refStartSW5ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5ryuu <= (char *)LastSeenOffset_PseudoPointer[13] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[13] < (56) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 28*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28*2-1), (uint64_t)(refEnd-refStartSW5ryuu), 28*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[13];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

   		if (FoundAtPosition!=NULL) {
				*retMatch=28*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFFFF8)|0x04; // 001, 32:(5+1)=5.3
				*ShortMediumLongOFFSET=5+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[10] != 0 ) // 2020-Jan-01
#endif
		{ // Search into ... If 18 is not found then skip all 18[+] - see the roster above.

//#17  24:3=             8     (1MB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOT >= refStart)
	if (refStartHOT < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOT, encStart, (uint32_t)(refEnd-refStartHOT), 24);	
		if (FoundAtPosition!=NULL) {
				*retMatch=24;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]

	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartCOLDERbig >= refStart)
	if (refStartCOLDERbig < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartCOLDERbig, encStart, (uint32_t)(refEnd-refStartCOLDERbig), 24);	
		if (FoundAtPosition!=NULL) {
				*retMatch=24;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
	if (refStartSW3 >= refStart) {
// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24-1), (uint32_t)(refEnd-refStartSW3), 24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[10] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[10] < (24) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(24-1), (uint32_t)(refEnd-refStartSW3), 24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(24-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[10];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=24;
				// The first four bits should be:
				                                                                    // 0100b = 4
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0004; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}

		} // B-TREE heuristic

//#18  16:2=             8     (4KB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTTER >= refStart)
	if (refStartHOTTER < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTTER, encStart, (uint32_t)(refEnd-refStartHOTTER), 16);	
		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                  // 0010b = 2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0002; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[6] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW2 >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW2), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[6] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[6] < (16) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW2), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[6];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                  // 0010b = 2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0002; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

//#19   8:1=             8     (16B)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTEST >= refStart)
	if (refStartHOTEST < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTEST, encStart, (uint32_t)(refEnd-refStartHOTEST), 8);	
		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                  // 1011b = B
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000B; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[2] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW1), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1 <= (char *)LastSeenOffset_PseudoPointer[2] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[2] < (8) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW1), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[2];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                  // 1011b = B
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000B; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}
		} // B-TREE heuristic

//#20  22:3=             7.3 (128KB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW128kb >= refStart) {
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 22);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(22-1), (uint32_t)(refEnd-refStartSW128kb), 22);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(22-1);
		} else FoundAtPosition = NULL;

		if (FoundAtPosition!=NULL) {
				*retMatch=22;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x2C;
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

//#21  36:(3+1)+1=       7.2   (2MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW3ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3ryuu <= (char *)LastSeenOffset_PseudoPointer[8] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[8] < (36) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW3ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[8];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=18*2;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFF8)|0x02; // 010, 18:(3+1)=4.5
				*ShortMediumLongOFFSET=3+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}
		} // B-TREE heuristic

//#22  28:(3+1)=         7     (2MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3ryuu >= refStart) {
// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW3ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3ryuu <= (char *)LastSeenOffset_PseudoPointer[11] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[11] < (28) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW3ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[11];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=28;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFF8)|0x06; // 011, 32:(3+1)=8
				*ShortMediumLongOFFSET=3+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#23  14:2=             7    (512B)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[5] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW512 >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW512), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW512 <= (char *)LastSeenOffset_PseudoPointer[5] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[5] < (14) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW512), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[5];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=14;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x5C;  // (4+1)C
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

//#24  36:(4+1)+1=       6   (512MB)
	if (refStartSW5 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW5), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5 <= (char *)LastSeenOffset_PseudoPointer[8] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[8] < (36) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint32_t)(refEnd-refStartSW5), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[8];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=18*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFF8)|0x01; // 100, 18:(4+1)=3.6
				*ShortMediumLongOFFSET=4+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[10] != 0 ) // 2020-Jan-01
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

//#25  24:4=             6   (256MB)
	if (refStartSW4 >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 48-24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(48-24-1), (uint32_t)(refEnd-refStartSW4), 48-24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(48-24-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW4 <= (char *)LastSeenOffset_PseudoPointer[10] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[10] < (24) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW4, encStart, (uint32_t)(refEnd-refStartSW4), 48-24);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW4 - src) -(uint32_t)(refEnd-refStartSW4 -1), srcR + (srcSize - 1) - (encStart - src) -(48-24-1), (uint32_t)(refEnd-refStartSW4), 48-24);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(48-24-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[10];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=48-24;
				// The first four bits should be:
				                                                                    // 0000b = 0x0; 6<<2
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFFFF0)|0x00; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic // 2020-Jan-04

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) // 2020-Jan-01
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18
//#26  18:(2+1)=         6     (8KB)
	if (refStartSW2ryuu >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW2ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(2+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2ryuu <= (char *)LastSeenOffset_PseudoPointer[7] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[7] < (18) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2ryuu, encStart, (uint32_t)(refEnd-refStartSW2ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2ryuu - src) -(uint32_t)(refEnd-refStartSW2ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW2ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(2+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[7];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=18;
				// The first four bits should be:
				                                                                  // 1000b = 8
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFF8)|0x03; // 110, 18:(2+1)=6
				*ShortMediumLongOFFSET=2+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#27  12:2=             6     (4KB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTTER >= refStart)
	if (refStartHOTTER < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTTER, encStart, (uint32_t)(refEnd-refStartHOTTER), 12);	
		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                  // 0110b = 6
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0006; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[4] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW2 >= refStart) {
// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW2), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[4] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[4] < (12) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW2), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[4];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                  // 0110b = 6
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x0006; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

//#28  28:(4+1)=         5.6 (512MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW5 >= refStart) {
// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW5), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5 <= (char *)LastSeenOffset_PseudoPointer[11] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[11] < (28) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint32_t)(refEnd-refStartSW5), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[11];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

		if (FoundAtPosition!=NULL) {
				*retMatch=28;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFF8)|0x05; // 101, 32:(4+1)=6.4
				*ShortMediumLongOFFSET=4+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#29  16:3=             5.3   (1MB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOT >= refStart)
	if (refStartHOT < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOT, encStart, (uint32_t)(refEnd-refStartHOT), 16);	
		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                    // 0001b = 1
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0001; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]

	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartCOLDERbig >= refStart)
	if (refStartCOLDERbig < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartCOLDERbig, encStart, (uint32_t)(refEnd-refStartCOLDERbig), 16);	
		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                    // 0001b = 1
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0001; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[6] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW3), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[6] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[6] < (16) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW3), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[6];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                    // 0001b = 1
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0001; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[8] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

//#30  36:(5+1)+1=       5.1 (128GB)
	if (refStartSW5ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint64_t)(refEnd-refStartSW5ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5ryuu <= (char *)LastSeenOffset_PseudoPointer[8] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[8] < (36) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 18*2);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18*2-1), (uint64_t)(refEnd-refStartSW5ryuu), 18*2);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18*2-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[8];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

   		if (FoundAtPosition!=NULL) {
				*retMatch=18*2;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFFFF8)|0x00; // 000, 18:(5+1)=3
				*ShortMediumLongOFFSET=5+1 +3333;
				*HowManyDittoTagsToEmit = 1;
				return;
		}
	}

		} // B-TREE heuristic

#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[11] != 0 ) // 2020-Jan-01
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

//#31  28:(5+1)=         4.6 (128GB)
	if (refStartSW5ryuu >= refStart) {

// 2020-Jan-01 [
#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint64_t)(refEnd-refStartSW5ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5ryuu <= (char *)LastSeenOffset_PseudoPointer[11] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[11] < (28) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 28);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(28-1), (uint64_t)(refEnd-refStartSW5ryuu), 28);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(28-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[11];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif
// 2020-Jan-01 ]

   		if (FoundAtPosition!=NULL) {
				*retMatch=28;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFFFF8)|0x04; // 001, 32:(5+1)=5.3
				*ShortMediumLongOFFSET=5+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#32  14:3=             4.6 (128KB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[5] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW128kb >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW128kb), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW128kb <= (char *)LastSeenOffset_PseudoPointer[5] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[5] < (14) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW128kb), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[5];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=14;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x1C;
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

//                              refEnd=40=encStart is LookAheadBuffer
//                              \/
// 1         2         3        |4
// 12345678901234567890123456789|0
// Bombastica Playlist Ecstatica|tica
//       [  ]               [  ]
//       ^^^^               ^^^^
// 36+(4-1) is within 1..39
// if (40-36 < 4) then memmem() 
// The buffer starts at refStartSW3ryuu and is long (uint32_t)(refEnd-refStartSW3ryuu) or:
// 1..(40-1) or 1..39
// SearchIntoSlidingWindow(&HowManyDittoTagsToEmit,              &ShortMediumLongOFFSET,              &index,             &match,                 refStart,       &src[srcIndex], &src[srcIndex], encEnd,       src,       srcR,       srcSize);
// SearchIntoSlidingWindow(unsigned int* HowManyDittoTagsToEmit, unsigned int* ShortMediumLongOFFSET, uint64_t* retIndex, unsigned int* retMatch, char* refStart, char* refEnd,   char* encStart, char* encEnd, char* src, char* srcR, uint64_t srcSize ){

//#33  18:(3+1)=         4.5   (2MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW3ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(3+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3ryuu <= (char *)LastSeenOffset_PseudoPointer[7] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[7] < (18) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3ryuu, encStart, (uint32_t)(refEnd-refStartSW3ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3ryuu - src) -(uint32_t)(refEnd-refStartSW3ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW3ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(3+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[7];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=18;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFF8)|0x02; // 010, 18:(3+1)=4.5
				*ShortMediumLongOFFSET=3+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#34  16:4=             4   (16MB)F
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[6] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW1a), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[6] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[6] < (16) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 16);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(16-1), (uint32_t)(refEnd-refStartSW1a), 16);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(16-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[6];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=16;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xA3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#35  12:3=             4     (1MB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOT >= refStart)
	if (refStartHOT < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOT, encStart, (uint32_t)(refEnd-refStartHOT), 12);	
		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0005; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]

	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartCOLDERbig >= refStart)
	if (refStartCOLDERbig < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartCOLDERbig, encStart, (uint32_t)(refEnd-refStartCOLDERbig), 12);	
		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0005; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[4] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW3), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[4] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[4] < (12) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW3), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[4];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                    // 0101b = 5
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0005; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

//#36   8:2=             4     (4KB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTTER >= refStart)
	if (refStartHOTTER < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTTER, encStart, (uint32_t)(refEnd-refStartHOTTER), 8);	
		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                  // 1010b = A
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000A; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[2] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW2 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW2), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[2] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[2] < (8) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW2), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[2];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                  // 1010b = A
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000A; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

//#37   4:1=             4     (16B)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTEST >= refStart)
	if (refStartHOTEST < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTEST, encStart, (uint32_t)(refEnd-refStartHOTEST), 4);	
		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                  // 1111b = F
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000F; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[0] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1 >= refStart) {

#ifndef BtreeHEURISTIC
//GLOBAL_Railgun_INVOCATIONS_004_1_bytes++;
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW1), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1 <= (char *)LastSeenOffset_PseudoPointer[0] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[0] < (4) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//GLOBAL_Railgun_INVOCATIONS_004_1_bytes++;
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1, encStart, (uint32_t)(refEnd-refStartSW1), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1 - src) -(uint32_t)(refEnd-refStartSW1 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW1), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[0];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                  // 1111b = F
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000F; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=1;
				return;
		}
	}
		} // B-TREE heuristic

//#38  18:(4+1)=         3.6 (512MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW5 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW5), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(4+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5 <= (char *)LastSeenOffset_PseudoPointer[7] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[7] < (18) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5, encStart, (uint32_t)(refEnd-refStartSW5), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5 - src) -(uint32_t)(refEnd-refStartSW5 -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint32_t)(refEnd-refStartSW5), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(4+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[7];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=18;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFF8)|0x01; // 100, 18:(4+1)=3.6
				*ShortMediumLongOFFSET=4+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#39  14:4=             3.5  (16MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[5] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW1a), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[5] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[5] < (14) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 14);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(14-1), (uint32_t)(refEnd-refStartSW1a), 14);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(14-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[5];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=14;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xB3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#40  18:(5+1)=         3   (128GB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[7] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW5ryuu >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint64_t)(refEnd-refStartSW5ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(5+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW5ryuu <= (char *)LastSeenOffset_PseudoPointer[7] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[7] < (18) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW5ryuu, encStart, (uint64_t)(refEnd-refStartSW5ryuu), 18);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW5ryuu - src) -(uint64_t)(refEnd-refStartSW5ryuu -1), srcR + (srcSize - 1) - (encStart - src) -(18-1), (uint64_t)(refEnd-refStartSW5ryuu), 18);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(18-1);
//printf("\nFoundAtPosition 18:(5+1): %lu\n", FoundAtPosition);//debugprint
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[7];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

   		if (FoundAtPosition!=NULL) {
				*retMatch=18;
				// The first 8 bits should be 0x93, in order to retain 4bytes-longness of 'retIndex' we play dirty - not tagging the 5bytes chunk with 0x93 but as "usual" - the address subchunk:
				*retIndex=(((refEnd-FoundAtPosition)<<3)&0xFFFFFFFFF8)|0x00; // 000, 18:(5+1)=3
				*ShortMediumLongOFFSET=5+1 +3333;
				return;
		}
	}
		} // B-TREE heuristic

//#41  12:4=             3    (16MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[4] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW1a), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[4] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[4] < (12) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 12);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(12-1), (uint32_t)(refEnd-refStartSW1a), 12);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(12-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[4];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=12;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xC3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#42   6:2=             3    (512B)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[1] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW512 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW512), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW512 <= (char *)LastSeenOffset_PseudoPointer[1] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[1] < (6) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW512, encStart, (uint32_t)(refEnd-refStartSW512), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW512 - src) -(uint32_t)(refEnd-refStartSW512 -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW512), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[1];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=6;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFF80)|0x4C;  // (4+0)C
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

//#43   8:3=             2.6   (1MB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOT >= refStart)
	if (refStartHOT < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOT, encStart, (uint32_t)(refEnd-refStartHOT), 8);	
		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                    // 1001b = 9
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0009; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]

	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartCOLDERbig >= refStart)
	if (refStartCOLDERbig < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartCOLDERbig, encStart, (uint32_t)(refEnd-refStartCOLDERbig), 8);	
		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                    // 1001b = 9
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0009; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
// B-TREE heuristic #2:
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[2] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW3), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[2] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[2] < (8) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW3), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[2];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

// ForwardSearch [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
//	FoundAtPosition2 = Railgun_Trolldom (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW3), 8);	

/*
	printf("\nrefStartSW3, encStart                                                                                                       = %p, %p", refStartSW3, encStart);	
	printf("\nsrcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3), srcR + (srcSize - 1) - (encStart - src) -(8-1)  = %p, %p\n\n", srcR + (srcSize - 1) - (refStartSW3 - src), srcR + (srcSize - 1) - (encStart - src));	

	printf("\nrefStartSW3:                                                                [");	
for (i=0; i<8; i++) {
	printf("%c",*(refStartSW3 +i));	
}
	printf("]");	
	printf("\nsrcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3): [");	
for (i=0; i<8; i++) {
	printf("%c",*(srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3) +i));	
}
	printf("]\n");	

	printf("\nencStart:                                       [");	
for (i=0; i<8; i++) {
	printf("%c",*(encStart +i));	
}
	printf("]");	
	printf("\nsrcR + (srcSize - 1) - (encStart - src) -(8-1): [");	
for (i=0; i<8; i++) {
	printf("%c",*(srcR + (srcSize - 1) - (encStart - src) -(8-1) +i));	
}
	printf("]\n");	
*/

// D:\Nakamichi_Washigan+\Nakamichi_Washigan+ForwardSearch>"Nakamichi_Washigan+.exe" Fahrenheit_451_-_Ray_Bradbury.txt
// ----------------------------------------------------------------------------------------------------------------------------------------------------------------
// refStartSW3, encStart                                                                                                       = 00000000002377C0, 00000000002377C0
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3), srcR + (srcSize - 1) - (encStart - src) -(8-1)  = 00000000002B6D88, 00000000002B6D88

// refStartSW3:                                                                [Fahrenhe]
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3): [F       ]

// encStart:                                       [Fahrenhe]
// srcR + (srcSize - 1) - (encStart - src) -(8-1): [ehnerhaF]
// ----------------------------------------------------------------------------------------------------------------------------------------------------------------
// refStartSW3, encStart                                                                                                       = 00000000002377C0, 00000000002377C1
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3), srcR + (srcSize - 1) - (encStart - src) -(8-1)  = 00000000002B6D88, 00000000002B6D87

// refStartSW3:                                                                [Fahrenhe]
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3): [aF      ]

// encStart:                                       [ahrenhei]
// srcR + (srcSize - 1) - (encStart - src) -(8-1): [iehnerha]
// ----------------------------------------------------------------------------------------------------------------------------------------------------------------
// refStartSW3, encStart                                                                                                       = 00000000002377C0, 00000000002377C2
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3), srcR + (srcSize - 1) - (encStart - src) -(8-1)  = 00000000002B6D88, 00000000002B6D86

// refStartSW3:                                                                [Fahrenhe]
// srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3): [haF     ]

// encStart:                                       [hrenheit]
// srcR + (srcSize - 1) - (encStart - src) -(8-1): [tiehnerh]
// ----------------------------------------------------------------------------------------------------------------------------------------------------------------

// Actual picture:
// 1 2 3 4 5 6 7 8 9 
// -----------------
// 1 2 3 4 2_3 2 3 9
//             < BawBawReverse
// 9 3 2 3_2 4 3 2 1
//   > Trolldom
// Paired with '_' is the match - close to the lookahead.

//		if (FoundAtPosition2!=NULL) {	
//	printf("\nFoundAtPosition  = %p\n",FoundAtPosition);	
//	printf("\nFoundAtPosition2 = %p\n",FoundAtPosition2);	
//	printf("\n%p\n\n",src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1));
//	if ( FoundAtPosition != src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1) ) {printf ("Mismatch!\n"); exit(13);} else printf ("\nMatch!\n");
//	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
//		}
// ForwardSearch ]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                    // 1001b = 9
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x0009; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

//#44  10:4=             2.5  (16MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[3] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 10);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(10-1), (uint32_t)(refEnd-refStartSW1a), 10);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(10-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[3] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[3] < (10) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 10);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(10-1), (uint32_t)(refEnd-refStartSW1a), 10);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(10-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[3];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=10;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xD3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#45   8:4=             2    (16MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[2] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW1a), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[2] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[2] < (8) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 8);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(8-1), (uint32_t)(refEnd-refStartSW1a), 8);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(8-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[2];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=8;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xE3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#46   6:3=             2   (128KB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[1] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW128kb >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW128kb), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW128kb <= (char *)LastSeenOffset_PseudoPointer[1] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[1] < (6) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW128kb, encStart, (uint32_t)(refEnd-refStartSW128kb), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW128kb - src) -(uint32_t)(refEnd-refStartSW128kb -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW128kb), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[1];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=6;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<7)&0xFFFF80)|0x0C;
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

//#47   4:2=             2     (4KB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOTTER >= refStart)
	if (refStartHOTTER < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOTTER, encStart, (uint32_t)(refEnd-refStartHOTTER), 4);	
		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                  // 1110b = E
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000E; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[0] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW2 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW2), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW2 <= (char *)LastSeenOffset_PseudoPointer[0] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[0] < (4) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//GLOBAL_Railgun_INVOCATIONS_004_2_bytes++;
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW2, encStart, (uint32_t)(refEnd-refStartSW2), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW2 - src) -(uint32_t)(refEnd-refStartSW2 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW2), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[0];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                  // 1110b = E
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFF0)|0x000E; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
		} // B-TREE heuristic

//#48   6:4=             1.5  (16MB)
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[1] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW1a >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW1a), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW1a <= (char *)LastSeenOffset_PseudoPointer[1] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[1] < (6) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW1a, encStart, (uint32_t)(refEnd-refStartSW1a), 6);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW1a - src) -(uint32_t)(refEnd-refStartSW1a -1), srcR + (srcSize - 1) - (encStart - src) -(6-1), (uint32_t)(refEnd-refStartSW1a), 6);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(6-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[1];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif

		if (FoundAtPosition!=NULL) {
				*retMatch=6;
				// The first four bits should be:
				                                                                    // 0011b = 0x3; 11xx0011b, xx==11
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFFFFFF00)|0xF3; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=4;
				return;
		}
	}
		} // B-TREE heuristic

//#49   4:3=             1.3   (1MB)
/*
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartHOT >= refStart)
	if (refStartHOT < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartHOT, encStart, (uint32_t)(refEnd-refStartHOT), 4);	
		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                    // 1101b = D
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x000D; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]

	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) [
	if (refStartCOLDERbig >= refStart)
	if (refStartCOLDERbig < refEnd) {
	FoundAtPosition = Railgun_Trolldom_64(refStartCOLDERbig, encStart, (uint32_t)(refEnd-refStartCOLDERbig), 4);	
		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                    // 1101b = D
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x000D; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
	// Pre-emptive strike, matches should be sought close to the lookahead (cache-friendliness) ]
*/
#if defined(BtreeHEURISTIC)
		if ( LastSeenOffset_PseudoPointer[0] != 0 ) 
#endif
		{ // LastSeenOffset_PseudoPointer[0,1,2,3,4,5,6,7] is 4,6,8,10,12,14,16,18

	if (refStartSW3 >= refStart) {

#ifndef BtreeHEURISTIC
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW3), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
#else
		if ( refStartSW3 <= (char *)LastSeenOffset_PseudoPointer[0] ) {
			if ( refEnd - (char *)LastSeenOffset_PseudoPointer[0] < (4) ) { // RETURN TO memmem(), the match cannot overlap with 'refEnd' position - it is the first position of the LookAhead!
			// Fallback to memmem(): [
//GLOBAL_Railgun_INVOCATIONS_004_3_bytes++;
//	FoundAtPosition = Railgun_BawBaw_reverse (refStartSW3, encStart, (uint32_t)(refEnd-refStartSW3), 4);	
	FoundAtPosition2 = Railgun_Trolldom_64 (srcR + (srcSize - 1) - (refStartSW3 - src) -(uint32_t)(refEnd-refStartSW3 -1), srcR + (srcSize - 1) - (encStart - src) -(4-1), (uint32_t)(refEnd-refStartSW3), 4);	
		if (FoundAtPosition2!=NULL) {	
	FoundAtPosition = src + (srcSize - 1) - (FoundAtPosition2 - srcR) -(4-1);
		} else FoundAtPosition = NULL;
			// Fallback to memmem(): ]
			} else FoundAtPosition = (char *)LastSeenOffset_PseudoPointer[0];
//if (FoundAtPosition != (char *)LastSeenOffset_PseudoPointer[0]) printf("\nrefStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = %p-%p:   %p,%p\n", refStartSW3,refEnd, FoundAtPosition,(char *)LastSeenOffset_PseudoPointer[0]); //debugprint
		} else FoundAtPosition = NULL;
#endif


// Note1: Looking how within 'Sherlock' the Btree values are not boundary compliant, we have to fall back to memmem(), see the dump below:
// Note2: Tsuyo was disabled by uncommenting 'goto Skip...'
// Compressing 3,714,387 bytes ...
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-00430047:   00000000,00430045
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-00430048:   00000000,00430046
// |; Each rotation means 64KB are encoded; Speed: 0,032,769 B/s; Done 1%; Compression Ratio: 1.82:1; Matches(16/24/48): 103/46/1; 128[+] long matches: 0; ETA: 0.00 days
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-00449475:   00000000,00449472
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-00449476:   00000000,00449473
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-00449477:   00000000,00449474
// /; Each rotation means 64KB are encoded; Speed: 0,065,536 B/s; Done 3%; Compression Ratio: 2.00:1; Matches(16/24/48): 268/63/1; 128[+] long matches: 0; ETA: 0.00 days
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00430020-0045B144:   0045500C,0045B141
// \; Each rotation means 64KB are encoded; Speed: 0,054,613 B/s; Done 35%; Compression Ratio: 2.63:1; Matches(16/24/48): 7,710/702/6; 128[+] long matches: 0; ETA: 0.00 days
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 0047D423-0057D422:   00000000,0057D41F
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 0047D424-0057D423:   00000000,0057D420
// |; Each rotation means 64KB are encoded; Speed: 0,034,152 B/s; Done 65%; Compression Ratio: 2.81:1; Matches(16/24/48): 18,255/1,938/15; 128[+] long matches: 0; ETA: 0.00 days
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 0058AE76-0068AE75:   00000000,0068AE73
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 0058AE77-0068AE76:   00000000,0068AE74
// \; Each rotation means 64KB are encoded; Speed: 0,024,342 B/s; Done 91%; Compression Ratio: 2.88:1; Matches(16/24/48): 28,524/3,262/27; 128[+] long matches: 20; ETA: 0.00 days
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00679F88-00779F87:   00000000,00779F85
// 
// refStartSW3-refEnd:  FoundAtPosition, (char *)LastSeenOffset_PseudoPointer[0] = 00679F89-00779F88:   00000000,00779F86
// |; Each rotation means 64KB are encoded; Speed: 0,021,595 B/s; Done 100%; Compression Ratio: 2.89:1; Matches(16/24/48): 31,867/3,627/28; 128[+] long matches: 21; ETA: 0.00 days
// NumberOfFullLiterals (lower-the-better): 487
// Tsuyo_HEURISTIC_APPLIED_thrice_back-to-back: 0
// NumberOf(Tiny)Matches[Micro]Window (4)[16B]: 1291
// NumberOfMatches[Bheema]Window [128GB window]: 23
// RAM-to-RAM performance: 21595 B/s.
// Compressed to 1,286,110 bytes.
// Source-file-Hash(FNV1A_YoshimitsuTRIAD) = 0x667c,8403
// Target-file-Hash(FNV1A_YoshimitsuTRIAD) = 0xec71,2979
// Decompressing 1,286,110 (being the compressed stream) bytes ...
// RAM-to-RAM performance: 442 MB/s.
// Verification (input and output sizes match) OK.
// Verification (input and output blocks match) OK.


		if (FoundAtPosition!=NULL) {
				*retMatch=4;
				// The first four bits should be:
				                                                                    // 1101b = D
				*retIndex=(((refEnd-FoundAtPosition)<<4)&0xFFFFF0)|0x000D; // xx ... x[OOLL]
				*ShortMediumLongOFFSET=3;
				return;
		}
	}
		} // B-TREE heuristic

/*
// #35  3:2=    1.5  (256B)  
	if (refStartSW1c >= refStart) {
	FoundAtPosition = Railgun_Baw_reverse (refStartSW1c, encStart, (uint32_t)(refEnd-refStartSW1c), 3);	
		if (FoundAtPosition!=NULL) {
				*retMatch=3;
				// The first four bits should be:
				*retIndex=(((refEnd-FoundAtPosition)<<8)&0xFF00)|0x03; // xx ... x[LLOO]
				*ShortMediumLongOFFSET=2;
				return;
		}
	}
*/


#else				
	while(refStart < refEnd){
		match=SlidingWindowVsLookAheadBuffer(refStart,refEnd,encStart,encEnd);
		if(match > *retMatch){
			*retMatch=match;
			*retIndex=refEnd-refStart;
		}
		if(*retMatch >= Min_Match_BAILOUT_Length) break;
		refStart++;
	}
#endif
}

unsigned int SlidingWindowVsLookAheadBuffer( char* refStart, char* refEnd, char* encStart,char* encEnd){
	int ret = 0;
	while(refStart[ret] == encStart[ret]){
		if(&refStart[ret] >= refEnd) break;
		if(&encStart[ret] >= encEnd) break;
		ret++;
		if(ret >= Min_Match_BAILOUT_Length) break;
	}
	return ret;
}

uint64_t Compress(char* ret, char* src, char* srcR, uint64_t srcSize){
	int FlagPlusONEbyte; // to tag the 2+1,3+1,4+1,5+1 offsets
	int FlagPlusONEbyte1; // to tag the 2+1,3+1,4+1,5+1 offsets
	uint64_t srcIndex=0;
	uint64_t retIndex=0;
	//unsigned int index=0; // Washigan
	uint64_t index=0; // Ryuugan
		//unsigned int index1=0;// Tsuyo
		uint64_t index1=0;// Tsuyo
	unsigned int match=0;
		unsigned int match1=0;// Tsuyo
	unsigned int notMatch=0;
//	unsigned char* notMatchStart=NULL; // This line causes error when /TP is used, so next one is the fix:
	char* notMatchStart=NULL;
	char* refStart=NULL;
		char* refStart1=NULL;
	char* encEnd=NULL;
		char* encEnd1=NULL;
	int Melnitchka=0;
	char *Auberge[4] = {"|\0","/\0","-\0","\\\0"};
	int ProgressIndicator;
	FILE *fpratio;

	unsigned int NumberOfFullLiterals=0;
	int GLOBALmediumT=0;
	int GLOBALshortT=0;
	int GLOBALtinyT=0;
	int GLOBAL24B=0;
	int GLOBAL32B=0;
	int GLOBAL48B=0;
	int GLOBAL3=0;
	int GLOBAL5bytes=0;
	int GLOBAL6bytes=0;
	unsigned int ShortMediumLongOFFSET=0;
		unsigned int ShortMediumLongOFFSET1=0;// Tsuyo
		int TsuyoHEURISTIC;
		long SPD;
		long long TsuyoHEURISTICAPPLIED=0;
		unsigned int HowManyDittoTagsToEmit;
		unsigned int HowManyDittoTagsToEmit1;

	if ((fpratio = fopen("Nakamichi.ratio-graph.csv", "a")) == NULL) {
		printf("Nakamichi: Can't write '%s' file.\n", "Nakamichi.ratio-graph.csv"); exit(13);
	}

	while(srcIndex < srcSize){
		if(srcIndex>=REF_SIZE)
			refStart=&src[srcIndex-REF_SIZE];
		else
			refStart=src;
		if(srcIndex>=srcSize-ENC_SIZE)
			encEnd=&src[srcSize];
		else
			encEnd=&src[srcIndex+ENC_SIZE];
		// Fixing the stupid 'search-beyond-end' bug:
		if(srcIndex+ENC_SIZE < srcSize) {
			SearchIntoSlidingWindow(&HowManyDittoTagsToEmit, &ShortMediumLongOFFSET,&index,&match,refStart,&src[srcIndex],&src[srcIndex],encEnd, src, srcR, srcSize);
			FlagPlusONEbyte = 0;
			if (ShortMediumLongOFFSET > 9999) {ShortMediumLongOFFSET=ShortMediumLongOFFSET-9999; FlagPlusONEbyte = 1;}
			if (ShortMediumLongOFFSET > 3333) {ShortMediumLongOFFSET=ShortMediumLongOFFSET-3333; FlagPlusONEbyte = 2;}
// Large_traffic_log_file_of_a_popular_website_fp.log:
// 1: Size: 2,000,938; Speed: 15051 B/s; NumberOfFullLiterals (lower-the-better): 579; Matches(24/48): 526,996/142,715
// 2: Size: 2,000,557; Speed: 10839 B/s; NumberOfFullLiterals (lower-the-better): 579; Matches(24/48): 526,920/142,857
// 3: Size: 2,000,557; Speed:  8323 B/s; NumberOfFullLiterals (lower-the-better): 579; Matches(24/48): 526,920/142,857

#ifdef GREEDY
goto SKIPTsuyo;
#endif

for (TsuyoHEURISTIC=1; TsuyoHEURISTIC<=3; TsuyoHEURISTIC++) // This is 'Zato' i.e. double 'Tsuyo' - the lookahead heuristic looks one more char ahead. [One level nested i.e. 1..2-1 due to tiny gains.]
{
// Tsuyo [
	if (ShortMediumLongOFFSET != 0)
	if (srcIndex+(1) < srcSize) {
		if(srcIndex+(1)>=REF_SIZE)
			refStart1=&src[srcIndex+(1)-REF_SIZE];
		else
			refStart1=src;
		if(srcIndex+(1)>=srcSize-ENC_SIZE)
			encEnd1=&src[srcSize];
		else
			encEnd1=&src[srcIndex+(1)+ENC_SIZE];
		if(srcIndex+(1)+ENC_SIZE < srcSize) {

				SearchIntoSlidingWindow(&HowManyDittoTagsToEmit1,&ShortMediumLongOFFSET1,&index1,&match1,refStart1,&src[srcIndex+(1)],&src[srcIndex+(1)],encEnd1, src, srcR, srcSize);
			FlagPlusONEbyte1 = 0;
			if (ShortMediumLongOFFSET1 > 9999) {ShortMediumLongOFFSET1=ShortMediumLongOFFSET1-9999; FlagPlusONEbyte1 = 1;}
			if (ShortMediumLongOFFSET1 > 3333) {ShortMediumLongOFFSET1=ShortMediumLongOFFSET1-3333; FlagPlusONEbyte1 = 2;}
	if (ShortMediumLongOFFSET1 != 0)
				if (match/(ShortMediumLongOFFSET+HowManyDittoTagsToEmit) +(1+1)  >= match1/(ShortMediumLongOFFSET1+HowManyDittoTagsToEmit1)) { // a brash heuristic
					break; // Exit the 'for' - simple heuristic, still not handling YES-NO-YES cases...
				}
				else {
					if (TsuyoHEURISTIC==3) TsuyoHEURISTICAPPLIED++;
					match=0; // Pretend nothing to find.

// 1of2
			if(notMatch==0){
				notMatchStart=&ret[retIndex];
				retIndex++;
			}
			//else if (notMatch==(127-64-32)) { 
			else if (notMatch==(127-64-32-16 -(7)-1)) { //127-64-32-16 -(7)=8 lower one more to 7 - for 'ditto' tag
NumberOfFullLiterals++;
				//*notMatchStart=(unsigned char)((127-64-32)<<3);
				*notMatchStart=(unsigned char)((127-64-32-16 -(7)-1)<<(4));
				*notMatchStart=(unsigned char)((127-64-32-16 -(7)-1)<<(4)) | 0x03; // Entag it as Literal
				notMatch=0;
				notMatchStart=&ret[retIndex];
				retIndex++;
			}
			ret[retIndex]=src[srcIndex];
			retIndex++;
			notMatch++;
			srcIndex++;
			if ((srcIndex-1) % (1<<16) > srcIndex % (1<<16)) {
				ProgressIndicator = (int)( (srcIndex+1)*(double)100/(srcSize+1) );
				//SPD=(((double)CLOCKS_PER_SEC*srcIndex/(double)(clock() - clocks1 + 1)));
				SPD=(double)srcIndex/(double)(time(NULL) - time1 + 1);
				if (SPD >9999999) SPD=9999999;
//				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f days  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600*24) );
				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f hours  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600) );
				Melnitchka = Melnitchka & 3; // 0 1 2 3: 00 01 10 11
			}
// 2of2
			ShortMediumLongOFFSET=ShortMediumLongOFFSET1;
			HowManyDittoTagsToEmit=HowManyDittoTagsToEmit1;
			FlagPlusONEbyte =0;
			if (FlagPlusONEbyte1 == 1) FlagPlusONEbyte =1; // Inherit the +1byte tag
			if (FlagPlusONEbyte1 == 2) FlagPlusONEbyte =2; // Inherit the +1byte tag
			index=index1;
			match=match1;

				}

		}
	}
// Tsuyo ]
}
SKIPTsuyo:
			if ( ShortMediumLongOFFSET==1 && match==4 ) GLOBALtinyT++;
			if ( ShortMediumLongOFFSET==1 && match==8 ) GLOBALshortT++;
			if ( ShortMediumLongOFFSET==1 && match==12 ) GLOBALmediumT++;
			if ( match==16 ) GLOBAL24B++;
			if ( match==24 ) GLOBAL32B++;
			if ( match==48 ) GLOBAL48B++;
			if ( match==3 ) GLOBAL3++;
			//if ( ShortMediumLongOFFSET==5 ) GLOBAL5bytes++;
			if ( match>=128 ) GLOBAL5bytes++;
			if ( ShortMediumLongOFFSET==6 ) GLOBAL6bytes++;
		}
		else
			match=0; // Nothing to find.
		//if ( match<Min_Match_Length ) {
		//if ( match<Min_Match_Length || match<8 ) {
  		if ( match==0 ) {
			if(notMatch==0){
				notMatchStart=&ret[retIndex];
				retIndex++;
			}
			//else if (notMatch==(127-64-32)) {
			else if (notMatch==(127-64-32-16 -(7)-1)) {
NumberOfFullLiterals++;
				//*notMatchStart=(unsigned char)((127-64-32)<<3);
				*notMatchStart=(unsigned char)((127-64-32-16 -(7)-1)<<(4));
				*notMatchStart=(unsigned char)((127-64-32-16 -(7)-1)<<(4)) | 0x03; // Entag it as Literal
				notMatch=0;
				notMatchStart=&ret[retIndex];
				retIndex++;
			}
			ret[retIndex]=src[srcIndex];
			retIndex++;
			notMatch++;
			srcIndex++;
			if ((srcIndex-1) % (1<<16) > srcIndex % (1<<16)) {
				ProgressIndicator = (int)( (srcIndex+1)*(double)100/(srcSize+1) );
				//SPD=(((double)CLOCKS_PER_SEC*srcIndex/(double)(clock() - clocks1 + 1)));
				SPD=(double)srcIndex/(double)(time(NULL) - time1 + 1);
				if (SPD >9999999) SPD=9999999;
//				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f days  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600*24) );
				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f hours  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600) );
				Melnitchka = Melnitchka & 3; // 0 1 2 3: 00 01 10 11
	fprintf( fpratio, "%.2f,", (double)(srcIndex) / (double)(retIndex) );
			}
		} else {
			if(notMatch > 0){
				*notMatchStart=(unsigned char)((notMatch)<<(4));
				*notMatchStart=(unsigned char)((notMatch)<<(4)) | 0x03; // Entag it as Literal
				notMatch=0;
			}
// ---------------------| 
//                     \ /

			//ret[retIndex] = 0x80; // Assuming seventh/fifteenth bit is zero i.e. LONG MATCH i.e. Min_Match_BAILOUT_Length*4
	  		//if ( match==Min_Match_BAILOUT_Length ) ret[retIndex] = 0xC0; // 8bit&7bit set, SHORT MATCH if seventh/fifteenth bit is not zero i.e. Min_Match_BAILOUT_Length
//                     / \
// ---------------------|
/*
			ret[retIndex] = 0x01; // Assuming seventh/fifteenth bit is zero i.e. LONG MATCH i.e. Min_Match_BAILOUT_Length*4
	  		if ( match==Min_Match_BAILOUT_Length ) ret[retIndex] = 0x03; // 2bit&1bit set, LONG MATCH if 2bit is not zero i.e. Min_Match_BAILOUT_Length
*/
// No need of above, during compression we demanded lowest 2bits to be not 00.
			// 1bit+3bits+12bits:
			//ret[retIndex] = ret[retIndex] | ((match-Min_Match_Length)<<4);
			//ret[retIndex] = ret[retIndex] | (((index-Min_Match_Length) & 0x0F00)>>8);
			// 1bit+1bit+14bits:
			//ret[retIndex] = ret[retIndex] | ((match-Min_Match_Length)<<(8-(LengthBITS+1))); // No need to set the matchlength
// The fragment below is outrageously ineffective - instead of 8bit&7bit I have to use the lower TWO bits i.e. 2bit&1bit as flags, thus in decompressing one WORD can be fetched instead of two BYTE loads followed by SHR by 2.
// ---------------------| 
//                     \ /
			//ret[retIndex] = ret[retIndex] | (((index-Min_Match_Length) & 0x3F00)>>8); // 2+4+8=14
			//retIndex++;
			//ret[retIndex] = (char)((index-Min_Match_Length) & 0x00FF);
			//retIndex++;
//                     / \
// ---------------------|
			// Now the situation is like LOW:HIGH i.e. FF:3F i.e. 0x3FFF, 16bit&15bit used as flags,
			// should become LOW:HIGH i.e. FC:FF i.e. 0xFFFC, 2bit&1bit used as flags.
/*
			ret[retIndex] = ret[retIndex] | (((index-Min_Match_Length) & 0x00FF)<<2); // 6+8=14
			//ret[retIndex] = ret[retIndex] | (((index-Min_Match_Length) & 0x00FF)<<1); // 7+8=15
			retIndex++;
			ret[retIndex] = (char)(((index-Min_Match_Length) & 0x3FFF)>>6);
			//ret[retIndex] = (char)(((index-Min_Match_Length) & 0x7FFF)>>7);
			retIndex++;
*/
// No need of above, during compression we demanded lowest 2bits to be not 00, use the full 16bits and get rid of the stupid '+/-' Min_Match_Length.
			//if (index>0xFFFF) {printf ("\nFatal error: Overflow!\n"); exit(13);}
			//memcpy(&ret[retIndex],&index,2+1); // copy lower 2 bytes
			//retIndex++;
			//retIndex++;
			 //retIndex++;

			if (FlagPlusONEbyte == 2) {
			ret[retIndex]=0x03;
			memcpy(&ret[retIndex+1],&index,ShortMediumLongOFFSET-1);
			} else if (FlagPlusONEbyte == 1) {
			ret[retIndex]=0x93;
			memcpy(&ret[retIndex+1],&index,ShortMediumLongOFFSET-1);
			} else
			memcpy(&ret[retIndex],&index,ShortMediumLongOFFSET);
			retIndex = retIndex + ShortMediumLongOFFSET;
			while (HowManyDittoTagsToEmit--) {
				ret[retIndex++]=0x83;
			}
//                     / \
// ---------------------|
			srcIndex+=match;
			if ((srcIndex-match) % (1<<16) > srcIndex % (1<<16)) {
				ProgressIndicator = (int)( (srcIndex+1)*(double)100/(srcSize+1) );
				//SPD=(((double)CLOCKS_PER_SEC*srcIndex/(double)(clock() - clocks1 + 1)));
				SPD=(double)srcIndex/(double)(time(NULL) - time1 + 1);
				if (SPD >9999999) SPD=9999999;
//				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f days  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600*24) );
				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f hours  \r", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,ProgressIndicator, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), ((double)(srcSize-srcIndex+1)/(SPD+1))/(3600) );
				Melnitchka = Melnitchka & 3; // 0 1 2 3: 00 01 10 11
	fprintf( fpratio, "%.2f,", (double)(srcIndex) / (double)(retIndex) );
			}
		}
	}
	if(notMatch > 0){
		*notMatchStart=(unsigned char)((notMatch)<<(4));
		*notMatchStart=(unsigned char)((notMatch)<<(4)) | 0x03; // Entag it as Literal
	}
	//SPD=(((double)CLOCKS_PER_SEC*srcIndex/(double)(clock() - clocks1 + 1)));
	SPD=(double)srcIndex/(double)(time(NULL) - time1 + 1);
	if (SPD >9999999) SPD=9999999;
//				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f days  \n", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,100, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), 0 );
				printf("%s; Each rotation means 64KB are encoded; Speed: %s B/s; Done %d%%; Compression Ratio: %.2f:1; Matches(16/24/48): %s/%s/%s; 128[+] long matches: %s; ETA: %.2f hours  \n", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(SPD, llTOaDigits4, 10)+(26-9) ,100, (double)(srcIndex) / (double)(retIndex),  _ui64toaKAZEcomma(GLOBAL24B, llTOaDigits2, 10), _ui64toaKAZEcomma(GLOBAL32B, llTOaDigits, 10), _ui64toaKAZEcomma(GLOBAL48B, llTOaDigits3, 10), _ui64toaKAZEcomma(GLOBAL5bytes, llTOaDigits5, 10), 0.0 ); // 2020-Jan-11, it was 0 now 0.0 - huge number?!
	fprintf( fpratio, "%.2f\n", (double)(srcIndex) / (double)(retIndex) );
	printf("NumberOfFullLiterals (lower-the-better): %d\n", NumberOfFullLiterals );
	printf("Tsuyo_HEURISTIC_APPLIED_thrice_back-to-back: %d\n", TsuyoHEURISTICAPPLIED );
//printf("NumberOf(Micro)Matches[Tiny]Window (%d)[%d]: %d\n", 3, 256, GLOBAL3);
printf("NumberOf(Tiny)Matches[Micro]Window (%d)[%dB]: %d\n", 4, 16, GLOBALtinyT);
//printf("NumberOf(Short)Matches[Tiny]Window (%d): %d\n", 8, GLOBALshortT);
//printf("NumberOf(Medium)Matches[Tiny]Window (%d): %d\n", 12, GLOBALmediumT);
//printf("NumberOf(ExtraLong)Matches[Long]Window (%d): %d\n", 24, GLOBAL24B);
//printf("NumberOf(Huge)Matches[Long]Window (%d): %d\n", 48, GLOBAL48B);
printf("NumberOfMatches[Bheema]Window [128GB window]: %d\n", GLOBAL6bytes);

	fclose(fpratio);

	return retIndex;
}

// Nakamichi_Ryuugan+ quick stats: 
/*
08/27/2017  02:49 PM    <DIR>          ..
04/06/2017  08:44 PM           152,089 alice29.txt
08/27/2017  12:48 PM            56,526 alice29.txt.L17.LZSSE2
08/27/2017  12:48 PM            67,579 alice29.txt.Nakamichi
04/06/2017  08:44 PM           260,569 Fahrenheit_451_-_Ray_Bradbury.txt
08/27/2017  12:50 PM           100,387 Fahrenheit_451_-_Ray_Bradbury.txt.L17.LZSSE2
08/27/2017  12:50 PM           115,818 Fahrenheit_451_-_Ray_Bradbury.txt.Nakamichi
04/06/2017  08:44 PM         1,820,160 Fleurs_du_mal.tar
08/27/2017  10:58 AM           557,422 Fleurs_du_mal.tar.L17.LZSSE2
08/27/2017  10:58 AM           414,512 Fleurs_du_mal.tar.Nakamichi
04/06/2017  08:44 PM             8,798 IBM_Deep_Blue_vs_Kasparov.pgn
08/27/2017  12:49 PM             4,803 IBM_Deep_Blue_vs_Kasparov.pgn.L17.LZSSE2
08/27/2017  12:49 PM             5,153 IBM_Deep_Blue_vs_Kasparov.pgn.Nakamichi
08/27/2017  10:46 AM           167,936 Nakamichi_Ryuugan+_(1xQWORD+1xXMM)_Intel_15.0_32bit_SSE41.exe
04/06/2017  08:44 PM         3,680,256 Resident_Evil_(10-books).tar
08/27/2017  02:49 PM         1,343,243 Resident_Evil_(10-books).tar.L17.LZSSE2
08/27/2017  02:49 PM         1,289,461 Resident_Evil_(10-books).tar.Nakamichi
04/06/2017  08:44 PM           698,072 The_Death_Ship_-_B.Traven.pdf.txt
08/27/2017  12:55 PM           258,683 The_Death_Ship_-_B.Traven.pdf.txt.L17.LZSSE2
08/27/2017  12:55 PM           277,889 The_Death_Ship_-_B.Traven.pdf.txt.Nakamichi
07/02/2017  10:06 AM         4,445,260 The_Project_Gutenberg_EBook_of_The_King_James_Bible_kjv10.txt
08/27/2017  12:44 PM         1,390,894 The_Project_Gutenberg_EBook_of_The_King_James_Bible_kjv10.txt.L17.LZSSE2
08/27/2017  12:44 PM         1,356,427 The_Project_Gutenberg_EBook_of_The_King_James_Bible_kjv10.txt.Nakamichi
*/

uint64_t Decompress (char* ret, char* src, uint64_t srcSize) {
	char* retLOCAL = ret;
	char* srcLOCAL = src;
	char* srcEndLOCAL = src+srcSize;
	unsigned int DWORDtrio;
	unsigned int DWORDtrio2;
	unsigned int DWORDtrioDumbo;
	unsigned int MatchLen;
	unsigned int Gear;
	uint64_t QWORDquartet;
	unsigned char MatchLenLUT0[8]; // LookUpTable
// The fisrt 3 bits in section 'Bheema' OOL, OO is offset len; L=1 long, L=0 short match:
MatchLenLUT0[0]=18; // 000, 18:(5+1)=3
MatchLenLUT0[1]=18; // 100, 18:(4+1)=3.6
MatchLenLUT0[2]=18; // 010, 18:(3+1)=4.5
MatchLenLUT0[3]=18; // 110, 18:(2+1)=6
MatchLenLUT0[4]=28; // 001, 32:(5+1)=5.3
MatchLenLUT0[5]=28; // 101, 32:(4+1)=6.4
MatchLenLUT0[6]=28; // 011, 32:(3+1)=8
MatchLenLUT0[7]=28; // 111, 32:(2+1)=10.6
// Instead of using array consider using QWORD variable and shifting it side to side:
// uint64_t MatchLenLUT = 0x2030405012121424; // (MatchLenLUT<<((7-OOL)<<3))>>8*7
// QWORD: [1byte][2byte][3byte][4byte][5byte][6byte][7byte][8byte]
//        LSB                                              MSB
// OO=0                        [OOL_5][  2  ][  3  ][  4  ][  5  ]
// OO=1                               [OOL_5][  2  ][  3  ][  4  ]
// OO=2                                      [OOL_5][  2  ][  3  ]
// OO=3                                             [OOL_5][  2  ]
	while (srcLOCAL < srcEndLOCAL) {
		DWORDtrio = *(unsigned int*)srcLOCAL;
		MatchLen = (DWORDtrio&0x0C); // 0|4|8|12
/*
#ifndef _N_GP
#ifdef _N_prefetch_64
		_mm_prefetch((char*)(srcLOCAL + 64), _MM_HINT_T0);
#endif
#ifdef _N_prefetch_128
		_mm_prefetch((char*)(srcLOCAL + 64*2), _MM_HINT_T0);
#endif
#ifdef _N_prefetch_4096
		_mm_prefetch((char*)(srcLOCAL + 64*64), _MM_HINT_T0);
#endif
#endif
*/

// Sizewise/MatchLenWise priority:
//#01 704:(5+1)+1+1+1+1+1+1+1+1+1+1=44     (1TB)
//#02 320:(5+1)+1+1+1+1=            32     (1TB)
//#03 256:(5+1)+1+1+1=              28.4   (1TB)
//#04 192:(5+1)+1+1=                24     (1TB)
//#05  90:2+1+1=                    22.5  (512B) 
//#06  44:2+1=                      22    (512B)
//#07 120:3+1+1+1=                  20   (128KB)
//#08  60:2+1=                      20    (512B) 
//#09  96:2+1+1+1=                  19.2   (4KB)
//#10 128:(5+1)+1=                  18.2   (1TB)
//#11  90:3+1+1=                    18   (128KB)
//#12  72:2+1+1=                    18     (4KB)
//#13  96:3+1+1+1=                  16     (1MB)
//#14  48:2+1=                      16     (4KB)
//#15  60:3+1=                      15   (128KB)
//#16  30:2=                        15    (512B)
//#17  72:3+1+1=                    14.4   (1MB)
//#18  56:(2+1)+1=                  14     (8KB)
//#19  96:4+1+1+1=                  13.7 (256MB)
//#20  72:4+1+1=                    12   (256MB)
//#21  48:3+1=                      12     (1MB)
//#22  24:2=                        12     (4KB)
//#23  12:1=                        12     (16B)
//#24  56:(3+1)+1=                  11.2   (2MB)
//#25  44:3+1=                      11   (128KB)
//#26  22:2=                        11    (512B)
//#27  64:(5+1)=                    10.6   (1TB)
//#28  30:3=                        10   (128KB)
//#29  48:4+1=                       9.6 (256MB)
//#30  56:(4+1)+1=                   9.3 (512MB)
//#31  28:(2+1)=                     9.3   (8KB)
//#32  36:(2+1)+1=                   9     (8KB)
//#33  56:(5+1)+1=                   8   (128GB)
//#34  24:3=                         8     (1MB)
//#35  16:2=                         8     (4KB)
//#36   8:1=                         8     (16B)
//#37  22:3=                         7.3 (128KB)
//#38  36:(3+1)+1=                   7.2   (2MB)
//#39  28:(3+1)=                     7     (2MB)
//#40  14:2=                         7    (512B)
//#41  36:(4+1)+1=                   6   (512MB)
//#42  24:4=                         6   (256MB)
//#43  18:(2+1)=                     6     (8KB)
//#44  12:2=                         6     (4KB)
//#45  28:(4+1)=                     5.6 (512MB)
//#46  16:3=                         5.3   (1MB)
//#47  36:(5+1)+1=                   5.1 (128GB)
//#48  28:(5+1)=                     4.6 (128GB)
//#49  14:3=                         4.6 (128KB)
//#50  18:(3+1)=                     4.5   (2MB)
//#51  16:4=                         4   (16MB)F
//#52  12:3=                         4     (1MB)
//#53   8:2=                         4     (4KB)
//#54   4:1=                         4     (16B)
//#55  18:(4+1)=                     3.6 (512MB)
//#56  14:4=                         3.5  (16MB)
//#57  18:(5+1)=                     3   (128GB)
//#58  12:4=                         3    (16MB)
//#59   6:2=                         3    (512B)
//#60   8:3=                         2.6   (1MB)
//#61  10:4=                         2.5  (16MB)
//#62   8:4=                         2    (16MB)
//#63   6:3=                         2   (128KB)
//#64   4:2=                         2     (4KB)
//#65   6:4=                         1.5  (16MB)
//#66   4:3=                         1.3   (1MB)

// |1stLSB    |2ndLSB  |3rdLSB   |
// -------------------------------
// |OO|LL|xxxx|xxxxxxxx|xxxxxx|xx|
// -------------------------------
// [1bit          16bit]    24bit]
// LL = 00b means Long MatchLength, (4-LL)<<2 or 16
// LL = 01b means Long MatchLength, (4-LL)<<2 or 12
// LL = 10b means Long MatchLength, (4-LL)<<2 or 8
// LL = 11b means Long MatchLength, (4-LL)<<2 or 4
// xxxx0011b Literals for xxxx in 1..15-7, Matches for 10..15 i.e. Sliding Window is   4*8-8=24 or  16MB
// OO = 00b MatchOffset, 0xFFFFFFFF>>OO, 4 bytes long i.e. Sliding Window is 4*8-LL-OO=4*8-4=28 or 256MB
// OO = 01b MatchOffset, 0xFFFFFFFF>>OO, 3 bytes long i.e. Sliding Window is 3*8-LL-OO=3*8-4=20 or   1MB    
// OO = 10b MatchOffset, 0xFFFFFFFF>>OO, 2 bytes long i.e. Sliding Window is 2*8-LL-OO=2*8-4=12 or   4KB    
// OO = 11b MatchOffset, 0xFFFFFFFF>>OO, 1 byte long  i.e. Sliding Window is 1*8-LL-OO=1*8-4=4 or   16B     

		if ( (DWORDtrio & 0x0F) == 0x03 ) {
		if ( ((DWORDtrio & 0xFF)>>4) <= 7 ) { // 9 not used, only 1..7 for literals, 8 for 'ditto' tag
			// Make next (nested branch) unbranched (https://godbolt.org/#):
			// x = (symbolA <= symbolB) ? countA : 0;
			// x = ((-(symbolA <= symbolB)) & countA);
			if ( ((DWORDtrio & 0xFF)>>4) == 0 ) {
			//        srcLOCAL-2
			//                      srcLOCAL
			//                             srcLOCAL+1
			// QWORD: [1byte][2byte][3byte][4byte][5byte][6byte][7byte][8byte]
			//        LSB                                              MSB
			// OO=0                        [OOL_5][  2  ][  3  ][  4  ][  5  ]
			// OO=1                               [OOL_5][  2  ][  3  ][  4  ]
			// OO=2                                      [OOL_5][  2  ][  3  ]
			// OO=3                                             [OOL_5][  2  ]
			MatchLen = (DWORDtrio>>8)&0x7;
			QWORDquartet = *(uint64_t*)(srcLOCAL+1- (3+(MatchLen&0x3)) ); // Safe since 5bytes backwards reads are less than MatchLengths used here.
			QWORDquartet = QWORDquartet >> (((3+(MatchLen&0x3))<<3)+3);
			srcLOCAL+= 5-(MatchLen&0x3)+1-(1);
ditto1:
			#ifdef _N_GP
				memcpy(retLOCAL, (const char *)( (uint64_t)(retLOCAL-QWORDquartet) ), 32);
			#endif
			#ifdef _N_XMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(0) ), retLOCAL +16*(0));
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(1) ), retLOCAL +16*(1));
			#endif
			#ifdef _N_YMM
				SlowCopy256bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +32*(0) ), retLOCAL +32*(0));
			#endif
			retLOCAL+= MatchLenLUT0[MatchLen];
if (*(unsigned char*)(++srcLOCAL) == 0x83) goto ditto1;
//			*(uint32_t*)(retLOCAL+4*(0)) = *(uint32_t*)(retLOCAL-((DWORDtrio&0xFFFF)>>8)+4*(0)); 
//			retLOCAL+= 3; 
//			srcLOCAL+= 2;
			} else {
//			#ifdef _N_GP
//				memcpy(retLOCAL, (const char *)( (uint64_t)(srcLOCAL+1) ), 16);
//			#endif
//			#ifdef _N_XMM
//				NotSoSlowCopy128bit( (const char *)( (uint64_t)(srcLOCAL+1) ), retLOCAL );
//			#endif
			*(uint64_t*)(retLOCAL) = *(uint64_t*)((const char *)( (uint64_t)(srcLOCAL+1) )); 
			retLOCAL+= ((DWORDtrio & 0xFF)>>4);
			srcLOCAL+= ((DWORDtrio & 0xFF)>>4)+1;
			}
		} else if ( ((DWORDtrio & 0xFF)>>4) > 9 ) {
			#ifdef _N_GP
				memcpy(retLOCAL, (const char *)( (uint64_t)(retLOCAL-(DWORDtrio>>8)) ), 16); // No need of DWORDtrio&0xFFFFFFFF
			#endif
			#ifdef _N_XMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-(DWORDtrio>>8))+16*(0) ), retLOCAL +16*(0));
			#endif
			#ifdef _N_YMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-(DWORDtrio>>8))+16*(0) ), retLOCAL +16*(0));
			#endif
			retLOCAL+= (18 - ((DWORDtrio & 0xFF)>>4))<<1; 
			srcLOCAL+= 4; // 6|8|10|12|14|16 in 16MB window
		} else { // i.e. 8|9
			QWORDquartet = *(uint64_t*)(srcLOCAL+1- (3+(0)) ); // Safe since 5bytes backwards reads are less than MatchLengths used here.
			QWORDquartet = QWORDquartet >> (((3+(0))<<3)+3-(3)); // Full 5x8=40bit i.e. 1TB
srcLOCAL+= 5-(0)+1-(1);
ditto2:
			#ifdef _N_GP
				memcpy(retLOCAL, (const char *)( (uint64_t)(retLOCAL-QWORDquartet) ), 64);
			#endif
			#ifdef _N_XMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(0) ), retLOCAL +16*(0));
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(1) ), retLOCAL +16*(1));
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(2) ), retLOCAL +16*(2));
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +16*(3) ), retLOCAL +16*(3));
			#endif
			#ifdef _N_YMM
				SlowCopy256bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +32*(0) ), retLOCAL +32*(0));
				SlowCopy256bit( (const char *)( (uint64_t)(retLOCAL-QWORDquartet) +32*(1) ), retLOCAL +32*(1));
			#endif
			retLOCAL+= 64;
if (*(unsigned char*)(++srcLOCAL) == 0x83) goto ditto2;
			// To reduce compressed size further consider:
			// if (uint64_t)(retLOCAL - ret)<((1LL)<<(37-8)) srcLOCAL+= 5-(MatchLen&0x3)+1 -1; // gain for 512-MB files
			// if (uint64_t)(retLOCAL - ret)<((1LL)<<(37-8-8)) srcLOCAL+= 5-(MatchLen&0x3)+1 -1-1; // gain for 2-MB files
		}		
		} else if ( (DWORDtrio & 0x0f) == 0x0C ) { 
			// 0011LLGx xxxxxxxx xxxxxxxx, 11LL is matchlength, 2bytes window: 1+8=512B; 3bytes window: 1+8+8=128KB
			Gear = (DWORDtrio>>3)&0x8; // 0/8 is 3/2 bytes respectively
			//*(uint64_t*)(retLOCAL+8*(0)) = *(uint64_t*)((retLOCAL-( (DWORDtrio&((0xFFFFFF)>>Gear))>>7 ))+8*(0)); 
			srcLOCAL+= 3-(Gear>>3) -(1); // ! -(1) is for 'ditto' tag
ditto4:
			#ifdef _N_GP
				memcpy(retLOCAL, (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&((0xFFFFFF)>>Gear))>>7)) ), 32);
			#endif
			#ifdef _N_XMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&((0xFFFFFF)>>Gear))>>7))+16*(0) ), retLOCAL +16*(0));
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&((0xFFFFFF)>>Gear))>>7))+16*(1) ), retLOCAL +16*(1));
			#endif
			#ifdef _N_YMM
				SlowCopy256bit( (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&((0xFFFFFF)>>Gear))>>7))+32*(0) ), retLOCAL +32*(0));
			#endif
			retLOCAL+= (DWORDtrio & 0x3C)>>1; // (12+0)>>1=6 | (12+16)>>1=14 | (12+32)>>1=22 | (12+48)>>1=30
if (*(unsigned char*)(++srcLOCAL) == 0x83) goto ditto4;
		} else if ( (DWORDtrio & 0x03) == 0x00 ) {
			// MatchLen 0|4|8 <<1 0|8|16
			MatchLen=MatchLen<<1; // To avoid 'LEA'
			srcLOCAL+= 4-(MatchLen>>3) -(1); // 24:2, 24:3, 24:4 ! -(1) is for 'ditto' tag
ditto3:
			#ifdef _N_GP
			*(uint64_t*)(retLOCAL+8*(0)) = *(uint64_t*)((retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 ))+8*(0)); 
			*(uint64_t*)(retLOCAL+8*(1)) = *(uint64_t*)((retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 ))+8*(1)); 
			*(uint64_t*)(retLOCAL+8*(2)) = *(uint64_t*)((retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 ))+8*(2)); 
			#endif
			#ifdef _N_XMM
			*(uint64_t*)(retLOCAL+8*(0)) = *(uint64_t*)((retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 ))+8*(0)); 
			NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 ))+8*(1) ), retLOCAL +8*(1));
			#endif
			#ifdef _N_YMM
				SlowCopy256bit( (const char *)( (uint64_t)(retLOCAL-( (DWORDtrio&(0xFFFFFFFF>>MatchLen))>>4 )) ), retLOCAL);
			#endif
			retLOCAL+= 24;
if (*(unsigned char*)(++srcLOCAL) == 0x83) goto ditto3;
		} else {
			DWORDtrioDumbo = (DWORDtrio & 0x03)<<3; // To avoid 'LEA'
			#ifdef _N_GP
				memcpy(retLOCAL, (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&(0xFFFFFFFF>>DWORDtrioDumbo))>>4)) ), 16);
			#endif
			#ifdef _N_XMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&(0xFFFFFFFF>>DWORDtrioDumbo))>>4)) ), retLOCAL );
			#endif
			#ifdef _N_YMM
				NotSoSlowCopy128bit( (const char *)( (uint64_t)(retLOCAL-((DWORDtrio&(0xFFFFFFFF>>DWORDtrioDumbo))>>4)) ), retLOCAL );
			#endif
			retLOCAL+= 16-MatchLen;
			srcLOCAL+= 4-(DWORDtrioDumbo>>3);
		}
	}        
	return (uint64_t)(retLOCAL - ret);
}

/*
; 'Ryuugan-ditto-1TB' decompression loop, 251-4c+5=522 bytes long, 148 instructions long:
; mark_description "Intel(R) C++ Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726";
; mark_description "-TP -O3 -archSSE4.1 -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ -FAcs";
; 17 branches [
; unconditional: 6 'jmp'
; jmp .B2.17 
; jmp .B2.17 
; jmp .B2.17 
; jmp .B2.17 
; jmp .B2.17 
; jmp .B2.17 
; conditional:   4 'je'
; je .B2.7 
; je .B2.11 
; je .B2.15 
; je .B2.24 
; conditional:   4 'jne'
; jne .B2.13 
; jne .B2.20 
; jne .B2.22 
; jne .B2.26 
; conditional:   2 'ja'
; ja .B2.9 
; ja .B2.21 
; conditional:   1 'jb'
; jb .B2.3 
; ]
_TEXT	SEGMENT      'CODE'
       ALIGN     16
	PUBLIC ?Decompress@@YA_KPEAD0_K@Z
?Decompress@@YA_KPEAD0_K@Z	PROC 
; parameter 1: rcx
; parameter 2: rdx
; parameter 3: r8
.B2.1::                         
  00000 48 83 ec 38      sub rsp, 56                            
  00004 4d 89 c1         mov r9, r8                             
  00007 4c 03 ca         add r9, rdx                            
  0000a 49 89 c8         mov r8, rcx                            
  0000d 41 b2 12         mov r10b, 18                           
  00010 41 b3 1c         mov r11b, 28                           
  00013 44 88 54 24 28   mov BYTE PTR [40+rsp], r10b            
  00018 4c 89 c0         mov rax, r8                            
  0001b 44 88 54 24 29   mov BYTE PTR [41+rsp], r10b            
  00020 49 3b d1         cmp rdx, r9                            
  00023 44 88 54 24 2a   mov BYTE PTR [42+rsp], r10b            
  00028 44 88 54 24 2b   mov BYTE PTR [43+rsp], r10b            
  0002d 44 88 5c 24 2c   mov BYTE PTR [44+rsp], r11b            
  00032 44 88 5c 24 2d   mov BYTE PTR [45+rsp], r11b            
  00037 44 88 5c 24 2e   mov BYTE PTR [46+rsp], r11b            
  0003c 44 88 5c 24 2f   mov BYTE PTR [47+rsp], r11b            
  00041 0f 83 45 01 00 
        00               jae .B2.19 
.B2.2::                         
  00047 48 89 6c 24 20   mov QWORD PTR [32+rsp], rbp            
.B2.3::                         
  0004c 44 8b 12         mov r10d, DWORD PTR [rdx]              
  0004f 45 89 d3         mov r11d, r10d                         
  00052 44 89 d5         mov ebp, r10d                          
  00055 41 83 e3 0f      and r11d, 15                           
  00059 83 e5 0c         and ebp, 12                            
  0005c 41 83 fb 03      cmp r11d, 3                            
  00060 0f 85 c1 00 00 
        00               jne .B2.13 
.B2.4::                         
  00066 41 0f b6 ea      movzx ebp, r10b                        
  0006a c1 ed 04         shr ebp, 4                             
  0006d 83 fd 07         cmp ebp, 7                             
  00070 77 65            ja .B2.9 
.B2.5::                         
  00072 85 ed            test ebp, ebp                          
  00074 0f 85 1a 01 00 
        00               jne .B2.20 
.B2.6::                         
  0007a 41 c1 ea 08      shr r10d, 8                            
  0007e 49 83 e2 07      and r10, 7                             
  00082 44 89 d5         mov ebp, r10d                          
  00085 83 e5 03         and ebp, 3                             
  00088 44 8d 5d 03      lea r11d, DWORD PTR [3+rbp]            
  0008c 8d 0c ed 1b 00 
        00 00            lea ecx, DWORD PTR [27+rbp*8]          
  00093 49 f7 db         neg r11                                
  00096 f7 dd            neg ebp                                
  00098 4c 03 da         add r11, rdx                           
  0009b 83 c5 05         add ebp, 5                             
  0009e 48 03 d5         add rdx, rbp                           
  000a1 4d 8b 5b 01      mov r11, QWORD PTR [1+r11]             
  000a5 49 d3 eb         shr r11, cl                            
  000a8 42 0f b6 4c 14 
        28               movzx ecx, BYTE PTR [40+rsp+r10]       
.B2.7::                         
  000ae 48 89 c5         mov rbp, rax                           
  000b1 48 ff c2         inc rdx                                
  000b4 49 2b eb         sub rbp, r11                           
  000b7 f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  000bc f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000c0 f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  000c5 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  000ca 48 03 c1         add rax, rcx                           
  000cd 80 3a 83         cmp BYTE PTR [rdx], -125               
  000d0 74 dc            je .B2.7 
  000d2 e9 a7 00 00 00   jmp .B2.17 
.B2.9::                         
  000d7 83 fd 09         cmp ebp, 9                             
  000da 0f 87 c5 00 00 
        00               ja .B2.21 
.B2.10::                        
  000e0 48 8b 4a fe      mov rcx, QWORD PTR [-2+rdx]            
  000e4 48 83 c2 05      add rdx, 5                             
  000e8 48 c1 e9 18      shr rcx, 24                            
.B2.11::                        
  000ec 48 89 c5         mov rbp, rax                           
  000ef 48 ff c2         inc rdx                                
  000f2 48 2b e9         sub rbp, rcx                           
  000f5 f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  000fa f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000fe f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  00103 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  00108 f2 0f f0 55 20   lddqu xmm2, XMMWORD PTR [32+rbp]       
  0010d f3 0f 7f 50 20   movdqu XMMWORD PTR [32+rax], xmm2      
  00112 f2 0f f0 5d 30   lddqu xmm3, XMMWORD PTR [48+rbp]       
  00117 f3 0f 7f 58 30   movdqu XMMWORD PTR [48+rax], xmm3      
  0011c 48 83 c0 40      add rax, 64                            
  00120 80 3a 83         cmp BYTE PTR [rdx], -125               
  00123 74 c7            je .B2.11 
  00125 eb 57            jmp .B2.17 
.B2.13::                        
  00127 41 83 fb 0c      cmp r11d, 12                           
  0012b 0f 85 96 00 00 
        00               jne .B2.22 
.B2.14::                        
  00131 44 89 d1         mov ecx, r10d                          
  00134 c1 e9 03         shr ecx, 3                             
  00137 83 e1 08         and ecx, 8                             
  0013a 89 cd            mov ebp, ecx                           
  0013c c1 ed 03         shr ebp, 3                             
  0013f f7 dd            neg ebp                                
  00141 83 c5 02         add ebp, 2                             
  00144 48 03 d5         add rdx, rbp                           
  00147 bd ff ff ff 00   mov ebp, 16777215                      
  0014c d3 ed            shr ebp, cl                            
  0014e 41 23 ea         and ebp, r10d                          
  00151 41 83 e2 3c      and r10d, 60                           
  00155 c1 ed 07         shr ebp, 7                             
  00158 41 d1 ea         shr r10d, 1                            
.B2.15::                        
  0015b 48 89 c1         mov rcx, rax                           
  0015e 48 ff c2         inc rdx                                
  00161 48 2b cd         sub rcx, rbp                           
  00164 f2 0f f0 01      lddqu xmm0, XMMWORD PTR [rcx]          
  00168 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  0016c f2 0f f0 49 10   lddqu xmm1, XMMWORD PTR [16+rcx]       
  00171 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  00176 49 03 c2         add rax, r10                           
  00179 80 3a 83         cmp BYTE PTR [rdx], -125               
  0017c 74 dd            je .B2.15 
.B2.17::                        
                                
  0017e 49 3b d1         cmp rdx, r9                            
  00181 0f 82 c5 fe ff 
        ff               jb .B2.3 
.B2.18::                        
  00187 48 8b 6c 24 20   mov rbp, QWORD PTR [32+rsp]            
.B2.19::                        
  0018c 49 2b c0         sub rax, r8                            
  0018f 48 83 c4 38      add rsp, 56                            
  00193 c3               ret                                    
.B2.20::                        
  00194 48 8b 4a 01      mov rcx, QWORD PTR [1+rdx]             
  00198 48 89 08         mov QWORD PTR [rax], rcx               
  0019b 48 03 c5         add rax, rbp                           
  0019e ff c5            inc ebp                                
  001a0 48 03 d5         add rdx, rbp                           
  001a3 eb d9            jmp .B2.17 
.B2.21::                        
  001a5 41 c1 ea 08      shr r10d, 8                            
  001a9 48 83 c2 04      add rdx, 4                             
  001ad f7 dd            neg ebp                                
  001af 49 f7 da         neg r10                                
  001b2 4c 03 d0         add r10, rax                           
  001b5 8d 4c 2d 24      lea ecx, DWORD PTR [36+rbp+rbp]        
  001b9 f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  001be f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  001c2 48 03 c1         add rax, rcx                           
  001c5 eb b7            jmp .B2.17 
.B2.22::                        
  001c7 44 89 d1         mov ecx, r10d                          
  001ca 83 e1 03         and ecx, 3                             
  001cd 75 4d            jne .B2.26 
.B2.23::                        
  001cf 03 ed            add ebp, ebp                           
  001d1 41 89 eb         mov r11d, ebp                          
  001d4 89 e9            mov ecx, ebp                           
  001d6 41 c1 eb 03      shr r11d, 3                            
  001da 41 f7 db         neg r11d                               
  001dd 41 83 c3 03      add r11d, 3                            
  001e1 49 03 d3         add rdx, r11                           
  001e4 41 bb ff ff ff 
        ff               mov r11d, -1                           
  001ea 41 d3 eb         shr r11d, cl                           
  001ed 45 23 d3         and r10d, r11d                         
  001f0 41 c1 ea 04      shr r10d, 4                            
.B2.24::                        
  001f4 48 89 c5         mov rbp, rax                           
  001f7 48 ff c2         inc rdx                                
  001fa 49 2b ea         sub rbp, r10                           
  001fd 48 8b 4d 00      mov rcx, QWORD PTR [rbp]               
  00201 48 89 08         mov QWORD PTR [rax], rcx               
  00204 f2 0f f0 45 08   lddqu xmm0, XMMWORD PTR [8+rbp]        
  00209 f3 0f 7f 40 08   movdqu XMMWORD PTR [8+rax], xmm0       
  0020e 48 83 c0 18      add rax, 24                            
  00212 80 3a 83         cmp BYTE PTR [rdx], -125               
  00215 74 dd            je .B2.24 
  00217 e9 62 ff ff ff   jmp .B2.17 
.B2.26::                        
  0021c c1 e1 03         shl ecx, 3                             
  0021f 41 bb ff ff ff 
        ff               mov r11d, -1                           
  00225 41 d3 eb         shr r11d, cl                           
  00228 f7 dd            neg ebp                                
  0022a 45 23 d3         and r10d, r11d                         
  0022d 83 c5 10         add ebp, 16                            
  00230 41 c1 ea 04      shr r10d, 4                            
  00234 49 f7 da         neg r10                                
  00237 4c 03 d0         add r10, rax                           
  0023a c1 e9 03         shr ecx, 3                             
  0023d f7 d9            neg ecx                                
  0023f 83 c1 04         add ecx, 4                             
  00242 f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  00247 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  0024b 48 03 c5         add rax, rbp                           
  0024e 48 03 d1         add rdx, rcx                           
  00251 e9 28 ff ff ff   jmp .B2.17 
  00256 0f 1f 00 0f 1f 
        80 00 00 00 00   ALIGN     16
.B2.27::
?Decompress@@YA_KPEAD0_K@Z ENDP
_TEXT	ENDS
*/

/*
; 'Ryuugan+' decompression loop, 239-39+6=518 bytes long, 143 instructions long:
; mark_description "Intel(R) C++ Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140726";
; mark_description "-TP -O3 -archSSE4.1 -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ -FAcs";
; 12 branches:
; unconditional: 6 'jmp'
; conditional:   2 'jne'
;                2 'je'
;                1 'jbe'
;                1 'ja'

.B2.3::                         
  00039 45 8b 18         mov r11d, DWORD PTR [r8]               
  0003c 45 89 da         mov r10d, r11d                         
  0003f 44 89 dd         mov ebp, r11d                          
  00042 41 83 e2 0f      and r10d, 15                           
  00046 83 e5 0c         and ebp, 12                            
  00049 41 83 fa 03      cmp r10d, 3                            
  0004d 0f 85 1e 01 00 
        00               jne .B2.11 
.B2.4::                         
  00053 41 0f b6 eb      movzx ebp, r11b                        
  00057 c1 ed 04         shr ebp, 4                             
  0005a 83 fd 08         cmp ebp, 8                             
  0005d 77 71            ja .B2.8 
.B2.5::                         
  0005f 85 ed            test ebp, ebp                          
  00061 74 14            je .B2.7 
.B2.6::                         
  00063 49 8b 48 01      mov rcx, QWORD PTR [1+r8]              
  00067 48 89 08         mov QWORD PTR [rax], rcx               
  0006a 48 03 c5         add rax, rbp                           
  0006d ff c5            inc ebp                                
  0006f 4c 03 c5         add r8, rbp                            
  00072 e9 bf 01 00 00   jmp .B2.16 
.B2.7::                         
  00077 41 c1 eb 08      shr r11d, 8                            
  0007b 41 83 e3 07      and r11d, 7                            
  0007f 45 89 da         mov r10d, r11d                         
  00082 41 83 e2 03      and r10d, 3                            
  00086 41 8d 6a 03      lea ebp, DWORD PTR [3+r10]             
  0008a 42 8d 0c d5 1b 
        00 00 00         lea ecx, DWORD PTR [27+r10*8]          
  00092 48 f7 dd         neg rbp                                
  00095 41 f7 da         neg r10d                               
  00098 49 03 e8         add rbp, r8                            
  0009b 41 83 c2 06      add r10d, 6                            
  0009f 4d 03 c2         add r8, r10                            
  000a2 48 8b 6d 01      mov rbp, QWORD PTR [1+rbp]             
  000a6 48 d3 ed         shr rbp, cl                            
  000a9 48 f7 dd         neg rbp                                
  000ac 48 03 e8         add rbp, rax                           
  000af 42 0f b6 4c 1c 
        20               movzx ecx, BYTE PTR [32+rsp+r11]       
  000b5 f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  000ba f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000be f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  000c3 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  000c8 48 03 c1         add rax, rcx                           
  000cb e9 66 01 00 00   jmp .B2.16 
.B2.8::                         
  000d0 83 fd 09         cmp ebp, 9                             
  000d3 76 25            jbe .B2.10 
.B2.9::                         
  000d5 41 c1 eb 08      shr r11d, 8                            
  000d9 49 83 c0 04      add r8, 4                              
  000dd f7 dd            neg ebp                                
  000df 49 f7 db         neg r11                                
  000e2 4c 03 d8         add r11, rax                           
  000e5 8d 4c 2d 24      lea ecx, DWORD PTR [36+rbp+rbp]        
  000e9 f2 41 0f f0 03   lddqu xmm0, XMMWORD PTR [r11]          
  000ee f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000f2 48 03 c1         add rax, rcx                           
  000f5 e9 3c 01 00 00   jmp .B2.16 
.B2.10::                        
  000fa 41 c1 eb 08      shr r11d, 8                            
  000fe 41 83 e3 07      and r11d, 7                            
  00102 45 89 da         mov r10d, r11d                         
  00105 41 83 e2 03      and r10d, 3                            
  00109 41 8d 6a 03      lea ebp, DWORD PTR [3+r10]             
  0010d 42 8d 0c d5 1b 
        00 00 00         lea ecx, DWORD PTR [27+r10*8]          
  00115 48 f7 dd         neg rbp                                
  00118 41 f7 da         neg r10d                               
  0011b 49 03 e8         add rbp, r8                            
  0011e 41 83 c2 06      add r10d, 6                            
  00122 4d 03 c2         add r8, r10                            
  00125 48 8b 6d 01      mov rbp, QWORD PTR [1+rbp]             
  00129 48 d3 ed         shr rbp, cl                            
  0012c 48 f7 dd         neg rbp                                
  0012f 48 03 e8         add rbp, rax                           
  00132 42 0f b6 4c 1c 
        28               movzx ecx, BYTE PTR [40+rsp+r11]       
  00138 f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  0013d f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00141 f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  00146 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  0014b f2 0f f0 55 20   lddqu xmm2, XMMWORD PTR [32+rbp]       
  00150 f3 0f 7f 50 20   movdqu XMMWORD PTR [32+rax], xmm2      
  00155 f2 0f f0 5d 30   lddqu xmm3, XMMWORD PTR [48+rbp]       
  0015a f3 0f 7f 58 30   movdqu XMMWORD PTR [48+rax], xmm3      
  0015f f2 0f f0 65 40   lddqu xmm4, XMMWORD PTR [64+rbp]       
  00164 f3 0f 7f 60 40   movdqu XMMWORD PTR [64+rax], xmm4      
  00169 48 03 c1         add rax, rcx                           
  0016c e9 c5 00 00 00   jmp .B2.16 
.B2.11::                        
  00171 41 83 fa 0c      cmp r10d, 12                           
  00175 74 7b            je .B2.15 
.B2.12::                        
  00177 44 89 d9         mov ecx, r11d                          
  0017a 83 e1 03         and ecx, 3                             
  0017d 75 3c            jne .B2.14 
.B2.13::                        
  0017f 03 ed            add ebp, ebp                           
  00181 41 ba ff ff ff 
        ff               mov r10d, -1                           
  00187 89 e9            mov ecx, ebp                           
  00189 41 d3 ea         shr r10d, cl                           
  0018c 45 23 da         and r11d, r10d                         
  0018f 41 c1 eb 04      shr r11d, 4                            
  00193 49 f7 db         neg r11                                
  00196 4c 03 d8         add r11, rax                           
  00199 c1 ed 03         shr ebp, 3                             
  0019c f7 dd            neg ebp                                
  0019e 83 c5 04         add ebp, 4                             
  001a1 4d 8b 13         mov r10, QWORD PTR [r11]               
  001a4 4c 89 10         mov QWORD PTR [rax], r10               
  001a7 f2 41 0f f0 43 
        08               lddqu xmm0, XMMWORD PTR [8+r11]        
  001ad f3 0f 7f 40 08   movdqu XMMWORD PTR [8+rax], xmm0       
  001b2 4c 03 c5         add r8, rbp                            
  001b5 48 83 c0 18      add rax, 24                            
  001b9 eb 7b            jmp .B2.16 
.B2.14::                        
  001bb c1 e1 03         shl ecx, 3                             
  001be 41 ba ff ff ff 
        ff               mov r10d, -1                           
  001c4 41 d3 ea         shr r10d, cl                           
  001c7 f7 dd            neg ebp                                
  001c9 45 23 da         and r11d, r10d                         
  001cc 83 c5 10         add ebp, 16                            
  001cf 41 c1 eb 04      shr r11d, 4                            
  001d3 49 f7 db         neg r11                                
  001d6 4c 03 d8         add r11, rax                           
  001d9 c1 e9 03         shr ecx, 3                             
  001dc f7 d9            neg ecx                                
  001de 83 c1 04         add ecx, 4                             
  001e1 f2 41 0f f0 03   lddqu xmm0, XMMWORD PTR [r11]          
  001e6 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  001ea 48 03 c5         add rax, rbp                           
  001ed 4c 03 c1         add r8, rcx                            
  001f0 eb 44            jmp .B2.16 
.B2.15::                        
  001f2 44 89 d9         mov ecx, r11d                          
  001f5 bd ff ff ff 00   mov ebp, 16777215                      
  001fa c1 e9 03         shr ecx, 3                             
  001fd 83 e1 08         and ecx, 8                             
  00200 d3 ed            shr ebp, cl                            
  00202 41 23 eb         and ebp, r11d                          
  00205 41 83 e3 3c      and r11d, 60                           
  00209 c1 ed 07         shr ebp, 7                             
  0020c 48 f7 dd         neg rbp                                
  0020f 48 03 e8         add rbp, rax                           
  00212 c1 e9 03         shr ecx, 3                             
  00215 f7 d9            neg ecx                                
  00217 41 d1 eb         shr r11d, 1                            
  0021a 83 c1 03         add ecx, 3                             
  0021d f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  00222 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00226 f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  0022b f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  00230 49 03 c3         add rax, r11                           
  00233 4c 03 c1         add r8, rcx                            
.B2.16::                        
  00236 4d 3b c1         cmp r8, r9                             
  00239 0f 82 fa fd ff 
        ff               jb .B2.3 
*/

/*
; 'Washigan+' (3xQWORD -> 1xQWORD+1xXMMWORD) decompression loop, 1a9-1e+6=401 bytes long, 120 instructions long:
; mark_description "Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140";
; mark_description "-TP -O3 -QxSSE4.1 -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ -FAcs";

.B2.3::                         
  0001e 44 8b 1a         mov r11d, DWORD PTR [rdx]              
  00021 45 89 da         mov r10d, r11d                         
  00024 44 89 dd         mov ebp, r11d                          
  00027 41 83 e2 0f      and r10d, 15                           
  0002b 83 e5 0c         and ebp, 12                            
  0002e 41 83 fa 03      cmp r10d, 3                            
  00032 0f 85 a9 00 00 
        00               jne .B2.13 
.B2.4::                         
  00038 41 0f b6 eb      movzx ebp, r11b                        
  0003c c1 ed 04         shr ebp, 4                             
  0003f 83 fd 08         cmp ebp, 8                             
  00042 77 36            ja .B2.8 
.B2.5::                         
  00044 85 ed            test ebp, ebp                          
  00046 75 1e            jne .B2.7 
.B2.6::                         
  00048 41 0f b7 cb      movzx ecx, r11w                        
  0004c 48 83 c2 02      add rdx, 2                             
  00050 c1 e9 08         shr ecx, 8                             
  00053 48 f7 d9         neg rcx                                
  00056 48 03 c8         add rcx, rax                           
  00059 8b 29            mov ebp, DWORD PTR [rcx]               
  0005b 89 28            mov DWORD PTR [rax], ebp               
  0005d 48 83 c0 03      add rax, 3                             
  00061 e9 40 01 00 00   jmp .B2.18 
.B2.7::                         
  00066 48 8b 4a 01      mov rcx, QWORD PTR [1+rdx]             
  0006a 48 89 08         mov QWORD PTR [rax], rcx               
  0006d 48 03 c5         add rax, rbp                           
  00070 ff c5            inc ebp                                
  00072 48 03 d5         add rdx, rbp                           
  00075 e9 2c 01 00 00   jmp .B2.18 
.B2.8::                         
  0007a 83 fd 09         cmp ebp, 9                             
  0007d 76 25            jbe .B2.10 
.B2.9::                         
  0007f 41 c1 eb 08      shr r11d, 8                            
  00083 48 83 c2 04      add rdx, 4                             
  00087 f7 dd            neg ebp                                
  00089 49 f7 db         neg r11                                
  0008c 4c 03 d8         add r11, rax                           
  0008f 8d 4c 2d 24      lea ecx, DWORD PTR [36+rbp+rbp]        
  00093 f2 41 0f f0 03   lddqu xmm0, XMMWORD PTR [r11]          
  00098 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  0009c 48 03 c1         add rax, rcx                           
  0009f e9 02 01 00 00   jmp .B2.18 
.B2.10::                        
  000a4 8b 4a 01         mov ecx, DWORD PTR [1+rdx]             
  000a7 41 89 ca         mov r10d, ecx                          
  000aa 41 c1 ea 03      shr r10d, 3                            
  000ae 33 ed            xor ebp, ebp                           
  000b0 83 e1 07         and ecx, 7                             
  000b3 49 f7 da         neg r10                                
  000b6 45 33 db         xor r11d, r11d                         
  000b9 4c 03 d0         add r10, rax                           
.B2.11::                        
  000bc ff c5            inc ebp                                
  000be f2 43 0f f0 04 
        13               lddqu xmm0, XMMWORD PTR [r11+r10]      
  000c4 f3 41 0f 7f 04 
        03               movdqu XMMWORD PTR [r11+rax], xmm0     
  000ca 41 83 c3 10      add r11d, 16                           
  000ce 3b e9            cmp ebp, ecx                           
  000d0 76 ea            jbe .B2.11 
.B2.12::                        
  000d2 c1 e5 04         shl ebp, 4                             
  000d5 48 83 c2 05      add rdx, 5                             
  000d9 48 03 c5         add rax, rbp                           
  000dc e9 c5 00 00 00   jmp .B2.18 
.B2.13::                        
  000e1 41 83 fa 0c      cmp r10d, 12                           
  000e5 74 7b            je .B2.17 
.B2.14::                        
  000e7 44 89 d9         mov ecx, r11d                          
  000ea 83 e1 03         and ecx, 3                             
  000ed 75 3c            jne .B2.16 
.B2.15::                        
  000ef 03 ed            add ebp, ebp                           
  000f1 41 ba ff ff ff 
        ff               mov r10d, -1                           
  000f7 89 e9            mov ecx, ebp                           
  000f9 41 d3 ea         shr r10d, cl                           
  000fc 45 23 da         and r11d, r10d                         
  000ff 41 c1 eb 04      shr r11d, 4                            
  00103 49 f7 db         neg r11                                
  00106 4c 03 d8         add r11, rax                           
  00109 c1 ed 03         shr ebp, 3                             
  0010c f7 dd            neg ebp                                
  0010e 83 c5 04         add ebp, 4                             
  00111 4d 8b 13         mov r10, QWORD PTR [r11]               
  00114 4c 89 10         mov QWORD PTR [rax], r10               
  00117 f2 41 0f f0 43 
        08               lddqu xmm0, XMMWORD PTR [8+r11]        
  0011d f3 0f 7f 40 08   movdqu XMMWORD PTR [8+rax], xmm0       
  00122 48 03 d5         add rdx, rbp                           
  00125 48 83 c0 18      add rax, 24                            
  00129 eb 7b            jmp .B2.18 
.B2.16::                        
  0012b c1 e1 03         shl ecx, 3                             
  0012e 41 ba ff ff ff 
        ff               mov r10d, -1                           
  00134 41 d3 ea         shr r10d, cl                           
  00137 f7 dd            neg ebp                                
  00139 45 23 da         and r11d, r10d                         
  0013c 83 c5 10         add ebp, 16                            
  0013f 41 c1 eb 04      shr r11d, 4                            
  00143 49 f7 db         neg r11                                
  00146 4c 03 d8         add r11, rax                           
  00149 c1 e9 03         shr ecx, 3                             
  0014c f7 d9            neg ecx                                
  0014e 83 c1 04         add ecx, 4                             
  00151 f2 41 0f f0 03   lddqu xmm0, XMMWORD PTR [r11]          
  00156 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  0015a 48 03 c5         add rax, rbp                           
  0015d 48 03 d1         add rdx, rcx                           
  00160 eb 44            jmp .B2.18 
.B2.17::                        
  00162 44 89 d9         mov ecx, r11d                          
  00165 bd ff ff ff 00   mov ebp, 16777215                      
  0016a c1 e9 03         shr ecx, 3                             
  0016d 83 e1 08         and ecx, 8                             
  00170 d3 ed            shr ebp, cl                            
  00172 41 23 eb         and ebp, r11d                          
  00175 41 83 e3 3c      and r11d, 60                           
  00179 c1 ed 07         shr ebp, 7                             
  0017c 48 f7 dd         neg rbp                                
  0017f 48 03 e8         add rbp, rax                           
  00182 c1 e9 03         shr ecx, 3                             
  00185 f7 d9            neg ecx                                
  00187 41 d1 eb         shr r11d, 1                            
  0018a 83 c1 03         add ecx, 3                             
  0018d f2 0f f0 45 00   lddqu xmm0, XMMWORD PTR [rbp]          
  00192 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00196 f2 0f f0 4d 10   lddqu xmm1, XMMWORD PTR [16+rbp]       
  0019b f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  001a0 49 03 c3         add rax, r11                           
  001a3 48 03 d1         add rdx, rcx                           
.B2.18::                        
  001a6 49 3b d1         cmp rdx, r9                            
  001a9 0f 82 6f fe ff 
        ff               jb .B2.3 
*/

/*
; 'Okamigan' (3xQWORD -> 1xQWORD+1xXMMWORD) decompression loop, 18c-21+6=369 bytes long, 106 instructions long:
; mark_description "Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140";
; mark_description "-TP -O3 -QxSSE4.1 -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -D_icl_mumbo_jumbo_ -FAcs";

.B2.3::                         
  00021 45 8b 10         mov r10d, DWORD PTR [r8]               
  00024 45 89 d3         mov r11d, r10d                         
  00027 44 89 d5         mov ebp, r10d                          
  0002a 41 83 e3 0f      and r11d, 15                           
  0002e 83 e5 0c         and ebp, 12                            
  00031 41 83 fb 03      cmp r11d, 3                            
  00035 75 75            jne .B2.9 
.B2.4::                         
  00037 41 0f b6 ea      movzx ebp, r10b                        
  0003b c1 ed 04         shr ebp, 4                             
  0003e 83 fd 08         cmp ebp, 8                             
  00041 77 44            ja .B2.8 
.B2.5::                         
  00043 85 ed            test ebp, ebp                          
  00045 74 14            je .B2.7 
.B2.6::                         
  00047 49 8b 48 01      mov rcx, QWORD PTR [1+r8]              
  0004b 48 89 08         mov QWORD PTR [rax], rcx               
  0004e 48 03 c5         add rax, rbp                           
  00051 ff c5            inc ebp                                
  00053 4c 03 c5         add r8, rbp                            
  00056 e9 2e 01 00 00   jmp .B2.16 
.B2.7::                         
  0005b 41 0f b7 ca      movzx ecx, r10w                        
  0005f 49 83 c0 02      add r8, 2                              
  00063 c1 e9 08         shr ecx, 8                             
  00066 48 f7 d9         neg rcx                                
  00069 48 03 c8         add rcx, rax                           
  0006c f2 0f f0 01      lddqu xmm0, XMMWORD PTR [rcx]          
  00070 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00074 f2 0f f0 49 10   lddqu xmm1, XMMWORD PTR [16+rcx]       
  00079 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  0007e 48 83 c0 20      add rax, 32                            
  00082 e9 02 01 00 00   jmp .B2.16 
.B2.8::                         
  00087 41 c1 ea 08      shr r10d, 8                            
  0008b 49 83 c0 04      add r8, 4                              
  0008f f7 dd            neg ebp                                
  00091 49 f7 da         neg r10                                
  00094 4c 03 d0         add r10, rax                           
  00097 8d 4c 2d 24      lea ecx, DWORD PTR [36+rbp+rbp]        
  0009b f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  000a0 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000a4 48 03 c1         add rax, rcx                           
  000a7 e9 dd 00 00 00   jmp .B2.16 
.B2.9::                         
  000ac 41 83 fb 0c      cmp r11d, 12                           
  000b0 75 5e            jne .B2.13 
.B2.10::                        
  000b2 41 f7 c2 30 00 
        00 00            test r10d, 48                          
  000b9 75 20            jne .B2.12 
.B2.11::                        
  000bb 41 0f b7 ca      movzx ecx, r10w                        
  000bf 49 83 c0 02      add r8, 2                              
  000c3 c1 e9 06         shr ecx, 6                             
  000c6 48 f7 d9         neg rcx                                
  000c9 48 03 c8         add rcx, rax                           
  000cc 48 8b 29         mov rbp, QWORD PTR [rcx]               
  000cf 48 89 28         mov QWORD PTR [rax], rbp               
  000d2 48 83 c0 06      add rax, 6                             
  000d6 e9 ae 00 00 00   jmp .B2.16 
.B2.12::                        
  000db 44 89 d1         mov ecx, r10d                          
  000de 49 83 c0 04      add r8, 4                              
  000e2 c1 e9 06         shr ecx, 6                             
  000e5 48 f7 d9         neg rcx                                
  000e8 48 03 c8         add rcx, rax                           
  000eb 49 83 e2 30      and r10, 48                            
  000ef f2 0f f0 01      lddqu xmm0, XMMWORD PTR [rcx]          
  000f3 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000f7 f2 0f f0 49 10   lddqu xmm1, XMMWORD PTR [16+rcx]       
  000fc f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  00101 f2 0f f0 51 20   lddqu xmm2, XMMWORD PTR [32+rcx]       
  00106 f3 0f 7f 50 20   movdqu XMMWORD PTR [32+rax], xmm2      
  0010b 49 03 c2         add rax, r10                           
  0010e eb 79            jmp .B2.16 
.B2.13::                        
  00110 44 89 d1         mov ecx, r10d                          
  00113 83 e1 03         and ecx, 3                             
  00116 75 3c            jne .B2.15 
.B2.14::                        
  00118 03 ed            add ebp, ebp                           
  0011a 41 bb ff ff ff 
        ff               mov r11d, -1                           
  00120 89 e9            mov ecx, ebp                           
  00122 41 d3 eb         shr r11d, cl                           
  00125 45 23 d3         and r10d, r11d                         
  00128 41 c1 ea 04      shr r10d, 4                            
  0012c 49 f7 da         neg r10                                
  0012f 4c 03 d0         add r10, rax                           
  00132 c1 ed 03         shr ebp, 3                             
  00135 f7 dd            neg ebp                                
  00137 83 c5 04         add ebp, 4                             
  0013a 4d 8b 1a         mov r11, QWORD PTR [r10]               
  0013d 4c 89 18         mov QWORD PTR [rax], r11               
  00140 f2 41 0f f0 42 
        08               lddqu xmm0, XMMWORD PTR [8+r10]        
  00146 f3 0f 7f 40 08   movdqu XMMWORD PTR [8+rax], xmm0       
  0014b 4c 03 c5         add r8, rbp                            
  0014e 48 83 c0 18      add rax, 24                            
  00152 eb 35            jmp .B2.16 
.B2.15::                        
  00154 c1 e1 03         shl ecx, 3                             
  00157 41 bb ff ff ff 
        ff               mov r11d, -1                           
  0015d 41 d3 eb         shr r11d, cl                           
  00160 f7 dd            neg ebp                                
  00162 45 23 d3         and r10d, r11d                         
  00165 83 c5 10         add ebp, 16                            
  00168 41 c1 ea 04      shr r10d, 4                            
  0016c 49 f7 da         neg r10                                
  0016f 4c 03 d0         add r10, rax                           
  00172 c1 e9 03         shr ecx, 3                             
  00175 f7 d9            neg ecx                                
  00177 83 c1 04         add ecx, 4                             
  0017a f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  0017f f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00183 48 03 c5         add rax, rbp                           
  00186 4c 03 c1         add r8, rcx                            
.B2.16::                        
  00189 4d 3b c1         cmp r8, r9                             
  0018c 0f 82 8f fe ff 
        ff               jb .B2.3 
*/

/*
; 'Okamigan' decompression loop, 191-21+6=374 bytes long, 108 instructions long:
; mark_description "Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140";
; mark_description "-TP -O3 -QxSSE4.1 -D_N_XMM -D_N_prefetch_4096 -D_N_HIGH_PRIORITY -FAcs";

.B2.3::                         
  00021 45 8b 10         mov r10d, DWORD PTR [r8]               
  00024 45 89 d3         mov r11d, r10d                         
  00027 44 89 d5         mov ebp, r10d                          
  0002a 41 83 e3 0f      and r11d, 15                           
  0002e 83 e5 0c         and ebp, 12                            
  00031 41 83 fb 03      cmp r11d, 3                            
  00035 75 75            jne .B2.9 
.B2.4::                         
  00037 41 0f b6 ea      movzx ebp, r10b                        
  0003b c1 ed 04         shr ebp, 4                             
  0003e 83 fd 08         cmp ebp, 8                             
  00041 77 44            ja .B2.8 
.B2.5::                         
  00043 85 ed            test ebp, ebp                          
  00045 74 14            je .B2.7 
.B2.6::                         
  00047 49 8b 48 01      mov rcx, QWORD PTR [1+r8]              
  0004b 48 89 08         mov QWORD PTR [rax], rcx               
  0004e 48 03 c5         add rax, rbp                           
  00051 ff c5            inc ebp                                
  00053 4c 03 c5         add r8, rbp                            
  00056 e9 33 01 00 00   jmp .B2.16 
.B2.7::                         
  0005b 41 0f b7 ca      movzx ecx, r10w                        
  0005f 49 83 c0 02      add r8, 2                              
  00063 c1 e9 08         shr ecx, 8                             
  00066 48 f7 d9         neg rcx                                
  00069 48 03 c8         add rcx, rax                           
  0006c f2 0f f0 01      lddqu xmm0, XMMWORD PTR [rcx]          
  00070 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00074 f2 0f f0 49 10   lddqu xmm1, XMMWORD PTR [16+rcx]       
  00079 f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  0007e 48 83 c0 20      add rax, 32                            
  00082 e9 07 01 00 00   jmp .B2.16 
.B2.8::                         
  00087 41 c1 ea 08      shr r10d, 8                            
  0008b 49 83 c0 04      add r8, 4                              
  0008f f7 dd            neg ebp                                
  00091 49 f7 da         neg r10                                
  00094 4c 03 d0         add r10, rax                           
  00097 8d 4c 2d 24      lea ecx, DWORD PTR [36+rbp+rbp]        
  0009b f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  000a0 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000a4 48 03 c1         add rax, rcx                           
  000a7 e9 e2 00 00 00   jmp .B2.16 
.B2.9::                         
  000ac 41 83 fb 0c      cmp r11d, 12                           
  000b0 75 5e            jne .B2.13 
.B2.10::                        
  000b2 41 f7 c2 30 00 
        00 00            test r10d, 48                          
  000b9 75 20            jne .B2.12 
.B2.11::                        
  000bb 41 0f b7 ca      movzx ecx, r10w                        
  000bf 49 83 c0 02      add r8, 2                              
  000c3 c1 e9 06         shr ecx, 6                             
  000c6 48 f7 d9         neg rcx                                
  000c9 48 03 c8         add rcx, rax                           
  000cc 48 8b 29         mov rbp, QWORD PTR [rcx]               
  000cf 48 89 28         mov QWORD PTR [rax], rbp               
  000d2 48 83 c0 06      add rax, 6                             
  000d6 e9 b3 00 00 00   jmp .B2.16 
.B2.12::                        
  000db 44 89 d1         mov ecx, r10d                          
  000de 49 83 c0 04      add r8, 4                              
  000e2 c1 e9 06         shr ecx, 6                             
  000e5 48 f7 d9         neg rcx                                
  000e8 48 03 c8         add rcx, rax                           
  000eb 49 83 e2 30      and r10, 48                            
  000ef f2 0f f0 01      lddqu xmm0, XMMWORD PTR [rcx]          
  000f3 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  000f7 f2 0f f0 49 10   lddqu xmm1, XMMWORD PTR [16+rcx]       
  000fc f3 0f 7f 48 10   movdqu XMMWORD PTR [16+rax], xmm1      
  00101 f2 0f f0 51 20   lddqu xmm2, XMMWORD PTR [32+rcx]       
  00106 f3 0f 7f 50 20   movdqu XMMWORD PTR [32+rax], xmm2      
  0010b 49 03 c2         add rax, r10                           
  0010e eb 7e            jmp .B2.16 
.B2.13::                        
  00110 44 89 d1         mov ecx, r10d                          
  00113 83 e1 03         and ecx, 3                             
  00116 75 41            jne .B2.15 
.B2.14::                        
  00118 03 ed            add ebp, ebp                           
  0011a 41 bb ff ff ff 
        ff               mov r11d, -1                           
  00120 89 e9            mov ecx, ebp                           
  00122 41 d3 eb         shr r11d, cl                           
  00125 45 23 d3         and r10d, r11d                         
  00128 41 c1 ea 04      shr r10d, 4                            
  0012c 49 f7 da         neg r10                                
  0012f 4c 03 d0         add r10, rax                           
  00132 c1 ed 03         shr ebp, 3                             
  00135 f7 dd            neg ebp                                
  00137 83 c5 04         add ebp, 4                             
  0013a 4d 8b 1a         mov r11, QWORD PTR [r10]               
  0013d 4c 89 18         mov QWORD PTR [rax], r11               
  00140 4d 8b 5a 08      mov r11, QWORD PTR [8+r10]             
  00144 4c 89 58 08      mov QWORD PTR [8+rax], r11             
  00148 4d 8b 52 10      mov r10, QWORD PTR [16+r10]            
  0014c 4c 89 50 10      mov QWORD PTR [16+rax], r10            
  00150 4c 03 c5         add r8, rbp                            
  00153 48 83 c0 18      add rax, 24                            
  00157 eb 35            jmp .B2.16 
.B2.15::                        
  00159 c1 e1 03         shl ecx, 3                             
  0015c 41 bb ff ff ff 
        ff               mov r11d, -1                           
  00162 41 d3 eb         shr r11d, cl                           
  00165 f7 dd            neg ebp                                
  00167 45 23 d3         and r10d, r11d                         
  0016a 83 c5 10         add ebp, 16                            
  0016d 41 c1 ea 04      shr r10d, 4                            
  00171 49 f7 da         neg r10                                
  00174 4c 03 d0         add r10, rax                           
  00177 c1 e9 03         shr ecx, 3                             
  0017a f7 d9            neg ecx                                
  0017c 83 c1 04         add ecx, 4                             
  0017f f2 41 0f f0 02   lddqu xmm0, XMMWORD PTR [r10]          
  00184 f3 0f 7f 00      movdqu XMMWORD PTR [rax], xmm0         
  00188 48 03 c5         add rax, rbp                           
  0018b 4c 03 c1         add r8, rcx                            
.B2.16::                        
  0018e 4d 3b c1         cmp r8, r9                             
  00191 0f 82 8a fe ff 
        ff               jb .B2.3 
*/

/*
RT;.,:;:,:;;;:,:;:;:;:,:,:;:;:;:;:;:,:,:;:,:,:;:,:,:;:,:;:,:;:;:,:;:;:,:,:;:,:,:,:,:;:,:;:;:,:;:,:,:,:,:;:;:,:;:;:;:,:;:;:;:;:,:,:,:;:,:,:,:,:,:;:;:,:,:,:;:;:;:,:;:;:,:,:,:;:,:;:,:,:;:,:,:,:;:;:;:;:;:,:;:;:,:,:;:,:,:,:,:,:
.:.,:,:;:,.,:,:;:,:;:,:,:;:;:;:,:;:,:,:;:,:;:;:,:,:,:,:;:;:;:,:;:;:;:,:;:;:;:;:;:;:,:;:;:;:;:;:,:,:;:;:,:;:;:;:;:;:,:,:;:,:;:,:,:,:;:,:;:;:;:;:,:,:,:;:,:;:;:;:,:,:,:;:;:;:;:;:;:;:,:,:,:;:,:;:;:,:,:;:,:,:;:,:;:,:,:;:;:,:;:,
,.,.;:;:;:,:,:,:,:,:,:,:;:,:;:;:,:;:;:;:;:;:,:,:,:;:;:,:,:,:,:;:,:;:;:;:;:,:,:;:;:;:;:;:,:,:,:,:;:;:,:,:,:;:,:,:,:,:;:,:;:,:;:,:,:;:;:;:;:,:;:;:,:,:,:,:;:,:;:;:;:;:,:,:,:;:;:;:;:;:;:;:,:;:;:,:;:;:,:;:,:;:,:,:;:;:;:,:;:,:;:
:,:;:;:,:,:;:;:;:;:,:,:,:;:,:;:,:;:;:;:;:,:,:;:,:,:,:;:,:;:,:,:,:,:;:,:,:,:,:,:;:;:,:,:,:,:;:;:,:;:;:,:,:;:,:;:,:;:;:;:;:;:,:;:,:,:,:;:,:;:;:,:,:,:,:;:;:;:;:;:,:,:;:;:,:,:;:;:;:;:;:;:,:;:,:;:;:;:,:,:;:,:,:;:;:;:;:,:,:;:,:,
;:;:,:;:;:;:,:;:,:;:;:;:;:;:;:,:;:,:;:;:;:;:;:,:,:,:,:;:,:;:,:,:,:,:,:;:,:,:;:,:;:;:;:;:,:,:,:;:;:;:,:;:;:;:;:;:,:;:;:;:,:,:,:,:;:,:;:;:,:,:,:,:;:;:;:;:;:,:;:;:,:,:;:;:;:,:;:,:,:;:,:,:;:;:,:;:,:;:;:,:,:,:,:,:;:;:,:;:,:,:,:
:;:;:,:;:;:;:,:;:;:,:,:,:,:,:;:;:,:,:;:;:;:,:;:;:;:,:;:,:;:,:,:,:,:;:,:,:;:;:,:;:;:,:,:,:;:,:,:,:;:;:;:;:;:;:;:,:,:,:,:;:;:,:;:;:;:,:,:,:,:;:;:;:;:,:;:;:,:;:;:,:,:,:,:,:;:;:;:,:;:;:,:,:;:,:,:,:,:,:;:,:,:;:,:;:;:;:;:;:,:;:;
;:;:;:,:;:,:,:,:;:,:;:;:,:,:;:,:,:,:;:,:;:;:;:;:,:;:;:;:,:,:;:;:;:,:;:;:;:;:,:,:,:;:;:,:,:,:,:;:,:,:;:;:;:,:;:,:,:,:;:,:,:,:,:;:;:;:,:,:;:;:;:,:;:,:;:;:;:;:;:,:;:,:,:,:,:,:,:;:;:;:,:,:,:,:,:,:,:;:,:;:,:;:;:,:,:;:;:,:,:,:,:
,,:;:,:;:,:,:,:,:,:;:,:;:;:,:,:,:;:,:,:,:,:;:;:;:,:;:,:,:;:;:;:,:;:,:,:,:,:,:,:;:;:;:;:,:;:,:,:,:;:,:,:;:,:,:,:,:;:;:,:;:,:,:;:;:,:;:,:;:,:,:;:,:;:;:;:;:;:,:;:;:,:,:,:,:;:;:;:;:,:;:;:,:,:;:;:;:;:;:,:;:,:;:;:,:;:,:,:;:,:;:,
;:,:,:;:,:,:;:;:;:,:;:;:;:;:;:;:;:;:,:;:;:,:,:;:,:,:,:;:,:,:,:,:,:;:,:,:,:,:;:,:,:,:;:,:;:;:,:;:;:;:;:,:,:;:;:;:,:;:,:,:,:,:;:;:,:;:,:,:;:,:;:,:;:;:,:;:,:,:;:;:,:;:;:;:,:,:,:;:,:;:;:,:;:,:,:,:;:,:;:;:,:;:,:;:,:;:;:,:,:,:,:
:,:;:;:,:,:,:,:,:;:;:,:;:;:;:,:;:;:;:;:,:;:;:,:,:;:;:;:,:;:,:;:,:,:;:;:;:;:;:,:;:;:,:;:,:;:;:,:;:,:,:,:;:,:;:;:;:,:;:;:;:,:,:,:,:;:;:,:;:,:,:,:,:;:;:,:,:;:,:;:,:;:,:;:,:;:;:;:,:;:,:,:,:;:,:,:;:;:;:;:;:;:,:,:;:;:;:;:;:,:;:;
;:;:;:,:,:,:;:;:;:;:,:,:;:;:,:;:;:;:;:,:,:;:;:;:,:;:,:,:,:,:;:;:,:,:;:,:,:,:;:,:,:;:,:,:,:;:;:,:,:,:;:,:,:,:,:,:,:;:,:;:;:,:,:;:,:,:;:;:,:;:;:,:;:,:,:,:,:,:,:,:;:,:;:,:,:;:;:,:;:;:,:,:;:;:;:;:;:,:,:;:,:,:,:;:;:;:;:;:,:,:;:
,;:,:,:,:;:,:,:,:;:,:,:;:,:,:;:,:;:;:,:,:;:,:;:;:;:,:;:;:,:,:,:,:,:;:;:;:,:;:;:,:;:;:;:,:;:;:,:;:,:;:,:;:;:,:;:;:,:;:,:,:,:,:;:,:,:,:;:;:;:,:,:;:;:;:,:,:,:;:,:;:,:;:;:;:,:;:,:,:,:;:,:,:;:,:;:,:,:;:;:;:;:;:,:,:;:,:;:;:;:,:,
;:;:;:;:;:;:;:;:;:;:;:;:;:;:;:,:,:;:;:,:;:,:,:,:;:;:;:,:,:,:,:,:;:;:,:;:;:,:,:;:;:,:;:,:;:;:,:;:,:,:,:;:;:;:,:;:;:,:,:,:,:;:,:,:,:,:;:;:,:;:;:;:,:,:,:,:,:,:,:;:,:,:;:,:,:,:;:;:;:;:,:;:;:;:;:,:;:;:,:,:,:;:;:;:,:;:;:;:,:,:,:
,;:;:;:,:;:,:;:,:;:;:,:,:,:,:,:;:;:,:,:;:,:,:,:,:;:,:,:,:,:,:;:;:;:,:;:,:,:;:;,,:,.,:;:;:;:,:;:;:,:,:;:;:,:,:;:;:,:,:,:;:,:;:,:;:;:;:;:,:,:;:;:;:,:,:,:,:,:;:;:;:;:;:,:;:;:;:;:;:,:;:,:,:;:,:,:;:;:,:;:,:;:;:;:,:,:;:;:,:;:;:,
;:;:,:;:;:,:,:,:;:,:,:,:;:,:;:,:,:;:,:;:;:,:;:,:;:,:,:,:;:,:,:,:;:,:;:,:,:,,;:;.,:;.;.,.,:,:,:;:;:,:;:;:;:;:;:,:;:,:,:,:,:;:,:,:;:,:,:;:,:;:,:,:,:,:,:,:,:;:;:,:;:,:;:,:;:;:;:;:,:,:;:;:;:;:,:;:;:;:,:,:;:;:,:;:,:,:;:,:;:,:,:
:;:,:;:,:;:,:,:,:,:,:;:;:,:;:;:,:;:;:;:;:;:;:;:;:;:,:,:,:,:,:;:;:;:,:,:,:;.,:,..,i;,.,;,.,:;:,:,:;:;:;:,:,:;:,:;:,:;:,:,:,:,:,:;:;:,:;:;:,:,:,:,:,:,:;:;:;:;:,:;:,:;:,:,:,:;:,:;:,:;:,:,:;:;:,:;:;:,:,:,:,:,:,:;:,:;:,:,:,:,:,
;:,:;:;:;:;:,:,:,:;:;:;:,:;:;:,:;:;:,:,:,:,:,:,:;:,:;:,:;:,:,:;:,:;:;:,:;:,.: ,iyvl;:i; ,.,,,:,:,:;:,:;:,:,:,:,:,:,:;:;:,:;:;:,:;:,:;:;:;:,:;:;:;:;:,:,:,:;:,:,:,:;:;:;:,:,:;:,:,:,:,:;:,:;:,:;:,:,:,:;:,:,:,:,:,:,:,:,:;:;:;:
:,:,:,:;:;:,:,:;:,:,:;:,:,:,:;:,:;:,:,:;:;:,:;:;:,:;:,:;:;:;:,:,:;:,:,.,,,...;vOXViiv3VYi,.,:;:,:;:;:,:;:;:;:;:,:;:,:;:;:,:,:;:;:,:,:;:;:;:;:;:;:;:,:,:;:,:,:,:,:;:,:;:,:;:,:;:;:;:,:;:;:;:,:,:;:,:,:,:,:;:,:,:;:;:;:;:,:;:,:,
;:;:;:;:,:,:,:;:;:,:,:;:;:;:;:;:;:;:;:;:,:,:;:;:;:;:;:,:,:;:,.,:,.,.,.,.,,ivtQ@DFVlv2K8BL...,.,:,:;,;:,:;:,:;:;:;:;:;:;:;:,:,:;:,:,:;:;:,:,:;:;:,:;:;:;:;:;:;:;:,:,:;:,:;:;:,:;:,:,:;:;:,:,:;:;:,:,:,:,:,:;:,:,:,:;:;:,:,:;:,:
,;:;:,:;:,:,:,:,:,:,:,:;:,:;:;:;:;:;:,:,:,:,:;:;:,:,:,:;:,.:.,.. : ..:.;ijOBE@B@E@@@Bt;yVi;;.:.,.,:,.,.,:,:;:;:,:,:,:,:;:;:;:;:,:;:,:;:,:,:;:;:,:,:;:,:,:;:;:;:;:;:,:;:;:;:,:,:;:;:;:;:,:;:,:,:,:,:;:;:,:,:;:,:;:,:;:;:,:;:;:,
;:,:,:,:;:;:;:;:,:,:,:,:;:;:,:,:;:,:;:;:,:,:;:;:,.,:,:,:,.: :ii;;   ,;ijZS8B@8B@@@@B@ECVylLyi;;,,.,.. ..,:;:;:,:;:;:;:,:;:,:,:,:,:,:,:;:;:,:,:,:;:;:,:,:;:,:;:,:,:;:;:;:;:;:;:;:;:;:,:;:,:;:;:;:,:;:;:,:,:;:,:;:;:;:,:;:,:,:,:
,,:;:;:;:;:;:;:;:,:,:,:;:;:,:;:,:;:,:;:;:,:;:,:,:,.,.,.,.;i;lBlyEtjOF16BB@EBQQQ@B88BE@8XvUVlivvi;;. ,yi:.,:;:,:;:,:;:,:;:;:;:,.,:,:;:,:,:;:;:,:;:,:;:;:,:,:,:,:,:;:;:,:,:;:,:,:;:,:,:,:,:;:,:,:;:,:,:,:;:;:,:,:,:,:,:;:,:,:,:,
;:;:;:;:,:,:;:,:,:;:;:;:,:;:;:,:;:,:;:,:;:,:,.,.;,,,;.:.iV336ScX88@B@B@EBB@8S1C3MyF8B8SlLUciyvVi;ii;@B@i..,:;:,:,:,:;:;:,:;.,.. :.;:,:;:;:,:,:,:,:,:,:,:,:;:;:,:;:,:,:;:;:;:;:,:;:,:;:,:,:,:;:,:;:,:;:;:,:,:,:,:,:;:;:,:,:;:,:
,;:,:,:,:,:;:,:,:;:;:,:;:,:,:,:,:;:;:,:;:,:,:;,;;i;Yl;,iYJljlyt$OEE@@@EQZB@@ED32G0KEG2FX1McCG$XVyvi;i@0;.,,,:;:;:;:,:;:,:;:, .i; ::;:;:;:;:;:,:;:;:,:,:,:;:;:,:;:,:,:,:;:,:;:,:,:,:;:,:;:;:,:,:;:,:;:,:;:;:;:;:;:,:;:;:;:,:,:,
;:;:,:;:;:,:;:,:;:;:;:,:;:,:,:;:;:,:;:;:,:;.,;i;yiivl;;;;;yLVlK3IX3D@B@BBB@88Z8@@83KOXIGSICIBBQ1Jly;;;, ::;:,:,,;:;:,:;:;:,. $@@; :.;:;:,:,:,:,:,:;:;:;:,:,:,:;:,:,:,:;:;:,:,:;:;:,:;:,:,:,:,:,:;:,:,:;:;:,:;:;:,:;:,:;:,:,:,:
:;:;:;:;:,:,:;:;:,:;:,:;:,:,:;:;:;:,:;:;,,:;;;it1cyVii;;,;iSE$XMj11tllJ8@@B8@@@Ei. .O@SGZ@DQQ8SKL1VLvi;;.,.;:;:,:,:,:;:;,,.. @B@2, ,:;:;:,:;:;:;:;:,:;:;:;:,:,:;:;:,:,:;:,:;:,:,:;:,:;:;:;:,:,:;:,:;:;:,:,:;:;:;:,:,:;:;:,:;:;
;:,:;:,:;:,:,:;:,:,:,:;:,:,:,:;:;:;:,:,:;:;,;ijVJVFUyii;;,;;U8BXOUi;iiivEBB@@Q;    i@B6Q@BBQDI3XFKMGOii;;.,.;:;:;:,:;:,:,:, .B@B@; .,:,:;:,:;:,:,:;:,:;:;:;:,:;:;:;:;:;:,:;:,:;:;:,:,:,:,:,:,:,:;:;:,:,:;:;:,:,:,:;:;:;:;:;:;:
:,:,:;:,:;:;:,:;:;:,:;:,:,:;:;:;:;:,:,.;:;:;;yiVUJcFUYii;;,..y0QZ1ivc0XVC8@@I     ;@@@@@@@@8O6Z$F68@8L;;;i,:.,:,,,:;:,:,:,. ,@@8@l .:,:,:;:;:;:;:,:,:,:,:;:,:,:;:,:;:;:;:;:;:,:;:,:,:,:,:;:;:;:,:;:;:;:;:,:,:;:;:;:;:;:,:;:,:,
;:;:;:,:;:;:,:;:,:,:,:,:;:,:,:;:,:;,;.;:;:,;lvlc3XVl2cYi;,;::.Y@BMK0803CE@@Di   . jB@B@@@DCUS@@B@B@B@MUi;;v;;:,.,:,.;:;:;.. 0@@X@Z; ,:;:;:;:,:,:,:,:;:;:;:;:;:;:;:,:;:;:;:,:,:;:,:;:,:,:;:,:,:,:;:;:,:;:,:;:;:,:;:;:;:;:,:;:,:
,,:,:;:;:,:,:;:,:,:;:;:;:,:,:;,,:;,;,,:;:,,lvUXCFL;iyXVyiiii;;v@@DI88St2E@8F$8KU.,B@@@B@iSi;V68@@@@@E6SU;iii;;,;.,.,:,:;::  B@8K8@; .,:,:,:;:,:;:,:,:,:;:;:,:,:,:;:;:,:;:;:;:,:;:,:;:,:,:,:;:;:;:,:;:,:;:;:,:;:,:,:,:;:;:;:;:,
;:,:;:,:;:,:;:;:,:,:,:;:;:,:;,;,,.;:;;;:,.iLVYMXLi;;iYJVUlyvv;y8@ZSQ80O2@@@B@B@BUO@@@@@jv1;.;;SB@DB@@0QMVvli;,;;i;;,,.,.,. ;@@GYEBv ::,:;:,:,:,:,:;:;:,:,:,:;:;:;:;:;:,:,:,:;:,:;:,:;:;:;:,:,:;:,:;:,:;:;:;:;:;:,:;:,:;:;:,:;:
:;:,:,:;:;:;:;:,:,:,:,:;:;:,:,.,:,:,:;;;:iUFJVYUiiiiiUcJVVvyviv8B8686SKCB@@@B@@@B@@@ytLVY;.,:iY@6IZBFCQSKSKJi;;;;;;i;;,,. .@@@FUE@v .,:;:;:;:,:;:,:,:,:;:;:;:,:;:;:;:,:,:;:;:;:;:,:;:;:;:;:;:,:,:;:,:;:;:,:;:,:,:,:,:;:,:,:,:,
;:,:,:;:;:;:;:,:;:;:;:;:,:;:;:;,;,;,,.,:;lXV2JYiiitVvjFVVvlvv;vS@8@88SOK@B@@@@@@@B@; ;Vi,.,:;;Y3QFS$L1@DDQ8QCyjl;.;;;;i;iilSECt2@@V ,:;:;:,:,:;:;:;:;:,:;:,:;:,:;:;:;:;:,:;:,:;:,:,:,:;:,:;:,:;:;:;:;:;:,:;:,:;:;:;:,:;:,:;:,:
:,:;:,:,:,:;:,:,:;:,:,:;:;:,:,:;;i;;;i;;;YVylVlll1QFijjYlyiviiv2S@8E8838B@@@@@B@@@U  . ..,:;,;;j308@OQQ3$B8@8ZSZLyyv;;;iv3MjVyFSB@v .;:,:,:,:,:;:;:,:,:,:;:;:,:;:,:;:;:,:;:,:,:,:;:,:;:;:,:,:,:;:,:,:;:;:;:;:;:;:,:,:;:,:,:,:;
;:,:,:,:,:,:,:;:,:;:;:;:,:;,;:;:;,;;iii;yUUiiivlUXQLvyUiYllililVKDQ3BQ$E@@@@@@@E@8; ,,;:;,;,;,;vCZ@B@QDKQB@8BB@8DFS3l;i;;ijJXVK2@B; ,:;,;:;:,:,:;:;:;:;:;:;:,:,:,:;:;:;:;:;:,:;:;:,:;:;:,:,:;:,:;:,:;:,:,:,:,:;:;:;:;:;:,:,:,:
,;:;:;:,:;:,:;:;:,:,:,:,:,:,:;,;,;,;,;;;iLylivvy;illiycLljllvlic0EOOQBZB@@B@B8$S@$ .,;,;,;:;,;,iyZ68B@@QDBEE06Q8OXU$jiii;;;LcXU6@i :.,,;:,:;:;:;:;:;:,:;:,:,:,:,:,:,:,:,:,:;:,:;:;:;:;:,:,:;:,:,:;:,:;:,:;:;:,:;:;:;:;:,:;:;:,
;:;:,:,:;:,:,:;:,:,:,:;:;:,:,:;:;;;;i;i;vyUlY1BJ, ,;;;ccXUjljlc0@QQSEZ6$StCK3ccM@F .;,;,;,;,;,;;vY8B@@B@@@B88QB863D32K1lv;ivjVJI0...,,;:;:,:;:,:;:;:,:;:;:,:;:,:;:;:,:;:;:;:,:;:;:,:;:,:;:;:;:,:,:,:,:;:;:;:;:;:,:;:,:;:;:;:,:
,,:,:;:;:,:,:,:;:;:;:;:;:;:;:,.,:;:;;iillcKEB@@@i  ,;ljXLFJtXt2B$O6B6OFJVVvylyl3@1 :,;,;,;,;,;,iiU@@@88@BQB@B@@@B8QQQE0IUyilyjUEEi :.;,,:,.,.;,,:;:;:,:,:;:;:;:,:;:;:;:,:;:,:;:;:;:;:,:;:;:;:;:,:,:,:,:;:;:;:,:,:,:,:;:;:;:;:,
;:,:;:,:;:;:;:,:,:,:,:;:,:,:;:,:,:;:;;i;ivU$@B@B@;  ilUjlyUcIF$0tS@@BtO1FXKXJUU2@X .;;;,;,;,,.;;iK@@@SV;,;vYFC8B@B@B@8B8S1tvlUXS@; .;,,.,.,;i,;:;:,:;:,:;:;:;:;:;:;:;:,:;:;:;:,:;:,:;:,:;:;:,:,:,:,:,:,:;:;:;:,:,:;:,:,:;:,:,:
:;:;:;:,:;:;:;:,:;:,:,:,:,:;:,:;,;,;:,;;,;;lyFZB@@ti;;iUilyjVCFLtVivLMviiiii;,;M@C .;;,;,;,;:,;;ii;i;;  .:.....;;VE@B@8@BBCXlLF@K. Yi;.,;vJc;,:;,;,;:;:,:,:,:;:;:;:;:,:;:;:;:;:;:;:;:,:,:;:,:,:;:;:;:;:,:;:;:;:;:,:;:;:;:,:;:,
;:;:,:,:,:;:,:;:,:;:;:;:,:,:,:,,,:;:;,;,;;;;lvc$BB@@@0QDSIEO2EEili,  :;.. . . ;G@Oi ;;;,;,;,;,;;v,.   ,.;.,.:..    ,BB@E6GGUVc8B; 30i:;;yv;.::;,;:,:;:;:,:;:;:,:,:,:;:;:;:,:,:;:,:;:;:,:;:;:,:;:,:,:,:,:,:;:,:;:;:,:;:;:;:,:,:
,;:;:,:,:;:;:;:;:,:;:;:,:;:;:,:,:;:;:,:;,;ilivlFXDB@B@@@B@@@B@BEZ@Qy  ;i.,.,..iZXZ3: ;;;,;,;,;,;i;,;:;:,:,:;.,.,..  ;@@Q1F1XL1O3;VGL,,iU;  ;,;,;,,:,:;:;:,:,:;:,:,:,:,:,:,:;:,:,:,:;:,:,:,:;:,:,:;:;:,:,:,:;:;:;:;:;:,:,:,:,:,
;:,:,:,:;:;:,:,:;:,:;:,:;:;:;:;:;:;:,:;:;,;;vvyL3$@B@B@B@@@@@B@B@SBM; ,;;.;,: i0tv6J..;,;;;,;,;;v,;;;,;,;:;:;:,:,.. y@@0OFXlYVB8My; ,yt;;vv;;:,,;,;:;:,:;:,:;:;:;:,:;:;:,:,:;:;:,:;:;:;:;:,:,:;:,:,:,:;:;:;:,:,:;:;:;:,:;:;:;:
:,:,:,:;:,:;:;:,:,:,:,:;:;:,:,:;:;:;:;:,:,.,ililF@B@@@@@B@@@B@@@B@@@i..l;:,;..i6XyXBji,;,;;;;;;30;:i;;,;:;,;:;:,.. iB@I20SCMtE$l;: ;L6M$1i:: ..,.,.,:,:;:;:,:,:,:;:;:;:,:;:;:,:,:;:,:,:,:;:,:,:;:;:;:,:,:;:,:;:;:,:,:;:;:,:;:;
;:;:,:,:,:;:,:,:,:;:;:,:,:;:;:,:,:,:;:;:,:,.;;vvJZ@B@B@@@@@@@@@@@B@Bi.VX;.,.: vG0VivIG3UUUJU6ZB@@;.;i;;,;,;:;,;...l8@tL2$XSBCi;.: ;y30@QLi;,vyVi;.,.,:,:;:;:,:;:;:;:;:;:;:;:;:,:;:,:,:,:,:;:,:,:,:;:;:,:;:;:;:,:,:;:;:;:;:;:,:
:,:,:,:;:,:,:,:;:,:;:;:;:,:;:,:;:,:;:;:;:;:;,;;yyJS@@@@@@@@@@@@@@@B@yi8B;:,;:.,UFvii;l1QSEGtJCO@@Qli,;,;:,:;:, ;iEBDjjYUJ$D1i;:;.;U1I@ZSKGMZ6l;Vv;.. :.,:,:,:;:;:,:,:,:;:,:,:;:;:;:,:,:;:,:,:,:;:,:;:,:,:;:,:;:,:,:;:;:,:;:;:;
;:;:;:,:,:,:;:,:,:,:;:;:;:,:;:,:;:,:;:;,;:;,;;YyyvUO@@@B@@@@@@@B@@@BMX@U:vSv:.:iUyYyjlyi;;;,;.,;M@@B6Vv;;;;;ii1E@EJllyXtGS0i;;;:iXMM@@BSQSS66Vli;.;il;;:;,,:;:;:;:;:;:;:;:,:,:,:,:,:;:;:;:;:;:;:;:,:;:;:,:;:,:;:;:,:,:,:,:,:;:
,;:,:,:,:,:;:;:;:,:,:,:;:;:,:,:;:;:;:;:;:,:,:;;villMQ@@@@@@@@@@@@@B@DEBci@Ei;v;,t@$Kli,;:;,;,;..,vVQB@@@88D@B@E$VviUjX1ZDSyi;;:iMcv8B@@@QEOGE@8B8B8@@t;;,;:;:;:,:;:,:;:,:;:;:,:;:;:;:,:;:,:,:,:;:;:;:,:,:;:;:;:;:;:;:,:;:;:,:;
;:;:,:;:;:;:;:;:,:,:,:,:;:;:;:,:,:;:;:,:;:;:;:,:;;ii10BB@@@@@B@@@@@B@BB8@BI;lOJ;UFl;;:;,;;;;;:;.::i;iiUUttXV1cVvcFM1MXO0ZXv;;,;t0;2@@EBBB88$EE@QY;jXUi;:;:;:;:,:;:;:,:;:,:,:;:;:;:;:,:;:;:,:,:,:,:,:;:,:,:;:;:;:;:,:,:;:,:,:;:
,;:,:;:,:;:,:;:,:,:;:;:,:;:,:;:,:;:;:,:,:,:,:;,;:,,iiicQZB@@@@@@@@@@@@B@B@ZOI@@M,,,;;;;;;;;;:;ii;;iMviilililV1J1FG1O1K$EMY;;,;jBviB@B8SQE8B@Q@Ei     ..,:,:;:;:,:,:,:;:;:;:;:,:,:;:;:;:,:,:,:,:,:,:;:;:,:;:;:;:;:;:;:,:;:;:,:,
;:;:;:;:;:,:,:,:;:,:;:;:,:,:,:;:;:,:,:;:;:;:;,;;;;iivlF2G6BB@@@@@@@B@@@@@B8Z@@8;,;;;;;;;;;;,;USvvVllIFUl2D$cUYLj1t3233D2Li;,;iEG;U@@@EEEBS880ESiXXl  .,.,.,:;.,:,:,:;:;:;:,:,:,:;:;:;:,:;:,:,:,:,:,:,:,:,:;:;:;:;:,:,:,:,:,:;:
,;:,:;:,:;:;:,:,:;:,:,:;:;:;:,:;:,:,:;:;:;:;:,.,:;;iiyLKME8@B@B@@@@@@@8@B@@@@@;.;i;;,;;;;;;;,0BB6@J;i$CGKQBQFcVXFOOO3SMUii;;;tBj.ZB@B@@@@@E86B@QllFL,;;,.,:,:,:;:;:;:,:,:,:;:,:,:,:;:;:,:,:;:;:,:;:;:;:,:,:,:;:;:,:,:;:,:;:,:;
;:;:,:,:,:;:;:,:;:;:,:,:,:;:;:;:;:;:;:;:,:,:;:,:,.,:;iVVtI88@@@B@@@B@B8B@B@@@K,,i;;,;,;;;;;,,iB@@@X.;SBU30EB@SGMO2$GSMJvi;i;vCQi;B@B@@@B@@@B@Q@@@GMSt,;;;,;,;,;,;:,:,:,:,:;:;:;:,:,:;:,:,:;:;:;:,:,:;:;:;:;:,:;:,:,:,:,:;:,:,:
:;:;:,:,:;:,:,:;:;:;:;:;:,:,:;:;:;:,:;:;:;:;:;:,:,,;;ivlivvcC8B@@@B@@@B@@@B@@v:i;;;;;;;i;;;;;;iJ33ii;c8Xy02QQ8OIK2ccjLli;ivviji.i@B@B@QBB@B8EB88E8E@@tlXli,;,;:;:,:;:,:;:,:;:;:,:;:;:,:;:,:,:,:;:,:,:,:,:,:;:;:,:,:;:;:,:,:,:,
;:,:,:;:,:;:;:;:,:;:,:;:;:;:;:,:;:,:;:;:;:;:;:;:,:,.;,;;i;iiJC8B@@@B@B@B@8@@M,;ii;;;;;i;i;vljyyvyvvvlUBJivVlLJFU1F1iivM2GK3Yi,. IB@B@8SS@@B$BB@88DEE@@6l;.. .:;,;:;:;:,:;:;:,:;:,:,:,:,:;:,:,:;:,:;:;:,:;:,:;:;:;:;:;:;:;:;:,:
,,:;:,:,:;:,:;:;:;:;:,:;:;:,:,:;:,:,:,:,:;:,:,:;,;,;,;,;ily1t3I88@@@@@8B8@B@;;ii;;;;;i;iiyVCXUlyvUvLj$BC;i;iiyljUKJVL8B@BB8Ei. :8@@8EB3GQ@@E8@@@BBDE8@B@B80V,,,,:;:,:,:,:;:,:,:,:;:,:,:,:,:;:;:,:,:,:,:,:,:,:,:;:;:;:,:,:;:,:,
;:;:;:,:;:,:,:;:;:;:,:;:,:,:,:;:,:;:;:;:,:,:,:;:,:;,;:;iylVlYlcKDDB8B88QBB@Y;;i;;;;;iiilccI$ZGSO6DSI0IE2l;i;iivvYyLJB@@B@B@8C;.;@@@D8B8GQ8@B868B@B@B@688@B@@$iiii;;,;,;,;:,:,:,:;:;:,:,:;:,:;:;:;:;:;:;:;:;:,:;:;:;:,:;:,:,:;:
:,:;:;:,:;:,:;:;:,:;:,:;:;:,:,:,:,:,:;:;:;:,:;:,:,:,:,:;iiivvyy1FG088B8@8@Fi;iii;;;i;lVO0QDBB@@@B@E8D$M0li;i;iiviyY3B@@@@@BBQGitB@@DQ@@@QB@@88QBB@@@8@88IZEGviiXy;,;,;,;,;:;:;:,:;:,:,:;:;:;:;:,:,:,:;:,:;:,:,:;:,:,:;:;:;:,:;
;:;:;:,:;:,:;:,:,:,:;:;:,:,:,:;:,:,:,:;:;:;:;:,:,:;:,:,:iilvliyllvylyJ0DBSy;iii;;;;;lXQQQGD3I0QGS0$S3lcOV;i;iiiilvVS@@@B@@@E8QEB@@@8B@@@D0@BB8B$E@@@@B@8QO6FX;;il;;,;,,:,:;:;:;:;:,:,:;:;:;:;:;:;:,:,:;:,:;:;:,:;:,:,:;:,:,:;:
:,:,:;:,:;:;:;:;:,:;:,:,:;:,:,:;:,:,:,:,:;:,:,:;:,:;:;:;,;,,.:.,.;;;:;vJcl;iii;i;;iyM8Q868E6JVii;viv;;lSViiiivivivY8QDBBQB@BB@@@@@B@B@B@ct8@S8BQX8B@@@@@Q88@BEY;   ..,:,:,:,:,:;:,:,:;:,:;:;:,:,:;:;:;:,:;:;:;:;:,:,:,:,:;:,:,
;:;:;:;:,:;:,:;:;:;:;:,:;:;:;:,:,:;:;:,:;:;:;:;:;:;:,:,:,.,.,:;:;,,:;;iii;vly;;;;;VI888E8QBEt;,:;,;;;,iVcvi;iiiiiicQDtE88DBE@@@@@@@@@B@@FUEB8Z@@DG@B@B@B@@@@@B@B@6i.. :.,.,:,:,:;:;:,:,:,:,:,:,:,:,:;:,:,:;:;:;:,:;:,:;:,:;:;:
,,:;:;:;:;:;:;:,:,:;:,:;:,:,:,:;:;:,:,:;:,:;:,:;:;:,:,:;:;:;,;,;,;:,,;:;;ilJviii;X$BDEZES3MDL;.;;;;;;;;vjVii;iiiiiVB8$3SS@Q6@@B@B@@@@@B@Uy3EESC@@EQ@@@@@888@B@B8B@@BLVvi,,,,:,:,:;:;:,:;:;:,:;:;:;:,:,:,:;:;:;:;:;:,:,:,:;:;:;
;:,:,:;:,:,:,:,:;:,:,:,:;:;:;:;:;:;:;:;:;:;:;:,:,:;:;:,:;:;,;:;:,:;:;:..cjvVcvll1686$G62XvlcU;,,;;i;i;;;lli;i;i;iit8@8EFSBB2B@@B@@@B@B@BU;cOSE$Q@@@8@B@B@@@EBB@BB$@8Kvi;;,;,,:,:,:,:,:,:,:;:,:;:;:,:;:,:,:,:,:,:;:;:;:;:,:;:,:
,,:;:;:,:,:,:;:;:,:;:;:,:,:,:;:;:,:;:;:,:,:,:;:,:;:;:;:,:,:,:;:,:;:,:,:yUi,y0OtQ8E6$1MUyvviVli:;;;;;;i;;ivii;i;iivLEQ6Q@B@BBB@B@B@B@B@B@Ot26S@BDD@@@@@@@8@B@@@B@B8Q@SCFi ..,.,.;:;:,:;:,:,:;:,:,:;:,:,:;:;:;:;:,:;:;:;:,:;:,:,
;:;:,:;:;:,:;:;:,:;:,:;:;:,:;:,:;:,:;:,:;:;:,:,:,:;:;:,:;:;:;:;:,:,.:.LUi,ilMIS6EOIULllvliilV;;,;;;;;;;;i;vii;iiiiLS8OE@@@@@@@@@@@@@@B@@@B@EBE@BBB@@@B@@BQBB@B@B@@@@8$@3i,;:,:;,;:;:;.;:,:,:;:;:,:;:,:,:;:,:;:,:;:;:,:;:;:;:;:
,,:;:,:;:;:,:;:,:;:,:,:;:,:;:;:;:;:,:,:;:,:,:,:,:;:,:;:,:,:,:;:;:,.:.lU;,vyXUI66KCLVvlvliiiYi;,;;;;;;;;;;iivivii;il$8BE8B@B@@@@@B@B@@@@@B@@BB@@@8BB@@@@@BQBBB@@@@@B@B@@@@Gii;;,;,;,,:,:;:;:;:;:;:;:;:;:,:;:;:,:;:,:,:,:;:;:,:;
;:;:,:,:;:;:,:;:;:;:;:;:;:;:;:,:,:;:,:,:;:;:;:;:;:,:,:,:;:,:;:,:;:,.ll;,llVtD6SK1YjlYvlii;iii,;,;;;;;;;;i;;;;;iiiil$@B@@@B@B@@@B@B@B@@@B@@@@@@EE8S@@@B@B@QB@BD8B@B@B@BBB@63y;,;:;;;,;:,:;:,:,:,:,:;:;:,:,:,:,:;:,:;:,:,:;:,:,:
:,:;:,:,:;:,:;:;:;:;:;:;:,:;:;:;:,:;:,:,:,:;:;:;:;:,:,:;:;:,:,:;:,:il;,iljc00SKFVVllilii;iiyi;,;;;;;;;;iii;i;i;;;;i$@@B@@@@@@@@@@@@@B@@@@@B@@@lX8B@@B@B@@@O88EQ@@@B@B@@@@@QXii;,;;,;,;;;,;,;:;:;:,:,:;:,:,:;:;:,:;:,:,:;:;:,:,
;:;:;:,:;:;:;:,:;:,:,:,:,:;:,:;:,:,:,:,:;:;:;:,:,:;:;:,:,:,:;:;:,:ii;;viycS$ItXyYlliiiiiiilvi,;;;;;;;;;;i;i;iii;i;iV8E8@@B@@@B@@@@@B@B@@@@@B@@@Gi;E8@@@B@@Q68E@@@@@@@B@@@BB8@QUi, :.;:;:;,;:;:,:,:,:;:,:;:,:,:,:;:;:,:,:;:;:;:
,;:,:,:;:;:;:;:,:;:,:;:,:,:,:,:,:,:,:,:;:;:,:,:,:;:,:,:;:;:;:,.,.;i;;vilVG3OtXVVvliviiiiiivv;;,;;;;;;;;;;;;;;iiiii;yD@D@B@@@B@@@@@@@B@@@@@@@@@@@V, :X@B@E@BB8@B@B@B@B@@@B@8@@It$YV;,.;:,:;:;:;:,:;:;:,:;:,:,:;:;:,:;:;:;:;:;:;
;:,:;:,:,:;:;:,:;:;:,:,:,:;:;:,:;:,:,:;:;:;:,:,:,:;:;:,:;:;:,:,.;;;;vvyVFF3XUyYvlilii;iivili;,;;;;;;;;ivv;;;iii;i;iiG@@8@@@@@B@B@@@@@B@B@@@@@@@@@v   t@@@@@@@@@@@@BDBB@@@8B88SSi;ilii;;:;:;:;:;:,:;:,:;:;:,:,:;:,:;:,:;:,:;:,:
:;:;:;:,:;:;:;:;:;:;:,:;:,:;:;:;:;:;:,:;:;:,:;:;:,:;:,:;:,:;,;.,;;;iiiV31CFXyYvlvviiiviiili;,;,;;;;;;;;lvv;;;i;i;i;iyB@8B@@@@@@@@@@@@@@@@@B@@@EIS$;. .8@B@D@@@@@@@8D6BB@BBBBQ@O;, .i;;;;,;:,:;:;:;:;:;:;:,:,:;:,:;:;:;:;:;:;:;
;:;:;:,:;:,:,:,:;:,:;:,:;:;:;:,:;:,:;:;:,:,:,:;:,:,:,:;:;:;,,:,,;;i;vvVcXYcYyiliv;iiiiiiii;;;,;;;;;;;;;;iii;i;;;iii;iG@8B@@@@@@B@@@B@@@@@@@@@BBU;,i,: ;B@2vyBB@B@@@EB8@@@B@8B@6ii,..,:;,;:,:;:,:;:;:;:;:,:;:,:;:,:,:;:,:;:,:;:
:;:;:;:,:;:,:,:;:,:,:;:,:,:,:;:,:,:;:;:;:,:,:;:,:;:,:,:;:;:,.,.;;iiviVvvilvliviviiiiiiiiii;;,;;;;;;;;;;;;i;iii;i;;;i;J@@8@@@@@B@B@B@@@B@B@@@@@@@y:.,.: ,i: ;Z@@@@@@@B@B@@@@@SB@83V:,.,:;:;:,:;:;:,:,:,:;:;:,:;:,:;:;:;:,:;:,:;
;:,:;:,:,:,:;:;:,:;:;:,:;:,:;:;:,:;:;:,:,:;:,:,:,:,:,:;:;,,:,;;iiilivvliiiiivivii;iiiilii;;,;;;;;;;;;;;;;;;;i;i;i;i;;iB@B@@@@@@@@@@@@@@@@B@B@@@@8, .,.: ..;j@@@B@@@BB8@B@@@@QSDK@E;.,:;:;:;:;:,:,:;:;:;:,:,:;:;:,:,:;:,:,:,:,:
,,:,:;:,:,:;:;:;:,:,:,:;:,:;:,:;:,:,:;:,:;:;:,:;:;:;:;:,.;:,;viivyii;iii;;;iiiiiiiilvlii;;,;,;;;;;;;;;;;;i;;;i;i;i;i,iM@B@@@B@@@B@B@@@B@@@@@B@@@Ei.  :..  .2@@@BB@@BE8B@BBB@B8$2Vtyi:,:;:;:,:;:,:;:,:;:,:;:,:,:;:,:,:;:;:,:;:,
;:;:;:;:,:,:,:;:;:,:;:;:,:;:,:;:;:,:;:,:,:;:,:,:;:;:;:,:,.,,;;;;i;;:,,;;;;iii;iiviYyy;;,;;;;;;;;;;;;i;i;;;;;i;i;i;iii;VE@B@@@B@@@@@B@B@@@B@@@@@@@B@J, . ,;I@@8@BE8@88QBBBZ8@@06B; iiV;,.;:;:,:,:;:,:;:;:;:;:,:,:;:;:,:;:,:,:,:
,;:;:,:,:,:;:;:;:,:;:;:,:;:;:;:,:;:;:,:;:,:,:,:,:;:;:,.,.;;;;;;i;;;;,;,,;;,;;;;i;;;;:,.;;i,;ii;;;i;i;;;;;;;;;;;i;i;viii8BB8@@@@@@@@@B@@@@@@@@@@@@@B@8;.:;BB@Q8BQCB@BEB8BBBEB@@BEi. ;i;:;:,:;:;:,:,:;:,:,:;:;:;:;:,:,:,:;:;:,:;
;:;:,:;:;:,:,:,:,:,:;:,:;:;:,:;:;:,:,:,:;:,:;:;:;:,.,.:.;V2J00S2S0$CMJUlylliiii;i;;;;,;,;,;,;,;,;,;;;.,:;;iivi;;iii;i,;6@BBB@B@@@@@@@@@@@B@@@@@@@BZO@BB1I@E0B@@I0B@EB8BB@BB8@88v;.:.,:,:,:,:;:,:;:;:;:,:,:;:;:,:;:,:,:,:;:,:,:
,,:;:,:,:;:,:,:,:,:,:;:;:,:;:;:;:,:,:;:,:;:;:,:,:;:,.;;;icYVjVlLYUYULXLXXKttLXctUXLUVjyYviii;i;;;i;,.,.,:;;;ili;;i;ii;,J8B8B@@B@@@B@@@@@B@@@B@B@B@BMVIKBB@$6SE6DQ@888BE8B@B@BIv@M;.,:,:;:;:,:;:,:,:,:;:;:,:,:;:,:;:;:,:;:,:;:;
;:,:;:,:;:;:;:;:;:,:,:;:;:,:;:,:,:,:,:;:;:;:;:;:;.,,iilili;;;;;.,:,.,,;,;,;,;;;;;;;;iivilivililvyVi.,.:.;;;.,,;;;;iii;;;O0EE@@@B@B@@@@@@@@@@@@@@@@@@Xl0ESM0IS6EQ@@BQB88DBBBE@I;YU;;:;:,:,:,:;:,:,:,:;:;:,:,:;:,:,:,:,:,:,:;:;:
,,:,:,:;:,:,:,:,:;:,:;:;:,:;:;:,:,:,:;:;:;:;:;:,:,,iii;i;i;i;;;;;;,;,;,;:,:,:,.,:,.,:,:,:;,;;;;;;i;;;;:,vCUv;i;;,;;i;i;;UBBB@@QB@@B@@@B@@@@@@@B@B@B@8Q8MKGOZQ@BE8@@BB@8BB@Qcv1K1.:,;:,:;:,:;:;:;:;:,:,:,:;:,:,:;:,:;:;:,:;:;:,
;:;:,:;:,:;:;:;:;:;:;:;:,:,:;:;:,:;:,:,:,:;:,:;:,:;;;;iiivvii;;;;;;;;;;,;;;;;;;;;,;;;,;;;,;,;,;,;,;;i;i;lVF2CjYii;i;;;;;iZ@8@@BE@B@@@@@B@@@@@@@B@8B@@B@$O0S8@@B$@B@Q@BBQ@BBtUiiQi ;:;:;:;:,:;:,:,:,:,:,:,:;:,:,:;:;:,:,:,:;:,:
:,:;:;:,:;:;:;:,:;:;:;:;:;:,:;:,:;:,:,:,:;:;:;:,:;,;,;;;iYlyvviiiiiiii;;;;;;;;;;;;;;,;,;;;;;;;;;;;;;;;;;,;,iyt2$cy;i;;;;,GBZMBB88BB@8@@@B@@@@@@@@@@@@@QQE@8@B@EB@@BZB@DB@@B@Iy.vJ;.;,,:,:;:;:,:;:,:;:,:,:;:;:,:;:;:,:;:;:,:;:,
;:;:;:;:,:,:,:;:,:;:;:,:,:,:;:;:;:,:,:,:,:;:,:;:,:;,;;;;vvYlylYljlyii;iii;i;;;iii;;;;;;,;;;;i;;;i;i;;;;;;;;:;,il2OXvi;;:;yEXl2@DEZE6QDBB@@@@@B@@@@@@@Q$O@B@8@8BB@@@8@EOB@@@@;iV:;i;.;:;:;:,:;:,:,:,:,:;:,:,:,:;:;:;:;:,:,:;:,:
:;:,:;:;:,:;:,:;:,:,:;:;:,:;:,:;:,:,:;:;:,:;:;:,:,,;;iililvyljVUlVlylylYlylYlylVlviviviiii;i;i;i;i;i;iii;;;;;;.,,vtGUi;;,ilyiU6EQ$3888E@@@@@@@@@B@@@BB$8B@BB@@8B8@BQB@ZQB@@O ,;;.,:;:,:,:,:,:;:,:;:;:,:;:;:;:;:;:,:;:;:;:;:;:,
;:;:;:,:;:;:,:;:;:,:,:,:;:,:,:;:;:;:,:,:,:;:;:,:;,;,iVVyJc1cF13XFX1cFK$S3U1XMtKMCUUL1tXJXlYlliiii;ilyii;i;vii;;;;.;l2ci,;;vylvVc8E6Z8ZEB@B@B@@@B@B@@@B8QBB@8@@@8B@8E@0SB@3C1;.,,;.,:;:;:;:,:;:,:,:;:,:,:;:;:,:;:,:,:,:,:,:,:;:
,,:;:,:,:,:,:;:,:,:,:;:;:;:,:,:;:;:;:;:;:,:;,;:,:,;ivUYjVXcXc2ttKGFKKG080ItXUXM8DGX1F3C$CXF0XcVLvvlciiilivlYyv;i;i;;;vi;;;y$Ui,;2@BE06DBB@B@@@@@B@@@BB6EQB8B@@Q8B@QEEZQ@Elij;:,;,;,;:;:,:,:;:;:;:,:,:;:,:;:,:;:,:;:;:,:,:,:;:;
;:,:;:;:,:;:,:;:;:,:;:;:;:;:;:,:;:,:;:,:;:,:,:,:;,;;vvVU1cXjMCG1KVFCC13cG$I1IO60GcXt0FJUJVXFICMUjYFUl;vviiyvlii;li;;i;i;;;lXSv;ijQ@BEDEEBB@@@@@B@@@@DCQ88Q@B@BSS@@@Q@DEB@V,;i.;,;:;:,:,:;:;:,:;:,:;:,:,:;:;:,:,:;:,:,:;:,:,:,:
:;:,:;:,:,:;:;:,:;:;:;:,:,:;:,:;:;:;:;:;:;,,,;:;,;,;;vlXtMX1F0M21F2ZtOD2V13$30I21KFS$ClyL2UUjtVcUK1Xlviliiilvvivvi;iiiii;;iVUyLZtK36BQXQB@@@@@@@@@@@QQ6Q0QB@BB2EB@BQ@BilY; ;;;.;:;:,:,:;:;:;:,:;:;:;:,:,:;:,:;:,:,:,:;:;:;:,:;
;:,:;:;:;:;:,:,:;:,:,:;:;:,:,:;:,:;:;:;:;:,:;:,:,:;;;;iiUJ2XCKO1J2D1UMQFUcZ6SF3FtVtFFYyjIXcVccJjXVjvviyvviVlliiii;i;i;iii;iiUltQCi;iQE0Q@BBB@B@B@B@B@8SIQQ88@BZE@@@6QQIi:.::;,;:,:;:;:;:,:,:,:,:,:;:,:;:,:,:;:;:,:,:;:;:,:,:;:
,;:;:,:,:,:,:;:;:,:,:,:,:,:;:;:;:;:,:;:,:;:,:,:;:;;i;iivV1XXU2O0XZ0KJC1M2SCMXCtJyUcMcLVFFYvylcUK1jviivvyiYVliviv;vyl;i;iil;;UUvKcCli1BBBQ@BB@@@@@@B@@8GE@@E8BBSB@@B8DBc;.,.,:;,;:,:;:;:,:;:,:;:,:,:,:,:,:;:;:,:,:,:;:;:;:;:,:,
;:;:;:,:;:;:,:;:,:,:,:,:,:;:,:;:,:;:,:;:,:;:;:,:,:;ivii;VU3F1XSS0I1J602S0JXyJC$1Jc2FtVUVjyyljVUVUyyvyyjlyyy;iyUiiiyvv;iivv;;lv;;JSMvYOBB8E@8BB@@@@@@@EEQBB@8@8E8@8@Q8Qv :,,:,:,:;:,:,:,:,:;:;:;:;:,:;:;:;:;:;:;:,:;:,:,:,:;:,:
,,:,:;:,:;:;:,:,:,:;:;:;:;:;:,:;:,:;:,:,:;:,:;:;:;,;;iiyyUM01F3SJFXIO3cItVyX3SFtUXJFJJlVljjLJCyliyyVlLlliLliijyv;iiiiyilLi:;;;;,c8yvlME@8E6@88E@B@@@@@BBQQS8EBBBB@88QBU;.;:,:;:;,;:,:;:,:,:;:,:;:,:,:,:;:,:,:,:;:;:,:;:;:;:;:,
;:,:;:,:;:,:;:;:,:,:;:;:;:;:;:,:,:,:,:;:,:;:,:;,;:;;;ivvllttFtIXUU3FJyXFGcUXGcliyVtJXVLlYUOVULYlyvVlllVvllv;vvVllvl;ivyFU:;;;:l33yilOK8QBBB@@SIMSE@@@B@B800Z$$@B@@B8@y;:::;:;:,:;:,:;:;:;:,:,:;:;:,:,:;:;:,:;:,:;:,:;:;:;:,:;:
:;:,:;:,:;:,:;:,:,:,:,:,:;:,:;:,:;:,:,:;:,:;:;:,:;:;;;;i;YJXL3FLyXXMUJLtcFXFUYvUU1KXvllliX0XlYljlVVLvyyyiliiiVVULUvVlyLV.,;i,;V8i..;vVGBSEB@BB$3GB@@@@B8$6DQ1S8B8@QB@v ;.;:,:,:,:;:;:,:;:,:;:,:,:;:;:;:;:,:;:;:,:,:;:;:;:,:;:;
;:;:;:;:;:;:;:;:;:;:,:;:;:;:;:,:;:;:,:,:,:,:,:;:;:,,;,iivYtjctIUCccjMKtYcU1UUVX3GXKYviVvvy1yjccYYvjUYvYvlvyljYliyyVyXtG;.,i;;,ii,.lyyltZ8OE8@B@EEQBB@BBQQQBQ06@Q8BBB@U.:;.;:,:,:;:,:,:,:,:;:;:,:;:;:;:;:;:;:,:;:,:,:;:;:,:,:;:
,,:,:;:,:,:,:;:;:;:,:,:;:;:,:,:,:;:,:;:;:;:;:;:;:,.;;;;iiyVXUXXKjJjtt3MGFtYylJJXVUVLjXLjyXyvjScjlvVFlllUXtVyyUlliV1XJ8L,.;;;:;;;:ycVlXvcQ88B8@B@EEQ@8BQEQBB@ZQ8B8@$B@J ,:;:;:;:,:,:,:,:;:;:,:,:,:,:,:,:;:;:;:,:,:;:,:;:,:;:,:,
;:,:;:,:;:;:;:;:;:,:;:;:;:,:,:;:,:,:;:;:;:,:,:,:;:,,;;;;iijXXVJUyL$O3UJc3FjYMcUyjLUF0tJyVyyiYVllYiLjYvYYCGJilt3LXK1F8V;.,,;;;,,.vUY;;Vv;3O8B@ZQB@EBBBZ88B8@BQOE8@BE1y,..,:,:;:,:,:;:;:;:;:;:;:,:;:;:;:;:;:;:;:,:;:;:,:,:;:,:;:
,,:,:,:;:;:;:;:;:;:,:;:,:,:;:,:;:;:;:;:,:;:,:,:,:,:,;i;;;lVXUJVUUcVJU1VyytVFILvVcFlUylYMyvivilvcjllliylyVMMCUUlVF01EG;.,,;,;,;:;ii;i;;;vivUQ8D3BBB8@SSQBDB@BI$QB@@Bi :.,.,.,:,:,:,:,:,:,:,:;:,:,:,:;:,:;:,:;:,:;:;:;:;:,:;:,:,
;:,:,:,:,:,:,:;:,:,:;:;:;:;:;:,:;:,:,:;:,:;:,:;:;.;:;;;,iiYycJKVjYUjUVUV1JLVJYUJ3VvVUvMMlililVccjycyVc3XCUt0CytI3cBE;.,,;,;,;,;;ly;,;;,;v;;iOQQQ8E8SS$QZQE@QOO88@BBiii;.,:;:,:,:,:,:;:;:,:;:,:;:;:;:,:;:,:,:,:;:,:;:;:,:,:;:,:
:,:,:,:,:;:,:,:;:;:,:,:,:,:;:;:;:,:,:,:,:;:;:;:;:;:,:;;iiiiyVF1MVXccjcU13Jivi3OZFlvUUJCFvVVYyUyViYXXj31UVUU32IXCOBBK:::;,;;;,;;;;J;;;i;iS2,;V8E@BB8EZQZ6S88SMQEBB@8cii;;;;,;:;:,:,.,:,:;:;:,:;:,:,:,:,:;:;:,:,:;:;:;:,:;:;:,:;
;:;:;:;:,:,:,:,:;:,:;:,:,:;:,:;:,:;:;:,:;:;:,:;:;:;:;:;il;ilclyjcjXUcYLj3YlvY6BZMV0cXG0cJVKVYyUJVJOKXjUyJK$SQCXCBBQ,.:;;;,;,;;;,;i;.;,;1@Xi;XDB@@B@DQ$ZOQEEM368Q@BQV;.;;;;;;;,;,;,;:,.,:,:,:,:,:;:;:,:,:;:;:;:;:;:;:,:;:,:;:;:
,;:;:,:,:,:,:;:;:;:;:;:;:;:;:,:;:;:,:,:,:;:,:,:;:,:;:;,iliijKtj1VcJCcVy3O3CIF0M21IEQO8Q3UJIKvyVMXMGZXUJ0SSIIF8@B@@i.:;,;;i;;,;;;,;:;;;:iVy;vUSD@@@BBSG$B8BD6Q@@QQ8Vli;,;;;;;;;;;;;;;,;,;:;:,:,:,:;:,:,:,:,:;:;:;:;:,:,:,:,:;:;
;:,:;:,:;:,:,:;:;:,:;:,:;:,:;:;:;:,:;:;:,:,:;:;:;:;:;:,,iiiiUJ1FIXt1S$DD$K2tFXCK33$FMCQGFC8OLVXjF2S33XKCG1$68B@S0y;.;;;:;;;,;;;,;,;,vi;.ii;;lJOE@@@BEKQBBBB8B@@Xyyv;;;;:;;;;;;i;i;;;;;;;;,;:,.;:;:,:;:;:,:,:,:,:;:;:,:;:,:,:,:
,,:,:;:,:,:,:;:;:,:;:,:;:;:,:,:,:;:;:,:,:;:,:;:;:;:,:,:;;v;;ilyXXFUcXZ$330X1KZ0$MMXUYX3ZCGIFLGSZSBOKMDG0SEE@@Syy;,.;,;,;,;,;,;,;,;:;iXi,;i;ivX0BB@8BQZE@8@BBS8QV;;;;:;;i;;,;;i;i;i;;;i;;,;,;:,:;:,:,:;:,:;:;:;:;:,:,:,:,:;:;:,
;:;:;:,:,:,:;:,:;:;:,:,:;:,:,:,:,:;:,:;:;:,:,:,:;:;:,:,,;;;;viiiJK3JCGSJGSS0EE8S02G3OISGS6ZJK$DIQBBKZE8E@@BB@2;:;:;,;,;,;,;,;,;,;,;,;;;:i;;illO8@B$S8Q@BDQ8ZEIVii;;,;,;il;;;;;iii;iili;,;:;;i,,:;:;:;:;:;:;:,:,:,:,:,:,:;:;:,:
,;:,:;:;:;:;:,:;:;:;:,:;:,:;:;:,:,:,:,:;:;:;:,:,:;:;:,:,:;;i;i;vYXFZ$6G6ZQ$0CO3$200EQE6ZSBZGG8IIQBDDS88@@@@@@J:;;;;;,;,;,;,;,;;;;;;i;;:;;i;VviVIE@QBBB8QKD8@@$viii;;;;:;;;,,,iiviyVKcVi;.:,il;.,:,:,:;:,:,:,:,:,:;:;:,:;:;:,:;
;:,:,:,:,:;:;:,:;:;:,:,:,:;:,:;:,:;:,:;:,:,:;:,:,:,:;:,:;,;,;iiiYYJ3DMOSEZDKtUK3Z0OGQS668QESQSSD@BDS@B@B@@@Bt,,;i;i;;,;,;;;,;,;,;;;;;,;;v;;ltivVMS8@@B@BQS@B@SUvv;;;;;;,;.,,;iUctVt112Sli,;jX;,:,:;:;:,:,:;:,:;:,:,:,:,:,:;:,:
,,:;:,:;:;:;:,:;:;:;:;:,:,:,:;:;:,:,:;:,:;:,:,:;:,:;:,:,:,:;:;;lvVyF1UUccO$Q68D$IQ$SO3tOQBEESEE@B@B@@@@@@BOj;;;;;;;;;;,;,;,;;;,;;;,;,;;;;i;;tZUXv1ZQ8@B@$M$@B$ylvv;;;i;;.iCEQDGQI3SB88@@Q@BS;..,:,:;:,:;:;:,:,:,:;:,:;:,:,:,:;
;:,:,:,:,:,:,:;:,:,:;:,:;:;:;:;:;:;:;:,:;:;:;:,:;:,:;:;:;:,:,:iiivVU1lVl3SD$EEB0S68Q8DE8@BBZEB@B@B@@@B@BBFl;;ii;;;;;;,;;;,;;;;;;;;;,;;;,;vY;l3Z1JC30B8EEB8@BBMVlVii;;;;:.V@B@XlillJ0@B@@8BJ:..,:;:;:,:;:,:;:,:;:;:;:;:;:,:;:,:
:,:,:,:,:,:;:,:,:,:,:;:,:,:;:;:,:,:,:,:;:,:;:;:,:;:,:;:;:;:,:;iiiylXUll3Z88BZEEB88Q88@@@BBB@B@B@@@@@@@82cVivii;i;;;;,;,;,;,;,;,;;i;,i1i;;iVjlIFjyIFDB@8@B8I8EZXVvviiii;; ;Q@BV;;;;,;l@@@,  ..,:;:;:,:;:;:,:,:,:,:;:;:,:,:,:;:;
;:;:,:,:,:;:,:,:,:,:;:;:;:,:;:,:;:;:;:;:,:;:;:;:;:;:,:,:,:;:,,i;iilvllSEQS86QEB8B8B8BB@BB8@@@B@@@@@8DD0vVyyii;i;i;;;;;;,;,;;;,;,;;;,iUXli;vVODXvlGD3BB@@@CK6EI3Vlilii;;;,.V8v;i;i;;,,K@Bv.:.,:;:,:,:,:,:;:;:,:,:,:;:,:,:,:,:;:
,,:;:,:,:;:,:,:;:;:;:;:,:,:,:,:;:;:,:;:,:,:;:;:,:,:;:;:,:,:,:;,,,;vVvV2QO6OIGQ8@68@@B@@@@BB@B@B@B@@QlcXLyjlvii;i;;;;,;;;;;,;;;,;,;,;,;;lli;ivM3CtZ888@B@Q$OESI3$Ylivii;;.,l0llvli;,;;;i$Bc,..,:;:;:,:;:,:,:;:;:,:;:,:,:,:;:,:,
;:;:;:;:,:;:,:;:,:;:;:;:,:,:,:,:;:,:;:,:,:,:,:;:,:;:;:;:;:,:;:,.,,llJcVlcMtlFO8BB8@E@@@8B8@@@B@B@B@83VcYVvvvv;i;i;;;;,;;;;;,;;;;;,;,;:;;UtViiX8GO2BB@@@@@8E68SEQMyyil;;;;:VGXlyll;;;;,;iVi;ii.,:,:;:,:;:;:,:,:;:,:,:,:;:;:;:;:
:,:;:,:,:;:;:,:;:;:;:;:;:;:;:,:;:,:,:;:;:,:,:;:;:,:;:;:,:;:;:,:;,;;iiUvvlUvijSQB8BSZ8@@BQ@@@@@@BEGFD3yiYviivii;i;i;;;;;ii;,;,;,i;;,i;;i;;VX1U$8S2GQB@@@@B@E8@@8821yvii;i,,l6Vyiviv;;;;;iilVl,..,.;:,:,:,:;:;:,:;:,:;:;:;:,:,:,
;:;:,:,:,:;:;:,:;:,:,:,:,:,:,:;:,:,:;:;:;:;:,:,:,:,:;:;:;:;:;:,,;:,;i;iivlvit3$O8BB6BBBB@B@B@8QMJVlvVivllilii;iii;;;;;;,;;;;;;;ii,iliiFl;iVyVX8ZQO8E@@@@@@@@@BB8ZXlii;i;;:yEMLYvlii;i;ivVvjli;i;,:,:;:;:,:;:,:,:;:;:,:,:;:,:;:
,;:,:;:;:;:,:,:,:,:,:,:,:;:;:;:;:,:,:,:,:;:,:;:,:;:;:,:,:,:,:;:;,,.;i;;iiyvyJXL$688B@@68@@B@01VyvylyiVyylyiv;i;iii;;;;;;,;iivyivilyUllUti;iLiJQ8E8B@@@B@B@@@BB8@QMvvii;i;,;@@@K1yl;i;;;iiXFDQGci:,:,:;:,:,:;:;:;:;:,:,:;:;:,:,
;:,:;:;:,:;:,:,:;:;:;:,:;:,:,:;:,:;:,:,:,:;:,:,:,:,:,:;:,:,:,:,:,:;:;.;;iiviyj2G3F6Q@@BS8@BtlivillLlVUclyvi;i;iii;;;;;VU;;v;vVYiivJVv;llv;VOt3BE8B@B@@@B@B@@@QB@8KFlvivi;,,M@@@BEMVii;i;iUXlli;,,:,:,:;:,:;:;:,:,:;:,:,:;:;:;:
:;:;:,:;:,:;:;:;:,:;:,:,:,:,:;:,:,:,:,:;:;:;:;:;:,:,:,:;:;:;:,:,:;:,.,,;:;iyvVLXYUX3F0CUy2Li;villyvyVjvvivilll;iiiii;Ytc;iii;ycV;iYciivVvlX0OBQQ8BZ@@@@@@@@@B@@@B8KUlvii;;.;vi;ilVllii;;,y3ti;...;:;:;:,:,:,:,:,:,:;:;:;:,:;:,
;:;:;:,:,:;:;:,:;:;:,:,:;:;:,:;:;:;:,:;:,:;:,:;:,:;:;:;:,:;:;:;:;:;:,.,:;;liiivvvillYvyivvliljLlLllvlii;vilV1Yviiiyiivl;iYYvllXl;itUVvVYVVFIE8QIEQ68@@@@@@@@@B@@@8E3MVlii;,.;.,:;,;;i;;.,lD2Qv..,:,:,:,:,:;:,:;:,:,:;:,:;:;:;:
,,:;:;:,:;:,:;:;:,:,:;:,:,:,:,:;:,:,:,:,:,:;:;:,:,:,:;:;:,:;:;:,:;:,:,:;,;vlii;iiiiviviylVcCKOJUcIJVvlYcVLvvilvli;;iiv;iv1llvvyLiLGIJXjLU136KQQSOBBBB@@@@@B@BUX@B@@@SSJcUy;,;iii;iiiiiilv0B8Q$i,:,:;:,:,:;:,:,:,:;:;:;:,:,:;:,
;:;:;:,:;:,:,:,:,:;:,:,:;:;:;:;:;:,:,:,:,:;:,:,:;:;:,:,:,:,:,:;:;:;:;:;:,,viyvi;viiiivLcJyOQ8$XV$QDI32E$tUtlVlvlYvyvUFXJjvyvVlLMXVGtUcUY21302ID6BB@8@B@B@@@B@; 1@@@B@EQ0Oyi;;iyivvllXLO@@@@8GJv:,:,:;:;:,:,:;:,:;:,:;:,:,:,:;:
:,:;:,:,:;:;:;:;:;:;:,:;:,:,:,:;:;:;:;:,:,:;:;:;:,:,:,:,:,:;:,:;:;:;:,:,:;;;iLviiylVyVc$MMG8S2VcK$0Q66G3VKGS2XLFtXyvvtMSXLY2SFlJXJSEIDIOI3MSIZSB@@S@@@@@@@@@BQ.,vB@@@@@@QZIJiiiyVYjM3@B@@Bi;:..::;:;:,:,:,:;:,:;:;:;:,:;:,:;:,
;:,:;:;:,:;:;:,:;:,:;:,:;:,:;:,:;:;:;:,:,:,:;:,:,:;:,:;:,:,:;:;:;:,:;:,:;:,.iVVlllXtUlXGO$QSD06DE2$SESGC$3ZGKU3OMVVvjtS$6OG$$jU1QSB@B8B6It66QE86BQD@@B@@@@@@icv  .i1@@@8@E8ZFiil1FZ8@DBSJl; ..,:;:,:,:;:,:,:,:;:;:,:,:,:,:;:,:
:;:,:,:;:;:;:,:;:;:;:;:;:;:,:,:;:,:;:;:;:;:,:,:;:,:,:;:,:,:;:;:,:,:;:;:,:,.;vcLVvjtCylVKK8Z6Z@@@@ESEQBQ8QDGGJcc2XUYJ1$O$OQQZCOIZSDEBQ8Q$LjUK0@B8SD0@@@B@@@S; .;, . ;yOvU@@BB3S3QQ@@@BcvY,..,.,:,:,:,:;:;:,:,:,:;:,:;:,:,:,:,:;
;:;:;:,:,:;:;:;:,:;:;:,:;:,:,:,:,:,:,:;:;:;:;:;:;:;:;:,:;:;:,:;:,:;:,:,:,.,ijVJVVycLYilLSB80EB@@@B@8BB@886ES$3030MIOEQ8QE6D2G$ESSO88B8QMcYt1G8@@@B88@B@@@@@l: ;,,.:   ,.i@@B@@@8@Z@BBSi ..,.,:,:;:;:,:;:;:,:,:;:,:,:,:;:,:,:;:
:,:;:,:;:;:;:;:;:;:,:,:;:;:,:,:;:,:;:;:,:,:,:;:,:;:,:,:,:;:;:,:;:,:,:,:,:;illYlcULlVyviXB@BEQ@@@8@@BE@@@Q88BB@88E8QBB@8@EQZE6D$EQ888Q80Fj1$B$8B@B@B@B@B@B@Gi.,.;,;.,.... ,;Y@@@3286Xyi:..,:;:;:;:;:;:;:,:;:,:;:,:,:;:,:,:,:;:,
;:;:,:;:;:;:,:,:;:,:;:;:,:,:,:;:,:,:,:;:,:;:;:;:,:;:,:;:;:,:;:;:,:,:;:;:,;viivlVCcLUUiv1B@@QB@B8@@@8BB@88E88@@@8B8BB@E88E3EEB$338BDMGC2VLV2SD8@BBQ8BB@@@@@; ..,:;:;:;:,.:   ;O@i:;i:. :.,:;:;:,:,:,:;:;:,:,:,:,:,:,:,:;:;:;:,:
:;:,:,:,:;:,:,:,:,:;:,:,:,:,:;:;:;:,:;:;:;:,:,:,:;:;:,:;:,:;:,:,:;:,:,:,:;;iiylt1ccOUvySQ@B6E@0ZQSGBB@Q6DB8@@@@B8BE@B86B8E$Z88C$E@tVVFK3tCK008B@BB8@8@B@@@i..,.;:,:,:,:,.,.. ... . ..,:;:;:,:;:,:,:,:;:;:;:;:,:;:;:,:;:,:;:,:,
;:;:,:,:,:;:;:;:,:,:,:,:;:;:,:;:,:,:,:;:,:;:;:,:,:,:;:,:;:,:,:,:;:,:;:,:;:;;lljUUy3QOijQ@@BFIS3CSt0EBSGOB@@B@@@BBEB8@EBB@@QI8QDD@B0VUXSDESZ3$Q@@@B@@@BB@@@,.,.,:,:,:,:,:,:,:,.:.,.,:,.,:;:;:,:,:,:,:;:;:,:;:,:;:;:;:;:,:,:,:,:
,;:,:,:,:;:;:;:,:;:,:,:;:;:,:,:;:,:;:,:;:;:,:,:,:,:;:;:,:;:,:,:;:;:;:,:,;;;ivVyLVXZ@QLc@B@8XJZOD03O@BBQ@@@B@B@@@BB8@@@8B8@E8B@S8@@Q$KGSQZE$3CQ8@@@@@B8E@B@y.,;.;:;:;:,:,:;:;:,:,:,:,:;:,:;:,:,:,:,:,:,:;:,:,:;:,:;:;:;:,:;:;:,
;:,:,:,:,:,:,:,:,:,:;:;:;:,:,:;:,:,:;:,:,:;:,:,:,:;:;:;:,:;:;:,:,:;:;,;:;;i;lyUyCS@@@cCB@@BcKEBBBQ@@@@@B@@@@@B@@@ED8@@BZZ3ZE@B8D@@80ICSOEB8MG$BB@@@8@B@B8B@v,,;:;:;:,:,:;:;:;:,:;:,:,:;:;:,:;:;:;:,:;:,:,:;:;:;:;:;:;:;:,:,:;:
:;:;:;:,:,:,:,:,:,:,:,:;:;:,:;:;:,:;:,:;:,:;:;:,:,:,:;:,:,:,:,:,:,:,:;.,:;iivclj3BB@BQSBBBSFC8B@B@@@@@@@@@@@BBB@BBS8@@EDKC08B@888@88QEOD8@8SIS6B8@B@B@@@IEBV.,:;:;:;:,:;:;:,:;:,:,:,:,:;:;:;:;:,:,:;:,:,:;:,:;:,:,:,:;:,:,:,:,
;:;:;:;:,:,:;:,:;:,:;:,:;:,:,:;:;:;:;:,:,:;:;:;:,:;:;:;:,:;:,:,:;:,:,:;;vvviFXj2@@@@@B@8BQI2QB@@@SEB@@@@@@@B@EB8B@@E@BBD21BB@88QQ$8Q88ES8DSSZGZ$Q8@@@@@Z1i; ..,:,:,:,:,:;:;:;:;:;:,:,:;:;:,:;:;:;:;:;:,:;:,:;:;:;:,:,:;:,:,:;:
,,:,:;:;:,:;:,:,:,:,:;:,:;:;:,:,:;:,:;:;:;:,:,:;:;:;:;:;:;:;:,:,:,:;:;,;;ilVVLU8@@@@@@@@B@EBB@@@B@8@B@@@B@@@B88@@@Q6B@BB3C8@B@8BQEBBSBB8DQSDG$K2M8@@B@@v.  :.,:,:;:;:,:,:,:,:;:;:,:,:,:,:;:,:;:,:;:;:,:;:,:;:;:;:,:,:,:;:,:,:,
;:;:,:,:;:,:;:,:;:,:,:,:,:;:,:;:;:,:,:;:;:,:;:,:;:,:,:;:,:,:,:;:;:;:,:;:,;ivyl28@B@@@@@@@@@B@@@@@@@B@@@@@@@B@Q8B@@BSBB@@QG88@88E@@@B88@8@B8GQQBQ608@@@X.:.,:,:,:;:;:;:,:;:;:,:;:;:;:,:,:,:,:,:,:;:,:;:;:;:,:;:,:,:,:,:;:;:,:,:
,,:;:;:;:,:;:,:,:;:,:;:,:;:;:;:;:;:;:,:;:,:;:,:;:,:;:,:,:,:,:;:;:,:;,;:;;;;vV16@6ZQ@B@@@@@@@B@@@B@@@@@@@@@@@@88B8@@B@@B@8B88QBB@888@B@8BB@88D8B@8Q6$li,..,.,:;:;:;:;:,:;:;:;:;:;:;:;:,:;:;:;:;:,:;:,:;:;:,:;:;:,:,:;:;:,:;:,:,
;:;:;:;:;:,:;:,:,:;:;:,:;:;:;:;:,:,:,:;:,:,:;:;:,:,:;:;:,:,:;:;:;:,,;:;.;;iilYFFG$8B@@@@@@@@@@@@@B@@@B@@@@@@@B@8B@@E@B@B@BB88E@@@DBB@BBB@B@@@8BEB8El, ..,.,:;:;:;:,:,:;:,:;:,:,:;:;:;:,:;:,:,:;:,:,:,:,:,:,:,:;:,:,:;:;:;:,:,:
,,:,:,:,:;:,:,:,:;:,:;:,:;:;:;:,:,:,:,:,:,:,:,:;:,:,:,:,:,:,:;:,:;:;:,:,,;;ilUvJSED88@B@@@B@@@@@@@BB@@@@@@B@@@8Q8@@@B@@@8B8@B@B@@BB@8B8B8B888@8BEDMy...,:;:;:,:;:;:,:,:,:,:,:,:,:,:;:;:;:;:,:;:,:;:,:;:,:,:;:,:;:;:;:;:,:;:,:;
;:,:,:,:;:;:,:,:;:;:,:;:;:,:;:;:;:;:;:;:;:;:,:,:;:;:;:,:;:;:;:,:;:,:;,,:;ivillU0B68Q@@@@@@@B@@@B@BBO@B@@@@@@@@B8@B@@@B@@B68B@BBB@@@@BE8E88BQ8EB@@BC.  ,:;:;:;:,:,:;:;:,:,:,:;:,:,:,:,:;:,:;:;:;:,:,:;:,:,:,:;:,:,:,:,:;:;:;:,:
:;:;:;:;:,:;:;:;:;:,:,:;:,:,:;:,:,:;:;:;:,:,:,:,:;:;:;:,:;:,:,:;:,:;:;:,;iii;vX@BB8@@@B@@@@@@@B@@@B@QFM@BB8B@@B@B@@@B@@@BB@@BB8@@BBBQ8Q8QB8BE8SDSBDy ..,:;,,:,:;:,:,:,:,:;:;:,:,:;:;:;:,:,:;:;:;:;:;:;:;:;:;:,:;:;:;:;:,:;:,:;
;:;:;:;:,:,:;:;:,:;:,:,:,:;:;:;:,:;:,:,:;:,:,:;.,:,.,:,.,.,.,.,:,.,.,.,:;:iillSB@B@@@@@B@@@@@@@@@B@Bl .v; ,,;v$D0Lt8@@@@@@@@@B8D88@BBEB888@BBSSGSCS81;,.,:;:;:;:,:;:,:;:;:,:,:,:;:,:;:,:,:;:;:,:,:;:;:,:,:;:,:,:,:;:,:;:,:,:;:
,;:,:,:,:;:,:,:;:,:,:,:;:;:,:,:;,;.,.,:,:;,;:;:,:,:,.,.,:,::.:.:.:.,.,,;;iiyyF6@B@@@@@@@@@@@@@@@B@SV;  .:. :.:,;ii:v086@@@BB8@QE8@B@BB8@B@8802JFJXY2BC;..,:;:;:;:,,,:;:,:,:;:;:;:;:;:,:,:;:,:;:;:;:,:;:,:,:;:;:,:,:,:,:;:;:,:;
;:,:;:;:,:;:;:;:;,,:;,;,;:,,;:,:;:;:,:;,;,;,;,;:;;;,;:;;iiiii,;,. ..;;i;villJFZQ8Q@@@B@@@@@B@@@@@Bv   ii;:,.,.;,;;;;vJS8@BBDB@BDB@BZ8B8SBBB88IFVVj1yUl;.:.:.,.,:,.,,;:,:,:;:,:,:,:,:;:;:,:,:;:,:;:,:;:;:,:;:;:;:;:,:;:,:,:,:,:
,,:,:,:;:,:;:;:;,;:;:;:;:;:,:;,;:;:;:,:;,;:;;;;iiUlYYyivyyvylYVU;iiviiivvylVVKIEQ8@@B@B@@@B@@@B@B@0Xlyi, ,.;:,:;,;;;;cS6Q@B@@@8ZQBQZZ@8$K8B@@@D3UtXXivVJi;,;:,.,.,.,:,:,.;:,:;:;:,:,:,:;:,:,:;:;:;:;:,:,:;:;:,:;:;:,:;:;:;:,:;
;:;:,:;:;:,:,:;:,:,:,,;:;,;:;:;,;:;:,:,:;,iiiilL2cViyVjlUtKyVLVl1X33$JyiUUcJ68@8B@@@@B@B@@@B@B@B8E@@@2yv: ..,:;:;;;,;iFGE88E@@@ZBB@E8@@6$S8Q@B@8ZFMtJyVyVllii;;,;:,.,.,:,:,:,,;:,:,:;:,:,:;:;:;:,:;:;:;:;:;:,:;:,:;:,:,:;:,:;:
,,:,:,:;:,:;:;:;,;:;,;:;:;:;:;:,:;,;;iiviiivii;;;vlliyj1F$KCLGCSQQD@@B0IO6GSE@@@@@@@@B8@B@EB8@EEZCcM8@@@X;...,:;:;;;;vVBBB88B@BB@@8B@@BEG8Q88@@@EDG63FlyljVliliiivii,,:,.,:;:,:;:,:,:,:,:,:,:;:,:;:,:,:;:;:;:,:;:;:,:,:,:,:;:;
;:,:,:;:,:,:;,;:;,;,;,;:;:,.,:,,;;iiyyVivvi;;;iii;lYUyUVFXXXtCO3S08B@@BQ@@@8BB@B@@@@@@@BBS$S@B8Q@SG2D8@@@@X;,.,:,,;;i;lQ@B@B@@@@@B@Q@@@ZSZEO6863B8888OJvllLUUcCUYvliiiii;;;,,.,,;:,.:.,:,:,:;:,:,:;:;:,:;:;:;:,:;:;:,:,:;:;:;:
,,:,:,:,:;:;,;,;,;:;,;.:.::;;;ivivilvlii;;;;;ylLYlvyvviyyUyVlcLcX3GE8BEE8@B@@@@@B@B@B@B@BQ068BSMX8E0LUM8@@Ey;,:;:;:,..;EB@B@B@88ME8BB@@@B@6S3@8FM@QStcVLjXJ2FKUUlyyYvYYVvi;;;i;;,;...,.,.;:;:;:;:,:,:,:,:;:,:,:;:;:,:,:;:,:,:;
;:,:,:,:;,;,;,;,;,;,, :,vyVlllUlyvlilivvylVvvivivivvyvlvyivlLlVU3C$SEQE686EQB8@@@8BE8SQSEEBE86ZXV0SctX1U36SUl,;:;:;,:;I@@8@QZLcUlvtS$USQ8B@BS28UjQSFG30COKFLUYjyliyvVVVvVlylViiii;;iFJ; :.,:;:,:,:,:,:,:;:;:;:,:;:,:;:;:;:;:,:
,;:,:;.;,;,;,;,;,;,,.;V02UlUcUlyyVvvillcLVvYlliviiilllvllvvUccVcXMK3FCXFC$I$IZZ8EBZSFFXMM6B@E88@EBSZQ8I1JMMOl;.;,;,;.,ij;;;ii,;li;;v;ili;lS@U;;;iXv1E8F13$yllccXlVVcVjlyyUylvlvyljjMCEJv;, ....:.,.,:,:,:;:;:,:,:;:;:,:,:,:;:,
;:,:;:,:;,;,;,;,;,, ;I@VlilFKVjyVllljyYyUyyycvylyvyvylYycYVyULUlLcCM3XXUKF3CSGSODSZ3GF2MO3E8@B@@@@@B@@@B@SVly;;,;;;,;.,;;.;;;.,;;;i;;iXlYlMDUillviV3IJyilljKFyVUXLJjXYUVLyUjUVLyjyVyUcG2MLl,,.. . ..:.,:,:,:,:;:;:;:;:,:;:;:;:
:,:;:;,;,;,;,;,;,,.;I8Jv,ijKVcXCLi;ylyvylVvylyyVlYlYlLVUYVvllJVVlUXIM3F3M3C0GZO$3$GD6QO$33KSQ@BB8BB@B@B@B@F. ;;;;;;;;;;ivyii;;;;;;ii;iiVLVivijVVvj1MlVLyi;iZIFJ3tcylilyyiiilyjVJLcVYvllLlX3KJXYyii:. . ..,.,:,:,,;:;:,:,:;:,:;
;:;:,:,,;,;,;,;;;. c@BFi;y0UcXFKi;ycyvlvyivivvlljyVyVYjYjvlvjjVlVUFF3F3K212FGISG$M0SQ$Z$6KG0EEBB@8@B@B@B@B@V;ivivii;iicK2VY;;;i;v;;;i;;,;;viv;;;i;vyjKFlcXGS6GGUyvYllvVlYvlvlvYyUUtX1XKtMXKMIF31G3ILVii,. . ..,:;,;,;:,:;:;:;:
,,:;:;:;,;,;;;;;..;B@B8$MES1VUV1yC8BZSYlivilvYlVlVyVlYvVUUVcctVVYVlVYJJ11GC0GZ06G0I$IG2S$EQB8@B@@@@@@@B@@@B@;ilVljlyvVXCJUYvii;lvli;;;;;,ivcLliv;;il;VX3FQS0cUjXX$68SQ68SZZQF3C$0QSQZ60DSQGIcUlylXXJX0tcVVi;...,:;:,:;:;:;:;:;
;:,:,:;:;,;,;;;,,i@@@@@BBQQMXLLJ6DSQZt8LvillylVvlvYlVlyljYUVcVLllillXMS6B8B8@BB8BB@886ED88BB@B@B@@@@@B@@@@@ZilKlLXcyUX$MXyViVlvyVvjvvii;;;Y12llviiV;,;vlvilCIcMGGLjcCKIF1X0S6SEZEQ8E@B8QB@@B@B@8QS88ESQ$$0EEBX;.;:,:;:;:;:,:,:
,,:;:;:,,;,;,;,;,OB@@@B8ZEB@0OQBS8KXyU8QylvLyyvyvlvlvlvlilvlvvilyM6@B@@@B@@@@@@@B@@@@@B@B@B@@@B@B@B@@@B@B@@OU0KcUtcLL2I2yYVcVUlylviVVYiviy2ZVlvliiiiivvVi: llj$@Qi               . .,;,;;iiiilljYX2D0E@@@@@@QV.,:;,;:;:;:,:,:;
;:,:,:;:;:;,;:;,,;;;;v@@@@@@@@@Q3S2jQB@8ZtMG$CMXKXtLJVcyvivillJK@@@@@B@@@B@@@@@@@@@B@@@B@B@B@@@B@@@@@@@@@B@B@@B8B68S62CVcUylVV1LMjVyVvlyGQ8XylUli;vYliYVV;iyviyY$8Si. ..:.:.,.:.. . . . .         . . ..:.,.. ,:;:;,,,;:,:;:;:
:,:,:,:;,;:;,;,;..   ;6@BE8@B@@SF20@@@@@8ESQQ8$SS6OZ0SO$KGIQB@@@@@B@@@@@@@@@B8SZGG2IKMctjlvlvlilvllVVUjKCSDBB@@@@@@BZSKKccVYvylYlUvv;iivC@$Y;ilyivlliviiiUMFyl;;i1EQXy,,,;,;,;:;,;:,:,:,.;.,.,.,.:.:.. . . ..,.,:;:,,;:,:,:,:;
;:,:;:,:,.,:;,;:;:,.:..    ...V@@@@@@@@@@@@B@B@@@@@B@@@B@@@B@@@@@BQtVii;;:,.:.:.:.: . . . . ..,.,.;,;,;;;;iilY1K$$8EEI3t1cLlyvlivvliiiiiOBZilvyvlilii;iiiiMUVi;i;.;Vti,.;,;:;,;:;,;,;:;,;,;,;:,:,.,:;:,:,.,.,,;,;:;,;:,:;:;:;:
:,:;:,:;:,:,:;:,:,:,:,.. . . .i@B@BBQ88@@@@@B@B@B@@@8BQ8EQ1Lvi;, . . ..:.,.,.,:,.,:,:;:,,;,;,;;;;;;;;;;;;i;i;iii;ivM$$t1Jclliliv;iililvl2@Iylyvlii;;;;iliij0v;;i;,.ilv::.;,;,;:;,;,;,;,;,;,;,;:,,;:;:,,;:;:;:;:,:;:,:,:;:;:;:,
;:,:,:;:;:,:,:;:;:,:;:,.,:,:,..                                 ..,.,:;,;:;:;:;,;,;,;,;,;;;,;;;;;;;;;;i;;;i;i;i;i;;VSCtUMUVviii;;,;iyYYvOB6jVllvviviiiiiyvy1Liyvvii;JKv:::;,;,;:;,;:;,;:;:;,,:;:,,,:,:;:;,;,;:;:;,;,;,,:,:;:,:
,;:,:;:,:,:,:,:;:;,;,;:;:,,;:,.. . . . . . . . . . . . ....:.,:,:,:;,;:;:;:;,;,;,;,;,;,;,;,;,;,;,;;;;;;;;i;;;i;iiii2ZOXJUcvlljlyi;,;illl3@8IUUYVvliv;iilyVlS0UvYlVvVyFSj.::;,;,;:;,;,,,;,;:;,;,;:;:;:,:;,;,;:;:;:,:;:;:;:,:,:,
;:;:;:;:,:;:,:;:,:;:;,;:,:;:;:;:;:;:;:,:,.,.,:,:,.,:;,,,;:,:;,;,,,;,;,;:;,;,;,;,;,;:;:;,;,;,;,;,;,;;;;;;;;;;i;iiyltZE3IjLX$C$DEZ6Ji;iillZ@@QItXyVlvii;llylVQ8KFjYvYlllLcl.,,;,;:;,;,;:;:;:;:;:,:,:;:,:;:;:;:;:;:;:;:;:,:;:;:;:
,;:;:,:,:;:;:,:;:;:;:;,;:;:;:;,;,;:,:;:,,,:;,;:;:,:;:;:;:;,;,;:;:;:;:;:;,;,;,;,;,;:;,;:;:;,;,;,;,;,;,;;;;;;;;iilvUZ@8D33CE8BB@S6QQCFi;iVS@BQM3cjyVvi;vljlyl8BQ2tllvvlViYUi.,,;:;:;,;:;,,,;:;:,:,:;:,,;,;:;:;:;:;:,:;:,:;:;:,:,
;:;:,:;:,:;:;:;:;:;:,:;:;:;:;:,,;,,,;,;:;:;:;:;:,:;:,:,:,,;,,:,:,:;:;:;:,,;,;,;:;:;:;,;,;,;,;,;,;,;,;,;;;;;;i;iilYB@@E8S8B@@@B$F6SEQMlVjE@B2GIMYVlliiilycYUB@StYyii;iiiiLl,.;,;:;:;:;:;,;:;:;:,:;:;:;:;,,:;:;:;:,:;:,:,:,:;:,:
,;:,:;:;:,:,:,:;:;:,:;:;:;:;:,:,:,:,,,:,,;:;:,:;,;:;:;:,:;:;,;:;,;,;,;:;:;:;:,,;,,:;:;,,:;,;,;,;,;,;,;,;,;;;;;;iilC@@@B@8@@@@8cX$88@8608B@B0IQ3MM$CIFC1UlyU@@8jliVVlvyiilV;,:;:;:;:;:;:;:;:;,;:,:,:,:;,;:;,;:,:,:,:;:,:;:;:;:;
;:,:;:;:;:,:,:,:;:;:,:,:;:;:,:,:;:,:,:;:,:;:;:;:;:;:;:,:,:,:;.,:,:;:;:;:;,;:;:,:;,,:;:;:;:,:;,;:;:;:;,;,;,;;;;;;iic8@B@@@@@@@61JD8@BBE@B@@@SQSSS@@@IG6B$XUI@@@SXK6BEEKl;jL;.,,;,;,;,;:;:;:;:;:;:,:;:;:;:;:;:,:,:,:;:;:;:,:;:;:
,;:;:;:,:,:;:;:;:,:;:,:;:;:,:;:,:,:;:;:;:,:,:;:,:;:;:,:,:;:;:,:,:;:,:;:;:,:,:,:,:;:;,;:;:,:,:;:;,,:,:;:;:,:;,;,;;;;l3B@@B@@@B$1D@@@@B@@@B@@BBBQB@@BtySBBG@@@B@QQ8@BO2E2F3j.,,;,,:;:;:;,,:;:;:;:,:;,,:,:;:,:;:;:;:,:,:;:;:;:;:;
;:,:;:;:,:,:;:;:;:;:;:;:,:;:;:,:,:,:,:,:;:,:,:,:,:,:;:,:,:,:,:,:,:;:;:,:,:;:,:;:,:,:,:,:;:,:;:,,;:,:,:,:,:;:;:,:,.: .:;iG@@@@B@@@@@B@B@B@@@@@B@@@@@FC8@@@@@@@@@8@@@1$QB@I:::;,;,;,;:,,;:;:,:,:,:;,;:;:;:;:,:;:,:,:,:,:,:,:;:;:
,;:,:,:,:,:,:,:,:;:;:,:;:;:;:;:,:,:;:,:,:;:,:;:;:;:,:;:;:;:;:;:;:,:,:,:,:;:,:;:;:,:;:,:,:,:,:,:;:,:,:,:;:;:;:,:;:,.:..   .;K@@0Y;;..     .;VMBB@B@@@@@B@MXXB@@@@@@@@B@@I:.:;:;,;,;:;:;,,:;:;,;:;:,:,:,:,:;:,:;:;:;:;:,:,:,:,:;
;:,:;:;:,:,:,:,:;:,:,:,:,:,:;:;:;:,:,:;:,:;:;:,:,:;:;:,:;:;:;:,:,:,:;:;:,:;:,:,:;:;:;:;:;:;:,:,:;:,:,:,:;:;:,,;,,:;:,.,..           . . .      :iV@BJ;;      .;iQ@@B0Jy...;:;:;:,:;,;:;:;:;:;,,:;:;:;:,:,:;:,:;:;:;:,:,:,:,:;:
,,:;:,:,:,:,:,:;:,:;:;:,:,:;:;:,:;:,:,:;:,:,:;:,:;:;:,:;:,:,:,:;:;:,:;:,:,:,:;:;:,:,:;:;:,:;:,:;:,:;:,:,:,:;:;:;:,:,,;,,:,.....:.,.,:,.,.,.:..         ... .       .   ..,:;:;:;:;:;:;:,:;:,:;:,:,:,:;:;:,:;:;:;:;:;:;:,:;:;:;
;:,:;:,:;:,:;:,:;:,:,:;:,:,:;:;:;:,:;:,:,:,:;:,:,:,:;:,:,:,:;:,:,:,:;:;:;:,:;:;:;:,:,:;:,:;:,:;:,:;:,:;:;:,:,:,:,:;:,:,:,:,:,.,:,:;:;:,:;:,:,.,.,.:.:.,:,:;:,.,.. . ..,:,:;:;:,:,,;:;:;:;:;,,:;:;:;:;:;:,:;:,:,:;:;:;:;:,:;:;:
,,:,:;:;:,:,:,:,:;:,:;:;:;:;:;:;:;:;:;:;:,:;:,:,:;:,:,:;:,:;:,:;:;:,:;:,:;:,:;:,:,:;:;:;:;:,:,:,:,:;:;:,:;:,:,:,:,:,:,:;:;:;:,:,:;:;:;:;:,:,:,:,:,.,:,:;:,:;:,:,:,:,:,:;:,:;:;:;:,:;:;:,:,:;:,:,:,:;:;:,:,:;:,:,:;:;:,:;:;:,:,
;:;:;:;:;:,:,:,:;:,:,:,:;:,:,:;:;:;:,:;:;:,:,:,:;:;:;:,:,:;:,:;:,:,:;:,:;:;:,:;:,:,:,:,:,:;:;:,:;:,:;:;:,:,:;:,:,:;:,:;:,:;:;:,:,:;:,:;:,:,:,:;:,:,:;:;:,:,:;:;:,:;:,:,:;:,:;:;:,:,:,:,:;:;:,:,:;:,:,:;:;:,:;:,:,:;:;:,:;:,:,:
:;:,:;:,:;:,:,:,:;:;:,:,:;:,:;:,:,:,:;:,:,:;:;:;:,:,:,:;:,:,:;:,:;:,:,:,:;:,:;:;:,:;:,:;:;:,:;:;:;:,:;:;:,:,:,:,:;:,:,:,:;:;:;:;:;:;:;:;:,:,:;:,:;:;:,:,:;:;:;:;:;:;:;:,:,:;:;:;:,:;:,:,:,:,:;:;:;:;:;:,:,:,:,:,:,:;:;:,:;:,:;
*/
// Railgun_Trolldom (the successor of Railgun_Swampshine_BailOut - avoiding second pattern comparison in BMH2 and pseudo-BMH4), copyleft 2016-Aug-19, Kaze.
// Railgun_Swampshine_BailOut, copyleft 2016-Aug-10, Kaze.
// Internet "home" page: http://www.codeproject.com/Articles/250566/Fastest-strstr-like-function-in-C
// My homepage (homeserver, often down): http://www.sanmayce.com/Railgun/
/*
!!!!!!!!!!!!!!!!!!!!!!!! BENCHMARKING GNU's memmem vs Railgun !!!!!!!!!!!!!!!!!!!!!!!! [
Add-on: 2016-Aug-22

Two things.

First, the fix from the last time was buggy, my apologies, now fixed, quite embarrassing since it is a simple left/right boundary check. It doesn't affect the speed, it appears as rare pattern hit misses.
Since I don't believe in saying "sorry" but in making things right, here my attempt to further disgrace my amateurish work follows:
Two years ago, I didn't pay due attention to adding 'Swampwalker' heuristic to the Railgun_Ennearch, I mean, only quick test was done and no real proofing - this was due not to a blunder of mine, nor carelessness, but overconfidence in my ability to write "on the fly". Stupid, indeed, however, when a coder gets momentum in writing simple etudes he starts gaining false confidence of mastering the subject, not good for sure!
Hopefully, other coders will learn to avoid such full of neglect style.

Second, wanted to present the heaviest testbed for search i.e. memmem() functions: it benefits the benchmarking (speed in real application) as well as bug-control.

The benchmark is downloadable at my INTERNET drive:
https://1drv.ms/u/s!AmWWFXGMzDmEglwjlUtnMJrfhosK

The speed showdown has three facets:
- compares the 64bit code generated from GCC 5.10 versus Intel 15.0 compilers;
- compares four types of datasets - search speed through English texts versus genome ACGT-type data versus binary versus UTF8;
- compares the tweaked Two-Way algorithm (implemented by Eric Blake) and adopted by GLIBC as memmem() versus my Railgun_Swampshine.

Note1: The GLIBC memmem() was taken from latest (2016-08-05) glibc 2.24 tar:
https://www.gnu.org/software/libc/
Note2: Eric Blake says that he enhanced the linearity of Two-Way by adding some sublinear paths, well, Railgun is all about sublinearity, so feel free to experiment with your own testfiles (worst-case-scenarios), just make such a file feed the compressor with it, then we will see how the LINEAR Two-Way behaves versus Railgun_Swampshine.
Note3: Just copy-and-paste 'Railgun_Swampshine' or 'Railgun_Ennearch' from the benchmark's source.

So the result on Core 2 Q9550s @2.83GHz DDR2 @666MHz / i5-2430M @3.00GHz DDR3 @666MHz:
--------------------------------------------------------------------------------------------------------------------------------
| Searcher                                  | GNU/GLIBC memmem()        | Railgun_Swampshine       | Railgun_Trolldom          | 
|--------------------------------------------------------------------------------------------------|---------------------------|
| Testfile\Compiler                         | Intel 15.0 | GCC 5.10     | Intel 15.0 | GCC 5.10    | Intel 15.0  | GCC 5.10    |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 27,703 bytes                        |     4506/- |   5330/14725 |    13198/- | 11581/15171 | 19105/22449 | 15493/21642 |
| Name: An_Interview_with_Carlos_Castaneda.TXT                          |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 308,062               |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 3,242,492,648       |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 2,347,772 bytes                     |      190/- |      226/244 |     1654/- |   1729/1806 |   1794/1822 |   1743/1809 |
| Name: Gutenberg_EBook_Don_Quixote_996_(ANSI).txt                      |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 14,316,954            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 6,663,594,719,173   |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 899,425 bytes                       |      582/- |      760/816 |     3094/- |   2898/3088 |   3255/3289 |   2915/3322 |
| Name: Gutenberg_EBook_Dokoe_by_Hakucho_Masamune_(Japanese_UTF8).txt   |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 3,465,806             |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 848,276,034,315     |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 4,487,433 bytes                     |      104/- |      109/116 |      445/- |     458/417 |     450/411 |     467/425 |
| Name: Dragonfly_genome_shotgun_sequence_(ACGT_alphabet).fasta         |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 20,540,375            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 13,592,530,857,131  |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 954,035 bytes                       |       99/- |      144/144 |      629/- |     580/682 |     634/807 |     585/725 |
| Name: LAOTZU_Wu_Wei_(BINARY).pdf                                      |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 27,594,933            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 8,702,455,122,519   |            |             |             |             |
|------------------------------------------------------------------------------------------------------------------------------|
| Size: 15,583,440 bytes                    |        -/- |          -/- |        -/- |     663/771 |     675/778 |     663/757 |
| Name: Arabian_Nights_complete.html                                    |            |             |             |             |
| LATENCY-WISE: Number of 'memmem()' Invocations: 72,313,262            |            |             |             |             |
| THROUGHPUT-WISE: Number of Total bytes Traversed: 105,631,163,854,099 |            |             |             |             |
--------------------------------------------------------------------------------------------------------------------------------

Note0: Railgun_Trolldom is slightly faster (both with Intel & GCC) than Railgun_Swampshine, this is mostly due to adding a bitwise BMH order 2 (8KB table overhead instead of 64KB) path - for haystacks <77777 bytes long - the warm-up is faster.
Note1: The numbers represent the rate (bytes/s) at which patterns/needles 4,5,6,8,9,10,12,13,14,16,17,18,24 bytes long are memmemed into 4KB, 256KB, 1MB, 256MB long haystacks.
in fact, these numbers are the compression speed using LZSS and memmem() as matchfinder.
Note2: The Arabian Nights is downloadable at:
https://ebooks.adelaide.edu.au/b/burton/richard/b97b/complete.html
Note3: On i5-2430M, TW is catching up since this CPU crunches instructions faster while the RAM speed is almost the same, Railgun suffers from the slow RAM fetches - the prefetcher and such suck.
Note4: With a simple English text 'Tales of 1001 Nights', 15,583,440 bytes long, the cumulative size of traversed haystack data is nearly 100TB, 105,631,163,854,099 ~ 1024^4 = 1,099,511,627,776.
Note5: With a simple French text 'Agatha_Christie_85-ebooks_(French)_TXT.tar', 32,007,168 bytes long, the cumulative size of traversed haystack data is nearly 200TB ~ 234,427,099,834,376.

Just to see how faster is Yann's Zstd in decompression (its level 12 is 377-331 MB/s faster), on Core 2 Q9550s @2.83GHz DDR2 @666MHz:
[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>Nakamichi_Kintaro++_Intel_15.0_64bit.exe Agatha_Christie_85-ebooks_(French)_TXT.tar
Nakamichi 'Kintaro++', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note1: This compile can handle files up to 1711MB.
Note2: The matchfinder/memmem() is Railgun_Trolldom.
Current priority class is HIGH_PRIORITY_CLASS.
Compressing 32007168 bytes ...
|; Each rotation means 64KB are encoded; Done 100%; Compression Ratio: 3.53:1
NumberOfFullLiterals (lower-the-better): 164
NumberOfFlushLiteralsHeuristic (bigger-the-better): 184323
Legend: WindowSizes: 1/2/3/4=Tiny/Short/Medium/Long
NumberOf(Tiny)Matches[Short]Window (4)[2]: 226869
NumberOf(Short)Matches[Short]Window (8)[2]: 119810
NumberOf(Medium)Matches[Short]Window (12)[2]: 71202
NumberOf(Long)Matches[Short]Window (16)[2]: 31955
NumberOf(MaxLong)Matches[Short]Window (24)[2]: 7078
NumberOf(Tiny)Matches[Medium]Window (5)[3]: 257313
NumberOf(Short)Matches[Medium]Window (9)[3]: 526493
NumberOf(Medium)Matches[Medium]Window (13)[3]: 285579
NumberOf(Long)Matches[Medium]Window (17)[3]: 158873
NumberOf(MaxLong)Matches[Medium]Window (24)[3]: 51276
NumberOf(Tiny)Matches[Long]Window (6)[4]: 41075
NumberOf(Short)Matches[Long]Window (10)[4]: 240454
NumberOf(Medium)Matches[Long]Window (14)[4]: 258653
NumberOf(Long)Matches[Long]Window (18)[4]: 209007
NumberOf(MaxLong)Matches[Long]Window (24)[4]: 190929
RAM-to-RAM performance: 605 bytes/s.
Compressed to 9076876 bytes.
LATENCY-WISE: Number of 'memmem()' Invocations: 102,091,852
THROUGHPUT-WISE: Number of Total bytes Traversed: 234,427,099,834,376

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>"Nakamichi_Kintaro++_Intel_15.0_64bit.exe" "Agatha_Christie_85-ebooks_(French)_TXT.tar.Nakamichi"
Nakamichi 'Kintaro++', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note1: This compile can handle files up to 1711MB.
Note2: The matchfinder/memmem() is Railgun_Trolldom.
Current priority class is HIGH_PRIORITY_CLASS.
Decompressing 9076876 bytes ...
RAM-to-RAM performance: 331 MB/s.
Compression Ratio (bigger-the-better): 3.53:1

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -h
*** zstd command line interface 64-bits v0.8.1, by Yann Collet ***
...

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -b12 "Agatha_Christie_85-ebooks_(French)_TXT.tar"
12#_(French)_TXT.tar :  32007168 ->   8965791 (3.570),   6.7 MB/s , 377.0 MB/s

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>zstd-windows-v0.8.1_win64.exe -b22 "Agatha_Christie_85-ebooks_(French)_TXT.tar"
22#_(French)_TXT.tar :  32007168 ->   6802321 (4.705),   1.0 MB/s , 260.7 MB/s

D:\Nakamichi_Kintaro++_source_executables_64bit_(GCC510-vs-Intel150)_(TW-vs-RG)_BENCHMARK>
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]

Two-Way is significantly slower than BMH Order 2, the speed-down is in range:
- for TEXTUAL ANSI alphabets: 1729/226= 7.6x
- for TEXTUAL UTF8 alphabets: 2898/760= 3.8x
- for TEXTUAL ACGT alphabets:  458/109= 4.2x
- for BINARY-esque alphabets:  580/144= 4.0x

For faster RAM, than mine @666MHz, and for haystacks multimegabytes long, the speedup goes beyond 8x.

The benchmark shows the real behavior (both latency and raw speed) of the memmem variants, I added also the Thierry Lecroq's Two-Way implementation:
http://www-igm.univ-mlv.fr/~lecroq/string/node26.html#SECTION00260
However, Eric Blake's one is faster, so it was chosen for the speed showdown.

Once I measured the total length of traversed haystacks, and for files 100+MB long, it went ... quintillion of bytes i.e. petabytes - good torture it is.

!!!!!!!!!!!!!!!!!!!!!!!! BENCHMARKING GNU's memmem vs Railgun !!!!!!!!!!!!!!!!!!!!!!!! ]
*/
// 2014-Apr-27: The nasty SIGNED/UNSIGNED bug in 'Swampshines' which I illustrated several months ago in my fuzzy search article now is fixed here too:
/*
The bug is this (the variables 'i' and 'PRIMALposition' are uint32_t):
Next line assumes -19 >= 0 is true:
if ( (i-(PRIMALposition-1)) >= 0) printf ("THE NASTY BUG AGAIN: %d >= 0\n", i-(PRIMALposition-1));
Next line assumes -19 >= 0 is false:
if ( (signed int)(i-(PRIMALposition-1)) >= 0) printf ("THE NASTY BUG AGAIN: %d >= 0\n", i-(PRIMALposition-1));
And the actual fix:
...
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed int)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) {
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
...
*/
// Railgun_Swampshine_BailOut, copyleft 2014-Jan-31, Kaze.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
#define NeedleThreshold2vs4swampLITE 9+10 // Should be bigger than 9. BMH2 works up to this value (inclusive), if bigger then BMH4 takes over. Should be <=255 otherwise the 0|1 BMH2 should be used.
char * Railgun_Trolldom_64 (char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern) 
{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	//signed long count;
	signed long long count; // 2020-Jan-11

	unsigned char bm_Horspool_Order2[256*256]; // Bitwise soon...
	unsigned char bm_Horspool_Order2bitwise[(256*256)>>3]; // Bitwise soon...
	//uint32_t i, Gulliver;
	uint64_t i, Gulliver;

	//uint32_t PRIMALposition, PRIMALpositionCANDIDATE;
	//uint32_t PRIMALlength, PRIMALlengthCANDIDATE;
	//uint32_t j, FoundAtPosition;

	uint64_t PRIMALposition, PRIMALpositionCANDIDATE;
	uint64_t PRIMALlength, PRIMALlengthCANDIDATE;
	uint64_t j, FoundAtPosition;

// Quadruplet [
    //char * pbTargetMax = pbTarget + cbTarget;
    //register unsigned long  ulHashPattern;
    unsigned long ulHashTarget;
    //unsigned long count;
    unsigned long countSTATIC;
    unsigned char SINGLET;
    unsigned long Quadruplet2nd;
    unsigned long Quadruplet3rd;
    unsigned long Quadruplet4th;
    unsigned long  AdvanceHopperGrass;
// Quadruplet ]

// 2020-Jan-11 [
//	uint64_t A=3123123123, B=5123123123;
//if ((signed int)A > 0) printf("(signed int)3billion OK\n"); else printf("(signed int)3billion Bug\n");
//if ((signed int)B > 0) printf("(signed int)5billion OK\n"); else printf("(signed int)5billion Bug\n");
//if ((signed long long)A > 0) printf("(signed long long)3billion OK\n"); else printf("(signed long long)3billion Bug\n");
//if ((signed long long)B > 0) printf("(signed long long)5billion OK\n"); else printf("(signed long long)5billion Bug\n");

//(signed int)3billion Bug
//(signed int)5billion OK
//(signed long long)3billion OK
//(signed long long)5billion OK
// 2020-Jan-11 ]

GLOBAL_Railgun_INVOCATIONS++; // 2020-Jan-29
GLOBAL_Railgun_INVOCATIONS_ARRAY[cbPattern]++; // 2020-Jan-29

	if (cbPattern > cbTarget) return(NULL);

#ifdef LITE
return(NULL); // 2020-Feb-14
#endif

	if ( cbPattern<4 ) { 
		// SSE2 i.e. 128bit Assembly rules here, Mischa knows best:
		// ...
        	pbTarget = pbTarget+cbPattern;
		ulHashPattern = ( (*(char *)(pbPattern))<<8 ) + *(pbPattern+(cbPattern-1));
		if ( cbPattern==3 ) {
			for ( ;; ) {
				if ( ulHashPattern == ( (*(char *)(pbTarget-3))<<8 ) + *(pbTarget-1) ) {
					if ( *(char *)(pbPattern+1) == *(char *)(pbTarget-2) ) return((pbTarget-3));
				}
				if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) { 
					pbTarget++;
					if ( (char)(ulHashPattern>>8) != *(pbTarget-2) ) pbTarget++;
				}
				pbTarget++;
				if (pbTarget > pbTargetMax) return(NULL);
			}
		} else {
		}
		for ( ;; ) {
			if ( ulHashPattern == ( (*(char *)(pbTarget-2))<<8 ) + *(pbTarget-1) ) return((pbTarget-2));
			if ( (char)(ulHashPattern>>8) != *(pbTarget-1) ) pbTarget++;
			pbTarget++;
			if (pbTarget > pbTargetMax) return(NULL);
		}
	} else { //if ( cbPattern<4 )
		if ( cbPattern<=NeedleThreshold2vs4swampLITE ) { 

// This is the awesome 'Railgun_Quadruplet', it did outperform EVERYWHERE the fastest strstr (back in old GLIBCes ~2003, by the Dutch hacker Stephen R. van den Berg), suitable for short haystacks ~100bytes.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
// char * Railgun_Quadruplet (char * pbTarget, char * pbPattern, unsigned long cbTarget, unsigned long cbPattern)
// ...
//    if (cbPattern > cbTarget) return(NULL);
//} else { //if ( cbPattern<4)
if (cbTarget<777) // This value is arbitrary(don't know how exactly), it ensures(at least must) better performance than 'Boyer_Moore_Horspool'.
{
        pbTarget = pbTarget+cbPattern;
        ulHashPattern = *(unsigned long *)(pbPattern);
//        countSTATIC = cbPattern-1;

    //SINGLET = *(char *)(pbPattern);
    SINGLET = ulHashPattern & 0xFF;
    Quadruplet2nd = SINGLET<<8;
    Quadruplet3rd = SINGLET<<16;
    Quadruplet4th = SINGLET<<24;

    for ( ;; )
    {
	AdvanceHopperGrass = 0;
	ulHashTarget = *(unsigned long *)(pbTarget-cbPattern);

        if ( ulHashPattern == ulHashTarget ) { // Three unnecessary comparisons here, but 'AdvanceHopperGrass' must be calculated - it has a higher priority.
//         count = countSTATIC;
//         while ( count && *(char *)(pbPattern+1+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) {
//	       if ( countSTATIC==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-cbPattern+1+(countSTATIC-count)) ) AdvanceHopperGrass++;
//               count--;
//         }
         count = cbPattern-1;
         while ( count && *(char *)(pbPattern+(cbPattern-count)) == *(char *)(pbTarget-count) ) {
	       if ( cbPattern-1==AdvanceHopperGrass+count && SINGLET != *(char *)(pbTarget-count) ) AdvanceHopperGrass++;
               count--;
         }
         if ( count == 0) return((pbTarget-cbPattern));
        } else { // The goal here: to avoid memory accesses by stressing the registers.
    if ( Quadruplet2nd != (ulHashTarget & 0x0000FF00) ) {
         AdvanceHopperGrass++;
         if ( Quadruplet3rd != (ulHashTarget & 0x00FF0000) ) {
              AdvanceHopperGrass++;
              if ( Quadruplet4th != (ulHashTarget & 0xFF000000) ) AdvanceHopperGrass++;
         }
    }
	}

	AdvanceHopperGrass++;

	pbTarget = pbTarget + AdvanceHopperGrass;
        if (pbTarget > pbTargetMax)
            return(NULL);
    }
} else if (cbTarget<77777) { // The warmup/overhead is lowered from 64K down to 8K, however the bitwise additional instructions quickly start hurting the throughput/traversal.
// The below bitwise 0|1 BMH2 gives 1427 bytes/s for 'Don_Quixote' with Intel:
// The below bitwise 0|1 BMH2 gives 1242 bytes/s for 'Don_Quixote' with GCC:
//	} else { //if ( cbPattern<4 )
//		if ( cbPattern<=NeedleThreshold2vs4Decumanus ) { 
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			//for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < (256*256)>>3; i++) {bm_Horspool_Order2bitwise[i]=0;}
			//for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			for (i=0; i < cbPattern-2+1; i++) bm_Horspool_Order2bitwise[(*(unsigned short *)(pbPattern+i))>>3]= bm_Horspool_Order2bitwise[(*(unsigned short *)(pbPattern+i))>>3] | (1<<((*(unsigned short *)(pbPattern+i))&0x7));
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
				if ( ( bm_Horspool_Order2bitwise[(*(unsigned short *)&pbTarget[i+cbPattern-1-1])>>3] & (1<<((*(unsigned short *)&pbTarget[i+cbPattern-1-1])&0x7)) ) != 0 ) {
					//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
					if ( ( bm_Horspool_Order2bitwise[(*(unsigned short *)&pbTarget[i+cbPattern-1-1-2])>>3] & (1<<((*(unsigned short *)&pbTarget[i+cbPattern-1-1-2])&0x7)) ) == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
//		} else { // if ( cbPattern<=NeedleThreshold2vs4Decumanus )
} else { //if (cbTarget<777)
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

// Slower than Swampshine's simple 0|1 segment:
/*
PRIMALlength=0;
for (i=0+(1); i < cbPattern-2+1+(1)-(1); i++) { // -(1) because the last BB order 2 has no counterpart(s)
    FoundAtPosition = cbPattern;
    PRIMALpositionCANDIDATE=i;
    while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
        j = PRIMALpositionCANDIDATE + 1;
        while ( j <= (FoundAtPosition-1) ) {
            if ( *(unsigned short *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(unsigned short *)(pbPattern+j-(1)) ) FoundAtPosition = j;
            j++;
        }
        PRIMALpositionCANDIDATE++;
    }
    PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+(2);
    if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
}
PRIMALlengthCANDIDATE = cbPattern;
cbPattern = PRIMALlength;
pbPattern = pbPattern + (PRIMALposition-1);
if (cbPattern<4) {
	cbPattern = PRIMALlengthCANDIDATE;
	pbPattern = pbPattern - (PRIMALposition-1);
}
if (cbPattern == PRIMALlengthCANDIDATE) {
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
} else { //if (cbPattern == PRIMALlengthCANDIDATE) {
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= cbPattern-1;} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			// The above 'for' gives  1424 bytes/s for 'Don_Quixote' with Intel:
			// The above 'for' gives  1431 bytes/s for 'Don_Quixote' with GCC:
			// The below 'memset' gives  1389 bytes/s for 'Don_Quixote' with Intel:
			// The below 'memset' gives  1432 bytes/s for 'Don_Quixote' with GCC:
			//memset(&bm_Horspool_Order2[0], cbPattern-1, 256*256); // Why why? It is 1700:1000 slower than above 'for'!?
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
} //if (cbPattern == PRIMALlengthCANDIDATE) {
*/

/*
So the result on Core 2 Q9550s @2.83GHz:
---------------------------------------------------------------------------------------------------------------------
| testfile\Searcher                         | GNU/GLIBC memmem()    | Railgun_Swampshine    | Railgun_Trolldom      | 
|-------------------------------------------------------------------------------------------|-----------------------|
| Compiler                                  | Intel 15.0 | GCC 5.10 | Intel 15.0 | GCC 5.10 | Intel 15.0 | GCC 5.10 |
|-------------------------------------------------------------------------------------------|-----------------------|
| The_Project_Gutenberg_EBook_of_Don        |        190 |      226 |       1654 |     1729 |       1147 |     1764 |
| _Quixote_996_(ANSI).txt                   |            |          |            |          |            |          |
| 2,347,772 bytes                           |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| The_Project_Gutenberg_EBook_of_Dokoe      |        582 |      760 |       3094 |     2898 |       2410 |     3036 |
| _by_Hakucho_Masamune_(Japanese_UTF-8).txt |            |          |            |          |            |          |
| 899,425 bytes                             |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| Dragonfly_genome_shotgun_sequence         |        104 |      109 |        445 |      458 |        484 |      553 |
| _(ACGT_alphabet).fasta                    |            |          |            |          |            |          |
| 4,487,433 bytes                           |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
| LAOTZU_Wu_Wei_(BINARY).pdf                |         99 |      144 |        629 |      580 |        185 |      570 |
| 954,035 bytes                             |            |          |            |          |            |          |
|-------------------------------------------------------------------------------------------|-----------------------|
Below segment (when compiled with Intel) is very slow, see Railgun_Trolldom two sub-columns above, compared to GCC:
*/
/*
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= (cbPattern-1);} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			// The above 'for' is translated by Intel as:
//.B5.21::                        
//  0013f 83 c0 40         add eax, 64                            
//  00142 66 0f 7f 44 14 
//        60               movdqa XMMWORD PTR [96+rsp+rdx], xmm0  
//  00148 3d 00 00 01 00   cmp eax, 65536                         
//  0014d 66 0f 7f 44 14 
//        70               movdqa XMMWORD PTR [112+rsp+rdx], xmm0 
//  00153 66 0f 7f 84 14 
//        80 00 00 00      movdqa XMMWORD PTR [128+rsp+rdx], xmm0 
//  0015c 66 0f 7f 84 14 
//        90 00 00 00      movdqa XMMWORD PTR [144+rsp+rdx], xmm0 
//  00165 89 c2            mov edx, eax                           
//  00167 72 d6            jb .B5.21 
			//memset(&bm_Horspool_Order2[0], cbPattern-1, 256*256); // Why why? It is 1700:1000 slower than above 'for'!?
			// The above 'memset' is translated by Intel as:
//  00127 41 b8 00 00 01 
//        00               mov r8d, 65536                         
//  0012d 44 8b 26         mov r12d, DWORD PTR [rsi]              
//  00130 e8 fc ff ff ff   call _intel_fast_memset                
			// ! The problem is that 256*256, 64KB, is already too much, going bitwise i.e. 8KB is not that better, when 'cbPattern-1' is bigger than 255 - an unsigned char - then 
			// we must switch to 0|1 table i.e. present or not. Since we are in 'if ( cbPattern<=NeedleThreshold2vs4swampLITE ) {' branch and NeedleThreshold2vs4swampLITE, by default, is 19 - it is okay to use 'memset'. !
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
						if ( count <= 0 ) return(pbTarget+i);	
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
*/
// Above fragment in Assembly:
/*
; mark_description "Intel(R) C++ Intel(R) 64 Compiler XE for applications running on Intel(R) 64, Version 15.0.0.108 Build 20140";
; mark_description "-O3 -QxSSE2 -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY -FA";
       ALIGN     16
.B6.1::                         ; Preds .B6.0
        push      rbx                                           ;3435.1
        push      r13                                           ;3435.1
        push      r15                                           ;3435.1
        push      rbp                                           ;3435.1
        mov       eax, 65592                                    ;3435.1
        call      __chkstk                                      ;3435.1
        sub       rsp, 65592                                    ;3435.1
        cmp       r9d, r8d                                      ;3460.18
        ja        .B6.25        ; Prob 28%                      ;3460.18
                                ; LOE rdx rcx rbx rsi rdi r12 r14 r8d r9d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.3::                         ; Preds .B6.1
        mov       r13d, DWORD PTR [rdx]                         ;3491.33
        lea       ebp, DWORD PTR [-1+r9]                        ;3492.67
        movzx     eax, bpl                                      ;3492.67
        xor       r10d, r10d                                    ;3492.4
        movd      xmm0, eax                                     ;3492.67
        xor       eax, eax                                      ;3492.4
        punpcklbw xmm0, xmm0                                    ;3492.67
        punpcklwd xmm0, xmm0                                    ;3492.67
        punpckldq xmm0, xmm0                                    ;3492.67
        punpcklqdq xmm0, xmm0                                   ;3492.67
                                ; LOE rdx rcx rbx rsi rdi r10 r12 r14 eax ebp r8d r9d r13d xmm0 xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.4::                         ; Preds .B6.4 .B6.3
        add       eax, 64                                       ;3492.4
        movdqa    XMMWORD PTR [48+rsp+r10], xmm0                ;3492.33
        cmp       eax, 65536                                    ;3492.4
        movdqa    XMMWORD PTR [64+rsp+r10], xmm0                ;3492.33
        movdqa    XMMWORD PTR [80+rsp+r10], xmm0                ;3492.33
        movdqa    XMMWORD PTR [96+rsp+r10], xmm0                ;3492.33
        mov       r10d, eax                                     ;3492.4
        jb        .B6.4         ; Prob 99%                      ;3492.4
                                ; LOE rdx rcx rbx rsi rdi r10 r12 r14 eax ebp r8d r9d r13d xmm0 xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.5::                         ; Preds .B6.4
        test      ebp, ebp                                      ;3515.28
        je        .B6.12        ; Prob 50%                      ;3515.28
                                ; LOE rdx rcx rbx rsi rdi r12 r14 ebp r8d r9d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.6::                         ; Preds .B6.5
        mov       eax, 1                                        ;3515.4
        lea       r11d, DWORD PTR [-1+r9]                       ;3515.4
        mov       r15d, r11d                                    ;3515.4
        xor       r10d, r10d                                    ;3515.4
        shr       r15d, 1                                       ;3515.4
        test      r15d, r15d                                    ;3515.4
        jbe       .B6.10        ; Prob 15%                      ;3515.4
                                ; LOE rdx rcx rbx rsi rdi r12 r14 eax ebp r8d r9d r10d r11d r13d r15d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.8::                         ; Preds .B6.6 .B6.8
        lea       eax, DWORD PTR [r10+r10]                      ;3515.36
        movzx     ebx, WORD PTR [rax+rdx]                       ;3515.75
        mov       BYTE PTR [48+rsp+rbx], al                     ;3515.36
        lea       eax, DWORD PTR [1+r10+r10]                    ;3515.36
        inc       r10d                                          ;3515.4
        cmp       r10d, r15d                                    ;3515.4
        movzx     ebx, WORD PTR [rax+rdx]                       ;3515.75
        mov       BYTE PTR [48+rsp+rbx], al                     ;3515.36
        jb        .B6.8         ; Prob 64%                      ;3515.4
                                ; LOE rdx rcx rsi rdi r12 r14 ebp r8d r9d r10d r11d r13d r15d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.9::                         ; Preds .B6.8
        lea       eax, DWORD PTR [1+r10+r10]                    ;3515.4
                                ; LOE rdx rcx rbx rsi rdi r12 r14 eax ebp r8d r9d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.10::                        ; Preds .B6.9 .B6.6
        dec       eax                                           ;3515.36
        cmp       eax, r11d                                     ;3515.4
        jae       .B6.12        ; Prob 15%                      ;3515.4
                                ; LOE rax rdx rcx rbx rsi rdi r12 r14 ebp r8d r9d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.11::                        ; Preds .B6.10
        movzx     r10d, WORD PTR [rax+rdx]                      ;3515.75
        mov       BYTE PTR [48+rsp+r10], al                     ;3515.36
                                ; LOE rdx rcx rbx rsi rdi r12 r14 ebp r8d r9d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.12::                        ; Preds .B6.5 .B6.10 .B6.11
        xor       r10d, r10d                                    ;3516.4
        lea       r15d, DWORD PTR [-3+r9]                       ;3522.27
        movsxd    r15, r15d                                     ;3522.7
        sub       r8d, r9d                                      ;3517.16
        lea       r11d, DWORD PTR [-2+r9]                       ;3520.32
                                ; LOE rdx rcx rsi rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.13::                        ; Preds .B6.12 .B6.24
        lea       eax, DWORD PTR [-2+r9+r10]                    ;3518.78
        movzx     ebx, WORD PTR [rax+rcx]                       ;3518.55
        movzx     eax, BYTE PTR [48+rsp+rbx]                    ;3518.16
        cmp       eax, ebp                                      ;3519.32
        je        .B6.24        ; Prob 50%                      ;3519.32
                                ; LOE rdx rcx rsi rdi r12 r14 r15 eax ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.14::                        ; Preds .B6.13
        cmp       eax, r11d                                     ;3520.32
        jne       .B6.23        ; Prob 62%                      ;3520.32
                                ; LOE rdx rcx rsi rdi r12 r14 r15 eax ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.15::                        ; Preds .B6.14
        mov       eax, r10d                                     ;3521.25
        add       rax, rcx                                      ;3521.25
        cmp       r13d, DWORD PTR [rax]                         ;3521.40
        je        .B6.17        ; Prob 50%                      ;3521.40
                                ; LOE rax rdx rcx rsi rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.16::                        ; Preds .B6.26 .B6.15
        mov       eax, 1                                        ;3527.6
        jmp       .B6.24        ; Prob 100%                     ;3527.6
                                ; LOE rdx rcx rsi rdi r12 r14 r15 eax ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.17::                        ; Preds .B6.15
        mov       rbx, r15                                      ;3522.7
        test      r15, r15                                      ;3523.23
        jle       .B6.22        ; Prob 2%                       ;3523.23
                                ; LOE rax rdx rcx rbx rsi rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.18::                        ; Preds .B6.17
        mov       QWORD PTR [32+rsp], rsi                       ;
                                ; LOE rax rdx rcx rbx rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.19::                        ; Preds .B6.20 .B6.18
        mov       esi, DWORD PTR [-1+rbx+rdx]                   ;3523.58
        cmp       esi, DWORD PTR [-1+rbx+rax]                   ;3523.79
        jne       .B6.26        ; Prob 20%                      ;3523.79
                                ; LOE rax rdx rcx rbx rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.20::                        ; Preds .B6.19
        add       rbx, -4                                       ;3524.22
        test      rbx, rbx                                      ;3523.23
        jg        .B6.19        ; Prob 82%                      ;3523.23
                                ; LOE rax rdx rcx rbx rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.21::                        ; Preds .B6.20
        mov       rsi, QWORD PTR [32+rsp]                       ;
                                ; LOE rax rbx rsi rdi r12 r14 xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.22::                        ; Preds .B6.17 .B6.21
        add       rsp, 65592                                    ;3525.32
        pop       rbp                                           ;3525.32
        pop       r15                                           ;3525.32
        pop       r13                                           ;3525.32
        pop       rbx                                           ;3525.32
        ret                                                     ;3525.32
                                ; LOE
.B6.23::                        ; Preds .B6.14
        neg       eax                                           ;3529.17
        add       eax, r9d                                      ;3529.17
        add       eax, -2                                       ;3529.40
                                ; LOE rdx rcx rsi rdi r12 r14 r15 eax ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.24::                        ; Preds .B6.16 .B6.23 .B6.13
        add       r10d, eax                                     ;3531.13
        cmp       r10d, r8d                                     ;3517.25
        jbe       .B6.13        ; Prob 82%                      ;3517.25
                                ; LOE rdx rcx rsi rdi r12 r14 r15 ebp r8d r9d r10d r11d r13d xmm6 xmm7 xmm8 xmm9 xmm10 xmm11 xmm12 xmm13 xmm14 xmm15
.B6.25::                        ; Preds .B6.1 .B6.24
        xor       eax, eax                                      ;3534.10
        add       rsp, 65592                                    ;3534.10
        pop       rbp                                           ;3534.10
        pop       r15                                           ;3534.10
        pop       r13                                           ;3534.10
        pop       rbx                                           ;3534.10
        ret                                                     ;3534.10
                                ; LOE
.B6.26::                        ; Preds .B6.19                  ; Infreq
        mov       rsi, QWORD PTR [32+rsp]                       ;
        jmp       .B6.16        ; Prob 100%                     ;
*/

// GCC 5.10; >gcc -O3 -m64 -fomit-frame-pointer
/*
Railgun_Trolldom:
	pushq	%r15
	.seh_pushreg	%r15
	movl	$65592, %eax
	pushq	%r14
	.seh_pushreg	%r14
	pushq	%r13
	.seh_pushreg	%r13
	pushq	%r12
	.seh_pushreg	%r12
	pushq	%rbp
	.seh_pushreg	%rbp
	pushq	%rdi
	.seh_pushreg	%rdi
	pushq	%rsi
	.seh_pushreg	%rsi
	pushq	%rbx
	.seh_pushreg	%rbx
	call	___chkstk_ms
	subq	%rax, %rsp
	.seh_stackalloc	65592
	.seh_endprologue
	cmpl	%r9d, %r8d
	movq	%rcx, %rbx
	movq	%rdx, %rdi
	movl	%r8d, %r12d
	movl	%r9d, %esi
	jb	.L118
	movl	(%rdx), %ebp
	leal	-1(%r9), %edx
	movl	$65536, %r8d
	leaq	48(%rsp), %rcx
	movzbl	%dl, %edx
	call	memset
	movl	%esi, %r11d
	subl	$1, %r11d
	je	.L119
	xorl	%eax, %eax
	.p2align 4,,10
.L113:
	movzwl	(%rdi,%rax), %edx
	movb	%al, 48(%rsp,%rdx)
	addq	$1, %rax
	cmpl	%eax, %r11d
	ja	.L113
.L112:
	leal	-4(%rsi), %r9d
	movl	%r12d, %r8d
	xorl	%edx, %edx
	leal	-3(%rsi), %eax
	shrl	$2, %r9d
	subl	%esi, %r8d
	leal	-2(%rsi), %r10d
	movslq	%eax, %r14
	negq	%r9
	movl	%eax, 44(%rsp)
	leaq	-1(%r14), %r15
	salq	$2, %r9
	leaq	(%rdi,%r14), %r13
	jmp	.L117
	.p2align 4,,10
.L130:
	movl	%r10d, %eax
	subl	%ecx, %eax
	cmpl	%r10d, %ecx
	je	.L129
.L114:
	addl	%eax, %edx
	cmpl	%r8d, %edx
	ja	.L118
.L117:
	leal	(%rdx,%r10), %eax
	movzwl	(%rbx,%rax), %eax
	movzbl	48(%rsp,%rax), %ecx
	cmpl	%r11d, %ecx
	jne	.L130
	movl	%r11d, %eax
	addl	%eax, %edx
	cmpl	%r8d, %edx
	jbe	.L117
.L118:
	xorl	%eax, %eax
	jmp	.L128
	.p2align 4,,10
.L129:
	movl	%edx, %ecx
	movl	$1, %eax
	leaq	(%rbx,%rcx), %r12
	cmpl	(%r12), %ebp
	jne	.L114
	movl	44(%rsp), %esi
	testl	%esi, %esi
	jle	.L124
	movl	(%r12,%r15), %esi
	cmpl	%esi, (%rdi,%r15)
	jne	.L114
	addq	%r14, %rcx
	xorl	%eax, %eax
	addq	%rbx, %rcx
	jmp	.L116
	.p2align 4,,10
.L132:
	movl	-5(%r13,%rax), %esi
	subq	$4, %rax
	cmpl	-1(%rcx,%rax), %esi
	jne	.L131
.L116:
	cmpq	%rax, %r9
	jne	.L132
.L124:
	movq	%r12, %rax
.L128:
	addq	$65592, %rsp
	popq	%rbx
	popq	%rsi
	popq	%rdi
	popq	%rbp
	popq	%r12
	popq	%r13
	popq	%r14
	popq	%r15
	ret
	.p2align 4,,10
.L131:
	movl	$1, %eax
	jmp	.L114
.L119:
	xorl	%r11d, %r11d
	jmp	.L112
*/

} //if (cbTarget<777)

		} else { // if ( cbPattern<=NeedleThreshold2vs4swampLITE )

// Swampwalker_BAILOUT heuristic order 4 (Needle should be bigger than 4) [
// Needle: 1234567890qwertyuiopasdfghjklzxcv            PRIMALposition=01 PRIMALlength=33  '1234567890qwertyuiopasdfghjklzxcv'
// Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv            PRIMALposition=29 PRIMALlength=04  'vvvv'
// Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv            PRIMALposition=08 PRIMALlength=20  'vvvBOOMSHAKALAKAvvvv'
// Needle: Trollland                                    PRIMALposition=01 PRIMALlength=09  'Trollland'
// Needle: Swampwalker                                  PRIMALposition=01 PRIMALlength=11  'Swampwalker'
// Needle: licenselessness                              PRIMALposition=01 PRIMALlength=15  'licenselessness'
// Needle: alfalfa                                      PRIMALposition=02 PRIMALlength=06  'lfalfa'
// Needle: Sandokan                                     PRIMALposition=01 PRIMALlength=08  'Sandokan'
// Needle: shazamish                                    PRIMALposition=01 PRIMALlength=09  'shazamish'
// Needle: Simplicius Simplicissimus                    PRIMALposition=06 PRIMALlength=20  'icius Simplicissimus'
// Needle: domilliaquadringenquattuorquinquagintillion  PRIMALposition=01 PRIMALlength=32  'domilliaquadringenquattuorquinqu'
// Needle: boom-boom                                    PRIMALposition=02 PRIMALlength=08  'oom-boom'
// Needle: vvvvv                                        PRIMALposition=01 PRIMALlength=04  'vvvv'
// Needle: 12345                                        PRIMALposition=01 PRIMALlength=05  '12345'
// Needle: likey-likey                                  PRIMALposition=03 PRIMALlength=09  'key-likey'
// Needle: BOOOOOM                                      PRIMALposition=03 PRIMALlength=05  'OOOOM'
// Needle: aaaaaBOOOOOM                                 PRIMALposition=02 PRIMALlength=09  'aaaaBOOOO'
// Needle: BOOOOOMaaaaa                                 PRIMALposition=03 PRIMALlength=09  'OOOOMaaaa'
PRIMALlength=0;
for (i=0+(1); i < cbPattern-((4)-1)+(1)-(1); i++) { // -(1) because the last BB (Building-Block) order 4 has no counterpart(s)
	FoundAtPosition = cbPattern - ((4)-1) + 1;
	PRIMALpositionCANDIDATE=i;
	while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
		j = PRIMALpositionCANDIDATE + 1;
		while ( j <= (FoundAtPosition-1) ) {
			if ( *(uint32_t *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(uint32_t *)(pbPattern+j-(1)) ) FoundAtPosition = j;
			j++;
		}
		PRIMALpositionCANDIDATE++;
	}
	PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+1 +((4)-1);
	if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
	if (cbPattern-i+1 <= PRIMALlength) break;
	if (PRIMALlength > 128) break; // Bail Out for 129[+]
}
// Swampwalker_BAILOUT heuristic order 4 (Needle should be bigger than 4) ]

// Swampwalker_BAILOUT heuristic order 2 (Needle should be bigger than 2) [
// Needle: 1234567890qwertyuiopasdfghjklzxcv            PRIMALposition=01 PRIMALlength=33  '1234567890qwertyuiopasdfghjklzxcv'
// Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv            PRIMALposition=31 PRIMALlength=02  'vv'
// Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv            PRIMALposition=09 PRIMALlength=13  'vvBOOMSHAKALA'
// Needle: Trollland                                    PRIMALposition=05 PRIMALlength=05  'lland'
// Needle: Swampwalker                                  PRIMALposition=03 PRIMALlength=09  'ampwalker'
// Needle: licenselessness                              PRIMALposition=01 PRIMALlength=13  'licenselessne'
// Needle: alfalfa                                      PRIMALposition=04 PRIMALlength=04  'alfa'
// Needle: Sandokan                                     PRIMALposition=01 PRIMALlength=07  'Sandoka'
// Needle: shazamish                                    PRIMALposition=02 PRIMALlength=08  'hazamish'
// Needle: Simplicius Simplicissimus                    PRIMALposition=08 PRIMALlength=15  'ius Simplicissi'
// Needle: domilliaquadringenquattuorquinquagintillion  PRIMALposition=01 PRIMALlength=19  'domilliaquadringenq'
// Needle: DODO                                         PRIMALposition=02 PRIMALlength=03  'ODO'
// Needle: DODOD                                        PRIMALposition=03 PRIMALlength=03  'DOD'
// Needle: aaaDODO                                      PRIMALposition=02 PRIMALlength=05  'aaDOD'
// Needle: aaaDODOD                                     PRIMALposition=02 PRIMALlength=05  'aaDOD'
// Needle: DODOaaa                                      PRIMALposition=02 PRIMALlength=05  'ODOaa'
// Needle: DODODaaa                                     PRIMALposition=03 PRIMALlength=05  'DODaa'
/*
PRIMALlength=0;
for (i=0+(1); i < cbPattern-2+1+(1)-(1); i++) { // -(1) because the last BB order 2 has no counterpart(s)
    FoundAtPosition = cbPattern;
    PRIMALpositionCANDIDATE=i;
    while ( PRIMALpositionCANDIDATE <= (FoundAtPosition-1) ) {
        j = PRIMALpositionCANDIDATE + 1;
        while ( j <= (FoundAtPosition-1) ) {
            if ( *(unsigned short *)(pbPattern+PRIMALpositionCANDIDATE-(1)) == *(unsigned short *)(pbPattern+j-(1)) ) FoundAtPosition = j;
            j++;
        }
        PRIMALpositionCANDIDATE++;
    }
    PRIMALlengthCANDIDATE = (FoundAtPosition-1)-i+(2);
    if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=i; PRIMALlength = PRIMALlengthCANDIDATE;}
}
*/
// Swampwalker_BAILOUT heuristic order 2 (Needle should be bigger than 2) ]

/*
Legend:
'[]' points to BB forming left or right boundary;
'{}' points to BB being searched for;
'()' position of duplicate and new right boundary;

                       00000000011111111112222222222333
                       12345678901234567890123456789012
Example #1 for Needle: 1234567890qwertyuiopasdfghjklzxcv  NewNeedle = '1234567890qwertyuiopasdfghjklzxcv'
Example #2 for Needle: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv  NewNeedle = 'vv'
Example #3 for Needle: vvvvvvvvvvBOOMSHAKALAKAvvvvvvvvvv  NewNeedle = 'vvBOOMSHAKALA'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[12]34567890qwertyuiopasdfghjklzxc[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{12}]34567890qwertyuiopasdfghjklzxc[v?] ! Searching for '12', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
Step 01_02: [1{2]3}4567890qwertyuiopasdfghjklzxc[v?] ! Searching for '23', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
...
Step 01_30: [12]34567890qwertyuiopasdfghjkl{zx}c[v?] ! Searching for 'zx', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
Step 01_31: [12]34567890qwertyuiopasdfghjklz{xc}[v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}1[23]4567890qwertyuiopasdfghjklzxc[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: 1[{23}]4567890qwertyuiopasdfghjklzxc[v?] ! Searching for '23', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
Step 02_02: 1[2{3]4}567890qwertyuiopasdfghjklzxc[v?] ! Searching for '34', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
...
Step 02_29: 1[23]4567890qwertyuiopasdfghjkl{zx}c[v?] ! Searching for 'zx', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
Step 02_30: 1[23]4567890qwertyuiopasdfghjklz{xc}[v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}1234567890qwertyuiopasdfghjklz[xc][v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: 1234567890qwertyuiopasdfghjklz[{xc}][v?] ! Searching for 'xc', FoundAtPosition = 33, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=01 PRIMALlength=33, NewNeedle = '1234567890qwertyuiopasdfghjklzxcv'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[vv]vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{v(v}]v)vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 02, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(02-1)-01+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}v[vv]vvvvvvvvvvvvvvvvvvvvvvvvvvvvv[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: v[{v(v}]v)vvvvvvvvvvvvvvvvvvvvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 03, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(03-1)-02+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[vv][v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: vvvvvvvvvvvvvvvvvvvvvvvvvvvvvv[{v(v}]v)  ! Searching for 'vv', FoundAtPosition = 32, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(32-1)-31+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=31 PRIMALlength=02, NewNeedle = 'vv'


     PRIMALlength=00; FoundAtPosition=33; 
Step 01_00: {}[vv]vvvvvvvvBOOMSHAKALAKAvvvvvvvvv[v?] ! For position #01 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=01, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-01+(2)=33 !
Step 01_01: [{v(v}]v)vvvvvvvBOOMSHAKALAKAvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 02, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(02-1)-01+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
Step 02_00: {}v[vv]vvvvvvvBOOMSHAKALAKAvvvvvvvvv[v?] ! For position #02 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=02, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-02+(2)=32 !
Step 02_01: v[{v(v}]v)vvvvvvBOOMSHAKALAKAvvvvvvvvvv  ! Searching for 'vv', FoundAtPosition = 03, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(03-1)-02+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 09_00: {}vvvvvvvv[vv]BOOMSHAKALAKAvvvvvvvvv[v?] ! For position #09 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=09, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-09+(2)=25 !
Step 09_01: vvvvvvvv[{vv}]BOOMSHAKALAKA(vv)vvvvvvvv  ! Searching for 'vv', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_02: vvvvvvvv[v{v]B}OOMSHAKALAKA[vv]vvvvvvvv  ! Searching for 'vB', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_03: vvvvvvvv[vv]{BO}OMSHAKALAKA[vv]vvvvvvvv  ! Searching for 'BO', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_04: vvvvvvvv[vv]B{OO}MSHAKALAKA[vv]vvvvvvvv  ! Searching for 'OO', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_05: vvvvvvvv[vv]BO{OM}SHAKALAKA[vv]vvvvvvvv  ! Searching for 'OM', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_06: vvvvvvvv[vv]BOO{MS}HAKALAKA[vv]vvvvvvvv  ! Searching for 'MS', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_07: vvvvvvvv[vv]BOOM{SH}AKALAKA[vv]vvvvvvvv  ! Searching for 'SH', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_08: vvvvvvvv[vv]BOOMS{HA}KALAKA[vv]vvvvvvvv  ! Searching for 'HA', FoundAtPosition = 24, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(24-1)-09+(2)=16 ! 
Step 09_09: vvvvvvvv[vv]BOOMSH{AK}AL(AK)Avvvvvvvvvv  ! Searching for 'AK', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_10: vvvvvvvv[vv]BOOMSHA{KA}L[AK]Avvvvvvvvvv  ! Searching for 'KA', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_11: vvvvvvvv[vv]BOOMSHAK{AL}[AK]Avvvvvvvvvv  ! Searching for 'AL', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
Step 09_12: vvvvvvvv[vv]BOOMSHAKA{L[A}K]Avvvvvvvvvv  ! Searching for 'LA', FoundAtPosition = 21, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(21-1)-09+(2)=13 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
...
Step 31_00: {}vvvvvvvv[vv]BOOMSHAKALAKAvvvvvvvvv[v?] ! For position #31 the initial boundaries are PRIMALpositionCANDIDATE=LeftBoundary=31, RightBoundary=FoundAtPosition-1, the CANDIDATE PRIMAL string length is RightBoundary-LeftBoundary+(2)=(33-1)-31+(2)=03 !
Step 31_01: vvvvvvvvvvBOOMSHAKALAKAvvvvvvv[{v(v}]v)  ! Searching for 'vv', FoundAtPosition = 32, PRIMALlengthCANDIDATE=RightBoundary-LeftBoundary+(2)=(32-1)-31+(2)=02 ! 
     if (PRIMALlengthCANDIDATE >= PRIMALlength) {PRIMALposition=PRIMALpositionCANDIDATE; PRIMALlength = PRIMALlengthCANDIDATE;}
     Result:
     PRIMALposition=09 PRIMALlength=13, NewNeedle = 'vvBOOMSHAKALA'
*/

// Here we have 4 or bigger NewNeedle, apply order 2 for pbPattern[i+(PRIMALposition-1)] with length 'PRIMALlength' and compare the pbPattern[i] with length 'cbPattern':
PRIMALlengthCANDIDATE = cbPattern;
cbPattern = PRIMALlength;
pbPattern = pbPattern + (PRIMALposition-1);

// Revision 2 commented section [
/*
if (cbPattern-1 <= 255) {
// BMH Order 2 [
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]= cbPattern-1;} // cbPattern-(Order-1) for Horspool; 'memset' if not optimized
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=i; // Rightmost appearance/position is needed
			i=0;
			while (i <= cbTarget-cbPattern) { 
				Gulliver = bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]];
				if ( Gulliver != cbPattern-1 ) { // CASE #2: if equal means the pair (char order 2) is not found i.e. Gulliver remains intact, skip the whole pattern and fall back (Order-1) chars i.e. one char for Order 2
				if ( Gulliver == cbPattern-2 ) { // CASE #1: means the pair (char order 2) is found
					if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
						count = cbPattern-4+1; 
						while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
							count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
					}
					Gulliver = 1;
				} else
					Gulliver = cbPattern - Gulliver - 2; // CASE #3: the pair is found and not as suffix i.e. rightmost position
				}
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
// BMH Order 2 ]
} else {
			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);
}
*/
// Revision 2 commented section ]

		if ( cbPattern<=NeedleThreshold2vs4swampLITE ) { 

			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			// Above line is translated by Intel as:
//  0044c 41 b8 00 00 01 
//        00               mov r8d, 65536                         
//  00452 44 89 5c 24 20   mov DWORD PTR [32+rsp], r11d           
//  00457 44 89 54 24 60   mov DWORD PTR [96+rsp], r10d           
//  0045c e8 fc ff ff ff   call _intel_fast_memset                
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+cbPattern-1-1-2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;

	if (cbPattern != PRIMALlengthCANDIDATE) { // No need of same comparison when Needle and NewNeedle are equal!
// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
	} else { //if (cbPattern != PRIMALlengthCANDIDATE)
							if ( count <= 0 ) return(pbTarget+i);
	}
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

		} else { // if ( cbPattern<=NeedleThreshold2vs4swampLITE )

			// BMH pseudo-order 4, needle should be >=8+2:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			// In line below we "hash" 4bytes to 2bytes i.e. 16bit table, how to compute TOTAL number of BBs, 'cbPattern - Order + 1' is the number of BBs for text 'cbPattern' bytes long, for example, for cbPattern=11 'fastest fox' and Order=4 we have BBs = 11-4+1=8:
			//"fast"
			//"aste"
			//"stes"
			//"test"
			//"est "
			//"st f"
			//"t fo"
			//" fox"
			//for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( *(unsigned short *)(pbPattern+i+0) + *(unsigned short *)(pbPattern+i+2) ) & ( (1<<16)-1 )]=1;
			//for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( (*(uint32_t *)(pbPattern+i+0)>>16)+(*(uint32_t *)(pbPattern+i+0)&0xFFFF) ) & ( (1<<16)-1 )]=1;
			// Above line is replaced by next one with better hashing:
			for (i=0; i < cbPattern-4+1; i++) bm_Horspool_Order2[( (*(uint32_t *)(pbPattern+i+0)>>(16-1))+(*(uint32_t *)(pbPattern+i+0)&0xFFFF) ) & ( (1<<16)-1 )]=1;
			i=0;
			while (i <= cbTarget-cbPattern) {
				Gulliver = 1;
				//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]&0xFFFF) ) & ( (1<<16)-1 )] != 0 ) { // DWORD #1
				// Above line is replaced by next one with better hashing:
				if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2]&0xFFFF) ) & ( (1<<16)-1 )] != 0 ) { // DWORD #1
					//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = cbPattern-(2-1)-2-4; else {
					// Above line is replaced in order to strengthen the skip by checking the middle DWORD,if the two DWORDs are 'ab' and 'cd' i.e. [2x][2a][2b][2c][2d] then the middle DWORD is 'bc'.
					// The respective offsets (backwards) are: -10/-8/-6/-4 for 'xa'/'ab'/'bc'/'cd'.
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-4-2; else {
					// Above line is replaced by next one with better hashing:
					// When using (16-1) right shifting instead of 16 we will have two different pairs (if they are equal), the highest bit being lost do the job especialy for ASCII texts with no symbols in range 128-255.
					// Example for genomesque pair TT+TT being shifted by (16-1):
					// T            = 01010100
					// TT           = 01010100 01010100
					// TTTT         = 01010100 01010100 01010100 01010100
					// TTTT>>16     = 00000000 00000000 01010100 01010100
					// TTTT>>(16-1) = 00000000 00000000 10101000 10101000 <--- Due to the left shift by 1, the 8th bits of 1st and 2nd bytes are populated - usually they are 0 for English texts & 'ACGT' data.
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-4-2; else {
					// 'Maximus' uses branched 'if', again.
					if ( \
					( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6 +1]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6 +1]&0xFFFF) ) & ( (1<<16)-1 )] ) == 0 \
					|| ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4 +1]>>(16-1))+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4 +1]&0xFFFF) ) & ( (1<<16)-1 )] ) == 0 \
					) Gulliver = cbPattern-(2-1)-2-4-2 +1; else {
					// Above line is not optimized (several a SHR are used), we have 5 non-overlapping WORDs, or 3 overlapping WORDs, within 4 overlapping DWORDs so:
// [2x][2a][2b][2c][2d]
// DWORD #4
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]>>16) =     !SHR to be avoided! <--
// [2x] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) =                        |
//     DWORD #3                                                                       |
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16) =     !SHR to be avoided!   |<--
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) = ------------------------  |
//         DWORD #2                                                                      |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]>>16) =     !SHR to be avoided!      |<--
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) = ---------------------------  |
//             DWORD #1                                                                     |
// [2d] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]>>16) =                                 |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) = ------------------------------
//
// So in order to remove 3 SHR instructions the equal extractions are:
// DWORD #4
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) =  !SHR to be avoided! <--
// [2x] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) =                        |
//     DWORD #3                                                                       |
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) =  !SHR to be avoided!   |<--
// [2a] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) = ------------------------  |
//         DWORD #2                                                                      |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) =  !SHR to be avoided!      |<--
// [2b] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) = ---------------------------  |
//             DWORD #1                                                                     |
// [2d] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]>>16) =                                 |
// [2c] (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF) = ------------------------------
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-6]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-0]&0xFFFF)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-2]&0xFFFF) ) & ( (1<<16)-1 )] ) < 3 ) Gulliver = cbPattern-(2-1)-2-6; else {
// Since the above Decumanus mumbo-jumbo (3 overlapping lookups vs 2 non-overlapping lookups) is not fast enough we go DuoDecumanus or 3x4:
// [2y][2x][2a][2b][2c][2d]
// DWORD #3
//         DWORD #2
//                 DWORD #1
					//if ( ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-4]&0xFFFF) ) & ( (1<<16)-1 )] ) + ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-8]>>16)+(*(uint32_t *)&pbTarget[i+cbPattern-1-1-2-8]&0xFFFF) ) & ( (1<<16)-1 )] ) < 2 ) Gulliver = cbPattern-(2-1)-2-8; else {
						if ( *(uint32_t *)&pbTarget[i] == ulHashPattern) {
							// Order 4 [
						// Let's try something "outrageous" like comparing with[out] overlap BBs 4bytes long instead of 1 byte back-to-back:
						// Inhere we are using order 4, 'cbPattern - Order + 1' is the number of BBs for text 'cbPattern' bytes long, for example, for cbPattern=11 'fastest fox' and Order=4 we have BBs = 11-4+1=8:
						//0:"fast" if the comparison failed here, 'count' is 1; 'Gulliver' is cbPattern-(4-1)-7
						//1:"aste" if the comparison failed here, 'count' is 2; 'Gulliver' is cbPattern-(4-1)-6
						//2:"stes" if the comparison failed here, 'count' is 3; 'Gulliver' is cbPattern-(4-1)-5
						//3:"test" if the comparison failed here, 'count' is 4; 'Gulliver' is cbPattern-(4-1)-4
						//4:"est " if the comparison failed here, 'count' is 5; 'Gulliver' is cbPattern-(4-1)-3
						//5:"st f" if the comparison failed here, 'count' is 6; 'Gulliver' is cbPattern-(4-1)-2
						//6:"t fo" if the comparison failed here, 'count' is 7; 'Gulliver' is cbPattern-(4-1)-1
						//7:" fox" if the comparison failed here, 'count' is 8; 'Gulliver' is cbPattern-(4-1)
							count = cbPattern-4+1; 
							// Below comparison is UNIdirectional:
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i]+(count-1)) )
								count = count-4;

	if (cbPattern != PRIMALlengthCANDIDATE) { // No need of same comparison when Needle and NewNeedle are equal!
// count = cbPattern-4+1 = 23-4+1 = 20
// boomshakalakaZZZZZZ[ZZZZ] 20
// boomshakalakaZZ[ZZZZ]ZZZZ 20-4
// boomshakala[kaZZ]ZZZZZZZZ 20-8 = 12
// boomsha[kala]kaZZZZZZZZZZ 20-12 = 8
// boo[msha]kalakaZZZZZZZZZZ 20-16 = 4

// If we miss to hit then no need to compare the original: Needle
if ( count <= 0 ) {
// I have to add out-of-range checks...
// i-(PRIMALposition-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4

// "FIX" from 2014-Apr-27:
// Because (count-1) is negative, above fours are reduced to next twos:
// i-(PRIMALposition-1)+(count-1) >= 0
// &pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4
	// The line below is BUGGY:
	//if ( (i-(PRIMALposition-1) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) && (&pbTarget[i-(PRIMALposition-1)+(count-1)] <= pbTargetMax - 4) ) {
	// The line below is NOT OKAY, in fact so stupid, grrr, not a blunder, not carelessness, but overconfidence in writing "on the fly":
	//if ( ((signed int)(i-(PRIMALposition-1)+(count-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)] <= pbTargetMax - 4) ) {
// FIX from 2016-Aug-10 (two times failed to do simple boundary checks, pfu):
	if ( ((signed long long)(i-(PRIMALposition-1)) >= 0) && (&pbTarget[i-(PRIMALposition-1)]+((PRIMALlengthCANDIDATE-4+1)-1) <= pbTargetMax - 4) ) { // 2020-jan-11
		if ( *(uint32_t *)&pbTarget[i-(PRIMALposition-1)] == *(uint32_t *)(pbPattern-(PRIMALposition-1))) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
			count = PRIMALlengthCANDIDATE-4+1; 
			while ( count > 0 && *(uint32_t *)(pbPattern-(PRIMALposition-1)+count-1) == *(uint32_t *)(&pbTarget[i-(PRIMALposition-1)]+(count-1)) )
				count = count-4;
			if ( count <= 0 ) return(pbTarget+i-(PRIMALposition-1));	
		}
	}
}
	} else { //if (cbPattern != PRIMALlengthCANDIDATE)
							if ( count <= 0 ) return(pbTarget+i);
	}

							// In order to avoid only-left or only-right WCS the memcmp should be done as left-to-right and right-to-left AT THE SAME TIME.
							// Below comparison is BIdirectional. It pays off when needle is 8+++ long:
//							for (count = cbPattern-4+1; count > 0; count = count-4) {
//								if ( *(uint32_t *)(pbPattern+count-1) != *(uint32_t *)(&pbTarget[i]+(count-1)) ) {break;};
//								if ( *(uint32_t *)(pbPattern+(cbPattern-4+1)-count) != *(uint32_t *)(&pbTarget[i]+(cbPattern-4+1)-count) ) {count = (cbPattern-4+1)-count +(1); break;} // +(1) because two lookups are implemented as one, also no danger of 'count' being 0 because of the fast check outwith the 'while': if ( *(uint32_t *)&pbTarget[i] == ulHashPattern)
//							}
//							if ( count <= 0 ) return(pbTarget+i);
								// Checking the order 2 pairs in mismatched DWORD, all the 3:
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1]] == 0 ) Gulliver = count; // 1 or bigger, as it should
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1]] == 0 ) Gulliver = count+1; // 1 or bigger, as it should
								//if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1+1]] == 0 ) Gulliver = count+1+1; // 1 or bigger, as it should
							//	if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1]] + bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1]] + bm_Horspool_Order2[*(unsigned short *)&pbTarget[i+count-1+1+1]] < 3 ) Gulliver = count; // 1 or bigger, as it should, THE MIN(count,count+1,count+1+1)
								// Above compound 'if' guarantees not that Gulliver > 1, an example:
								// Needle:    fastest tax
								// Window: ...fastast tax...
								// After matching ' tax' vs ' tax' and 'fast' vs 'fast' the mismathced DWORD is 'test' vs 'tast':
								// 'tast' when factorized down to order 2 yields: 'ta','as','st' - all the three when summed give 1+1+1=3 i.e. Gulliver remains 1.
								// Roughly speaking, this attempt maybe has its place in worst-case scenarios but not in English text and even not in ACGT data, that's why I commented it in original 'Shockeroo'.
								//if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+count-1]>>16)+(*(uint32_t *)&pbTarget[i+count-1]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = count; // 1 or bigger, as it should
								// Above line is replaced by next one with better hashing:
//								if ( bm_Horspool_Order2[( (*(uint32_t *)&pbTarget[i+count-1]>>(16-1))+(*(uint32_t *)&pbTarget[i+count-1]&0xFFFF) ) & ( (1<<16)-1 )] == 0 ) Gulliver = count; // 1 or bigger, as it should
							// Order 4 ]
						}
					}
				} else Gulliver = cbPattern-(2-1)-2; // -2 because we check the 4 rightmost bytes not 2.
				i = i + Gulliver;
				//GlobalI++; // Comment it, it is only for stats.
			}
			return(NULL);

		} // if ( cbPattern<=NeedleThreshold2vs4swampLITE )
		} // if ( cbPattern<=NeedleThreshold2vs4swampLITE )
	} //if ( cbPattern<4 )
}
/*
// For short needles, and mainly haystacks, 'Doublet' is quite effective. Consider it or 'Quadruplet'.
// Fixed version from 2012-Feb-27.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	uint32_t ulHashTarget, count, countSTATIC;

	if (cbPattern > cbTarget) return(NULL);

	countSTATIC = cbPattern-2;

	pbTarget = pbTarget+cbPattern;
	ulHashPattern = (*(uint16_t *)(pbPattern));

	for ( ;; ) {
		if ( ulHashPattern == (*(uint16_t *)(pbTarget-cbPattern)) ) {
			count = countSTATIC;
			while ( count && *(char *)(pbPattern+2+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+2+(countSTATIC-count)) ) {
				count--;
			}
			if ( count == 0 ) return((pbTarget-cbPattern));
		}
		pbTarget++;
		if (pbTarget > pbTargetMax) return(NULL);
	}
}
*/

// Fixed version from 2012-Feb-27.
// Caution: For better speed the case 'if (cbPattern==1)' was removed, so Pattern must be longer than 1 char.
char * Railgun_Doublet (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
{
	char * pbTargetMax = pbTarget + cbTarget;
	register uint32_t ulHashPattern;
	uint32_t ulHashTarget, count, countSTATIC;

	if (cbPattern > cbTarget) return(NULL);

	countSTATIC = cbPattern-2;

	pbTarget = pbTarget+cbPattern;
	ulHashPattern = (*(uint16_t *)(pbPattern));

	for ( ;; ) {
		if ( ulHashPattern == (*(uint16_t *)(pbTarget-cbPattern)) ) {
			count = countSTATIC;
			while ( count && *(char *)(pbPattern+2+(countSTATIC-count)) == *(char *)(pbTarget-cbPattern+2+(countSTATIC-count)) ) {
				count--;
			}
			if ( count == 0 ) return((pbTarget-cbPattern));
		}
		pbTarget++;
		if (pbTarget > pbTargetMax) return(NULL);
	}
}

// Pattern must be >=4
char * Railgun_BawBaw_reverse (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
{
	register uint32_t ulHashPattern;
	signed long count;

	unsigned char bm_Horspool_Order2[256*256]; // Bitwise soon...
	uint32_t i, Gulliver;

	if (cbPattern > cbTarget) return(NULL);

			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=cbTarget;
			while (i >= cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i-cbPattern]] != 0 ) {
					if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i-cbPattern+2]] == 0 ) Gulliver = cbPattern-(2-1)-2; else {
						if ( *(uint32_t *)&pbTarget[i-cbPattern] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-4+1; 
							while ( count > 0 && *(uint32_t *)(pbPattern+count-1) == *(uint32_t *)(&pbTarget[i-cbPattern]+(count-1)) )
								count = count-4;
							if ( count <= 0 ) return(pbTarget+i-cbPattern);
						}
					}
				} else Gulliver = cbPattern-(2-1);
				i = i - Gulliver;
			}
			return(NULL);
}

// Pattern must be >=2
char * Railgun_Baw_reverse (char * pbTarget, char * pbPattern, uint32_t cbTarget, uint32_t cbPattern)
{
	register uint16_t ulHashPattern;
	signed long count;

	unsigned char bm_Horspool_Order2[256*256]; // Bitwise soon...
	uint32_t i, Gulliver;

	if (cbPattern > cbTarget) return(NULL);

			// BMH order 2, needle should be >=4:
			ulHashPattern = *(uint32_t *)(pbPattern); // First four bytes
			for (i=0; i < 256*256; i++) {bm_Horspool_Order2[i]=0;}
			for (i=0; i < cbPattern-1; i++) bm_Horspool_Order2[*(unsigned short *)(pbPattern+i)]=1;
			i=cbTarget;
			while (i >= cbPattern) {
				Gulliver = 1; // 'Gulliver' is the skip
				if ( bm_Horspool_Order2[*(unsigned short *)&pbTarget[i-cbPattern]] != 0 ) {
						if ( *(uint16_t *)&pbTarget[i-cbPattern] == ulHashPattern) { // This fast check ensures not missing a match (for remainder) when going under 0 in loop below:
							count = cbPattern-2+1; 
							while ( count > 0 && *(uint16_t *)(pbPattern+count-1) == *(uint16_t *)(&pbTarget[i-cbPattern]+(count-1)) )
								count = count-2;
							if ( count <= 0 ) return(pbTarget+i-cbPattern);
						}
				} else Gulliver = cbPattern-(2-1);
				i = i - Gulliver;
			}
			return(NULL);
}

// To Tomisaburo Wakayama:
/*
                                                                                                                                                                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                                                                                                                                                                
                                                                                                  UjM                                                                                                                                                                                                                                                                                                           
                                                                                                 Z8MN;                                                                                                                                                                                                                                                                                                          
                                                             :YMTUXUXXrrvv,                     AOmvMv                                                                                                                                                                                                                                                                                                          
                                                           vb6GtHX4AwThMNhXhTV;.               .ttrvr;                                                                                                                                                                                                                                                                                                          
                                                          hOC0jkyVvvvvvYVyLALMrhrV;            vUcyYV;                                                                                                            .Al                                                                                                                                                                                           
                                                         rBejUrvvvvvvvvvvvYvVVyLrLwAL;         vLUMvMv                                                                                                           ;BDj:                      ;vlllvv:                                                                                                                                                            
                                                        .pBcllvvvvvvvvvvvvvvvvvllyVAyAry;    .mVvwhYry                                                                                                          ,GDrv;                ;YXtpCpjmmUUXUhr                                                                                                                                                          
                                                        yZjvvvvvv;v;vvvvvvvvvvvvvvvlYVyyrVv. vkvvvhyyy:                                                                                                         j0v:v:           ,lMmp0bbcHhyvvvvvvvlhH.                                                                                                                                                        
                                                        HqrvvvvvvvvvvvvvvvvvvvvvvvvvvYYVYyyyvvvv;vlwLrv                                                                                                        XZHvvl.        vwHj2CjtUrYvvvvv;vvvvvvvlA                                                                                                                                                        
                                                       .cHVvvvvvvvvvv;v;v;v;vvvvvvvvvvvvYvyVYvv;vvvlwLV;                                                                                                      U#bYvlv     ,vkm2C2tmhVvvvvvvvvvvvv;vvv;;lv                                                                                                                                                       
                                                       ;khvvvvvvvv;v;;,:,:,:;v;vvvvvvvvvvvvYYVYVvv;;vTyy,                                                                                                    mCZLvv:   :VUHjp@CcAyvvvvvvvvvvvvvvvv;vvv;vv.                                                                                                                                                      
                                                       vtrvvv;vvv;;;:;r4mH4yv::,;;vvvvvvvvvvvvyVyvv;;vVYV.                                                                                                 .kj9Tv;;  vhhHtZZpMl;v;v;vvvvvvvvvvvvvvvvvvvvv;                                                                                                                                                      
                                                       VcAvvvvvv;v;:UG99DODODZkv:,;vvvvvvvvvvvvvYyllvv;llY:                                                                                               vtmGX;;;vAAXcDZ0Uy;v;v;v;v;v;v;;;v;v;vvvvvvvvvvv                                                                                                                                                      
                                                       lhVvvvvvvv;,U6qCtpt2200DO0hv,;;vvvvvvvvvvvvVYVvv;vlV;                                                                                             McHZr:;vYANCZOcrv;;vvv;vvv;v;;,,,:,:;vvvvvvvvvvv;                                                                                                                                                      
                                                       y4y;vvvvv;:vOq2j2tpjbjb20@OZHv;;vvlvvvvvvvvvvlyYv;vYlv,                                                                                         vHHcCV;vYrm#9CUv;;v;vvvvvvv;;.:;lUtttA;:vvvvvvvvvvv                                                                                                                                                      
                                                       ymyv;vvv;v,wObjpctj2tpjptpjC@mv;;vvvvvvvvvvvvvvVYvvvvVlv                                                                                      :UHXHplvYwcGGcyv;v;vvv;vvv;v;;;NtZZO#DDe@l:vvvvvvvvvv                                                                                                                                                      
                                                       y4yvvvvvv;:tDjjc2tpt2jjctmjHHwlvv;;;vvvvvvvvvvvvvlVvvvllv:                                                                                  ;hcXNHmlvMbODUv;;;v;v;vvvvv;;;lH##qp0p2p@0gp;;vvvvvvvvv                                                                                                                                                      
                                                       vkyvvvvv;;;@btcctjjbpbttHmHcMlvVYl;;;vvvvlvvvvvvvvvVlvvlvlv;                                                                             .vUkkw4HklMCBOw;;;vvvvv;v;v;;vNkLvvrmmtcjjC20#Ov;vvvvvvvv;                                                                                                                                                      
                                                       vhVvvvv;v;vCCcjctcjtpjpmHmcmkvvvvvYvv;;;vvlvlvvvvvvvVlYvlYvvv:        ,,;;;;vvvvvvvvlvvvvvlvvvvvvvvvv;v;;;;::,,..                     ,vNkUNhMhNhr0BDMv;v;vvv;vvvv;vkkpHAv, vrkmjjpjCp#9N,vvvvvvvv;                                                                                                                                                      
                                                       :4yvvvvvv;;bCpmjcpc2tpccmcHccU;vvvvvvlvv;;;vvlvvvvvvvvvrvlvlvv;v;v;vvlvYlyYyyyVryLyrrLyrLyyrVyVyyryyVVllvllvvlvvvlvVvvvvvv;;,....,;vrUUkXNTTArLhj92T;;;vvvvv;v;v;vvk0cYvv; ;Vwhmcjtpb0#ek;;vvvvvvv:                                                                                                                                                      
                                                       ,hyvvvv;v:v0qmptjctjpjjctmtttp4vvvvvvvvvYvv;vvvvvvvvvvvvyVlvYvv;vlVVrVLVryLLrLrLAyryrLArAyrrTAMrMrArMrryMrAyrrrrArTrAyrVyVVVLLrrwTNhUThAMrAVyXZg2V;;vvv;v;;;;;vvAUj4Y;vvv.,vMhmmjtjjCq#9c,vvvvvvvv:                                                                                                                                                      
                                                        wyvvvvv;;;#CccjttcCjpttmmkHUktUvvvvvvvvvvvlvvvvvlvYvlvvvlYylvvvvVVVvVllVyYyVyYylyVylllyYyVyVVYVYYYYYyVyyryryryALrrAyArTrMrrAMLMyLrMrrrAyryHD8qr;;vv;v;;;vlrLNXUhAvvvvvv,.vrwkHcctt2jCC6k:;vvvvvvv.                                                                                                                                                      
                                                        yMvvvvvv;;j#tptpcjjptptckwLy:;lVvlvvvvvvvvvvvVvYlVvvvvvvvvvVlvvYvlvlvlvVlYvYvVvVvlvlvlllvlvlvvvlvvvlvYvlvlvVvllylYYylllylyYVvYvVlyLyyrLrwDeDr;;vvv;;vvLArArrVlvvvvvvvv:.;rNHkccttCp2t#9H:vvvvvvvv                                                                                                                                                       
                                                yAvvv:  vrl;vvv;;:t@pcjtjjpjpccHHwNYv;;,;vvvvvvvvvvvvvvvlvVvVvVVvvvvVlYvlvlvllylVlyllvVlYvYlYvYvYvlvlvlvVVyvlvlvlvvvvvlvlvlvlvvvvvVlYvYlyVyyrrUt9qy;;;vvv;VrrVyvvvvvvvvvvvvvv;;vTUcctcjjjcCppZGr:vvvvvvvv                                                                                                                                                       
                                               :B0vvvvv;vyvvvvvv;:UOjjtjtCjpctHmHHVvvYlv:;vv;vvvvlvvvvvvvvvvlhkHrAyLrwyrVylVYylVlVlYYVllvVlVlYlVllvlvlvyLryylvvlvlvvvlvvvlvvvYvlvllVlllVYVVryhkpXv;vvvvvvlVlvvvvvvvvvvvvvv;v.;vvvllYyUHccjp0C9Dv:vvvvvvv:                                                                                                                                                       
                                                  ;vv;;;vlYvvvvvv,wO2ttt2p2t2ctHHmUvvlYVyvVyyvvvlvvvvvvvvvlvYUZjpmHUNMryLVyyyVylyYVlyYyVYYVlllllVvVllvAVYvlvlvvvYYlvlvlvlvYvllYvlvYvlvVlYYyyrrNrVvlvvvvvvvvvvvvvvvvvvvvvvvvvvllvyv; ;TmHjcC2@OC;;vvvvvv;.                                                                                                                                                       
                                                    ;LVv;lYlvvvv;;vZ2jjttCtpjjmcHcmXvvVVYyVrryvlvlvlvVvyyMwXwUHHXhrryLyyVyVyyyVVVyVyVyVylyVyYyYyVylYvAyVYVvlvvlvvvvYvVvlvYvYvllYlYvYlVlVvylyVryyVryylVllvvvvvvvvvvvvvvvvvllVllvv;: ;YNHct2CCC6U:vvvvvv;;  :vAk:                                                                                                                                                 
                                                     ;qh;vVlvvv;v;;cZjjtpppjttjmcmmmkv;;VylvlvYlyVVyMrNwU4hrALryryyYyVryyyryrVyVyVVlylyYyYyYylVYVYllMyyVyVVVVvlllvvvYvlvllYvlvYvYvllVlVvYVVYyYyVylVvVVyLyyVvlvvvvvvvvvvvvvv;v;;.,:YM4UmmpjCbOGV:vvvvvv;:,:;Vw.                                                                                                                                                  
                                                      vCv;vyvvvvvv,rOqtptbjjjpcjccctcbmrvLyNMryAM4XHkU4hrAyrLrLArAyyVLyLyLVLVyVyVyVyVyVyVylyYylVYlvAryVyyyyyVVlVvlvvvYllvllVlYlYlVlYvYlYVVYVlYlVllvYvvvVlyVLYyllvvvvvvvv;;;;,,.;vM4kkcctmpjC9Z;;vvvvvv;,.;vY                                                                                                                                                    
                                                       vw;vYYvvvvv;;j0pcjjptbjCjptb29B8BcvvMHHmmjjttmwMrryrrArTLryLyyyyyryLyryyVyyrVyYyVyVyyyVyVYVAyyVyyLyrVyVVYVvllvvvvylYvVlYlyVyvYlVlYlVvVvYvYvlvvvvvlvlvVyyYyllvvvvvv;::;vrwkHcktcjjjjC@eM:;vvvvv;;.,vV                                                                                                                                                     
                                                        YyvYYlvvvv;:VObccjj2jbp2pOB8BGtwryvvvllyTHwhyyLLyArALMLLyLVLyLyryLyLyLVyVyyyyLyyyyYyVyYVYAyyyrVryLyyVyYyYylVvvvvlVYllVvVvyYyYyvVlVlVlYvVvYvlvlvvvvvvvlvllVYyYlvv:vrcHmHmHmmtjbpbtbCGq;;vvvvvv;..;r                                                                                                                                                      
                                                         ylvyYvvvvv;;jZt2t2tbj0Z8B8@UyyyArrVyVrLryyyrrAyrLryrLryryyyyyLVLyryyyryrLryryyyyVyVLyVVryLyryryyyryryrVyVylVlvvvlylyVyVVYllyVVlVlVlYvVvllYvlvvvlvvvvvvvvvvYV;;;;;r0eO0tttjj2jC2CbZGU;vvvvvvv:.:y                                                                                                                                                       
                                                         .LlYyvvvvvv:l#@pjp0COB8g24UThAMAArwMMAhrArryryTyrrMyryLyryLyyyyyLyryyyryVlyVyyrVyVyyyVAyyyryyyryyYVvlvVyyYVYVlYvvlylVVyYyYllVYYlYvYvVlVvlvlllvlvlvvvvvvvvvvvvvvvv;vrCG6qbpCbqCqCq9#;;vvvvvv;,,l.                                                                                                                                                       
                                                          ;UylVvvvvv;,XOCj0ZBe9jNMMrrAwAhrMrAAMAArMrAyryAyryryyyryyyLVyyryLyryLVYvvvvYyyryyyyyryryryyyyyAlyVVvlvlYLVyYVlVvvvVYVvVyVvlvlvVlVlYvVvYYlvlvlvvvlvvvvvvvvvvvvvvvv;::VbB6Dq#C0C@Z6A;;vvvvv;;,v,                                                                                                                                                        
                                                           vyVYvvvvvv;;20CGBZtXTVyyl:vVTATrArTrALTrwrrrALLrryyyyyryryryyVLyryryLyylvvvyyVrVyVALrLLVryLyrVyVyyyYVvvvyVyYyYVvvvYlvvryylVvvvVlyvlvVvlvYvvvlvvvvvvvvvvvvvvvvvvvvv;,:l09Obbp0@et;;vvvvv;;,;.                                                                                                                                                         
                                                            yVyVvvvvv;:;68GjUryVrrTv;;yAwrhAMrTrArAAAyrrryLyLyyVryryryryryrrLVryryrlvvYVyyyVLyryrLAyyrrVLyyVlVyyVvvvyyyVyyyvvvVvvrLyryyvv;llVlVllvYvlvlvlvYvvvvvvvvvvvvvvvvvv;vv:,rCD2bbDOV:vvvvvvv;;,                                                                                                                                                          
                                                            .rVrlvvv;v;;pGHMYyyArwTv;vywTwAwTTAMMwrArrLArAyryryryrLLyAyryLyAyryryLyLylvYVyVArArArALyyryrrAyYAylryyvvvyyLVyyyvvvvvAryyryLVvvvvVlYlllYlYvlvvvlvvvlvvvvvvvvvvvvvvrwyv,vUZCCDN:v;vvvvv;:,                                                                                                                                                           
                                                             vyVyvvv;vyHqkyYLrALAThv;vrrhAAAhrlYTAMrTyryrrrLLyrVryryryyyrrALyLryAyryrLVvvlrArrALrLyyrrMAMyvM8XvYyyLvvvVVyVLyyVv;vMAVLyyyyYVvvvVvVllvlllvlvvvvvvvvvvvlvvvvvvvv;vyXLv:;ljOc:;vv;v;v;;,                                                                                                                                                            
                                                              VyMy;vvNjqUVYArArAAhAv;YrMrArMyyvvlTAMrMrMLALryryrrAyAyryrrArrrryryryryrrY;vATrArAyLyrATAMrr;bB#;LyryyvvvyVrVyVrVv;UrLyyVyyyYYvv;vlVvYvlllllvlvlvvvvvvvvvvvvvvvv;VM4vv;:vUv:;vvvvvv;:                                                                                                                                                             
                                                              ;yVlYAH2CMlyAAALArMTTv;lrAwAALMyV;vlrrTwwM4AArMrArryLyrAArArMAMrAAMrrrryrLlVwAArArrrNwwrTrTy;B8B;YLyryrvvvVVyVyVLVyyrYyVyyLVLVVvvvvvVllvVvVvlvlvlvvvvvvvvvvvvvvvvvTAAvv;;;l;;;vvv;v;                                                                                                                                                              
                                                               VvycGZcLVVMATrAAArMTV;vrhhTVALryylvvVlyywMhTwhwyrrMAArMLrrTAXTwAhwwAArryAAwAwLArAyhhwrwAMrVv8B8vvLLyryAvvvVVyVyyryryyyyVrVyVyYYvv;vlyllvYvYvlvlvlvlvvvvvlvvvvvvv;VrMv;vv;vv;;;v;;;.                                                                                                                                                              
                                                               :yrCqHyYyTrwATMTrAAXAvvyM4LrAhhXThArVYvvvllyrkUUNNMTAMrLr4wNwMAwrMAwMMrryArMrTrrLhhUMwMAAAvAB8BU;ryyVryLvvvVVyyLyLyrYyVLvvvLVVYYYlvvvlvVvlvlvlvlvlvYvvvvvvvvvvvv;yAwvv;vvvvl;;;;;;                                                                                                                                                               
                                                                yAAAVyrMryvvvwMwrArTVvvMAAXkUtjjtCc2mmMrVYvvvyAh4XAUMrMUX4wXrLVlvlrwrAAArMAAArLNNhwhTTrTrvc8B89;yALyyryrvvvVyyVLyyYVYMArvvvYVyVyVVvvvyVVvYvlvVvYvlvlvvvvvvvvvvvvvYLVvvvvvvvlv;;;                                                                                                                                                                
                                                                AVyyLyALyyyv;vrwhrMrhyvvrrHc22CCqb@ZDOO@#tcTAvvvAXUNwUpkUwXAAATArvvLwrAAwrAyryN4UwTMwAwArvBB8B8;VyAyLyLyyvvvyyryLYYvLNTrrlvvvYVYyYVvvvYlYlVvYvlvvvvvvvlvvvlvvvv;;vyYvvvvvvvvv;;,                                                                                                                                                                
                                                               .AArAyrrryAArv;vLTTMwTHM;;wcbjhvyrhHjcb0Z#ZD@Ct4MllYyyjcUThA4hwAhhy;lATrTrArrLUU4AwrAAwrAYvB888BlvryryyyyyrvvvLyrVyvvAkLrLLvvvvvyVyVyYvvllVvlvYvvvlvlvvvlvvvvvlv;:vllvvvvvvvv;;:                                                                                                                                                                 
                                                               ;hrrLArMVrrMrrv;;VAkXkkph;VbCmvLryvvvyAkmpjqC#b@0chyvmpHXwMUcUMhANMl;yAArMyAyhNXThAhMwAMrYY8B888yvrryryryyyyvvlryyVvvXXrLryLvv;vvyVyVyYvvvllvlvvvVvlvvvvvv;vvvv;,;vvvvvvvv;;;v;.                                                                                                                                                                 
                                                               LMAVrLALyyrrTrAv;;vMtcct0mkmjkyHjjjcmLvvvLNkppCjCttmcpckkAhjcMTMwwNTvvLLrLryhhNwhMMATMAAAvhB8B8Bj;yyryyyyVrLVvvYrVVvykhyyVLyyvvvvvyVyVLVv;vvlvYlvvvvlvVllvvvv;v;vvvvv;v;v;;;vv;                                                                                                                                                                  
                                                              ,wMyyyyrAYLrTAwArvv;vym20jCbccpr4pjmC@Z@cAvvvrmcjjjcjttHHwAHZkNTwAMAhrvvyyyyMXNAwATAArMATLvC8B8B8O;VryryyyLVyylvvlyvvhUyyyryyVVvvvvlVYylyllvyYVYVyyyrrryrYyVlvvvvvv;;;v;;;;;;;vv                                                                                                                                                                  
                                                              Y4yyVyywAlyrLAM4NXyv;;vU2Z2tmpbHyCbcccHp2D04v;;YhccbtmcHUNhq2mUXwMAMANYvvVVhhwMTAMrwMMrMrr;e88B8B8;Vyyyryryyyryl;llvymrryrVyVyVYvvvYYyYyYyYylVrArMTUrrVvvlvvvvll;v;;;;;;:;lV;;;l:                                                                                                                                                                 
                                                              ULyyyyrAkyVVrrMwkkH4Y;;:YmZ#CjpcLT9DbcttbjqqZmLvvvMmttjkmAcCjkmUhrTrTAwv;vyHUMMAwAMAArAVV;.e8B8B8B,;vlyyLyLyryLyv;;vmXrVryLyrVyyl;vvVlVvylyyLMNhhXhllvlvlvv;vvyvv;v;;;;;;lyvv;;vv                                                                                                                                                                 
                                                         .Tv ;hLYyVrLTkAvyyATNTmktH4v;,:vUcC2qcVw0O9kryAMmj#@pwlvvLHtc4TmCcHHkAwrwrwwy;;AcMTrAATLryl;;vrh8B8B8B8kLv;,vvyVyyryAy;:rkrVLyyyyVylyYv;vvYlylVyrhmHNVlvvvlvvvv;;;vvvvv;;;v;;vrvv;;;;v,                                                                                                                                                                
                                                         pklVyrVyVyyLMkylVrLNhw4mHjjtkAv;.;vwHCHrAC9UvTrv:;yHp#tkyvvrXUAjttkHXUAwTTrNAv;HNMATAALLv;V#B8B8B8B8B8B8B8BeX;:vlyyLyAYvwwyyVyVyVyVVVyYv;vlylyVMUkryvvvlvvvVllvv;;;vvv;;;v;;vLVv;;:;;v;                                                                                                                                                                
                                                        yZyvvrVVVVyryMwMlyyLrhNHctjtmpjtcUv;,;vTXMwjtVc8Ocv:;vTc2bHrv;vrcjmmXUhwMwrArhyTUArTrArY;wB8B8B888B8B8B8B8B8B8BeY:vVyrVLrwVLlyyryyVVYVVrvv;vlVrhwrvvvYlyrNhTrMvlv;,vYvvv;;;;vyyv;v;:;;;v..                                                                                                                                                              
                                                        c2V;vVylyYyYyTwrVlVVyMkUct2c2cpC0CCchl;:vvvyUTAD88eHv:;v4mbpHVvYjcmUUNhAwATATrhMArArTrv;eB8B8B888B8B888B88888B888ev;lVyVyyyYyyryVVyYVVyyrv;vyrMlvvvlyrUUHNXNhAyv;,vVyvv;;,;vyVv;;;;,;;;;;;v                                                                                                                                                             
                                                        cbVvvyVVYyrLywrAYvVyVwXHm2tCqC0DpC2bcpckVv;;;v;wgBeBOmv;:vAct2kkccUH4XhhTXMhMMrArALrrv;8B88888B8B8ZpmccZB8B8B8B8B8Bc:lVryLVyyyVyVLVyVyyyrY;vvv;vvyLhmtkhvvvrMyv;,;VAvv::,vVyvv;;;;;:;;;;:,;l                                                                                                                                                            
                                                        tHyvvYyYyyLyryyLAvvYLLNktcjjqqOCDqO9#cHt0jUlv;;;jg9G6g@rv;;vNmjmkUUN4ANhAvvVhTTrArArvv8B888B8B8r;,;;;;::;;rB8B8B8B8Bc:YVyVyVVVVYlYyvVYLVwr;:;;YLNXHkwvvvvvv;vv;,;ly;:,;vyyY;;;;;;;;,;;;;;.:v;                                                                                                                                                           
                                                       ,UHVvvyVyVyVyVylrrAvvvLAkkHHpb00ZGG9eD9#jt0CjXy;;;qGOZZD#kLv;;VUjmmUkhAUjXv;vMwyyyAVl;8B8B888BV.;vv,:;;,;;v;:w888B8B8Bl;yVyVYYchYvvvVlyvyywv;YAhk4wlv;vvlvlv;,;;;:;,:;lYylv;;;;;;;;,:;;:;;.,v;                                                                                                                                                           
                                                       .NmAvlYyYyVyyyyVLrrkrv;lAwUccCZZCOOZ@9O6G9OO0qtNv,;O6DbCCZtwl;:;ycmcmU4OCwvvvrTyVrVy:jB8B8B8Bv,lv;v088B8j;;lv:V8B88888t:lyVVvNpkVlvvvVlllVLTrXhhyv;vvVvyMAyY:,,,,;;vYylvvv;;;;;;;;:,,;;;;;.,vv                                                                                                                                                           
                                                       ,rcAyvVlyYyYyLyVAVA4cmA;vlhkcct0O@Z@ZOOOD@#qDOO#0T;vCbC2CbZCcyv:;vUccAjbtAYv;YhVyVyv;B8B8B8BX.Yl;A8B8B8B88L;Vv,k888B888:vYyYvXtUyVVv;vVyVVLrwrY;;vVyyVmmMYv;..,;vYAVyvvvv;;;;;;:::;.:;;:;:::v;                                                                                                                                                           
                                                        yXUVYvYlVVyVVVAVyAUktckLv;lMmjCpCjjZ#Cqq#Cbp009O6ZHhtcjcttb#bMv;:;MANHUkAvv;vMMyrYvv8B888B8;;vvv8B8B8B8B8B;vV:YB8B8888;vyVYvykHYyyV;;vYlyyyv;;vYLVrkcUl;;,.,;vwU4yVvvvvvv;;;;;;:;.::;,;::,;v,                                                                                                                                                           
                                                        VTmVvlvVyyYVlyyVLwNkmmkcHwvvvwkcmj2bt2j2q0t22ptCpqZ2UkUkUmXc2qUv;;;ytcw4rvVv;TwALr;l8888B8B;;V;yB8B8B8B8B8vvv;v8B8B8B8;vvYvvlHUVVrrl;vvvvv;;vrrLLkcUv;;;.,;rhHcTv;vvvv;v;;;;;;::.,:;,;,;,:;v                                                                                                                                                            
                                                        ylHAvvllyVyVyVLlywXNHkU4ctt4V;vyUmmmtcpttjptbmtmkkmUHXUMhXUNkcDkv;:VDHHUHLlv;vhAMylv8B8B888;.vv;BB8B8B888m;vY.hB8B8B8p,vVlvvLt4lVykr;;v;;;vywrrhHAl;;;:.vLHkrv;;;;v;;;;;;;;:;::.,::::,:,,,v:                                                                                                                                                            
                                                        vVvklvvVlylVVyVyVwhUUUMUkmXtjkAlvYrUUHkcmckckHHcHHHUNUwwATwNAhkbwv;LC2HHkUvl;;vAwAl;B8B8B8B8:;vv;0B8B8B8L,vv.,B88888Bv;lvlvvyqLvvyHw;;;;vrMMVryyv;;;;;,vUHY;;;;;;;;;;;;;:;:;,,..:;,,,:,,.v;                                                                                                                                                             
                                                        ;VvwUvvllvVVyVyVrr4wUXkNkwUkjO0: ;;;vYTwUXkUkh4wXXUhUTwwNAMrwTNwmAvytbmmmkrvl;;lrrL;rB8B8B8B8.,;;.;yXhV,:;; ;B8B8B8Bj.vvlvv;ctvvlYUr,.;lUTylVvv;;;;;;:;vv:;;;;;;;;;;;:;:;,,.,.,:;;:,,,,.:;:                                                                                                                                                             
                                                         yvYMlvlvlvYlVYyrAh4wXU4kUXkceH. Yv;;:;;vVrMTXNXNhMhrArArMrArArwTkrTcckckHNyvv,;vrVl:b88B888B8v..,.. ...  ,@B8B888BC.vvvvv;w#rvlvvMY.:AkLlvlv;;;;;;;;;;;:;:;;;;;;;;;::,,....,::;::,:,..,.,.                                                                                                                                                             
                                                         YYvlvvvlvlvVYVyAMUMXT4N4hwhtGN  .v:v;v;;;;;vYrAwAwrNwwAMrArAyrAAyw4cXUUkhUUyvv,;vVlv,0B8B8B8B8Bbrv;;:;rqB8B8B888Bj ;vvvv;Vqkvvvlvy;:Akvvvv;;;;;;;;;;;;;;:;;;;;;;;: .   .,::;:;:;:,.,.,...                                                                                                                                                              
                                                         ;VvvlvvvlvllylryTTNw4w4h4M4c9M  ,vv;;;vvvv;,;;vlVyryArrLryArLyyrALrrAMNUk4hrYlv:;vlvv.UB888B8B8B8B8B8B8B8B8B8B8Br ;vvvv;YjUvvvvvvvvw4v;;;;;;;;;:;:;;;;;:;;;;;;;. .;;::;;;:;:;:;:: ....,.                                                                                                                                                               
                                                          yvlvvvvvYvlvlVrAhTMXXwhwXAt@L .:v;v:.   ,:v;;:;;vlyyryryLyLVLyyyyVyVLrAMwr4rllv;;vvvv.vG8B8B8B888B8B8B8B88888k..vvvvv;lpjvvvvvvvvyL;;;;;;;;;;;;:;;;;;;;::..      Al;;;;:;:;,::;........                                                                                                                                                               
                                                          vYvlvvvvvllYvLyrAMAhMXTNTwXOw  .:;; p8y,    .::::::vlyVylVvVYyVylyVyyyVrMwrryVlv;;;vvv:.;HB8B8B8B8B888B8B8OV..;vvvvv;L2cvvvvvvvvvv;;;;;;;;;;:;;;;;;:.            Y;;;::;:;:;,:,,::....                                                                                                                                                                
                                                           llvvvvlAVvvYyyyTAhAww4MAyhCt.  .,, 8B8B8BH:    .,,...vlLVYlYlyllVVVVlVYVVrLyyyll;;;vvvv;..vUt9B8B8B89mV;. .;vvvvvvvXC4vvvvvv;vvv;;;;;;;;;;:;;v;;.               v;:;::,:::::,:,:v: .                                                                                                                                                                 
                                                          .VvvvvvvVhyv;lyrrrrwLThrTGAtp;   .  j8B8B8B8B8l     .  .;YyyYYlVvYvVlVVllyVyyrYlYyv;;;vvvv;;,. ...., ..::;vvvvvvvvltjr;vvvvv;;;v;;;;;;;;:;;;::                   v;:,;::,:,:,:.,;v..                                                                                                                                                                  
                                                          lAvvvvvvvVNTv;yyALLrArwVhBhr0v.   . ;B8B8B8B8B888y        ,vyyYvlvlvYvYvVllvYlYvYlVlv;vvvvvvvvv;v;;;vvvvvvvvvvvvlwc4v;vvv;;;v;;;;;;;;:;;;::            vZBe     :V;:;,:,:,:,:,.,v,..                                                                                                                                                                  
                                                          .HvvvvvvvlvLAyvyyyyrALyyY8jYpM:      8B8B8B8B8B8B8B8X.       ;vrVYvlvvvlvYvlvYvlvVvVYYvvvvvvvvvvvvvvvvvvvvvvvvlTUHvvvvvvv;vv;;;;:;:;;;:,           lZ8B8B84     vY::::,:,:,,.,.v;.                                                                                                                                                                    
                                                           L4vvvvvvvVvVr4VVyLVyyrv;B8;mkv.     v888B8B888B8B8B8B8H        vVyllvvvvvvvvvlvYvlvYlVlVvvvvvvvvvvvlvVVVlyyAMNrYvvvv;v;v;;;;;;;;;;:,          .CB8B8B8B8B      Av,.,,:,:,,,,.;v,.                                                                                                                                                                    
                                                           .MNvvvvvvvYvvyyYylyyyYY:8BvVtY:      e88888B8B888B8B8B8B8A       ,lVyvvvvvvvvvvvvvvvvvllyVyllvvvv;vYyVrAwArylvv;v;v;v;;;;;;;;:;;;          leB8B888B8B8B8     .L; v;,,,,,,,.;v,                                                                                                                                                                      
                                                            vylvvvvvvvlllvVlVVrVVV;U8#:kt;,      B888B8B8B8B8B8B8B8B88e.       ;VVVvvvvvvvvvvvvvvvvvllyyryryArAyrVyvv;vvvvv;v;;;;;;;;:;;;,         A8B8B8B8B8B8B8B8.     Vy, jv :,,,, :v: .                                                                                                                                                                     
                                                             vvvvvvvvvvlvVlYYylLyLvvB8;vcX;,      B8B8B8B88888B8B888B8888t       .vVYYvvvvvvvvvlvvvlvvvvvlvVvlvvvv;vvvvv;v;v;v;;;;;;;;;.        U8B8B8B8B8B888B8B8H     ;M; ,8: ,,.,.;v:..                                                                                                                                                                      
                                                              yvvvvvvvvvvvlvYYyYyvv,BB8 vHM;       B8B8B8B8B8B8B8B8B888B8B8B:       :vyYvvvvvvvvvvvvlvvvvvvvvvvvvvvvv;v;v;;;;;;;;;;;;        k8B8B8B8B8B888B88888e      yl. tG .,...:;,..                                                                                                                                                                       
                                                              ,yvvvvvlvvvvvvvllYYlv;v8Bt Vmy:       G888B8B8B8B8B8B8B888B8B8B8m        :;vvvvvvvvvvvvvvvvvvvvvvv;v;v;v;v;;;;;;;v;:        T8B8B8B8B8B8B8B8B8B8B8B      yY; .Bm ,.,.,,,..                                                                                                                                                                        
                                                               ,yllvvvvvvvvvvvvvYlYv,C8BN yHA;       :8B888B8B8B8B8B8B8B8B8B8B8B         Vv;vvvvvvvvvvvvvvvvv;v;v;v;v;;;;;;;;:,        v8B8B8B8B888B8B888B8B8B80      yVv  D8. ,,.,....                                                                                                                                                                         
                                                                ;rllllvlvvvvvlvlvlvl;,B8BH vUNv.       vB8B8B8B8B8B8B8B8B8B8B8:         kwvv;v;vvvvvvvvvvvvvvv;v;;;;;;;;,,,,        ,#B8B8B8B8B88888B8B8B8B8B8;     .yYl  r8h .,.,....                                                                          .:.....:                                                                                        
                                                                 ;AYYvvvlvvvvvvvvvlvv,;B8BC ;rhV:         ve888B8B88888B8BO;          ;qUvvvv;v;;;;;;;;;;;v;;;;;;;;:;,:,,,::       ,8B8B8B888B888B8B888B888BA      :yYv. ;8B  ,......                               v      ;UTr                G8v              888B8B8B8                                                                                       
                                                                  :AVYvvvlvvvvvvvvvvvv,;88B8,.vUhv            ;Uqe9ODbl              4jy;vvvvv;v;;;;;;;;:;;:,;::,:,;:;:;;;;v:        8B8B888B8B8B888B8B8B8v       vyvv  ,88, .......                           eB8mGB8B.   8B8B                8Bk                                                                                                              
                                                                   .LyVvvvLyYvvvvvvvvvv.;B8B8y .VwTv.                              vCUv;vvvvvvvvvvvvvvv;v;v;;;v;v;v;vvvvv;vvY:        ,B888B8B88888B8BBM        ;LVY;  v8Bv ..... .                            98B8B8B6B8B8B8B8B8B8L           B8y              rB8B8B8H          lBw                                                      G8B;                 
                                                :                    rrVlvvVVTLv;vvvvvvv,,B8B8Bv ,vNNr;                          lUUv;;vvvvvvvvvvvvvvvvvvvvvvvvvvvvv;vvv;vvvvy;          vp888B8B8#U;         ;yVVv,  U8Bv  ....                               :B8B8B  8B8B6OeZ8B8Bv           8By            B8B8clvUB8B8v       A8c                                                      ;BB                  
                       vwMMyylvv:.            v0hv;                   lyVvvvlvrryvvvvvvvv: H8B8B8l  vrUhTv;.                 ,lktMv;v;vvvvvvvvvvvvvvvvvvvvvvv;vvvvv;v;vvv;v;;;lv                            vrrlY:  ,68B;  .. .  ..                           8B888B8  B8B8CODCB8B8v           B8V          v88r         B8B      yB4                 ,.                 ,       ,,                             
                      rcAMylvVvVvvv;,         cDVv;;.                  yVVvlvvvlllvvvvvlvv;.;8B8B8Bb;  ;YwwhwAv;;;,.,;;;vM4mj2Xv.vyv;vvvvvvvvvvvvvvvvvvvvvvv;vvv;v;v;v;v;v;v;vvvvv                       ;yTyVl;   4B8e,  ..   .,.                            v8B;B8Bj 8B8B8B8B888Bv           8By         .B8            68D     l8T    8B8       8B88888O B8     GB.D8B8B8v .8B8888       88                  
                      ArkB8XYYVvYvvvvv;,.     jtv;;;;,                  yVYllvvvvvvvvvvvvvv;: vB8B8B8Bt;   .;;lVAMhwHhXwwrV;:  vgBy;vvvvvvvvvvvvvvvvvvvvvvvvvvv;v;v;;;v;;;v;;;;;;vlv;                .vyryVvv,   V888c    .   :,                                  8B8B B8B8;vv;0888;           B8y         B8:             B8     V8l  B8B;      r8BV    ;888B     98B8    B8B8j   .8B      8B                  
                      vyU8B9rVYVYVvlvvvvvv;.  m#rv;;::,                  ;VYvlvvvvvvvvvvvvvvvv. vGB8B888B80Xv;            ,vU8B8D;;vvvvvvvlVlVvlvvvvvvvvvvvvvvvvvvvv;v;;;v;;;;;v;v:,;vvv;:.     ,;;Vyylv;;.    UB8Bev  . .   ,                                  B8B8B8 8B8B8B88888B,           88r         8B              8B;    v8rUB8:       v8B        H88     #BB      B8      L8Y     B8                  
                      ,YVc8BCLylVVVllvvvvvv;;,cOkvv;;,:,                  :vVvlvvvvvvvvvvvvvvvv;: :X8B88888B8B8B86GGgB8B8B8B8Bp,.;vvllyVrVLyyvVlVlVvlVyVrVyVyYvvvvvvvvv;v;;;v;;;;y9m;  .:;vvvvvvv;;;;.      MG8B8By   . .                                     8B8B8B8B B8BBL888 lB8w           B8y         B8              B8     vB8B;         8B          8B     O8,      8B      vB4     8B                  
                       vvyj8B2AyvvvvvYvvvvvv;;H9XYvv;:,:.                  .vyvlvlvvvvvvvvvvvvvvvv:. ,yOB8B8B8B8B888B8B8B8BU:..;vVlrATMwrAAyyVlyyLyATMLyvvvlYrrAyVvvvvvvvv;v;v;;;:;@B8by,              :YCB8B8BDv    . .                                      B8Blv8B8 8B8c B8B8B8B8           8Br         vB8            p8B     v888By        B8          B8     98.      B8      v8r     B8                  
                       ,Vvyj8BpAt2A;;vlvvvvv;;tjAVYv;:,...                   ;yvvvvvvvvvvvvvvvvvvvv;;;. .:vAt@BB8B8eGbkV;..,;vLrwUU4UXkAXhryAyyrMrV:            ;lryyllvvvvvvvv;;;: ,U8B888eqHkhNUcCBB8B8B88#l    . .                                          k  vB8B B8B#  B8B8B             88V          UB8.         B8B      VB; 0B8;       B8        B88     G8,      8B      V8w     88                  
                        vVvLteejp888cv;vvlvv;vtcyVll;;,,,,                    .llYvvvvvv;v;vvvvvvvvvvvvv;;,.         ..:;;vyrUkHmcUkUUMrAwyArhMy.                  .vrvvvlvlvvvv;v;;,  .vtB8B8B8B8B888BOkl,      . .                                           ,  B8B8;8B8B8B8B8B8BO;          8By            B8Bel,.vC8B8r       M8c   B8Bv      B8BV  v8B888     8B;      B8      M8c     88                  
                        .VlvVcB6Hk8B8BU;vlvv;v0HyYVvv;:.,;,                     ;VVvlvvvvvv;v;;;vvvvvvvvvvvvvvv;;;v;vvvvVVTTkkcmtkmX4wXhUTUXUX4vvYXUHkmHHkHUkU4ry;:  ,YYlvlvlvlvlvv;;::.     .::v;;,.         . .                                              B8B8B8B8B8B8B8B #888BA          88X              9B888B8Bv         :Bv     8Bv      ;888B8B: 8@     A8       89      ;B;     82                  
                         ;VvvrbeG4A8B8Bp;vvv;y2mVVvlv;::.vY.                      ;rVlvvvvvvvv;v;v;vvvvvvvvvvvvvvvvvvYYyVMNmUcccHHUHUUUHUUUmmtmtjjmHkHUHkHUk4kUUkHHmAlYyvlvllYlYvyVllvvv;;,.           . ... ...                                               cB8B8; B8BCl.     GBV           eBv                                                                                                              
                          vlvvrCB9A28B88t;Yv;AZkYvlvv;;:.,M;                        vVrVYvvvvvvvvvv;v;v;v;v;v;vvvvvvvvyyhXttqq0cckcHcUHHkktUy;,                .,.,;vyArrVVvllVvYyALATwlv;;::,,,:,,.,.,......                                                                                                                                                                                                   
                           vlvvwDB2AB8B88r;v;A#Hvvvlvv;:..Vw.                         ,vvVvvvvvvvvvvvvvvvvvvvvvvvvvYlVVLAHjqZZpjUkUHkHUkmH:                            .;yVlvvvlvyyrAALv;;:;::,:,:,,...... .       .                                                                                                                                                                                            
                           .lvvvkGeX#B8B8ev;vA0Avvvvv;;:: vc;                            YyvvvvvvvvvvvvvvvvvvvvvllYYVvVlyrwktjZ@0ckXHkcjY       vU#888888B8B8B89pr;       vVvvvvvvLyrlv;;:;;:,:........ .         .                                           NLryyyryryryLyLyryrVyVryLyryyyrLryyyyyLyryryryryryryryryryryryryLVLVLyryryryryryrLryLyryLyryryryryryLyryrLALryLyryryryryLyryLyXv                  
                            ;lvvl2eCc888B8N;vTjLvvvlvv;;,.:pr                             :lllvvvvvvvvvvvvvvvvvvvvvvvvvlvlvyyXHCCOZpkUcH    v8B8B8B8B8B8B8B8B8B8B888B8;    ;vvvvvvYrvv;;,::,.:..                 .                                            vvvv;v;vvvvv;v;vvv;v;v;v;v;vvvvv;v;v;v;v;v;v;v;v;v;vvvvv;vvvvv;v;v;v;v;vvv;v;v;v;v;v;v;v;v;v;v;v;v;v;v;v;v;v;vvv;v;v;v;v;vvv;vv:                  
                            .vvvvM9OpB888BD;;Apyvvlvv;;;;.,tt.                               ;VYylvvvvvvvvvvvvvvvvvvvvlvvvvvlYAAHc0q@jjH   B8B888BB9D2@qZ@9OeB8B8B88888By   vvvvyVYvv;;:;::.,.. .               ,,,                                                                                                                                                                                             
                             vvv;vmebBB8B8Bv;ywVvvvvvv;;:.,jb;                                 .;vvvvvvvvv;vvv;vvvvvvvvlvvvlvvvyyNUc2#qOA  t                           vA   vvvyVVvv;;::.,.... .             ..,,;:;:,                                     
                             vlvvvMOG#8B888r;lyvlvvvvv;;;.,m#v                                    :;;:;;;;;;:,;;;;vvv;,vVvlvvvvvYvVyN4cqOU                                 ;LryyY;;,:,,.,....               ,;;,,.::;;;::.                                 
                             vllvvV09#8888Bj;lvlvvvvvv;;;.;b#w.                                  ..,. .. .:;:,   ,:;;v, ;YvvvVYlvvvllVrNm#ObAyLyLhAyvv.      ,,::;.      ;VTAy;;::.,,,.... .           ,...,,:,:.,.:,;:;;;;;:.                             
                             vyvlvVme08B8B89vvlvlvvvvvv;; vOgk,                              ,vvv;;,:.,..  :;98H; ,;;;v. :vvvvvlVvlvvvvvllrXmjtctHkwrYlvv;;vvvvvvvvvlvvvlvv;:...,.,., ...             ..,...,.,.,.,,,,;:;;;;v;;;,                          
                             vylvvvHG9O888B8l;vlvvvvvv;;: Veej, .                          ;lyvvv;;;:;,,,.   mB8B8XyVv;;:.,vv:  yVvvvvvvvvvvvvvvvvvvvvvvvYvvvvvvvv;v;;;;::,,.,.,.... .         .:.     . ......,.,,,.:,:,;;;;v;v;v;,                       
                             vLvVvvw96jB8B8Bk;vvlvvvvv;;: mB9j; ,                       .vrVYvv;v;;;;;:,;,   ,8B8Bb.vvv;v;,:;   ,Yvvvvvvvvlvv;v;;;;;v;v;v;v;v;;;;;;;;:;,:,,,,.,..         . ..:,,.        ....,.,.,,:,:,;:;;;;v;;;vvv;.                    
                             lVYllvhZ8tCB8B8g;;lvvvvvv;;..b8Z#v ..                   .vVyrYYvvvv;;;;,;;;:;,   q8B80;vlvvvv;;;    ;vv;v;vvv,vv;;v;;;;;;;;;;;;;;;;;;;;,:,,,......,       ;Z8C, ,.,,,       . .....,,,:,::;:;;;;;;; .;vvvv;                   
                          wBBylvVllr@BZyBB888y:vvvvvvvv;,:OBZZy ,,           .,.,  vgqyvyyYvvvvvv;;,:;;:;;;   lB88jvyVLVyvv;vv: :::;;;vv;   ;;;;;;;;;;;;;;;:;;;,:::,,,,...... .        ;DegY .,.:,.       . ....,.,,::;:;;;;;;v;   .;;vvv,                 
                         UBeyvvylYvXOBOTl8B8B9:vvvvvvv;v,;98D9w..:        vyrMVV:vB8Hvv;;VrYvlvv::,::Yv;,v;.  ,888hlLryrVLyYvlvrYv;;,;,      ;;;,;:;:;:.  ,;,,,:.,.,               ,..  Aeec .,:,:,.        .,.,.,,:,:...;;;;;;;vl;, .,;vv,                
                         OgrvvylVvYhOB9klV8B8B4,vvvvvvv;,;GB9Om..,, ....:;vvv;, MB8v;;;;vvrAyv;,;;;:;yA;;;, . .B8BryNTMAAyAyylYyMvv;;:        .::,:,:.     .:.... .             ..,.,,. V68D; :,:,::.       ....,,,,::, ,,..,.;ymU4Lv;. ,;;                
                        ;92YvlVVlYYkOBOjwYv#B8By,vvvvv;v.;G8GGc, ,..;vvvvv;;:. @B8,:;;vlllvw4;:;;;;;;;;:..  .  8BblXw4h4MAyryVvywrvv;v;;@8jy,    ...         . .           ..:,:,,.,,:. v8BB; :;::,;,          ..,,::;;;lrYvvYwcHmUkNwyv.                  
                        UOM;vvyYVlLUDgDckAY;Ve8BT;vvvvvv:,DBeGq:.,,..,vvv;;;: 8B8Z .;vVlYvvvvvvvv;;;;::,:.  , ,B8;ywXTUXwrrVVvvVXwyvvvv;;D8B8BeT:     ..,.          ....,,;,,,,,:.:,:,. VB8G; ;:;,::;,          ..::;,,;rAUUmtjtjttctcmNrv;                
                        Z@vvvVYyYVrHZeZjkUrV;,vqkvvvvvvv:,b86eOv :,,...;;;:; 0B8B8BU;Vllvvvvvvvv;v;;;;:;:, .. ;8w,yXwNArrTyryYvvyXAyvlvv: ;8B8B8Bc  :;;;:;;;...,.,:;:;:;::,:,:,:,:,:,:. w8B0 .,;;;,::;,            .. .YMhXmccNryyrUHjttmtmA               
                       YgUvvVYVVVlAHD9OpmXNrVv;:;vvvvvv;; 48BOgA..:,,. ,;;;; g8B886yvvVvvvvvvvvvv;;;;;;::. .,.yt.:YAXMrrMrArLVYvAXXyYvYvv;. XB8B8BG. ,:,;,:,;:;:;,;,:,,::::,:,:,:,::::. j88l ,::;;:,:,;         .,::vvVLNkcUV;, ...,;l4cpcttN              
                       j0V;vlVyyYVrt@O#bHHwAllvvvvvvvvvv;,:eBGep,.,:,, ,;vvv;;U8B0lVllYVvvvvvvvv;v;v;;v;:, .,:v;,;;yVTM4AwAMLyYvYUXAyyYvvv;; ,q8B8B8; ,;;;,::;:;:::::;,;,;:;;;;;;;;;:: ,989. ;:::;:::;:;       .,;;vvVLXUcM; ..,,:,,,:;VUpHccA             
                       @tv;vyVlVrYMH#ZCpcU4ryvvvvvvvvvv;v;.r8BeOv :,,,:,:;vv; AOYvvvVlyVlvvvvvvvl;v;;;;;v:  ,,:,;;vvvrXMArArAyyvvhkMNryvlvv;;. v8B888l ,;;;;;:;;;:;:;;;:;;;;;:;;;;;;;: ;8BX ,:;:;:;,:,;:,       .,;;vVwUtN,  ...,.::;;;;lXjccmr            
                      ;qMvrpcr;vYAUp0ZpjHkhrVlvvvvvvvvvv;v,.c86eU..:.:;;.:;;.mBv;vlyyryrvvvvvv;:;rv;;;;;;v:  ,,;;;;vvLLMAhMAyryyvykXTwyrVYvvvv;  pB8B8l ,;;;;;;;;;:;;;;;;;;;;;;;;;;;;; yB8: ,;:::;:;,;::,        :;vvLwHm;     ..,:;;;;v;vXcHcmv           
                      vAvy6BHv;;lrkm2tcUkXULyvlvvvvvvvv;v;;.:b8O#v .,:;;,.; UBlvyrwrrVVllvvvv;.  ,lvv;;;,;v,  ,,;;;vVVyyTAwrMyLyvvhU4wMVLvlvvvv;: vB8B8v :;;;;;;;;;;;;;;;;;;;;;;;;;;;; r8e  ::;:;:;:::;::,      .,;vyMUmh       ,,::;;;;v;yUcUmU,          
                      ;VvCBZv;;vvMkmHc4XTwMrlvvvvvvvvv;vvv;;.:t90M...;;;,. y8AvryylyyMAryAyy,.:;;..,::.. ,;v,..,:;;vvvVyyMAArryyYvvUhhLryylYvvvv;; .G8B8:,;v;;;;;v;v;v;;;v;v;v;;;v;v;;.yBO .::;v;;:;:;;;,.       :;vrw4tv      ..,,;:;;;;;vhmkXml          
                     .AvhBBT;;;vyrUHkNXTTAAVlvvvvvv;v;v;;;;;; ,wCH; ,,;;:  BB;yrrv,.;ykAy;;. ;LNmH4r;.:;; .;: ..,:;vvvVYrrhrrLylyvvyHwMyLVVllvlvvyl..q88O.;;v;vvv;v;v;v;v;v;v;vvv;v;;;.;8q .;,,vV;;::;;,;       .:vyUwUk,       .,::;:;;;;lUjHUUA.         
                     vyvUBDy;;;vyMANTwrAyyVllvvvvvvv;v;v;;;;:; .lml,.,,;. y8CvVAV;.;cOtkr, ;AHmcmmHcUwLrYv.    . :;vvlvYrwAALryyYVvvwHTMyyYVvVv;;mrv:.O8Bv,vvv;vvv;vvv;;;vvvvv;v;vvv;v:.66 :;: .;v;:,;:;;,       :;rMMhL       ..,,;:;::.;TbcHUUA:         
                     vyvhGOV;;v;LyyVryyYLyVvlvvvvvvvv;;;;;v;;;:..;l:..:,  Aecvrrv,;c8B8B89Z99Z@2pcHkHkkwAyV     .,;;vvVlrMMMAyyVylYvV4UArlYvllv.;tkvv,:B8r,vvvvvvvvvvvvvvvvvvvvvylvvv;;.HB;,;,,..,;,:,::;:      .,;vlly,        ..:::,. ;MbtckUMA,         
                     VVvy0CV;;;vlryrVyYVVVvlvvvvvvvv;v;;A4lv;:,:,,.,,,,, yAvvLMA;,48BBeeGeeGDDCptcUHXUUHUkMV    .::;;vllvrAArrVyVyllvyhXVyvylv::;Uclvv.OBX.vvvvvvvvvvvvvvvvvvvvllAryvvv;;9l.::;;...,:;:;:;       :;;;;.        ..,,,. .vm#pjtmTrv.         
                     lyvYrkv;;v;lrryyvYYyvlvvvvvvvv;v:;kbyv;;::::,,.,.. vTrVyMHv.vG88ee6e6e9Oq0jjHhv;:;;ymbmr.  ..::;:vYVVArAyLVVlYvlvlrMVlv;:;;;vtVvv,N8w:vvvvv;vYvvvvvlvvvYvlv;:vAyvv;;vv:;,;;;,;;;:;,::,                    ....  ;UC#tjjjwrYv          
                     VYvvyhV;;;vvyyyvyrLvvvvvvvvvv;v;;lCUv;;;;,:,:.,., :MTYyk#kv.CB8BBeBgeGGOZ@btU;  . ..;ACpX,    ..,;lVyrryylYYVvYvlvlvl;;;;vv;vhAvl;LBr:vvvv; ;VvvvvvvvvYlYlv:..;vrlv;;:;:,:;;;;;:;:;:;,                    .   ;TCCjkHkkwyvv,          
                     vVvvvyv;;v;vYVvmG@ky;;;v;v;v;v;;;rmr;;;;;;::,,.,  lhvVA6@; VB8BBeBeeee9G@@Cpl  ...   ,vj@m;   ..,;vllyVryVvVvlvlvYvv;;;vvlvv;VrvvvvAvvvlv;.,;VvvvvvvvVVLyrv. ..:;lvv;;:::;;;:;;:,;,;:,                      .ypObHh4wAVlvv;           
                     ;vvvllvvvvvvvvUpck4Yv;;;;;v;v;;;vMHv;;;:;;;:,.,   UV;:vv. ;B88BeBeB6eeeOOZ0jl ...     .;cqc;  ..;;vllvVVVvlvlvvvvvYlYvVllvvvvvLvvvv;vvvv;,;::;rvvvvvvvVyAy;,; ..,:;v;;;.;;;;;:;,,,:,;.                     ;XtjUhTMyyvv;;:            
                    .;vvvvYvv;vvvvALvvvvv;;;;;;;;;;;;vMV;;;;;,;:;,:,, ;tv.,0eC988B8e8BBeBee6eO9Z@w  .     ...;tbm,  .,;;lvllyvlvvvvvvvvvlvYvYvlvvvvvyvvvvvvv;,;;;:;YyvvvvvvvVrV.;Vv,..,,;;;,,;;;;:;;:  .,.                     ;TAAyyVylvvv;;,             
                   88@;vvvvlvv;vvVYvvvvv;v;;;;;;;;;;;vVv;;;;::::,:,:. ;@Y.,6B8B8BBe8B8B8BBeBgGG9q0v        ..:YHHV   :;;vlvVvlvvvvvvvvvvvvvvvvvvvvvvVYvvvvv::v;v;;:vlvvvvvvVvl;.vylv;. ..,..:;;;:::;,                         ;ylvvlvvvv;;,:               
                  vB84;;vvvvv;;vyvvvvvv;v;v;;;;:;;;:;vV;;;;::,:,,.,,, ,yl.,G8eeeBgB88B8B8BBge9G9O#b;        ..vyMv   .;;vvvvlvvvvvvvv;vvvvvvlvvvvvvvlYvvv;::vvvvv;;;vvvvvvvlVv,:Yvvvv;;...,:;;;:;:::,    ;h                   vvv;;;;;;::.                 
                   lMV;v;vvv;;vyvvvvvv;v;v;;;;;;:;:;;Yv;:;::,:,,.,..     vw96gge6Bg8B8B8B8BBee96OD00;        .;vv.   ..;;vvvvvvv;;:yvvvvvvvvvvvvvvvvvvvv;::vvvvvvv;;;vvvvvvv;,.vvvvvvvvv;v;;,::;::::..   29,                   ,,:,:,,..                   
                  .NbM;;v;vvv;vvv;vvvvv;v;;;;;;;;:::vYv;;::,,.,......    U60eG6gB6BB8B8B8e8BegGOO#Z@DT        ,,     .,:;;;;;;:.::;vv;v;v;vvvvvvvvvvv;;,:;v;vvvvvvv:;;v;v;;;,.;vv;vvv;v;;;;:: .::,:..   .ZB;                                               
                  ;rYv;;;v;v;v;v;v;v;v;;;;;;;;:;::,;vl;;,:,,.,.,.. .     .pOGg9e6ee8B8B8B8BBee9GDZ@ZqO@L       :     ...,:.....;;;:vvvvv;vvv;vvv;vvvvvvvvvvv;vvv;vv;;;;;;;::.:;;;vvvvv;;;;:;,   .,..    .e8r                                               
                  :vv;;;;;v;;;v;;;;;;;;;;;;:;:;:;:,;v;:::.,.... .         :pB9G9e6ee8B8B8B8BB9O#DqCCCqDO@w;.  .;            ,:;;;;;;v;v;v;v;vvv;vvvvvvvvvvv;vvv;v;vv;:;:;,. :;;;;;;;;;;;;;;,.            H8b                                               
                   ;;;;;;;;v;v;;;;;;;;;;;;;;:;:::;;v;;,,...... .           ;eBG69G96eBB8B88BgG#Dq@2btpbZOGZCw;:v,        ,,::;;;;;:;;;;v;;;v;;,:;v;vvv;vvv;v;v;;;v;v;;:;:,.;;;;;;;;;;;;;::::           . .p8v                                              
                   .;;;;;;;;;;;;;;;;;:;;;:;,:::,:,;;;,,.,.. .               L8eO9O9O69G96GGOODZq#CCctmtjZZ@mHUVYl   ....,,;:;:;:;:::;;;;;;;:,.,:;vv;v;vvv;;;v;;;;;;;;;;;;;;;;:;;;;;;;:;::,:.          .,, ,CZ.                                             
                    .;;;;;;;;;;;;;;;:;;;,:,:,,,,.,.,.... .                   OB9OO9GO9O9OOOOZZZDb2cckmUkUkUXryvly    ....,,,,:,;,;,:,::;:,..,;;;:vvv;v;;;v;;;;;;;;:;;;;;;;;;;;;;.,:;::,:,:.          .,:,. ,Ur                                             
                      ,:;;v;;;;;;;;;;;;::::,,.,.,.. ...                       ee9D9O9DOZO#Z@ZbqC2tmkk4XTNAAyyv:ym;  . ..,.,,,,:,;,:,,.....:;;;;:;;v;;;;;v;;;;;;;:.;;;;;;;:;:;:;,  ,::.,,...        .,,;:,.. .;.                                            
                      :rVVvv;;,;,;:;:;::,:,,,,......                           9e9qZZZZ#qqbCtjtc4HkUMTAALrYYv..c#r   ....,.:,:.,,;:;::.,,;;;:;:;,;;;;;;;;;;;;;,. .;;:;:::::;:;.    ..,....       ..,:;::,,.. .                                             
                      v4Alv;;::::,:,;,:,,,,.. ... .                             pO@CCb0C0CbcmHHUU4XATrryVlv;, HeBc  ..,.,...,,:,:,::;:;:;:;::::,,.;;;;;;;:;:,.    ;;;::,;::,:.                   .;;;,:,:,:,...                                            
                       vvv;::;:;:,,,.:,,.. . . .                                 r2C22cjctmmU4h4TMrAVVlvvv;. LB8B9..,:,,,:,,,,,:,:::,:,,,:::,,,,...::;:;,,.    .  ,;,:,:,,,.                  .  ::;::,;,,,:,,.                                            
                        ;;;,:,:,:.,,,...                                         ,rAUUckHXXXXANAryylvvv;:. .;y8B8C.,;::::,:,,.:,:,:,:,:,,,:,,,,,... . .       .    ,:,,.,..                ..,:. .:::,;,:,  .,.                                            
                          ,,.......... ..... ..                                  :v:;vlyyyVLVVvvvvvv;,    vXvvB88w ;;;:;,;::,:,,,,,,.,,,.,.,.,......               .,:..                ...,,:::.  :::,;,,   ...                                           
                                ... .:;;;;;;;v;.                                  .;vvvvvv;;;.,..      :AmjUV;e88:,:;:;;;:;::::.,.,...,........ .                   .               . ,.,,:,:,:,;,. ..:,,.... ..                                           
                                   .vyYVYyV4mT;.                                   lvvvvvVyryyvvYVVAhkUC0UAMvvB8V :;;;;;;;;;::,:,,.... .                                         ....,,,,,,:,;,::;;:.. . .,:.. .                                           
                                    vLAAwrUUw;.                                   :YlvvvlvyLXUctb#Z0ZcXcjTAY;j8k.,;;;;;:;;;;;::,;,.                                           ....,.,.,,,,:::,;,:;;vv;;::,:,,.,.                                           
                                       ..,.                                       ;VvlvllyVyAXXcmmpCtcAkckrlYBU.;v;;;v;;;;;;;;,;:,                                           ...,:.,,:,:,,,:::,:,;;;;v;;::,,.,..                                           
                                                                                  vvlvlvYyyyMrHccmjmckMwjkTVyv;;;;v;v;v;;;;;;:;:, . .                                       ....:,,,:,,,:::,:,::::;;;;;::,:,,..                                            
                                                                                 ,vvvlvYlyyArwXmHjtbtHMXcHALlv;vvv;;;;,vv;;;:;,,......                                       ..,,,,:,,,:,:,:,:,;:;:;:;;:::.,                                               
                                                                                 ;YvvvlvyYyrhw44HHjpckhLkkhVYvv;v;;::.;lv;;;;,,.,,,,,..                                       ....:,:,:::,;,;:;;;:;:;,,.                                                   
                                                                                 vvlvlvllyyrTUNXkjcbmmhyAkMrlvv;::,::;;v;;;;,,.,,,,,...                                                . .....                                                             
                                                                                 vvvvvlvVVyrN4HUXc2cmUXAyyAYv;,,;;;;v;vv;;;,..;;;,,....                                                                                                                    
                                                                                 vvvvvvYlyLMMkUjcjccmH4hyyv;,,:;;vvvvv;;::,:;v;;,;,...                                                                                                                     
                                                                                 :yYlvvvYVrAUUmHjCtkHXUwTVv;;vYvvvvvvvv;;;;;;;;::,,.. .                                                                                                                    
                                                                                  ,VVVvllYyTAUctcbjtcHUkNTLMyyvv;vvvvv;;;;;;;;:;,,....                                                                                                                     
                                                                                    ;vAyyVyyrTHmtm2cmUkhwAAryvvvv;v;v;;;;;;;;,,.,....                                                                                                                      
                                                                                       ;vyyATXhkmjHkXUU4rAyylvvv;v;;;;;;;;;;:;::,.                                                                                                                         
                                                                                           .;vyyNUcHHkkAAMAyVvvvvvv;v;v;v;;::..                                                                                                                            
                                                                                                  .,:;;v;vvv;v;;;;;:,,                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                                                                                                                                                                
*/

// Testmachine: Windows 10, Laptop with i5-7200u, SSD Kingston 240GB connected in (USB 2.0 i.e. High-Speed) via USB 3.0 port, [drivers were not installed], also, Write-Caching is disabled (as default is).
/*
C:\Windows\system32>cd\

C:\>cd MinGW

C:\MinGW>set_distro_paths.bat

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>MakeEXEs_Ryuugan-ditto-1TB_btree_GCC.bat

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>gcc -O3 -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Nakamichi_Ryuugan-ditto-1TB_RAM_GCC730.exe -D_N_XMM -D_N_prefetch_4096 -D_N_alone -D_N_HI
GH_PRIORITY -DHashInBITS=20 -DHashChunkSizeInBITS=20 -DRAMpoolInKB=6612048

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>gcc -O3 -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Nakamichi_Ryuugan-ditto-1TB_SSD_GCC730.exe -D_N_XMM -D_N_prefetch_4096 -D_N_alone -D_N_HI
GH_PRIORITY -DHashInBITS=20 -DHashChunkSizeInBITS=20 -DRAMpoolInKB=6612048 -DExternalRAM

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>Nakamichi_Ryuugan-ditto-1TB_RAM_GCC730.exe Arabian_Nights_complete.html
Nakamichi 'Ryuugan-ditto-1TB', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note0: Nakamichi 'Dragoneye' is 100% FREE, licenseless that is.
Note1: Hamid Buzidi's LzTurbo ([a] FASTEST [Textual] Decompressor, Levels 19/29/39) retains kingship, his TurboBench (2017-Apr-07) proves the supremacy of LzTurbo, Turbo-Amazing!
Note2: Conor Stokes' LZSSE2 ([a] FASTEST Textual Decompressor, Level 17) is embedded, all credits along with many thanks go to him.
Note3: 'Ryuugan' predecessors are Washigan, Okamigan, Zato, Tsubame, Tengu-Tsuyo, Tengu, Rakka, Kokuen, Kinroba, Yoko, Kinutora, Jiten, Butsuhira, Suiken, Keigan, Kumataka, Washi, Aratama, Hitomi, Nekomata, Kitsune, Kinezumi, Sanbashi, Kaiko, Inazuma, Zangetsu, Hanabi, Hanazakari, Sanshi and Kaidanji.
Note4: This variant is the SLOWEST compressor under the Sun! This compile can handle files up to 5120MB.
Note5: The matchfinder is either 'Railgun_Trolldom' (matches longer than 18) or Leprechaun's B-tree order 3 (matches less or equal to 18).
Note6: Instead of '_mm_loadu_si128' '_mm_lddqu_si128' is used.
Note7: The lookahead 'Tsuyo' heuristic which looks one char ahead is applied thrice, still not strengthened, though.
Note8: The compile made 2017-Oct-22, the decompression time measuring is done in 16x8 passes choosing the top score from 64 back-to-back runs - the goal - to enter [maximal] Turbo Mode.
Note9: In GP/SSE4.1/AVX2 compile, the 24 matches become 3xQWORD/1xQWORD+1xXMMWORD/1xYMMWORD.
NoteA: Maximum compression ratio is 44:1, for 704 bytes long matches within 1TB Sliding Window.
NoteB: Please send me (at sanmayce@sanmayce.com) decompression results obtained on machines with fast CPU-RAM subsystems.
NoteC: In this latest (2019-Jan-20) compile, clock() was replaced with time() - to counter bigtime stats misreporting.
NoteD: Multi-way hashing allows each KeySize to occupy its own HASH pool, thus less RAM is in use - the LEAF is smaller.
Current priority class is REALTIME_PRIORITY_CLASS.
Allocating Source-Buffer 14 MB ...
Allocating Source-Buffer 14 MB (REVERSED) ...
Allocating Target-Buffer 46 MB ...
Allocating Verification-Buffer 14 MB ...
Leprechaun: Memory pool for B-tress is 6,612,048 KB.
Leprechaun: In this revision 8MB 8-way hash is used which results in 8 x 1,048,576 internal B-Trees of order 3.
Leprechaun: In this revision, 1 pass is to be made.
Leprechaun: Allocating HASH memory 67,108,929 bytes ... OK
Leprechaun: Allocating memory for B-tress 6458 MB ... OK
Leprechaun: Size of input file: 15,583,440

Leprechaun: Inserting keys/BBs of order 004 into B-trees, free RAM in B-tree pool is 6,612,048 KB ...
Leprechaun: Inserting keys/BBs of order 006 into B-trees, free RAM in B-tree pool is 6,604,089 KB ...
Leprechaun: Inserting keys/BBs of order 008 into B-trees, free RAM in B-tree pool is 6,550,882 KB ...
Leprechaun: Inserting keys/BBs of order 010 into B-trees, free RAM in B-tree pool is 6,388,585 KB ...
Leprechaun: Inserting keys/BBs of order 012 into B-trees, free RAM in B-tree pool is 6,055,645 KB ...
Leprechaun: Inserting keys/BBs of order 014 into B-trees, free RAM in B-tree pool is 5,532,175 KB ...
Leprechaun: Inserting keys/BBs of order 016 into B-trees, free RAM in B-tree pool is 4,825,455 KB ...
Leprechaun: Inserting keys/BBs of order 018 into B-trees, free RAM in B-tree pool is 3,954,416 KB ...

Leprechaun: Number Of Total/Distinct/Undistinct keys/BBs (all orders): 124,667,440/55,177,480/69,489,960
Leprechaun: Number Of TREEs(GREATER THE BETTER): 6,768,818
Leprechaun: Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: 34,942,972
Leprechaun: Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): 4
Leprechaun: Used value for B-trees pool in KB: 6,612,048
Leprechaun: Use next time for B-trees pool in KB: 3,672,584
Leprechaun: Total keys (all orders) into B-trees order 3 (during traversal/dump): 55,177,480
Leprechaun: Total keys MISSES/HITS (all orders) into B-trees order 3: 55,177,480/69,489,960

Leprechaun: B-trees building speed (counting ROOT LEAFs): 1,069,533 LEAFs/s
Leprechaun: B-trees traverse speed (counting ROOT LEAFs): 5,958,827 LEAFs/s
Leprechaun: Total Searches-n-Inserts Per Second: 2,770,387 SNIPS
Leprechaun: RAM needed to house B-trees (relative to the file being ripped): 241N

Compressing 15,583,440 bytes ...
^C

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>Nakamichi_Ryuugan-ditto-1TB_ssd_GCC730.exe Arabian_Nights_complete.html
Nakamichi 'Ryuugan-ditto-1TB', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note0: Nakamichi 'Dragoneye' is 100% FREE, licenseless that is.
Note1: Hamid Buzidi's LzTurbo ([a] FASTEST [Textual] Decompressor, Levels 19/29/39) retains kingship, his TurboBench (2017-Apr-07) proves the supremacy of LzTurbo, Turbo-Amazing!
Note2: Conor Stokes' LZSSE2 ([a] FASTEST Textual Decompressor, Level 17) is embedded, all credits along with many thanks go to him.
Note3: 'Ryuugan' predecessors are Washigan, Okamigan, Zato, Tsubame, Tengu-Tsuyo, Tengu, Rakka, Kokuen, Kinroba, Yoko, Kinutora, Jiten, Butsuhira, Suiken, Keigan, Kumataka, Washi, Aratama, Hitomi, Nekomata, Kitsune, Kinezumi, Sanbashi, Kaiko, Inazuma, Zangetsu, Hanabi, Hanazakari, Sanshi and Kaidanji.
Note4: This variant is the SLOWEST compressor under the Sun! This compile can handle files up to 5120MB.
Note5: The matchfinder is either 'Railgun_Trolldom' (matches longer than 18) or Leprechaun's B-tree order 3 (matches less or equal to 18).
Note6: Instead of '_mm_loadu_si128' '_mm_lddqu_si128' is used.
Note7: The lookahead 'Tsuyo' heuristic which looks one char ahead is applied thrice, still not strengthened, though.
Note8: The compile made 2017-Oct-22, the decompression time measuring is done in 16x8 passes choosing the top score from 64 back-to-back runs - the goal - to enter [maximal] Turbo Mode.
Note9: In GP/SSE4.1/AVX2 compile, the 24 matches become 3xQWORD/1xQWORD+1xXMMWORD/1xYMMWORD.
NoteA: Maximum compression ratio is 44:1, for 704 bytes long matches within 1TB Sliding Window.
NoteB: Please send me (at sanmayce@sanmayce.com) decompression results obtained on machines with fast CPU-RAM subsystems.
NoteC: In this latest (2019-Jan-20) compile, clock() was replaced with time() - to counter bigtime stats misreporting.
NoteD: Multi-way hashing allows each KeySize to occupy its own HASH pool, thus less RAM is in use - the LEAF is smaller.
Current priority class is REALTIME_PRIORITY_CLASS.
Allocating Source-Buffer 14 MB ...
Allocating Source-Buffer 14 MB (REVERSED) ...
Allocating Target-Buffer 46 MB ...
Allocating Verification-Buffer 14 MB ...
Leprechaun: Memory pool for B-tress is 6,612,048 KB.
Leprechaun: In this revision 8MB 8-way hash is used which results in 8 x 1,048,576 external B-Trees of order 3.
Leprechaun: In this revision, 1 pass is to be made.
Leprechaun: Allocating HASH memory 67,108,929 bytes ... OK
Leprechaun: Allocating/ZEROing 6,770,737,166 bytes swap file ... OK
Leprechaun: Size of input file: 15,583,440

Leprechaun: Inserting keys/BBs of order 004 into B-trees, free RAM in B-tree pool is 6,612,048 KB ...
Leprechaun: Inserting keys/BBs of order 006 into B-trees, free RAM in B-tree pool is 6,604,089 KB ...
Leprechaun: Inserting keys/BBs of order 008 into B-trees, free RAM in B-tree pool is 6,550,882 KB ...
Leprechaun: Inserting keys/BBs of order 010 into B-trees, free RAM in B-tree pool is 6,388,585 KB ...
Leprechaun: Inserting keys/BBs of order 012 into B-trees, free RAM in B-tree pool is 6,055,645 KB ...
Leprechaun: Inserting keys/BBs of order 014 into B-trees, free RAM in B-tree pool is 5,532,175 KB ...
Leprechaun: Inserting keys/BBs of order 016 into B-trees, free RAM in B-tree pool is 4,825,455 KB ...
Leprechaun: Inserting keys/BBs of order 018 into B-trees, free RAM in B-tree pool is 3,954,416 KB ...

Leprechaun: Number Of Total/Distinct/Undistinct keys/BBs (all orders): 124,667,440/55,177,480/69,489,960
Leprechaun: Number Of TREEs(GREATER THE BETTER): 6,768,818
Leprechaun: Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: 34,942,972
Leprechaun: Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): 4
Leprechaun: Used value for B-trees pool in KB: 6,612,048
Leprechaun: Use next time for B-trees pool in KB: 3,672,584
Leprechaun: Total keys (all orders) into B-trees order 3 (during traversal/dump): 55,177,480
Leprechaun: Total keys MISSES/HITS (all orders) into B-trees order 3: 55,177,480/69,489,960

Leprechaun: B-trees building speed (counting ROOT LEAFs): 13,322 LEAFs/s
Leprechaun: B-trees traverse speed (counting ROOT LEAFs): 42,693 LEAFs/s
Leprechaun: Total Searches-n-Inserts Per Second: 30,354 SNIPS
Leprechaun: RAM needed to house B-trees (relative to the file being ripped): 241N
Leprechaun: Total IOPS for 402,619,834 'freads' and 268,170,926 'fwrites' (of packets 106 bytes long) during loading traversing all orders: 163,328 IOPS

Compressing 15,583,440 bytes ...
^C

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>MakeEXEs_Ryuugan-ditto-1TB_btree_GCC.bat

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>gcc -O3 -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Nakamichi_Ryuugan-ditto-1TB_RAM_GCC730.exe -D_N_XMM -D_N_prefetch_4096 -D_N_alone -D_N_HI
GH_PRIORITY -DHashInBITS=20 -DHashChunkSizeInBITS=20 -DRAMpoolInKB=13612048

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>gcc -O3 -msse4.1 -fomit-frame-pointer Nakamichi_Ryuugan-ditto-1TB_btree.c -o Nakamichi_Ryuugan-ditto-1TB_SSD_GCC730.exe -D_N_XMM -D_N_prefetch_4096 -D_N_alone -D_N_HI
GH_PRIORITY -DHashInBITS=20 -DHashChunkSizeInBITS=20 -DRAMpoolInKB=13612048 -DExternalRAM

D:\Nakamichi_Ryuugan-ditto-1TB_bigtime_b-tree_2019-Jan-20>Nakamichi_Ryuugan-ditto-1TB_ssd_GCC730.exe Complete_Works_of_Charles_Dickens.txt
Nakamichi 'Ryuugan-ditto-1TB', written by Kaze, based on Nobuo Ito's LZSS source, babealicious suggestion by m^2 enforced, muffinesque suggestion by Jim Dempsey enforced.
Note0: Nakamichi 'Dragoneye' is 100% FREE, licenseless that is.
Note1: Hamid Buzidi's LzTurbo ([a] FASTEST [Textual] Decompressor, Levels 19/29/39) retains kingship, his TurboBench (2017-Apr-07) proves the supremacy of LzTurbo, Turbo-Amazing!
Note2: Conor Stokes' LZSSE2 ([a] FASTEST Textual Decompressor, Level 17) is embedded, all credits along with many thanks go to him.
Note3: 'Ryuugan' predecessors are Washigan, Okamigan, Zato, Tsubame, Tengu-Tsuyo, Tengu, Rakka, Kokuen, Kinroba, Yoko, Kinutora, Jiten, Butsuhira, Suiken, Keigan, Kumataka, Washi, Aratama, Hitomi, Nekomata, Kitsune, Kinezumi, Sanbashi, Kaiko, Inazuma, Zangetsu, Hanabi, Hanazakari, Sanshi and Kaidanji.
Note4: This variant is the SLOWEST compressor under the Sun! This compile can handle files up to 5120MB.
Note5: The matchfinder is either 'Railgun_Trolldom' (matches longer than 18) or Leprechaun's B-tree order 3 (matches less or equal to 18).
Note6: Instead of '_mm_loadu_si128' '_mm_lddqu_si128' is used.
Note7: The lookahead 'Tsuyo' heuristic which looks one char ahead is applied thrice, still not strengthened, though.
Note8: The compile made 2017-Oct-22, the decompression time measuring is done in 16x8 passes choosing the top score from 64 back-to-back runs - the goal - to enter [maximal] Turbo Mode.
Note9: In GP/SSE4.1/AVX2 compile, the 24 matches become 3xQWORD/1xQWORD+1xXMMWORD/1xYMMWORD.
NoteA: Maximum compression ratio is 44:1, for 704 bytes long matches within 1TB Sliding Window.
NoteB: Please send me (at sanmayce@sanmayce.com) decompression results obtained on machines with fast CPU-RAM subsystems.
NoteC: In this latest (2019-Jan-20) compile, clock() was replaced with time() - to counter bigtime stats misreporting.
NoteD: Multi-way hashing allows each KeySize to occupy its own HASH pool, thus less RAM is in use - the LEAF is smaller.
Current priority class is REALTIME_PRIORITY_CLASS.
Allocating Source-Buffer 40 MB ...
Allocating Source-Buffer 40 MB (REVERSED) ...
Allocating Target-Buffer 72 MB ...
Allocating Verification-Buffer 40 MB ...
Leprechaun: Memory pool for B-tress is 13,612,048 KB.
Leprechaun: In this revision 8MB 8-way hash is used which results in 8 x 1,048,576 external B-Trees of order 3.
Leprechaun: In this revision, 1 pass is to be made.
Leprechaun: Allocating HASH memory 67,108,929 bytes ... OK
Leprechaun: Allocating/ZEROing 13,938,737,166 bytes swap file ... OK
Leprechaun: Size of input file: 42,935,960

Leprechaun: Inserting keys/BBs of order 004 into B-trees, free RAM in B-tree pool is 13,612,048 KB ...
Leprechaun: Inserting keys/BBs of order 006 into B-trees, free RAM in B-tree pool is 13,605,572 KB ...
Leprechaun: Inserting keys/BBs of order 008 into B-trees, free RAM in B-tree pool is 13,546,308 KB ...
Leprechaun: Inserting keys/BBs of order 010 into B-trees, free RAM in B-tree pool is 13,285,138 KB ...
Leprechaun: Inserting keys/BBs of order 012 into B-trees, free RAM in B-tree pool is 12,604,428 KB ...
Leprechaun: Inserting keys/BBs of order 014 into B-trees, free RAM in B-tree pool is 11,354,612 KB ...
Leprechaun: Inserting keys/BBs of order 016 into B-trees, free RAM in B-tree pool is 9,485,965 KB ...
Leprechaun: Inserting keys/BBs of order 018 into B-trees, free RAM in B-tree pool is 7,061,527 KB ...

Leprechaun: Number Of Total/Distinct/Undistinct keys/BBs (all orders): 343,487,600/139,455,560/204,032,040
Leprechaun: Number Of TREEs(GREATER THE BETTER): 6,869,619
Leprechaun: Number Of LEAFs(littler THE BETTER) not counting ROOT LEAFs: 97,898,274
Leprechaun: Highest Tree not counting ROOT Level i.e. CORONA levels(littler THE BETTER): 5
Leprechaun: Used value for B-trees pool in KB: 13,612,048
Leprechaun: Use next time for B-trees pool in KB: 9,440,253
Leprechaun: Total keys (all orders) into B-trees order 3 (during traversal/dump): 139,455,560
Leprechaun: Total keys MISSES/HITS (all orders) into B-trees order 3: 139,455,560/204,032,040

Leprechaun: B-trees building speed (counting ROOT LEAFs): 5,116 LEAFs/s
Leprechaun: B-trees traverse speed (counting ROOT LEAFs): 10,564 LEAFs/s
Leprechaun: Total Searches-n-Inserts Per Second: 11,301 SNIPS
Leprechaun: RAM needed to house B-trees (relative to the file being ripped): 225N
Leprechaun: Total IOPS for 1,320,112,595 'freads' and 735,431,907 'fwrites' (of packets 106 bytes long) during loading traversing all orders: 67,632 IOPS

Compressing 42,935,960 bytes ...
^C
*/

// 2019-Aug-05:
/*
http://mattmahoney.net/dc/text.html

Large Text Compression Benchmark
Matt Mahoney
Last update: July 25, 2019.

                Compression                      Compressed size      Decompresser  Total size   Time (ns/byte)
Program           Options                       enwik8      enwik9     size (zip)   enwik9+prog  Comp Decomp  Mem Alg Note
-------           -------                     ----------  -----------  -----------  -----------  ----- -----  --- --- ----
phda9 1.8                                     15,010,414  116,544,849     42,944 xd 116,587,793  86182 86305  6319 CM  83
cmix v17                                      14,877,373  116,394,271    208,263 s  116,602,534 641189 645651 25258 CM 83

...

cabarc 1.00.0601  -m lzx:21                   28,465,607  250,756,595     51,917 xd 250,808,853   1619    15   20 LZ77
sr3                                           28,926,691  253,031,980      9,399 s  253,054,625    148   160   68 SR   26
bzip2 1.0.2       -9                          29,008,736  253,977,839     30,036 x  254,007,875    379   129    8 BWT

rh5_x64           -window:27 c6               29,078,552  254,220,469     36,744 x  254,257,213    196   9.4  145 ROLZ 48
RangeCoderC v1.7  c7 26                       28,788,013  254,527,369      7,858 x  254,535,227   2460  2436 1116 CM   26
quad v1.11        -x                          29,110,579  256,145,858     13,387 s  256,159,245    956   116   34 ROLZ
WinACE            -sfx -m5 -d4096             29,481,470  257,237,710          0 xd 257,237,710   1080    77    4
lzsr 0.01                                     29,433,834  258,912,605     40,287 x  258,952,892    194    88    6 LZ77 26
120

libzling 20160107 e4                          29,721,114  259,475,639     35,582 s  259,511,221     83    27   28 ROLZ 48
xpv5              c2                          29,963,217  262,525,246     14,371 x  262,539,617   2359   516    9 ROLZ 26
sr3c 1.0                                      29,731,019  266,035,006      7,701 x  266,042,707    160   145    5 SR   26
lzc v0.08         10                          30,611,315  266,565,255     11,364 x  266,576,619    302    63  550 LZ77

Nakamichi 'Dragoneye'                         32,917,888  277,293,058                                    1.3      LZSS 85

crush 1.00        cx                          31,731,711  279,491,430      2,489 s  279,493,919    948   2.9  148 LZ77 60

xeloz 0.3.5.3     c889                        32,441,272  283,621,211     18,771 s  283,639,982   1079     8  230 LZ77 48
bzp 0.2                                       31,563,865  283,908,295     36,808 x  283,945,103    110   120    3 LZP
ha 0.98           a2                          31,250,524  285,739,328     28,404 x  285,767,732   2010  1800  0.8 PPM
ulz 0.06          c9                          32,945,292  291,028,084     49,450 x  291,077,534    325   1.1  490 LZ77 82
irolz                                         33,310,676  292,448,365      4,584 s  292,452,949    274   144   17 ROLZ 26

60. Tested by Ilia Muravyov on an Intel Core i7-3770K, 4.8 GHz, 16 GB Corsair Vengeance LP 1800 MHz CL9, Corsair Force GS 240 GB SSD, Windows 7 SP1.
82. Tested by Ilia Muraviev on an Intel Core i7-4790K @ 4.6GHz, 32GB @ 1866MHz DDR3 RAM, RAMDisk.
85. Tested by Georgi Marinov on i5-7200U @ 3.1GHz, 8GB @ 2133MHz DDR4 RAM, Windows 10.

Decompression rate in nanoseconds per byte, 1.3ns/B:
enwik9.Nakamichi, 725MB/s is 725x1024x1024B per 1,000,000,000ns
enwik9                       1,000,000,000B per (1,000,000,000B/(725x1024x1024B))x1,000,000,000ns= 1,315,412,850ns

Or, Nakamichi decompresses enwik9 in 1.3s on a laptop.

Needed memory for Compression:
4N        + 293N               + (HASHPOOL=5N) <= 302N or 302GB
[Physical]  [Physical|External]  [Physical] 

Needed memory for Decompression:
<= 2N or 2GB

Compression Rate:
122 B/s or 1000000000/122/3600/24 =~ 95 days

D:\TEXTORAMIC_benchmarking>lzbench173 -c4 -i1,15 -o3 -etornado,16/blosclz,9/brieflz/crush,2/csc,5/density,3/fastlz,2/gipfeli/lzo1b,999/lzham,4/lzham24,4/libdeflate,1,12/lz4hc,1,10,12/lizard,19,29,39,49/lzf,1/lzfse/lzg,9/lzham,1/lzjb/lzlib,9/lzma,9/lzrw,5/lzsse2,17/lzsse4,17/lzsse8,17/lzvn/pithy,9/quicklz,3/snappy/slz_zlib,3/ucl_nrv2b,9/ucl_nrv2d,9/ucl_nrv2e,9/xpack,1,9/xz,9/yalz77,12/yappy,99/zlib,1,5,9/zling,4/shrinker/wflz/lzmat enwik9
lzbench 1.7.3 (64-bit Windows)   Assembled by P.Skibinski
The results sorted by column number 4:
Compressor name         Compress. Decompress.  Orig. size  Compr. size  Ratio Filename
csc 2016-10-13 -5        2.33 MB/s    59 MB/s  1000000000    213296889  21.33 enwik9
lzma 16.04 -9            1.12 MB/s    81 MB/s  1000000000    213337819  21.33 enwik9
xz 5.2.3 -9              1.19 MB/s    79 MB/s  1000000000    213337866  21.33 enwik9
lzham 1.0 -d26 -4        0.81 MB/s   188 MB/s  1000000000    215673584  21.57 enwik9
lzlib 1.8 -9             1.07 MB/s    57 MB/s  1000000000    216832124  21.68 enwik9
tornado 0.6a -16         1.31 MB/s   175 MB/s  1000000000    217735325  21.77 enwik9
lzham24 1.0 -4           1.01 MB/s   188 MB/s  1000000000    227368900  22.74 enwik9
zling 2016-01-10 -4        27 MB/s   144 MB/s  1000000000    259449164  25.94 enwik9
lzham 1.0 -d26 -1        1.97 MB/s   191 MB/s  1000000000    259506946  25.95 enwik9

Nakamichi 'Dragoneye'                725 MB/s                277293058

crush 1.0 -2             0.35 MB/s   269 MB/s  1000000000    279083341  27.91 enwik9
xpack 2016-06-02 -9        10 MB/s   746 MB/s  1000000000    300716430  30.07 enwik9
libdeflate 0.7 -12       5.65 MB/s   559 MB/s  1000000000    310824785  31.08 enwik9
lizard 1.0 -49           1.38 MB/s  1046 MB/s  1000000000    318854201  31.89 enwik9
lzfse 2017-03-08           47 MB/s   596 MB/s  1000000000    319756993  31.98 enwik9
zlib 1.2.11 -9             17 MB/s   253 MB/s  1000000000    322789230  32.28 enwik9
lizard 1.0 -29           1.44 MB/s  1191 MB/s  1000000000    323348239  32.33 enwik9
zlib 1.2.11 -5             30 MB/s   249 MB/s  1000000000    327365805  32.74 enwik9
ucl_nrv2e 1.03 -9        1.30 MB/s   248 MB/s  1000000000    332405521  33.24 enwik9
ucl_nrv2d 1.03 -9        1.30 MB/s   250 MB/s  1000000000    335533150  33.55 enwik9
lzsse2 2016-05-14 -17    2.26 MB/s  2923 MB/s  1000000000    340270593  34.03 enwik9
ucl_nrv2b 1.03 -9        1.27 MB/s   242 MB/s  1000000000    341785796  34.18 enwik9
lzsse4 2016-05-14 -17    2.51 MB/s  3123 MB/s  1000000000    344520599  34.45 enwik9
lzsse8 2016-05-14 -17    2.33 MB/s  3032 MB/s  1000000000    346637623  34.66 enwik9
libdeflate 0.7 -1         122 MB/s   587 MB/s  1000000000    355647167  35.56 enwik9
xpack 2016-06-02 -1       114 MB/s   575 MB/s  1000000000    358741520  35.87 enwik9
lzo1b 2.09 -999            12 MB/s   459 MB/s  1000000000    363178533  36.32 enwik9
lzmat 1.01                 31 MB/s   255 MB/s  1000000000    367262723  36.73 enwik9
lz4hc 1.8.0 -12            11 MB/s  2127 MB/s  1000000000    371677964  37.17 enwik9
lizard 1.0 -19           5.39 MB/s  2507 MB/s  1000000000    372092974  37.21 enwik9
lz4hc 1.8.0 -10            20 MB/s  2145 MB/s  1000000000    373026340  37.30 enwik9
zlib 1.2.11 -1             71 MB/s   245 MB/s  1000000000    378355076  37.84 enwik9
lizard 1.0 -39           5.27 MB/s  2337 MB/s  1000000000    378912990  37.89 enwik9
lzg 1.0.8 -9             0.84 MB/s   447 MB/s  1000000000    386976301  38.70 enwik9
brieflz 1.1.0              86 MB/s   135 MB/s  1000000000    388557049  38.86 enwik9
yalz77 2015-09-19 -12      17 MB/s   269 MB/s  1000000000    394059341  39.41 enwik9
quicklz 1.5.0 -3           39 MB/s   589 MB/s  1000000000    395494056  39.55 enwik9
lzvn 2017-03-08            39 MB/s   708 MB/s  1000000000    395814407  39.58 enwik9
lz4hc 1.8.0 -1             86 MB/s  2030 MB/s  1000000000    400818043  40.08 enwik9
gipfeli 2016-07-13        205 MB/s   318 MB/s  1000000000    411940549  41.19 enwik9
density 0.12.5 beta -3    252 MB/s   263 MB/s  1000000000    432914184  43.29 enwik9
lzrw 15-Jul-1991 -5       101 MB/s   355 MB/s  1000000000    436682071  43.67 enwik9
pithy 2011-12-24 -9       201 MB/s  1200 MB/s  1000000000    437729417  43.77 enwik9
slz_zlib 1.0.0 -3         164 MB/s   213 MB/s  1000000000    478256185  47.83 enwik9
fastlz 0.1 -2             210 MB/s   370 MB/s  1000000000    487260752  48.73 enwik9
yappy 2014-03-22 -99       72 MB/s  1574 MB/s  1000000000    492824491  49.28 enwik9
lzf 3.6 -1                214 MB/s   458 MB/s  1000000000    492987190  49.30 enwik9
blosclz 2015-11-10 -9     170 MB/s   634 MB/s  1000000000    498688572  49.87 enwik9
snappy 1.1.4              214 MB/s   889 MB/s  1000000000    507860747  50.79 enwik9
wflz 2015-09-16           165 MB/s   572 MB/s  1000000000    559915321  55.99 enwik9
lzjb 2010                 176 MB/s   329 MB/s  1000000000    665072021  66.51 enwik9
shrinker 0.1              197 MB/s  5596 MB/s  1000000000    968576855  96.86 enwik9
*/

/*
'Dragon Suffix Roster' revision 6
---------------------------------------------------------------------
| SORTED SUFFIXES | DRAGON               | LEPRECHAUN               |
---------------------------------------------------------------------
| -               | DRAGON               | LEPRECHAUN               |
| -adelic         | dragonadelic         | LEPRECHAUNadelic         |
| -adelically     | dragonadelically     | LEPRECHAUNadelically     | 
| -AGE            | DRAGONAGE            | LEPRECHAUNAGE            |
| -AGES           | DRAGONAGES           | LEPRECHAUNAGES           |
| -ALIA           | DRAGONALIA           | LEPRECHAUNALIA           |
| -ALIBUS         | DRAGONALIBUS         | LEPRECHAUNALIBUS         |
| -ALIS           | DRAGONALIS           | LEPRECHAUNALIS           |
| -ALIUM          | DRAGONALIUM          | LEPRECHAUNALIUM          |
| -ANTHROP        | DRAGONANTHROP        | LEPRECHAUNANTHROP        |
| -ANTHROPE       | DRAGONANTHROPE       | LEPRECHAUNANTHROPE       |
| -ANTHROPES      | DRAGONANTHROPES      | LEPRECHAUNANTHROPES      |
| -ANTHROPI       | DRAGONANTHROPI       | LEPRECHAUNANTHROPI       |
| -ANTHROPIA      | DRAGONANTHROPIA      | LEPRECHAUNANTHROPIA      |
| -ANTHROPIC      | DRAGONANTHROPIC      | LEPRECHAUNANTHROPIC      |
| -ANTHROPICALLY  | DRAGONANTHROPICALLY  | LEPRECHAUNANTHROPICALLY  |
| -ANTHROPIES     | DRAGONANTHROPIES     | LEPRECHAUNANTHROPIES     |
| -ANTHROPIST     | DRAGONANTHROPIST     | LEPRECHAUNANTHROPIST     |
| -ANTHROPISTS    | DRAGONANTHROPISTS    | LEPRECHAUNANTHROPISTS    |
| -ANTHROPOUS     | DRAGONANTHROPOUS     | LEPRECHAUNANTHROPOUS     |
| -ANTHROPS       | DRAGONANTHROPS       | LEPRECHAUNANTHROPS       |
| -ANTHROPUS      | DRAGONANTHROPUS      | LEPRECHAUNANTHROPUS      |
| -ANTHROPY       | DRAGONANTHROPY       | LEPRECHAUNANTHROPY       |
| -ARIA           | DRAGONARIA           | LEPRECHAUNARIA           |
| -ARIUM          | DRAGONARIUM          | LEPRECHAUNARIUM          |
| -ARIUMS         | DRAGONARIUMS         | LEPRECHAUNARIUMS         |
| -aroo           | dragonaroo           | leprechaunaroo           |
| -aroonie        | dragonaroonie        | leprechaunaroonie        |
| -ATA            | DRAGONATA            | LEPRECHAUNATA            |
| -ATE            | DRAGONATE            | LEPRECHAUNATE            |
| -ATES           | DRAGONATES           | LEPRECHAUNATES           |
| -ATICA          | DRAGONATICA          | LEPRECHAUNATICA          |
| -ATICUM         | DRAGONATICUM         | LEPRECHAUNATICUM         |
| -ATICUS         | DRAGONATICUS         | LEPRECHAUNATICUS         |
| -ATRICES        | DRAGONATRICES        | LEPRECHAUNATRICES        |
| -ATRIX          | DRAGONATRIX          | LEPRECHAUNATRIX          |
| -ATRIXES        | DRAGONATRIXES        | LEPRECHAUNATRIXES        |
| -ATUM           | DRAGONATUM           | LEPRECHAUNATUM           |
| -ATUS           | DRAGONATUS           | LEPRECHAUNATUS           |
| -aut            | dragonaut            | LEPRECHAUNaut            |  
| -autic          | dragonautic          | LEPRECHAUNautic          |
| -autical        | dragonautical        | LEPRECHAUNautical        |
| -autics         | dragonautics         | LEPRECHAUNautics         |
| -autrix         | dragonautrix         | LEPRECHAUNautrix         |
| -autte          | dragonautte          | LEPRECHAUNautte          |
| -BORN           | DRAGONBORN           | LEPRECHAUNBORN           |
| -BORNS          | DRAGONBORNS          | LEPRECHAUNBORNS          |
| -CEPHALY        | DRAGONCEPHALY        | LEPRECHAUNCEPHALY        |
| -cholia         | DRAGONcholia         | LEPRECHAUNcholia         |
| -choliac        | DRAGONcholiac        | LEPRECHAUNcholiac        |
| -cholian        | DRAGONcholian        | LEPRECHAUNcholian        |
| -cholically     | DRAGONcholically     | LEPRECHAUNcholically     |
| -cholie         | DRAGONcholie         | LEPRECHAUNcholie         |
| -cholies        | DRAGONcholies        | LEPRECHAUNcholies        |
| -cholily        | DRAGONcholily        | LEPRECHAUNcholily        |
| -choliness      | DRAGONcholiness      | LEPRECHAUNcholiness      |
| -cholious       | DRAGONcholious       | LEPRECHAUNcholious       |
| -cholist        | DRAGONcholist        | LEPRECHAUNcholist        |
| -cholists       | DRAGONcholists       | LEPRECHAUNcholists       |
| -cholize        | DRAGONcholize        | LEPRECHAUNcholize        |
| -choly          | DRAGONcholy          | LEPRECHAUNcholy          |
| -clad           | dragonclad           | leprechaunclad           |
| -CRAFT          | DRAGONCRAFT          | LEPRECHAUNCRAFT          |
| -CRAFTED        | DRAGONCRAFTED        | LEPRECHAUNCRAFTED        |
| -CRAFTING       | DRAGONCRAFTING       | LEPRECHAUNCRAFTING       |
| -DOM            | DRAGONDOM            | LEPRECHAUNDOM            |
| -DOMS           | DRAGONDOMS           | LEPRECHAUNDOMS           |
| -eer            | dragoneer            | LEPRECHAUNeer            |
| -eers           | dragoneers           | LEPRECHAUNeers           |
| -ella           | DRAGONella           | LEPRECHAUNella           |
| -entelechial    | dragonentelechial    | LEPRECHAUNentelechial    |
| -entelechially  | dragonentelechially  | LEPRECHAUNentelechially  |
| -entelechy      | dragonentelechy      | LEPRECHAUNentelechy      | 
| -erast          | DRAGONerast          | LEPRECHAUNerast          |
| -erastic        | DRAGONerastic        | LEPRECHAUNerastic        |
| -erasts         | DRAGONerasts         | LEPRECHAUNerasts         |
| -ERIE           | DRAGONERIE           | LEPRECHAUNERIE           |
| -ERIES          | DRAGONERIES          | LEPRECHAUNERIES          |
| -eroo           | dragoneroo           | leprechauneroo           |
| -eroonie        | dragoneroonie        | leprechauneroonie        |
| -ESE            | DRAGONESE            | LEPRECHAUNESE            |
| -ESQUE          | DRAGONESQUE          | LEPRECHAUNESQUE          |
| -ESQUELY        | DRAGONESQUELY        | LEPRECHAUNESQUELY        |
| -ESS            | DRAGONESS            | LEPRECHAUNESS            |
| -ESSES          | DRAGONESSES          | LEPRECHAUNESSES          |
| -ETTE           | DRAGONETTE           | LEPRECHAUNETTE           |
| -ette           | dragonette           | LEPRECHAUNette           |
| -fulness        | DRAGONfulness        | LEPRECHAUNfulness        |
| -HEAD           | DRAGONHEAD           | LEPRECHAUNHEAD           |
| -HEART          | DRAGONHEART          | LEPRECHAUNHEART          |
| -HEARTED        | DRAGONHEARTED        | LEPRECHAUNHEARTED        |
| -HEARTEDLY      | DRAGONHEARTEDLY      | LEPRECHAUNHEARTEDLY      |
| -HEARTEDNESS    | DRAGONHEARTEDNESS    | LEPRECHAUNHEARTEDNESS    |
| -HOOD           | DRAGONHOOD           | LEPRECHAUNHOOD           |
| -IA             | DRAGONIA             | LEPRECHAUNIA             |
| -IACISM         | DRAGONIACISM         | LEPRECHAUNIACISM         |
| -IAL            | DRAGONIAL            | LEPRECHAUNIAL            |
| -IAN            | DRAGONIAN            | LEPRECHAUNIAN            |
| -IANA           | DRAGONIANA           | LEPRECHAUNIANA           |
| -IANICITY       | DRAGONIANICITY       | LEPRECHAUNIANICITY       |
| -IANISM         | DRAGONIANISM         | LEPRECHAUNIANISM         |
| -ianly          | DRAGONianly          | LEPRECHAUNianly          |
| -IC             | DRAGONIC             | LEPRECHAUNIC             |
| -ICA            | DRAGONICA            | LEPRECHAUNICA            |
| -ICAE           | DRAGONICAE           | LEPRECHAUNICAE           |
| -ICAL           | DRAGONICAL           | LEPRECHAUNICAL           |
| -ICALIZATION    | DRAGONICALIZATION    | LEPRECHAUNICALIZATION    |
| -ICALIZATIONS   | DRAGONICALIZATIONS   | LEPRECHAUNICALIZATIONS   |
| -ICALIZATOR     | DRAGONICALIZATOR     | LEPRECHAUNICALIZATOR     |
| -ICALIZATORS    | DRAGONICALIZATORS    | LEPRECHAUNICALIZATORS    |
| -ICALIZATRESS   | DRAGONICALIZATRESS   | LEPRECHAUNICALIZATRESS   |
| -ICALIZATRESSES | DRAGONICALIZATRESSES | LEPRECHAUNICALIZATRESSES |
| -ICALIZATRICES  | DRAGONICALIZATRICES  | LEPRECHAUNICALIZATRICES  |
| -ICALIZATRIX    | DRAGONICALIZATRIX    | LEPRECHAUNICALIZATRIX    |
| -ICALIZATRIXES  | DRAGONICALIZATRIXES  | LEPRECHAUNICALIZATRIXES  |
| -ICALIZE-MENT   | DRAGONICALIZEMENT    | LEPRECHAUNICALIZEMENT    |
| -ICALIZE-MENTS  | DRAGONICALIZEMENTS   | LEPRECHAUNICALIZEMENTS   |
| -ICALIZE        | DRAGONICALIZE        | LEPRECHAUNICALIZE        |
| -ICALIZED       | DRAGONICALIZED       | LEPRECHAUNICALIZED       |
| -ICALIZER       | DRAGONICALIZER       | LEPRECHAUNICALIZER       |
| -ICALIZERESS    | DRAGONICALIZERESS    | LEPRECHAUNICALIZERESS    |
| -ICALIZERESSES  | DRAGONICALIZERESSES  | LEPRECHAUNICALIZERESSES  |
| -ICALIZERS      | DRAGONICALIZERS      | LEPRECHAUNICALIZERS      |
| -ICALIZES       | DRAGONICALIZES       | LEPRECHAUNICALIZES       |
| -ICALIZING      | DRAGONICALIZING      | LEPRECHAUNICALIZING      |
| -ICALLY         | DRAGONICALLY         | LEPRECHAUNICALLY         |
| -ICALNESS       | DRAGONICALNESS       | LEPRECHAUNICALNESS       |
| -ICAM           | DRAGONICAM           | LEPRECHAUNICAM           |
| -ICARUM         | DRAGONICARUM         | LEPRECHAUNICARUM         |
| -ICAS           | DRAGONICAS           | LEPRECHAUNICAS           |
| -ICE            | DRAGONICE            | LEPRECHAUNICE            |
| -ICHE           | DRAGONICHE           | LEPRECHAUNICHE           |
| -ICI            | DRAGONICI            | LEPRECHAUNICI            |
| -ICIAN          | DRAGONICIAN          | LEPRECHAUNICIAN          |
| -ICIANS         | DRAGONICIANS         | LEPRECHAUNICIANS         |
| -ICICITY        | DRAGONICICITY        | LEPRECHAUNICICITY        |
| -ICIDAL         | DRAGONICIDAL         | LEPRECHAUNICIDAL         |
| -ICIDE          | DRAGONICIDE          | LEPRECHAUNICIDE          |
| -ICIS           | DRAGONICIS           | LEPRECHAUNICIS           |
| -ICISM          | DRAGONICISM          | LEPRECHAUNICISM          |
| -ICISMS         | DRAGONICISMS         | LEPRECHAUNICISMS         |
| -icity          | dragonicity          | leprechaunicity          |
| -ICIZATION      | DRAGONICIZATION      | LEPRECHAUNICIZATION      |
| -ICIZATIONS     | DRAGONICIZATIONS     | LEPRECHAUNICIZATIONS     |
| -ICIZATOR       | DRAGONICIZATOR       | LEPRECHAUNICIZATOR       |
| -ICIZATORS      | DRAGONICIZATORS      | LEPRECHAUNICIZATORS      |
| -ICIZATRESS     | DRAGONICIZATRESS     | LEPRECHAUNICIZATRESS     |
| -ICIZATRESSES   | DRAGONICIZATRESSES   | LEPRECHAUNICIZATRESSES   |
| -ICIZATRICES    | DRAGONICIZATRICES    | LEPRECHAUNICIZATRICES    |
| -ICIZATRIX      | DRAGONICIZATRIX      | LEPRECHAUNICIZATRIX      |
| -ICIZATRIXES    | DRAGONICIZATRIXES    | LEPRECHAUNICIZATRIXES    |
| -ICIZE-MENT     | DRAGONICIZEMENT      | LEPRECHAUNICIZEMENT      |
| -ICIZE-MENTS    | DRAGONICIZEMENTS     | LEPRECHAUNICIZEMENTS     |
| -ICIZE          | DRAGONICIZE          | LEPRECHAUNICIZE          |
| -ICIZED         | DRAGONICIZED         | LEPRECHAUNICIZED         |
| -ICIZER         | DRAGONICIZER         | LEPRECHAUNICIZER         |
| -ICIZERESS      | DRAGONICIZERESS      | LEPRECHAUNICIZERESS      |
| -ICIZERESSES    | DRAGONICIZERESSES    | LEPRECHAUNICIZERESSES    |
| -ICIZERS        | DRAGONICIZERS        | LEPRECHAUNICIZERS        |
| -ICIZES         | DRAGONICIZES         | LEPRECHAUNICIZES         |
| -ICIZING        | DRAGONICIZING        | LEPRECHAUNICIZING        |
| -ICNESS         | DRAGONICNESS         | LEPRECHAUNICNESS         |
| -ICO            | DRAGONICO            | LEPRECHAUNICO            |
| -ICORUM         | DRAGONICORUM         | LEPRECHAUNICORUM         |
| -ICOS           | DRAGONICOS           | LEPRECHAUNICOS           |
| -ICS            | DRAGONICS            | LEPRECHAUNICS            |
| -ICUM           | DRAGONICUM           | LEPRECHAUNICUM           |
| -ICUS           | DRAGONICUS           | LEPRECHAUNICUS           |
| -IDAS           | DRAGONIDAS           | LEPRECHAUNIDAS           |
| -ier            | DRAGONier            | LEPRECHAUNier            |
| -iest           | DRAGONiest           | LEPRECHAUNiest           |
| -IFEROUS        | DRAGONIFEROUS        | LEPRECHAUNIFEROUS        |
| -IFIABLE        | DRAGONIFIABLE        | LEPRECHAUNIFIABLE        |
| -IFIC           | DRAGONIFIC           | LEPRECHAUNIFIC           |
| -IFICATION      | DRAGONIFICATION      | LEPRECHAUNIFICATION      |
| -IFIED          | DRAGONIFIED          | LEPRECHAUNIFIED          |
| -IFIER          | DRAGONIFIER          | LEPRECHAUNIFIER          |
| -IFIERS         | DRAGONIFIERS         | LEPRECHAUNIFIERS         |
| -IFIES          | DRAGONIFIES          | LEPRECHAUNIFIES          |
| -IFY-MENT       | DRAGONIFYMENT        | LEPRECHAUNIFYMENT        |
| -IFY-MENTS      | DRAGONIFYMENTS       | LEPRECHAUNIFYMENTS       |
| -IFY            | DRAGONIFY            | LEPRECHAUNIFY            |
| -IFYING         | DRAGONIFYING         | LEPRECHAUNIFYING         |
| -IFYINGS        | DRAGONIFYINGS        | LEPRECHAUNIFYINGS        |
| -IGENOUS        | DRAGONIGENOUS        | LEPRECHAUNIGENOUS        |
| -IGER           | DRAGONIGER           | LEPRECHAUNIGER           |
| -IGEROUS        | DRAGONIGEROUS        | LEPRECHAUNIGEROUS        |
| -INA            | DRAGONINA            | LEPRECHAUNINA            |
| -INE            | DRAGONINE            | LEPRECHAUNINE            |
| -INITY          | DRAGONINITY          | LEPRECHAUNINITY          |
| -INUM           | DRAGONINUM           | LEPRECHAUNINUM           |
| -INUS           | DRAGONINUS           | LEPRECHAUNINUS           |
| -ISH            | DRAGONISH            | LEPRECHAUNISH            |
| -ISHLY          | DRAGONISHLY          | LEPRECHAUNISHLY          |
| -ISHNESS        | DRAGONISHNESS        | LEPRECHAUNISHNESS        |
| -ISM            | DRAGONISM            | LEPRECHAUNISM            |
| -ISMS           | DRAGONISMS           | LEPRECHAUNISMS           |
| -ISSIMA         | DRAGONISSIMA         | LEPRECHAUNISSIMA         |
| -ISSIMAE        | DRAGONISSIMAE        | LEPRECHAUNISSIMAE        |
| -ISSIMI         | DRAGONISSIMI         | LEPRECHAUNISSIMI         |
| -ISSIMO         | DRAGONISSIMO         | LEPRECHAUNISSIMO         |
| -ISSIMUM        | DRAGONISSIMUM        | LEPRECHAUNISSIMUM        |
| -ISSIMUS        | DRAGONISSIMUS        | LEPRECHAUNISSIMUS        |
| -ISSIMUSES      | DRAGONISSIMUSES      | LEPRECHAUNISSIMUSES      |
| -IST            | DRAGONIST            | LEPRECHAUNIST            |
| -ISTESS         | DRAGONISTESS         | LEPRECHAUNISTESS         |
| -ISTS           | DRAGONISTS           | LEPRECHAUNISTS           |
| -ISTSESSES      | DRAGONISTSESSES      | LEPRECHAUNISTSESSES      |
| -ITARIAN        | DRAGONITARIAN        | LEPRECHAUNITARIAN        |
| -ITARIANISM     | DRAGONITARIANISM     | LEPRECHAUNITARIANISM     |
| -ITARY          | DRAGONITARY          | LEPRECHAUNITARY          |
| -ITE            | DRAGONITE            | LEPRECHAUNITE            |
| -itis           | DRAGONitis           | LEPRECHAUNitis           |
| -ITUDE          | DRAGONITUDE          | LEPRECHAUNITUDE          |
| -ITUDES         | DRAGONITUDES         | LEPRECHAUNITUDES         |
| -ITY            | DRAGONITY            | LEPRECHAUNITY            |
| -IUM            | DRAGONIUM            | LEPRECHAUNIUM            |
| -IUS            | DRAGONIUS            | LEPRECHAUNIUS            |
| -IZABILITY      | DRAGONIZABILITY      | LEPRECHAUNIZABILITY      |
| -IZABLE         | DRAGONIZABLE         | LEPRECHAUNIZABLE         |
| -IZATION        | DRAGONIZATION        | LEPRECHAUNIZATION        |
| -IZATIONS       | DRAGONIZATIONS       | LEPRECHAUNIZATIONS       |
| -IZATOR         | DRAGONIZATOR         | LEPRECHAUNIZATOR         |
| -IZATORS        | DRAGONIZATORS        | LEPRECHAUNIZATORS        |
| -IZATRESS       | DRAGONIZATRESS       | LEPRECHAUNIZATRESS       |
| -IZATRESSES     | DRAGONIZATRESSES     | LEPRECHAUNIZATRESSES     |
| -IZATRICES      | DRAGONIZATRICES      | LEPRECHAUNIZATRICES      |
| -IZATRIX        | DRAGONIZATRIX        | LEPRECHAUNIZATRIX        |
| -IZATRIXES      | DRAGONIZATRIXES      | LEPRECHAUNIZATRIXES      |
| -IZE-MENT       | DRAGONIZEMENT        | LEPRECHAUNIZEMENT        |
| -IZE-MENTS      | DRAGONIZEMENTS       | LEPRECHAUNIZEMENTS       |
| -IZE            | DRAGONIZE            | LEPRECHAUNIZE            |
| -IZED           | DRAGONIZED           | LEPRECHAUNIZED           |
| -IZER           | DRAGONIZER           | LEPRECHAUNIZER           |
| -IZERESS        | DRAGONIZERESS        | LEPRECHAUNIZERESS        |
| -IZERESSES      | DRAGONIZERESSES      | LEPRECHAUNIZERESSES      |
| -IZERS          | DRAGONIZERS          | LEPRECHAUNIZERS          |
| -IZES           | DRAGONIZES           | LEPRECHAUNIZES           |
| -IZING          | DRAGONIZING          | LEPRECHAUNIZING          |
| -KIN            | DRAGONKIN            | LEPRECHAUNKIN            |
| -KIND           | DRAGONKIND           | LEPRECHAUNKIND           |
| -LAND           | DRAGONLAND           | LEPRECHAUNLAND           |
| -LESS           | DRAGONLESS           | LEPRECHAUNLESS           |
| -lessness       | DRAGONlessness       | LEPRECHAUNlessness       |
| -LET            | DRAGONLET            | LEPRECHAUNLET            |
| -LETS           | DRAGONLETS           | LEPRECHAUNLETS           |
| -LIKE           | DRAGONLIKE           | LEPRECHAUNLIKE           |
| -liness         | DRAGONliness         | LEPRECHAUNliness         |
| -linesses       | DRAGONlinesses       | LEPRECHAUNlinesses       |
| -LING           | DRAGONLING           | LEPRECHAUNLING           |
| -LINGS          | DRAGONLINGS          | LEPRECHAUNLINGS          |
| -LORAMA         | DRAGONLORAMA         | LEPRECHAUNLORAMA         |
| -LORE           | DRAGONLORE           | LEPRECHAUNLORE           |
| -LORES          | DRAGONLORES          | LEPRECHAUNLORES          |
| -LORIC          | DRAGONLORIC          | LEPRECHAUNLORIC          |
| -LORISH         | DRAGONLORISH         | LEPRECHAUNLORISH         |
| -LORIST         | DRAGONLORIST         | LEPRECHAUNLORIST         |
| -LORISTIC       | DRAGONLORISTIC       | LEPRECHAUNLORISTIC       |
| -LORISTICS      | DRAGONLORISTICS      | LEPRECHAUNLORISTICS      |
| -LORISTS        | DRAGONLORISTS        | LEPRECHAUNLORISTS        |
| -LY             | DRAGONLY             | LEPRECHAUNLY             |
| -NESS           | DRAGONNESS           | LEPRECHAUNNESS           |
| -NESSes         | DRAGONNESSes         | LEPRECHAUNNESSes         |
| -OCEPHALI       | DRAGONOCEPHALI       | LEPRECHAUNOCEPHALI       |
| -OCEPHALIC      | DRAGONOCEPHALIC      | LEPRECHAUNOCEPHALIC      |
| -OCEPHALISM     | DRAGONOCEPHALISM     | LEPRECHAUNOCEPHALISM     |
| -OCEPHALOUS     | DRAGONOCEPHALOUS     | LEPRECHAUNOCEPHALOUS     |
| -OCEPHALUS      | DRAGONOCEPHALUS      | LEPRECHAUNOCEPHALUS      |
| -OCEPHALY       | DRAGONOCEPHALY       | LEPRECHAUNOCEPHALY       |
| -OCRACIES       | DRAGONOCRACIES       | LEPRECHAUNOCRACIES       |
| -OCRACY         | DRAGONOCRACY         | LEPRECHAUNOCRACY         |
| -OCRAT          | DRAGONOCRAT          | LEPRECHAUNOCRAT          |
| -OCRATIC        | DRAGONOCRATIC        | LEPRECHAUNOCRATIC        |
| -OCRATICAL      | DRAGONOCRATICAL      | LEPRECHAUNOCRATICAL      |
| -OCRATICALLY    | DRAGONOCRATICALLY    | LEPRECHAUNOCRATICALLY    |
| -OCRATS         | DRAGONOCRATS         | LEPRECHAUNOCRATS         |
| -ODOULIC        | DRAGONODOULIC        | LEPRECHAUNODOULIC        |
| -ODOULIST       | DRAGONODOULIST       | LEPRECHAUNODOULIST       |
| -ODOULISTS      | DRAGONODOULISTS      | LEPRECHAUNODOULISTS      |
| -ODULE          | DRAGONODULE          | LEPRECHAUNODULE          |
| -ODULES         | DRAGONODULES         | LEPRECHAUNODULES         |
| -ODULIC         | DRAGONODULIC         | LEPRECHAUNODULIC         |
| -ODULIST        | DRAGONODULIST        | LEPRECHAUNODULIST        |
| -ODULISTS       | DRAGONODULISTS       | LEPRECHAUNODULISTS       |
| -ODULY          | DRAGONODULY          | LEPRECHAUNODULY          |
| -ogeny          | dragonogeny          | leprechaunogeny          |
| -ognosis        | dragonognosis        | leprechaunognosis        |
| -ogony          | dragonogony          | leprechaunogony          |
| -ogram          | DRAGONogram          | LEPRECHAUNogram          |
| -ogrammatic     | DRAGONogrammatic     | LEPRECHAUNogrammatic     |
| -ogrammatical   | DRAGONogrammatical   | LEPRECHAUNogrammatical   |
| -ogrammatically | DRAGONogrammatically | LEPRECHAUNogrammatically |
| -ogrammed       | DRAGONogrammed       | LEPRECHAUNogrammed       |
| -ogramming      | DRAGONogramming      | LEPRECHAUNogramming      |
| -ograms         | DRAGONograms         | LEPRECHAUNograms         |
| -OGRAPH         | DRAGONOGRAPH         | LEPRECHAUNOGRAPH         |
| -OGRAPHER       | DRAGONOGRAPHER       | LEPRECHAUNOGRAPHER       |
| -OGRAPHERS      | DRAGONOGRAPHERS      | LEPRECHAUNOGRAPHERS      |
| -OGRAPHIC       | DRAGONOGRAPHIC       | LEPRECHAUNOGRAPHIC       |
| -OGRAPHICAL     | DRAGONOGRAPHICAL     | LEPRECHAUNOGRAPHICAL     |
| -OGRAPHICALLY   | DRAGONOGRAPHICALLY   | LEPRECHAUNOGRAPHICALLY   |
| -OGRAPHIES      | DRAGONOGRAPHIES      | LEPRECHAUNOGRAPHIES      |
| -OGRAPHIST      | DRAGONOGRAPHIST      | LEPRECHAUNOGRAPHIST      |
| -OGRAPHISTS     | DRAGONOGRAPHISTS     | LEPRECHAUNOGRAPHISTS     |
| -ographomania   | DRAGONographomania   | LEPRECHAUNographomania   |
| -ographomaniac  | DRAGONographomaniac  | LEPRECHAUNographomaniac  |
| -ographomaniacs | DRAGONographomaniacs | LEPRECHAUNographomaniacs |
| -OGRAPHS        | DRAGONOGRAPHS        | LEPRECHAUNOGRAPHS        |
| -OGRAPHY        | DRAGONOGRAPHY        | LEPRECHAUNOGRAPHY        |
| -ogyral         | dragonogyral         | leprechaunogyral         |
| -oholic         | DRAGONoholic         | LEPRECHAUNoholic         |
| -oholics        | DRAGONoholics        | LEPRECHAUNoholics        |
| -OID            | DRAGONOID            | LEPRECHAUNOID            |
| -OIDS           | DRAGONOIDS           | LEPRECHAUNOIDS           |
| -olagnia        | DRAGONolagnia        | LEPRECHAUNolagnia        |
| -olagniac       | DRAGONolagniac       | LEPRECHAUNolagniac       |
| -olagniacs      | DRAGONolagniacs      | LEPRECHAUNolagniacs      |
| -olagnist       | DRAGONolagnist       | LEPRECHAUNolagnist       |
| -olagnists      | DRAGONolagnists      | LEPRECHAUNolagnists      |
| -OLATER         | DRAGONOLATER         | LEPRECHAUNOLATER         |
| -OLATERS        | DRAGONOLATERS        | LEPRECHAUNOLATERS        |
| -OLATRIES       | DRAGONOLATRIES       | LEPRECHAUNOLATRIES       |
| -OLATROUS       | DRAGONOLATROUS       | LEPRECHAUNOLATROUS       |
| -OLATRY         | DRAGONOLATRY         | LEPRECHAUNOLATRY         |
| -OLOGER         | DRAGONOLOGER         | LEPRECHAUNOLOGER         |
| -OLOGERS        | DRAGONOLOGERS        | LEPRECHAUNOLOGERS        |
| -OLOGIC         | DRAGONOLOGIC         | LEPRECHAUNOLOGIC         |
| -OLOGICAL       | DRAGONOLOGICAL       | LEPRECHAUNOLOGICAL       |
| -OLOGIST        | DRAGONOLOGIST        | LEPRECHAUNOLOGIST        |
| -OLOGISTS       | DRAGONOLOGISTS       | LEPRECHAUNOLOGISTS       |
| -OLOGY          | DRAGONOLOGY          | LEPRECHAUNOLOGY          |
| -OMACH          | DRAGONOMACH          | LEPRECHAUNOMACH          |
| -OMACHAL        | DRAGONOMACHAL        | LEPRECHAUNOMACHAL        |
| -OMACHES        | DRAGONOMACHES        | LEPRECHAUNOMACHES        |
| -OMACHIAN       | DRAGONOMACHIAN       | LEPRECHAUNOMACHIAN       |
| -OMACHICAL      | DRAGONOMACHICAL      | LEPRECHAUNOMACHICAL      |
| -OMACHIST       | DRAGONOMACHIST       | LEPRECHAUNOMACHIST       |
| -OMACHISTS      | DRAGONOMACHISTS      | LEPRECHAUNOMACHISTS      |
| -OMACHY         | DRAGONOMACHY         | LEPRECHAUNOMACHY         |
| -OMAGY          | DRAGONOMAGY          | LEPRECHAUNOMAGY          |
| -OMANCER        | DRAGONOMANCER        | LEPRECHAUNOMANCER        |
| -OMANCERS       | DRAGONOMANCERS       | LEPRECHAUNOMANCERS       |
| -OMANCY         | DRAGONOMANCY         | LEPRECHAUNOMANCY         |
| -OMANIA         | DRAGONOMANIA         | LEPRECHAUNOMANIA         |
| -OMANIAC        | DRAGONOMANIAC        | LEPRECHAUNOMANIAC        |
| -OMANIACS       | DRAGONOMANIACS       | LEPRECHAUNOMANIACS       |
| -OMANTIC        | DRAGONOMANTIC        | LEPRECHAUNOMANTIC        |
| -OMANTICA       | DRAGONOMANTICA       | LEPRECHAUNOMANTICA       |
| -OMANTICAL      | DRAGONOMANTICAL      | LEPRECHAUNOMANTICAL      |
| -OMANTICALLY    | DRAGONOMANTICALLY    | LEPRECHAUNOMANTICALLY    |
| -OMANTICHE      | DRAGONOMANTICHE      | LEPRECHAUNOMANTICHE      |
| -OMANTICI       | DRAGONOMANTICI       | LEPRECHAUNOMANTICI       |
| -OMANTICISM     | DRAGONOMANTICISM     | LEPRECHAUNOMANTICISM     |
| -OMANTICO       | DRAGONOMANTICO       | LEPRECHAUNOMANTICO       |
| -OMANTICRATIC   | DRAGONOMANTICRATIC   | LEPRECHAUNOMANTICRATIC   |
| -OMANTICS       | DRAGONOMANTICS       | LEPRECHAUNOMANTICS       |
| -OMATIC         | DRAGONOMATIC         | LEPRECHAUNOMATIC         |
| -OMATICALLY     | DRAGONOMATICALLY     | LEPRECHAUNOMATICALLY     |
| -OMATICISM      | DRAGONOMATICISM      | LEPRECHAUNOMATICISM      |
| -OMATOGRAPHY    | DRAGONOMATOGRAPHY    | LEPRECHAUNOMATOGRAPHY    |
| -OMER           | DRAGONOMER           | LEPRECHAUNOMER           |
| -OMERS          | DRAGONOMERS          | LEPRECHAUNOMERS          |
| -OMETER         | DRAGONOMETER         | LEPRECHAUNOMETER         |
| -OMETRIC        | DRAGONOMETRIC        | LEPRECHAUNOMETRIC        |
| -OMETRICAL      | DRAGONOMETRICAL      | LEPRECHAUNOMETRICAL      |
| -OMETRICALLY    | DRAGONOMETRICALLY    | LEPRECHAUNOMETRICALLY    |
| -OMETRY         | DRAGONOMETRY         | LEPRECHAUNOMETRY         |
| -OMIA           | DRAGONOMIA           | LEPRECHAUNOMIA           |
| -OMIAE          | DRAGONOMIAE          | LEPRECHAUNOMIAE          |
| -OMIC           | DRAGONOMIC           | LEPRECHAUNOMIC           |
| -OMICA          | DRAGONOMICA          | LEPRECHAUNOMICA          |
| -OMICAL         | DRAGONOMICAL         | LEPRECHAUNOMICAL         |
| -OMICALLY       | DRAGONOMICALLY       | LEPRECHAUNOMICALLY       |
| -OMICON         | DRAGONOMICON         | LEPRECHAUNOMICON         |
| -OMICS          | DRAGONOMICS          | LEPRECHAUNOMICS          |
| -OMICUM         | DRAGONOMICUM         | LEPRECHAUNOMICUM         |
| -OMICUS         | DRAGONOMICUS         | LEPRECHAUNOMICUS         |
| -OMIES          | DRAGONOMIES          | LEPRECHAUNOMIES          |
| -OMIST          | DRAGONOMIST          | LEPRECHAUNOMIST          |
| -OMISTS         | DRAGONOMISTS         | LEPRECHAUNOMISTS         |
| -OMY            | DRAGONOMY            | LEPRECHAUNOMY            |
| -ONOMATIC       | DRAGONONOMATIC       | LEPRECHAUNONOMATIC       |
| -ONOMATICALLY   | DRAGONONOMATICALLY   | LEPRECHAUNONOMATICALLY   |
| -ONOMATICISM    | DRAGONONOMATICISM    | LEPRECHAUNONOMATICISM    |
| -ONOMATOGRAPHY  | DRAGONONOMATOGRAPHY  | LEPRECHAUNONOMATOGRAPHY  |
| -ONOMIC         | DRAGONONOMIC         | LEPRECHAUNONOMIC         |
| -ONOMICS        | DRAGONONOMICS        | LEPRECHAUNONOMICS        |
| -ONOMY          | DRAGONONOMY          | LEPRECHAUNONOMY          |
| -OPHANIC        | DRAGONOPHANIC        | LEPRECHAUNOPHANIC        |
| -OPHANIES       | DRAGONOPHANIES       | LEPRECHAUNOPHANIES       |
| -OPHANOUS       | DRAGONOPHANOUS       | LEPRECHAUNOPHANOUS       |
| -OPHANOUSLY     | DRAGONOPHANOUSLY     | LEPRECHAUNOPHANOUSLY     |
| -OPHANY         | DRAGONOPHANY         | LEPRECHAUNOPHANY         |
| -OPHILE         | DRAGONOPHILE         | LEPRECHAUNOPHILE         |
| -OPHILES        | DRAGONOPHILES        | LEPRECHAUNOPHILES        |
| -OPHILIA        | DRAGONOPHILIA        | LEPRECHAUNOPHILIA        |
| -OPHILIAC       | DRAGONOPHILIAC       | LEPRECHAUNOPHILIAC       |
| -OPHILIC        | DRAGONOPHILIC        | LEPRECHAUNOPHILIC        |
| -OPHILISM       | DRAGONOPHILISM       | LEPRECHAUNOPHILISM       |
| -OPHILIST       | DRAGONOPHILIST       | LEPRECHAUNOPHILIST       |
| -OPHILISTS      | DRAGONOPHILISTS      | LEPRECHAUNOPHILISTS      |
| -OPHILOUS       | DRAGONOPHILOUS       | LEPRECHAUNOPHILOUS       |
| -OPHILY         | DRAGONOPHILY         | LEPRECHAUNOPHILY         |
| -OPHOBE         | DRAGONOPHOBE         | LEPRECHAUNOPHOBE         |
| -OPHOBES        | DRAGONOPHOBES        | LEPRECHAUNOPHOBES        |
| -OPHOBIA        | DRAGONOPHOBIA        | LEPRECHAUNOPHOBIA        |
| -OPHOBIC        | DRAGONOPHOBIC        | LEPRECHAUNOPHOBIC        |
| -ophonic        | DRAGONophonic        | LEPRECHAUNophonic        |
| -ophony         | DRAGONophony         | LEPRECHAUNophony         |
| -OPHORIA        | DRAGONOPHORIA        | LEPRECHAUNOPHORIA        |
| -OPHORIANT      | DRAGONOPHORIANT      | LEPRECHAUNOPHORIANT      |
| -OPHORIANTS     | DRAGONOPHORIANTS     | LEPRECHAUNOPHORIANTS     |
| -OPHORIAS       | DRAGONOPHORIAS       | LEPRECHAUNOPHORIAS       |
| -OPHORIC        | DRAGONOPHORIC        | LEPRECHAUNOPHORIC        |
| -OPHORICALLY    | DRAGONOPHORICALLY    | LEPRECHAUNOPHORICALLY    |
| -OPHORICS       | DRAGONOPHORICS       | LEPRECHAUNOPHORIC        |
| -OPLAST         | DRAGONOPLAST         | LEPRECHAUNOPLAST         |
| -OPLASTS        | DRAGONOPLASTS        | LEPRECHAUNOPLASTS        |
| -OPOLIS         | DRAGONOPOLIS         | LEPRECHAUNOPOLIS         |
| -ORAMA          | DRAGONORAMA          | LEPRECHAUNORAMA          |
| -oramic         | dragonoramic         | leprechaunoramic         |
| -oramical       | dragonoramical       | leprechaunoramical       |
| -oramically     | dragonoramically     | leprechaunoramically     |
| -OSCOPE         | DRAGONOSCOPE         | LEPRECHAUNOSCOPE         |
| -OSCOPES        | DRAGONOSCOPES        | LEPRECHAUNOSCOPES        |
| -OSCOPY         | DRAGONOSCOPY         | LEPRECHAUNOSCOPY         |
| -OSITIES        | DRAGONOSITIES        | LEPRECHAUNOSITIES        |
| -OSITY          | DRAGONOSITY          | LEPRECHAUNOSITY          |
| -OSTAS          | DRAGONOSTAS          | LEPRECHAUNOSTAS          |
| -OSTASE         | DRAGONOSTASE         | LEPRECHAUNOSTASE         |
| -OSTASES        | DRAGONOSTASES        | LEPRECHAUNOSTASES        |
| -OSTASIS        | DRAGONOSTASIS        | LEPRECHAUNOSTASIS        |
| -othetic        | dragonothetic        | leprechaunothetic        |
| -othetical      | dragonothetical      | leprechaunothetical      |
| -othetically    | dragonothetically    | leprechaunothetically    |
| -OTHYMIA        | DRAGONOTHYMIA        | LEPRECHAUNOTHYMIA        |
| -OTHYMIC        | DRAGONOTHYMIC        | LEPRECHAUNOTHYMIC        |
| -OTHYMICLY      | DRAGONOTHYMICLY      | LEPRECHAUNOTHYMICLY      |
| -otopia         | DRAGONotopia         | LEPRECHAUNotopia         |
| -otopian        | DRAGONotopian        | LEPRECHAUNotopian        |
| -otopias        | DRAGONotopias        | LEPRECHAUNotopias        |
| -otopic         | DRAGONotopic         | LEPRECHAUNotopic         |
| -OUS            | DRAGONOUS            | LEPRECHAUNOUS            |
| -ovenator       | DRAGONovenator       | LEPRECHAUNovenator       |
| -ovenators      | DRAGONovenators      | LEPRECHAUNovenators      |
| -path           | DRAGONopath          | LEPRECHAUNopath          |
| -pathic         | DRAGONopathic        | LEPRECHAUNopathic        |
| -pathically     | DRAGONopathically    | LEPRECHAUNopathically    |
| -pathics        | DRAGONopathics       | LEPRECHAUNopathics       |
| -pathies        | DRAGONopathies       | LEPRECHAUNopathies       |
| -pathist        | DRAGONopathist       | LEPRECHAUNopathist       |
| -pathists       | DRAGONopathists      | LEPRECHAUNopathists      |
| -paths          | DRAGONopaths         | LEPRECHAUNopaths         |
| -pathy          | DRAGONopathy         | LEPRECHAUNopathy         |
| -RIES           | DRAGONRIES           | LEPRECHAUNRIES           |
| -RY             | DRAGONRY             | LEPRECHAUNRY             |
| -S              | DRAGONS              | LEPRECHAUNS              |
| -SHIP           | DRAGONSHIP           | LEPRECHAUNSHIP           |
| -SMITH          | DRAGONSMITH          | LEPRECHAUNSMITH          |
| -smithing       | dragonsmithing       | leprechaunsmithing       |
| -SMITHS         | DRAGONSMITHS         | LEPRECHAUNSMITHS         |
| -smithying      | dragonsmithying      | leprechaunsmithying      |
| -SOME           | DRAGONSOME           | LEPRECHAUNSOME           |
| -SOMELY         | DRAGONSOMELY         | LEPRECHAUNSOMELY         |
| -SOMENESS       | DRAGONSOMENESS       | LEPRECHAUNSOMENESS       |
| -SOMER          | DRAGONSOMER          | LEPRECHAUNSOMER          |
| -SOMEST         | DRAGONSOMEST         | LEPRECHAUNSOMEST         |
| -STONE          | DRAGONSTONE          | LEPRECHAUNSTONE          |
| -STONES         | DRAGONSTONES         | LEPRECHAUNSTONES         |
| -TASTIC         | DRAGONTASTIC         | LEPRECHAUNTASTIC         |
| -TASTICLY       | DRAGONTASTICLY       | LEPRECHAUNTASTICLY       |
| -TROPE          | DRAGONOTROPE         | LEPRECHAUNOTROPE         |
| -TROPIC         | DRAGONOTROPIC        | LEPRECHAUNOTROPIC        |
| -TROPISM        | DRAGONOTROPISM       | LEPRECHAUNOTROPISM       |
| -TROPISMS       | DRAGONOTROPISMS      | LEPRECHAUNOTROPISMS      |
| -TROPIST        | DRAGONOTROPIST       | LEPRECHAUNOTROPIST       |
| -TROPISTS       | DRAGONOTROPISTS      | LEPRECHAUNOTROPISTS      |
| -TROPY          | DRAGONOTROPY         | LEPRECHAUNOTROPY         |
| -URGIST         | DRAGONURGIST         | LEPRECHAUNURGIST         |
| -URGISTS        | DRAGONURGISTS        | LEPRECHAUNURGISTS        |
| -URGY           | DRAGONURGY           | LEPRECHAUNURGY           |
| -WARD           | DRAGONWARD           | LEPRECHAUNWARD           |
| -WARDS          | DRAGONWARDS          | LEPRECHAUNWARDS          |
| -WISE           | DRAGONWISE           | LEPRECHAUNWISE           |
| -WITH           | DRAGONWITH           | LEPRECHAUNWITH           |
| -WYF            | DRAGONWYF            | LEPRECHAUNWYF            |
| -Y              | DRAGONY              | LEPRECHAUNY              |
---------------------------------------------------------------------
Latest revision: 2019-Apr-24
Total suffixes: 486
Homethread: https://forum.thefreedictionary.com/postst175564_Etymology-of--dragon-.aspx
*/

/*
Star_Trek_-_737_TXT-Ebooks.tar (325,071,872 bytes, UTF-8, English/ASCII text mostly), 29bit hashtable:

-----------------------------------------------------------------------------------------------------------------------------------
| Hasher, Building-Blocks order    | Collisions                                                                                   |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (171 - 171) =                          [0] |
| FNV1A_Pippip: All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (171 - 171) =                          [0] |
| WYHASH_v3   : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (171 - 171) =                          [0] |
| XXH3        : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (171 - 171) =                          [0] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (7,540 - 7,540) =                      [0] |
| FNV1A_Pippip: All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (7,540 - 7,540) =                      [0] |
| WYHASH_v3   : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (7,540 - 7,540) =                      [0] |
| XXH3        : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (7,540 - 7,540) =                      [0] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (81,269 - 81,269) =                    [0] |
| FNV1A_Pippip: All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (81,269 - 81,265) =                    [4] |
| WYHASH_v3   : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (81,269 - 81,263) =                    [6] |
| XXH3        : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (81,269 - 81,262) =                    [7] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (427,531 - 427,471) =                 [60] |
| FNV1A_Pippip: All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (427,531 - 427,358) =                [173] |
| WYHASH_v3   : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (427,531 - 427,380) =                [151] |
| XXH3        : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (427,531 - 427,362) =                [169] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (1,469,991 - 1,468,831) =          [1,160] |
| FNV1A_Pippip: All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (1,469,991 - 1,467,836) =          [2,155] |
| WYHASH_v3   : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (1,469,991 - 1,467,984) =          [2,007] |
| XXH3        : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (1,469,991 - 1,467,969) =          [2,022] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,990,514 - 3,976,606) =         [13,908] |
| FNV1A_Pippip: All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,990,514 - 3,975,612) =         [14,902] |
| WYHASH_v3   : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,990,514 - 3,975,699) =         [14,815] |
| XXH3        : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,990,514 - 3,975,820) =         [14,694] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,150,775 - 9,073,465) =         [77,310] |
| FNV1A_Pippip: All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,150,775 - 9,072,819) =         [77,956] |
| WYHASH_v3   : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,150,775 - 9,073,588) =         [77,187] |
| XXH3        : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,150,775 - 9,072,886) =         [77,889] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (17,941,023 - 17,644,835) =      [296,188] |
| FNV1A_Pippip: All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (17,941,023 - 17,644,064) =      [296,959] |
| WYHASH_v3   : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (17,941,023 - 17,644,106) =      [296,917] |
| XXH3        : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (17,941,023 - 17,645,122) =      [295,901] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (30,981,351 - 30,106,215) =      [875,136] |
| FNV1A_Pippip: All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (30,981,351 - 30,104,837) =      [876,514] |
| WYHASH_v3   : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (30,981,351 - 30,105,085) =      [876,266] |
| XXH3        : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (30,981,351 - 30,104,309) =      [877,042] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (48,387,322 - 46,272,512) =    [2,114,810] |
| FNV1A_Pippip: All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (48,387,322 - 46,273,345) =    [2,113,977] |
| WYHASH_v3   : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (48,387,322 - 46,272,960) =    [2,114,362] |
| XXH3        : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (48,387,322 - 46,271,345) =    [2,115,977] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (69,456,330 - 65,156,973) =    [4,299,357] |
| FNV1A_Pippip: All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (69,456,330 - 65,146,568) =    [4,309,762] |
| WYHASH_v3   : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (69,456,330 - 65,150,706) =    [4,305,624] |
| XXH3        : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (69,456,330 - 65,152,752) =    [4,303,578] |
-----------------------------------------------------------------------------------------------------------------------------------

"(Dictionary_Specification_Language_(ABBYY_Software_House))_Hanyu_Cihai_new_Sea-of-Words_(Zho-Zho).dsl" (42,920,232 bytes, UNICODE, Chinese), 26bit hashtable:

-----------------------------------------------------------------------------------------------------------------------------------
| Hasher, Building-Blocks order    | Collisions                                                                                   |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (256 - 256) =                          [0] |
| FNV1A_Pippip: All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (256 - 256) =                          [0] |
| WYHASH_v3   : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (256 - 256) =                          [0] |
| XXH3        : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (256 - 256) =                          [0] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (31,620 - 31,620) =                    [0] |
| FNV1A_Pippip: All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (31,620 - 31,618) =                    [2] |
| WYHASH_v3   : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (31,620 - 31,610) =                   [10] |
| XXH3        : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (31,620 - 31,613) =                    [7] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (779,296 - 779,296) =                  [0] |
| FNV1A_Pippip: All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (779,296 - 774,956) =              [4,340] |
| WYHASH_v3   : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (779,296 - 774,722) =              [4,574] |
| XXH3        : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (779,296 - 774,792) =              [4,504] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,486,913 - 3,402,913) =         [84,000] |
| FNV1A_Pippip: All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,486,913 - 3,397,884) =         [89,029] |
| WYHASH_v3   : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,486,913 - 3,397,698) =         [89,215] |
| XXH3        : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,486,913 - 3,397,593) =         [89,320] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (6,753,621 - 6,421,931) =        [331,690] |
| FNV1A_Pippip: All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (6,753,621 - 6,424,985) =        [328,636] |
| WYHASH_v3   : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (6,753,621 - 6,425,636) =        [327,985] |
| XXH3        : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (6,753,621 - 6,424,949) =        [328,672] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,745,315 - 9,069,101) =        [676,214] |
| FNV1A_Pippip: All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,745,315 - 9,069,787) =        [675,528] |
| WYHASH_v3   : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,745,315 - 9,071,273) =        [674,042] |
| XXH3        : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (9,745,315 - 9,070,217) =        [675,098] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (12,146,222 - 11,111,934) =    [1,034,288] |
| FNV1A_Pippip: All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (12,146,222 - 11,109,915) =    [1,036,307] |
| WYHASH_v3   : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (12,146,222 - 11,110,179) =    [1,036,043] |
| XXH3        : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (12,146,222 - 11,110,481) =    [1,035,741] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (13,922,118 - 12,573,815) =    [1,348,303] |
| FNV1A_Pippip: All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (13,922,118 - 12,507,408) =    [1,414,710] |
| WYHASH_v3   : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (13,922,118 - 12,572,063) =    [1,350,055] |
| XXH3        : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (13,922,118 - 12,572,988) =    [1,349,130] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (15,567,034 - 13,894,829) =    [1,672,205] |
| FNV1A_Pippip: All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (15,567,034 - 13,827,123) =    [1,739,911] |
| WYHASH_v3   : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (15,567,034 - 13,892,591) =    [1,674,443] |
| XXH3        : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (15,567,034 - 13,893,522) =    [1,673,512] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (16,911,322 - 14,948,437) =    [1,962,885] |
| FNV1A_Pippip: All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (16,911,322 - 14,882,178) =    [2,029,144] |
| WYHASH_v3   : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (16,911,322 - 14,949,193) =    [1,962,129] |
| XXH3        : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (16,911,322 - 14,948,130) =    [1,963,192] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (18,326,389 - 16,037,613) =    [2,288,776] |
| FNV1A_Pippip: All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (18,326,389 - 15,971,799) =    [2,354,590] |
| WYHASH_v3   : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (18,326,389 - 16,040,122) =    [2,286,267] |
| XXH3        : All Keys 11 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (18,326,389 - 16,037,900) =    [2,288,489] |
-----------------------------------------------------------------------------------------------------------------------------------

enwik9 (1,000,000,000 bytes, UTF-8, XML), 30bit hashtable:

-----------------------------------------------------------------------------------------------------------------------------------
| Hasher, Building-Blocks order    | Collisions                                                                                   |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (206 - 206) =                          [0] |
| FNV1A_Pippip: All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (206 - 206) =                          [0] |
| WYHASH_v3   : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (206 - 206) =                          [0] |
| XXH3        : All Keys 01 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (206 - 206) =                          [0] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (22,664 - 22,664) =                    [0] |
| FNV1A_Pippip: All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (22,664 - 22,664) =                    [0] |
| WYHASH_v3   : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (22,664 - 22,664) =                    [0] |
| XXH3        : All Keys 02 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (22,664 - 22,664) =                    [0] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (491,817 - 491,817) =                  [0] |
| FNV1A_Pippip: All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (491,817 - 491,738) =                 [79] |
| WYHASH_v3   : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (491,817 - 491,709) =                [108] |
| XXH3        : All Keys 03 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (491,817 - 491,717) =                [100] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,222,263 - 3,212,764) =          [9,499] |
| FNV1A_Pippip: All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,222,263 - 3,217,541) =          [4,722] |
| WYHASH_v3   : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,222,263 - 3,217,456) =          [4,807] |
| XXH3        : All Keys 04 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (3,222,263 - 3,217,511) =          [4,752] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (11,375,257 - 11,327,748) =       [47,509] |
| FNV1A_Pippip: All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (11,375,257 - 11,314,689) =       [60,568] |
| WYHASH_v3   : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (11,375,257 - 11,315,057) =       [60,200] |
| XXH3        : All Keys 05 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (11,375,257 - 11,315,286) =       [59,971] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (28,245,411 - 27,879,922) =      [365,489] |
| FNV1A_Pippip: All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (28,245,411 - 27,876,238) =      [369,173] |
| WYHASH_v3   : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (28,245,411 - 27,878,277) =      [367,134] |
| XXH3        : All Keys 06 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (28,245,411 - 27,877,986) =      [367,425] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (53,725,626 - 52,405,388) =    [1,320,238] |
| FNV1A_Pippip: All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (53,725,626 - 52,404,876) =    [1,320,750] |
| WYHASH_v3   : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (53,725,626 - 52,403,276) =    [1,322,350] |
| XXH3        : All Keys 07 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (53,725,626 - 52,403,054) =    [1,322,572] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (87,951,564 - 84,448,947) =    [3,502,617] |
| FNV1A_Pippip: All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (87,951,564 - 84,445,511) =    [3,506,053] |
| WYHASH_v3   : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (87,951,564 - 84,446,072) =    [3,505,492] |
| XXH3        : All Keys 08 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (87,951,564 - 84,444,323) =    [3,507,241] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (130,682,041 - 123,041,596) =  [7,640,445] |
| FNV1A_Pippip: All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (130,682,041 - 123,049,405) =  [7,632,636] |
| WYHASH_v3   : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (130,682,041 - 123,041,605) =  [7,640,436] |
| XXH3        : All Keys 09 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (130,682,041 - 123,041,777) =  [7,640,264] |
-----------------------------------------------------------------------------------------------------------------------------------
| iSCSI CRC32 : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (180,821,533 - 166,411,474) = [14,410,059] |
| FNV1A_Pippip: All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (180,821,533 - 166,415,343) = [14,406,190] |
| WYHASH_v3   : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (180,821,533 - 166,413,129) = [14,408,404] |
| XXH3        : All Keys 10 bytes; | (Distinct_Keys - Used_Slots) = [Hash_Collisions]: (180,821,533 - 166,417,790) = [14,403,743] |
-----------------------------------------------------------------------------------------------------------------------------------

FNV1A_Pippip_Yurii:
        mov     rax, QWORD PTR [rdi]
        cmp     rsi, 8
        jbe     .L2
        lea     rax, [rsi-1]
        shr     rax, 4
        lea     rdx, [8+rax*8]
        movabs  rax, -3750763034362895579
        sub     rsi, rdx
        add     rdx, rdi
.L3:
        xor     rax, QWORD PTR [rdi]
        add     rdi, 8
        imul    rax, rax, 591798841
        xor     rax, QWORD PTR [rdi-8+rsi]
        imul    rax, rax, 591798841
        cmp     rdi, rdx
        jne     .L3
.L4:
        mov     rdx, rax
        shr     rdx, 32
        xor     eax, edx
        mov     edx, eax
        shr     edx, 16
        xor     eax, edx
        ret
.L2:
        movabs  rdx, -3750763034362895579
        mov     ecx, 8
        sub     ecx, esi
        sal     ecx, 3
        sal     rax, cl
        shr     rax, cl
        xor     rax, rdx
        imul    rax, rax, 591798841
        jmp     .L4

Source: https://godbolt.org/z/D9MyQQ

// Dedicated to Pippip, the main character in the 'Das Totenschiff' roman, actually the B.Traven himself, his real name was Hermann Albert Otto Maksymilian Feige.
// CAUTION: Add 8 more bytes to the buffer being hashed, usually malloc(...+8) - to prevent out of boundary reads!
// Many thanks go to Yurii 'Hordi' Hordiienko, he lessened with 3 instructions the original 'Pippip', thus:
#include <stdlib.h>
#include <stdint.h>
#define _PADr_KAZE(x, n) ( ((x) << (n))>>(n) )
uint32_t FNV1A_Pippip_Yurii(const char *str, size_t wrdlen) {
	const uint32_t PRIME = 591798841; 
	uint32_t hash32; uint64_t hash64 = 14695981039346656037ULL;
	size_t Cycles, NDhead;
if (wrdlen > 8) {
	Cycles = ((wrdlen - 1)>>4) + 1; NDhead = wrdlen - (Cycles<<3);
#pragma nounroll
        for(; Cycles--; str += 8) {
		hash64 = ( hash64 ^ (*(uint64_t *)(str)) ) * PRIME;        
		hash64 = ( hash64 ^ (*(uint64_t *)(str+NDhead)) ) * PRIME;        
	}
} else
	hash64 = ( hash64 ^ _PADr_KAZE(*(uint64_t *)(str+0), (8-wrdlen)<<3) ) * PRIME;        
hash32 = (uint32_t)(hash64 ^ (hash64>>32)); return hash32 ^ (hash32 >> 16);
} // Last update: 2019-Oct-30, 14 C lines strong, Kaze.
*/

// Last change: 2020-May-09; Added info report how many RAM is needed to build trees in one pass.
// Last change: 2020-Apr-22; Added LastSeen...[] for 128:, 56:.
// Last change: 2020-Apr-12; Grmbl! Ugh! The stupid (done in a hurry) change from 2020-Feb-26 had a bug - the last 'i' has to be 'i64'.
// Last change: 2020-Feb-26; Grmbl! It crashes with 2.7 and 3.3 GB DNA files, don't know the exact reason - the bug maybe is the writing in variables areas due to using 'int i' for building REVERSED memory block - maybe it becomes after 2GB negative...
// Last change: 2020-Feb-19; Added LastSeen...[] for 12:1, 8:1, 4:1.
// Last change: 2020-Feb-14; The same as 2020-Feb-02 but added -DLITE compile switch - it forces all memmem() i.e. Railgun invocations to immediately retutn NULL i.e. NOT FOUND - thus this 'LITE' compile uses only B-trees.
// Last change: 2020-Feb-02; 1] Do not write to file if in bench mode. 2] Enabled SHA3 at compile time, optional, that is. 3] Commented the UPDATING at 'EncStart' - it used to confuse the parser, see the '// debugg' tag
// Last change: 2020-Jan-29; Added 48 as LastSeen. Also, fixed the compression rate slowdown blunder with 'Skip=NULL;' init - unnecessary memmem() for 128 needles.
// Last change: 2020-Jan-25; Changed the updating of LastSeenOffsets (not going past Sliding Window, but up to LookAheadBuffer thus fallback to memmem() is avoided).
// Last change: 2020-Jan-13; In order to enter SCB, decompression happens on 'stdout'.
// Last change: 2020-Jan-11; Fixed 5 overlooked '(signed int)' casts in Railgun, should be 4+GB long i.e. '(signed long long)'
// Last change: 2020-Jan-10; Fixed an overlooked haystack size of uint32_t in Railgun, should be 4+GB long, so, char * Railgun_Trolldom(char * pbTarget, char * pbPattern, uint64_t cbTarget, uint32_t cbPattern);.
// Last change: 2020-Jan-04; Fixed an overlooked heuristic for 18:(2+1) causing different ratios.
// Last change: 2020-Jan-01; // Some more BtreeHEURISTIC were added, investigate why 2019-Dec-26 gives better ration with 'Sherlock'...?! Surely the answer lies in the three 24: sections and four 28: sections.
// Last change: 2019-Dec-26;
// Last change: 2019-Dec-19;
// Last change: 2019-Dec-07;
// Last change: 2019-Dec-04;
// Last change: 2019-Sep-28;
// Last change: 2019-Jul-01;
// Last change: 2019-Apr-24;
// Last change: 2019-Feb-13;
// Last change: 2018-Nov-12;
// Last change: 2017-Oct-22;
// Last change: 2016-Aug-22; fixed Railgun_Swampshine, after that changed with Trolldom.
// Last change: 2016-Apr-08; small fix in encoding (avoiding possible negative offset if Sliding Window is biggy) from 2015-Mar-03.
// If you want to help me to improve it, email me at: sanmayce@sanmayce.com
// Enfun!